#!python
"""
Code for the class and exception min-tutorials.
"""

class Foo(object):
    """ 
    This foo class doesn't do much. It inherits from 'object', the generic base 
    type for classes.
    """
    
    def __init__(self, value=None):
        """ constructor """
        self.value = value  # by convention, an instance of a class refers to
                            # itself with 'self'.  the default of value is None.
    
    def printValue(self):   # self should be the first argument for most
                            # methods.  it allows the object to refer to itself.
        if self.value is not None:
            print 'Foo value =', self.value
        else:
            print 'Foo has no value defined.'
            
            
class Bar(Foo):
    """ this class inherits from Foo """
    
    def __init__(self, value=None, nprint=2):
        self.nprint = nprint
        super(Bar, self).__init__(value)    # we overloaded Foo's constructor,
                                            # but we can still call it
    
    def printValue(self):
        """
        overriding Foo's method, but using its data attribute
        """
        if self.value is not None:
            val = ' - '.join(str(self.value) for _ in xrange(self.nprint))
            print 'Bar value =', val
        else:
            print 'Bar has no value defined.'
            
            
# showing try-except.  to run this code:
# >>> from classtut import except_demo
# >>> except_demo()
#
def except_demo():
    n = 0
    while True:
        d = raw_input('denominator? ')
        try:
            x = 10./float(d)
        except ZeroDivisionError:
            print "you can't divide by zero!"
        else:
            break
        finally:
            n += 1
            print '\tthat was attempt', n

    return x
