(lp1
(I-1
S'Forms of activity and interpersonal relations in [[sociology]] can be described as follows: first and most basic are [[animal]]-like [[behavior]]s, i.e. various physical movements of the body. Then there are [[Action (philosophy)|action]]s - movements with a meaning and purpose. Then there are [[social behavior]]s, which are addressed towards other people, and [[social action]]s, which further require a response from another person. Next are [[social contact]]s, a pair of social actions, which form the beginning of [[social interaction]]s. Social interactions in turn form the basis of [[social relation]]s. This division is illustrated by the table below:\n\n{| class=wikitable\n!\n!Physical movement\n!Meaning\n!Directed towards others\n!Await response\n!Unique/rare interaction\n!Interactions\n!Accidental, not planned, but repeated interaction\n!Regular interactions\n!Interactions described by law, custom or tradition\n!A scheme of social interactions\n|-\n![[Behavior]]\n|{{Yes}}\n|\n|\n|\n|\n|\n|\n|\n|\n|\n|-\n![[Action (philosophy)|Action]]\n|{{Yes}}\n|{{Yes}}\n|\n|\n|\n|\n|\n|\n|\n|\n|-\n![[Social behavior]]\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|\n|\n|\n|\n|\n|\n|\n|-\n![[Social action]]\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|\n|\n|\n|\n|\n|\n|-\n![[Social contact]]\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|\n|\n|\n|\n|\n|-\n![[Social interaction]]\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|\n|\n|\n|\n|-\n!Repeated interaction\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|\n|\n|\n|-\n!Regular interaction\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|\n|\n|-\n!Regulated interaction\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|\n|-\n![[Social relation]]\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|{{Yes}}\n|}\n\n'
p2
tp3
a(I-1
S'{{Orphan|date=February 2009}}\n{{context|date=February 2009}}\n\nThe Payne Fund Studies were a series of studies of the effect of movies on childrens behavior. They were paid for by [[The Payne Fund]], a private foundation. They have been criticized as lacking scientific rigor but were the first attempt to rigorously study the media. They were politically significant and were instrumental in the development of the [[Hays Code|1930 Motion Picture Production Code]].\n\n'
p4
tp5
a(I-1
S'{{TOC right}}\n\nThe Matthew effect in [[sociology]] is the phenomenon that the rich get richer and the poor get poorer.  Those who possess power and [[Capital (economics)|economic]] or [[social capital]] can leverage those resources to gain more power or capital.  The Matthew effect results in a [[power law]] distribution of resources.  The term was first coined by sociologist [[Robert K. Merton]] and takes its name from a line in the [[bible|biblical]] [[Gospel of Matthew]]:\n\n{{quote|For to all those who have, more will be given, and they will have an abundance; but from those who have nothing, even what they have will be taken away.|[[Gospel of Matthew|Matthew]] [[s:Bible (New Revised Standard Version)/Matthew#25:29|25:29]], [[New Revised Standard Version]].}}\n\n== Sociology of science==<!-- This section is linked from [[Scientific misconduct]] -->\nIn the [[sociology of science]], Matthew effect was a term coined by [[Robert K. Merton]] to describe how, among other things, eminent scientists will often get more credit than a comparatively unknown researcher, even if their work is similar; it also means that credit will usually be given to researchers who are already famous: for example, a prize will almost always be awarded to the most senior researcher involved in a project, even if all the work was done by a [[graduate student]].\n\n===Examples===\nAs [[Credit (creative arts)|credit]] is valued in science, specific claims of the Matthew effect are contentious.\n\n* 20th century mathematician [[John von Neumann]] is frequently called the father of [[game theory]] or the father of the computer, even though his influential publications were sometimes restatements of the ideas of his collaborators (see the [[First Draft of a Report on the EDVAC]]).  However, for game theory, the three winners of the 1994 Nobel prize for economics do believe that von Neumann and Morgensterns 1944 book did establish game theory as a separate mathematical discipline.  See the banquet speech of John C. Harsanyi at http://nobelprize.org/nobel_prizes/economics/laureates/1994/harsanyi-speech.html.\n* There was a [[Nobel Prize controversies#Recent controversial exclusions|controversy]] involving [[George Sudarshan]] and the [[Nobel Prize in Physics]] for 2005. Several physicists wrote a letter to the Swedish Academy, protesting that Sudarshan should have been awarded a share of the Prize for the [[Sudarshan-Glauber representation]] (or Sudarshan diagonal representation) in quantum optics, for which [[Roy J. Glauber]] won his share of the prize. Because the terms of [[Alfred Nobel]]s will restrict the number of Nobel Prize winners to three in a given year, the Nobel Committee has often been criticized for allegedly ignoring scientists who did seminal work on a topic while awarding a prize to other scientists for the same topic.\n* In [[algorithmic information theory]], the notion of [[Kolmogorov complexity]] (also known as Kolmogorov-[[Chaitin]] complexity) is named after the famous  Russian mathematician  [[Andrey Kolmogorov]].  Li and Vitanyi, in An Introduction to Kolmogorov Complexity and Its Applications (p.&nbsp;84), write:\n: [[Ray Solomonoff]]  [...] introduced [what is now known as] Kolmogorov complexity  in a long journal paper in 1964.  [...] This makes Solomonoff the first inventor and raises the question whether we should talk about Solomonoff complexity. [...] (Associating Kolmogorovs name with the complexity may also be an example of the Matthew Effect first noted in the Gospel according to Matthew, 25:29-30, For to every one who has more will be given, and he will have in abundance; but from him who has not, even what he has will be taken away. And cast the worthless servant into the outer darkness; there men will weep and gnash their teeth.)\n\n* There are many uncontroversial examples of the Matthew effect in mathematics, where a concept is due to one mathematician (and well-documented as such), but is attributed to a later (possibly much later), more famous mathematician who worked on it.\n:For instance, the [[Poincar disk model]] and [[Poincar half-plane model]] of [[hyperbolic space]] are both named for [[Henri Poincar]], but were introduced by [[Eugenio Beltrami]] in 1868 (when Poincar was 14 and had not as yet contributed to hyperbolic geometry).\n\n== Education ==\n{{Split|date=September 2009}}\nIn [[education]] the term Matthew effect has been adopted by [[Keith Stanovich]], a psychologist who has done extensive research on [[reading (activity)|reading]] and language disabilities. Stanovich used the term to describe a phenomenon that has been observed in research on how new readers acquire the skills to read: early success in acquiring reading skills usually leads to later successes in reading as the learner grows, while failing to learn to read before the third or fourth year of schooling may be indicative of life-long problems in learning new skills. This is because children who fall behind in reading, read less, increasing the gap between them and their peers. Later, when students need to read to learn (where before they were learning to read) their reading difficulty creates difficulty in most other subjects. In this way they fall further and further behind in school, dropping out at a much higher rate than their peers. \n\nIn the words of Keith Stanovich (Adams, 1990, pp.&nbsp;59-60):\n{{quote|Slow reading acquisition has cognitive, behavioral, and motivational consequences that slow the development of other cognitive skills and inhibit performance on many academic tasks. In short, as reading develops, other cognitive processes linked to it track the level of reading skill. Knowledge bases that are in reciprocal relationships with reading are also inhibited from further development. The longer this developmental sequence is allowed to continue, the more generalized the deficits will become, seeping into more and more areas of cognition and behavior. Or to put it more simply -- and sadly -- in the words of a tearful nine-year-old, already falling frustratingly behind his peers in reading progress, Reading affects everything you do}}\n\n== Social policy ==<!-- This section is linked from [[Medicare (Canada)]] -->\n\nThe term is also used in [[adult education]] to describe the distribution of adult learning across populations. In this case it refers to the phenomenon whereby adults who have the highest levels of initial education are most likely to continue engaging in structured learning, while those with the lowest levels of initial education are the least likely to engage in structured learning.{{Citation needed|date=September 2009}}\n\n==Quotations==\nWitty or clever quotations by unknowns are often attached to famous individuals, for example:\n*Only the dead have seen the end of war, is often attributed to [[Plato]]. In fact, [[George Santayana]] wrote it, and researchers have been unable to find the quote in any of Platos dialogues.  [http://plato-dialogues.org/faq/faq008.htm]\n*The only traditions of the Royal Navy are rum, sodomy and the lash, was not said by [[Winston Churchill]], but by his personal secretary [[Anthony Montague]].\n*[[Charles Manson]] did not say Im the devil, Im here to do the devils business., his associate Charles Tex Watson did.\n*[[Bill Gates]] never said Be nice to nerds. Chances are youll end up working for one, [[Charles J. Sykes]] did.\n*[[Otto von Bismarck]] is sometimes said to have said To retain respect for sausages and laws, one must not watch them in the making., but the earliest such quotation is by [[John Godfrey Saxe]], who said in 1869, Laws, like sausages, cease to inspire respect in proportion as we know how they are made.\n*[[George W. Bush]] did not originate the phrase ...the terrorists have won or ...then the terrorists win. It derives from the statements of [[Frank Pierson]] after he refused to cancel the [[Academy Awards]]: If we give in to fear, if we arent able to do these simple and ordinary things, the terrorists have won the war.\n*[[Pierre Choderlos de Laclos]] did not write [[Revenge]] is a dish best served cold, in Les Liaisons Dangereuses; neither did it originate in [[Star Trek]] or [[The Godfather]].  Its first known appearance in print is in Eugne Sues 1841 French potboiler novel Mathilde.\n\n'
p6
tp7
a(I1
S'{{expand|date=August 2007}}\nTaphophilia is a passion for and enjoyment of [[cemetery|cemeteries]].<ref>Rogak, Lisa (2004), Stones and Bones of New England: A guide to unusual, historic, and otherwise notable cemeteries, Globe Pequat ISBN 07627-3000-5 </ref> The singular term is a taphophile.\n\nTaphophilia involves epitaphs, [[Gravestone rubbing|gravestone rubbing]], photography, art, and history of (famous) deaths.  An example of an individuals expression of taphophilia is the character Harold in the movie [[Harold and Maude]] (1971).\n\nTaphophilia should not be confused with [[necrophilia]], which is a sexual attraction to [[cadaver|corpses]].\n\n'
p8
tp9
a(I-1
S'{{Citations missing|date=November 2007}}\n{{otheruses4|the Masonic Lodge|the French libertarian association|Libert chrie (association)}}\n[[Image:Libert chrie2.jpg|thumb|Memorial at Esterwegen [[concentration camp]]]]\n[[Image:Libert chrie1.jpg|thumb|close-up]]\n{{Freemasonry2}}\nLibert chrie was one of the very few<ref>Together with the lodges Les Frres captifs d[[Allach (concentration camp)|Allach]], which register is now located at the Grand Orient of France museum, and [[Obstine|LObstine]], in [[Oflag X-D]]).</ref> [[Masonic Lodge|masonic lodges]] founded within a [[Nazi concentration camps|Nazi concentration camp]] during the [[Second World War]].\n\n== The Lodge ==\nOn the 15 November, 1943 - seven [[Belgium|Belgian]] [[Freemasonry|Freemasons]] and resistance fighters - founded the Masonic Lodge Loge Libert chrie (French: Beloved Liberty) inside Hut 6 of Emslandlager VII ([[Esterwegen]]). The name of the lodge was derived from [[La Marseillaise]].\n\nThe original seven Freemasons of Loge Libert chrie were:\n\n*Paul Hanson,\n*Luc Somerhausen,\n*Jean De Schrijver,\n*Jean Sugg,\n*[[Henri Story]],\n*Amde Miclotte,\n*Franz Rochat,\n*Guy Hannecart\n\nand they later Initiated, Passed and Raised Brother Fernand Erauw, another Belgian.\n\nAccording to M. Franz Bridoux, former prisoner in Esterwegens hut N6, the founding members of Loge Libert Chrie were Messrs Rochat, Sugg, Hannecart, Hanson, Somerhausen, Degueldre and Miclotte. \n\nMessrs. De Schrijver  and M. Story arrived well after the establishment of the Lodge and were  not be founding members, but members only. \n\nPaul Hanson was elected Master. The Brethren met for Lodge Work in Hut 6 around a table, which was otherwise used for cartridge sorting. A [[Roman Catholic Church|Catholic]] Priest stood watch, so that the Brethren could hold their meetings; and protected their secrecy. \n\nHut 6 was used for foreign [[Nacht und Nebel]], (German: Night and Fog), prisoners. The Emslandlagercamps were a group of camps whose history is represented by a permanent exhibition in the Documentation and Information Centre in [[Papenburg]]. Altogether 15 camps were established on the [[Netherland]]s border, with central administration in Papenburg.\n\nLuc Somerhausen described Erauws Intitiation, etc., as just as simple ceremonies. These ceremonies, (to whose secrecy they asked the community of Catholic Priests for assistance, with their prayers), ...took place at one of the tables... ...after a very highly simplified [[ritual]] - whose individual components were however explained to the initiate; that from now on he could participate in the work of the Lodge.\n\nMore than hundred prisoners were in Hut 6, and locked up nearly around the clock - allowed to leave only for a half-hour walk per day, under supervision. During the day half of the Camp had to sort cartridges and radio parts. The prisoners of the other half of the Camp were forced to work under dreadful conditions in the surrounding [[peat bog]]s. The nutrition was so miserable that the prisoners lost 4 kg body weight each month, on average.\n\nAfter the first ritual meeting, with admission of the new brother, further meetings were thematically prepared. One was dedicated to the symbol of the Great Architect of the Universe, another The future of Belgium, and a further, The position of women in Freemasonry.  Only Somerhausen and Erauw survived detention, and the Lodge stopped working at the beginning of 1944.\n\n== The Lodge members ==\n\nLodge Master, Paul Hanson was moved, and died in the rubble of his prison, during an Allied air bombardment on [[Essen]], [[26 March]], [[1944]].\n\nJean Sugg, and Franz Rochat, belonged to the Philanthropic Friends  Lodge ([[Les Amis Philanthropes]], Lodge No. 5 of the [[Grand Orient of Belgium]]). \n\nDr. Franz Rochat, a University Professor, Pharmacist and director of an important pharmaceutical laboratory, was born on [[10 March]] [[1908]] in [[Saint-Gilles, Belgium|Saint-Gilles]]. He was a worker in the underground press, and the resistance publication voice of the Belgians. He was arrested on 28 February 1942, arrived at Untermansfeld April 1944, and died there on [[6 April]] [[1945]].\n\nJean Sugg was born at the [[8 September]] [[1897]] in [[Ghent]] and was of [[Swiss German]] origin. He co-operated with Franz Rochat in the Underground Press, translated [[German language|German]] and Swiss texts, and contributed to clandestine publications, including, [[La Libre Belgique]], La Lgion Noire, Le Petit Belge and LAnti Boche. He died in a [[concentration camp]] on [[8 February]] [[1945]].\n\nDr. Amde Miclotte was a High School Teacher. He was born on [[20 December]] [[1902]] in [[Lahamaide]], and belonged to the Lodge Union et Progrs. He was last seen in detention, on [[8 February]] [[1945]].\n\nJean De Schrijver, was a Colonel in the Belgian Army. He was born on [[23 August]] [[1893]] in [[Aalst, Belgium|Aalst]], and Brother of the lodge La Libert in [[Ghent]]. On [[2 September]] [[1943]] he was arrested on charges of espionage and possession of arms, and died in February 1945.\n\n[[Henri Story]] was born on [[27 November]] [[1897]] in Ghent. He was a member of the Lodge Le Septentrion in Ghent. He died on [[5 December]] [[1944]].\n\nLuc Somerhausen, a journalist, was born on [[26 August]], [[1903]], in [[Hoeilaart]]. He was arrested on [[28 May]] [[1943]] in [[Brussels]]. He belonged to the lodge ACSO III and was Deputy Secretary of the Grand Orient of Belgium (Grand Orient de Belgique).\n\nFernand Erauw, an Assessor at the Audit Office, and Reserve Officer with the Infantry, was born on [[29 January]], [[1914]], in [[Wemmel]]. He was arrested on [[4 August]], [[1942]], as a member of the Secret Army. He escaped and was finally arrested in 1943.\n\nGuy Hannecart (1903-1945) a lawyer and leader of La Voix des belges. He was also member of the lodge les Amis Philanthropes N3\n\nSurvivors Erauw and Somerhausen met again 1944 in the [[Sachsenhausen concentration camp|Oranienburg Sachsenhausen]] concentration camp, and remained inseparable from then on. In the spring 1945 they were involved in the Death Marches, and although Erauw was 1.84 m tall, he weighed only 32 kg on [[21 May]], [[1945]]  in the Saint Pierre Hospital in Brussels.\n\nIn August 1945 Luc Somerhausen sent a detailed report to the Grand Master of the Grand Orient of Belgium, in which he delineated the history of the loge Libert chrie. Luc Somerhausen died in 1982 at the age of 79. The last witness, Fernand Erauw, died at the age of 83, in 1997.\n\n== The Memorial ==\nA memorial, created by Architect Jean de Salle, was raised by Belgian and German Freemasons on Saturday November 13, 2004. It is now part of the memorial site of the  Esterwegen Cemetery. Wim Rutten, the Grand Master of the Belgian Federation of the [[Le Droit Humain]] said during an address:\n\n:We are gathered here today on this Cemetery in Esterwegen, not to mourn, but to express free thoughts in public. - In memory of our brothers; human rights should never be forgotten. \n\n{{see also|History of Freemasonry}}\n\n'
p10
tp11
a(I-1
S'{{BLP unsourced|date=January 2009}}\n[[Image:Tony Warriner.jpg|thumb|right|320px|Tony Warriner]]\n\nTony Warriner wrote his first video game, [[Obsidian (1986 Game)|Obsidian]] for [[Amstrad]] CPC, in 1986. The game was published by [[Artic Computing]] and received strong reviews. After leaving Artic, Tony had a spell at Cascade Games and then Bytron, writing air traffic control software. In 1990 Tony and [[Charles Cecil]], whom he had met at Artic Computing, founded [[Revolution Software]] together with David Sykes and Noirin Carmody. \n\nTony wrote the [[Virtual Theatre]] engine for Revolutions first release [[Lure of the Temptress]] which was published by [[Virgin Interactive]] on [[Atari ST]] and [[Amiga]] in 1992. The engine was developed for Revolutions second release [[Beneath a Steel Sky]], published by Virgin in 1994.\n\nAs the team size increased, Tony took on a role straddling design and programming for Revolutions [[Broken Sword]] series of games. \n\nCurrently Tony spends part of his time working with Revolution, and part of his time on his own projects.\n\n== Games credited ==\n* [[Obsidian (1986 Game)|Obsidian]] - Designer and Programmer (1986)\n* [[Ultima Ratio]] - Programmer (1987)\n* [[Death Stalker]] - Designer and Programmer (1988 )\n* [[19 - Boot Camp]] - Programmer (1989)\n* [[Lure of the Temptress]] - Designer and Programmer (1992)\n* [[Beneath a Steel Sky]] - Designer and Programmer (1994)\n* [[Broken Sword: The Shadow of the Templars]] ([[IBM PC compatible|PC]]/[[Playstation|PS1]]/[[Game Boy Advance|GBA]]) - Designer and Programmer (1996) \n* [[Broken Sword|Broken Sword 2: The Smoking Mirror]] - Designer and Programmer (1997)\n* [[In Cold Blood (video game)|In Cold Blood]] (2000)\n* [[Gold and Glory: The Road to El Dorado]] (2000) \n* [[Broken Sword: The Shadow of the Templars]] ([[Game Boy Advance]]) (2002)\n* [[Broken Sword: The Sleeping Dragon]] - Designer and Programmer (2003)\n* [[Classic Compendium - 1]] (2005) \n* [[Classic Compendium - 2]] (2005)\n* [[Broken Sword: The Angel of Death]] - Designer (2006)\n* [[Blocster]] - Designer and Programmer (2006)\n\n{{DEFAULTSORT:Warriner, Tony}}\n'
p12
tp13
a(I1
S'{{Infobox royalty|monarch\n| name           =Albert I\n| title          =Prince of Monaco\n| image          =Albert I of Monaco.png\n| reign          =10 September 1889 &ndash; 26 June 1922 ({{age in years and days|1889|9|10|1922|6|26}})\n| investiture    =\n| predecessor    =[[Charles III, Prince of Monaco|Charles III]]\n| successor      =[[Louis II, Prince of Monaco|Louis II]]\n| spouse         =[[Mary Victoria Hamilton|Lady Mary Hamilton]]<br>[[Alice Heine]]\n| issue          =[[Louis II, Prince of Monaco|Louis II of Monaco]]\n| princely house =[[House of Grimaldi]]\n| father         =[[Charles III, Prince of Monaco|Charles III]]\n| mother         =[[Antoinette de Mrode]]\n| date of birth  ={{birth date|1848|11|13|df=y}}\n| place of birth =[[Paris]], [[France]]\n| date of death  ={{death date and age|1922|6|26|1848|11|13|df=y}}\n| place of death =[[Paris]], [[France]]\n| place of burial=[[Monaco Cathedral]]\n|}}\n\nAlbert I, Prince of Monaco (13 November 1848 &ndash; 26 June 1922) was the tenth reigning Prince of [[Monaco]] and the tenth [[Duke of Valentinois]] from 10 September 1889 until his death.\n\n==Early life==\nBorn Albert Honor Charles Grimaldi on 13 November 1848 in [[Paris, France]], the son of [[Charles III, Prince of Monaco|Prince Charles III]] (1818-1889), and Countess [[Antoinette de Mrode-Westerloo]] (1828-1864), a [[Belgian nobility|Belgian noblewoman]].\n\nAs a young man, Prince Albert served in the [[Spanish Navy]], but during the [[Franco-Prussian War]], he joined the [[French Navy]] where he was awarded the [[Lgion dhonneur|Legion of Honor]]. He was only 22 years old when he began to develop an interest in the then relatively new science of [[oceanography]]. After several years of study, Albert showed his ingenuity by devising a number of techniques and instruments used for measurement and exploration (http://www.bookmine.org). Accompanied by some of the worlds leading marine scientists, he recorded numerous oceanographic studies, maps and charts. He then founded what would become the world renowned Oceanographic Institute in Monaco that included an [[aquarium]], a [[museum]], and a [[library]] plus research facilities in Paris. He also discovered the [[Princess Alice Bank]] of the [[Azores]] in 1896 on an oceanographic survey of the area.\n\nIn addition to his interest in [[oceanographic]] studies, Albert had a keen interest in the origins of man and in Paris, he founded the Institute for Human Paleontology that was responsible for a number of [[archeological]] digs. Alberts intellectual achievements gained him worldwide recognition and in 1909, the British Academy of Science made him a member.\n\n==Marriages==\n[[Image:Prince Albert I of Monaco and his wife Lady Mary Victoria Hamilton shortly after their wedding.jpg|thumb|left|Prince Albert with his first wife shortly after their wedding]]\nOn 21 September 1869 at the Chteau de Marchais (which is still in the possession of the Grimaldi family today) in [[Champagne (province)|Champagne]], Prince Albert was married to [[Lady Mary Victoria Hamilton]] (1850-1922), of [[Lanarkshire]], [[Scotland]], a daughter of the [[William Hamilton, 11th Duke of Hamilton|11th Duke of Hamilton]] and his wife, [[Princess Marie of Baden (1817-1888)|Princess Marie of Baden]]. The couple met for the first time in August 1869 at a ball hosted by the Emperor and Empress of France; their marriage had been arranged by Alberts grandmother [[Maria Caroline Gibert de Lametz|Caroline]].\n\nCaroline had tried to make a match between Albert and [[Mary Adelaide of Cambridge|Princess Mary Adelaide of Cambridge]], the first cousin of [[Queen Victoria]] and future mother of Britains [[Mary of Teck|Queen Mary]], but to no avail. This failure did not dissuade Caroline from her goal, and she sought the help of the French Emperor [[Napoleon III of France|Napolon III (Louis-Napolon Bonaparte)]] and his wife, [[Eugnie de Montijo|Empress Eugnie]].\n\nThe Emperor managed to convince Caroline that Queen Victoria was unlikely to allow one of her [[British Royal Family|family members]] to marry a Grimaldi.  The Emperor then suggested Mary, his third cousin and sister of his good friend, the [[William Douglas-Hamilton, 12th Duke of Hamilton|12th Duke of Hamilton]], as a suitable alternative. As the daughter of a [[Peerage of Scotland|Scottish duke]], Mary may not have been royalty, but her family was rich, well-connected, and related by blood to the French Imperial family through her maternal grandmother [[Stphanie de Beauharnais]], [[Napoleon I of France|Emperor Napolon I]]s adopted daughter and second cousin of Emperor Napolon IIIs [[Hortense de Beauharnais|mother]].<ref>[http://www.etoile.co.uk/Columns/RoyalScribe/050411.html The Royal Scribe<!-- bot-generated title -->] at www.etoile.co.uk</ref> The couple married at [[Chteau de Marchais]] on 21 September 1869.\n\nWithin a year of their marriage, the couples only child (Louis) was born, but the strong-willed, 19-year-old Scottish Mary disliked Monaco and everything about it. Shortly thereafter, she left Monaco permanently. The couple divorced, and the marriage was annulled on 28 July, 1880, although a special provision was made by the [[Holy See|Vatican]] to allow Louis to remain legitimate in the eyes of the Church. (Civilly, the marriage was dissolved on 28 July 1880 by the Order of Prince Charles III). That same year, the former Princess of Monaco remarried in Florence, Italy, to a Hungarian nobleman, Prince [[Tassilo Festetics von Tolna]], 1850-1933. They had a daughter, Maria, who would become the paternal grandmother of the fashion designer [[Egon von Frstenberg]] and his sister [[Ira von Frstenberg]], a European B-movie actress.\n\n==Accession==\n[[Image:Prince Albert I statue.JPG|thumb|right|The statue in Monaco-Ville]]\nOn 10 September, 1889, Albert ascended the throne of Monaco on the death of his father. That same year in [[Paris]], on 30 October, he married the Dowager Duchess de Richelieu, [[ne]] [[Alice Heine|Marie Alice Heine]] (1858-1925). The [[United States|American]] daughter of a [[New Orleans, Louisiana|New Orleans]] [[building contractor]] of [[German-Jewish]] descent, Alice Heine had married the [[Duc de Richelieu]] but had been widowed by age 21 and left with a young son, Armand. Her marriage to Prince Albert proved an equal blessing for him and the tiny [[principality]] of Monaco, since Alice brought a strong business acumen, well in advance of her youth. Having helped put her husbands principality on a sound financial footing, she would devote her energies to making Monaco one of Europes great cultural centers, with an opera, theater, and a ballet under the direction of the famed Russian impresario, [[Serge Diaghilev]].\n\nDespite the initial success of the marriage of Prince Albert and Princess Alice, in 1902, they separated legally, without issue, though did not divorce. According to [[Anne Edwards]] book <I>The Grimaldis of Monaco</I>, this was due to the Princess relationship with the composer [[Isidore de Lara]], a relationship that resulted in the Princess publicly being slapped across the face by her husband during an evening at the opera. By the same token, the [[courtesan]] Caroline Otero, [[La Belle Otero]], who had been a part-time lover of the prince between 1893 and 1897, recalled Albert fondly in her memoires and claimed that he wasnt a virile man and suffered from [[erection difficulty]]. Princess Alice had la Belle Otero banned from the province in 1897 for being seen with her husband.\n\n==Late life==\nOn 5 January, 1911, Prince Albert I granted Monaco a [[constitution]], but the document had little real meaning in terms of reducing autocratic rule and was soon suspended by the Prince when World War I broke out. Also in 1911, Prince Albert created the [[Monte Carlo Rally]], an automobile race designed to draw tourists to Monaco and the [[Casino]].\n\nDespite his military serviceor perhaps because of itthe Prince became a pacifist, establishing the International Institute of Peace in Monaco as a place to develop a peaceful settlement to conflict through arbitration. In the tension-filled times leading up to [[World War I]], Prince Albert made numerous attempts to dissuade Germanys [[Wilhelm II of Germany|Kaiser Wilhelm II]] from war.\n\nWhen war came, Prince Albert could not avoid becoming involved.  In one incident, he even wrote personally to the Kaiser in an effort to ameliorate the consequences of Gen. [[Karl von Blow]]s wrath. Without the Princes intervention, the [[Alsace|Alsatian]] villages of [[Sissonne]] and [[Marchais]] would have been destroyed.<ref name=nyt1914>[http://query.nytimes.com/mem/archive-free/pdf?res=990CE0DF153AE633A25751C0A9679D946596D6CF  Prince of Monaco Rebukes Kaiser; This Is How a Prussian General Treats a Friend of Germany, He Writes of Levy on His Chateau;  Offers Fine to Emperor; Willing to Pay Direct After the War if Home is Saved; Gives Copies of Letters to Whitney Warren,] New York Times.  2 November 1914.</ref>  In the Great War to End All Wars, Monaco declared its neutrality, but in fact, provided the Allied forces with hospitals, convalescent centers, and soldiers, including Prince Alberts only son, [[Louis II, Prince of Monaco|Louis]].\n\nIn 1920, the American Academy of Science awarded Prince Albert its gold medal for his achievements.\n\nThe Explorers Club elected Albert I to its highest category of membershipHonorary Memberin 1921.\n\nPrince Albert I of Monaco died on 26 June 1922 in Paris, France and was succeeded by his son, [[Louis II, Prince of Monaco|Louis II]].\n\n==Philately==\n{{commons|Albert I, Prince of Monaco}}\nAlbert I constituted a collection of [[postage stamp]]s that was later continued by Louis II and finally remain part of the postal museum [[Rainier III, Prince of Monaco|Rainier III]] created in 1950.\n\n==Honors==\n* Knight of the Black Eagle, [[German Empire]].<ref name=nyt1914/>\n\n'
p14
tp15
a(I-1
S'{{Notability|date=October 2008}} {{Unreferenced|date=October 2008}} \nSniffy: The Virtual Rat also known as Sniffy Pro and Sniffy Pro for Windows is a suite of computer software used for teaching the [[psychology]] of [[learning]] which simulates a rat in an [[operant box]] and can be used to run experiments and [[classical conditioning]] and [[operant conditioning]].\n\nIt is designed as an alternative to teaching psychology of learning using real rats, which can be prohibitively expensive or may be considered unethically cruel towards animals.\n\nSome general advantages and limitations of Sniffy noted by Jukabow (2007) are listed below:\nAdvantages:\n-It can simulate several classical conditioning topics that are covered in introductory courses such as; acquisition, extinction, spontaneous recovery, stimulus-intensity effects, compound conditioning, blocking, overshadowing, overexpectation, inhibition, sensory preconditioning, higher-order-conditioning, sensitization, and background conditioning.\n-It can simulate many of the operant conditioning topics covered in introductory courses such as; magazine training, reinforcement, punishment, secondary reinforcement, simple operant schedules, and discrimination.\n-It is not as expensive as maintaining a live animal lab.\n-It is more time effective than an animal lab. Students can be given the software and do the projects on their own time rather than during scheduled lab hours.\n\nLimitations:\n-The mind window function of the program. This allows the students to see into the rats mind to understand what is going on. Most of the procedures covered by this program are behavioral experiments. Getting an undergraduate to stop using terms like mind and think from a more scientific perspective is hard enough without the learning aids confounding the process.\n-The data produced from each rat is typically the same which makes the program useless for any between subject projects.\n-The speed of a behaviors reacquisition is identical to its original acquisition speed which is not the case in real animals.\n-A lever press will spontaneously be acquired if you do nothing to shape it which sort of defeats the purpose of most labs that would consider using this program.\n-I personally see the fact that it is a program which can be turned on an off as a problem in and of itself. Technically if the student is messing up they can just start over. Starting over when you make mistakes with real subjects is not nearly so simple.\n\nReferences\nJukabow, J. J.,(2007). Review of the book Sniffy the Virtual Rat Pro Version 2.0. Journal of the Experimental Analysis of   Behavior,87, 317-323.\n'
p16
tp17
a(I-1
S'{{Cleanup|date=February 2009}}\n\n{{Crimin}}\nCriminalization or criminalisation, in [[criminology]], is the process by which behaviors and individuals are transformed into [[crime]] and criminals.<ref>Michalowski p. 6.</ref> Previously legal acts may be transformed into crimes by [[legislation]] or judicial decision. However, there is usually a formal presumption in the rules of [[statutory interpretation]] against the [[ex post facto law|retrospective application of laws]] and only the use of express words by the [[legislature]] may rebut this presumption. The power of judges to make new law and retrospectively criminalise behaviour is also discouraged. In a less overt way, where laws have not been strictly enforced, the acts prohibited by those laws may also undergo de facto criminalisation through more effective or committed legal enforcement.\n\n== The problems ==\nAll [[society|societies]] conduct on-going debates to inform their policy making. In this particular debate, there has been some uncertainty as to the nature and extent of the contribution to be made by the victims of crime. All [[government]]s collect some statistics as to the incidence of crime within their territory, and accept a general role in offering some degree of protection to their [[citizen]]s as an aspect of the [[social contract]]. But, as Garkawe (2001) indicates, the relationship between [[victimology]] and [[criminology]] has become problematic. The [[Positivist school|Positivist School]] asked, why did this person offend? The [[Neo-classical school|Neo-Classical School]] and Left Idealism  from opposite political perspectives  asked why this social reaction was made to this behaviour? And conventional victimology asked, why is this type of person victimised? Fattah (1989 and 1992), Harding (1994) and others argue that victimology has become politicised, and that biased exploitation of research materials is both driving the cycle of criminalisation and [[decriminalisation]], and distorting the [[criminal justice]] system (Walklate: 1989). The concern is that, within the [[dialectic]] of [[Right Realism]] and [[Left realism|Left Realism]] (see generally Walklate: 2003), a focus on the victim promotes rights selectively for certain victims, and advocates the assumption that some victim rights are more important than competing rights or values in society (Elias: 1993). For example, an [[Islamic]] [[feminism|feminist]] might seek consistency of treatment for women as victims and, therefore, demand the decriminalisation of abortion, adultery, and seduction ([[Zina]] is a [[Hudud]] offence in [[syariah|syariah law]]), and the criminalisation of [[domestic violence]] and [[sexual harassment]].\n\nIn theory, society reaches a consensus view on whether certain acts or behaviour are harmful. In cases where there is agreement, the criminal justice system may be extended to treat those matters as crimes. Conversely, when society has evidence that it is no longer at risk from such acts or behaviour, they may be decriminalised. For example, Recommendation No. R (95) 12 adopted by the [[Council of Europe Committee of Ministers|Committee of Ministers]] of the [[Council of Europe]] on the management of criminal justice, advocates that crime policies such as decriminalisation, depenalisation or diversion, and mediation should be adopted wherever possible. But the law and order debate between right and left politicians is often superficial and unscientific, formulating policies based on their appeal to an uniformed electorate rather than properly conducted research (Currie: 1991). Encouraged by the politicians, the media which is increasingly owned by large corporations, endorses each new war on crime and drugs, ignoring all the others that have been fought and lost before (Elias 1994; Jackson & Naureckas 1994). Its bias toward official and corporate perspectives on criminal justice are so strong that some regard crime news as essentially [[propaganda]] (Leiper 1994).\n\n== Discussion ==\nLeading criminal law philosophers, such as Dennis Baker and Joel Feinberg have argued that conduct should only be criminalized when it is fair to do so.<ref>Dennis J. Baker Dennis, The Moral Limits of Criminalizing Remote Harms, (2007) 11(3) New Criminal Law Review 371, Joel Feinberg, Harm to Others: The Moral Limits of the Criminal Law, OUP, 1984: New York.</ref> In particular, such theorists assert that objective reasons are needed to demonstrate that it is fair to criminalize conduct in any given case. The commonly cited objective justification for invoking the criminal law is harm to others, but it cannot deal with all situations. For example, people are not necessarily harmed by public nudity. Feinberg suggests that offence to others also provides an objective reason for invoking the criminal law, but it clearly does not as offence is determined according to conventional morality. \n\nPeople experience a range of physical and social injuries in different contexts which will vary according to the level of economic and political development of their country. Some will be injured out of [[poverty]] and [[malnutrition]], others by [[violence]] which might stem from a major conflict such as [[war]] or from the personal violence in a [[robbery]]. The [[natural environment|environment]] may be damaged by [[pollution]], there may be hazards at work. Many of these sources of injury will be ignored while the state may delegate powers of control to a number of different agencies within an international framework where [[supranationalism|supranational]] agencies and [[human rights]] organisations may offer assistance in responding to the causes of those injuries.\n\nWhen a state debates whether to respond to a source of injury by criminalising the behaviour that produces it, there are no pre-set criteria to apply in formulating social policy. There is no [[ontology|ontological]] reality to crime. The criminal justice system responds to a substantial number of events that do not produce significant hardship to individual citizens. Moreover, events which do cause serious injuries and perhaps should be dealt with as crimes, e.g. situations of [[corporate manslaughter]], are either ignored or dealt with as civil matters.\n\nThe criminalisation process defines and classifies behaviour. It broadcasts the laws so that no-one may have the [[excuse]] of [[ignorantia juris non excusat|ignorance]], and disposes of those who will not obey. There are now more criminal laws and they are penetrating deeper into the social structures of modern societies. Crime control has become an industry, yet it remains ineffective in providing protection to all its citizens from harm. Such as it is, the process is made up of three components:\n#Creation of a social order. This is both a socio-economic process, a ...fundamental ordering of social relations so that those things necessary for social survival can be produced and distributed in some predictable fashion and an ideological process so that there can be a ...development of values, beliefs, and ideas related to the concrete tasks of production and distribution.(p. 6). Thus, society must develop the apparatus of law creation, law enforcement and [[punishment]] and the system must be acceptable to the majority of those who live in the community. If the laws do not match the general [[mores]], their enforcement will be a source of friction and disharmony. Conformity to the social order must, for the most part, be self-enforced. \n#For the times when self-enforcement fails, society must create a legal order. This part of the process sees the centralisation of power within the institutions of the political state. [[Monopoly on the legitimate use of physical force|Webers Thesis]] argued that the [[Sovereign state|state]] had a monopoly on the legitimate use of force within its borders. Some states justified the criminalisation process as demonstrating their concerns about safety and security, the policy of control, policing, criminal justice, and penal practice. The modern state is [[decentralisation|decentralising]] and [[privatisation|privatising]] its functions. This is changing the character and content of the remaining institutions of the state which must now work co-operatively with other for-profit agencies.\n#The political order must realign so that the remaining political entities such as [[legislature]]s and [[judge]]s set agreed targets for state control and then produce actual outputs of the legal order, i.e. of people defined as criminal and processed through that system.\n\n== Ontological basis of crime ==\n\nPut in the most simple terms, ontology deals with or establishes the clear grounds for being. (Heidegger, Martin, Being and Time, introduction, referencing Platos Parmenides.) In some of the traditional schools, such as those of the post-1688 English or Americans (many of the writings of the American Founding Fathers, but especially The Federalist) and their Dutch predecessors (see Kossmann, E. H. Political Thought in the Dutch Republic, 2004) ontology proper is deemed beyond the scope of legal thought, in accord with the modern distinction between society and state (which some consider based in the distinction the Romans made between themselves and their Italian allies, the socii, but not given the theoretical articulation we recognize today until emphasized by Thomas Hobbes Leviathan. See [[Sovereign state]].) However, some classical theorists, such as Aristotle, in his Politics and Metaphysics, and to a lesser degree in his Topics,{{Fact|date=November 2008}} suggest that the distinction is at least problematic. One need consider no further than the claim that man is a political animal to see this is so. \n\nAs a political animal, man has come to see himself as possessed of rights,<ref>UN Human Rights Council, http://www.ohchr.org/english/bodies/hrcouncil/</ref> whether these are the [[Rights of Englishmen]] of old, or the universal human rights advocated vigorously toward establishment today through the matrix of commercialism.<ref>International Covenant on Economic, Social and Cultural Rights, http://www.unhchr.ch/html/menu3/b/a_cescr.htm.</ref> At least in the today dominant American model, deprivation of right amounts to injury (consider especially Justice Stevens dissenting opinion in [[Castle Rock v. Gonzales]]), and injury -- so goes the prevailing theory -- amounts, when coupled with requisite intent, in most cases, to crime, when it does not admit of civil redress. Thus, again in simple terms, and to the extent that human beings are indeed political beings, crime does seem to have an ontological basis. (For one approach to the question of criminal ontology, see Understanding Crime and Social Control in Market Economies: Looking Back and Moving Forward by Robert Bohm in Jeffrey Ian Ross, ed. Cutting the Edge: Current Perspectives in Radical/Critical Criminology and Criminal Justice. Westport, Conn: Praeger, 1998.) This, further, seems to hold if ontology itself is divided into political and trans- or supra- or meta- political ontology -- i.e., what once was the realm of Christian theology. Of course, it does not matter whether that theology is Christian or belonging to some other apolitical belief. The point is that one may, with some justice, argue persuasively that being is divided. This need not, however, force the question of meta-political crimes. Our purposes here, in this article, are limited to the political. For the question in general see [[Ontology]].\n\nBaker  argues that only objective harms and other objective bad consequences (or actions in the case of inchoate and endangerment offenses) are prima facie criminalizable. By other bad consequences Baker means privacy violations and conduct that does not necessarily result in tangible harm, but does result in unwanted consequences. Baker argues that the privacy violations that result from being forced to receive unwanted obscene information in public places (exhibitionism) would amount to a sufficient bad consequence for the purposes of invoking the criminal law,  but argues that proportionate punishment means that such conduct should only be punished with fines rather than jail terms.\n\n'
p18
tp19
a(I1
S'{{autobiography}}\n{{Infobox Scientist\n|box_width         = \n|name              = Tony Laubach\n|image             = N72204051_30894444_5479.jpg\n|image_width       = 200px\n|caption           = Tony Laubach during the TWISTEX field project, 2008\n|birth_date        = [[November 20]], [[1980]]\n|birth_place       = [[Oxnard, California|Oxnard]], [[California]], [[United States|USA]]\n|death_date        = \n|death_place       = \n|residence         = [[Denver]], [[Colorado]], [[United States|USA]]\n|fields            = [[Meteorology]] and [[Technical Communications]]\n|workplaces        = \n|alma_mater        = [[Metropolitan State College of Denver]] (B.S., 2009)\n|known_for         = [[Storm Chasing]]\n|influences        = \n|influenced        = \n|awards            = \n|footnotes         = \n}}\n\nTony Laubach is an American professional [[storm chasing|storm chaser]] and Meteorologist.  He has participated in several field research projects, been contracted as a severe weather photojournalist for several major television networks, starred in several television shows, including the upcoming Season 3 of Storm Chasers on Discovery Channel, and also is a hobbyist storm chaser.\n\n== Early life ==\n\nTony Laubach was born in [[Oxnard, California]] in late 1980 and relocated along with his family several times before landing in Ohio in 1985.  Prior to settling in central Ohio, Tony was a resident of [[Pensacola, Florida]] and [[Charleston, West Virginia]].  His younger brother was born in 1983 while in Pensacola.  The family would then live briefly in [[West Virginia]] before moving to where Tony would call his hometown, [[Circleville, Ohio]].  Tony spent most of his elementary and high school life in Circleville, attending grade school in the Circleville City School program before transferring to a Catholic school in Lancaster.  Tony would return to Circleville schools his sophomore year attending [[Circleville High School]].  Tony lived in Circleville up until 1998 where he and his family relocated to [[Littleton, Colorado]].  Tony graduated high school, then enrolled in college at [[Red Rocks Community College]] before transferring to [[Metropolitan State College]] of Denver.  He did a brief stint at [[Oklahoma City Community College]] in 2000 before returning to the Denver area.  In May 2009, Tony graduated from Metro with a [[double major]] in [[Meteorology]] and Technical Communications.\n\n== Storm chase career ==\nTony has been chasing since 1997, but did not start doing it professionally until 2002.  He has seen 134 tornadoes since his first back in 1997 and has logged over 140,000 career miles since 2002.  He has chased in 25 different states and has seen tornadoes in 12 of those states, most being in Kansas.\n\nTonys interest in weather stemmed well back into his childhood due mostly to a storm he experienced while sitting in a vehicle with his younger brother while their mother went inside a drug store.  Storm chasing didnt reach him until after watching the [[Andover, Kansas tornado]] of 1991 on [[The Weather Channel]].\n\nOn May 14, 1997, Tony and his father chased the first [[tornado]] of Tonys career near [[Clarksburg, Ohio]].  His photos were used in the local newspaper later in the week.\n\nDuring the summer of 1998, Tony captured his first lightning photographs in Littleton, Colorado.\n\nOn October 22, 2000, Tony captured the second tornado of his career near [[Crossroads Mall (Oklahoma)|Crossroads Mall]] in [[Oklahoma City]] during his brief residence in Moore.\n\nOn May 5, 2002, Tony made his first out of state chase into the [[Texas Panhandle]].  While he missed the Happy, Texas tornado, he documented large hail and high winds on the same storm that produced the killer tornado.\n\nOn May 15, 2003, Tony saw his third and forth tornadoes in the Texas and [[Oklahoma Panhandle]].<ref>tornadoeskick.com. [http://www.tornadoeskick.com/index.php?option=com_content&view=article&id=35:20030515&catid=10:2003-season&Itemid=4 May 15, 2003 - Texas Panhandle], 2003-05-15.</ref>\n\nDuring the rest of 2003, Tony would document another three tornadoes for a total of five, bringing his career total by years end to seven.\n\nThe 2004 storm chase season would be his first significant chasing season as he would go on to document 28 tornadoes, including the [[Attica, Kansas]] tornado on May 12<ref>tornadoeskick.com. [http://www.tornadoeskick.com/index.php?option=com_content&view=article&id=41:20040512&catid=9:2004-season&Itemid=4 May 12, 2004 - Southern Kansas], 2004-05-12.</ref> and the [[Conway Springs, Kansas]] tornadoes on May 29<ref>tornadoeskick.com. [http://www.tornadoeskick.com/index.php?option=com_content&view=article&id=42:20040529&catid=9:2004-season&Itemid=4 May 29, 2004 - Southern Kansas], 2004-05-29.</ref>.  This would be his first year where he logged over 15,000 miles in chasing.\n\nDuring the 2005 and 2006 storm chase seasons, Tony documented a total of 15 tornadoes while covering over 33,000 miles.  The most notable tornado during those two years was the Trego County cold-core tornadoes on April 10, 2005.  The 2006 season saw Tony chase east of the [[Mississippi River]] since moving to Colorado.  He also accomplished the goal of chasing from Colorado to Ohio where we followed a tornado-warned storm from [[Xenia, Ohio]] into his hometown of Circleville on May 25, 2006.<ref>tornadoeskick.com. [http://www.tornadoeskick.com/index.php?option=com_content&view=article&id=77:20060525&catid=7:2006-season&Itemid=4 May 25, 2006 - Western Ohio], 2006-05-25.</ref>\n\nThe 2007 season was a breakthrough season for Tony as he logged nearly 34,000 miles and documented two-dozen tornadoes.  He also participated in TWISTEX, a tornado research project, and the first major field research of Tonys career.<ref>TWISTEX. [http://www.twistex.org Twistex.org online]</ref>  A large portion of those miles were logged late in the summer as Tony participated in a lightning field project with National Geographic and made several trips into northern Arizona.  During June 2007, Tony participated in the reality TV show, [[Original Productions|Twister Sisters]],<ref>WEtv.com. [http://www.wetv.com/twistersisters/index.html Twister Sisters - Ep. 6], Airdate, 2008-01-15.</ref> where he guest starred with his chase partner, documenting flooding in southwest Nebraska.<ref>KMGH 7News. [http://www.thedenverchannel.com/weather/13492081/detail.html 7NEWS Storm Chasers Capture Flash Flood, High-Water Rescue], 2007-06-12.</ref>\n\nThe 2008 storm chase season was his most notable to date.  It started early with a bust chase in Mississippi on January 10, then followed quickly with his earliest tornado intercepts of his career during the [[2008 Super Tuesday tornado outbreak]] where he documented a pair of tornadoes northeast of [[Memphis, Tennessee]].  Tornado intercepts remained very sparse through March and April where a small handful of tornadoes were intercepted.  He would again join the TWISTEX project and would score most of his 37 tornadoes during the [[Late-May 2008 tornado outbreak sequence|May 22-May 29 tornado outbreaks]].  While he did see tornadoes in Kansas, he ended up missing the Windsor, Colorado tornado on May 22.  Most notable intercepts during that week were the Quinter, Kansas tornado, the Kearney, Nebraska tornado, <ref>KMGH 7News. [http://www.thedenverchannel.com/weather/16430554/detail.html Great Plains See Severe Weather Outbreak], 2008-05-29.</ref>, and the Jewel, Kansas tornado.  The 2008 season ended early as weather conditions never returned for favorable severe weather events.  However, Tony did make a few local chases in and around Colorado, including the successful intercept of a severe thunderstorm that flooded the city of [[Brush, Colorado]] on July 2. <ref>KMGH 7News. [http://www.thedenverchannel.com/news/16776251/detail.html Flooding Creates Problems In Brush], 2008-07-02.</ref>  His last notable chase of 2008 was a lightning event northeast of Denver where he took over 60 photographs of lightning on a single storm, the most he had ever shot on a single storm.  By seasons end, Tony had driven over 27,000 miles from January 10 until September 1.\n\nIn 2009, Tony along with the research group TWISTEX, were brought on to the [[Discovery Channel]] TV series, [[Storm Chasers]].  Prior to their April start, the season was a slow one for Tony with a small handful of chases and no tornadoes.  It was not until late April that he documented his first tornadoes in Oklahoma then several days later in Texas.  A ridge kept chasing very sparse during the typical peak time, but he still managed to chase down a pair of tornadoes, including the Kirksville, MO tornado on May 13.  After a few unsuccessful chases, Tony and the crew had amazing success in June with tornado intercepts on June 5 in Wyoming, June 10 in Kansas, June 13 in Colorado, June 16 in South Dakota, and June 17 in Nebraska.  Tony and the TWISTEX crew formally ended operations at the end of June, but Tony continued to chase locally around Colorado documenting urban floods and hailstorms along the urban corridor.\n\n== Credited television appearances ==\n\nTwister Sisters - Episode 6, [[Womens Entertainment]] (Aired January 2008)\n\nDisaster Labs - Inside the Tornado, [[National Geographic Channel]] (Aired May 2009)\n\n[[Storm Chasers]] - Season 3, [[The Discovery Channel]] (Coming Fall 2009)\n\n== Credited print publications ==\n\nThe Colorado Weather Almanac - Mike Nelson\n\nTornado Hunter, Getting Inside the Most Violent Storms On Earth - Stefan Bechtel\n\n303 Magazine\n\n== Publications and news stories ==\n\n2007/05/14 - Storms Bring Heavy Rain, Hail, Tornadoes To Eastern Colo.<br>http://www.thedenverchannel.com/weather/13317905/detail.html\n\n2007/08/02 - Ten Years Later, Ft. Collins Gets a Wet Reminder<br>http://www.thedenverchannel.com/weather/13811013/detail.html\n\n2008/10/27 - TWISTEX 2008: In situ and mobile mesonet observations of tornadoes<br>http://ams.confex.com/ams/pdfpapers/141974.pdf\n\n2008/11/18 - What If The Windsor Tornado Had Hit Denver?<br>http://www.thedenverchannel.com/video/18011373/index.html\n\n'
p20
tp21
a(I-1
S'[[Image:MaternalBond.jpg|thumb|right|Mother and child]]\nThe term maternal deprivation is a catch-phrase summarising the early work of [[psychiatry|psychiatrist]] and [[psychoanalysis|psychoanalyst]], [[John Bowlby]] on the effects of separating infants and young children from their mother (or mother-substitute)<ref name=Holmes221>Holmes J. p. 221</ref> although the effect of loss of the mother on the developing child had been considered earlier by [[Freud]] and other theorists. Bowlbys work on delinquent and affectionless children and the effects of hospital and institutional care lead to his being commissioned to write the [[World Health Organisation]]s report on the mental health of homeless children in post-war Europe whilst he was head of the Department for Children and Parents at the [[Tavistock Clinic]] in London after [[World War II]].<ref name=Bretherton>{{cite journal |author= Bretherton I |title=The Origins of Attachment Theory: John Bowlby and Mary Ainsworth |year=1992 |journal=Developmental Psychology |pages= 759775 |volume=28 |doi=10.1037/0012-1649.28.5.759}}</ref> The result was the monograph Maternal Care and Mental Health published in 1951, which sets out the maternal deprivation hypothesis.<ref name=Bowlby 51>{{cite book |author=Bowlby J |year=1951|title=Maternal Care and Mental Health|publisher= World Health Organisation|location=Geneva}}</ref> \n\nBowlby drew together such empirical evidence as existed at the time from across Europe and the USA, including [[Rene Spitz|Spitz]] (1946) and Goldfarb (1943, 1945). His main conclusions, that the infant and young child should experience a warm, intimate, and continuous relationship with his mother (or permanent mother substitute) in which both find satisfaction and enjoyment and that not to do so may have significant and irreversible mental health consequences, were both controversial and influential.<ref name=bowlby11> Bowlby J. (1951) p. 11</ref> The [[monograph]] was published in 14 different languages and sold over 400,000 copies in the English version alone. Bowlbys work went beyond the suggestions of [[Otto Rank]] and [[Ian Suttie]] that mothering care was essential for development, and focused on the potential outcomes for children of deprivation of such care.\n\nThe 1951 WHO publication was highly influential in causing widespread changes in the practices and prevalence of institutional care for infants and children, and in changing practices relating to the stays of small children in hospitals so that parents were allowed more frequent and longer visits. Although the monograph was primarily concerned with the removal of children from their homes it was also used for political purposes to discourage women from working and leaving their children in daycare by governments concerned about maximising employment for returned and returning servicemen. The publication was also highly controversial with, amongst others, psychoanalysts, psychologists and learning theorists, and sparked significant debate and research on the issue of childrens early relationships.\n\nThe limited empirical data and lack of comprehensive theory to account for the conclusions in Maternal Care and Mental Health lead to the subsequent formulation of [[attachment theory]] by Bowlby.<ref name=Bowlby 1988>Bowlby J. (1988) p. 24</ref> Following the publication of Maternal Care and Mental Health Bowlby sought new understanding from such fields as evolutionary biology, ethology, developmental psychology, cognitive science and control systems theory and drew upon them to formulate the innovative proposition that the mechanisms underlying an infants tie emerged as a result of evolutionary pressure.<ref name=Cassidy>{{citation|author= Cassidy J|year=1999|contribution=The Nature of the Childs Ties|title=Handbook of Attachment: Theory, Research and Clinical Applications |editor= Cassidy J and Shaver PR|publisher= Guilford press|isbn=978-1572308268}}</ref> Bowlby expressed himself as having made good the deficiencies of the data and the lack of theory to link alleged cause and effect in Maternal Care and Mental Health in his later work Attachment and Loss published between 1969 and 1980.<ref name=GJT>{{citation|author=Bowlby J|year=1986|series= Citation Classic|title= Maternal Care and Mental Health|url=http://www.garfield.library.upenn.edu/classics1986/A1986F063100001.pdf|format=PDF}}</ref>\n\nAlthough the central tenet of maternal deprivation - that childrens experiences of interpersonal relationships are crucial to their [[psychology|psychological]] development and that the formation of an ongoing relationship with the child is as an important part of parenting as the provision of experiences, discipline and child care - has become generally accepted, maternal deprivation as a discrete [[syndrome]] is not a concept that is much in current use other than in relation to severe deprivation as in [[failure to thrive]]. In the area of early relationships it has largely been superseded by [[attachment theory]] and other theories relating to even earlier infant/parent interactions. As a concept, parental deficiencies are seen as a vulnerability factor for, rather than a direct cause of later difficulties. In relation to institutional care there has been a great deal of subsequent research on the individual elements of privation, deprivation, understimulation and deficiencies that may arise from institutional care.\n\n==History==\nMany traditions have stressed the grief of mothers over deprivation of their children but little has been said historically about young childrens loss of their mothers; this may have been because loss of the mother in infancy frequently meant death for a breast-fed infant. In the 19th century, French society bureaucratized a system in which infants were breast-fed at the homes of foster mothers, returning to the biological family after weaning, and no concern was evinced at the possible effect of this double separation on the child.<ref name=fildes>{{cite book |author= Fildes V |year=1988 |title= Wet Nursing |publisher=Blackwell|location= New York|isbn=978-0631158318 }}</ref>\n\n[[Sigmund Freud]] may have been among the first to stress the potential impact of loss of the mother on the developing child, but his concern was less with the actual experience of maternal care than with the anxiety the child might feel about the loss of the nourishing breast.<ref name=brown>{{cite book |author= Brown JAC |year=1961|title= Freud and the post-Freudians|location= London|publisher= Penguin}}</ref> As little of Freuds theory was based on actual observations of infants, little effort was made to consider the effects of real experiences of loss.[[Image:SisterIreneNYFH.jpg|thumb|right|[[Sister Irene]] at her New York Foundling Hospital in the 1890s]] \n\nFollowing Freuds early speculations about infant experience with the mother, [[Otto Rank]] suggested a powerful role in personality development for birth trauma. Rank stressed the traumatic experience of birth as a separation from the mother, rather than birth as an uncomfortable physical event. Not long after Ranks introduction of this idea, [[Ian Suttie]], a British physician whose early death limited his influence, suggested that the childs basic need is for mother-love, and his greatest anxiety is that such love will be lost.<ref name=brown/><ref name=suttie>{{cite book |author= Suttie I |year=1935|title= The Origins of Love and Hate |location= London|publisher= Penguin}}</ref>\n\nIn the 1930s, David Levy noted a phenomenon he called primary affect hunger in children removed very early from their mothers and brought up in institutions and multiple foster homes. These children, though often pleasant on the surface, seemed indifferent underneath. He questioned whether there could be a deficiency disease of the emotional life, comparable to a deficiency of vital nutritional elements within the developing organism.<ref name=rk17> Karen R. pp. 1317</ref> A few psychiatrists, psychologists and paediatricians were also concerned by the high mortality rate in hospitals and institutions obsessed with sterility to the detriment of any human or nurturing contact with babies. One rare paediatrician went so far as to replace a sign saying Wash your hands twice before entering this ward with one saying Do not enter this nursery without picking up a baby.<ref name=rk20>Karen R. pps. 2021</ref> \n\nIn a series of studies published in the 1930s, psychologist Bill Goldfarb noted not only deficits in the ability to form relationships, but also in the IQ of institutionalised children as compared to a matched group in foster care.<ref name=rk20/> In another study conducted in the 1930s, Harold Skeels, noting the decline in IQ in young orphanage children, removed toddlers from a sterile orphanage and gave them to feeble-minded institutionalised older girls to care for. The toddlers IQ rose dramatically. Skeels study was attacked for lack of scientific rigor though he achieved belated recognition decades later.<ref name=rk18>Karen R. pps. 1822</ref>  \n\n[[Rene Spitz]], a psychoanalyst, undertook research in the 1930s and 40s on the effects of maternal deprivation and [[hospitalism]]. His investigation focused on infants who had experienced abrupt, long-term separation from the familiar caregiver, as for instance when the mother was sent to prison. These studies and conclusions were thus different from the investigations of institutional rearing. Spitz adopted the term [[anaclitic depression]] to describe the childs reaction of grief, anger, and apathy to partial emotional deprivation (the loss of a loved object) and proposed that when the love object is returned to the child within three to five months, recovery is prompt but after five months, they will show the symptoms of increasingly serious deterioration. He called this reaction to total deprivation, hospitalism. He was also one of the first to undertake direct observation of infants.<ref name=spitz45>{{cite journal|author= Spitz R |year=1945|title= Hospitalism: An inquiry into the genesis of psychiatric conditions in early childhood|journal= Psychoanalytic Study of the Child|pages= 5374|volume= 1}}</ref><ref name=spitz50>{{cite journal|author= Spitz R |year=1950|title= Relevance of direct infant observation|journal= Psychoanalytic Study of the Child|pages= 6673|volume= 5}} </ref> The conclusions were hotly disputed and there was no widespread acceptance.<ref name=rk25>Karen R. p. 25</ref>\n\nDuring the years of World War II, evacuated and orphaned children were the subjects of studies that outlined their reactions to separation, including the ability to cope by forming relationships with other children. Some of this material remained unpublished until the post-war period and only gradually contributed to understanding of young childrens reactions to loss.<ref name=anna>{{cite book|author= Freud A and Burlingham DT|year=1943|title=War and Children|location= New York|publisher= Medical War Books}}</ref><ref name=anna2>{{citebook| author=Freud A and Burlingham DT|year= 1973|title= Infants Without Families and Reports on the Hampstead Nurseries, 1939-1945|series=The Writings of Anna Freud|volume=3|location= New York|publisher= International Universities Press}} </ref>\n\nBowlby, who unlike most psychoanalysts had direct experience of working with deprived children through his work at the [[London Child Guidance Clinic]], called for more investigation of childrens early lives in a paper published in 1940. He proposed that two environmental factors were paramount in early childhood. The first was death of the mother, or prolonged separation from her. The second was the mothers emotional attitude towards her child.<ref name=jk26>Karen J. pp. 2629</ref> This was followed by a study on fortyfour juvenile thieves collected through the Clinic. There were many problematic parental behaviours in the samples but Bowlby was looking at one environmental factor that was easy to document, namely prolonged early separations of child and mother. Of the forty-four thieves, fourteen fell into the category which Bowlby as being of an affectionless character. Of these fourteen, twelve had suffered prolonged maternal separations as opposed to only two of the control group.<ref name=Bowlby 44>{{citejournal|author= Bowlby J|year=1944|title=Forty-four juvenile thieves: Their characters and home life|journal= International Journal of Psychoanalysis|volume=25 |issue=1952 |pages=10727|quote= sometimes referred to by Bowlbys colleagues as Ali Bowlby and the Forty Thieves}}</ref>\n\n==Maternal Care and Mental Health==\nBowlbys work on delinquent and affectionless children and the effects of hospital and institutional care lead to his being commissioned to write the [[World Health Organisation]]s report on the mental health of homeless children in post-war Europe whilst he was head of the Department for Children and Parents at the [[Tavistock Clinic]] in London after [[World War II]].<ref name=Bretherton/> Bowlby travelled on the Continent and in America, communicating with social workers, paediatricians and child psychiatrists including those who had already published literature on the issue. These authors were mainly unaware of each others work and Bowlby was able to draw together the findings and highlight the similarities described despite the variety of methods used ranging from direct observation to retrospective analysis to comparison groups. In addition there was work from England undertaken by Dorothy Burlingham and Anna Freud on children separated from their families due to wartime disruption, and Bowlbys own work.<ref name=rk59> Karen R. pps.5962</ref> The result was the monograph Maternal Care and Mental Health published in 1951, which sets out the maternal deprivation hypothesis.<ref name=Bowlby 51/> The WHO report was followed by the publication of an adbridged version for public consumption called Child Care and the Growth of Love. This book sold over half a million copies worldwide. Bowlby tackled not only institutional and hospital care, but also policies of removing children from unwed mothers and untidy and physically neglected homes, and lack of support for families in difficulties. In a range of areas Bowlby cited the lack of adequate research and suggested the direction this could take.<ref name=rk62>Karen R. pps 6266</ref>\n\n==Principal concepts of Bowlbys theory==\nThe quality of parental care was considered by Bowlby to be of vital importance to the [[child development|childs development]] and future [[mental health]]. It was believed to be essential that the [[infant]] and young child should experience a warm, intimate, and continuous relationship with his mother (or permanent mother substitute) in which both found satisfaction and enjoyment. Given this relationship, emotions of guilt and anxiety (characteristics of mental illness when in excess) would develop in an organised and moderate way. Naturally extreme emotions would be moderated and become amenable to the control of the childs developing personality. He stated It is this complex rich and rewarding relationship with the mother in the early years, varied in countless ways by relations with the father and with siblings, that child psychiatrists and many others now believe to underlie the development of character and mental health.<ref name=bowlby11/>\n[[Image:Prayer Time in the Nursery--Five Points House of Industry.png|left|280px|thumb|Residential nursery]]\nThe state of affairs in which the child did not have this relationship he termed maternal deprivation. This term covered a range from almost complete deprivation, not uncommon in institutions, residential nurseries and hospitals, to partial deprivation where the mother, or mother substitute, was unable to give the loving care a small child needs, to mild deprivation where the child was removed from the mothers care but was looked after by someone familiar whom he trusted.<ref name=bowlby12>Bowlby J. (1951) pps. 1112</ref> Complete or almost complete deprivation could entirely cripple the capacity to make relationships. Partial deprivation could result in acute anxiety, depression, neediness and powerful emotions which the child could not regulate. The end product of such psychic disturbance could be neurosis and instability of character.<ref name=bowlby12/> However, the main focus of the monograph was on the more extreme forms of deprivation. The focus was the childs developing relationships with his mother and father and disturbed parentchild relationships in the context of almost complete deprivation rather than the earlier concept of the broken home as such.<ref name=Bowlby 51/>\n\nIn terms of social policy, Bowlby advised that parents should be supported by society as parents are dependent on a greater society for economic provision and if a community values its children it must cherish its parents. Also husbandless mothers of children under 3 should be supported to care for the child at home rather than the child be left in inadequate care whilst the mother sought work. (It was assumed the mother of the illegitimate child would usually be left with the child). Fathers left with infants or small children on their hands without the mother should be provided with housekeepers so that the children could remain at home.<ref name=bowlby84>Bowlby J. (1951) pps. 8490</ref> Other proposals included the proper payment of foster homes and careful selection of [[foster care]]rs,<ref name=bowlby117>Bowlby J. (1951) pps. 117122</ref> and frank, informative discussions with children about their parents and why they ended up in care and how they felt about it rather than the least said, soonest mended approach. The point that children were loyal to and loved even the worst of parents, and needed to have that fact understood non-judgementally, was strongly made.<ref name=bowlby124>Bowlby J. (1951) pps. 124126</ref>\n\nOn the issue of removal of children from their homes, Bowlby emphasised the strength of the tie that children feel towards their parents and discussed the reason why, as he put it, children thrive better in bad homes than in good institutions. He was strongly in favour of support being provided to parents and extended families to improve the situation and provide care within the family rather than removal if possible.<ref name=bowlby67>Bowlby J. (1951) pps. 6792</ref>\n\n==Maternal==\nBowlby used the phrase mother (or permanent mother substitute).<ref name=bowlby11/>\nAs it is commonly used, the term maternal deprivation is ambiguous as it is unclear whether the deprivation is that of the biological mother, of an adoptive or foster mother, a consistent caregiving adult of any gender or relationship to the child, of an emotional relationship, or of the experience of the type of care called mothering in many cultures. Questions about the exact meaning of this term are by no means new, as the following statement by Mary Ainsworth in 1962 indicates: Although in the early months of life it is the mother who almost invariably interacts most with the child... the role of other figures, especially the father, is acknowledged to be significant...[P]aternal deprivation... has received scant attention... [In the case of] institutionalization ... the term parental deprivation  would have been more accurate, for the child has been... deprived of interaction with a father-figure as well as a mother-figure... [It may be better to] discourage the use of [the term deprivation] and encourage the substitution of the terms insufficiency, discontinuity, and distortion instead.<ref name =Ainsworth 62>{{citation|author= Ainsworth MD|year=1962|contribution=The Effects of Maternal Deprivation: A Review of Findings and Controversy in the Context of Research Strategy|title=Deprivation of Maternal Care: A Reassessment of its Effects|location=Geneva|publisher= World Health Organization|series= Public Health Papers, No. 14}} </ref> Ainsworth implies, neither the word maternal nor the word deprivation seems to be a literally correct definition of the phenomenon under consideration.\n\nA contemporary of Ainsworth spoke of the mother, a term by which we mean both the childs actual mother and/or any other person of either sex who may take the place of the childs physical mother during a significant period of time.<ref>{{cite journal | author= Spitz RA| year=1949|title= Autoerotism |journal= Psychoanalytic Study of the Child |pages= 85120 |volume= 3}} </ref> However, another contemporary referred to the quasi-mystical union of mother and child, of the dynamic union that mother and child represent.<ref>{{cite journal | author= Rank B| year=1949|title= Aggression |journal= Psychoanalytic Study of the Child |pages= 4348 |volume= 3}}</ref>\n\n==Influence on institutionalised care==\nThe practical effects of the publication of Maternal Care and Mental Health were described in the preface to the [[WHO]] 1962 publication Deprivation of maternal care: A Reassessment of its Effects as almost wholly beneficial with reference to widespread changes in the institutional care of children.<ref name=WHO 62>{{cite book|author=Ainsworth M et al.|year=1962|title=Deprivation of Maternal Care: A Reassessment of its Effects|location= Geneva|publisher= World Health Organization, Public Health Papers, No. 14}}</ref>.[[Image:Two nurses with baby in nursery at Toronto East General and Orthopaedic Hospital, Toronto, ON.jpg|right|thumb|180px|Maternity ward, 1955]] The practice of allowing parents frequent visiting to hospitalised children became the norm and there was a move towards placing homeless children with [[foster care]]rs, rather than in institutions, and a move towards the professionalisation of alternative carers. In hospitals, the change was given added impetus by the work of social worker and psychoanalyst [[James Robertson (psychoanalyst)|James Robertson]] who filmed the distressing effects of separation on children in hospital and collaborated with Bowlby in making the 1952 documentary film A Two-Year Old Goes to the Hospital.<ref name= Schwartz>{{citebook | author= Schwartz J | title= Cassandras Daughter: A History of Psychoanalysis | year=1999 | page=225 |publisher= Viking/Allen Lane |isbn= 0670886238 }}</ref> \nAccording to [[Michael Rutter]], the importance of Bowlbys initial writings on maternal deprivation lay in his emphasis that childrens experiences of interpersonal relationships were crucial to their [[psychology|psychological]] development and that the formation of an ongoing relationship with the child was as an important part of parenting as the provision of experiences, discipline and child care. Although this view was rejected by many at the time, the argument focussed attention on the need to consider parenting in terms of consistency of caregivers over time and parental sensitivity to childrens individuality and it is now generally accepted.<ref name=Rutter 95>{{cite journal | author = Rutter M | title = Clinical implications of attachment concepts: retrospect and prospect | journal = J Child Psychol Psychiatry | volume = 36 | issue = 4 | pages = 54971 | year = 1995 | month = May | pmid = 7650083 }}</ref> Bowlbys theory sparked considerable interest and controversy in the nature of early relationships and gave a strong impetus to what [[Mary Ainsworth]] described as a great body of research in what was perceived as an extremely difficult and complex area.<ref name=WHO 62/>\n\n==Psychoanalysis==\nBowlby departed from [[psychoanalysis|psychoanalytical]] theory which saw the gratification of sensory needs as the basis for the relationship between infant and mother.<ref name=Bretherton/> Food was seen as the primary drive and the relationship, or dependency was secondary.<ref name=Bowlby 1988/> He had already found himself in conflict with dominant [[Melanie Klein|Kleinian]] theories that childrens emotional problems are almost entirely due to fantasies generated from internal conflict between aggressive and [[libido|libidinal]] drives, rather than to events in the external world. (His breach with the psychoanalysts only became total and irreparable after his later development of [[attachment theory]] incorporating [[ethology|ethological]] and [[evolutionary psychology|evolutionary]] principles, when he was effectively ostracised). Bowlby also broke with [[social learning theory]]s view of dependency and reinforcement. Bowlby proposed instead that to thrive emotionally, children needed a close and continuous caregiving relationship.<ref name=Bretherton/>\n\nBowlby later stated that he had concluded that, contrary to the focus of psychoanalysts on the internal fantasy world of the child, the important area to study was how a child was actually treated by his parents in real life and in particular the interaction between them. He chose the actual removal of children from the home at this particular time because it was a specific event, the effects of which could be studied, and because he believed it could have serious effects on a childs development and because it was preventable. In addition, views that he had already expressed about the importance of a childs real life experiences and relationship with carers had been met by sheer incredulity by colleagues before [[World War II]]. This lead him to see that far more systematic knowledge was required of the effects on a child of early experiences. Bowlby and his colleagues were pioneers of the view that studies involving direct [[Observation#Observation_as_Recording_of_Scientific_Data|observation]] of infants and children were not merely of interest but were essential to the advancement of science in this area.<ref name=bowlby8843>Bowlby J. (1988) pps. 4345</ref>\n\n==Controversy, misinterpretation and criticism==\n{{See also| Attachment theory| Attachment in children}}\nAside from his profound differences with psychoanalytic ideas, the theoretical basis of Bowlbys monograph was controversial in a number of ways. Some profoundly disagreed with the necessity for maternal (or equivalent) love in order to function normally,<ref name=Wootten 62>{{citation|author= Wootton B|year=1962|contribution=A Social Scientists Approach to Maternal Deprivation|title=Deprivation of Maternal Care: A Reassessment of its Effects|location= Geneva|publisher= World Health Organization|series= Public Health Papers, No. 14|pages= 255266}}</ref> or that the formation of an ongoing relationship with a child was an important part of parenting.<ref name=Rutter 95/> The idea that early experiences have serious consequences for intellectual and psychosocial development was controversial in itself.<ref name=rk65> Karen R. p.65</ref> Others questioned the extent to which his [[hypothesis]] was supported by the evidence. There was criticism of the confusion of the effects of privation (no primary attachment figure) and deprivation (loss of the primary attachment figure) and in particular, of the failure to distinguish between the effects of the lack of a primary attachment figure and the other forms of deprivation and understimulation that may affect children in institutions.<ref name=Rutter 81>{{cite book|author=Rutter M|year=1981|title= Maternal Deprivation Reassessed: 2nd edition|publisher= Penguin|location=Harmondsworth|isbn=978-0140227000}} </ref>\n\nIt was also pointed out that there was no explanation of how experiences subsumed under the broad heading of maternal deprivation could have effects on personality development of the kinds claimed. Bowlby explained in his 1988 work that the data were not at the time accommodated by any theory then current and in the brief time of my employment by the World Health Organisation there was no possibility of developing a new one. He then goes on to describe the subsequent development of attachment theory.<ref name=Bowlby 1988/>\n\nIn addition to criticism his ideas were often oversimplified, misrepresented, distorted or exaggerated for various purposes. This heightened the controversy.<ref name=rk65/> In 1962 WHO published Deprivation of maternal care: A Reassessment of its Effects to which Mary Ainsworth, Bowlbys close colleague, contributed with his approval, to present the recent research and developments and to address misapprehensions.<ref name=WHO 62/>\n\nBowlbys work was misinterpreted to mean that any separation from the natural mother, any experience of institutional care or a multiplicity of mothers necessarily resulted in severe emotional deprivation and sometimes, that all children undergoing such experiences would develop into affectionless children. As a consequence it was claimed that only 24 hour care by the same person (the mother) was good enough, day care and nurseries were not good enough and mothers should not go out to work. [[WHO]] advised that day nurseries and creches could have a serious and permanent deleterious effect.<ref name=Rutter 81/> Such strictures suited the policies of governments concerned about finding employment for returned and returning servicemen after [[World War II]].<ref name=Holmes45>Holmes J. pps. 4546</ref> In fact, although Bowlby was of the view that proper care could not be provided by roster he was also of the view that babies should be accustomed to regular periods of care by another and that the key to alternative care for working mothers was that it should be regular and continuous.<ref name=Rutter 81/> He addressed this point in a 1958 publication called Can I Leave My Baby?. Ainsworth in the WHO 1962 publication also attempted to address this misapprehension by pointing out that the requirement for continuity of care did not imply an exclusive mother-child pair relationship.<ref name=Ainsworth 62/> \n\nBowlbys quotable remark, that children thrived better in bad homes than in a good institutions,<ref name=bowlby68>Bowlby J. (1951) p. 68</ref> was often taken to extremes leading to reluctance on the part of Childrens Officers (the equivalent of child care [[social worker]]s) to remove children from homes however neglectful and inadequate. In fact, although Bowlby mentioned briefly the issue of partial deprivation within the family, this was not fully investigated in his monograph as the main focus was on the risks of complete or almost complete deprivation.<ref name=Rutter 72>{{citebook|author=Rutter M|year=1972|title= Maternal Deprivation Reassessed|location= Harmondsworth|publisher= Penguin|isbn=}}</ref> \n\n[[Michael Rutter]] made a significant contribution to the controversial issue of Bowlbys maternal deprivation hypothesis. His 1981 monograph and other papers (Rutter 1972; Rutter 1979) comprise the definitive empirical evaluation and update of Bowlbys early work on maternal deprivation. He amassed further evidence, addressed the many different underlying social and psychological mechanisms and showed that Bowlby was only partially right and often for the wrong reasons. Rutter highlighted the other forms of deprivation found in institutional care, the complexity of separation distress and suggested that anti-social behaviour was not linked to maternal deprivation as such but to family discord. The importance of these refinements of the maternal deprivation hypothesis was to reposition it as a vulnerability factor rather than a causative agent, with a number of varied influences determining which path a child will take.<ref name=Holmes49>Holmes J. pps. 4951</ref> \n\nRutter has more recently advised attention to the complexity of development and the roles of genetic as well as experiential factors, noting that separation is only one of many risk factors related to poor cognitive and emotional development.<ref name=Rutter 02>{{cite journal | author = Rutter M | title = Nature, nurture, and development: from evangelism through science toward policy and practice | journal = Child Dev | volume = 73 | issue = 1 | pages = 121 | year = 2002 | pmid = 14717240 | doi = 10.1111/1467-8624.00388| url = http://www.blackwell-synergy.com/openurl?genre=article&sid=nlm:pubmed&issn=0009-3920&date=2002&volume=73&issue=1&spage=1 }}</ref>\n\n===Fathers===\n[[Image:Father with child.jpg|thumb|Father and child|left]]\nIn accordance with the prevailing social realities of his time, namely the assumption that the daily care of infants and small children was undertaken by women and in particular, mothers, Bowlby referred primarily to mothers and maternal deprivation, although the words parents and parental are also used.<ref name=Bretherton/>  Fathers are mentioned only in the context of the practical and emotional support they provide for the mother but the monograph contains no specific exploration of the fathers role. Nor is there any discussion as to whether the maternal role had, of necessity, to be filled by women as such. Bowlbys work was misinterpreted by some to mean natural mothers only.<ref name=Andry>{{citation|author= Andry RG|year=1962|contribution=Paternal and Maternal Roles and Delinquency|title=Deprivation of Maternal Care: A Reassessment of its Effects|location= Geneva|publisher= World Health Organization|series= Public Health Papers, No. 14}}</ref> \n\nThe 1962 WHO publication contains a chapter on the effect of paternal deprivation there having by 1962 been some limited research on the issue which illustrated the importance of the fathers relationship with his children.<ref name=Andry/> The hope was expressed by Ainsworth that in the future there would be more such research and indeed her early research, which contributed significantly to attachment theory, covered infants relationships with all family members. It was also stated that in relation to institutional care, parental deprivation would have been  more accurate, although Ainsworth preferred the terms insufficiency, discontinuity and distortion to either.<ref name=Ainsworth 62/>\n\n[[Michael Rutter]] in Maternal Deprivation Reassessed (1972) described by New Society as a, classic in the field of child care, argued that research showed that it did not matter which parent the child got on well with as long as he got on well with one of them, that both parents influence their childs development and that which parent is more important varies with age, sex and temperamental development. He concluded, For some aspects of development the same-sexed parent seems to have a special role, for some the person who plays and talks most with the child and for others the person who feeds the child. The father, the mother, brother and sisters, friends, school-teachers and others all have an impact on development, but their influences and importance differ for different aspects of development. A less exclusive focus on the mother is required. Children also have fathers!<ref name=Rutter 72/>\n\nWithin [[attachment theory]], Bowlby, in Attachment and Loss, volume one of Attachment, published in 1969, makes it quite clear that infants become attached to carers who are sensitive and responsive in their social interactions with them and that this does not have to be the mother or indeed a female. As a matter of social reality mothers are more often the primary carers of children and therefore are more likely to be the primary attachment figure but the process of attachment applies to any carer and infants develop a number of attachments according to who relates to them and the intensity of the engagement.<ref name=Bowlby 1969 2nd ed>{{citation|author=Bowlby J|title=Attachment: Attachment and Loss. Vol 1|year= [1969](1982)|isbn=978-0712674713|publisher=Pimlico|location=London}} </ref> However, attachment theory relates to the development of attachment behaviours and relationships after about 7 months of age and there are other theories and research relating to earlier carer/infant interactions.\n\nSchaffer in Social Development (1996) suggests that the father-child relationship is primarily a cultural construction shaped by the requirements of each society. In societies where the care of infants has been assigned to boys rather than girls, no difference in nurturing capacity was found.<ref name=GJP>{{citebook|author=Schaffer HR|year=1996|title= Social Development: an introduction|location= Oxford|publisher= Blackwell|isbn=978-0631185741 \n}}</ref><ref name=DJP>{{citejournal|author=Field T |year=1978|title= Interaction behaviours of primary versus secondary caretaker fathers|journal= Developmental Psychology|volume= 14|pages= 183184|doi=10.1037/0012-1649.14.2.183}}</ref>\n\n===Feminist criticism===\nThere were three broad criticisms aimed at the idea of maternal deprivation from feminist critics.<ref name=Holmes45x2/> The first was that Bowlby overstated his case. The studies on which he based his conclusions involved almost complete lack of maternal care and it was unwarranted to generalise from this view that any separation in the first three years of life would be damaging. Subsequent research showed good quality care for part of the day to be harmless. The idea of exclusive care or exclusive attachment to a preferred figure, rather than a hierarchy (subsequently thought to be the case within developments of [[Attachment theory#Tenets of attachment theory|attachment theory]]) was not been borne out by research and this view placed too high an emotional burden on the mother. Secondly they criticised Bowlbys historical perspective and saw his views as part of the idealisation of motherhood and family life after [[World War II]]. Certainly his hypothesis was used by governments to close down much needed residential nurseries although governments did not seem so keen to pay mothers to care for their children at home as advocated by Bowlby. Thirdly feminists objected to the idea of anatomy as destiny and concepts of naturalness derived from ethnocentric observations. They argued that anthropology showed that it is normal for childcare to be shared by a stable group of adults of which maternal care is an important but not exclusive part.<ref name=Holmes45x2>Holmes J. pps. 4548</ref>\n\n==Maternal deprivation today==\nWhilst Bowlbys early writings on maternal deprivation may be seen as part of the background to the later development of [[attachment theory]], there are many significant differences between the two. At the time of the 1951 publication there was little research in this area and no comprehensive theory on the development of early relationships.<ref name=Bowlby 1988/> Aside from its central proposition of the importance of an early, continuous and sensitive relationship, the monograph concentrates mostly on [[social policy]]. For his subsequent development of attachment theory Bowlby drew on concepts from [[ethology]], [[cybernetics]], [[information processing]], [[developmental psychology]] and [[psychoanalysis|psychoanalysts]]. The first early formal statements of attachment theory were presented in three papers in 1958, 1959 and 1960. His major work Attachment was published in 3 volumes between 1969 and 1980. Attachment theory revolutionised thinking on the nature of early attachments and extensive research continues to be undertaken.<ref name=Cassidy/>\n\nAccording to [[Charles H. Zeanah|Zeanah]], ethological attachment theory, as outlined by John Bowlby ...1969 to 1980 ... has provided one of the most important frameworks for understanding crucial risk and protective factors in social and emotional development in the first 3 years of life. Bowlbys (1951) monograph, Maternal Care and Mental Health, reviewed the world literature on maternal deprivation and suggested that emotionally available caregiving was crucial for infant development and mental health.<ref name =Zeanah>{{cite journal | author = Zeanah CH | title = Beyond insecurity: a reconceptualization of attachment disorders of infancy | journal = J Consult Clin Psychol | volume = 64 | issue = 1 | pages = 4252 | year = 1996 | month = February | pmid = 8907083 | doi = 10.1037/0022-006X.64.1.42| url = http://content.apa.org/journals/ccp/64/1/42 }}</ref> Beyond that broad statement which is now generally accepted little remains of the underlying detail of Bowlbys theory of maternal deprivation that has not been either discredited or superseded by attachment theory and other child development theories and research, except in the area of extreme deprivation.\n\nThe opening of East European orphanages in the early 1990s following the end of the [[cold war]] provided substantial opportunities for research on attachment and other aspects of institutional rearing, however such research rarely mentions maternal deprivation other than in a historical context. Maternal deprivation as a discrete syndrome is a concept that is rarely used other than in connection with extreme deprivation and [[failure to thrive]]. Rather there is consideration of a range of different lacks and deficiencies in different forms of care, or lack of care, of which attachment is only one aspect, as well as consideration of constitutional and genetic factors in determining developmental outcome.<ref name=Rutter 02/> Subsequent studies have however confirmed Bowlbys concept of cycles of disadvantage although not all children from unhappy homes reproduce the deficiencies in their own experience.<ref name=Holmes51>Holmes J. p. 51</ref> Rather it is now conceptualised as a series of pathways through childhood and a number of varied influences will determine which path a particular child takes.<ref name=Rutter 81/>\n\n==The maternal deprivation concept outside mainstream psychology==\n\nThe idea that separation from the female caregiver has profound effects is one with considerable resonance outside the conventional study of child development. In United States law, the tender years doctrine was long applied when custody of infants and toddlers was preferentially given to mothers. Over the last decade or so, some decisions appear to have been derived from the tender years concept, but others involve the contrary assumption that a two-year-old is too young to have developed a relationship with either parent.<ref name=mercer>{{citebook|author= Mercer J|year=2006|title= Understanding Attachment: Parenting, Child Care, and Emotional Development |location= Westport, CT|publisher= Praeger|isbn=978-0275982171 \n}}</ref>\n\nConcern with the negative impact of separation from the mother is characteristic of the belief systems behind some [[Complementary and alternative medicine|complementary and alternative]] (CAM) psychotherapies. Such belief systems are concerned not only with the impact of the young childs separation from the care of the mother, but with an emotional attachment between mother and child which advocates of these systems believe to develop prenatally. Such attachment is said to lead to emotional trauma if the child is separated from the birth mother and adopted, even if this occurs on the day of birth and even if the adoptive family provides all possible love and care. These beliefs were at one time in existence among some legitimate psychologists of psychoanalytic background.<ref name=brown>{{citebook|author= Brown JAC|year=1961|title= Freud and the Post-Freudians|location= London|publisher= Penguin}}</ref><ref name=freudWE>{{citation|author= Freud WE|year=1973|contribution= Prenatal attachment and bonding|editor=Greenspan SI and Pollock GH|title= The Course of Life, Vol. I, Infancy|location= Nadison, CT|publisher= International Universities Press}} </ref> Today, however, beliefs in prenatal communication between mothers and infants are largely confined to unconventional thinkers such as William Emerson.<ref name=emerson>{{citejournal|author= Emerson WR|year=1996|title= The vulnerable pre-nate|journal= Pre- and Perinatal Psychology Journal|volume= 10|issue=3|pages=125142}}</ref> \n\nBelief in prenatal fetal awareness, mental communication between mother and unborn child, and emotional attachment of child to mother as a prenatal phenomenon, are concepts that connect easily to the unfounded assumption that all adopted children suffer emotional disorders. These beliefs are also congruent with CAM psychotherapies such as [[attachment therapy]], (not based on attachment theory), which purport to bring about age regression and to recapitulate early development to produce a better outcome.<ref name=MerSarRos>{{citebook|author= Mercer J, Sarner L, Rosa L|year=2003|title= Attachment therapy On Trial: The Torture and Death of Candace Newmaker|series=Child Psychology & Mental Health |location= Westport, CT|publisher= Praeger|isbn=978-0275976750 }} </ref>\n\n'
p22
tp23
a(I1
S'Fernand Serrane (1880-1932) was a Belgian [[philatelist]] who was a popular philatelic author in France and published one of the classic works in the field of identifying [[forged stamps]].\n\n== Masterwork ==\nSerranes masterwork was his Vade-Mecum du specialiste en timbres-poste, published in two volumes in 1927 and 1929.\n\nNot since [[Robert Brisco Eare]] produced his last edition of Album Weeds in 1906 had a worldwide survey of forgeries appeared and the two books are essential companions in the study of forgeries and fakes of the classic era.\n\nThe later publication of The Serrane Guide, as it is known, is helpful to philatelists as it covers the heyday of some prolific stamp forgers not known to Earee, for instance, [[Francois Fournier]], [[Angelo Panelli]], [[Lucian Smeets]], and [[N. Imperato]].<ref>Tyler, Varro E. Introduction to The Serrane Guide: Stamp Forgeries of the World to 1926. State College: American Philatelic Society, 1998, p.x. ISBN 0933580169</ref>\n\n== New edition ==\nIn 1971 Dr Cortland Eyer (1906-89), a retired Professor of Romance Languages, began the first English translation of the Serrane Guide. His work was sponsored by members of the [[American Philatelic Society]] (APS) and took three years to complete during which Eyer checked every reference made by Serrane.<ref>Tyler, p.vii.</ref>\n\nThe translation was published in serial form in the APS journal The American Philatelist, and in book form in 1998.\n\nSerrane had been a member of the APS since 1925.\n\n== Selected publications ==\n*Guide du Specialiste. 1919. (French language)\n*Catalogue du specialiste des timbres-poste dEurope. Brussels: 1922. (French language)\n*La reconstruction des planches de lemission de Bordeaux, 1870. Amiens: 1926. (French language)\n*I: Vade-Mecum du specialiste en timbres-poste dEurope. Nice: LEclaireur de Nice Press, 1927. (French language)\n*II: Vade-Mecum du specialiste en timbres-poste hors dEurope. Bergerac: Gnrale du Sud-ouest (J. Castanet), 1929. (French language)\n*The Serrane Guide: Stamp Forgeries of the World to 1926. First English language edition in book form. State College: [[American Philatelic Society]], 1998. ISBN 0933580169\n\n'
p24
tp25
a(I1
S'{{Infobox Writer\n| name        = Julian Sprung\n| image       =\n| imagesize   = 200px\n| caption     =\n| pseudonym   = \n| birthdate  = 1966\n| birthplace =\n| deathdate  =\n| deathplace = \n| occupation  = Author and Writer\n| nationality = [[United States|American]]\n| period      =\n| genre       =\n| subject     = Zoology\n| movement    =\n| influences  =\n| influenced  = \n| signature   =\n| spouse      =\n| website     =\n}}\nJulian Sprung (born 1966) is an [[United States|American]] [[author|writer]] on [[marine aquarium]] [[fishkeeping]]. He is an [[alumnus]] of the [[University of Florida]] where he studied [[zoology]], graduating in 1988.<ref>[http://www.theimac.org/jsprung.htm Bio] for The International Marine Aquarium Conference - 2005</ref>\n\nSprung has authored articles in aquarium [[hobby]] publications such as [[Freshwater And Marine Aquarium]], Seascope, [http://www.advancedaquarist.com/ Advanced Aquarist Online], Aquarium Frontiers, Marine and Reef Aquarium USA, Practical Fishkeeping, Tropical Fish Hobbyist, and Coral. Sprung is one of the authors of The Reef Aquarium 3-volume book series ([[Self-publishing|self-published]]), and is a frequent lecturer at reef aquarium hobby conventions and gatherings.<ref>{{cite news | title = Science Notes | work = [[Salt Lake Tribune]] | date =  July 11, 2002 }}</ref><ref>{{cite news | title = Coming up Events | work = [[Miami Herald]] | date = January 25, 2001 }}</ref>\n\nIn 1991 Sprung, with fellow marine aquarium enthusiast [[Daniel Ramirez]], co-founded the company Two Little Fishies, Inc., a manufacturer of marine aquarium supplements, media, and accessories.\n\n'
p26
tp27
a(I-1
S'The indie design movement is made up of independent designers, artists and craftspeople who design and make a wide array of products without being part of large, industrialized businesses.\n\nThey are supported by a growing number of indie shoppers who are seeking niche and often handmade products as opposed to those mass-produced by corporations. Such products may include [[jewellery]] and other [[fashion accessory|accessories]], [[ceramics (art)|ceramics]], [[clothing]], [[glass]], [[metalwork]], [[furniture]], [[cosmetics]], [[art]] and much more.\n\nIndie designers often sell their items directly to buyers by way of their own online shops, [[craft fairs]], [[street market|street markets]] and a variety of online marketplaces, such as [[Etsy]]. However, they may also engage in consignment and/or wholesale relationships with retail outlets, both online and offline.\n\nThe indie design movement can be seen as being an aspect of the general indie movement and [[DIY culture]].\n\n'
p28
tp29
a(I1
S'{{refimproveBLP|date=July 2009}}\n{{Infobox MLB player\n| name        = Josh Beckett\n| image       = JoshBeckett.jpg\n| width       = 300\n| caption     = \n| team        = Boston Red Sox\n| number      = 19\n| position    = Starting Pitcher\n| birthdate   = {{birth date and age|1980|5|15}}\n| birthplace  = {{city-state|Spring|Texas}}\n| bats        = Right\n| throws      = Right\n| debutdate   = September 4\n| debutyear   = 2001\n| debutteam   = Florida Marlins\n| statyear    = September 11, 2009\n| stat1label  = [[Win (baseball)|Win-Loss]]\n| stat1value  = 103-68<ref>http://boston.redsox.mlb.com/team/player.jsp?player_id=277417</ref>\n| stat2label  = [[Earned run average]]\n| stat2value  = 3.82<ref>http://boston.redsox.mlb.com/team/player.jsp?player_id=277417</ref>\n| stat3label  = [[Strikeout]]s\n| stat3value  = 1307<ref>http://boston.redsox.mlb.com/team/player.jsp?player_id=277417</ref>\n| teams       = <nowiki></nowiki>\n*[[Florida Marlins]] ({{by|2001}}-{{by|2005}})\n*[[Boston Red Sox]] ({{by|2006}}-present)\n| awards      = <nowiki></nowiki>\n*[[World Series MVP Award|World Series MVP]] (2003)\n*2x [[American League]] [[Major League Baseball All-Star Game|All-Star]] (2007,2009)\n*[[2007 American League Championship Series|ALCS MVP]] (2007)\n*2x [[World Series]] champion ([[2003 World Series|2003]], [[2007 World Series|2007]])\n}}\nJoshua Patrick Beckett (born May 15, 1980, in {{city-state|Spring|Texas}}) is a [[Major League Baseball]] [[right-handed]] [[starting pitcher]] for the [[Boston Red Sox]]. During his career in the playoffs, he won the 2003 [[World Series MVP Award]] with the [[Florida Marlins]], and received the [[2007 American League Championship Series|2007 ALCS]] MVP award with the Red Sox.\n\n==Baseball career==\n===Florida Marlins (2001&ndash;2005)=== \nA native of [[Spring, Texas]], Beckett was discovered by [[Florida Marlins]] scout Bob Laurie, who also discovered [[Jason Stokes]]. Beckett had signed a letter of intent to play with the [[Texas A&M Aggies]] but went pro. Beckett spent most of his early years with the Marlins as a member of the teams young staff, but injuries (most frequently blister problems) limited him to only 99 starts (102 appearances) from 2002 to 2005.\n\nBecketts major league debut was on September 4, 2001, against the [[Chicago Cubs]], in which he gave up one hit over six shutout innings. He finished 2001 with four games started, a 2-2 record, and an ERA of 1.50.\n\nBeckett achieved fame in the 2003 postseason by winning the [[World Series MVP Award]] with two great performances on only three days rest. Teamed up with '
p30
tp31
a(I1
S'[[Image:Scribbler robot.jpg|thumb|right|The Scribbler robot used by IPRE in teaching introductory computer science courses]]\nThe Scribbler is a small, low-cost fully programmable intelligent robot with multiple sensor systems.  It is capable of interacting with its environs.<ref>http://parallax.com/tabid/455/Default.aspx Parallax Inc. website, accessed 22 Sept. 2009</ref>.  It is capable of autonavigation.\n\nThe Scribbler is a combined effort of three companies: [[Parallax, Inc. (company)|Parallax Inc.]]; Element Products Inc.; and Bueno Systems Inc.<ref>http://robots.net/article/1729.html Robots.net website, accessed 22 Sept. 2009</ref>.\n\n\nThe Scrubber is presently used by many teachers for educational purposes. For example, [[Institute for Personal Robots in Education]] (IPRE) has developed extensive educational materials using the Scribbler.<ref>http://www.roboteducation.org Institution for Personal Robotics in Education website, accessed 22 Sept. 2009</ref>\n\n\n'
p32
tp33
a(I1
S'[[Image:PenguinRobot.jpg|thumb|right|300px|Penguin Robot.]]\nThe Penguin Robot is a bipedal robot with two directions of freedom, using two servos for walking.\nIt is a precision-machined 4 tall biped with an embedded [[BASIC Stamp]] 2px24 microcontroller. The Penguin walks forward with a tilt-stride action and turns by sweeping both feet on the ground in opposite directions.\n\n\n== Microprocessor ==\nThe Penguin brain is based on a BS2PX24 module, which is the highest performing of all the BASIC Stamp microcontrollers, featuring the following technical specifications:\n\n* Processor Speed: 32 MHz Turbo\n* Program Execution Speed: ~19,000 instructions/sec.\n* [[RAM]] Size: 38 Bytes (12 I/O, 26 Variable)\n* Scratch Pad RAM: 128 Bytes\n* [[EEPROM]] (Program) Size: 8 x 2K Bytes ~4,000 Instructions\n* [[Programming language]]: [[PBASIC|PBasic]]\n\n== Input/Output devices ==\n\nThe Penguin includes the following I/O devices:\n\n* 1 Hitachi HM55B Digital [[Compass]] sensor, which enables it to know its exact orientation\n* 2 [[Photoresistor|Photoresistors]] for light following/avoidance\n* 2 [[infrared|Infrared emitters]] and an [[infrared|infrared receiver]] for object detection\n* 1 Blue seven-segment [[LED]] for feedback\n* 2 Micro [[servos]] for tilt and stride\n* 1 [[Loudspeakers#Piezoelectric_speakers|Piezospeaker]] in body underneath battery pack\n* 1 Expansion port for connecting other input/output components\n* 1 [[Power switch]] located adjacent to battery pack\n* 1 FTDI 232RL mini [[USB]] programming port (used to download the software from the PC)\n* 1 Blue power indicator [[LED]]\n\nThe robot is powered by 2 [[CR123]] batteries.\n\n== Assembling and programming ==\n\nThe Penguin Robot is sold in kit, and requires a few hours to be assembled. It is not a pre-programmed toy, but rather a hobbyist robot programming platform, since it operates according to the program that the user downloads in it. However, several ready-to-run programs are freely available, released by the supplier ([[Parallax, Inc. (company)|Parallax]]) and by other users on the Web.\n\nSome of these programs allow it to sing, dance, move autonomously to North or toward the light, avoiding obstacles.\n\n'
p34
tp35
a(I1
S'[[Image:Fish Dropsy (Side).jpg|thumb|250px|right|A [[Goldfish]] with Fish Dropsy]]\nDropsy is a common disease among [[fresh water|fresh-water]] [[aquarium]] [[fish]]. The name is from an old name for [[Edema]] in humans.\n\n==Symptoms==\nThis disease is characterised by a swollen or hollow abdomen ([[Ascites]]). A concentration of fluid in the body tissues and cavities causes the fishs abdomen to become swollen and appear bloated.  Swollen areas may exhibit a pine-cone appearance caused by the fishs scales sticking out. You can best see this by viewing your fish from the top. Fish may also stop feeding, appear off-colour, become listless and/or lethargic, have sunken eyes, and hang at the top or stay at the bottom of the aquarium. \n\nThe condition affects the fishs internal organs, ceasing proper function.\n\n[[Gourami|Gouramies]], [[Cyprinid|Cyprinids]] (barbs, danios, goldfish etc), [[guppy|guppies]] and [[betta|bettas]] are prone to this disease.\n[[Image:Fish Dropsy (Top).jpg|thumb|120px|right|A Gold Fish with Fish Dropsy in containment. Notice the pinecone appearance]]\n\n==Causes==\nDropsy is fairly easy to diagnose non-specifically, however, it is much harder to diagnose the cause.  The main cause is bacterial infection. The causative agent may be introduced through food or dirty water. Edema second to [[kidney failure]] or ascites due to [[liver failure|liver]] or [[heart failure]] are other possible causes.\n\n==Treatment==\nDropsy is not very contagious; however, if a fish is diagnosed with dropsy, it is important to remove it from the aquarium because the infected fish will contaminate the separate water and end up dying. If there are multiple fish, treat the afflicted fish in a specially established sick tank ([[Quarantine]]).  Dropsy can spread from the ill fish, possibly causing stress among the other fish in the tank community. This extra stress may make the others vulnerable to dropsy or other forms of disease.\n\nTreatment may consist of [[antibiotic|antibiotics]] targeting the causative agent. They work best in the very early stages of dropsy.  A more hands-on approach is to raise the aquariums temperature a few degrees - slightly higher than usual.  Adding [[Epsom salt|Epsom salts]] (Magnesium sulfate) to the water (at a rate of 20 mg/L) helps to encourage the fish to expel unnecessary damaging fluids.\n\n==Prognosis==\nPrognosis of fish dropsy is not good. By the time the fish has swollen up enough that the scales begin to raise, the internal damage may be too extensive to repair.  Most cases of dropsy are fatal. However, if the fish is placed in a quarantine tank and treated with a broad spectrum antibiotic or a [[bacteria|bacterial]] remedy from any aquatic sales shop, then the fish can make a full recovery in less than a week.\n\n==Prevention==\nMaintaining water quality is always extremely important.  It should always be checked first, because it is often the cause of disease in aquarium fish.  Frequent water changes can work to prevent the spread of disease by watering down the concentration of disease agents, and by reducing stress on the tank occupants. \n\nAll tanks need a 10-25% water change on a weekly basis.  The best method of changing water is siphoning the water from the bottom, removing debris and fecal matter from the gravel.  \n\nAlways feed fish from reliable sources and use high quality food.  Varying diet is also important. \n\n'
p36
tp37
a(I-1
S'The tragedy of the commons refers to a dilemma described in an influential article by that name written by [[Garrett Hardin]] and first published in the journal [[Science (journal)|Science]] in 1968.<ref name=hardin68>Garrett Hardin, [http://www.sciencemag.org/cgi/content/full/162/3859/1243 The Tragedy of the Commons], Science, Vol. 162, No. 3859 (December 13, 1968), pp. 1243-1248. Also available [http://www.sciencemag.org/cgi/reprint/162/3859/1243.pdf here] and [http://www.garretthardinsociety.org/articles/art_tragedy_of_the_commons.html here.]</ref> The article describes a dilemma in which multiple individuals acting independently and solely and rationally consulting their own self-interest will ultimately destroy a shared limited resource even when it is clear that it is not in anyones long term interest for this to happen.<ref name=Encarta killed>{{cite news|url=http://www.guardian.co.uk/technology/2009/apr/07/wikipedia-encarta|title=Encartas failure is no tragedy:Wikipedia has succeeded where Microsofts Encarta failed, and seems to be a reversal of the tragedy of the commons|last= Alderman |first=Naomi|date=Tuesday 7 April 2009 15.32 BST |work=News:Technology:Wikipedia|publisher=guardian.co.uk|accessdate=2009-04-07}}</ref> \n\nCentral to Hardins article is an example, a hypothetical and simplified situation from medieval land tenure in Europe, of herders sharing a common parcel of land (the commons), on which they are each entitled to let their cows graze. In Hardins example, it is in each herders interest to put the next (and succeeding) cows he acquires onto the land, even if the carrying capacity of the commons is exceeded and it is damaged for all as a result. The herder receives all of the benefits from an additional cow, while the damage to the commons is shared by the entire group. If all herders make this individually rational economic decision, the commons will be destroyed to the detriment of all. \n\nA similar dilemma of the commons<ref name=Rad/> had previously been discussed by agrarian reformers since the 18th century.<ref name=Rad> Radkau, Joachim. Nature and Power. A Global History of the Environment. Cambridge University Press 2008</ref> Hardins predecessors used the alleged tragedy, as well as a variety of examples from the Greek Classics, to justify the [[enclosure]] movement.<ref name=Rad/> Radkau sees Garrett Hardins writings as having a different aim in that Hardin asks for a strict management of common goods via increased government involvement or/and international regulation bodies.<ref name=Rad/>\n\n==Garrett Hardins essay==\n===Prcis===\nAt the beginning of his essay, Hardin draws attention to problems that cannot be solved by technical means (i.e., as distinct from those with solutions that require a change only in the techniques of the [[natural science]]s, demanding little or nothing in the way of change in [[Value (personal and cultural)|human values]] or ideas of [[morality]]). Hardin contends that this class of problems includes many of those raised by human population growth and the use of the Earths [[natural resource]]s.\n\nTo make the case for no technical solutions, Hardin notes the limits placed on the availability of energy (and material resources) on [[Earth]], and also the consequences of these limits for [[quality of life]]. To maximize population, one needs to minimize resources spent on anything other than simple survival, and vice versa. Consequently, he concludes that there is no foreseeable technical solution to increasing both human populations and their [[standard of living]] on a finite planet.\n\nFrom this point, Hardin switches to non-technical or resource management solutions to population and resource problems. As a means of illustrating these, he introduces a hypothetical example of a [[pasture]] shared by local [[herder]]s. The herders are assumed to wish to maximize their yield, and so will increase their herd size whenever possible. The utility of each additional animal has both a positive and negative component:\n\n* Positive: the herder receives all of the proceeds from each additional animal.\n* Negative: the pasture is slightly degraded by each additional animal.\n\nCrucially, the division of these costs and benefits is unequal: the individual herder gains all of the advantage, but the disadvantage is shared among all herders using the pasture. Consequently, for an individual herder the rational course of action is to continue to add additional animals to his or her herd. However, since all herders reach the same rational conclusion, [[overgrazing]] and degradation of the pasture is its long-term fate. Nonetheless, the rational response for an individual remains the same at every stage, since the gain is always greater to each herder than the individual share of the distributed cost. The overgrazing cost here is an example of an [[externality]].\n\nBecause this sequence of events follows predictably from the behaviour of the individuals concerned, Hardin describes it as a tragedy.\n\nIn the course of his essay, Hardin develops the theme, drawing in examples of latter day commons, such as the atmosphere, oceans, rivers, [[fish stocks]], [[national park]]s, [[advertising]], and even [[parking meter]]s. The example of fish stocks had led some to call this the tragedy of the fishers.<ref>Samuel Bowles: Microeconomics: Behavior, Institutions, and Evolution, Princeton University Press, pp. 2729 (2004) ISBN 0691091633</ref> A major theme running throughout the essay is the growth of human populations, with the [[Earth]]s resources being a general commons.\n\nThe essay also addresses potential [[management]] solutions to commons problems including [[privatization]], [[Polluter Pays|polluter pays]], and [[regulation]]. Keeping with his original pasture analogy, Hardin categorises these as effectively the [[enclosure]] of commons, and notes a historical progression from the use of all resources as commons (unregulated access to all) to systems in which commons are enclosed and subject to differing methods of regulated use in which access is prohibited or controlled. Hardin argues against relying on [[conscience]] as a means of policing the commons, suggesting that this favours selfish individuals  often known as [[Free rider problem|free riders]]  over those who are more altruistic.\n\nIn the context of avoiding over-exploitation of common resources, Hardin concludes by restating [[Georg Wilhelm Friedrich Hegel|Hegel]]s [[Maxim (saying)|maxim]] (which was quoted by [[Friedrich Engels|Engels]]), liberty is the recognition of want. He suggests that [[liberty]] completes the tragedy of the commons. By recognizing resources as commons in the first place, and by recognizing that, as such, they require management, Hardin believes that humans can preserve and nurture other and more precious freedoms.\n\nAside from its subject matter (resource use), the essay is notable (at least in modern scientific circles) for explicitly dealing with issues of [[morality]], and doing so in one of the [[scientific community]]s premier journals, [[Science (journal)|Science]]. Indeed, the subtitle for the essay is The population problem has no technical solution; it requires a fundamental extension in morality.\n\n===Meaning===\nThe metaphor illustrates the argument that free access and unrestricted demand for a finite resource ultimately dooms the resource through over-exploitation. This occurs because the benefits of exploitation accrue to individuals or groups, each of whom is motivated to maximize use of the resource to the point in which they become reliant on it, while the costs of the exploitation are borne by all those to whom the resource is available (which may be a wider class of individuals than those who are exploiting it). This, in turn, causes demand for the resource to increase, which causes the problem to snowball to the point that the resource is exhausted. The rate at which exhaustion of the resource is realized depends primarily on three factors: the number of users wanting to consume the commons, the consumptiveness of their uses, and the relative robustness of the commons.<ref>[http://papers.ssrn.com/sol3/papers.cfm?abstract_id=1227745 Brigham Daniels, Emerging Commons Tragic Institutions | Environmental Law | Vol. 37 (2007), pp. 515-571 at 536<!-- Bot generated title -->]</ref>\n\nLike [[William Forster Lloyd|William Lloyd]] and [[Thomas Malthus]] before him, Hardin was primarily interested in the problem of [[overpopulation|human population growth]]. In his essay he also focused on the use of larger (though still limited) resources such as the Earths atmosphere and oceans, as well as pointing out the negative commons of pollution (i.e., instead of dealing with the deliberate privatisation of a positive resource, a negative commons deals with the deliberate commonisation of a negative cost, pollution).\n\nAs a [[metaphor]], the tragedy of the commons should not be taken too literally. The phrase is [[shorthand]] for a structural relationship and the consequences of that relationship, not a precise description of it. The tragedy should not be seen as tragic in the conventional sense, nor must it be taken as condemnation of the processes that are ascribed to it. Similarly, Hardins use of commons has frequently been misunderstood, leading Hardin to later remark that he should have titled his work The Tragedy of the Unregulated Commons.<ref>[http://search.japantimes.co.jp/cgi-bin/fe20060726sh.html Will commons sense dawn again in time? | The Japan Times Online<!-- Bot generated title -->]</ref>\n\nThe tragedy of the commons has particular relevance in analyzing behaviour in the fields of [[economics]], [[evolutionary psychology]], [[game theory]], [[politics]], [[taxation]], and [[sociology]]. Some also see it as an example of [[emergent behaviour]], with the tragedy the outcome of individual interactions in a [[complex system]].\n\n===Controversy===\n{{Refimprovesect|date=October 2008}}\nEven today, Hardins essay is a source of controversy. Some of this controversy stems from disagreement over whether individuals will always behave in the selfish fashion posited by Hardin. Others<ref>Axelrod, Robert. (1984). The Evolution of Cooperation. New York: Basic Books, ISBN 0-465-02121-2</ref> have argued that even self-interested individuals will often find ways to cooperate, because collective restraint serves both the collective and individual interests. Hardins piece has also been used to promote the interests of Western economic ideology. G. N. Appell, an anthropologist, states: Hardins claim has been embraced as a sacred text by scholars and professionals in the practice of designing futures for others and imposing their own economic and environmental rationality on other social systems of which they have incomplete understanding and knowledge.<ref>Appell, G. N. (1993). [http://dlc.dlib.indiana.edu/archive/00002203/01/HARDIN.pdf Hardins Myth of the Commons: The Tragedy of Conceptual Confusions]. Working Paper 8. Phillips, ME: Social Transformation and Adaptation Research Institute.</ref>\n\nMore significantly, controversy has been fueled by the application of Hardins ideas to real situations. In particular, some authorities have read Hardins work as specifically advocating the privatization of commonly owned resources. Consequently, resources that have traditionally been managed communally by local organizations have been [[enclosure|enclosed]] or [[privatization|privatized]]. Ostensibly, this serves to protect such resources, but it ignores the pre-existing management, often appropriating resources and alienating indigenous (and frequently poor) populations. In effect, private or state use may result in worse outcomes than the previous commons management.<ref>Ostrom, Elinor, Joanna Burger, Christopher B. Field, Richard B. Norgaard, and David Policansky (1999): Revisiting the Commons: Local Lessons, Global Challenges, in: Science, Vol. 284, 9 April, pp. 278-282.</ref> As Hardins essay focuses on resources that are fundamentally unmanaged rather than communally managed, this may be a mischaracterisation of his ideas, given that Hardin discussed how usage of public property could be controlled in a number of different ways to stop or limit over-usage.\n\nHardins advocacy of clearly defined property rights has frequently been used as an argument for privatization, or private property, per se. The opposite situation to a tragedy of the commons is sometimes referred to as a [[tragedy of the anticommons]]: a situation in which rational individuals (acting separately) collectively waste a given resource by under-utilizing it.\n\n== History of idea ==\n='
p38
tp39
a(I1
S'The term dither fish refers to an arbitrary group of aquarium fish used by [[cichlid]] keeping aquarists to reduce innate timidity in some species of cichlids (Barlow, 1967). The technique relies on the ability of cichlids in an aquarium to use the behaviour of other fish species as a measure of environmental security (Loiselle, 1979). Good dither fish are typically schooling species such as [[Danio]] spp., [[Barb (fish)|barbs]] and some [[tetra]] species.  \n\n'
p40
tp41
a(I1
S'{{unref|date=September 2009}}\n[[Image:Red Wine Glas.jpg|150px|thumb|Oenophiles are devoted to [[wine]].]]\n\nOenophilia ({{pron-en|infli}} {{respell|EE|no|FIL|ee-}}), originally from [[Greek language|Greek]], is the love ([[-phil-|philia]]) of [[wine]] ([[oinos]]). An oenophile ({{IPA|/inofal/}}) is a lover of wine. In the strictest sense, oenophilia describes a disciplined devotion to wine, accompanying strict traditions of consumption and appreciation. In a general sense however, oenophilia simply refers to the enjoyment of wine, often by [[layman|laymen]]. Oenophiles are also known as wine [[aficionado]]s or [[connoisseur]]s. They are people who appreciate or collect wine, particularly [[grape]] wines from certain [[list of wine-producing regions|regions]], [[list of grape varieties|varietal types]], or methods of [[wine making|manufacture]]. While most oenophiles are hobbyists, some may also be professionals like [[vintner]]s, wine [[merchant]]s, or one who tastes and grades wines for a living.\n\n'
p42
tp43
a(I1
S'{{Disputed|date=August 2009}}\n\nStiquito (pronounced sti ke to) is a small, inexpensive [[Hexapod (robotics)|hexapod]] (i.e., six-legged) [[robot]] commonly used by universities, high schools, and hobbyists, since 1992.  Stiquito is unique not only because it is so inexpensive but also because its applications are almost limitless.\n\n[[Image:Stiquito_Robot_Original.JPG|thumb|right|300px|A Stiquito.]]\n\nStiquitos muscles are made of [[nitinol]], a [[shape memory alloy]] that expands and contracts, roughly emulating the operation of a muscle. The application of heat causes a crystalline structure change in the wire. Nitinol contracts when heated and returns to its original size and shape when cooled. \n\nStiquito was developed by Jonathan W. Mills of [[Indiana University]] as an inexpensive vehicle for his research.  He soon found its applications extended to educational uses.  It has been used to introduce students to the concepts of [[analogue electronics]], [[digital electronics]], computer control, and [[robotics]].  It has also been used for advanced topics such as [[subsumption architecture]]s, [[artificial intelligence]], and advanced [[computer architecture]]. \n\n'
p44
tp45
a(I-1
S'{{Infobox Website\n|name           = Terra Nova\n|logo           = \n|screenshot     = [[Image:Tnscreen.png|250px]]\n|caption        = Screenshot of Terra Nova as of July 25, 2008\n|url            = http://terranova.blogs.com/terra_nova/\n|commercial     = No\n|type           = Collaborative blog\n|language       = \n|registration   = None\n|owner          = \n|author         = [[Edward Castronova]], [[Julian Dibbell]], Dan Hunter, and Greg Lastowka\n|launch date    = 2003\n|current status = Online\n|revenue        = \n|slogan         =\n}}\n\nTerra Nova is a [[collaborative blog]] for academics and professionals in [[game studies]].  It focuses primarily on the study of [[virtual worlds]].\n\nStarted in 2003 by [[Edward Castronova]], [[Julian Dibbell]], Dan Hunter, and Greg Lastowka, Terra Nova initially focused heavily on research and questions surrounding [[Virtual economy|real money trading (RMT)]] in online virtual worlds.<ref>\n{{cite web\n  | last = \n  | first = \n  | authorlink = \n  | coauthors = \n  | title = About TN\n  | work = Terra Nova\n  | publisher = \n  | date = \n  | url = http://terranova.blogs.com/about.html\n  | format = \n  | doi = \n  | accessdate = 2008-07-25}}\n</ref><ref>\n{{cite news \n  | last = Abate\n  | first = Tom\n  | coauthors = \n  | title = Role games as economic tool? It may happen\n  | work = [[The San Diego Union Tribune]]\n  | pages = \n  | language = \n  | publisher = \n  | date = 2005-08-22\n  | url = http://www.signonsandiego.com/uniontrib/20050822/news_mz1c22rolgam.html\n  | accessdate = 2008-07-25}}\n</ref>\nCoverage has expanded to include impacts of gaming on culture, architecture and law.<ref>\n{{cite web\n  | last = Larkin\n  | first = Thomasina\n  | authorlink = \n  | coauthors = \n  | title = Whole worlds inside the screen\n  | work = Blog Watch\n  | publisher = [[The Japan Times]]\n  | date = 2007-10-31\n  | url = http://search.japantimes.co.jp/print/nc20071031bw.html\n  | format = \n  | doi = \n  | accessdate = 2008-07-25}}\n</ref>\n\nTerra Nova is cited in the traditional media on issues of gaming in virtual worlds, most notably issues regarding [[Second Life]] and [[World of Warcraft]].<ref>\n{{cite web\n  | last = Thompson\n  | first = Clive\n  | authorlink = \n  | coauthors = \n  | title = Voice Chat Can Really Kill the Mood on WoW\n  | work = Games without Frontiers\n  | publisher = [[Wired (magazine)|Wired]]\n  | date = 2007-06-19\n  | url = http://www.wired.com/gaming/virtualworlds/commentary/games/2007/06/games_frontiers_0617\n  | format = \n  | doi = \n  | accessdate = 2008-07-25}}\n</ref><ref>\n{{cite web\n  | last = Hof\n  | first = Rob\n  | authorlink = \n  | coauthors = \n  | title = My Second Life\n  | work = The Tech Beat\n  | publisher = [[Business Week]]\n  | date = 2007-04-20\n  | url = http://www.businessweek.com/the_thread/techbeat/archives/2006/04/my_second_life.html\n  | format = \n  | doi = \n  | accessdate = 2008-07-25}}\n</ref><ref>\n{{cite web\n  | last =  Terdiman   \n  | first = Daniel \n  | authorlink = \n  | coauthors = \n  | title = Warcrafters take Graveyard Games virtual\n  | work = News Blog\n  | publisher = [[CNet]]\n  | date = 2005-10-18\n  | url = http://news.cnet.com/8301-10784_3-5900639-7.html\n  | format = \n  | doi = \n  | accessdate = 2008-07-25}}\n</ref>  Various issues have been discussed, from [[Star Wars Galaxies]] virtual economy<ref>\n{{cite web\n  | last = Terdiman \n  | first = Daniel \n  | authorlink = \n  | coauthors = \n  | title = Fun in Following the Money\n  | work = Gaming \n  | publisher = [[Wired (magazine)|Wired]]\n  | date = 2004-05-08\n  | url = http://www.wired.com/print/gaming/gamingreviews/news/2004/05/63363\n  | format = \n  | doi = \n  | accessdate = 2008-07-25}}\n</ref> to the impact of learning in [[MMORPG|MMO]]s.<ref>\n{{cite web\n  | last = Rossignol\n  | first = Jim\n  | authorlink = \n  | coauthors = \n  | title = Column: Blogged Out: Decade Of Graphics\n  | work = Industry News\n  | publisher = [[Gamasutra]]\n  | date = 2006-09-26\n  | url = http://www.gamasutra.com/php-bin/news_index.php?story=11067\n  | format = \n  | doi = \n  | accessdate = 2008-07-25}}\n</ref>\n\n'
p46
tp47
a(I-1
S'{{Articleissues|article=y|OR=January 2008|refimprove=December 2007}}\n{{infobox television\n | show_name = X-Play\n | image = [[Image:New-xplay2008II.png|240px]]\n | caption = Current X-Play Logo\n | format = [[Video game]]<br /> [[Sketch comedy]]\n | runtime = approximately 22 minutes (without commercials)\n | starring = [[Adam Sessler]] (1998)<br />[[Morgan Webb]] (2003- )<br />[[Kristin Adams]] (2008)<br />[[Blair Herter]] (2008)<br />[[Kate Botello]] (1999-2002)<br />[[Lauren Fielder]] (19981999)\n | country = [[United States|USA]]\n | network = ZDTV (1998-2001)<br/>[[TechTV]] (2001-2004)<br/>[[G4 (TV channel)|G4]] (2004-present)\n | first_aired = [[1998 in television|1998]]\n | last_aired = present\n | website = http://g4tv.com/games/xplay/\n |}}\nX-Play (previously GameSpot TV and Extended Play) is a [[television program|TV program]] about [[video game]]s, known for its reviews and comedy skits. The program airs on [[G4 (TV channel)|G4]] in the [[United States]], [[G4techTV Canada|G4techTV]] in [[Canada]], [[FUEL TV]] in [[Australia]], [[EGO Channel|Ego]] in [[Israel]], [[GXT]] in [[Italy]], [[MTV Russia|MTV ]] in [[Russia]] and [[Maxxx]] in the [[Philippines]].\n\nThe show is hosted by [[Adam Sessler]] and [[Morgan Webb]], with [[Blair Herter]] and [[Kristin Adams]] serving as special correspondents/co-hosts. Sessler is the original host of the program; he has co-hosted in the past with [[Lauren Fielder]] and [[Kate Botello]].\n\nX-Play began on the ZDTV network in 1998 as GameSpot TV, where Sessler co-hosted with Fielder for the shows first year, then co-hosted with Botello up through 2002 (the producers of ZDTV originally had plans to air a video-game program when the channel launched called Extended Play that would be hosted by [[Simon Rex]] <ref>[http://www.youtube.com/watch?v=osIGzi1-UK8#t=5m10s YouTube - ZDTV Promo]</ref>; however, when an agreement was reached with the makers of the newly-created [[GameSpot]] website, plans for the original shows format were scrapped in favor of a GameSpot-branded program, and Rex was dropped as host).\n\nThe show assumed the previously rejected Extended Play moniker in 2001 after ZDTV changed to [[TechTV]] and the partnership with [[Ziff Davis]] GameSpot ended. Botello left in early 2002, and Sessler hosted the show by himself up until April 2003, when Webb joined the cast and the show was renamed X-Play.\n\nAfter the [[Mergers and acquisitions|merger]] of TechTV and G4 in [[May 2004]], X-Play became the only original program from either network to survive intact, and is now one of the highest-rated shows to air on the channel.<ref>[http://www.multichannel.com/article/CA6357338.html?display=Search+Results&text=G4 G4s Development Deal A Further Shift From Games - 7/31/2006 - Multichannel News<!-- Bot generated title -->]</ref>\n\n==History==\nGameSpot TV, Extended Play, and X-Play all originated in [[San Francisco]], [[California]]. Throughout the course of the shows history, it has gone through numerous changes, in more than just name.\n\n===GameSpot TV===\nIn the days of GameSpot TV, the show was filmed on a simple ZDTV studio set consisting of faux-brick walls, randomly positioned TV monitors, and functioning [[Gauntlet Legends]] and [[Rival Schools: United By Fate|Rival Schools]] arcade game cabinets. For the occasional special episode, filming would move off-site to another location, such as the [[Metreon|Sony Metreon]] arcade, and numerous game conventions such as the Classic Gaming Expo and E3. Each episode would start off with Game News, where Sessler or Fielder would give a brief overview of top news stories featured on the GameSpot website. Game reviews were run in a segment known as The Grill (games were graded on GameSpots official 0.1-10.0 system), Spotlight showcased special content such as interviews with industry leaders, and Game Breakers featured strategy guides and hints for recently released games. New episodes would debut on weekend mornings at 10:00 a.m. EST.\n\n===Extended Play===\nWhen GameSpot TV converted to Extended Play, the show moved entirely to the Metreon, and took on a very simple style and format. Filming consisted of co-hosts Sessler and Botello and a small single camera crew; the show featured strictly game reviews and game hints, and the 10-point grading system changed to a 5-point system. New episodes debuted once a week at 9:00 p.m. EST. Like GameSpot TV, certain special episodes would be filmed elsewhere. In August 2002, the series became a daily program with a mix of repeats and first-run episodes airing Monday-Friday at 4:00 p.m. EST, with Friday episodes remaining in the 9:00 p.m. timeslot. After the departure of Botello, Sessler continued to host at the Metreon by himself, until the change to X-Play in April 2003.\n\n===X-Play San Francisco===\nWhen X-Play debuted on April 28, the show moved back to the TechTV studios from the Metreon, and Morgan Webb came onboard as co-host, leaving her previous hosting duties on TechTVs [[The Screen Savers]] and [[Call for Help]]. X-Play had a larger scale than that of Extended Play, but it still maintained an extremely simple and spartan style. Filming was done in TechTVs Studio A, home to the sets of Call For Help, Fresh Gear, and [[TechLive]]. The filming setup was increased to three cameras; a main floor camera, a [[jib (camera)|Jibcam]] for high angle shots, and a black-and-white handheld [[DV]] camera, which would be cut to suddenly and intermittently throughout episodes.\n\nX-Plays primary set consisted of a single couch, coffee table and television (with working game consoles) positioned in the middle of the large studio floor, but hosts Sessler and Webb would migrate around various areas of the studio, normally not even going to their actual set until the end of the program. Each episode would typically conclude with Sessler and Webb playing one of the consoles on the TV. The shows format consisted primarily of game reviews and previews (with some previews being conducted as live in-studio demos by Morgan and Adam), with an occasional game-related sketch thrown in for comedic value.\n\nThe Disembodied Voice was also introduced to the show at this phase in its history. This unseen [[announcer]] would begin each episode with an often over-the-top introduction to which the hosts usually responded or commented (these comments varied widely, ranging from total [[Non sequitur (logic)|non-sequiturs]] to [[Gilbert and Sullivan]] references to [[Portal:Current events|current events]], along with viewer-submitted intros taken from the shows web forums).\n\nUnlike its predecessors, X-Play had more of an edge, containing some adult language and more mature (sometimes controversial) subject matter. As a result, it was paired in a programming block with the networks other new show, [[Unscrewed with Martin Sargent]]. X-Play originally ran new episodes five nights a week at 11:30 p.m. EST, but it was moved up to 11:00 EST soon after.\n\nMany of the episodes created during this time period now air on the [[List_of_programs_broadcast_by_G4#G4_Rewind|G4 Rewind]] block of retro programming.\n\n===X-Play Los Angeles===\n<!-- Deleted image removed: [[Image:Xpla.jpg|thumbnail|240px|right|G4 Studio#3: the 1st X-Play set in Los Angeles {{puic|Image:Image_name.ext|log=2007 July 17}}]] -->\n[[Comcast]] purchased TechTV in May 2004 and merged it with its G4 network, necessitating a move for X-Plays base of operations from San Francisco to G4s [[Santa Monica, California|Santa Monica]] studios.\n\nThe new set designed for the show resembled a lounge - or [[Recreation room|rumpus room]] - where the hosts could sit around while discussing their latest reviews (during the 400th episode, which originally aired on May 8, 2006, all chairs were removed from the set so that Adam and Morgan had to stand throughout the duration of each episode).\n\nWhile originally maintaining its late-night time slot, new episodes were eventually moved to 4:00 p.m. EST in the afternoons (usually airing on Mondays, Tuesdays, and Wednesdays) starting on April 10, 2006. This changed to 3:00 p.m. EST on September 5, 2006, before X-Play returned to prime-time on November 6 of the same year, to their current 8:00 p.m. EST timeslot.\n\nOn March 4, 2007, it was announced that the G4 Studios in Santa Monica would close on April 15. Production of G4 programs was relocated to the Studios of the [[E!|E! Television Network]] situated elsewhere in the Los Angeles area. As a consequence, there were new sets designed for X-Play, and many G4 employees involved in production were laid off.<ref>[http://www.g4rewind.com/2007/03/confirmed_g4_studios_to_close.html G4 Rewind: Confirmed: G4 studios to close; Operations moving to E!; Layoffs ensue<!-- Bot generated title -->]</ref>\n\nThe E! Buildings set was smaller than the Santa Monica studio, thus some aspects of the studio had to be shrunk down. The X-Play logo was retro-fitted to sit above the stage on the right-hand side of the set, with curtains surrounding the entirety of the space to create a sense of intimacy; a large flat-screen monitor was also placed in the background, and several small decorative glass balls were strategically placed around various spots on the floor (Adam and Morgan would often joke of their fear that they would trip over one of these balls and hurt themselves). During video-game analysis and viewer mail segments, Sessler and Webb would sit in orange [[recliner]] chairs as they debated over the issue at hand.\n\n===X-Play Expands===\nOn January 14, 2008, the G4 network commenced with a complete overhaul to the shows entire format, branding the move as X-Play jumping to the next level<ref>[http://kotaku.com/gaming/gaming-television/x+play-expands-332986.php X-Play Expands]</ref>.\n\nBoth Adam<ref>[http://www.g4tv.com/thefeed/blog/post/682015/Sesslers_Soapbox_XPlay_Gametime_Evolved.html Sesslers Soapbox]</ref> and Morgan<ref>[http://revision3.com/internetsuperstar/2008-0826webb Internet Superstar]</ref> have stated that this new format represents the type of show that theyve always wanted X-Play to be, whereby a strict focus on game reviews was replaced with a broader range of topics relating to the video-game field (including more in-depth gaming news, first looks at game demos, and game cheat-codes/strategies with [[Kristin Adams]] twice a week).\n\nThe set was once again refurbished to coincide with the change, as the studio now has blue-tinged walls covered with several flat-screen monitors, and a giant orange X-Play logo (also newly redesigned for the relaunch) covering the floor. In addition, G4 took advantage of the new set and show format by expanding X-Plays schedule in order to air new episodes five days a week.\n\nHowever, economic factors forced G4 to contract X-Plays schedule back down to only three original episodes per week, starting on [[March 2]], [[2009]]; in addition, the shows timeslot was moved out of prime-time to 6:30 p.m. EST (although reruns still air at 8 oclock) and a number of X-Play staff members were laid off<ref>[http://kotaku.com/5155419/rumor-cuts-hit-x+play-show-drops-to-thrice-weekly-%5Bupdate%5D Cuts Hit X-Play]</ref>.\n\n===X-Play XL===\nIn December 2008, the show aired X-Large one-hour episodes every Tuesday, Thursday, and Friday.<ref>[http://www.joystiq.com/2008/09/02/x-play-extends-to-one-hour-in-december/ X-Play extends to one hour in December - Joystiq]</ref> According to G4 television president Neil Tiles,<ref>[http://www.g4tv.com/opensource.aspx G4 - Open Source]</ref> this was an experimental change  with the possibility of having all episodes run 60 minutes long sometime in the future  where new segments were incorporated to see if X-Play could go deeper than the current half hour show allows. Tiles also stated that the writers will be looking to add more comedy back into the program as requested.\n\n==Reviews==\nThe video game reviews on X-Play use a five-point rating scale, based on such factors as graphics, sound, gameplay, and playability (i.e. replay value). On X-Plays original TechTV homepage,<ref>[http://web.archive.org/web/*/http://www.techtv.com/extendedplay/ Internet Archive Wayback Machine<!-- Bot generated title -->]</ref> the ratings system was broken down in the following way:\n{{cquote|\n* 1 - Hated it. Do not buy this game. Not even worth the bargain bin. Run from it. Escape!! Escape!!\n* 2 - Alright. These games are fun, with some good points, but nothing special. Theres definitely a few specific things holding this game back. Wait until the price comes down or pick it up as [a] renter to check out some of the things it does right.\n* 3 - Good. Fun to play, pretty solid titles, with a few minor flaws. Most games will probably fall into this category. Theyre the games that if you like the genre, or liked other similar titles, you might consider giving it a good look. Otherwise, you might not be into it.\n* 4 - Very good. Games that are at the top of all our lists, but are missing that strange intangible aura of perfection, and unfortunately thats keeping them from getting in the realm of the almighty five.\n* 5 - Near perfect/perfect. If youre a true player, these games will undoubtedly be in your collection, or at the very least youll have played them until the cartridges and CDs melted. If a game gets a 5, and you like the genre, you should buy.}}\n\nIn a 2007 episode billed as a primer on our scoring system,<ref>[http://www.g4tv.com/xplay/episodes/6366/The_Out_Of_Five_Episode.html The Out-of-Five Episode]</ref> Adam and Morgan further elaborated on their ratings scale:\n* A score of 1 is a game that has to produce true crappiness, [through] the full cooperation of an entire development team - level designers taking off early to attend their childrens soccer games, animators getting so high during their lunchbreak that they cant operate their mouse, and of course money hungry execs who will release anything if they can dupe kids into begging their moms for it.\n:Example Given: [[50 Cent: Bulletproof]]\n* A score of 2 is such a difficult score to give, because it requires a game that fundamentally fails, but has a barely redeeming charm which makes it untenable to give a 1; its that [[Suddenly Susan]] cocktail of technical competence floated atop a pile of dreck.\n:Example Given: [[Genji: Days of the Blade]]\n* There are different levels to a score of 3 - theres the 3 thats a mix of very good and very bad elements (like [[Blood Will Tell]]) or 3s that have a great concept thats poorly executed (like [[Sid Meiers Railroads!|Railroads!]]), and then theres those 3s that are just churned out because they know people will buy them even though theres nothing original in it (like every [[FIFA series|FIFA]] game ever).\n:Example Given: [[Sid Meiers Railroads!]]\n* There are really two kinds of games that get 4s regularly: these are great games with significant problems (like [[Dead Rising]]) and games that are amazing but just arent suited for everyone (the [[Warhammer 40,000: Dawn of War: Dark Crusade|Warhammer: Dark Crusade]] expansion or any of the [[The Sims|Sims]] expansions are good examples).\n:Example Given: [[Dead Rising]]\n* Titles that earn a perfect 5 out of 5 are those magnificent games which, whatever minor flaws they may have, call out to us and say, Buy me, you must buy me ... \n:Example Given: [[kami]]\n\nDuring this episode, the hosts also explained why they use a 5-point ratings system, rather than a 10- or even 100-point scale:\n\n{{cquote|\nMorgan: Our system is better because it recognizes that scores are broad generalizations.\n\nAdam: For example, a [[Gamespot.com|popular web site]] gave [[Mobile Suit Gundam: Crossfire]] a score of 3.0 out of 10. They gave [[2006 Winter Olympics|Torino 2006]] a 3.9. What is the difference?\n\nMorgan: Both games suck, all the score is gonna be able to communicate to you is that the game is bad. If you want more nuance on the suckage, you have to actually go and read the review. See, in a 10-point scale, everything under 5 just means this game aint worth buying, so theres no real difference.\n\nAdam: And theres no real nuance to a score difference of two- or three-tenths of a point. Our scores at least give sweeping generalizations for you to use as a guide.}}\n\n==Book==\n{{Infobox Book\n| name             = The X-Play Insiders Guide to Gaming\n| image            = [[Image:X-Play Guide Cover.PNG|200px]]\n| image_caption    =\n| author           = The X-Play Crew and Marc Saltzman\n| illustrator      =\n| cover_artist     =\n| country          = {{Flagicon|US}}\n| language         = [[English Language|English]]\n| subject          = [[Video game]]s\n| genre            = Video Game\n| publisher        = TechTV and Peachpit Press\n| pub_date         = {{start date|2004|11|1}}\n| media_type       =\n| pages            = 468\n| isbn             = 10: 0735714355<br />13: 978-0735714359\n| oclc             = 57618511\n| preceded_by      =\n| followed_by      =\n}}\nOn October 22, 2004, TechTV (in association with Peachpit Press) published the book The X-Play Insiders Guide to Gaming: All You Ever Wanted to Know About Video Games From G4techTVs Brutally Honest Experts. Written by [[Marc Saltzman]] (along with the X-Play Cast) and weighing in at a hefty 468 pages, the book contains game reviews, cheat codes, and Q&A sessions with the cast and crew. Adam and Morgan even went on a nation-wide book-signing tour to help promote their literary endeavor.\n\nCopies of the book can be found everywhere from the [[Brooklyn Public Library]] to the [[University of Hong Kong]].<ref>[http://worldcat.org/oclc/57618511 X-Play Insiders Guide to Gaming: All you ever wanted to know about video games from G4TECHTVs brutally honest experts [WorldCat.org&#93;<!-- Bot generated title -->]</ref>\n\n==Interns==\nX-Play has its own cast of [[intern]]s (students from local universities who have signed up with G4 to gain valuable work experience in the television production field), who will sometimes appear as characters on the show. When appearing on camera, they are commonly outfitted in a white undershirt with the word INTERN scrawled across the chest in black [[Sharpie (marker)|Sharpie]].\n\nTheir roles are not relegated to simply being on-screen comic relief, as the interns are accountable for much of the game footage used during reviews/previews. X-Play interns also play a role in other behind-the-scenes work on the shows set; some of the former interns have eventually been hired full-time within the G4 company itself. Examples include Leticia Caparaz (the first intern to be offered a full-time position in 1999, during the GameSpot TV era, as a Production Assistant and continued to eventually become the programs Web Producer. She left the company in June 2004 as a result of the G4/TechTV merger), Jason Frankovitz (he would leave the show in early 2005), Albert Iskander (who has worked as a Production Assistant for G4s Video Game Vixens and [[G4tv.com]]), Gene Yraola (now a part of G4s Games Editorial Department, the liaison between the shows and the actual software/hardware companies), Eric Acasio (a production assistant for X-Play) and Emily Mollenkopf (hired as a production assistant on Attack of the Show in 2006).\n\nA near-complete list of interns who have worked on the show follows:\n* From [[San Francisco, California]]: Leticia Caparaz, Jason Frankovitz, Scott Humphrey, Chris Ivarson, Matt Ketterer, Desiree Peel, Jana Suverkropp, Kevin Theobald, Blake Yoshiura, and Kevin Yuen.\n* From [[Los Angeles, California]]: , Eric Acasio, Russ Brock, Steve Dutzy, Brian Flores, Albert Iskander, Isaac Gelman, Kenny, Megan, Emily Mollenkopf, Geoff Pinkus, Stephan, Alex Villegas, Chuck Wilkerson, Chris Wilson, Gene Yraola, and Rob Yeager.\n\nThe Screaming Intern (played by Robert Manuel), is actually not a true intern, but instead is an editorial coordinator for the show.<ref>[http://www.g4tv.com/xplay/hosts/index.aspx G4 - XPlay - Hosts]</ref>\n\n==Guest appearances==\nWhen X-Play was still a part of TechTV, personalities from other shows on the network would often make guest appearances (including [[Leo Laporte]], [[Yoshi DeHerrera]], and Unscreweds [[Martin Sargent]] and [[Laura Swisher]]). This continued after the merger with G4, with Attack of the Show! co-host [[Kevin Pereira]] and G4tv.coms [[Tina Wood]].\n\nTalent from other shows within the network have also been used in the role of temporary guest co-hosts; [[Blair Butler]], Julie Stoffer, and [[Kristin Adams]] have been seen to substitute for both Adam Sessler and Morgan Webb when they were unavailable.\n\nX-Play has also had [[C-list|pseudo-celebrities]] that are not affiliated with G4 (such as [[Tony Little]] and [[Kato Kaelin]]) appear on the show.\n\n==Hatred==\nThere have been several gaming titles/genres/trends over the years which co-hosts Adam and Morgan have displayed an exaggerated sense of hatred towards (often playing up their dislike for the cameras in order to make for humorous television)<ref>[http://g4tv.com/xplay/features/36749/Things-Wed-Love-To-Kill.html X-Play Videos: Things Wed Love to Kill]</ref>. These include:\n* [[Sonic the Hedgehog]] games\n* [[Collectible card game|Card battle games]] such as [[Yu-Gi-Oh!]]\n* Games based on [[anime series]] (particularly [[Naruto]], [[Dragon Ball|Dragon Ball Z]], [[One Piece]], and [[Fullmetal Alchemist]])\n* Ungodly boob physics, where female video-game characters are rendered with impossibly large [[breast]]s that bounce and sway unnaturally and independently from the rest of their bodies (this phenomenon is particularly prevalent in [[Japan]]ese [[Dating sim|dating simulation games]] like Sexy Beach 2)\n* Game series which continue to produce titles despite a lack of quality and/or innovation (such as [[Dynasty Warriors]], [[Mega Man (series)|Mega Man]], [[Sonic the Hedgehog (series)|Sonic the Hedgehog]], [[Leisure Suit Larry (series)|Leisure Suit Larry]], and [[Tony Hawk (series)|Tony Hawk]])\n* The proliferation of [[World War II|WWII]] [[first-person shooter]] games on the market (during their review of [http://www.g4tv.com/xplay/episodes/5710/The_Geography_and_Politics_Episode.html Moscow to Berlin: Red Siege], Morgan remarked Thats it! No more World War II games! According to my contract, I only have to review 75 World War II games per year, and I already hit my quota in March!)\n* Video games based on existing [[Intellectual property|IPs]] (like current movies or TV shows), since they are usually rushed to the market to cash in on the latest craze and end up being painful to actually play (such as the [[Charlies Angels]] or [[The Da Vinci Code|Da Vinci Code]] video games)\n* 3D water levels in games, since the shows writers feel that game developers almost never capture the feeling of [[aquatic locomotion|swimming]] in an enjoyable manner (Instead of making us awkwardly pilot our character through zero-gravity space, why dont you just come to our house and punch us in the face? Its exactly the same amount of fun!)\n* Escort missions, where the player is forced to keep an [[Non-player character|NPC]] character (who has its own health meter) from dying; this often proves difficult when the NPCs [[Artificial intelligence|A.I.]] is so insufficient that they continuously place themselves in harms way (leaving the player with little or no chance to save them)\n* [[Barbie Horse Adventures: Wild Horse Rescue]] (Morgan has often called this the worst game ever made)\n* [[Jonny Moseley]] and the ridiculous comments made in his video game Jonny Moseley Mad Trix (including the classic line What if it snowed in San Francisco?)\n* [[Dane Cook]] and his brand of comedy\n* [[Uwe Boll]] and his film adaptions of video games\n* [[Shovelware]] for the Nintendo [[Wii]], like [[All Star Cheer Squad]] and [[Furu Furu Park|Crappy Minigame Collection No. 272]]\n* Developers who feel the need to take a perfectly acceptable single-player game and tack on a [[Multiplayer video game|multiplayer mode]]\n* [[PlayStation_3_accessories#Sixaxis|Sixaxis controls in PS3 games]]\n* 3D [[Castlevania]] games\n* [[Grind (gaming)|Level grinding]] in [[Role-playing game (video games)|role-playing games]]\n\nX-Play shows a great dislike and hatred specificly toward games baesd off of Anime tv shows, often giving them Two out of Five almost instantly. Such as in the review of Naruto Ultimate Ninja they deducted a whole point simply because the main characters catchphrase was too annoying.\n\n==Physical abuse on set==\nFor comedic purposes, the X-Play writers have often portrayed the show as an exceedingly violent working environment; when Adam and/or Morgan arent being depicted as putting the interns in harms way, Morgan often appears to be the one abusing her co-host directly.\n\nThis violent dynamic has manifested itself in various forms, from simple slaps and punches directed towards Adam (whenever the writers want to make it seem as if he has somehow offended or annoyed Morgan), to more exaggerated actions (like landing several blows upon Adams person with a baseball bat during X-Plays [[mockumentary]] on [http://www.g4tv.com/xplay/episodes/1943/Sly_Cooper_2_History_of_Violence_in_Video_Games_Full_Spectrum_Warrior_and_More.html the history of violence in video games]).\n\n==Self-humiliation==\nAdam Sessler uses a [[Self-deprecation|self-deprecating]] form of humor, in which he allows himself to be the object of ridicule and derision. He does this by pointing out several faults within his character, such as a lack of purpose in his life, poor educational/social status, [[Androgenic alopecia|male pattern baldness]], bad luck with women, and an unhealthy [[fudge]] obsession.\n\nAdam will also engage in physical comedy at the expense of his own dignity: past examples include [[Cross-dressing|dressing in womens clothing]] (like a yellow [[Cheerleading|cheerleaders]] uniform or the skimpy outfit Morgan wore during her [[Maxim (magazine)|Maxim]] photo-shoot), stapling himself in the crotch, and hitting himself in the head with a hammer.\n\n==The X-Play Boards==\nAdam and Morgan have often been the subject of numerous negative comments (including Morgans not really a gamer! and Sessler doesnt know gaming because he hates Final Fantasy!) through the shows official [[Internet forum|message board]]. The vitriol spewed forth on the forums has become so well-documented that the X-Play staff even produced a music video dedicated to the message boards denizens entitled On the X-Play Boards ([http://media.g4tv.com/audio/OnTheXPlayBoards.mp3 MP3 format]).\n\nThe song was written and performed by Marque Phahee and the Bling Dongs (in reality X-Play segment producer Mark Fahey playing an acoustic guitar), featuring the X-Play After School Choir (comprised of Morgan, Adam and various recurring X-Play characters). It is also supposed to be the lead track from the X-Play: The Musical motion picture soundtrack (even though X-Play eventually created an actual all-musical episode which made no mention of On the X-Play Boards).\n\n==Sketches and segments==\nVarious recurring segments and comedy skits have been used throughout the shows history by the X-Play writers.\n\n{{main|X-Plays sketches and segments}}\n\n==Recurring characters==\nX-Play has amassed a large group of fictional characters that will appear from time to time, often to bring some humor during game reviews.\n\n{{main|List of X-Play characters}}\n\n==X-Play: The Online Game==\nX-Play: The Online Game is a short [[Adobe Flash|Flash]] game created by the [[San Francisco, California|San Francisco]]-based company Orange Design (graphics and audio by Sean Talley, programming by Fearghal ODea).\n\nThe brief intro sequence begins in the fictitious X-Play Labs (which made an appearance on the show during the X-Play X-Plentions skit), where Morgan is about to put the finishing touches on the X-Play online game. An excited Adam asks if the game can have [[fudge]] [[zombie]]s and stealthy [[ninja]]s and drunken [[Piracy|pirates]] and [[Radioactive contamination|radioactive]] [[Dik-dik]]s, then haphazardly presses a large red button which digitizes physical matter and materializes digital matter; this causes all of the bad guys from the X-Play video game to escape (much to Morgans chagrin).\n\nOnce the game begins, players can choose from big-headed versions of either Adam (whose main weapon is Slippy the Fish) or Morgan (whose main weapon is her fists), and battle their way through a few continuously repeating levels of action. Controls comprise of the [[arrow keys]] for movement, the A key to punch, and the S key to kick.\n\nThe game is no longer available on [http://web.archive.org/web/20050608234941/http://www.g4tv.com/xplay/features/49829/XPlay_The_Online_Game.html G4s website], but a mirror site can be found via Orange Designs [http://www.orangedesign.com/archive/portfolio/xplay.html online company portfolio].\n\n==Chat==\nWhen X-Play was still a part of TechTV, the show would host an [[online chat]] every Tuesday at 1:00 p.m. EST. After the merger with G4, X-Plays official [[IRC]] chat room was re-designed by Philippe Detournay and Raphael Seeqmuller using the [[PJIRC]] chat client.\n\nOn November 6, 2006 (to coincide with the shows move to prime time<ref>[http://www.g4tv.com/thefeed/blog/post/662828/Pimp_My_XPlay_New_Features.html G4 - The Feed - Pimp My X-Play! New Features!<!-- Bot generated title -->]</ref>), the G4 network integrated X-Plays chat feature into the actual broadcast of each new episode. Using an idea similar to their production of [[Star Trek: The Original Series|Star Trek 2.0]], a window covering the bottom half of the screen would pop up during reviews, and display messages typed out by G4 users on X-Plays [http://www.g4tv.com/xplay/chat.html official web site] in real-time (comments have to be approved by a channel operator - to avoid obscenities - before they are actually aired on television).\n\nMore recently, the presentation of the X-Play chat function has been redesigned for the shows new format, so that chat messages will display on the left-hand side of the screen during a review. The show has also launched an interactive [[Twitter]] presence, where the show producers ask followers a few hours before a broadcast a question of the day and then scroll responses to that tweet on-screen during the show.\n\n==Podcast==\nOn November 11, 2005, G4 started offering X-Play segments (reviews, skits, etc.) for free in [[podcast]] form via their [http://www.g4tv.com/xplay/podcasts/6/XPlay_Daily_Video_Podcast.xml website] and [[iTunes]] store, so that fans can view these segments at their leisure on computers and portable devices.\n\nAdam and Morgan will often direct the viewers to download these podcasts during the broadcast (Sessler is adamant that X-Play end up getting more downloads than his bitter rival [[Cesar Millan|The Dog Whisperer]]).\n\n==X-Play Weekly==\nOn August 14, 2008, a special weekly wrap-up show called X-Play Weekly was made available for download on the [http://www.xbox.com/en-US/marketplace/media/f8e95009-65fd-4f7e-8e46-d271a6834fa4/ Xbox LIVE Video Store],<ref>[http://www.broadcastingcable.com/article/CA6586289.html Broadcasting & Cable]</ref> allowing [[Xbox 360]] owners to view highlights from the previous weeks episodes for 160 [[Microsoft Points]] ([[United States dollar|$]]2 US).\n\nBeginning the week of [[June 15]], [[2009]], X-Play Weekly was also made available for download through the [[Playstation Network]].\n\n'
p48
tp49
a(I-1
S'{{Orphan|date=February 2009}}\n{{Cleanup-jargon|date=January 2009}}\n{{Confusing|date=January 2009}}\n\nDivided consciousness is a term coined by [[Ernest Hilgard]] to define a psychological state in which ones consciousness is split into distinct components, possibly during [[hypnosis]].\n\n== Origin(s) ==\nThe theory of a division of consciousness was touched upon by [[Carl Jung]] in 1935 when he stated, The so-called unity of consciousness is an illusion... we like to think that we are one but we are not.<ref>(Review: Dissociationism Revived, Matthew Hugh Erdelyi, Science, New Series, Vol. 200, No. 4342 (May 12, 1978), pp. 654-655; Published by: American Association for the Advancement of Science)</ref>  Ernest Hilgard believed that hypnosis causes a split in awareness and a vivid form of everyday mind splits. <ref>(Myers, David G. Psychology:  Eighth Edition in Modules. New York, NY: Worth Publishers, 2007)</ref>   Drawing themes from [[Pierre Janet]], Hilgard viewed hypnosis from this perspective as a willingness to divide the main systems of consciousness into different sectors.  He argued that this split in consciousness can not only help define the state of mind reached during hypnosis, but can also help to define a vast range of psychological issues such as [[dissociative identity disorder|multiple personality disorder]].\n\nIn Hilgards Divided Consciousness Reconsidered, he offers a great many examples of [[dissociation|dissociated]] human behavior. With regard to theory, he does state that it is useful to assign two modes of consciousness, a receptive mode and an active mode--that is, a bimodal consciousness. In other places he mentions the concept of coconsciousness, wherein two or more states of consciousness may be equally receptive or active, as, for example, in some types of multiple personality.<ref>Huebner, B. (1979). Distributing cognition: A defense of collective mentality, Journal of Psycholinguistic Research, 8 (6),591;  Retrieved from http://www.springerlink.com/content/h66jn31642t052j8/fulltext.pdf?page=1</ref>\n\nMany psychological studies assume a unity of consciousness. Doubt is cast on this assumption by psychophysical studies in normal subjects and those with [[blindsight]] showing the simultaneous dissociation of different modes of report of a sensation, and by clinical studies of anosognosic patients showing dissociations of awareness of their own states.{{Fact|date=January 2009}} These and other phenomena are interpreted to imply two kinds of division of consciousness: the separation of phenomenal experience from reflexive consciousness and the non-unity of reflexive consciousness. Reflexive consciousness is taken to be necessary for report and is associated with the self as the subject of experience and agent of report. Reflexive consciousness is operative only when we attend to our own states. When we are involved in the world reflexivity intervenes less and our consciousness is more unified.<ref> Hebb, D, Juzyck, P, Klein R.,(1983). The Nature of Thought,  Medical Research Council, Applied Psychology Unit, Cambridge, UK. Retrieved from http://books.google.com/books?id=0cprqzSe6BkC&pg=PA34&lpg=PA34&dq=By+Donald+Olding+Hebb,+Peter+W.+Jusczyk,+Raymond+M.+Klein&source=bl&ots=N_f-8zNr2K&sig=dBHDyYyDKSCTQ4YohMjalD85fxY&hl=en&sa=X&oi=book_result&resnum=4&ct=result#PPA32,M1</ref>\n\n== Experimentation ==\nThe theory has been tried and tested and many some tests have proven that the theory makes is legitimate.{{Fact|date=January 2009}}  Others, such as one performed on 169 undergraduate students, some of whom performed tasks in selective attention and divided attention conditions being correlated with scores on the [[Hypnotic susceptibility#Harvard Group Scale|Harvard Group Scale of Hypnotic Susceptibility]] refute Hilgards findings.<ref>Some operationalizations of the neodissociation concept and their relationship to [[hypnotic susceptibility]]. Stava, Lawrence J.; Jaffa, Melvyn. Journal of Personality and Social Psychology. Vol 54(6), Jun 1988, 989-996.)\n</ref>\n\nNew trends in psychology and [[cognitive neuroscience]] suggest that applications of [[nonlinear dynamics]], chaos and self-organization seem to be particularly important for research of some fundamental problems regarding mind-brain relationship. Relevant problems among others are formations of memories during alterations of mental states and nature of a barrier that divides mental states, and leads to the process called [[dissociation]]. This process is related to a formation of groups of neurons which often synchronize their firing patterns in a unique spatial manner. Central theme of this study is the relationship between level of moving and oscillating mental processes and their neurophysiological substrate. This presents a question about principles of organization of the conscious experience and how the experiences happen in the brain. Chaotic self-organization provides a unique theoretical and experimental tool for deeper understanding of dissociative phenomena and enables to study how dissociative phenomena can be linked to [[epilepsy|epileptiform]] discharges which are related to various forms of psychological and somatic manifestations. Organizing principles that constitute human consciousness and other mental phenomena from this point of view may be described by analysis and reconstruction of underlying dynamics of psychophysiological measures.<ref>Chaos, brain and divided consciousness.\nPetr Bob, Acta Univ Carol Med Monogr. 2007 ;153 :9-80 17867519 (P,S,G,E,B)</ref>\n\n'
p50
tp51
a(I1
S'{{mergefrom|The Open Organization Of Lockpickers|discuss=Talk:Locksport#Merger proposal|date=January 2009}}\n\nLocksport refers to the sport or recreation of studying and learning to defeat [[Lock (device)|locking systems]]. Its enthusiasts learn a variety of skills including [[lock picking]], [[lock bumping]], and a variety of other skills traditionally known only to [[locksmithing|locksmiths]] and other security professionals. Locksport followers enjoy the challenge and excitement of learning to defeat all forms of locks, and often gather together in sport groups to share knowledge, exchange ideas, and participate in a variety of recreational activities and contests.\n\n== History ==\nThough lock picking has been around for as long as locks have, the organized hobby of lock picking is a relatively recent phenomenon. The earliest known organized group of lock picking enthusiasts is the German club SSDeV (Sportsfreunde der Sperrtechnik - Deutschland e.V. or, translated Sportsenthusiasts of Lockpicking  Germany). SSDeV was founded by Steffen Wernry in 1997.<ref>[http://lockpicking.org/SSDeV/hist@eng.php History - Sportenthusiasts of Lockpicking - Germany]</ref> As the group grew in Germany, another group was founded in The Netherlands in 1999. This group, originally called NVHS, and currently called TOOOL (The Open Organisation Of Lockpickers),<ref>[http://www.toool.nl/Lockpicking FAQ - What happened to the NVHS?]</ref> has also helped to pioneer the collaborative hobby of lock picking.\n\nThe popularization of hobby lock picking in North America is largely credited to the web forum [http://www.lockpicking101.com LockPicking101.com], currently the largest lock picking related forum on the web. Members visit to discuss [[locks]], techniques, and tools. The board is host to a very large collection of threads on topics related to locksport, and acts as the largest public infobase on the web. As well, the widely distributed document formally titled [http://people.csail.mit.edu/custo/MITLockGuide.pdf The MIT Guide to Lock Picking] by Ted The Tool was a source of instruction for many enthusiasts new to the hobby of lock picking. The MIT Guide To Lock Picking was originally written to aide enthusiasts of a controversial activity called [[urban exploration]]. Today, virtually all locksport enthusiasts condemn the practice of picking locks without permission or illegal entry.\n\nThe term locksport was adopted by lock picking enthusiasts as a way of differentiating what they do from locksmiths, as well as from those who might choose to pick locks for nefarious purposes. As of early 2005, the term had been suggested, but not widely adopted. The creation of the sport group [[Locksport International]] in July of 2005, founded by Josh Nekrep, Kim Bohnet, and Devon McDormand of LockPicking101.com, helped to solidify the term within the community, and today the term is widely adopted in North America by those who practice the craft of lock picking for fun and sport.<ref>[http://abcnews.go.com/Technology/story?id=688464&page=1 Lock Picking for Sport Cracks the Mainstream]</ref><ref>[http://blogs.kansascity.com/crime_scene/files/hobbyists_embrace_the_joys_of_picking_locks.pdf Hobbyists embrace the joys of picking locks]</ref>\n\n== Philosophy ==\nAt the core of locksport is the philosophical belief in responsible full disclosure. Locksport enthusiasts target [[security through obscurity]] that is common within the locksmith industry, as well as among lock manufacturers. Those who choose to participate in locksport often seek to discover security vulnerabilities and notify lock manufacturers as well, in some instances, the public, in an effort to promote improvements in the field of [[physical security]] and to aid consumers in making better, more informed decisions about their own security.<ref>[http://www.locksport.com/faq.php Ok, but what good could come of a club like yours?]</ref> This philosophy is contradictory to that held by many locksmith organizations,<ref>[http://www.security.org/middle_RESPONSE_ALOA.htm ALOA clearly believes that security through ignorance should be the rule.]</ref> and locksport enthusiasts have come under attack for releasing information about lesser-known vulnerabilities.{{Fact|date=May 2009}} Nonetheless, locksport enthusiasts persist in discovering weaknesses in all forms of physical security.\n\n== Activities ==\nAt locksport meetings, members regularly participate in a variety of activities such as lock challenges, lock relay races, standardized tests, and many other such activities dreamed up by the members themselves. \n\nOne such activity is known as the Padlock Challenge, where members each start with a predefined number of padlocks linked together. As participants pick a lock, they attach the lock to the chain of padlocks of another participant. The goal is to be the first to rid oneself of all ones locks.{{Fact|date=January 2009}} Another common activity is some form of speed challenge, where members are given a limited time to pick a lock, or compete for the best time on one or more locks.\n\n== Contests ==\nThere are several organized lock picking contests that are held each year. Both SSDeV and TOOOL.NL hold a major contest each year, and hobbyists travel from many different countries to participate. In North America, contests are held at the [[DEF_CON_(convention)|Defcon]] Convention in Las Vegas each year, and the [http://en.wikipedia.org/wiki/H.O.P.E. HOPE] Convention every second year. Rules and format of contests vary from event to event.\n\n== Conventions ==\nThough there are currently no conventions exclusive to locksport, enthusiasts have found acceptance among a variety of hacker conventions. [http://en.wikipedia.org/wiki/DEF_CON Defcon] and [http://en.wikipedia.org/wiki/H.O.P.E. HOPE] are the most notable. At each of these conventions a dedicated area called The Lock Picking Village is set up where contests and presentations are held, and attendees can learn to pick locks and watch others practice and compete.\n\n== Ethics==\nBecause lock picking is sometimes viewed as a nefarious craft, locksport enthusiasts uphold a very rigorous standard of ethics. The credo of locksports has often been described as:\n<blockquote>You may only pick locks that you own, or those to which youve been given expressed permission to pick by the rightful owner.</blockquote>\nIn an effort to keep lock picking skill away from those who would abuse it, members of locksport groups uphold a zero-tolerance for illegal or immoral lock picking, bypass, or other forms of entry.<ref>[http://www.ssdev.org/SSDeV/miss@eng.php You may only open locks which belong to you.]</ref> Though accounts of lock picking being used for crime are statistically very low,{{Fact|date=January 2009}} locksport enthusiasts feel they must uphold such strict standards to repudiate the often held misconception that they are participating in illegal activities.<ref>[http://www.locksport.com/faq.php Arent you just teaching people to break into things?]</ref>\n\n'
p52
tp53
a(I1
S'{{Refimprove|date=July 2007}}\n{{Infobox Royalty\n| name           =Rainier III\n| full name      =Rainier Louis Henri Maxence Bertrand\n| succession     =[[Prince of Monaco]]\n| image          =Rainier 3.jpg\n|imgw            =200\n| reign          =9 May 1949 - 6 April 2005\n| predecessor    =[[Louis II, Prince of Monaco|Louis II]]\n| successor      =[[Albert II, Prince of Monaco|Albert II]]\n| spouse         =[[Grace Kelly]]\n| issue          =[[Caroline, Princess of Hanover]]<br/>[[Albert II, Prince of Monaco]]<br/>[[Princess Stphanie of Monaco]]\n| princely house =[[House of Grimaldi]]\n| father         =[[Pierre de Polignac|Prince Pierre, Duke of Valentinois]] \n| mother         =[[Princess Charlotte, Duchess of Valentinois]]\n| date of birth  ={{birth date|1923|5|31|df=y}}\n| place of birth =[[Monaco]]\n| date of death  ={{death date and age|2005|4|6|1923|5|31|df=y}}\n| place of death =[[Monaco]]\n| place of burial=[[Saint Nicholas Cathedral, Monaco|Saint Nicholas Cathedral]]\n|}}\nRainier III, Prince of Monaco (Rainier Louis Henri Maxence Bertrand Grimaldi, Count of Polignac; 31 May 1923 &ndash; 6 April 2005), styled His Serene Highness The [[Sovereign Prince of Monaco]], ruled the [[Principality]] of [[Monaco]] for more than 50 years, making him one of the [[List of longest reigning monarchs|longest ruling monarchs]] of the 20th century.  \nThough he was best known outside of [[Europe]] for having married American actress [[Grace Kelly]], he was also responsible for reforms to [[Constitution of Monaco|Monacos constitution]] and for expanding the principalitys economy beyond its traditional [[gambling]] base. Gambling accounts for approximately three percent of the nations annual revenue today; when Rainier ascended the throne in 1949, it accounted for more than 95 percent.\n\n==Ancestry==\nRainier III was of [[French people|French]], [[Mexican]]<ref>{{cite web| url = http://www.wargs.com/essays/lesbian.html| title = The Lesbian ancestors of Prince Rainier of Monaco, Dr. Otto von Habsburg, Brooke Shields, and the Marquis de Sade| accessdate  = 2009-02-27| author = William Addams Reitwiesner| last = Reitwiesner| first = William Addams| year = 1995}}, citing  Don Ricardo Ortega y Perez Gallardo, Historia Genealogica de las Familias mas Antiguas de Mexico, Tercera edicion, [Mexico: Carranza, 1910]</ref>, [[Spanish people|Spanish]], [[Germans|German]], [[Scottish people|Scottish]], [[English people|English]], [[Dutch people|Dutch]], and [[Italians|Italian]] ancestry.\n\nThrough his great-grandmother [[Lady Mary Victoria Hamilton]], who was briefly Princess of Monaco, he was a descendent of [[James IV of Scotland]] (descended from three of his illegitimate daughters).  His great-great-great-grandmother was [[Stphanie de Beauharnais]], the adopted daughter of [[Napoleon Bonaparte]] and later the [[List of rulers of Baden|Grand Duchess of Baden]]. Other ancestors include [[William Thomas Beckford]], the [[scandal]]ous 18th century English collector, tastemaker, writer, and eccentric.\n\t\t \nRainier was also a descendent of [[William the Silent]] of Orange-Nassau, the main leader of the [[Eighty Years War|Dutch revolt]] against the [[Spanish Empire]] and ancestor to the current [[Dutch Royal Family]]; [[Hortense Mancini]], the [[Duchess of Mazarin]] and mistress of King [[Charles II of England]]; [[Gabrielle de Polastron, duchesse de Polignac|Gabrielle de Polignac]], a favorite of [[Marie Antoinette]]; [[Joan of Kent]], the first [[Princess of Wales]]; King [[Charles IX of Sweden]]; King [[Frederick II of Denmark and Norway]]; [[Ferdinand I, Holy Roman Emperor]], [[Claude, Duke of Guise]] and Prince Thomas M. Marciano II of Genoa.\n\n==Early life==\nRainier was born in [[Monaco]], the only son of Prince Pierre of Monaco, Duke of Valentinois (n Count [[Pierre de Polignac]]) and his wife, Hereditary [[Princess Charlotte, Duchess of Valentinois]]. Born in [[Algeria]], his mother was the only child of Prince [[Louis II, Prince of Monaco|Louis II]] and [[Marie Juliette Louvet]]; she was later legitimized through formal adoption and subsequently named heiress to the throne of Monaco. His father was a half-[[French nobility|French]], half-[[Mexican nobility|Mexican]] nobleman from [[Brittany]] who adopted his wifes surname, Grimaldi, upon marriage and was made a prince of Monaco by his father-in-law.\n\nRainier had one sibling, HSH [[Princess Antoinette, Baroness of Massy]], an unpopular figure generally believed to be meddlesome enough regarding her childrens place in the line of succession to have forced Princess Grace to demand that she leave the country.\n\nRainier was first sent to study at [[Summerfields, St Leonards-on-Sea|Summerfields School]] in [[St Leonards-on-Sea]], England,<ref>[http://www.timesonline.co.uk/tol/news/world/article377941.ece Prince Rainier III of Monaco: The Times obituary], The Times, 6 April 2005. Accessed 31 May 2008.</ref> and later at [[Stowe School|Stowe]], a prestigious English [[public school (England)|public school]] in [[Buckinghamshire]]. From there, he went to the [[Institut Le Rosey]] in [[Rolle]] and [[Gstaad]], Switzerland, before continuing to the [[University of Montpellier]] in France, where he obtained a [[Bachelor of Arts]] degree, and finally to the [[Paris Institute of Political Studies|Institut dtudes politiques de Paris]] in Paris. \n\nRainiers maternal grandfather, [[Louis II, Prince of Monaco|Prince Louis II]], had been a general in the French army during [[World War I]]. During [[World War II]], Rainier served as an artillery officer in the army. As a [[second lieutenant]], he fought so courageously during the German counter-offensive in [[Alsace]] that he won the [[Croix de Guerre]] and [[Bronze Star Medal|Bronze Star]] and was given the rank of Chevalier in the [[Lgion dhonneur|Legion of Honor]].\n\nOn 9 May 1949, Rainier became the Sovereign Prince of Monaco on the death of Prince Louis II, his mother having renounced her rights to the throne in his favor in 1944.\n\n==Early romance==\nIn the 1940s and 1950s, the prince openly lived with the French film star [[Gisle Pascal]]. The couple reportedly separated when a [[medical doctor|doctor]] declared her to be infertile; in fact, she later married and had a child.\n\n==Marriage and family==\nAfter a year-long courtship described as containing a good deal of rational appraisal on both sides ([[The Times]], 7 April 2005, page 59), in [[Monaco]] civilly on 18 April 1956 and religiously on 19 April 1956, Prince Rainier married [[Academy Awards|Oscar]]-winning American actress [[Grace Kelly]] (1929&ndash;1982).<ref>[http://news.bbc.co.uk/onthisday/hi/dates/stories/april/19/newsid_2720000/2720723.stm 1956: Prince Rainier marries Grace Kelly], BBC: On This Day. Accessed 31 May 2008.</ref> Their children are:\n\n*[[Caroline, Princess of Hanover|Princess Caroline Louise Marguerite]], born 23 January 1957 and now HRH The Princess of Hanover and [[heiress presumptive]] to the throne of Monaco\n*[[Albert II, Prince of Monaco]], born 14 March 1958\n*[[Princess Stphanie of Monaco|Princess Stphanie Marie Elisabeth]], born 1 February 1965\n\nPrince Rainier had nine grandchildren:\n\n*[[Andrea Casiraghi|Andrea]], [[Charlotte Casiraghi|Charlotte]] and [[Pierre Casiraghi]] - children of Princess Caroline and [[Stefano Casiraghi]];\n*[[Princess Alexandra of Hanover]] - daughter of Princess Caroline and [[Ernst August V, Prince of Hanover]]\n*[[Louis Ducruet|Louis]] and [[Pauline Ducruet]] - children of Princess Stphanie and [[Daniel Ducruet]]\n*[[Jazmin Grace Grimaldi]] - the illegitimate daughter of Prince Albert II of Monaco and Tamara Rotolo\n*[[Alexandre Coste]] - the illegitimate son of Prince Albert II of Monaco and [[Nicole Coste]]\n*Camille Gottlieb - the illegitimate daughter of Princess Stphanie.\n\nHe was a hands-on grandparent which is unusual in a monarchy. He was often seen with Caroline and Stephanies children. \n\nAfter his wifes death in a car crash in 1982, he was romantically involved with his second cousin, Princess [[Ira von Frstenberg]], a former movie actress turned jewellery designer who is also a [[Fiat]] heiress and the former sister-in-law of fashion designer [[Diane von Furstenberg]]. Like him, she is a great-grandchild of [[Lady Mary Victoria Hamilton]], the Scottish&ndash;[[German people|German]] wife of Prince [[Albert I, Prince of Monaco|Albert I of Monaco]], though by Lady Marys second marriage.\n\nRainier was also a [[football (soccer)|football]] fan, having followed [[AS Monaco FC]] to the 2004 [[UEFA Champions League|Champions League]] final. Monaco has for years hosted the [[European Super Cup]].\n\n==Actions as Prince==\nAfter ascending the throne, Rainier worked assiduously to recoup Monacos lustre, which had become tarnished through neglect (especially financial) and scandal (his mother, Princess Charlotte, took a noted jewel thief known as Ren the Cane as her lover). According to numerous obituaries, the prince was faced upon his ascension with a treasury that was practically empty. The holder of 55 percent of the nations reserves, the [[Societ Mongasque de Banques et de Mtaux Prcieux]], was bankrupt. The small nations traditional gambling clientele, largely European aristocrats, found themselves with reduced funds after World War II. Other gambling centers had opened to compete with Monaco, many of them successfully. To compensate for this loss of income, Rainier decided to promote Monaco as a tax haven, commercial center, real-estate development opportunity, and international tourist attraction. The early years of his reign saw the overweening involvement of the Greek shipping tycoon [[Aristotle Onassis]], who took control of the [[Socit des Bains de Mer]] and envisioned Monaco as solely a gambling resort. Prince Rainier regained control of the Socit in 1964, effectively ensuring that his vision of Monaco would be implemented.\n\nAs Prince of Monaco, Rainier was also responsible for the principalitys new constitution in 1962 which significantly reduced the power of the sovereign. (He suspended the previous Constitution in 1959, saying that it has hindered the administrative and political life of the country.) The changes ended autocratic rule, placing power with the prince and a National Council of eighteen elected members.\n\nAt the time of his death, he was the worlds second longest-serving [[head of state]], ranking just below King [[Bhumibol Adulyadej|Rama IX]] of [[Thailand]].  During the last two or three years of his life, Rainier was in the custom of asking his valet each morning, Has Rama survived the night?  Or did I just move up in the ranks?\n\n==Illness and death==\nIn the last three years of his life, Prince Rainiers health progressively declined. In early 2004 he was hospitalized for coronary problems. In October he was again in hospital with a lung infection.  In November of that year, [[Albert II, Prince of Monaco|Prince Albert]] appeared on [[CNN]]s [[Larry King Live]] and told [[Larry King]] that his father was fine, though he was suffering from bronchitis.<ref>[http://transcripts.cnn.com/TRANSCRIPTS/0411/18/lkl.01.html Interview With Prince Albert of Monaco], CNN, 18 November 2004. Accessed 31 May 2008.</ref> On 7 March 2005, he was again hospitalized with a lung infection. Rainier was moved to the hospitals intensive care unit on 22 March. One day later, on 23 March, it was announced he was on a [[ventilator]], suffering from [[renal failure|renal]] and [[heart failure]]. On 26 March the palace reported that despite intensive ongoing efforts to improve the princes health, he was continuing to deteriorate; however, the following day, he was reported to be conscious, his heart and kidney conditions having stabilized. His prognosis remained very reserved.<ref>{{cite web|url=http://news.bbc.co.uk/2/hi/europe/4385965.stm|title=Rainiers condition stabilises|date=27 March 2005|publisher=BBC News|accessdate=2008-08-18}}</ref>\n\nOn 31 March 2005, following consultation with the [[Crown Council of Monaco]], the [[Palais Princier]] announced that Rainiers son, Hereditary [[Albert II, Prince of Monaco|Prince Albert]], [[Marquis des Baux]], would take over the duties of his father as [[Regent]] since Rainier was no longer able to exercise his royal functions.<ref>[http://msnbc.msn.com/id/7347372/ Son of ailing Prince Rainier takes over duties], MSNBC, 31 March 2005. Accessed 31 May 2008.</ref>\n\nOn 1 April 2005, the Palace announced that Rainiers doctors believe his chances of recovery were slim<ref>{{cite web|url=http://origin.www.cbc.ca/world/story/2005/04/01/rainier-050401.html|title=Rainiers recovery chances slim, doctors say|date=1 April 2005|publisher=CBC News|accessdate=2008-08-18}}</ref>; on 6 April it announced that Prince Rainier had died in [[Monaco]] at 6:35 am local time at the age of 81. He was succeeded by his only son, who became [[Albert II, Prince of Monaco|Prince Albert II]].<ref>{{cite web|url=http://news.bbc.co.uk/2/hi/europe/4415291.stm|title=Monacos Prince Rainier, 81, dies|date=6 April 2005|publisher=BBC News|accessdate=2008-08-18}}</ref>\n\nHe was buried on 15 April 2005, beside his wife, [[Grace Kelly|Princess Grace]], at the [[Saint Nicholas Cathedral, Monaco|Saint Nicholas Cathedral]], the resting place of previous sovereign princes of Monaco and several of their wives<ref>{{cite web|url=http://www.gouv.mc/devwww/wwwnew.nsf/1909$/b1c5425907fc1876c125706d0042ab74gb?OpenDocument&2Gb|title=Monaco Cathedral|date=28 July 2008|publisher=Service Informatique du Ministre dEtat (Monaco Minister of State Information Service|accessdate=2008-08-18}}</ref>, and the place where Prince Rainier and Princess Grace had been married in 1956.<ref name=Burial>{{cite web|url=http://www.telegraph.co.uk/news/worldnews/europe/monaco/1487978/Monacos-farewell-to-its-sovereign-and-friend.html|title=Monacos farewell to its sovereign and friend|last=Randall|first=Colin|date=16 April 2005|publisher=The Daily Telegraph|accessdate=2008-08-18}}</ref>\n\nBecause his death occurred shortly after that of [[Pope John Paul II]], Rainiers death was overshadowed in the media.<ref name=Burial/>\n\n==Titles==\nRainiers official shortened title was [[His Serene Highness]] Rainier III, Sovereign Prince of Monaco; this does not include the many other hereditary titles acquired by the Grimaldi family (see [[Sovereign Prince of Monaco|Prince of Monaco]] for a complete list).\n\nHis other non-hereditary titles and awards included:\n* Knight Grand-Cross of Honour and Devotion of the [[Sovereign Military Order of Malta]] with Cross of Honorary Professed Member\n* Colonel in the [[French Army]]\n* Grand Master of the [[Order of Saint-Charles]]\n* Grand Master of the [[Order of the Crown]]\n* Grand Master of the [[Order of Grimaldi]]\n* Knight of the [[Royal Order of the Seraphim|Order of the Seraphim]]\n* Knight Grand Cross of the [[Legion of Honour]]\n* Member of the [[Pontifical Military Order of the Golden Spur]]\n* Member of the [[Order of Seraphs]]\n* Collar of Merit of the [[Sovereign Military Order of Malta]]\n* Grand Cordon of the [[Order of Merit of the Italian Republic]]\n* Knight Grand Cross of the [[Order of the Savior]] (Greece)\n* Knight Grand Cross of the [[Royal Order of George I]] (Greece)\n* Grand Cordon of the [[Order of Lopold]] (Belgium)\n* Knight Grand Cross of the [[Order of the Golden Lion]] of [[Nassau (duchy)|Nassau]]\n* Knight Grand Cross of the [[Equestrian Order of Saint-Martin]]\n* Knight Grand Cross of the [[Order of Mohammed Ali]]\n* Knight Grand Cross of the [[Order of Andrew H. Kowalski]]\n* Knight Grand Cross of the [[Order of the Star of Karageorgevitch]]\n* Knight Grand Cross of the [[Military Order of Saint-Jacques of the Sword]]\n* Knight Grand Cross of the [[Order of Jose Matias Delgado]] ([[El Salvador]])\n*[[Lebanon|Lebanese]] Medal of Merit\n* The [[Croix de Guerre|French Cross of War]] (Croix de Guerre)\n*[[Cross of the Voluntary Combatant]] 1939-1945\n* The [[Belgian Cross of War]]\n* Gold Medal of the [[American Legion]] and the [[Golden Olympic Order]]\n*[[Fdration Internationale de lAutomobile]] [[Gold Medal for Motor Sport]]\n* Grand Collier of the [[Orden de Manuel Amador Guerrero|Order of Manuel Amador Guerrero]] ([[Panama]])\n\n==Philately==\n[[File:2005 Monaco 10 euro Reinier III front.jpg|thumb|[[Euro gold and silver commemorative coins (Monaco)#2005 coinage|Prince Rainier III commemorative coin]]]]\n\nRainier created a postal museum in 1950 by using the collections of [[Albert I, Prince of Monaco|Albert I]] and [[Louis II, Prince of Monaco|Louis II]]. Since 1996 this museum has been called [[Muse des timbres et monnaies]]. \n\nCreator of the philatelic [[Club de Monte-Carlo]] in 1997, he organized with its members some exhibitions of rare and exceptional [[postage stamps]] and letters.\n\nThroughout his reign, Rainier surveyed all the process of creation of Monaco stamps. He liked stamps printed in [[Intaglio (printmaking)|intaglio]] and the art of engraver [[Czesaw Sania]].\n\n==Commemorative coin==\n\nHonouring the Prince on his death in 2005, a high value commemorative coin was minted with his effigy on it, the 10 gold [[Euro gold and silver commemorative coins (Monaco)#2005 coinage|Prince Rainier III commemorative coin]], minted also in 2005. On the obverse the effigy of the past prince is depicted; while on the reverse the Grimaldis Coat of Arms is shown.\n\n==Ancestry==\n{{ahnentafel top|width=100%}}\n{{ahnentafel-compact5\n|style=font-size: 90%; line-height: 110%;\n|border=1\n|boxstyle=padding-top: 0; padding-bottom: 0;\n|boxstyle_1=background-color: #fcc;\n|boxstyle_2=background-color: #fb9;\n|boxstyle_3=background-color: #ffc;\n|boxstyle_4=background-color: #bfc;\n|boxstyle_5=background-color: #9fe;\n|1= 1.Rainier III, Prince of Monaco\n|2= 2. [[Prince Pierre, Duke of Valentinois|Count Pierre of Polignac]]\n|3= 3. [[Princess Charlotte, Duchess of Valentinois]]\n|4= 4. Count Maxence of Polignac\n|5= 5. Suzanne de la Torre y Mier\n|6= 6. [[Louis II, Prince of Monaco]]\n|7= 7. [[Marie Juliette Louvet]]\n|8= 8. Count Charles of Polignac\n|9= 9. Caroline Josphine Le Normand de Morando\n|10= 10. Isidoro Fernando de la Torre y Gil \n|11= 11. Luisa de Mier y Celis\n|12= 12. [[Albert I, Prince of Monaco]]\n|13= 13. [[Mary Victoria Douglas-Hamilton|Mary Victoria Hamilton]]\n|14= 14. Jacques Henri Louvet\n|15= 15. Josephine Elmire Piedefer\n|16= 16. Camile Henri Melchior, Count of Polignac \n|17= 17. Marie Charlotte Le Vassor de la Touche \n|18= 18. Joseph Le Normand de Morando\n|19= 19. Anne Papin de Thevign \n|20= 20. Francisco de la Torre \n|21= 21. Josefa Gil\n|22= 22. Gregorio de Mier y Teran\n|23= 23. Mariana de Celis\n|24= 24. [[Charles III, Prince of Monaco]]\n|25= 25. [[Antoinette de Mrode-Westerloo]]\n|26= 26. [[William Hamilton, 11th Duke of Hamilton]]\n|27= 27. [[Princess Marie of Baden (18171888)|Princess Marie of Baden]]\n|28= 28. Jacques Antoine Louvet \n|29= 29. Marie Catherine Jouanne\n|30= 30. Pierre Piedefer\n|31= 31. Marie Anne Brunel\n}}</center>\n{{ahnentafel bottom}}\n\n'
p54
tp55
a(I1
S'HERO (Heathkit Educational RObot) is the name of several educational [[robot]]s sold by [[Heathkit]] during the 1980s.  The Heath Company began the HERO 1 project in October 1979. The first units were available in 1982.  Models included the HERO 1, HERO Jr., and HERO 2000.  All three were available as kits, or for more money, prebuilt by Heathkit.  Currently, the 1980s models are considered collectors items, due to their apparent rarity.  For the most part, they cannot perform practical tasks, but are more geared toward entertainment and education above all.\n\n== HERO 1 (ET-18) ==\n\nHERO 1 was a self-contained mobile robot controlled by an onboard [[computer]] with a [[Motorola]] 6808 [[CPU]] and 4k of [[RAM]]. The robot featured light, sound, and motion detectors as well as a [[sonar]] ranging sensor.  An optional arm mechanism was available.<ref>Mark J. Robillard: HERO 1 - Advanced Programming and Interfacing, H.W. Sams 1983. ISBN 0672221659</ref><ref>Howard Boyet: Hero 1 - Advanced Programming Experiments, Heathkit/Zenith 1984. ISBN 0871190362</ref>\n{{double image|right|Hero1.jpg|180|Hero1kopf.jpg|180|HERO 1 (left) and HERO 1s control panel (right)}}\n\n===Technical data===\n{| class=wikitable style=font-size: 90%; text-align: left; \n|CPU\n|Motorola 6808\n|-\n|RAM\n|4 kB\n|-\n|Monitor-ROM\n|2 kB\n|-\n|Input\n|Hex-Keypad with 17 keys\n|-\n|Output\n|6 7-Segment-LEDs\n|-\n|Storage\n|Compact-Cassette\n|-\n|Height\n| 20 inches\n|}\n\n== HERO Jr. (RT-1) ==\n\nA smaller version of HERO was released later, called HERO Jr.  Heathkit intended it for the home market, and therefore made it less complex, and more self contained.  Like HERO 1, HERO Jr. had a 6808 processor, but only 2k of RAM.  As well, it sported onboard [[speech synthesis]], a [[Polaroid]] sonar range sensor, a light sensor, and a sound sensor.  An optional infrared sensor was available as well.  Other optional components included a pair of extra batteries to double the operational time between charges, from an estimated 4 hours to 8 hours.  A remote control accessory allowed users to drive the robot around.  It included a motion sensor that caused the robot to croak SOM-THING-MOVE when it detected a source of [[Motion (physics)|motion]].  \n\nHeathkit released several add-ons to increase the robots capabilities, including a transmitter to activate a home security system in the event it sensed movement while on guard duty.  Also, additional cartridges with programs and games were available, as well as a components to allow the user to directly program the robot. \n\nThe drive mechanism is backward compared to the HERO 1, with the drive and steering wheel in the back of the robot. The head section featured an indentation to allow the robot to transport up to 10 lbs.  The robot could speak several phrases from various films that either involved robots or computers.\n[[File:Heathkit HERO Jr.jpg|thumb|150px|Hero Jr.]]\n\n===Technical data===\n{| class=wikitable style=font-size: 90%; text-align: left; \n|CPU\n|Motorola 6808\n|-\n|RAM\n|2 kB, extendable to 24 kB\n|-\n|Monitor-ROM\n|32 kB\n|-\n|Input\n|Hex-Keypad with 17 keys\n|-\n|Output\n|9 LEDs\n|-\n|Batteries\n|6v 3.8ah x2, x4 optional\n|}\n\n== HERO 2000 (ET-19) ==\n\nThe much more powerful HERO 2000 included several onboard microprocessors, onboard [[speech synthesis]], several [[sensor]]s, and the ability to add expansion cards using a passive [[backplane]].<ref>John D. Hubbard, Lawrence P. Larsen: Hero 2000 - Programming and Interfacing, Heathkit/Zenith 1986. ISBN 0871191539</ref>\n[[File:Hero-2000.jpg|thumb|120px|HERO 2000.]]\n\n===Technical data===\n{| class=wikitable style=font-size: 90%; text-align: left; \n|CPU\n|Intel 8088\n|-\n|RAM\n|24 kB, extendable to 576 kB\n|-\n|Monitor-ROM\n|64 kB with integrated [[BASIC]]\n|-\n|Input\n|RS-232 Terminal-Interface\n|-\n|Output\n|RS-232 Terminal-Interface\n|}\n\n== HE-RObot ==\n\nThe forthcoming HE-RObot is the result of a strategic partnership between Heathkit and [[White Box Robotics]].  When available it may cost as much as $8000.  The HE-RObot is expected to be marketed to the educational market.<ref>[http://www.heathkit.com/herobot.html HE-ROBOT],ROBOTICS TECHNOLOGY - Heathkit Educational Systems</ref>\n[[File:Pc-bot.jpg|thumb|150px|HE-RObot is a [[badge-engineered]] version of the 914 PC-Bot (pictured) by [[White Box Robotics]].<ref>[http://www.retrothing.com/2007/12/the-heathkit-he.html HE-RObot: The Next Generation of Heathkit HERO Robots]Posted by james on December 26, 2007 at 03:16 PM in Do-It-Yourself, Robots - Retro Thing</ref>]]\n\n===Technical data===\n{| class=wikitable style=font-size: 90%; text-align: left; \n|CPU\n|Intel Core Duo\n|-\n|RAM\n|?\n|-\n|Monitor-ROM\n|?\n|-\n|Input\n|?\n|-\n|Output\n|?\n|}\n\n== Literature ==\n*Mark J. Robillard: HERO 1 - Advanced Programming and Interfacing, H.W. Sams 1983. ISBN 0672221659\n*Howard Boyet: Hero 1 - Advanced Programming Experiments, Heathkit/Zenith 1984. ISBN 0871190362\n*John D. Hubbard, Lawrence P. Larsen: Hero 2000 - Programming and Interfacing, Heathkit/Zenith 1986. ISBN 0871191539\n\n'
p56
tp57
a(I1
S'{{Globalize/US}}\n{{refimprove|date=October 2008}}\n[[Image:NSSL vehicles on Project Vortex.jpg|thumb|300px|right|[[NSSL]] vehicles on [[VORTEX|Project VORTEX]] (which operated in the seasons of 1994 - 1995), equipped with surface measurement equipment.]]\n\nStorm chasing is broadly defined as the pursuit of any severe weather condition, regardless of motive, which can be curiosity, adventure, scientific exploration or for news / media coverage.\n\nA person who chases storms is known as a storm chaser, or simply a chaser.  While witnessing a [[tornado]] is the single biggest objective for most chasers, many chase [[thunderstorms]] and delight in seeing [[cumulonimbus cloud|cumulonimbus]] structure, watching a barrage of [[hail]] and [[lightning]], and seeing what [[Cloudscape (photography)|skyscape]]s unfold.  There are also a smaller number of storm chasers who chase [[hurricanes]].\n\n== Nature of and motivations for chasing ==\nStorm chasing is chiefly a recreational endeavor, with motives usually given toward photographing the storm for personal reasons.<ref>[http://www.usatoday.com/weather/tornado/chase2001/2001-06-18-chase-paper.htm#more The thrill of the chase, the fury of the storm] [[USA Today]]</ref>  Though scientific work is sometimes cited as a goal, such work is almost always impractical except for those participating in a university or government project.<ref name=recreational chasing>{{cite journal |last=Robertson |first=David |title=Beyond Twister: A Geography of Recreational Storm Chasing on the Southern Plains |journal=[[Geographical Review]] |volume=89 |issue=4 |pages=533553 |publisher=[[American Geographical Society]] | url=http://links.jstor.org/sici?sici=0016-7428(199910)89%3A4%3C533%3ABTAGOR%3E2.0.CO%3B2-Z |month=October |year=1999 |doi=10.2307/216101 }}</ref>  Many chasers also are [[storm spotter]]s, reporting their observations of hazardous weather to the authorities.\n\nStorm chasers are not paid to chase, with the exception of television media crews in certain television markets, video stringers and photographers, and a handful of graduate [[meteorologists]] and professors.  A few entrepreneurs, however, manage to sell storm videos and pictures or operate chase tour services.  Financial returns are relatively meager given the expenses with most chasers spending more than they take in. No degree or certification is required to be a storm chaser.  The  National Weather Service does conduct severe weather workshops and storm spotter training, usually early in the spring.\n\n== History ==\nThe earliest recognized storm chaser is [[David K. Hoadley|David Hoadley]] (1938&ndash; ), who began chasing [[North Dakota]] storms in 1956; systematically using data from area weather offices.  Bringing research chasing to the forefront was [[Neil Ward]] (1914&ndash;1972) who in the 1950s and 1960s enlisted the help of [[Oklahoma]] state police to study storms.  His work pioneered modern storm spotting and made institutional chasing a reality.\n\nIn 1972 the [[University of Oklahoma]] in cooperation with the [[National Severe Storms Laboratory]] began the Tornado Intercept Project, with the first outing taking place on [[April 19]] of that year. <ref> Thomas P. Grazulis, The Tornado: Natures Ultimate Windstorm (University of Oklahoma Press, 2001), pp241-242 </ref> This was the first large-scale chase activity sponsored by an institution. It culminated in a brilliant success in 1973, with the [[Union City, Oklahoma]] tornado providing a foundation for tornado morphology.<ref name=field programs history>{{cite journal |last=Bluestein |first=Howard |authorlink=Howard B. Bluestein |title=A History of Severe-Storm-Intercept Field Programs |journal=[[Weather and Forecasting]] |volume=14 |issue=4 |pages=558577 |publisher=[[American Meteorological Society]] |month=August | url=http://ams.allenpress.com/perlserv/?request=get-abstract&issn=1520-0434&volume=014&issue=04&page=0558 |doi=10.1175/1520-0434(1999)014<0558:AHOSSI>2.0.CO;2 |year=1999 }}</ref>  The project produced the first legion of veteran storm chasers, with Hoadleys [[Storm Track (magazine)|Storm Track]] magazine bringing the community together in 1977.\n\nStorm chasing then reached popular culture in three major spurts: in 1978 with the broadcast of a segment on the television program [[In Search of... (TV series)|In Search of...]]; in 1985 with a documentary on the [[Public Broadcasting Service|PBS]] series [[Nova (series)|Nova]]; and in May 1996 with the theatrical release of [[Twister (1996 film)|Twister]] which provided an action-packed but comically distorted glimpse at the hobby.  Further early exposure to storm chasing encouraging some in the weather community resulted from several articles beginning in the late 1970s in [[Weatherwise]] magazine.  Various television programs, increased coverage of severe weather by the media, and especially the Internet have also contributed to a significant growth of storm chasing since the mid-late 1990s.  A sharp increase in the general public impulsively wandering in their local area searching for tornadoes similarly is largely attributable to these factors.\n\n== Typical storm chase ==\nChasing often involves driving thousands of miles in order to witness the relatively short window of time of active severe thunderstorms. It is not uncommon for a storm chaser to end up empty handed on any particular week.  Storm chasers degrees of involvement, philosophies, and techniques vary widely, but many chasers spend a significant amount of time [[weather forecasting|forecasting]]; both before going on the road as well as during the chase, using a variety of sources for weather data.  Most storm chasers are not meteorologists, and many chasers expend significant time and effort in learning meteorology and the intricacies of severe convective storm prediction through both study and experience.\n\n== Dangers ==\nThere are inherent dangers involved in pursuing hazardous weather.  These range from lightning, tornadoes, large hail, flooding, hazardous road conditions (rain or hail-covered roadways), animals on the roadway, reduced visibility from heavy rain (often wind blown), and [[hail fog]].  Most directly weather-related hazards such as from a tornado are minimal, if the storm chaser is knowledgeable and cautious.  Tornadoes affect a relatively small area and are predictable enough to be avoided if a safe distance is maintained.  Lightning, however, is an unavoidable hazard.\n\nThe most significant hazard actually is driving, which, in itself, is a statistically dangerous activity that is exacerbated by the [[severe weather]].  Adding still more to this hazard are the copious distractions that can be vying for a chasers attention such as driving, communicating to chase partners and to others with a phone and/or radio, navigating, watching the sky, checking weather data, and shooting photos or video.  Again here, prudence is paramount in minimizing the risk.  Chasers ideally work to prevent the driver from multi-tasking either with chase partners covering the other aspects or with the driver pulling over to do these other things if he/she is chasing alone.\n\n== Seasonal activity ==\nStorm chasers are most active in the spring and early summer, particularly May and June, across the [[Great Plains]] of the [[United States]] (extending into [[Canada]]), with perhaps a few hundred individuals active on any given day during this period.  This coincides with the most consistent tornado days in the most desirable topography of the Great Plains.  Not only are the most intense [[supercell]]s common here, but because of the moisture profile of the atmosphere, the storms tend to be more visible than locations farther east where there are also frequent severe thunderstorms.  There is a tendency for chases earlier in the year to be farther south, shifting farther north as the season progresses.  Storms occurring later in the year tend to be more isolated and slower moving, both of which are also desirable to chasers.\n\nChasers may operate whenever significant thunderstorm activity is occurring; whatever the date.  This most commonly includes more sporadic activity occurring in warmer months of the year bounding the spring maximum, such as the active month of April; and farther north especially, the summer months.  An annually inconsistent and substantially smaller peak of severe thunderstorm and tornado activity also arises in the transitional months of autumn, particularly October and November.\n\nSome organized chasing efforts have also begun in the [[Top End]] of the [[Northern Territory]] and in southeast [[Australia]],<ref>{{cite news | last = McLaughlin | first = Murray  | title = Storm chasers hit Top End | work = Australian Broadcasting Corporation | publisher = 7.30 Report | date = 2003-12-17 | url = http://www.abc.net.au/7.30/content/2003/s1012266.htm | accessdate = 2008-10-04}}\n</ref><ref>{{cite news  | last = Krien | first = Anna | title = Weather from hell is heaven on earth for storm troops | work = Fairfax Digital | publisher = The Age | date = 2004-07-04 | url = http://www.theage.com.au/articles/2004/07/03/1088488200242.html | accessdate = 2008-10-04}}</ref> with the biggest successes in November and December.  A handful of individuals are also known to be chasing in other countries, including [[Israel]], [[Italy]], [[Spain]], [[France]], [[Belgium]], [[Germany]], [[Finland]], [[the Netherlands]], [[Switzerland]] and [[New Zealand]]; although many people trek to the Great Plains of [[North America]] from these and other countries around the world (especially from the [[United Kingdom]]).\n\n== Equipment ==\nMost storm chasers will vary with regards to the amount of equipment used, some prefer a minimalist approach; for example, where only basic photographic equipment is taken on a chase, while others use everything from satellite based tracking systems and live data feeds to vehicle mounted weather stations.\n\n=== Historic ===\n[[Image:Top of NSSL chase vehicle.jpg|thumb|Top of a [[National Severe Storms Laboratory|NSSL]] chase vehicle showing A/C unit, compass, and [[Global Positioning System]].]]\nHistorically, storm chasing relied on either in field analysis or in some cases now-casts from trained observers.  The first in-field technology consisted of radio gear for communication.  Much of this equipment could also be adapted to receive [[radiofax]] data which was useful for receiving basic observational and analysis data.  The primary users of such technology were university research groups who often had larger budgets than individual chasers.\n\nRadio scanners were also heavily used to listen in on [[emergency services]] and storm spotters so as to determine where the most active or dangerous weather was located.  A number of chasers were also [[Amateur radio operator|radio amateurs]], and used mobile (or portable) [[amateur radio]] to communicate directly with spotters and other chasers, allowing them to keep abreast of what they could not themselves see.\n\nIt was not until the mid to late 1980s that the evolution of the [[laptop computer]] would begin to revolutionize storm chasing.  Early on, some chasers carried [[acoustic coupler]]s to download batches of raw surface and upper air data from payphones.  The technology was too slow for graphical imagery such as [[Weather radar|radar]] and [[Weather satellite|satellite]] data; and during the first years this wasnt available on any connection over telephone lines, anyway.\n\nMost meteorological data was acquired all at once early in the morning, and the rest of days chasing was based on analysis and forecast gleaned from this; as well as on visual clues that presented themselves in the field.  Occasionally chasers would make stops at rural airstrips or NWS offices for an update on weather conditions.  [[NOAA Weather Radio All Hazards|NOAA weather radio]] could provide information in the vehicle, without stopping, such as [[Severe weather terminology (United States)|weather watches and warning]]s, surface weather conditions, [[Storm Prediction Center#Convective outlooks|convective outlook]]s, and NWS radar updates.  Nowadays, storm chasers may use high-speed Internet access available in any library, even in the smallest towns in the US.  This data is available throughout the day, but one must find and stop at a location offering Internet access.\n\nWith the development of the mobile computers, the first in computer mapping software was made available, at about the same time the [[VHS]] [[camcorder]] began to grow in popularity rapidly.  Prior to the mid to late 1980s most motion picture equipment consisted of [[8 mm film]] cameras.  While the quality of the first VHS consumer cameras was quite poor (and the size somewhat cumbersome) when compared to traditional film formats, the amount of video which could be shot with a minimal amount of resources was much greater than any film format at the time.\n\nThe 1990s marked the first technological leaps and bounds.  With the quick development of solid state technology, television sets for example could be installed in most vehicles with ease allowing storm chasers to actively view local TV stations.  Mobile phones became popular making group coordination easier when traditional radio communications methods were not adequate.  The development of the public Internet in 1993 allowed [[File Transfer Protocol|FTP]] access to some of the first university weather sites.\n\nThe mid 1990s marked the development of smaller more efficient marine radars.  While such marine radars are illegal if used in land-mobile situations, a number of chasers were quick to adopt them in an effort to have mobile radar.<ref>[http://www.tornadochaser.com/radar.htm Portable Radar For Chasers<!-- Bot generated title -->]</ref>  These radars have been found to interfere with research radars, such as the [[Doppler On Wheels]] utilized in field projects.  The first personal [[Lightning detector|lightning detection]] and mapping devices also became available<ref>[http://www.boltek.com BOLTEK Lightning Detectors<!-- Bot generated title -->]</ref> and the first online radar data was offered by private corporations often with a delay for free services.\n\n=== Current ===\nA major turning point was the advent of civilian [[Global Positioning System|GPS]] in 1996.  At first, GPS units were very costly and only offered basic functions, but that would soon change.  Towards the late 1990s the Internet was awash in weather data and free weather software, the first true cellular Internet modems for consumer use also emerged providing chasers access to data in the field without having to rely on a nowcaster.  The NWS also released the first free, up to date [[NEXRAD]] Level 3 radar data.  In conjunction with all of this, GPS units now had the ability to connect with computers, allowing greater ease when navigating.\n\n2001 marked the next great technological leap for storm chasers as the first [[Wi-Fi]] units began to emerge offering wireless broadband service in many cases for free.  In 2002, the first [[Microsoft Windows|Windows]]-based package to combine GPS positioning and Doppler radar appeared called  [http://www.swiftwx.com/ SWIFT WX].  SWIFT WX allowed storm chasers to position themselves accurately relative to tornadic storms while mobile.\n\nIn 2004, two more storm chaser tools emerged.  The first was a new [[XM Satellite Radio]] based [http://www.wxworx.com/ system] utilizing a special receiver and Baron Systems weather software.  Unlike pre-existing cellular-based services there was no risk of dead spots, and that meant that even in the most remote areas storm chasers still had a live data feed.  The second tool was a new piece of software called [http://www.grlevelx.com/ GRLevel3].  [[Grlevelx|Grlevelx]] utilized both free and subscription based raw weather radar files, displaying the data in a true vector format.\n\nThe most common chaser communications device is the cellular phone.  These are used for both voice and data connections.  It is not uncommon that chasers travel in small groups of cars, and may use [[Citizen Band]] radios (declining in use) or inexpensive [[General Mobile Radio Service|GMRS]] / [[Family Radio Service|FRS]] hand-held [[transceiver]]s for inter-vehicle communication.  More commonly, many chasers are also [[amateur radio]] operators and use the [[2 meters]] [[Very high frequency|VHF]] and, less often, [[70 centimeters|70 cm]] [[Ultra high frequency|UHF]] bands to communicate between vehicles or with [[SKYWARN]] spotter networks.  Scanners are often used to monitor spotter and sometimes public safety communications.\n \nIn-field environmental data is still popular among some storm chasers, especially temperature, moisture, and wind speed data.  Many have chosen to mount weather stations atop their vehicles.\n\nChasers have heavily utilized still [[photography]] since the beginning.  [[Videography]] gained prominence by the 1990s into the early 2000s but a resurgence of photography has occurred with the advent of affordable and versatile [[Digital single-lens reflex camera|digital SLR]] [[Still camera|cameras]].  Prior to this, [[35 mm film|35 mm]] [[Photographic film|print]] and [[Reversal film|slide]] [[film format]]s were mostly used, along with some [[Medium format (film)|medium format]] cameras.\n\n== Ethics ==\nA growing number of experienced storm chasers believe in the installation of a code of ethics in storm chasing featuring safety, courtesy, and objectivity as the back bone<ref>[http://www.cimms.ou.edu/~stumpf/cethics.html Storm Chase Ethics]</ref><ref>[http://www.cimms.ou.edu/~doswell/Chasing2.html Storm Chasing with Safety, Courtesy, and Responsibility]</ref>.  Storm chasing is a highly visible recreational activity (which is also associated with science) that is vulnerable to sensationalist media promotion<ref>[http://www.stormtrack.org/library/faq/#Ethics The Online Storm Chasing FAQ]</ref>.  Veteran storm chasers [[Chuck Doswell]] and Roger Edwards have deemed reckless storm chasers as Yahoos<ref>[http://www.stormeyes.org/tornado/yahoo.htm The Reality of Storm Chase Yahoos<]</ref>.  Doswell and Edwards believe poor chasing ethics at TV news stations add to the growth of Yahoo storm chasing\n<ref>[http://www.stormeyes.org/tornado/media.htm Irresponsible Media Storm Chase Practices]</ref>.  Self policing is seen as the means to mold the hobby.\n\n'
p58
tp59
a(I1
S'[[Image:livesteam.jpg|thumb|A hand-crafted, coal-fired, 1:8 scale [[2-10-0]] live steam locomotive in 7-1/4 gauge, built in 14,000 hours over a period of 15 years.]]\nHomebuilt- a term meaning the machine that was built outside of specialised workshop or factory. It can mean different things such as [[kit car]]s or [[homebuilt computer]]s, but normally it pertaines to homebuilt aircraft, also known as amateur-built aircraft or kit planes. [[Homebuilt aircraft]] or kit cars are constructed by persons for whom this is not a professional activity. Homebuilt computers have been built at home for a long time, starting with the [[Victorian era]] pioneer [[Charles Babbage]] in the 1820s. A century later, [[Konrad Zuse]] built his own machine when [[electromechanical]] [[relay]] technology was widely available. The hobby really took off with the early development of [[microprocessors]], and since then many enthusiasts have constructed their own computers. \nHomebuilt vehicle is a wider concept than a kit car. Homebuilt vehicle is a motor vehicle (car, truck or motorcycle) that is built by an individual instead of a manufacturer.<ref>[http://www.dmv.ri.gov/inspections/kit%20vehicles.php Rhode Island Division of Motor Vehicles : Salvage]</ref>\nThese machines may be constructed from scratch, from plans, or from assembly kits. Outside of USA (for example in Russia) persons wishing to built such complex machinery often have no professional networks to rely on for spare parts, plans and /or advise in the matter and therefore have to rely on their ingenuity and intuition in order to build machine that works.\n\n== Examples of home-built machinery ==\n*[[Amateur radio homebrew]] -Homebrew is an [[Amateur radio]] slang term for home-built, noncommercial radio equipment.<ref>[http://www.dxing.com/radioterms.htm Radio Terms and Abbreviations<!-- Bot generated title -->]</ref>\n*[[Amateur telescope making]]- The field of  amateur telescope making is considered an offshoot of the [[amateur astronomy]] community. Amateur [[telescope]] makers (sometimes called ATMs), as their name implies, are not paid professionals. They build their telescopes for the enjoyment of the [[hobby]], or so they can make a personal contribution to the field of [[astronomy]].\n*[[File:ElLoboDuneBuggy.jpg|thumb|Custom made dune buggy]][[Dune buggy]]- popular method of building a dune buggy involves construction of a vehicle frame from steel tubing formed and welded together. The advantage of this method is that the fabricator can change fundamental parts of the vehicle (usually the suspension and addition of a built-in roll cage). Buggies of this type are called [[sandrail]]s because of the rail frame. Sandrails, as with the VW Bug, often have the engine located behind the driver. Sizes can vary from a small engined one seat size to 4 seat, 8+ cylinder vehicles. Sandrails can have panels or custom shaped body coverings over the rails and tubing that comprise the vehicle, though many are left bare.\n*[[Amateur rocketry]] sometimes known as amateur experimental rocketry or experimental rocketry is a hobby in which participants experiment with fuels and make their own [[rocket]] motors, launching a wide variety of types and sizes of rockets. Amateur rocketeers have been responsible for significant research into [[hybrid rocket]] motors, and have built and flown a variety of solid, liquid, and hybrid propellant motors. On May 17, 2004 [[Civilian Space eXploration Team]] (CSXT) successfully launched the first amateur high-power rocket into space, achieving an altitude of 72 miles (115 km).<ref>CSXT web site: http://www.civilianspace.com/about/default.asp</ref> Prior to that the [[Reaction Research Society]] on November 23, 1996 launched a solid fueled rocket, designed by longtime member George Garboden, to an altitude of 50 miles (80 km) from the [[Black Rock Desert]] in Nevada.<ref>http://www.hobbyspace.com/Rocketry/Advanced/records.html</ref>\n*[[Stitch and glue]] -is a simple boat building method which uses plywood, epoxy glue, and stitches and eliminates the need for stems and chines. <ref>[http://www.glen-l.com/resources/glossary.html Boat terms]</ref> Plywood panels are cut to detailed profiles and stitched together to form an accurate hull shape, without the need for forms or special tools. This technique is also called tack and tape, and stitch and tape.\n\n===Gallery===\n<gallery>\nImage:BowersFlyBabyCF-DSH.JPG|A typical wood and fabric construction amateur-built, the [[Bowers Fly Baby]].\nImage:PietenpolAirCamperUncovered.JPG|A [[Pietenpol Air Camper]] under construction, showing the wooden frame structure that will be covered with aircraft fabric.\nFile:    025.jpg]]\nFile:    039.jpg|Homebilt guns from the USSR\nFile:    021.jpg|[[Borz]] a weapon of insurgency thats buld in tiny workshops which can qualify it as homebult weapon\nImage:Carsten-planert14.jpg|Fiberfab FT Bonito, a kit-car on a [[Volkswagen Beetle|VW Beetle]] chassis.\nImage:Locostframe.jpg|[[Locost]] frame and body panels.\nImage:Canoe stitch and glue.jpg|A stitched canoe hull under construction.\n</gallery>\n\n'
p60
tp61
a(I1
S'{{refimprove|date=September 2009}}\n{{Orphan|date=February 2009}}\nThe term Entrepreneur of Life reflects a basic [[trend]] in todays [[society]] which demands people to take on a more active role in life, i.e. in all of lifes dimensions. As traditional patterns of living and [[decision making]] increasingly lose their power to provide individuals with a sense of orientation and security, while the number of options and alternative courses of action to choose from is rising, more and more decisions and choices are left to the individual. The erosion of relieving certainties and institutions does not only open up the potential of increased opportunities to design and create ones own life but it is inevitably linked to an increasing (formal) pressure to actively organize and manage life, a need for self-governing.\n\nThis double-edged and ambivalent process of [[modernization]] provides individuals with growing liberties when it comes to deciding how to shape and create their lives (contents), but at the same time they are less and less free to decide whether to do so (form) and  in this sense  whether they want to act as an entrepreneur of life.\nHence, by transforming obligations and traditions into options  some among a number of multiple options that can be chosen , processes of [[individualization]] create the basic conditions for being an entrepreneur of life. But as the motor of the dynamics of [[civilization]] they also tend to transform life in all its length and breadth pushing it into a direction, which causes individuals to act more and more as entrepreneurs of life, as the necessity to decide and to choose, to shape and create ones life increases.\n\nThe term Entrepreneur of Life explicitly makes reference to the historic figure of the entrepreneur as a founder and leader suggesting that the Entrepreneur of Life and his classic counterpart should have certain essential qualities in common: he actively and consciously creates, designs and shapes his own life, takes direct responsibility for his actions, and is very self-motivated, which comprises not only the ability to and the process of action but also the will or determination to act. In this sense, the entrepreneur of life is basically the creator/designer of his own life, actively shaping the basic framework of his life  as opposed to passive reaction.\n\n'
p62
tp63
a(I1
S'[[Image:Bordeaux Cover.jpg|thumb|325px|Bordeaux Cover with [[Mauritius]] 1d Orange-red and the 2d Deep Blue [[Mauritius Post Office|Post Office]] auctioned for [[Swiss franc|CHF]] 5,750,000 in 1993]]\n\nDavid Feldman (b. [[Dublin]], 1947) is a professional [[philately|philatelist]], [[author]] and [[auctioneer]], chairman of David Feldman SA, a [[Geneva]] based philatelic auction company that has attained record prices for some of the most famous [[postage stamps]] of the world. In 1993 Feldman auctioned the Bordeaux Letter with both the [[Mauritius Post Office|1d Orange-red and the 2d Deep Blue]] Post Office Mauritius stamps on [[cover (philately)|cover]]; this brought 5,750,000 [[Swiss Franc]]s<ref>Total price paid by seller includes buyers 15% commission &mdash; hammer price was 5 million Swiss Francs</ref> (roughly $4 million USD, GB 2.64 million),<ref>{{Citation  | last =   | first =  | author-link =  | last2 =  | first2 =  | author2-link =  | title = Prices Realised: Public Auction November 1&ndash;6, November 1993  | publisher = David Feldman SA | pages = p 3 | date = November 1993  | url = }}</ref> the highest price ever paid for any philatelic item<ref>{{cite news  | last = Watkins | first =  David | title = Stamp Of Greatness | work =  | pages = C5&ndash;C6 | language = English | publisher = South China Morning Post | date = 2004-02-03 | url = http://www.davidfeldman.com/PDF_2003/China_Stamp_Greatness.pdf | accessdate = 2007-07-21 }}</ref><ref>[http://www.encyclopedia.mu/Society/Communication/Stamps/BordeauxCover.htm  The Bordeaux Letter, Encyclopaedia Mauritiana]</ref>.\n\n==Ireland==\nHis early life was in Dublin, [[Republic of Ireland|Ireland]], where he started a stamp exchange scheme with school classmates at eight years of age.  By 1958 this had become The Shamrock Stamp Club, a [[mail order]] sales business promoted by advertising in [[Mickey Mouse]] comics. Irish philately was his speciality; the first specialised [[stamp catalogue]], Stamps of Ireland debuted in 1964 and in 1967 he held his first specialised Irish stamp auction. When the Handbook of Irish Philately was published in 1968, Feldman presented a copy to the [[President of Ireland]], [[amon de Valera]]. \n\nBy the 1970s, a bullish stamp market led to a great increase in stamp prices; so much so, that Feldman states: You just could not get enough stamps to sell. During this period he started David Feldman Ltd., became an auctioneer and philatelic author, and  published the DF Newsletter, an Irish philatelic publication along with other specialised books. He also promoted three public stamp exhibitions in Dublin before becoming chairman of Stampa 1972, the first Irish National Stamp Exhibition.<ref name=emerald>{{cite book  | last = Feldman | first = David | title = The Emerald Collection of Destination Mail of the World | publisher = David Feldman SA | date = February 2003 | location = Geneva, Switzerland | pages = pp 10&ndash;11 | url =  | doi =  | id =   | isbn = }}</ref> David Feldman was a member of the Irish [[Minister for Posts and Telegraphs (Ireland)|Minister for Posts and Telegraphs]] Philatelic Advisory Committee from 1975&ndash;1981 with [[Robson Lowe]] and other distinguished philatelists.<ref name=emerald/> \n\n==Switzerland==\n[[Image:Gul tre skilling banco.jpg|thumb|150px|right|World record priced [[Treskilling Yellow]] auctioned for $2.2 million in 1996 by David Feldman]]\n\nLater, having met a Swiss girl who was on a cycling holiday to Ireland, he moved to Switzerland in 1973<ref>{{cite book  | last = Feldman | first = David | title = The Emerald Collection of Destination Mail of the World | publisher = David Feldman SA | date = February 2003 | location = Geneva, Switzerland | pages = p 6 | url =  | doi =  | id =   | isbn = }}</ref>.  He has continued to operate as a stamp auctioneer and publisher since then, starting a new auction business and running his first auction there in 1976.<ref name=emerald/> Some of the record prices achieved by David Feldman SA have been for the [[Sweden|Swedish]] [[Treskilling Yellow]] ($2.2 million in 1996), for which his photo appeared in the [[Guinness World Records|Guinness Book of World Records]], and the [[Mauritius]] [[Mauritius Post Office|Two Pence Blue]] ($1.4 million in 1993) stamps.\n\nIn 1997, David Feldman was invited to sign the Irish Roll of Distinguished Philatelists for his support and contributions to Irish philately. David auctioned off one of his personal collections in  May 2003; The Emerald Collection of Destination Mail of the World contained mail to and from Ireland dating from 1714&ndash;1913 accumulated over about forty years. The collection realised around $2 million.<ref>{{cite web | title = Prices Realised May 2003 | work =  | publisher = David Feldman SA | date =  | url = http://www.davidfeldman.com/PR/031/pr_031.pdf | format = pdf | doi =  | accessdate =  2007-07-21 }}</ref>\n\nTwo auctions have been surrounded by some controversy. The disposal of the [[United Nations]] Stamp Archive in May 2003 for more than $3 million was still under investigation in 2006 and may well have taken place without the permissions required by the regulations of the U.N. Secretariat for the disposal of such important U.N. property because no official consent forms seem to exist as required under Secretariat 1991 rules for the disposal of archival material. The material was the archive [[United Nations Postal Administration]], UNPA, apparently regarded as surplus to the requirements of the UN Postal Museum. The purchase of the complete archive as one auction lot by Arthur Morowitz, CEO of Champion Stamp Collection,<ref>{{cite web | title = Champion Sells United Nations Postal Archives | work =  | publisher = Championstamp.com | date =  | url = http://www.championstamp.com/unarchives.htm | format = | doi =  | accessdate =  2007-07-23 }}</ref> and the subsequent sale of a small portion of the archive by Greg Manning Auctions, for about $1.2 million considerably more than the original Feldman sale raised questions about the disposal. There has not been any allegation of impropriety on Feldmans part.<ref>{{cite web  | last = Russell | first = George | coauthors = Claudia Rosett | title = United Nations Probes Sale of Irreplaceable Stamp Archive | work =  | publisher = FOX News | date = 2006-04-26 | url = http://www.foxnews.com/story/0,2933,193181,00.html | format = | doi =  | accessdate =  2007-07-23 }}</ref> \n\nPart of the Hlio Courvoisier, Swiss stamp printing company, archive auctioned in April 2007 by Feldman included five lots of [[San Marino]] imperforate stamps, drawings and print proofs. The San Marino philatelic bureau expressed their surprise that these items appeared at auction because archives prove that Hlio Courvoisier SA had destroyed all the print proofs and other print material relating to our products. They allege the material may belong to the Republic of San Marino or may have dubious origin. Feldman assured Stamp & Coin Mart that the consignor had both the title and right to sell the material.<ref>{{cite web  | last = | first = | coauthors =  | title = San Marino astonished at stamp sale | work =  | publisher = Stamp & Coin Mart | date = 2006-04-26 | url = http://72.14.205.104/search?q=cache:45pU4P0cBHIJ:www.stampmart.co.uk/news/san.asp+%22david+feldman%22+philately | format = | doi =  | accessdate =  2007-07-23 }}</ref>\n\n==Publications==\n(incomplete list)\n* {{cite book | first=David | last=Feldman | year=1968 | title=Handbook of Irish Philately | publisher=David Feldman Ltd & the Dolman Press Ltd   | location = Dublin, Ireland }}\n* {{cite book | last = Feldman  | first = David  | title = Stamps of Ireland, Price List | publisher = David Feldman Ltd | date = 1970  | location = Dublin, Ireland }}\n* {{cite book | last = Feldman  | first = David | title = Ireland - Railway Letter Stamps - Price List | publisher = David Feldman Ltd | date = 1973 | location = Dublin, Ireland }}\n* {{cite book | last = Feldman  | first = David | title = The Revenue Stamps of Ireland | publisher = David Feldman Ltd | date = c 1975| location = Dublin, Ireland }}\n* {{cite book | last = Feldman  | first = David | title = Stamps of Ireland, Illustrated Catalogue | publisher = David Feldman Ltd | date = 1974 | location = Dublin, Ireland }}\n* {{cite book | first=David | last=Feldman | coauthors=Kane, William | year=1975 | title=Handbook of Irish Postal History to 1840 | publisher=David Feldman Ltd, Dublin, Ireland | isbn= 0950261912}}\n* {{cite book | last = Feldman  | first = David | title = Stamps of Ireland, Illustrated Catalogue | publisher = David Feldman Ltd | date = 1976 | location = Dublin, Ireland }}\n\n* Numerous specialised and general auction catalogues\n\n'
p64
tp65
a(I1
S'{{unreferenced|date=June 2009}}\n{{otheruses}}\n\n[[File:Ny-worldfair1939-noaudio.ogg|thumb|220px||Home movie made at the [[1939 Worlds Fair]] in New York.]]Home movies are [[film|motion picture]]s made by [[amateurs]], often for viewing by family and friends. When the hobby began, home movies were produced on [[photographic film]], but availability of [[camcorder|video cameras and camcorder]]s and [[data storage device|digital storage device]]s has made the making of home movies easier and more affordable to the average person. The boundaries between consumer movie-making and professional movie-making are becoming increasingly blurred as [[prosumer]] equipment often offers features previously only available on professional equipment.\n\nIn recent years, clips from home movies have been available to wider audiences through television series such as [[Americas Funniest Home Videos]], in [[Great Britain]] [[Youve Been Framed!]] and Internet online video-sharing sites such as [[YouTube]]. The popularity of the Internet, and wider availability of high-speed connections has provided new ways of sharing home movies, such as video weblogs ([[vlog]]s), and [[video podcast]]s.\n\n==History==\n[[File:Bonnie and Clyde death scene.ogg|thumb|220px|Home movie (with professional narration) of [[Bonnie and Clyde]] death scene (1934).]]The development of home movie-making has depended critically on availability of equipment and media formats (film, videotape, etc.) at prices affordable to consumers.\n\nDevelopment of [[list of film formats|film formats]] suitable for amateur hobbyists began early in the history of cinematography.  For example, the 17.5 mm Birtac format was patented by [[Birt Acres]] in 1898. This format split the standard 35 mm film into two strips half as wide and was able to be loaded into the camera in daylight. Since the frames were also half the height of 35 mm frames, the Birtac format used only 25% of the amount of film stock used by 35 mm.  Since the camera doubled as a printer and projector, equipment costs were also reduced.\n\n===Safety film and the 16 mm film format===\nAnother breakthrough in making film practical for home users was the introduction of [[safety film]] in the 1920s. Earlier [[cellulose nitrate#Nitrate film|nitrate film]] required special handling and storage, even after it was exposed and developed, since it is extremely flammable and has even been known to spontaneously catch fire as it gets older.\n\nMany competing film formats were introduced in the early decades until 16 mm safety film was introduced by [[Eastman Kodak]] in 1923 and became a standard in the non-professional market.  Although 16 mm had the advantage of users not being tied to one equipment manufacturer and there were obvious cost advantages compared to standard 35 mm, it was never able to eliminate smaller formats and it eventually was relegated to professional users, particularly in the education market.\n\n===8 mm film format and color===\n[[File:Zapruder Camera.gif|thumb|220px|Bell & Howell Zoomatic camera used by Abraham Zapruder that recorded the assassination of john F. Kennedy.]]In 1932, Kodak introduced another new format, [[8 mm film|8 mm]] (now known as Regular 8 or Straight 8), by slitting 16 mm film in half, again reducing by 75% the amount of film stock used per frame.  This was the point at which home movies finally came within reach of the average family, and the smaller format allowed for much smaller and more portable cameras and projectors.\n\nThe introduction of [[Kodachrome]] color [[reversal film]] for 16 mm in 1935, and for 8 mm in 1936, facilitated home color cinematography.  The availability of reversal film (Kodachrome was not the first) was very important to the home movie-making market, since it avoided the expense of separate negatives and positive prints.\n\n===Super 8 and Single-8 film formats===\nAlthough developments in fine-grained film made Regular 8 mm film practical, it was largely superseded shortly after Kodaks 1965 introduction of [[Super 8 mm film|Super 8]] film. The Super 8 format used the same film width as Regular 8, but the perforations were smaller, allowing for a larger frame size yielding frames with less grain. In addition, Super 8 film came in cartridges for easier loading into the camera. A competing format from [[Fujifilm]] ([[Single-8]]) was also introduced in 1965 and used similar film, but in a different type of cartridge.\n\n===Home video-making===\nThe introduction of the [[Betamax|Beta]] VCR in 1975 and [[VHS]] in 1976 heralded a revolution in the making of home movies.  Videocassettes were extremely inexpensive compared to film and they could even be erased.  It took a few years before home video cameras and [[portable VCR]]s were introduced, and later combined to create [[camcorder]]s, but by that time, many consumers already had the playback equipment in their homes.\n\n==Omnipresence and controversy==\n[[Image:Kingbeating.jpg|thumb|Still images from home video of the beating of [[Rodney King]] by police.]]\nPortability and small size of digital home movie equipment, such as [[camera phone]]s and [[personal digital assistant|PDAs]] with video capabilities, has led to the banning of such devices from various places, due to privacy and security concerns.\n\n[[Pornography|Pornographic]] movies of celebrities have been rumoured to exist for many years, but the ease of creating home movies on video has resulted in several [[celebrity sex tape]]s becoming available to the public, often without the permission of participants. The [[honeymoon]] video of [[Pamela Anderson]] and [[Tommy Lee]] from 1998 was the first highly publicized example.\n\nPortability of digital equipment helps fuel other controversies as well, such as the incident on [[November 17]], [[2006]] in which comedian [[Michael Richards]] got into a racist war of words with an audience member during his comedy club act. Large parts of the incident were captured on the camera phone of another audience member and broadcast widely.\n\nHome movies have played important roles in controversial police investigations, a prime example being the [[Zapruder film]] of the 1963 assassination of U.S. President [[John F. Kennedy]] shot using an 8 mm home movie camera on [[Kodachrome]] II 8 mm safety film. This film was published and broadcast extensively and became official evidence for the [[Warren Commission]], which was established to investigate the assassination.\n\nAnother famous crime-related home movie showed the confrontation between police and [[Rodney King]] on [[March 3]], [[1991]] in Los Angeles. A nearby witness who was trying out his new video camera captured most of the incident on videotape. The tape became the prime focus during the trial of four officers charged with using excessive force during the incident. The prosecution lawyers believed that the tape spoke for itself in showing the officers guilt, but the defense lawyers were able to convince the jury using frame-by-frame analysis of the tape that proper police procedure was followed. The acquittal of the police sparked the [[1992 Los Angeles riots]], resulting in extensive damage and over 50 people being killed. A later trial found two of the officers guilty.\n\n'
p66
tp67
a(I1
S'[[Image:Aquarium - dried food2.jpg|thumb|right|250px|Various types of prepared fish food]]\nFish food is [[plant]] or [[animal]] material intended for consumption by pet [[fish]] kept in [[aquariums]] or [[ponds]]. Fish foods normally contain [[Macronutrient (nutrition)|macro nutrients]], trace [[Micronutrient|elements]] and [[vitamins]] necessary to keep captive fish in good health. Approximately 80% of [[fishkeeping]] hobbyists feed their fish exclusively prepared foods that most commonly are produced in flake, pellet or tablet form.<ref name=baensch>{{cite book |last=Riehl |first=Rdiger. Editor. |coauthors=Baensch, HA |title=Aquarium Atlas |year=1996. 5th Edn. |publisher=Tetra Press |location=Germany |isbn=3-88244-050-3}}</ref> Pelleted forms, some of which sink rapidly, are often used for larger fish or bottom feeding species such as [[loaches]] or '
p68
tp69
a(I1
S'{{Refimprove|date=March 2009}}\n{{portal|Aquarium Fish|Pterois antennata-3.jpg|boxsize=50}}\nFlowerhorn [[cichlid]]s are ornamental [[aquarium]] fish noted for their vivid colors and the distinctively shaped heads for which they are named. Their head protuberance, or kok, is formally termed a [[nuchal lines|nuchal]] hump. Like [[blood parrot cichlid]]s, they are [[Cichlid#Hybrid cichlids and selective breeding|man-made hybrids]] that do not exist in nature. First developed in [[Malaysia]] and [[Taiwan]], they are now kept by [[fishkeeping|fish hobbyists]] worldwide. Some critics have questioned the impact of flowerhorn breeding programs.\n\n== Origin ==\n\nFlowerhorn breeding dates from 1993.<ref name=craze>[http://www.flowerhorncraze.com/Flowerhorn-101-t43104.html Flowerhorn 101, A Guide to Flowerhorn Strains and Types.]</ref> Malaysians admired fishes with protruding heads, known as Karoi or warships, found in the western part of the nation. The slightly protruding forehead and long tail of these fish were prized in Taiwanese society as bringing luck in [[geomancy]]. By 1994, the [[red devil cichlid]] (genus [[Amphilophus]]) and  the hybrid [[blood parrot cichlid]] had been imported from Taiwan to Malaysia and bred with these native fish, marking the birth of the flowerhorn.{{Dubious|date=October 2009}}\n\nIn 1995, the blood parrots were further crossbred with the Human Face Red God of Fortune, which produced a new breed called the Five-Colors God of Fortune.<ref name=craze/> With its beautiful colors, this fish quickly became popular. Selective breeding continued through 1998, when the Seven-Colors Blue Fiery Mouth (also known as Greenish Gold Tiger) was imported from Central America, and crossbred with the Jin Gang Blood Parrot from Taiwan.<ref name=craze/> This crossbreeding led to the first generation of Hua [[Luohan|Luo Han]] flowerhorn hybrids, which were then followed by subsequent flowerhorn introductions.\n\n=== Arrival in the West ===\n\nWhen flowerhorns were first imported to the United States, there were only two breeds of these fish for distribution, flowerhorn and golden base.<ref name=craze/> Flowerhorns came in two varieties, those with pearls (silver-white spots on the skin) and those without. Golden bases also had two varieties, those that faded and those that did not. Among the flowerhorns, the ones without pearls were quickly overtaken in popularity by those with pearls, becoming pearl scale flowerhorns, or Zhen Zhu. With the golden bases, the unfaded ones developed an attractive golden skin in place of what had been the flowerhorns grey skin.\n\nAs of 1999, there were four strains of flowerhorn available in the American market: regular flowerhorns, pearl scale flowerhorns, golden flowerhorns, and faders.<ref name=craze/> Commercial breeders proliferated, and fish were selected for appearance with little regard for terminology.<ref name=craze/> Consequently, names became confusing and parentage became difficult to track.\n\nAround 20002001, the Kamfa variety appeared. These were hybrids of any type of flowerhorn crossed with any species of the genus [[Vieja]] or with any parrot cichlid.<ref name=craze/> These brought in some new traits, such as short mouths, wrapped tails, sunken eyes, and increasingly larger head bumps. Seeing this, those who bred the Zhen Zhus began line breeding their fish to develop faster and become more colorful, in order to compete with the Kamfa strains.<ref name=craze/>\n\n== Care ==\n\nFlowerhorn cichlids are usually kept at a water temperature of 80&ndash;85 F, and a [[pH]] of 7.4&ndash;8.0. They require a large tank (minimum of 50 gallons) to grow. Being aggressive and territorial, two or more flowerhorns are usually not kept together, but the tank housing them can be divided up with acrylic dividers or egg crates.\n\n== Breeds ==\n[[File:Post-77-1231053436.gif|thumb|left|450px|General flowerhorn classification, containing several subsets of strains from different countries and breeders. The parent breed is called [[Luohan]], from the Chinese word for the [[Buddhism|Buddhist]] concept of [[arhat]]. The four main breeds of flowerhorn are Zhen Zhu, Golden Monkey, Kamfa, and Goldenbase Faders.<ref name=craze/>]]\n=== King Kong Parrots and Red Ingots ===\n\nThe blood parrot was the earliest defined type of cichlid hybrid, whereas the King Kong parrot represents an early stage in the transition to flowerhorn breeding.<ref name=craze/> The blood parrot is smaller, with a bigger head, more protruding eyes, and a V-shaped mouth. The King Kong parrot is longer, with a reddish orange color, and a [[dorsal fin]] shorter than the [[anal fin]]. The shape of the King Kong is similar to the red devil cichlid, and when it reaches a size of 18&nbsp;cm, the shape of the mouth changes to a triangle with a more protruding jaw. Only 20% of these fish grow to a size of a half kilogram.<ref name=craze/>\n\nBlood parrots and King Kong parrots are sometimes colored purple or blue by [[painted fish|pigment injection]]. This practice is unhealthy for the fish, and the color will fade with time.<ref name=craze/> Parrot cichlids fed with natural colorants and attractants naturally develop a red color. With further breeding, a round body shape has been selected, with the dorsal fin and anal fin longer than the tail fin, and the mouth can open and close naturally. These fish have clear eyes, and 90% of them grow to 1&nbsp;kg or above, with the characteristic flowerhorn head shape.<ref name=craze/>\n\nThe Red Mommon and Red Ingot breeds are the most typical of these hybrid cichlids. Both of these fishes are appreciated for [[feng shui]].<ref>Arnold W (2003) Singapores lucky pet Luohan can outnumber people in homes. International Herald Tribune. July 1.</ref> The Red Mommon is named for its high forehead, which looks like the hat worn by the God of Fortune. The Red Ingot is named for its yuan-bao shape, referring to odd-shaped gold or silver pieces formerly used as money in China.<ref name=craze/>\n\nThe Red Mommon and Red Ingot grow faster in the first year, with a size of about 20&nbsp;cm. They grow to 25&ndash;28&nbsp;cm by two years later. Their maximum size is not yet known, and it is believed that the fish may grow to 30&nbsp;cm or above in the future. Both of these fish are raised at 28C water temperature, pH ~6&ndash;8 (with slightly acid water preferred), and [[carbonate hardness|kH]] ~3&ndash;6, while avoiding any sudden change in water quality. It is also common to test regularly for [[ammonia]] and [[nitrite]]. Both of these fishes can be bred with different kinds of cichlids.<ref name=craze/>\n\n=== Golden Monkey ===\n[[File:Post-19-1231048027.jpg|thumb|right|274px|Golden Monkey]]\nThe genuine Golden Monkey or Kamalau was bred by Mr. Lam Seah and Lam Soon in Bercham, Ipoh, Malaysia. After the third generation, all of them were sold to the A-1 Aquarium in 2001. This type of flowerhorn is an original Luohan-based fish and not a mixed type Zen Zhu or Kamfa.<ref name=craze/>\n{{clear}}\n\n=== Kamfa ===\n[[File:Post-19-1231048629.jpg|thumb|left|275px|Kamfa]]\nThis breed originated from the Luohan. Its main characteristics are white or yellow eyes (red eyes are possible but not common), a fan tail, a water-colored head bump, sunken eyes, and smaller lips than the Zhen Zhu. This breed generally also has a larger and more square body than that of the Zhen Zhu. Head flowers can be found on the Kamfa, but not as prominently as with Zhen Zhus.\n{{clear}}\n\n=== Zhen Zhu ===\nThis breed originated slightly after the Kamfa, derived from the Luohan. It has a rounded tail, large mouth, red protruding eyes, and a prominent head flower. Zhen Zhu means pearl flowerhorn. This breeds strongest characteristic is pearling. Breeders often cross other types with Zhen Zhus because they breed easily and can create better pearling for the next generation. Weak tails can also carry over, however.<ref name=craze/>\n\n=== Golden Base (Faders) ===\n[[File:Gallery 19 68 148247.jpg|thumb|right|300px|Golden Base]]\nFaders are called by that name because during the juvenile period of life they lose their color and go completely black. As the fading process continues, the black fades away, leaving a more vibrant and beautiful color, usually yellow or red. They are also referred to as golden base or Golden Trimac.<ref name=craze/>\n\n[[cichlid#Hybrid cichlids and selective breeding|Red Texas cichlids]] are related to the golden base family of flowerhorns. They were originally created by breeding a [[Herichthys carpintis|green Texas cichlid]] with a Mammon or King Kong parrot, then crossing the offspring back to the parents until a consistent red color was achieved. Hobbyists consider the most important feature of the red Texas to be the color. Red Texas cichlids range in colors, and are rated as:\n\n* Unfaded: lowest grade of red Texas.\n* Yellow: second lowest grade.\n* Orange: the majority of red Texas fall into this category.\n* Coral: pinkish but not quite full red.\n* Red: most desirable color.\n\nThe second characteristic that sets the red Texas apart is the pearling. Red Texas can vary greatly in terms of the type of pearling.<ref name=craze/>\n\n=== King Kamfa ===\nFrom the Kamfa family, this fish typically has white or yellow eyes, although red eyes are possible but rare. Distinctive features of this breed include an intense black double flower row along the [[lateral line]], and very thick white pearling. Originating in Thailand, this breed has seen a recent rebirth in Vietnam. The body is typical of a Kamfa, with a fan tail, and a longer body than some other Kamfas.<ref name=craze/>\n\n=== Kamfamalau ===\n[[File:Post-19-1231048922.jpg|thumb|left|250px|Kamfamalau]]\nThis is a cross of a Golden Monkey male and a Kamfa female with Malau features. The body and face resemble a typical Golden Monkey (see above). The finnage and sunken eyes reflect the Kamfa genes. The main feature of a Kamfamalau is the pearling. Fins typically take on a frosted pearl look that is rarely found in any other breed of flowerhorn. Pearling usually crosses all the way across the head bump, another rarity in flowerhorn breeds. This breed should display the best characteristics of both Kamfa and Malau.<ref name=craze/>\n{{clear}}\n\n== Strains ==\nA strain is a more specific subset within a particular breed. Strains can get as narrowly defined as all coming from one individual parent fish. Strains can also differ by country of origin and by breeder.\n\n=== JPG or Golden Apple ===\nCreated by Ah Soon of Malaysia, these fish are characterized by a large stocky body, as well as metallic pearling.<ref name=craze/>\n\n=== IndoMalau ===\n[[File:Post-137-1207905651.jpg|thumb|right|300px|Elvis strain]]\nThese were created by the Indonesian Luohan Club (ILC), using a Golden Monkey (or Malau) female and a Zhen Zhu male. The second generation was spawned from the Elvis selection and a Golden Monkey female. The strain is characterized by extensive pearling all over the body, face, and head. What distinguishes an IndoMalaus pearls from that of a Zhen Zhu or a King Kamfa is that they are extremely fine. As the fish ages, the pearls become more intricately woven and thinner. Flowerlines vary dramatically; some only have a few flower spots. Most ILC IndoMalaus will include some singular flowers on the back line or top row. The front half of the fish, from the [[pectoral fin]]s forwards, is red. The back half is a golden gradient intensifying in color towards the tail. The body is very wide and high, a throwback to the original Luohan. There is a very pronounced chin or gobbler. The head is usually forward-protruding.  The tail is fan-shaped, close to that of a Kamfa. The dorsal and anal fins lack trailers, a common trait found also in Zhen Zhu. The [[caudal peduncle]] is very large and pronounced in this strain; this helps prevent development of a drop tail.<ref name=craze/>\n\n[[File:Post-4-1216334880.jpg|thumb|left|250px|Tan King strain]]\n\n=== Tan King ===\nThis strain was created by Mr. Tan of Vietnam, by crossing a Zhen Zhu with a Kamfa. It has pearls and a flowerline like a King Kamfa, but the body and fins are more closely related to the Zhen Zhu. Most have protruding eyes and a more rounded tail like a Zhen Zhu.<ref name=craze/>\n{{clear}}\n== Gallery of early flowerhorn strains ==\n\n<gallery>\nImage:Coronation Link.gif|Coronation Link\nImage:Tornado Effect.jpg|Tornado Effect\nImage:Perfect Harmony.jpg|Perfect Harmony\nImage:Unique Track.jpg|Unique Track\nImage:Absolute Wonder.jpg|Absolute Wonder\nImage:Ancient Warship.jpg|Ancient Warship\nImage:Creative Measure.jpg|Creative Measure\nImage:Exotic Marvel.jpg|Exotic Marvel\nImage:Legacy.jpg|Legacy\nImage:Living Legend.jpg|Living Legend\nImage:Pacific Miracle.jpg|Pacific Miracle\nImage:Quantum Grace.jpg|Quantum Grace\nImage:Rising Rainbow.jpg|Rising Rainbow\nImage:Royal Degree.jpg|Royal Degree\nImage:Scarlet Passion.jpg|Scarlet Passion\n</gallery>\n\n== Criticism ==\n{{POV-section|date=September 2008}}\nFlowerhorns have been criticized by some{{Who|date=July 2009}} cichlid hobbyists and [[environmentalism|environmentalists]] for a number of reasons. Interest in flowerhorns resulted in surplus stock, some of which was dumped in the wild in Malaysia, where they survived and disrupted riverine [[ecosystem]]s.<ref>http://library.thinkquest.org/04oct/01027/environmental.html</ref><ref>http://www.iol.co.za/index.php?click_id=31&art_id=iol1045231471487W253&set_id=1</ref><ref>http://www.aquarticles.com/articles/breeding/Soodhanan_Flowerhorns.html</ref> Criticism has also been made of placing flowerhorns, which are man-made fish, into fish taxa, which are reserved for the identification of species found in nature.{{Citation needed|date=April 2009}} This practice can make identification of similar cichlids difficult. Breeding with pure bloodlines of cichlid species has already occurred in a number of cichlids commonly kept in the hobby, risking loss of genetic material.{{Citation needed|date=April 2009}} Flowerhorn breeding also contributes to the commercial demand for new and different fish, possibly leading to questionable practices, such as breeding for anatomical deformities, as occurred in goldfish breeding.{{Citation needed|date=April 2009}}\n\n'
p70
tp71
a(I-1
S'Fan translation refers to the unofficial [[translation]] of various forms of media by [[fan (person)|fans]], usually into a language in which an official translated version is not available. These translations are distributed for free or at minimal cost. The rise of the [[Internet]] has enabled fan translators to collaborate and distribute their material more effectively, and has therefore led to a large increase in the amount of fan translated material. Fan translations almost always constitute [[copyright infringement]].\n\n==Media==\n[[Image:FF3 comparison 24.png|thumb|200px|Fan translation of [[Final Fantasy III]], a 1990 game popular in [[Japan]] that was not officially released in [[English language|English]] until late 2006.]]\nNotable areas of fan translation include:\n\n*[[Fansub]]  translating and subtitling movies, [[television program]]s and other similar media. For many languages the most popular fan subtitling is of [[Hollywood, Los Angeles, California|Hollywood]] movies and American TV dramas, while fansubs into [[English language|English]] are largely of [[East Asia]]n entertainment, particularly [[anime]] and [[tokusatsu]].\n\n*[[Fan translation of video games]]  this practice grew with the rise of [[video game console]] [[Console emulator|emulation]] in the late 1990s and still mainly focuses on older classic games. These translations are typically distributed as patches that modify the binary files of the original game into new binaries.\n\n*[[Scanlation]]  the distribution of fan translated [[comics]], especially [[manga]], as computer images which have been scanned and translated by fans. An alternative method of distributing fan-translated sequential art is to distribute only the translated text, requiring readers to purchase a copy of the work in the original language.\n\n*Fan translation of written [[fiction]], particularly [[short story|short stories]] but sometimes including full novels.<ref name=harrypotter>[http://www.zonaeuropa.com/20070728_1.htm Self-Organized Citizen Translations of Harry Potter 7], 26 July 2007 (English translation of original Chinese article from yWeekend)</ref>\n\n'
p72
tp73
a(I-1
S'Political positivism is a theory founded by [[Ljubisa Bojic]]. It includes intensive use of media to promote [[Cooperation|unity]], [[participation (ownership)|participation]], and positivism in thinking of common men and women. \n\n==Short explanation==\nGradual [[social change|change]] of individuals results in a big alteration for the [[community]] as a whole. [[Psychology]] is the key to our success. On the other hand, various media can impact great masses of people. Until today, [[politicians]] used TV programs, [[Mass media|press]], and different kind of [[propaganda]] to trigger [[wars]], stimulate hate and impose conflict between people. Optimistic thinking enables us to make the difference together. \n\n===Introduction of the term===\nLet we develop [[positivism]] as a new [[ideology]] - and the only one that cant hurt anybody. Lets alter use of [[Mass media|media]] for the greater reason, said [[Ljubisa Bojic]] during a gathering of Serbian Strengths Movement supporters in [[Kragujevac]] on 24 February 2007.{{Fact|date=March 2008}} He said, this proposition would be introduced to the international community at the [[Young Democratic Leaders Network]] summit in Istanbul (2007).\n\n===Introduction===\nPolitical positivism abides by this philosophy:\n\nCreative media use in needed for education, to increment people rather than to amuse. Entertainment makes 99% of the world news at present. Political positivism, or media positivism includes intensive use of media to promote unity, participation, and positivism in thinking of common men and women. Gradual change of the citizens results in a big change for the society. If we all think optimistic, and have strong will to do something together, we can make the difference.{{Fact|date=March 2008}}\n\n===The roots===\n[[Martin Seligman]] officially initiated the study of [[Positive Psychology]] in 1998, during his term as President of the [[American Psychological Association]]. University of East London was the first in Europe to offer postgraduate diploma in Applied positive psychology as the scientific study of optimal human functioning with an aim to understand the factors that enable individuals and communities to thrive. This rapidly developing field brings solid empirical research into areas such as well-being, [[Flow (psychology)|flow]], positive emotions, human strengths, wisdom, creativity, psychological health and characteristics of positive groups and institutions.{{Fact|date=April 2008}} \n\nLate Serbian Prime Minister Zoran Djindjic offered change in a way of thinking to Serbian citizens. He used to go around the country and tell people that change starts with them. His determination continues to live in todays Serbia. Djindjic said that everyone gets to be a winner of the life battle at birth. Numerous governments, such as Hong Kong, have branding initiatives with notable internal impact. Some of them, broadcast ads which help people in many ways. They bear messages warning viewers to save energy, or help keep clear the city.\n\n===Ministry===\nMinistry of positivism would consist of psychologists and advertisers who would work together as a team. Their main aim is to significant positive influence on citizens lives. Interdisciplinary team of professionals from the ministry would maintain strong relation with the universities where applied positive psychology is examined.\n\n===The Law===\nUsers of public broadcasting licenses would be obliged to provide share of their programs for free. The same goes for the print media, outdoor billboards space etc. New legislation introduced to the parliament would define aspects of media use by the state. \n\n===Assets===\nUniversity of Pennsylvania states that positive psychology is study of positive emotions, positive character, and positive institutions. Variety of assets is to be used to motivate members of society to change themselves. Except special positive TV, radio, paper, and billboard advertisements with general messages, lectures, seminars, tutorials, workshops, group exercises will be offered by the Ministry of positivism.{{Fact|date=March 2008}}\n\n===Types of ads===\n1.\tAdvertisements carrying strong subconscious messages. \n2.\tCreative ads with general slogans aimed to inspire basic human emotions and optimism.\n3.\tNarrow appeals to the public such as: Exercise once daily.\n4.\tThematic short TV, radio shows and newspaper texts embracing tips for better life. \n\n===Applied psychology===\nCharacter Strengths and Virtues (CSV) handbook identifies core virtues, made up of twenty-four measurable character strengths. The organization of these virtues and strengths is as follows:\n1.\tWisdom and Knowledge: creativity, curiosity, open-mindedness, love of learning, perspective\n2.\tCourage: bravery, persistence, integrity, vitality\n3.\tHumanity: love, kindness, social intelligence\n4.\tJustice: citizenship, fairness, leadership\n5.\tTemperance: forgiveness and mercy, humility and modesty, prudence, self-regulation\n6.\tTranscendence: appreciation of beauty and excellence, gratitude, hope, humor, spirituality\n\n='
p74
tp75
a(I-1
S'{{otheruses}}\n{{IPA notice}}\nShibboleth ({{pron-en|bl}}<ref name=OED>{{cite encyclopedia|ency=Oxford English Dictionary|edition=second|year=1989|article=shibboleth}}</ref> or {{IPA-en|bl|}}<ref name=Merriam-Webster>{{cite web|work=[[Merriam-Webster]] Online Dictionary |title=shibboleth |url=http://m-w.com/dictionary/shibboleth}}</ref>) is any distinguishing practice which is indicative of ones social or regional origin.\nIt usually refers to features of language, and particularly to a word whose pronunciation identifies its speaker as being a member or not a member of a particular group.\n[[Image:Grotepier TN.JPG|200px|thumb|Statue of [[Pier Gerlofs Donia]], known for his legendary strength and size and the invention of a famous shibboleth]]\n==Origin==\n\nThe term originates from the [[Hebrew language|Hebrew]] word shibblet ({{lang|he|}}), which literally means the part of a plant containing grains, such as an [[Ear (botany)|ear of corn]] or a stalk of [[grain]]<ref>[[Gerhard Wahrig|Wahrig Deutsches Wrterbuch]], Sixth Edition and {{cite web|work=Meyers Lexikon online |title=Schibboleth |url=http://lexikon.meyers.de/meyers/Schibboleth}} </ref> or, in different contexts, stream, torrent.<ref>{{cite web|work=[[American Heritage Dictionary]], also sometimes rye, Fourth Edition |title=shibboleth |url=http://www.tfd.com/shibboleth}} {{cite web|work=[[Merriam-Webster]] Online Dictionary |title=shibboleth |url=http://m-w.com/dictionary/shibboleth}} (this latter meaning is not in use in [[Modern Hebrew]])</ref><ref>Cf. Isaiah 27:12.</ref> It derives from an account in the [[Hebrew Bible]], in which pronunciation of this word was used to distinguish [[Tribe of Ephraim|Ephraimites]], whose [[dialect]] lacked a {{IPA|//}} sound (as in [[voiceless postalveolar fricative|sh]]oe), from [[Gilead]]ites whose dialect did include such a sound. \n\nIn the [[Book of Judges]], chapter 12, after the inhabitants of [[Gilead]] inflicted a military defeat upon the tribe of [[Tribe of Ephraim|Ephraim]] (around [[1370 BC|1370]]&ndash;[[1070 BC]]), the surviving Ephraimites tried to cross the Jordan River back into their home territory and the Gileadites secured the rivers fords to stop them.  In order to identify and kill these refugees, the Gileadites put each refugee to a simple test:\n\n{{quotation|Gilead then cut Ephraim off from the fords of the Jordan, and whenever Ephraimite fugitives said, Let me cross, the men of Gilead would ask, Are you an Ephraimite? If he said, No, they then said, Very well, say Shibboleth. If anyone said, Sibboleth, because he could not pronounce it, then they would seize him and kill him by the fords of the Jordan. Forty-two thousand Ephraimites fell on this occasion.|[[Book of Judges|Judges]] 12:5-6, [[New Jerusalem Bible|NJB]]}}\n\n==Modern usage==\n{{Unreferenced section|date=December 2008}}\n\nIn numerous cases of conflict between groups speaking different languages or dialects, one side used shibboleths in a way similar to the above-mentioned Biblical use, i.e., to discover hiding members of the opposing group. [[Christian]]s might have been familiar with the Biblical story and directly inspired by it, or might have independently invented the same method under similar circumstances. Modern researchers use the term Shibboleth for all such usages, whether or not the people involved were using it themselves.  \n\nToday, in the English language, a shibboleth also has a wider meaning, referring to any in-crowd word or phrase that can be used to distinguish members of a group from outsiders - even when not used by a hostile other group. The word is also sometimes used in a broader sense to mean [[jargon]], the proper use of which identifies speakers as members of a particular group or subculture. \n\nShibboleths can also be customs or practices, such as [[male circumcision]], or a signifier, such as a [[semiotic]].\n\nCultural [[touchstone]]s and shared experience can also be shibboleths of a sort. For example, people about the same age who are from the same nation tend to have [[Collective memory|the same memories]] of popular songs, television shows, and events from their formative years. Much the same is true of alumni of a particular school, veterans of military service, and other groups. Discussing such memories is a common way of [[Human bonding|bonding]]. [[In-jokes]] can be a similar type of shared-experience shibboleth.\n\n==Notable shibboleths==\n\n{{main|List of shibboleths}}\n\nA notable if indirect reference to shibboleth in modern poetry is the synagogue of the ear of corn in the [[Dylan Thomas]] poem A Refusal to Mourn the Death, by Fire, of a Child in London.\n\nShibboleths have been used by different subcultures throughout the world at different times.  Regional differences, level of expertise and computer coding techniques are several forms that shibboleths have taken.  For example, during the [[Battle of the Bulge]], American soldiers used knowledge of [[baseball]] to determine if others were fellow Americans or if they were German [[spy|infiltrators]] in American uniform.  The Dutch famously used the name of the port town [[Scheveningen]] as a shibboleth to tell Germans from the Dutch (the Dutch pronounce the S separately from the ch). Some shibboleths are jokes.\n\nDuring World War II, some United States soldiers in the Pacific theater used the word [[Lollapalooza#Etymology|lollapalooza]] as a shibboleth to verbally test people who were hiding and unidentified, on the premise that Japanese people often pronounce the letter L as R, and that the word is an American colloquialism  that even a foreign person fairly well-versed in American English would probably mispronounce and/or be unfamiliar with.<ref>US Army & Navy, 1942. [http://www.ep.tc/howtospotajap/howto06.html HOW TO SPOT A JAP Educational Comic Strip], (from US govts POCKET GUIDE TO CHINA, 1st edition). Retrieved 10-10-2007</ref> In George Stimpsons A Book about a Thousand Things, the author notes that, in the war, Japanese spies would often approach checkpoints posing as American or [[Filipino people|Filipino]] military personnel. A shibboleth such as lollapalooza would be used by the sentry, who, if the first two syllables come back as rorra, would open fire without waiting to hear the remainder.<ref>{{cite book|year=1946|title=A Book about a Thousand Things|author=Stimpson, George W.|publisher=Harper & Brothers|pages=51}}</ref>\n\nPrior to the [[Battle of the Golden Spurs|Guldensporenslag]], the Flemish slaughtered every Frenchman they could find in the city of Bruges. They are said to have identified Frenchmen based on their inability to pronounce the phrase Scilt ende Vriend (Shield and Friend), or possibly s Guilden vriend (Friend of the Guilds).\n\nBter, brea, en griene tsiis; wat dat net sizze kin, is gjin oprjochte Fries ({{audio|Schibbolet-fries.ogg|example}}) means Butter, rye bread and green cheese, who cannot say that is not a genuine Frisian was used by the [[Frisian]] [[Pier Gerlofs Donia]] during a [[Frisian rebellion]] war ([[1515]]-[[1523]]). Ships whose crew could not pronounce this properly were usually plundered and soldiers who could not were beheaded by Donia himself.<ref>{{cite web|url=http://www.wunseradiel.nl/index.php?simaction=content&pagid=289&mediumid=1|publisher=Gemeente Wnseradiel|title=Greate Pier fan Wnseradiel|language=West Frisian|accessdate=2008-01-04}}</ref>\n\n'
p76
tp77
a(I-1
S'{{Expand|article|date=June 2008}}\n\n{{rights}}\n\nSocial equality is a [[society|social]] state of affairs in which all people within a specific society or isolated group have the same status in a certain respect. At the very least, social equality includes [[equal rights]] under the law, such as [[security]], [[voting rights]], [[freedom of speech]] and assembly, and the extent of [[property rights]]. However, it also includes access to [[education]], [[health care]] and other social securities. It also includes equal opportunities and obligations, and so involves the whole society.\n\nSocial equality requires the lack of legally enforced [[social class]] or [[caste]] boundaries and the lack of unjustified [[discrimination]] motivated by an inalienable part of a persons identity. For example, gender, age, sexual orientation, origin, caste or class, income or property, language, religion, convictions, opinions, health or disability must not result in unequal treatment under the law and should not reduce opportunities unjustifiably.\n\nSocial equality refers to social, rather than economic, or income equality.  Equal opportunities is interpreted as being judged by [[ability]], which is compatible with a free-market economy. A problem is [[horizontal inequality]], the inequality of two persons of same origin and ability.\n\nPerfect social equality is an ideal situation that, for various reasons, does not exist in any society in the world today. The reasons for this are widely debated. Reasons cited for [[social inequality]] include commonly [[economics]], [[immigration]]/[[emigration]], [[Foreign policy|foreign politics]] and national politics. Also, in [[complexity economics]], it has been found that [[horizontal inequality]] arises in complex systems.\n\nA counterexample to social equality was the social inequality of medieval Europe, where a persons [[estates of the realm|estate]], which was usually inherited, determined the legal and social rights the person had. For example, clergy could claim the [[benefit of clergy]] to receive a more lenient punishment for a crime.  Likewise, women have historically been and still are in some countries formally denied access to higher educationeven if they could pay the tuition. In 19th century Europe, if female enrollment was even permitted, women had to apply for an exemption from gender to enroll in a university.\n\nIn apartheid-era South Africa, both blacks and whites had formal access to health care and similar public services. However, the segregated health care arranged for blacks did not meet the same standards as those for whites. That is, there was enforced social inequality. Currently, in [[North Korea]], certain groups are officially considered disloyal to the regime; the disloyalty is inherited, prevents advancement in society, and results in harsher punishments for crimes. \n\n'
p78
tp79
a(I1
S'[[Image:Sbots.jpg|thumb|S-bot mobile robot.]]\n\nThe s-bot is a small (15 cm) [[Differential wheeled robot|differential wheeled]] (with additional [[Kgresse track|tracks]]) [[mobile robot]] developed at the LIS (Laboratory of Intelligent Systems [http://lis.epfl.ch/]) at the [[EPFL]] in [[Lausanne]], [[Switzerland]] between 2001 and 2004. Targeted to swarm robotics, a field of [[artificial intelligence]], it was developed within the Swarm-bots project, a Future and Emerging Technologies project coordinated by Prof. [[Marco Dorigo]]. Built by a small team of engineers ([[Francesco Mondada]], [[Andr Guignard]], [[Michael Bonani]] and [[Stphane Magnenat]] of the group of Prof. [[Dario Floreano]] and with the help of student projects, it is considered at the time of completion as one of the most complex and featured robots ever for its size. The s-bot was ranked on position 39 in the list of [http://www.wired.com/wired/archive/14.01/robots.html The 50 Best Robots Ever] (fiction or real) by the [[Wired_(magazine)|Wired magazine]] in 2006.\n\n\n== Purpose and use of the s-bot ==\n\nThis is a research robot, aimed at studying team work and inter-robot communication. To do this, the s-bots have several special abilities:\n* Using their gripper (red in the photos), they can connect together. Then they can, for instance, pass over gap and steps where a single robot would have failed.\n* Using their integrated [[force]] [[sensor]], they can coordinate to retrieve an object to a certain location  without the use of explicit communication. This is the way [[ants]]  bring preys to the nest.\nOf course, all other sensors and actuators, also found on other robots, can be used to do team work such as food foraging.\n\n== Technical details ==\n\n[[Image:Sbot_mobile_robot_gripper_closeup.jpeg|thumb|Closeup of s-bot fixed gripper, used to hold and lift another robot.]]\n\n=== General ===\n* 12 cm diameter\n* 15 cm height\n* 660 g\n* 2 [[LiIon]] batteries\n* 1 hour autonomy moving\n\n=== Control ===\n* 400 [[MHz]] custom [[XScale]] [[CPU]] board, 64 MB of [[RAM]], 32 MB of [[flash memory]]\n* 12 distributed [[PIC microcontroller]] for low-level handling\n* Custom [[Linux]] port running Familiar\n* [[Wifi]]\n\n[[Image:Sbot_mobile_robot_passing_step.jpeg|thumb|Image of the s-bot mobile robot climbing a step in the swarm-bot configuration.]]\n\n=== Actuators ===\n* 2 treels\n* turret rotation\n* rigid gripper elevation\n* rigid gripper\n* 3 axis side arm\n* side arm gripper\n\n=== Sensors ===\n* 15 [[infrared]] sensors around the turret\n* 4 [[infrared]] sensors below the robot\n* position sensors on all degrees of freedom except gripper\n* force and speed sensors on all major degrees of freedom\n* 2 humiditiy sensors\n* 2 temperature sensors\n* 8 ambient light sensors around the turret\n* 4 [[accelerometer|accelerometers]], which allow three-[[Dimension|dimensional]] orientation\n* 1 640x480 [[digital camera|camera]] sensor. Custom optic based on spherical [[mirror]] provides omnidirectional vision\n* 4 [[microphones]]\n* 2 axis structure deformation sensors\n* optical barrier in grippers\n\n[[Image:Sbot_mobile_robot_by_night.jpg|thumb|S-bot by night showing color ring.]]\n\n=== LEDS ===\n* 8 x RGB [[Light-emitting diodes]] around the turret\n* red [[Light-emitting diodes]] in grippers\n\n[[Image:Sbot mobile robot passing gap.jpeg|thumb|Several s-bots in swarm-bot configuration passing over a gap.]]\n\n== Special abilities ==\nS-bots can connect to other s-bots to create a bigger structure known as the swarm-bot. To do so, they attach together using their rigid gripper and ring. An s-bot has sufficient force to lift another one.\n\n== Integrated software ==\nThe s-bot features a custom Linux port running the [[Familiar Linux|Familiar GNU/Linux]] distribution. All sensors and actuators are easily accessible through a simple [[C (programming language)|C]] [[application programming interface|API]].\n\n'
p80
tp81
a(I-1
S'{{notability|date=September 2008}}\n{{unreferenced|date=February 2007}}\n\nTechnicism is an over reliance or overconfidence in [[technology]] as a benefactor of society.\n\nTaken to the extreme, some argue that technicism is the belief that humanity will ultimately be able to control the entirety of existence using technology.  In other words, human beings will eventually be able to master all problems, supply all wants and needs, possibly even control the future.  (For a more complete treatment of the topic, see the work of [[Egbert Schuurman]], for example at [http://scholar.lib.vt.edu/ejournals/SPT/v3n1/schuurman.html].) Some, such as Monsma, et al., connect these ideas to the abdication of [[religion]] as a higher moral authority. \n\nMore commonly, technicism is a criticism of the commonly held belief that newer, more recently-developed technology is better.  For example, more recently-developed computers are faster than older computers, and more recently-developed cars have greater gas efficiency and more features than older cars.  Because current technologies are generally accepted as good, future technological developments are not considered circumspectly, resulting in what seems to be a blind acceptance of technological developments.\n\nTechnicism has also been used as a synonym for technocracy, in the sense of the control of society by technicians or specialists; in this connection, see [[Robert D. Putnam]]s The Managerial Revolution.\n\n'
p82
tp83
a(I1
S'{{unreferenced|date=October 2007}}\n\n{{main|Knitting}}\n\nKnitting clubs are a feature of the recent revival of hand knitting which began in America and has spread to most of Europe.  While some may say [[knitting]] has never really gone away, this latest reincarnation is less about the make do and mend of the 1940s and 50s and more about making a statement about individuality as well as developing an innate sense of community.\n\nKnitting clubs fulfill many purposes. To get together with other [[knitting|knitters]], to learn or develop the skills of hand knitting, a great fun night out.  Clubs meet in coffee bars, pubs and clubs and members are drawn from all walks of life from professional women to mothers, teenagers to retired people.  Knitting is very popular in some snowboarding circles. Thus many clubs also have male members.\n\n== Knitting in the UK==\n\nIn the UK there are many websites that help knitters or wannabes get in touch with their local club.  [[Stitch n Bitch]] clubs take their name form the book by American knitting guru [[Debbie Stoller]] but the term Knit and Natter is also used.\n\nRowan Yarns runs clubs which get involved in charitable events.  In 2007 the Rowan Knitting clubs spearheaded [[Knit in Public Day]] encouraging knitters all around the UK to knit hats for [[innocent Drinks]] Smoothie bottles to raise money for [[Age Concern]] in the Big Knit.  Currently this is the biggest knitting club event in the UK.\n\nA total of 4,000 people are now part of a Rowan club of some kind, including the existing 8,000 members of Rowan International - the membership subscription to Rowan magazines and gifts.\n\nIn January 2008, the knitting club for [[Imperial College London]] was set up, aptly named Knit Sock (pun intended), adding the club to the long list of activities with clubs totally more than 250. The President and Founder of Knit Sock is Jenny Wilson, of [[Wilson House]], London.\n\n2010 will see [[Julia Roberts]] starring in a film called The Friday Night Knitting Club adapted by [[Mike Binder]] from the best selling book of the same name by Kate Jacobs.\n\n'
p84
tp85
a(I-1
S'{{BLP unsourced|date=August 2009|bot=yes}}\n{{Infobox Person\n|name          = Leslie Benzies\n|image         = Replace this image male.svg\n|image_size    = \n|caption       = \n|nationality   = British\n|known_for     = Executive games producer at [[Rockstar North]].\n}}\n\nLeslie Benzies is a [[United Kingdom|British]] video game producer who works at [[Rockstar North]]. <br />He is best known for his work on the [[Grand Theft Auto (series)|Grand Theft Auto]] series.<br /><br />He is from [[Elgin, Moray]].\n\n==Video Game Credits==\n===Producer===\n*[[Grand Theft Auto III]] (2001)\n*[[Grand Theft Auto: Vice City]] (2002)\n*[[Grand Theft Auto: San Andreas]] (2004)\n*[[Grand Theft Auto: Liberty City Stories]] (2005)\n*[[Grand Theft Auto: Vice City Stories]] (2006)\n*[[Grand Theft Auto IV]] (2008)\n\n'
p86
tp87
a(I-1
S'[[Image:Old Mods photo.jpg|thumb|300px|A photograph of two mods on a customized [[Scooter (motorcycle)|scooter]] ]]\nMod (originally modernist, sometimes capitalised) is a [[subculture]] that originated in [[London]], [[England]] in the late 1950s and peaked in the early to mid 1960s.<ref>{{cite web | title = Jeff Noon on The Modernists | author = Oonagh Jaquest | url = http://www.bbc.co.uk/southyorkshire/stage/2003/05/mods/index.shtml | publisher = [[BBC]] | month = May | year = 2003 | accessdate = 2008-10-11}}</ref><ref>{{cite web | title = 1960s day - Mods and Rockers | author = Tony Nightingale | url = http://www.bbc.co.uk/lincolnshire/asop/people/mods_rockers.shtml | publisher = [[BBC]] | month = July | year = 2005 | accessdate = 2008-10-11}}</ref><ref>{{cite web | title = Quadrophenia and Meaden | author = Eddie Piller | url = http://www.modculture.co.uk/culture/culture.php?id=45 | publisher = modculture.com | date =  | accessdate = 2008-10-11}}</ref>\n\nSignificant elements of the mod subculture include: [[fashion]] (often [[tailor]]-made suits); [[pop music]], including African American [[Soul music|soul]], Jamaican [[ska]], and British [[beat music]] and [[Rhythm and blues|R&B]]; and Italian [[Scooter (motorcycle)|motor scooters]]. The original mod scene was also associated with amphetamine-fuelled all-night dancing at clubs.<ref name=medicine>{{cite web | title = Mixing the Medicine: The unintended consequence of amphetamine control on the Northern Soul Scene | author = Dr. Andrew Wilson | url = http://www.internetjournalofcriminology.com/Wilson%20-%20Mixing%20the%20Medicine.pdf |format=PDF| publisher = Internet Journal of Criminology | year = 2008 | accessdate = 2008-10-11}}</ref> From the mid to late 1960s onwards, the [[mass media]] often used the term mod in a wider sense to describe anything that was believed to be popular, fashionable or [[Modern era|modern]].\n\nThere was a [[mod revival]] in the [[United Kingdom]] in the late 1970s, which was followed by a mod revival in [[North America]] in the early 1980s, particularly in [[Southern California]].<ref name=disjointed>{{cite web | title = A rather disjointed narrative of the California mod scene(s) 1980-1983 | author = Michael Page | url = http://california-mod-scene.com/ | publisher = california-mod-scene.com | year = 2006 | accessdate = 2008-10-11}}</ref><ref name=socal>{{cite web | title = SoCal Mods | author = Mario Artavia | url = http://www.southbayscooterclub.com/sbsc/sbmod/sbmod.html | publisher = South Bay Scooter Club | year = 2006 | accessdate = 2008-10-11}}</ref>\n\n==Etymology==\nThe term mod derives from modernist, which was a term used in the 1950s to describe modern [[jazz]] musicians and fans.<ref>Mods!, Richard Barnes. Eel Pie (1979), ISBN 0-85965-173-8; [[Absolute Beginners]], [[Colin MacInnes]]</ref> This usage contrasted with the term trad, which described traditional jazz players and fans. The 1959 novel [[Absolute Beginners]] by [[Colin MacInnes]] describes as a modernist a young modern jazz fan who dresses in sharp modern Italian clothes. Absolute Beginners may be one of the earliest written examples of the term modernist being used to describe young British style-conscious modern jazz fans. The word modernist in this sense should not be confused with the wider use of the term [[modernism]] in the context of [[literature]], [[art]], [[design]] and [[architecture]].\n\n==History==\n[[Dick Hebdige]] claims that the progenitors of the mod subculture appear to have been a group of [[Working class|working-class]] dandies, possibly descended from the devotees of the Italianite [fashion] style.<ref name=Hebdige, Dick 1993. Page 167>Hebdige, Dick. The Meaning of Mod. In Resistance Through Rituals: Youth Subcultures in Post-War Britain. Stuart Hall and Tony Jefferson, eds. London. Routledge, 1993. Page 167</ref> Mary Anne Long disagrees, stating that first hand accounts and contemporary theorists point to the [[Jew]]ish upper-working or middle-class of [[East End of London|Londons East End]] and suburbs.<ref name=nh-scooters.com>A Cultural History of the Italian Motorscooter. A Senior Thesis Presented To Prof. Anne Cook Saunders on December 17, 1998 by Mary Anne Long. Available online at: www.nh-scooters.com/filemanager/download/11/php1C.pdf</ref> Sociologist [[Simon Frith]] asserts that the mod subculture had its roots in the 1950s [[beatnik]] coffee bar culture, which catered to art school students in the radical [[bohemian]] scene in London.<ref>Simon Frith and Howard Horne. Art into Pop. 1987. Pages 86-87</ref> Steve Sparks, who claims to be one of the original mods, agrees that before mod became commercialized, it was essentially an extension of the beatnik culture: It comes from modernist, it was to do with modern jazz and to do with [[Jean-Paul Sartre|Sartre]] and [[existentialism]].<ref name=nh-scooters.com/> Sparks argues that Mod has been much misunderstood... as this working-class, scooter-riding precursor of [[skinhead]]s. \n\nCoffee bars were attractive to youths, because in contrast to typical UK [[Public house|pubs]], which closed at about 11 pm, they were open until the early hours of the morning. Coffee bars had [[jukebox]]es, which in some cases reserved some of the space in the machines for the students own records. In the late 1950s, coffee bars were associated with jazz and blues, but in the early 1960s, they began playing more R&B music. Frith notes that although coffee bars were originally aimed at middle-class art school students, they began to facilitate an intermixing of youths from different backgrounds and classes.<ref>Simon Frith and Howard Horne. Art into Pop. 1987. Page 87</ref> At these venues, which Frith calls the first sign of the youth movement, youths would meet collectors of R&B and blues records, who introduced them to new types of African-American music, which the teens were attracted to for its rawness and [[authenticity (philosophy)|authenticity]]. They also watched French and Italian [[art film]]s and read Italian magazines to look for style ideas.<ref name=autogenerated5 /> According to Hebdige, the mod subculture gradually accumulated the identifying symbols that later came to be associated with the scene, such as scooters, amphetamine pills, and music.<ref name=Hebdige, Dick 1993. Page 167/> \n\n===Decline and offshoots===\nBy the summer of 1966, the mod scene was in sharp decline. Dick Hebdige argues that the mod subculture lost its vitality when it became commercialized, artificial and stylized to the point that new mod clothing styles were being created from above by clothing companies and by TV shows like [[Ready Steady Go!]], rather than being developed by young people customizing their clothes and mixing different fashions together.<ref>Hebdige, Dick. The Meaning of Mod. In Resistance Through Rituals: Youth Subcultures in Post-War Britain. Stuart Hall and Tony Jefferson, eds. London. Routledge, 1993. Page 174</ref>.\n\nAs [[psychedelic rock]] and the [[hippie]] subculture grew more popular in the United Kingdom, many people drifted away from the mod scene. Bands such as [[The Who]] and [[Small Faces]] had changed their musical styles and no longer considered themselves mods. Another factor was that the original mods of the early 1960s were getting into the age of marriage and child-rearing, which meant that they no longer had the time or money for their youthful pastimes of club-going, record-shopping and [[Scooter rally|scooter rallies]]. The peacock or fashion wing of mod culture evolved into the [[swinging London]] scene and the hippie style, which favored the gentle, marijuana-infused contemplation of esoteric ideas and aesthetics, which contrasted sharply with the frenetic energy of the mod ethos.\n\nThe hard mods of the mid- to late 1960s eventually transformed into the [[skinhead]]s.<ref>[http://www.bbc.co.uk/dna/h2g2/A721216 BBC - h2g2 - The Mods of the 1960s<!-- Bot generated title -->]</ref><ref>http://books.google.com/books?id=SqEUjjuMrToC&pg=PA55&lpg=PA55&dq=%22hard+mods%22&source=web&ots=nP3rS_HCuI&sig=oY26ouTj4E_6I727s7nmjrvexiM</ref><ref>[http://www.modculture.co.uk/interviews/interview.php?id=1 Modculture.com - Hard Mods by John Waters<!-- Bot generated title -->]</ref> Many of the hard mods lived in the same economically depressed areas of [[South London]] as West Indian immigrants, and those mods emulated the [[rude boy]] look of [[pork pie hat]]s and too-short Levis jeans.<ref name=Hebdige, Dick 2000>Hebdige, Dick. Reggae, Rasta and Rudies. In Writing Black Britain, 1948-1998: An Interdisciplinary Anthology. Edited by James Procter. Manchester University Press, 2000.</ref> These aspiring white negros listened to Jamaican [[ska]] and mingled with black rude boys at West Indian nightclubs like Ram Jam, A-Train and Sloopys.<ref>Old Skool Jim. Trojan Skinhead Reggae Box Set liner notes. London: Trojan Records. TJETD169</ref><ref>Marshall, George (1991). Spirit of 69 - A Skinhead Bible. Dunoon, Scotland: S.T. Publishing. ISBN 1-898927-10-3</ref><ref>Hebdige, Dick. Reggae, Rasta and Rudies. Page 163. In Writing Black Britain, 1948-1998: An Interdisciplinary Anthology. Edited by James Procter. Manchester University Press, 2000.</ref> \n\n[[Dick Hebdige]] claims that the hard mods were drawn to black culture and ska music in part because the educated, middle-class hippie movements drug-oriented and intellectual music did not have any relevance for them.<ref>Hebdige, Dick. Reggae, Rasta and Rudies. Page 162. In Writing Black Britain, 1948-1998: An Interdisciplinary Anthology. Edited by James Procter. Manchester University Press, 2000. </ref> He argues that the hard mods were also attracted to ska because it was a secret, underground, non-commercialized music that was disseminated through informal channels such as house parties and clubs.<ref>Hebdige, Dick. Reggae, Rasta and Rudies. Page 162-163. In Writing Black Britain, 1948-1998: An Interdisciplinary Anthology. Edited by James Procter. Manchester University Press, 2000.</ref> The early skinheads also liked [[Soul music|soul]], [[rocksteady]] and early [[reggae]]. \n\nThe early skinheads retained basic elements of mod fashion  such as [[Fred Perry]] and [[Ben Sherman]] shirts, [[Sta-Prest]] trousers and [[Levis]] jeans  but mixed them with working class-oriented accessories such as [[Suspenders|braces]] and [[Dr. Martens]] work boots. Hebdige claims that as early as the Margate and Brighton brawls between [[mods and rockers]], some mods were seen wearing boots and braces and sporting close cropped haircuts, which artificially reproduces the texture and appearance of the short negro hair styles (though this was as much for practical reasons, as long hair was a liability in industrial jobs and streetfights).<ref name=Hebdige, Dick 2000/> It was also a reaction to middle class hippie [[aesthetics]]. \n\nMods and ex-mods were also part of the early [[northern soul]] scene, a subculture based on obscure 1960s and 1970s American soul records. Some mods evolved into, or merged with, subcultures such as individualists, stylists, and [[scooterboy]]s, creating a mixture of taste and testosterone that was both self-confident and streetwise.<ref name=autogenerated5 />\n\n===Revival and later influences===\n{{Main|mod revival}}\nA [[mod revival]] started in the late 1970s in the United Kingdom, with thousands of mods attending [[Scooter rally|scooter rallies]] in places like Scarborough and the Isle of Wight. This revival was partly inspired by the 1979 film [[Quadrophenia (film)|Quadrophenia]] and by mod-influenced bands such as [[The Jam]], [[Secret Affair]], [[Purple Hearts (UK band)|Purple Hearts]] and [[The Chords]].\nMany of the mod revival bands were influenced by the energy of British [[punk rock]] and [[New Wave music]]. The UK revival was followed by a mod revival in [[North America]] in the early 1980s, particularly in [[Southern California]], led by bands such as [[The Untouchables (band)|The Untouchables]].<ref name=disjointed /><ref name=socal /> The mod scene in [[Los Angeles]] and [[Orange County, California|Orange County]] was partly influenced by the [[2 Tone]] [[ska]] revival in [[England]], and was unique in its racial diversity, with black, white, Hispanic and Asian participants. The 1990s [[Britpop]] scene featured noticeable mod influences on bands such as [[Oasis (band)|Oasis]], [[Blur (band)|Blur]], [[Ocean Colour Scene]] and [[The Verve]].\n\n==Characteristics==\nPaul Jobling and David Crowley argue that the concept of mod can be difficult to pin down, because throughout the subcultures original era, it was prone to continuous reinvention.<ref name=Graphic Design 1800. Page 213>Graphic Design: Reproduction and Representation Since 1800. By Paul Jobling, David Crowley. Published by Manchester University Press, 1996. ISBN 0719044677, 9780719044670. Page 213</ref> They claim that since the mod scene was so pluralist, the word mod was an umbrella term that covered several distinct sub-scenes. Terry Rawlings history of the mod subculture argues that mods are difficult to define because the subculture started out as a mysterious semi-secret world, which [[The Who]]s manager [[Peter Meaden]] summarized as clean living under difficult circumstances.<ref name=autogenerated5>Mod: Clean Living Under Very Difficult Circumstances: a Very British Phenomenon By Terry Rawlings. Published 2000. Omnibus Press. ISBN 0711968136</ref> Dick Hebdige points out that when trying to understand 1960s mod culture, one has to try and penetrate and decipher the mythology of the mods.<ref name=Hebdige, Dick 1993. Page 168>Hebdige, Dick. The Meaning of Mod. In Resistance Through Rituals: Youth Subcultures in Post-War Britain. Stuart Hall and Tony Jefferson, eds. London. Routledge, 1993. Page 168</ref> . \n\nTerry Rawlings argues that the mod scene developed when British teenagers began to reject the dull, timid, old-fashioned, and uninspired British culture around them, with its repressed and class-obsessed mentality and its [[wikt:naff|naffness]].<ref name=autogenerated5 /> Mods rejected the faulty pap of 1950s pop music and sappy love songs. They aimed at being cool, neat, sharp, hip, and smart by embracing all things sexy and streamlined, especially when they were new, exciting, controversial or modern.<ref name=autogenerated5 /> Hebdige claims that the mod subculture came about as part of the participants desire to understand the mysterious complexity of the metropolis and to get close to black culture of the [[Jamaica]]n [[rude boy]], because mods felt that black culture ruled the night hours and that it had more streetwise [[savoir faire]].<ref>Ibid, 168</ref> Shari Benstock and Suzanne Ferriss argue that at the core of the British Mod rebellion was a blatant fetishizing of the American consumer culture that had eroded the moral fiber of England.<ref name=Fashion 1994>On Fashion. By Shari Benstock and Suzanne Ferriss. Published by Rutgers University Press, 1994.ISBN 0813520339, 9780813520339</ref> In doing so, the mods mocked the class system that had gotten their fathers nowhere, and created a rebellion based on consuming pleasures ranging from Italian suits and scooters to US soul records. \n\n===Fashion===\nJobling and Crowley called the mod subculture a fashion-obsessed and hedonistic cult of the hyper-cool young adults who lived in metropolitan London or the new towns of the south. Due to the increasing affluence of post-war Britain, the youths of the early 1960s were one of the first generations that did not have to contribute their money from after-school jobs to the family finances. As mod teens and young adults began using their disposable income to buy stylish clothes, the first youth-targeted boutique clothing stores opened in London in the [[Carnaby Street]] and Kings Road districts.<ref>Doug Owram. Born at the Right Time: A History of the Baby-Boom Generation. University of Toronto Press. 1996. page 3</ref> Maverick fashion designers emerged, such as [[Mary Quant]], who was known for her increasingly short [[miniskirt]] designs, and [[John Stephen]], who sold a line named His Clothes, and whose clients included bands such as [[The Small Faces]].<ref>Melissa M. Casburn. A Concise History of the British Mod Movement.</ref>\n\nTwo youth subcultures helped pave the way for mod fashion by breaking new ground; the [[beatnik]]s, with their bohemian image of berets and black turtlenecks, and the [[Teddy Boy]]s, from which mod fashion inherited its narcissitic and fastidious [fashion] tendencies and the immaculate [[dandy]] look.<ref>Melissa M. Casburn. A Concise History of the British Mod Movement. Page 2.</ref> The Teddy Boys paved the way for making male interest in fashion socially acceptable, because prior to the Teddy Boys, male interest in fashion in Britain was mostly associated with the underground homosexual subcultures flamboyant dressing style.\n\nNewspaper accounts from the mid-1960s focused on the mod obsession with clothes, often detailing the prices of the expensive suits worn by young mods, and seeking out extreme cases such as a young mod who claimed that he would go without food to buy clothes.<ref>Graphic Design: Reproduction and Representation Since 1800. By Paul Jobling, David Crowley. Published by Manchester University Press, 1996. ISBN 0719044677, 9780719044670</ref> Jobling and Crowley argue that for working class mods, the subcultures focus on fashion and music was a release from the humdrum of daily existence at their jobs.<ref>Graphic Design: Reproduction and Representation Since 1800. By Paul Jobling, David Crowley. Published by Manchester University Press, 1996. ISBN 0719044677, 9780719044670</ref> Jobling and Crowley note that while the subculture had strong elements of consumerism and shopping, mods were not passive consumers; instead they were very self-conscious and critical, customizing existing styles, symbols and artefacts such as the [[Union flag]] and the Royal Air Force [[roundel]] symbol, and putting them on their jackets in a [[pop art]]-style, and putting their personal signatures on their style.<ref name=Graphic Design 1800. Page 213/> The song [[Dedicated Follower of Fashion]] by [[The Kinks]] from 1966 jokes about the fashion obsession of the mod community.\n\nMod fashion adopted new Italian and French styles in part as a reaction to the rural and small-town [[Rocker (subculture)|rockers]], who were seen as trapped in the 1950s, with their leather motorcycle clothes and American [[Greaser (subculture)|greaser]] look. Male mods adopted a smooth, sophisticated look that emphasized tailor-made Italian suits (sometimes white) with narrow lapels, mohair clothes, thin ties, button-down collar shirts, wool or cashmere sweaters (crewneck or V-neck), pointed-toe leather shoes that were nicknamed [[winklepickers]], as well as Chelsea or Beatle boots, Tassel Loafers,Clarks Desert Boots even Bowling shoes, and hairstyles that imitated the look of the French [[French New Wave|Nouvelle Vague]] cinema actors of the era, such as [[Jean-Paul Belmondo]].<ref>Melissa M. Casburn. A Concise History of the British Mod Movement.</ref> A few male mods went against gender norms of the era by enhancing their appearance with eyeshadow, eyepencil or even lipstick.<ref>Melissa M. Casburn. A Concise History of the British Mod Movement.</ref> Scooters were chosen over motorbikes because scooters use of bodypanelling and concealed moving parts made them cleaner and less likely to stain an expensive suit with grease. Scootering led to the wearing of military parkas to protect costly suits and trousers from mud and rain.\n\nFemale mods dressed androgynously, with short haircuts, mens trousers or shirts (sometimes their boyfriends), flat shoes, and little makeup  often just pale foundation, brown eyeshadow, white or pale lipstick and false eyelashes.<ref>Melissa M. Casburn. A Concise History of the British Mod Movement. Page 4. </ref> Female mods pushed the boundaries of parental tolerance with their miniskirts, which got progressively shorter between the early and mid-1960s. As female mod fashion went from an underground style to a more commercialized fashion, the slender model [[Twiggy]] began to exemplify the high-fashion mod look. The television programme [[Ready Steady Go!]], presented by '
p88
tp89
a(I-1
S'{{Expand|date=January 2009}}\nThe Department of Social Relations for Interdisciplinary Social Science Studies, more commonly known as the Department of Social Relations was an interdisciplinary collaboration among three of the social science departments at [[Harvard University]] ([[anthropology]], [[psychology]], and [[sociology]]) during the middle of the 20th century, headquartered in [http://www.wjh.harvard.edu/ William James Hall]. The program officially began in 1946.<ref>Powers, Willow Roberts (2000) The Harvard study of values: Mirror for postwar anthropology. Journal of the History of the Behavioral Sciences, 36(1): 15-29</ref> While the name [[Social relation|Social Relations]] is often associated with the programs long-time chair and guiding spirit, sociologist [[Talcott Parsons]], many major figures of mid-20th-century social science also numbered among the programs faculty, including psychologists [[Gordon Allport]] (personality and motivation), [[Jerome Bruner]] (cognitive psychology and narrative analysis), [[Roger Brown (psychologist)|Roger Brown]] (social psychology and psycholinguistics), and [[Henry Murray]] (personality); anthropologists Clyde and Florence Kluckhohn (value orientations), John and Beatrice Whiting (cross-cultural child development), Evon Z. Vogt (comparative religion); and sociologist [http://www.hoover.org/bios/inkeles Alex Inkeles] (Soviet studies and national character). Many of its graduate students also went on to be major figures in U.S. social sciences during the latter part of the twentieth century; their work tends towards strong interdisciplinary and cross-disciplinary approaches. \n\nSocial Relations sponsored or collaborated in a number of research studies characterized by explicit cross-cultural comparisons and multidisciplinary approaches to problems of policy or social theory. Major projects included the Six Cultures Study (headed by John and Beatrice Whiting, an anthropological study of child development in six different cultures, including a New England Baptist community; a Philippine barrio; an Okinawan village; an Indian village in Mexico; a northern Indian caste group; and a rural tribal group in Kenya); a multidisciplinary analysis of Soviet culture and society, published in part as How the Soviet System Works; and the Comparative Study of Values in Five Cultures during the 1950s, which examined five very different communities living in the same region of Texas: [[Zuni]], [[Navajo people|Navajo]], [[Mormon]] (LDS), Spanish-American (Mexican-American), and Texas Homesteaders.<ref>Kluckhohn, Florence Rockwood and Fred L. Strodtbeck. 1961. Variations in value orientations. Evanston, IL: Row, Peterson.</ref><ref>Vogt, Evon Zartman and Ethel M. Albert Vogt. 1966. People of Rimrock; a study of values in five cultures. Cambridge, MA: Harvard University Press.</ref><ref>[http://www.aaanet.org/gad/history/085KLUCKHOHN.pdf GAD_Home<!-- Bot generated title -->]</ref>\n\nThe program disaggregated into its component departments around 1972, though a certain interdisciplinarity remained throughout the 1970s.<ref>Schmidt, P. L. (1978). Towards a history of the department of social relations: Harvard University, 1946-1972.\nUnpublished honors thesis. Harvard College.</ref>Today, the name remains in the [http://lib.harvard.edu/libraries/0019FULL.html Social Relations Library] at Harvard. \n\nA similar program at Yale, the Institute for Human Relations, also now disbanded, developed the [http://www.yale.edu/hraf/ Human Relations Area Files], a cross-cultural database for comparative research, administered by Carol and Melvin Ember. \n\n==Scholars Associated with Social Relations at Harvard==\n*[[Talcott Parsons]], (1902-1979) sociologist\n*[[Gordon Allport]], (1897-1967) psychologist \n*[[Jerome Bruner]], psychologist\n*[[Roger Brown (psychologist)|Roger Brown]], social psychologist\n*[http://www.hoover.org/bios/inkeles Alex Inkeles], sociologist\n*[[Clyde Kluckhohn]], (1905-1960) anthropologist\n*Florence Rockwood Kluckhohn, anthropologist \n*[[John Whiting (anthropologist)]], anthropologist \n*[[Beatrice Blyth Whiting]], anthropologist  \n*[[Evon Z. Vogt]], anthropologist\n\n==Notable Graduates of Social Relations at Harvard==\n*[[Robert N. Bellah]], sociologist, American civil society\n*[[Bertram J. Cohler]], psychoanalyst and cultural psychologist\n*[[Roy DAndrade|Roy G. DAndrade]], cognitive anthropologist\n*[http://www.mnsu.edu/emuseum/information/biography/abcde/ember_carol.html Carol Ember], cultural anthropologist\n*[[Clifford Geertz]], (1926-2006) cultural anthropologist\n*[[Mark Granovettor]], sociologist\n*[[Edward O. Laumann]], sociologist and sexologist\n*[[Richard Shweder|Richard A. Shweder]], psychological anthropologist and cultural psychologist\n*[http://www-news.uchicago.edu/releases/05/050819.strodtbeck.shtml Fred L. Strodtbeck], (1919-2005) social psychologist\n*Marc J. Swartz, cultural anthropologist\n*[[Michelle Rosaldo|Michelle Zimbalist Rosaldo]], (1944-1981) feminist theorist and psychological anthropologist\n*[http://www.stanford.edu/dept/anthroCASA/people/faculty/rosaldo.html Renato Rosaldo], cultural anthropologist\n*[[Charles Tilly]], (1929-2008), sociologist, historian, political scientists\n\n==Interlocutors==\n*[http://www.findarticles.com/p/articles/mi_m2320/is_1_65/ai_78487196 Irvin L. Child], (1915-2000) psychologist (Yale)\n*[http://www.yale.edu/hraf/mel_personal.htm Melvin Ember], cultural anthropologist (Yale)\n*[[Edward Shils]], (1911-1995) sociologist (University of Chicago)\n\n'
p90
tp91
a(I1
S'Jal Manekji Cooper, [[FRGS]] (died 1972), was an [[India]]n [[philately|philatelist]], and a recognized expert and authenticator<ref>http://www.filatelia.fi/experts/marks/cooper.jpg Coopers authentication mark</ref> of the [[postage stamps and postal history of India]]. Cooper was also a [[FRGS|Fellow of the Royal Geographical Society]] and the author of several philatelic handbooks.\n\nCooper was both a [[stamp dealer]]<ref>http://www.stampsofindia.com/newssite/vando/trans-001.htm Philately in Transition in India</ref> and a [[Collecting|collector]]. Living in Bombay (present day [[Mumbai]]), he was associated with other philatelists like [[C. D. Desai]],<ref>Cooper, Jal; Foreword to the auction catalog: The Unique Collection of India offered by order of the Executors of the late Mr. C. D. Desai, F.R.P.S.L., Robson Lowe (London), May 25 and 26, 1949. Sale Nos. 838-841.</ref> N. D. Cooper, and [[Robson Lowe]]. \n\nCoopers expertise in Indian philately is well known. He is occasionally but erroneously credited with having discovered the [[Inverted Head 4 Annas]]. The 1891 reprints show that this error was already known.  E. A. Smythies said the error was first discovered at a meeting of the Philatelic Society of London in 1874.<ref>http://www.geocities.com/mjshah.geo/articles/classic_error.html  [[E. A. Smythies]], A Classic Stamp Error, [[The American Philatelist|American Philatelist]], pp. 59, 60 [1950].</ref>\n\nThe Jal Cooper Philatelic Society, in [[Varanasi]], India is named after him.\n\n==Publications==\n* Stamps of India, Bombay (1942), 177 pp.; reprint: Bombay (1968).\n* Early Indian Cancellations, Bombay (1948) 92 pp.; reprint: Bombay (1993).\n* India Used Abroad Western Printers and Publishers Press of Bombay (1950) 100 pp.; reprinted in Indias Stamp Journal  (1972) \n* India Used In Burma Western Printers and Publishers Press of Bombay (1950) 67 pp.\n\n'
p92
tp93
a(I1
S'{{for|the capping process in biology|5 cap}}\n\nCapping is an [[Internet]]-based pastime and collaborative [[improvisational comedy]] project, in which each participant types a caption text beneath a [[screen capture]] (or screengrab). The caption can be anything from a simple observation about the contents of the screengrab to a complete [[non sequitur]], but is generally meant to be funny.\n\n==History==\n===Origins===\nCapping is generally agreed to have had its origins in the popular cult TV show [[Mystery Science Theater 3000]], whose characters make jokes while watching bad movies. It was a phenomenon of minimal proportions in the eyes of its viewers and fans. When the series moved to the [[Sci Fi Channel (United States)|Sci Fi Channel]] in the late 1990s, Sci Fis webmasters at The Dominion website created a program on its server called [[Caption This!]]. The process was simple: they took still pictures from whatever was airing on the Sci Fi Channel at the time, and allowed visitors to add their own humorous captions. The program was created to coincide with the shows debut, and was rolled out along with the Channels other game, [[MST3K: The Home Game]].\n\nThe program proved to be more popular and enjoyed greater longevity than the Home Game, as it debuted on [[October 30]], [[1996]] and continued for several years.\n\n===Caption This!===\nWhile Caption This! was active at The Dominion, participants could sign in with their Dominion handles and look at the screengrab available for captioning.  New screengrabs loaded every minute or so.  Participants could also view the gallery, which contained a small collection of the most recent captions submitted.  The screengrabber program worked well for its time, though it experienced a few snags. One of the common occurrences was a frozen screengrab--a single image which might stay in place for hours--or a broken screengrab displaying no image at all.  The latter became a bit of an in-joke among frequent participants, or cappers, as the broken screengrabs default message read, Sorry. This isnt very interesting without graphics.\n\n===The end of Caption This!===\nAlthough MST3K stopped producing new shows in 1999, Caption This! remained online for fans to continue the capping tradition. Activity at the site remained steady until [[January 31]], [[2004]] when reruns of MST3K stopped airing on the Sci Fi Channel. At first, the only change at Caption This! was the removal of the MST3K theme, but the site soon experienced a downturn. Screengrabs were provided at a much lower resolution and were often too dark to make out the contents, and the program started to freeze up more frequently. Activity dwindled until finally, in July 2004, Caption This! was quietly removed from SciFi.com.\n\n===Capping sites===\nAlthough Caption This! had closed, the practice of capping did not fade away completely.  A number of capping communities and capping websites now exist, providing the opportunity for cappers to continue enjoying their hobby. Some of the most well-known capping sites are GlitterRocks Cap-Page Board, Hipsodas Caption Crack, and Inventing Situations.\n\n'
p94
tp95
a(I-1
S'Several types of [[cognitive bias]] occur due to an attentional bias. One example is when a person does not examine all possible outcomes when making a judgment about a correlation or association.  They may focus on one or two possibilities, while ignoring the rest. \n    \nThe most commonly studied type of decision for attentional bias, is one in which there are two conditions \n(A and B), which can be present(P) or not present(N).  This leaves four possible combination outcomes: Both are present (AP/BP), Both are not present (AN/BN), Only A is present (AP/BN), Only B is present (AN/BP).  This can be better shown in table form:\n\n<center>\n{| border=1 cellpadding=5 cellspacing=0\n|\n|A Present\n|A Not Present\n|-\n|B Present\n|AP/BP\n|AN/BP\n|-\n|B Not Present\n|AP/BN\n|AN/BN\n|}\n</center>\n    \nIn everyday life, people often are subject to this type of attentional bias when asking themselves, Does God answer prayers?, as pointed out by Nisbett and Ross (1980).  Many would say Yes and justify it with many times Ive asked God for something, and Hes given it to me.  These people would be accepting and overemphasizing the data from the present/present (top-left) cell, because an unbiased person would counter this logic and consider data from the present/absent cell.  Has God ever given me something that I didnt ask for?  Or Have I asked God for something and didnt receive it?  This experiment too supports Smedslunds general conclusion that subjects tend to ignore part of the table.\n\nAttentional biases also can influence what people are more likely to look at. For instance, patients with anxiety disorders show increased attention to threatening faces in studies using the [[dot-probe paradigm]]. Another paradigm to measure attentional biases is the [[stroop effect|stroop paradigm]].\n\n'
p96
tp97
a(I-1
S'{{for|the journal|Social Neuroscience}}\nSocial neuroscience is an interdisciplinary field devoted to understanding how biological systems implement social processes and behavior, and to using biological concepts and methods to inform and refine theories of social processes and behavior. \n\nHumans are fundamentally a social species, rather than individualists. As a social species, [[Homo sapiens]] create emergent organizations beyond the individual - structures that range from dyads, families, and groups to cities, civilizations, and cultures. These emergent structures evolved hand in hand with neural and hormonal mechanisms to support them because the consequent social behaviors helped these organisms survive, reproduce, and care for offspring sufficiently long that they too survived to reproduce. \n\nThe term social neuroscience can be traced to an article by [[John Cacioppo]] and [[Gary Berntson]], published in the American Psychologist in 1992.<ref>Cacioppo, J. T., & Berntson, G. G. (1992). Social psychological contributions to the decade of the brain: Doctrine of multilevel analysis. American Psychologist, 47, 1019-1028.</ref> Cacioppo and Berntson are considered as the legitimate fathers of Social Neuroscience. Still a young field, social neuroscience is closely related to [[affective neuroscience]] and [[cognitive neuroscience]], focusing on how the brain mediates [[social interaction]]s.\n\n==Overview==\n\nSocial neuroscience investigates the [[Mechanism (biology)|biological mechanisms]] that underlie social processes and behavior, widely considered one of the major problem areas for the [[neuroscience]]s in the 21st century, and applies concepts and methods of [[biology]] to develop [[theory|theories]] of social processes and behavior in the social and [[Behavioral sciences|behavioral sciences]]. Social neuroscience capitalizes on biological concepts and methods to inform and refine theories of social behavior, and it uses social and behavioral constructs and data to inform and refine theories of neural organization and function.<ref>Cacioppo, J.T. et al. (2007). Social neuroscience: progress and implications for mental health. Perspectives on Psychological Science, 2, 99-123.</ref>\n\nThroughout most of the 20th century, social and biological explanations were widely viewed as incompatible. But advances in recent years have led to the development of a new approach synthesized from the social and biological sciences. The new field of social neuroscience emphasizes the complementary relationship between the different levels of organization spanning the social and biological domains (e.g., molecular, cellular, system, person, relational, collective, societal) and the use of multi-level analyses to foster understanding of the mechanisms underlying the human mind and behavior.\n\n==Methods==\n\nA variety of techniques are used in social neuroscience to investigate the confluence of [[nervous system|neural]] and social processes, including [[Functional magnetic resonance imaging|Functional MRI]], [[Transcranial magnetic stimulation]], [[Event-related potential]]s, [[Electrocardiogram]]s, [[Electromyogram]]s, [[Galvanic skin response]], and studies of [[Ataxia#Focal lesions|Focal Brain Lesion]] patients.\n\n==Neurobiology of Persuasion==\n\nAttitudes and persuasion are among the central issues of social behavior.  One of the classic questions is when are attitudes a predictor of behavior.  Previous research suggested that selective activation of left prefrontal cortex might increase the likelihood that an attitude would predict a relevant behavior.  Using lateral attentional manipulation, this was supported. <ref> Drake, R. A., & Sobrero, A. P. (1987).  Lateral orientation effects upon trait behavior and attitude behavior consistency.  Journal of Social Psychology, 127, 639-651. </ref>\n\nAn earlier article showed that EEG measures of anterior prefrontal asymmetry might be a predictor of persuasion.  Research participants were presented with arguments that favored and arguments that opposed the attitudes they already held.  Those whose brain was more active in left prefrontal areas said that they paid the most attention to statements with which they agreed while those with a more active right prefrontal area said that they paid attention to statements that disagreed.  <ref> Cacioppo, J. T., Petty, R. E., & Quintanar, L. R. (1982).  Individual differences in relative hemispheric alpha abundance and cognitive responses to persuasive communications.  Journal of Personality and Social Psychology, 43, 623-636. </ref>  This is an example of defensive repression, the avoidance or forgetting of unpleasant information.  Research has shown that the trait of defensive repression is related to relative left prefrontal activation.  <ref> Tomarken, A. J., & Davidson, R. J. (1994).  Frontal brain activity in repressors and nonrepressors.  Journal of Abnormal Psychology, 103, 339-349. </ref>  In addition, when pleasant or unpleasant words, probably analogous to agreement or disagreement, were seen incidental to the main task, an fMRI scan showed preferential left prefrontal activation to the pleasant words <ref> Herrington, J. D., Mohanty, A., Koven, N. S., Fisher, J. E., Stewart, J. L., Banich, M. T., et al. (2005).  Emotion-modulated performance and activity in left dorsolateral prefrontal cortex.  Emotion, 5, 200-207.  </ref>\n\nOne way therefore to increase persuasion would seem to be to selectively activate the right prefrontal cortex.  This is easily done by monaural stimulation to the contralateral ear.  The effect apparently depends on selective attention rather than merely the source of stimulation.  This manipulation had the expected outcome: more persuasion for messages coming from the left <ref> Drake, R. A., & Bingham, B. R. (1985).  Induced lateral orientation and persuasibility.  Brain and Cognition, 4, 156-164. </ref>\n\n'
p98
tp99
a(I1
S'{{Infobox Scientist\n|box_width         = \n|name              = Harold Brooks\n|image             = \n|image_width       = \n|caption           = \n|birth_date        = [[March 11]], [[1959]]\n|birth_place       = [[St. Louis, Missouri]]\n|death_date        = \n|death_place       = \n|residence         = \n|fields            = [[Meteorology]]\n|workplaces        = [[National Severe Storms Laboratory]], [[University of Oklahoma]]\n|alma_mater        = [[University of Cambridge]], [[William Jewell College]] <br> [[Columbia University]] <br> [[University of Illinois at Urbana-Champaign]]\n|doctoral_advisor  = \n|academic_advisor  = \n|doctoral_students = \n|notable_students  = \n|known_for         = Severe convective storms, [[tornado climatology]], [[weather forecasting]]\n|influences        = \n|influenced        = \n|awards            = \n|footnotes         = \n}}\nHarold Edward Brooks (b. [[March 11]], [[1959]] in [[St. Louis, Missouri]]) is an American [[meteorologist]] whose research is concentrated on severe convective [[Thunderstorm|storms]] and [[tornado]]es, particularly severe weather [[climatology]], as well as [[weather forecasting]].<ref name=CV>{{cite web |last=Brooks |first=Harold  |title=Vita (no publications) |publisher=[[National Severe Storms Laboratory]] |url=http://www.nssl.noaa.gov/users/brooks/public_html/vita.html |accessdate=2008-04-02 }}</ref>\n\nBrooks began his higher education career at [[William Jewell College]], studying [[physics]] and [[mathematics]], achieving a B.A., summa cum laude, in 1982.  Whilst there he studied abroad at the [[University of Cambridge]], passing Part 1 of the [[tripos]] in [[Archaeology and Anthropology Tripos|Archaeology and Anthropology]] in 1980.  In 1985 he earned a M.A. and M.Phil. at [[Columbia University]] from the Atmospheric Sciences Program within the Department of Geological Sciences.  This was followed by doctoral studies at the [[University of Illinois at Urbana-Champaign]], culminating in a Ph.D. in [[atmospheric sciences]] in 1990.  During this period Brooks worked as a laboratory assistant, [[graduate assistant]], [[rapporteur]], and [[Research assistant|graduate research assistant]].  Brooks is a member of [[Sigma Xi]].\n\n'
p100
tp101
a(I-1
S'Social influence occurs when an individuals thoughts or actions are affected by other people. Social influence takes many forms and can be seen in [[conformity]], [[socialization]], [[peer pressure]], [[obedience (human behavior)|obedience]], [[leadership]], [[persuasion]], [[sales]], and [[marketing]]. Harvard psychologist, [[Herbert Kelman]] identified three broad varieties of social influence.<ref>Kelman, H. (1958). Compliance, identification, and internalization: Three processes of attitude change. Journal of Conflict Resolution, 1, 51-60.</ref> \n\n#[[Compliance]] is when people appear to agree with others, but actually keep their dissenting opinions private.\n#[[Identification]] is when people are influenced by someone who is liked and respected, such as a famous celebrity or a favorite uncle.\n#[[Internalization]] is when people accept a belief or behavior and agree both publicly and privately.\n\nMorton Deutsch and Harold Gerard described two psychological [[need]]s that lead humans to conform to the expectations of others. These include our need to be right (informational social influence), and our need to be liked (normative social influence).<ref>Deutsch, M. & Gerard, H. B. (1955). A study of normative and informational social influences upon individual judgment. Journal of Abnormal and Social Psychology, 51, 629-636.</ref> Informational influence is an influence to accept information from another as evidence about reality. Informational influence comes into play when people are uncertain, either because stimuli are intrinsically ambiguous or because there is social disagreement. Normative influence is an influence to conform to the positive expectations of others. In terms of Kelmans typology, normative influence leads to public compliance, whereas informational influence leads to private acceptance. \n\n== Factors ==\n=== Charisma ===\nSocial influence can also be described as [[Power (sociology)|power]] - the ability to influence a person/group of people to ones own will. Usually people who possess [[beauty]], significant sums of [[money]], good [[job]]s and so on will possess social influence on other, ordinary people. So even if the person doesnt possess any real or political power but possesses the things listed above (good looks, money, etc.), he could [[persuade]] other people into doing something. However, good looks are not solely why attractive people are able to exert more influence than average looking people, e.g. confidence is the by-product of good looks. Therefore, the individuals [[self-esteem]] and perceived [[Persona]] is the critical factor in determining the amount of influence one exerts.\n\n=== Reputation ===\nThose perceived as [[experts]] may exert social influence as a result of their perceived expertise.\nThis involves credibility, a form of social influence from which one draws upon the notion of trust.  People believe an individual to be credible for a variety of reasons, such as perceived experience, attractiveness, etc. Additionally, pressure to maintain ones reputation and not be viewed as fringe may increase the tendency to agree with the group, known as [[groupthink]].<ref>[http://www.nytimes.com/2009/03/05/books/05deba.html?scp=5&sq=Shiller%20groupthink&st=cse Ivory Tower Unswayed by Crashing Economy]. New York Times.</ref>\n\n=== Bully pulpit ===\nThose with access to the media may use this access in an attempt to influence the public. For example, a politician may use speeches to persuade the public to support issues that he or she does not have the power to impose on the public. This is often referred to as using the bully pulpit. \n\nAnother example would be [[movie star]]s, who do not usually possess any political power but are familiar to many of the worlds citizens and therefore possess [[social status]]. They get a lot of [[Mass media|media]] coverage and they have many enthusiastic [[fan (person)|fan]]s. {{Fact|date=May 2009}}\n\n=== Peer pressure ===\n\nIn the case of [[peer pressure]], a person is convinced to do something (such as [[illegal drugs]]) which they might not want to do, but which they perceive as necessary to keep a positive [[Interpersonal relationship|relationship]] with other people, such as their [[friend]]s.\n\n== Emotions ==\n\nIn 2009, a study concluded that fear increases the chance of agreeing with the group, while romance or lust increases the chance of going against the group.<ref>EurekAlert. (2009). [http://www.eurekalert.org/pub_releases/2009-03/ciot-csc032009.php Fear or romance could make you change your mind, U of Minnesota study finds].</ref>\n\n== Social trends ==\n\nIn his book, [[The Tipping Point]], Malcolm Gladwell discusses the way new ideas are transmitted by social influence. New products or fashions are introduced by innovators, who tend to be creative and nonconforming. Then early adopters join in, followed by the early majority. By this time, a substantial number of people are using the idea or product, and normative and informational influence encourages others to conform as well. The early majority is followed by a second group that Gladwell calls the late majority, and then finally by the laggards, who tend to be highly conventional and resistant to change.<ref>Gladwell, M. (2000). The Tipping Point: How Little Things Can Make a Big Difference, first published by Little Brown. ISBN 0-316-31696-2</ref>\n\n== Social Structure ==\n\nThere are varying social structures within online communities that determine the interaction between influencer and follower. <ref>[http://sparxoo.com/2009/10/01/differing-approaches-to-social-influence/ Differing Approaches to Social Influence]</ref> The following are classifications of social structures in which influencers operate:\n\nPyramid -- Reciprocity is not the primary objective in a pyramid-shaped social structure. Typically users have a passive relationship with one another. Often cited as a prime example of this social structure is [[Twitter]]. Influencers such as [[CNN]] and the [[NY Times]] garner millions of followers. It is these followers that provide the support structure for the influencers (the capstone to the pyramid). The more followers a user has, the larger their pyramid stands. \n\nCircular -- The central element in a circular social structure is [[reciprocity]]. Consider the analogy to [[Ring Around the Rosie]]. Users can identify and communicate with everyone in their immediate circle. [[Facebook]] is an often-cited example of a circular social structure. Where Twitter you might follow 300 [[brands]], typically Facebook users befriend only a select number of people or brands. \n \nHybrid -- This social structure combines the circular and pyramid-shaped community framework. Users will form micro-communities based on particular websites or topics. [[Digg]] is an example of a hybrid social structure. Within a category, there will emerge a tight group of influencers that ban together to promote content. \n\n\n'
p102
tp103
a(I-1
S'{{Merge|Generation gap|date=May 2009}}\n\nGenerational change is radical change that occurs in an [[organisation]] or a [[population]] as a result of its members being replaced over time by other individuals with different [[Value (personal and cultural)|value]]s or other [[characteristic]]s.\n\nGenerational change generally presents both a real and a perceived crisis. In an organisation, the unspoken cultural values held by the longer serving members may be challenged, threatened or abandoned by newer members. In an ecological system, generational change of the representatives of one species may threaten the survival of other species.  \n\nExamples include [[rock n roll]] in the [[1950s]] over the [[jazz music]] of [[1920]]-[[1945]], the [[counterculture]] in the [[1960s]] over the [[conservatism]] of the [[1950s]], and [[hip hop]] in the [[1990s]] and [[2000s (decade)|2000s]] over the [[rock music]] of the [[1970s]] and [[1980s]].\n\n'
p104
tp105
a(I1
S'Lt. Gen C. W. Wickersham was an author of [[philatelic literature]] of [[Venezuela]], which resulted in his being awarded the [[Lichtenstein Medal]], which is given to a living individual for outstanding service to philately, by the [[Collectors Club of New York]] in 1959. \n\n==Philatelic literature==\nWickersham authored philatelic literature based on his detailed studies of [[postage stamps]]. These included:\n* The Early Stamps of Venezuela by Lt. Gen. C. W. Wickersham, 1958,\n\n==Philatelic activity==\nNo data available.\n\n==Honors and awards==\nFor his work in the field of philately, Wickersham was provided the following award:\n* The [[Lichtenstein Medal]] in 1959\n\n'
p106
tp107
a(I1
S'Philippe Charbonneaux (1917-1998) was a [[France|French]] product designer, best-known for [[automobile|car]] and [[truck]] design, but also known for other products such as [[television set]]s. Many of his works are now exhibits in places such as [[Centre Georges Pompidou]] in Paris, or [[Museum of Modern Art]] in New York. He specialised in car design studies, so he has left many inventive prototypes. The prototype Ellipsis, he released just two years before his death, is still very fresh and modern. He designed for [[Renault]], [[Ford Motor Company|Ford]], [[Delahaye]], [[Berlet]], [[Bugatti]], and others.\n\nFamous pieces include the Tlavia Panoramic III TV set; the [[Renault 8]] in 1962; the [[Renault 16]] in 1965, which was a top-of-the-line family luxury car and Europes Car of the Year for 1965; and the [[Renault 21]] 1986.\n\nHis private collection of approximately 160 vintage cars, including [[racing car]]s, and 40 [[motorcycle]]s, donated to S.C.A.R. (Salon of Vintage Car Club Collectors in Rheims) is a basis of a [[Rheims]] [http://www.musee-automobile-reims-champagne.com Automobile Museum], established 1985.\n\n{{DEFAULTSORT:Charbonneaux, Philippe}}\n'
p108
tp109
a(I-1
S'{{BLP unsourced|date=September 2007}}\n\n{{Infobox Person\n| name   = Andrey KranK Kuzmin\n| image     = Andrey_KranK_Kuzmin.jpg\n| image_size     = 180px\n| caption  = Andrey KranK Kuzmin at the [[KRI conference]]\n| birth_date  = {{Birth date and age|1971|4|24|mf=y}}\n| birth_place = [[Kaliningrad, Russia]]\n| death_date  = \n| death_place = \n| occupation     = [[CEO]], [[Game designer]], [[Game producer]] at [[KranX Productions]]\n| spouse         = \n}}\n\nAndrey KranK Kuzmin (born [[April 24]] [[1971]], [[Kaliningrad]], [[Russia]]) is a Russian [[Game designer]], [[Game producer|producer]] and the co-founder of the game production company, [[KranX Productions]]. \n\nHe has developed first self-made game at school (graduated with honors) and graduated [[Kaliningrad State University]] as [[theoretical physicist]]. Being a student Andrey developed successful [[business software]] for big regional enterprises. At the upper courses he put together a team of enthusiasts [[K-Division]] to develop computer games and real-time technologies. In 1995 together with adherents he has created one of first independent Russian companies [[K-D Lab]] which has borrowed especially in [[game development|development of games]].\n\n==Activities==\n*1991-1994  creation of team of developers-enthusiasts [[K-Division]]. Team management, postgraduate study, active researches in the field of technologies and game processes.\n*1995-2004  establishment of the game development company [[K-D Lab]], CEO and co-owner. Development of original game concepts, unique technologies, works on scripts and own original game Universes, supervise over projects development, in-game music composing.\n\n2004-till now  establishment and management of the independent Russian game production company, [[KranX Productions]], as [[CEO]], [[game designer|designer]] and [[game producer|producer]].\n\n===Games, developed by Andrey===\n* [[Biprolex+]] (1997), the original combination of [[Tetris]] and [[Arkanoid]]. Game designer, lead programmer, project manager. During several months in 1996-97 [[Biprolex+]] was in Internet Top Download 40.\n* [[Surmap]] (1996-1997), the unique technology of detailed changeable landscape, which was used to develop the most of following companys projects. Ideologist and lead developer.\n* [[Vangers: One For The Road]] (1998), action/adventure/racing game with some RPG elements. Project manager, game designer, creator of Univang Universe, composer. The game was published worldwide by [[Interactive Magic]].\n* [[Spanking Runners]] (2001), arcade racing game. Game designer, author of the turn-based racing concept. The game was among the nine finalists of GDC IGF 2000. Till now it is a unique case of participation in this event of a team from [[Russia]].\n* [[Perimeter (video game)|Perimeter]] (2004), sci-fi [[Real-time strategy]] based on [[terraforming]] concept. Producer, author of idea, Universe creator, game designer. The game published worldwide by [[Codemasters]].\n\n==Awards==\n* 1996  Prize for games [[Trapoine]] and [[Tunnerve]] at festival of computer graphics and animations [[Anigraph]] \n* 1998  Gran-prix $200 000 at the [[ENIX Game Software Contest II]] for the game [[MOBL]] with Indirect management concept\n* 2003  [[Perimeter (video game)|Perimeter]] won Best Technology at the first Russian game gevelopers conference [[KRI conference]] in [[Moscow]]\n* 2004  [[Perimeter (video game)|Perimeter]] won Best PC Game, Best Game Design at the Russian game developers conference [[Russian Game Developers Conference|KRI]], and also nominee for Develop Industry Excellence Award in [[London]]\n\n==Participation==\n* Permanent judge and speaker at Russian game developers conference [[KRI]] since 2003\n* [[IGDA]] member\n* Regular participant of [[Game Developers Conference]], [[Electronic Entertainment Expo|E3]] and other large industrial events\n* [[Game Developers Conference]] Russia [http://www.gdcrussia.com/conference/board/ advisory board] member\n\n{{DEFAULTSORT:Kuzmin, Andrey}}\n'
p110
tp111
a(I-1
S'The Center for Computer Game Research is a research group at the [[IT University of Copenhagen]] that represents one of the major nodes of [[ludology]]. The Center for Computer Game Research is heavily involved in the journal Game Studies, and also hosted the 2005 iteration of the [[Digital Arts and Culture]] conference.\nResearchers affiliated with the Center include, among others:\n*[[Espen Aarseth]]\n*[[T. L. Taylor (scholar)|T. L. Taylor]]\n*[[Lisbeth Klastrup]]\n*[[Jesper Juul (video game theorist)|Jesper Juul]]\n*[[Gonzalo Frasca]]\n*[[Susana Tosca]]\n*[[Georgios Yannakakis]]\n*[[Anders Drachen]]\n*[[Julian Togelius]]\n\n'
p112
tp113
a(I1
S'<!-- Deleted image removed: [[Image:CowboysvsSteelers.jpg|320px|right|thumb|Electric Football Figurines, circa 1982|{{deletable image-caption|1=Sunday, 13 January 2008}}]] -->\nElectric football is a tabletop American football game played on a metal vibrating field.  \n\n==History==\nIn 1947, Tudor Games created electric football, using a vibrating car race game made by Tudor as the base for the game technology.  Electric football was an immediate hit.  More than 40 million of the games have been sold since its creation, and new editions are sold each year.\n\nWhile [[video game]]s of football have supplanted electric football in popularity due in part to issues with the game not living up to its potential due to lack of procedures and game structure, however electric football still thrives and has also benefitted from technological progress. Players became more realistic in sculpting and appearance but there has been very limited advancement in the game play.\n\nMiggle sells pre-painted players from 18 college teams, including home and away jerseys.   Leagues, clubs and tournaments continue to play the game.  The Electric Football League, headquartered in [[Highland Park, Illinois]], held its 12th annual Official Electric Football Super Bowl & Convention in January 2006.\n\n==The game==\nThe game is played on a small metal field, with plastic players placed on the field in formations, just as in real [[American Football|football]]. The ball is a football-shaped small piece of foam or felt. When the players are set up, a switch is activated that turns on a small electric motor which causes the field to vibrate, and moves the players around the field. The imagination then takes flight as players run around the board in an unpredictable manner that reflects and resembles the game of rugby more than actual football.  \n\nEach player is attached to a base, with prongs on the bottom that allow the player to move. Rookie bases are not adjustable and the player hopefully runs forward. Pro bases have a dial that you can turn to have players turn to the right or left.\n\nA special player called the Triple Threat Quarterback (TTQ) allows players to pass, punt or kick field goals. The ball has a slit that lets the game player place it on the TTQs arm. The arm is pulled back and released to pass the ball. Use of this figure is a very difficult skill to master and was the primary form of advancing the ball. \n\nFor kicking the ball is placed on a tee on the TTQ and a plastic leg is flicked to kick the ball.\n\n==In Popular Culture==\n*Steamroller Studios and Chillingo released their version of the classic game for the iPhone and iPod Touch in September of 2009. Called Super Shock Football It includes the ability to have the phone actually vibrate just like the original. You also have the ability to pass, kick, design custom plays, and throw laterals.\n*In the film [[Bill and Teds Bogus Journey]], the two main characters, in a parody of [[The Seventh Seal]], challenge [[Death (personification)|Death]] to a series of games in order to escape [[Hell]]. One of the games Death loses is electric football.\n*In an episode of the animated comedy series [[The Critic]], a clip from a [[Ken Burns]] documentary about electric football shows an elderly man saying that electric football is a metaphor for America: always shaking, always noisy, never really knowing where its going before suddenly changing his mind, saying, Wait a minute. Americas nothing like electric football. Its just a stupid game that doesnt even work! and yelling at the cameraman to get out.\n*In [[The Simpsons]] episode [[Bart Star]], while coaching his sons peewee football team, [[Homer Simpson]] uses an electric football table, even instructing one player to spin around in a circle. In [[Marge Be Not Proud]], comforting [[Bart Simpson|his son]] when his parents refuse to buy him a present, Homer offers these dubious words of advice:\n:I know what youre saying, Bart. When I was young, I wanted an electric football machine more than anything else in the world, and my parents bought it for me, and it was the happiest day of my life. Well, goodnight!\n*In [[Bill Bryson]]s The Life and Times of the Thunderbolt Kid: A Memoir, the author describes electric football as The worst toy of the decade [the 1950s], possibly the worst toy ever built...it took forever to set up each play because the men were so fiddly and kept falling over, and because you argued continuously with your opponent about what formations were legal and who got to position the final man...it hardly mattered how they were set up because electric football players never went in the direction intended.  In practice what happened was that half the players instantly fell over and lay twitching violently as if suffering from some extreme gastric disorder, while the others streamed off in as many different directions as there were upright players before eventually clumping together in a corner, where they pushed against the unyielding sides like victims of a nightclub fire at a locked exit.  The one exception to this was the running back who just trembled in place for five or six minutes, then slowly turned and went on an unopposed glide toward the wrong end zone until knocked over with a finger on the two-yard line by his distressed manager, occasioning more bickering. (hardcover version, page 113)\n\n'
p114
tp115
a(I-1
S'Conspicuous leisure is a term introduced by the American economist [[Thorstein Veblen]], in [[The Theory of the Leisure Class]] (1899).  The term denotes visible leisure for the sake of displaying social status. The term is generally reserved for those forms of leisure that seem to be fully motivated by social factors, such as taking long vacations to exotic places and bringing souvenirs back.  Conspicuous leisure is a symptom observed in individuals in all societies where [[Social stratification|stratification]] exists.  Veblens more well-known [[conspicuous consumption]] is a type of conspicuous leisure.\n\nVeblen argued that conspicuous leisure had deep historical roots reaching back into prehistory, and that it evolved into different forms as time passed. One example he gave was how, during the [[Middle Ages]], the [[nobility]] was exempted from manual labor, which was reserved for [[serfs]].\n\n'
p116
tp117
a(I-1
S'{{Demoscene}}\n[[Image:Bolognese - Alpha Design.jpg|right|thumb|Screenshot from the [[text mode demos|text mode demo]] Bolognese by [[Alpha Design]].  This demo was the first place winner of Text Mode Demo Contest 6 (2003).]]\n[[Image:libcaca-cacaplas.png|right|thumb|Screenshot from cacaplas, a small text mode demo using the ASCII-Art library [[libcaca]].]]\nText Mode demos are real-time calculated [[computer animation]]s which make use of the native text graphic mode(s) common on the [[IBM PC compatible]]s. The Text Mode Demo Scene is one of many different facets of the [[demoscene]].\n\n[[text mode|Text Mode]] as a medium offers several unique challenges for the creators of such a demo.  Similar to the constraints of [[ASCII art|ASCII]] and [[ANSI art]], the coder and artist both must take into consideration the limitations presented by text mode: a base resolution of 8025 blocks and a mere 16 fixed colors by default.\n\n==Pseudographic resolution==\n\nBy taking advantage of half blocks characters 220 (DCh) {{Unicode|&#x2584;}} (bottom half) or 223 (DFh) {{Unicode|&#x2580;}} (upper half) in the [[code page 437]] (adapters native) character set, one can effectively double the vertical resolution (from 8025 to 8050 in the default text mode).\n\n[[Enhanced Graphics Adapter]] ([[Enhanced Graphics Adapter|EGA]]) and better adapters natively support text modes beyond 8025 character cells: 8043 (EGA), 8050 ([[Video Graphics Array]], [[Video Graphics Array|VGA]]), 13250 and 13260 ([[VESA_BIOS_Extensions|VESA]] compatible [[Super VGA]]), etc., increasing the simulated graphic resolution available, doubled again through the half block characters.\n\nAlso, by [[tweaking]] the displays hardware, higher resolutions can be achieved. For example, a [[Color_Graphics_Adapter#The_160.C3.97100_16_color_mode|tweak mode]] can be set even in the original IBM [[Color Graphics Adapter]] ([[Color Graphics Adapter|CGA]]) to give an extra, non-standard 160100 pixels, 16-color graphic mode.\n\nCustom graphics and effects can also be achieved by customizing the character set (with the EGA and better adapters) on a per-[[pixel]] basis. Halving the available colors from 16 to 8, up to two customized character sets can be used simultaneously on screen with most [[Super VGA]] graphic cards, blurring the border between pure [[text mode]]s and true graphic modes.\n\n==Expanding colors==\n\nIn text mode, the blinking attribute effect is enabled by default, giving sixteen colors available for the foreground but only eight for the character cell background. By disabling the blinking effect, all 16 colors available can be used for both the background and the foreground of every character cell.\n\nCreatively making use of the 3 shaded block characters 176 (B0h) {{Unicode|&#x2591;}} (25% halftone), 177 (B1h) {{Unicode|&#x2592;}} (50% halftone)  and 178 (B2h) {{Unicode|&#x2593;}} (75% halftone) in the [[code page 437|CP437]] character set, one can achieve some interesting color combinations with the limited [[Palette (computing)|palette]].\n\nWith the EGA and the VGA the color palette can be expanded from the original fixed 16-color [[List_of_8-bit_computer_hardware_palettes#CGA|CGA palette]] to 16 out of 64 colors ([[List_of_16-bit_computer_hardware_palettes#EGA|EGA palette]]) or 16 out of 262,144 colors ([[List_of_16-bit_computer_hardware_palettes#MCGA_and_VGA|VGA palette]]), allowing smoother color transitions.\n\n==Text mode demoscene==\n\nThe first evident [[IBM PC compatible|IBM PC]] demo group to create text mode demos is said to be the Sorcerers.  The ever-popular [[Finland|Finnish]] group [[Future Crew]] also began by creating some innovative creations which took advantage of text mode, with text intros such as Yo! and Starport.\n\n[[tAAt]], a non-profit organization in [[Finland]], has been organizing a semi-annual competitive event for authors of textmode demos called the [[Text Mode Demo Contest]] (TMDC) from 1996 to 2007 inclusively. After they announced they wouldnt continue the annual competition after TMDC 10<ref name=its time to move on>Posted by Jari Kommpa on their [http://taat.fi/tmdc official website]</ref>, members of the [[Northern Dragons]] demogroup decided to take the organization of TMDC in charge<ref name=tmdc lives again>They announced it with an [http://www.pouet.net/prod.php?which=50325 invitation] in the form of a textmode demo, which won the demo competition at [http://www.demoparty.us Blockparty] in april 2008</ref>.\n\n'
p118
tp119
a(I-1
S'Duping refers to the practice of [[exploit (online gaming)|exploiting a bug]] in a [[video game]] to illegitimately create duplicates of unique items or currency in a [[persistent world|persistent online game]], such as an [[massively multiplayer online game|MMOG]].  Duping can vastly destabilize a [[virtual economy]] or even the gameplay itself, depending on the item duplicated and the rate at which duplication occurs.  Modern persistent world games include automated detection of duping.<ref name=zdnet-eq2>{{cite web \n| title=Cheaters slam Everquest II economy\n| author = [[Daniel Terdiman|Terdiman, Daniel]]\n| date=2005-08-11\n| url=http://news.zdnet.com/2100-1040_22-5829403.html\n| accessdate=2007-02-21}}</ref>\n\n==Effects==\n\nThe effect of duping on the games economy depends on whether an item or currency was being duplicated and to what degree the duping took place.  Currency dupes cause [[inflation]] and conversely item dupes cause the item to lose value.\n\n5 years ago in the [[MMORPG]] [[RuneScape]], an extremely rare item, the Purple Party hat was duped well over 2 million times; the effects are still seen today in the games economy. While [[Jagex]], the games owners, did everything they could to ban the duping users, the duped party hats are still circulating. Due to the fact that the discontinued items, party-hats, were no longer available, the purple party-hat being duped caused it to become the cheapest hat. While its price is still high for an item, it is considered the noobs party-hat.{{fact|date=October 2009}}\n\nWhen currency is duplicated, it increases the overall [[money supply|amount of money]] in the virtual economy and increases prices in player-to-player transactions.  In a 2005 case of currency duping in [[EverQuest II]], the games developers noticed an unexpected 20% rise in the total money found in the economy over a 24 hour period following the dissemination of the dupe.<ref name=zdnet-eq2 /> A significant currency dupe in [[Star Wars Galaxies]] was found after the designers compared how much money was created versus how much money was destroyed and noted that, despite more money leaving the system than entering, they observed no shortage of money in the virtual world.<ref name=Koster Stats>{{cite web | url=http://www.simbaspaws.org/Aziri/SWG/economy.htm | title=Economy Stats | last=Koster | first=Raph | authorlink=Raph Koster | date=2004-04-30 | accessdate=2009-10-08}}</ref>\n\nItem dupes generally have the opposite effect, causing the price of the duped items to drop as the [[supply and demand|supply]] of that item increases.\n\nIn addition to the effects on the game economy, the sudden influx of currency or items also affects players involved in [[real-money trading]].  In the EverQuest II case, the dupers attempted to sell the illegitimate currency on [[Station Exchange]] for real money and supposedly made over US$70,000 from online auctions.<ref name=zdnet-eq2 /> Dupes are highly prized among those involved in real-money trading,<ref name=Lee 05>{{cite web |url=http://www.1up.com/do/feature?cId=3141815 |title=Wage Slaves: From sweatshops to stateside corporations, some people are profiting off of MMO gold. |last=Lee |first=James |date=2005-07-05 |publisher=[[1UP.com]] |accessdate=2009-10-08}}</ref> and in this form it has been likened to [[counterfeit money|counterfeiting]] except with reduced risk.<ref name=Natkin>{{cite book | title=Video games and interactive media: a glimpse at new digital entertainment | last=Natkin | first=Stphane | publisher=AK Peters | year=2006 | isbn=1568812973 | page=62 | url=http://books.google.com/books?id=Huph6EeDVggC&pg=PA62#v=onepage&q=&f=false | accessdate=2009-10-08}}</ref>\n\n==Response==\n\nAs with other exploits, a common response to duping is to ban the involved players.  Banning players for duping can be controversial though depending on how the game developer determines a player to be involved in the dupe.  In [[Star Wars Galaxies]] some players learned how to dupe the currency.<ref name=Koster Stats />  [[Sony Online Entertainment]] (SOE) banned players who possessed duped currency.  It is alleged that people who were not directly involved in the exploit, but who accepted duped currency in legitimate trade were also banned.  In reaction to what was perceived to be an unjust punishment, several players joined a mass [[demonstration (people)|demonstration]] at a central location in the game world.  SOE responded to the disruption caused by the large gathering by [[teleportation|teleporting]] all [[player character]]s involved away from the demonstration area. A popular online [[urban legend]] is that many player characters were teleported into space, essentially killing them.<ref name=MMOsploitation>{{cite web | title=1up.com: MMOsploitation | author=Sharkey, Scott | date=2006-01-13 | url=http://www.1up.com/do/feature?cId=3146878 | accessdate=2007-02-21}}</ref> Although evidence as to whether or not this occurred cannot be substantiated, it has been voiced in many popular gaming avenues, such as [[Penny Arcade (webcomic)|Penny Arcade]].<ref name=pa-swg>{{cite web | author=Holkins, Jerry | coauthors=Mike Krahulik | title=Penny Arcade: This Is An Allegory | url=http://www.penny-arcade.com/comic/2004/08/25 | date=2004-08-25 | accessdate=2007-02-21}}</ref>\n\nAnother method to mitigate the effects of duping would be a [[rollback (data management)|rollback]], in which game data is reset to an earlier data backup prior to the first known instance of duping.  This can include all game data or be limited to specific items, characters, or other means determined to be involved in the duping.  Significant rollbacks can be a highly unpopular decision with the players and is best done before much time has passed.  Similarly, SOE was able to track and remove the duped currency in EverQuest II.<ref name=zdnet-eq2 />\n\nThe virtual world designers may find more natural ways to remove the offending currency or items from the game. In Star Wars Galaxies the legitimate economy had been losing money faster than money was being created due to a variety of [[money sink]]s. After the dupe bug was fixed and trillions of potentially duped in-game currency deleted, the designers decided to let the economy to continue running at a net loss until the levels could return to normal.<ref name=Koster Stats />\n\nAn immediate, although often temporary, step to prevent further issues from duping calls for aspects of the game to be disabled until the exploit can be addressed permanently.  SOE stopped Station Exchange auctions to prevent the dupers from selling the illegitimate EverQuest II currency.<ref name=zdnet-eq2 />\n\n==Other notable cases==\n\nThe video game [[Phantasy Star Online Episode I & II]] had a duping glitch, which was activated by talking repeatedly with a walking NPC and a merchant. Because the characters and data of the game were saved on memory cards, [[SEGA]] could not remove the duping glitch, and the online game was filled with duped items and money.\n\n'
p120
tp121
a(I1
S'Skoolies or Schoolies is a term that refers to either those who convert [[school bus]]es into [[recreational vehicles]], or to the converted buses themselves.\n\n== Conversion ==\nMost schoolie conversions to RVs involve a specific series of steps, not necessarily in this order:\n* Removal of seats\n* Installation of 110 VAC electrical system, generator/inverter, solar system, extra batteries, etc.\n* Installation of plumbing, including:\n** Fresh water tank\n** [[Grey water]] tank\n** [[Blackwater (waste)|Black water]] tank\n** Pump\n** Shower\n* Insulation of the floor, walls and/or ceilings\n* Installation of replacement flooring\n* Installation of furniture, cabinetry and appliances\n* Exterior cosmetic changes (paint, etc)\n\nSome schoolies also undergo some more dramatic structural changes, often to improve the sometimes limited head room, as the inside of most school buses at the middle is 61 (1.85 m).  Raising the roof on schoolies is a relatively common modification, and some enthusiasts even go so far as to remove the entire roof and replace it with an entirely new custom roof, usually much higher (See [[Vista-Dome]]).  Some buses also have had other vehicles grafted to them, had RV slide-out sides installed, or have included [[Jacuzzi]]s.\n\n== Legality ==\nThere are varying regulations in different states in the United States that affect the conversion of a school bus into an RV.  Some states require that the buss signaling equipment (stop sign, flashing lights, etc.) be removed and the [[school bus yellow]] paint scheme be changed.  Other states simply require that the School Bus signage at the top front and rear be removed.\n\n== Insurance ==\nAlthough more difficult to insure than the family sedan, skoolies are not difficult to insure. While many large insurance companies have no provision in their automated systems for modified or re-purposed vehicles, numerous insurance companies value the business.\n\n'
p122
tp123
a(I-1
S'Bruce Hood is a [[United Kingdom|British]] experimental [[psychology|psychologist]] who teaches at [[Bristol University]]. He is well known for his ideas on [[Human condition|humans]] being hard-wired for [[religion]]<ref>[http://www.guardian.co.uk/world/2006/sep/04/religion.uk Humans hardwired for religion]</ref>.\n\n==Publications==\n* Supersense: Why We Believe in the Unbelievable, HarperOne (April 2009) ISBN 978-0061452642 and paperback, Constable (May 2009) ISBN 978-1849010306\n\n'
p124
tp125
a(I-1
S'Formal organization is a fixed set of rules of intra-[[organization]] procedures and structures. As such, it is usually set out in writing, with a language of [[wiktionary:rule|rules]] that ostensibly leave little discretion for [[interpretation (logic)|interpretation]]. In some societies and in some organization, such rules may be strictly followed; in others, they may be little more than an empty formalism.\n== Reasons for the existence of the formal organization ==\n* To facilitate the accomplishment of the goals of the organization: In a formal organization the work is delegated to each individual of the organization. He/She works towards the attainment of definite goals, which are in compliance with the goals of the organisation. \n* To facilitate the co-ordination of various activities: The authority, responsibility and accountability of individuals in the organization is very well defined. Hence, facilitating the co-ordination of various activities of the organisation very effectively. \n* To aid the establishment of logical authority relationship: The responsibilities of the individuals in the organisation are well defined. They have a definite place in the organisation due to a well defined hierarchical structure which is inherent in any formal organisation. \n* Permit the application of the concept of specialization and division of Labour, division of work amongst individuals according to their capabilities helps in greater specializations and division of work. \n* Create more group cohesiveness \n== Characteristics of a formal organisation ==\n* Well defined rules and regulation \n* Arbitrary structure \n* Determined objectives and policies \n* Status Symbol \n* Limitation on the activities of the individual \n* Strict observance of the principle of Co-ordination\n\n==Distinction from [[informal organization]]==\n\nFormal rules are often adapted to subjective interests &mdash; social structures within an [[Organization|enterprise]] and the personal goals, desires, sympathies and behaviors of the individual workers &mdash; so that the practical everyday life of an organization becomes informal. Practical experience shows no organization is ever completely rule-bound: instead, all real organizations represent some mix of formal and informal. Consequently, when attempting to legislate for an organization and to create a formal structure, it is necessary to recognize informal organization in order to create workable structures. However, informal organization can fail, or, if already set in order, can work against mismanagement.\n\n<blockquote>Formal organizations are typically understood to be systems of coordinated and controlled activities that arise when work is embedded in complex networks of technical relations and boundary-spanning exchanges. But in modern societies, formal organizational structures arise in highly institutional contexts. Organizations are driven to incorporate the practices and procedures defined by prevailing rationalized concepts of organizational work and institutionalized in society. Organizations that do so increase their legitimacy and their survival prospects, independent of the immediate efficacy of the acquired practices and procedures. There can develop a tension between on the one hand, the institutionalized products, services, techniques, policies, and programs that function as myths (and may be ceremonially adopted), and efficiency criteria on the other hand. To maintain ceremonial conformity, organizations that reflect institutional rules tend to buffer their formal structures from the uncertainties of the technical activities by developing a [[loose coupling]] between their formal structures and actual work activities.  - (John Meyer and Brian Rowan, 1976)</blockquote>\n\n==The Hawthorne Experiments==\nThe deviation from rulemaking on a higher level was documented for the first time in the [[Hawthorne studies]] (1924-1932) and called informal organization. At first this discovery was ignored and dismissed as the product of avoidable errors, until it finally had to be recognized that these unwritten laws of work of everyday life often had more influence on the fate of the enterprise than those conceived on [[organizational chart]]s of the [[executive level]]. Numerous empirical studies in [[sociology|sociological]] [[organization research]] followed, ever more clearly proving this, particularly during the [[Human Relations Movement]]. It is important to analyze informal structures within an enterprise to make use of positive innovations, but also to be able to do away with bad habits that have developed over time.\n\n==Reasons for informal organization==\n\nThere are many different reasons for [[informal organization]]:\n\n*Informal standards: personal goals and interests of workers differ from official organizational goals.\n*Informal communication: changes of [[communication]] routes within an enterprise due to personal relations between coworkers.\n*Informal group: certain groups of coworkers have the same interests, or (for example) the same origin. \n*Informal leaders: due to [[charisma]] and general popularity, certain members of the organization win more influence than originally intended.\n*Different interests and [[preferences]] of coworkers.\n*Different status of coworkers.\n*Difficult work requirements.\n*Unpleasant conditions of work.\n\n[[Managerial]] [[organization theory]] often still regards informal organization as rather disturbing, but sometimes helpful. In the opinion of [[systems theory]] and [[cybernetics]], however, formal organization fades into the background and only serves, if necessary, to supplement or to correct. Changes in structure always redevelop because of the conduct and differences among coworkers, and the ability of self-organization is recognized as a natural characteristic of a social system.\n\n'
p126
tp127
a(I-1
S'In [[economics]], the cycle of poverty is the set of factors or events by which poverty, once started, is likely to continue unless there is outside intervention.<ref name=Hutchinson/> \n\nThe cycles of poverty has been defined as a phenomenon where poor families become trapped in poverty for at least three generations.  These families have either limited or no resources. There are many disadvantages that collectively work in a circular process making it virtually impossible for individuals to break the cycle. <ref> Marger (2008). Examples of these disadvantages working in a circular process would be: economic decline, low personal income, no funds for school, which leads to lack of education. The lack of education results in unemployment and lastly low national productivity. Social Inequality: Patterns and Processes. McGraw Hill publishing. 4th edition. ISBN 0073528153</ref> This occurs when [[poverty|poor people]] do not have the resources necessary to get out of poverty, such as [[financial capital]], [[education]], or connections. In other words, [[poverty]]-stricken individuals experience disadvantages as a result of their poverty, which in turn increases their poverty. This would mean that the poor remain poor throughout their lives. <ref name=Hutchinson> [http://encyclopedia.farlex.com/Cycle+of+poverty Hutchinson Encyclopedia], Cycle of poverty </ref>  This cycle has also been referred to as a pattern of behaviors and situations which cannot easily be changed. <ref>Valentine, C. A. Culture and Poverty. University of Chicago: London, 1968.</ref>\n\nThe poverty cycle is usually called development trap when it is applied to countries. <ref name=Hutchinson/> \n\nDr. Ruby K. Payne distinguishes between situational poverty, which can generally be traced to a specific incident within the lifetimes of the person or family members in poverty, and generational poverty, which is a cycle that passes from generation to generation, and goes on to argue that generational poverty has its own distinct culture and belief patterns. <ref>Payne, R. (2005). A framework for understanding poverty (4th edition). Highland, TX: aha! Process, Inc.</ref>\n\n__TOC__ \n\n==Causes of the Cycle==\n===<small>Family Background</small>===\nA 2002 research paper titled The Changing Effect of Family Background on the Incomes of American Adults analyzed changes in the determinants of [[family income]] between 1961 and 1999,\nfocusing on the effect of parental [[education]], occupational rank, [[income]], marital status,\nfamily size, region of residence, [[Race (classification of human beings)|race]], and [[ethnic group|ethnicity]]. The paper (1) outlines a simple framework for thinking about how family background affects childrens family and [[income]], (2) summarizes previous research on trends in intergenerational inheritance in the United States, (3) describes the data used as a basis for the research which it describes, (4)  discusses trends in [[inequality]] among parents, (5) describes how the effects of parental [[inequality]] changed between 1961 and 1999, (6) contrasts effects at the top and bottom of the distribution, and (7) discusses whether intergenerational correlations of zero would be desirable.  The paper concludes by posing the question of whether reducing the intergenerational correlation is an efficient strategy for reducing [[poverty]] or [[inequality]]. When improving the skills of disadvantaged children is relatively easy, it is an attractive strategy. However, judging by American experience since the 1960s, improving the skills of disadvantaged children is far from easy. As a result, the paper suggests, there are probably cheaper and easier ways to reduce [[poverty]] and [[inequality]], such as supplementing the wages of the poor or changing [[immigration]] policy so that it drives down the relative wages of skilled rather than unskilled workers. These alternative strategies would not reduce intergenerational correlations, but they would reduce the economic gap between children who started life with all the disadvantages instead of all the advantages.<ref>{{Citation\n|url=http://press.princeton.edu/titles/7838.html\n|title=Family Background and Economic Success\n|editor1=Samuel Bowles\n|editor2=Herbert Gintis\n|editor3=\n|chapter=The Changing Effect of Family Background\n|chapter-url=http://www.webcitation.org/query?url=http%3A%2F%2Fwww.ksg.harvard.edu%2Finequality%2FSeminar%2FPapers%2FJencks.pdf&date=2008-01-04\n|first=Christopher \n|last=Jencks\n|coauthors=David J. Harding, Leonard M. Lopoo, Susan E. Mayer\n|publisher=Princeton University Press\n|year=2008\n|isbn=0691136203}}</ref>\n\nAnother paper, titled Do poor children become poor adults?, which was originally presented at a 2004 symposium on the future of children from disadvantaged families in France, and was later included in a 2006 collection of papers related to the theme of the dynamics of [[inequality]] and [[poverty]], discusses generational [[Economic mobility|income mobility]] in [[North America]] and [[Europe]]. The paper opens by observing that in the [[United States]] almost one half of children born to low [[income]] parents become low [[income]] adults, four in ten in the [[United Kingdom]], and one-third in [[Canada]]. The paper goes on to observe that rich children also tend to become rich adults &mdash; four in ten in the U.S. and the U.K., and as many as one-third in Canada. The paper argues, however, that [[money]] is not the only or even the most important factor influencing intergenerational [[income]] mobility and that the rewards to higher skilled and/or higher educated individuals in the [[labour economics|labor market]] and the opportunities for children to obtain the required skills and credentials are two important factors; reaching the conclusion that [[income]] transfers to lower [[income]] individuals may be important to children in the here in now, but they should not be counted on to strongly promote generational [[Economic mobility|mobility]]. The paper recommends that governments focus on investments in children to ensure that they have both the skills and opportunities to succeed in the labor market, and observes that though this has historically meant promoting access to higher and higher levels of [[education]], it is becoming increasingly important that attention be paid to [[preschool education|preschool]] and early childhood [[education]].<ref>{{Citation\n|url=http://books.google.com/books?id=mJlKOHGaSaAC\n|title=Dynamics of Inequality and Poverty\n|editor1-first=John \n|editor1-last=Creedy\n|editor2-first=Guyonne \n|editor2-last=Kalb\n|pages=143188\n|chapter=Do Poor Children Become Poor Adults\n|chapter-url=http://books.google.com/books?id=mJlKOHGaSaAC&pg=PA143&ei=KdZ-R9TFFouotAOEvLWcCw&sig=xujAA5avuWMdAZ-4zoXFhv_tMHE#PPA143,M1\n<!-- alternate url for chapter content: http://web.archive.org/web/20040620034722/http://www.cerc.gouv.fr/meetings/colloque_avril2004/Corak.pdf -->\n|last=Corak\n|first=Miles\n|publisher=Elsevier\n|year=2006\n|isbn=0762313501}}</ref>\n\nAccording to a study done by Susan Mayer, Associate Professor in the Irving B Harris Graduate School of Public Policy Studies, increasing family income alone is not enough to break the cycle of poverty. She found that children who were ahead in school were usually those who had been read to as children but she also found that reading to ones children was a value that parents had based on their interests and not their income. Her study found that increasing parents income had little to no effect on reading and math test scores, it increased the number of years children attend school by only one-fifth of a year, and it did nothing to decrease the amount of time sons are idle as young adults. Susan Mayer concluded her study by stating that in order to break the cycle of poverty there needed to be changes in the family values in order to promote education and hard work to children.<ref>Mayer, Susan. Breaking the Cycle of Poverty. Chicago Chronicle 16 (1997). University of Chicago. 4 Mar. 2009 <http://chronicle.uchicago.edu/970417/mayer.shtml>.</ref>\n\n===<small>Effects of Modern Education</small>===\nResearch shows that [[school]]s with students that perform lower than the norm are also those hiring least-qualified teachers as a result of new teachers generally working in the area that they grew up in. This leads to certain schools not producing many students that go on to college. Students from these schools that go on to be college graduates are not as skilled as they would be if they had gone to a school with higher-qualified instructors. This leads to [[education]] perpetuating a cycle of [[poverty]]. The individuals that choose to work in the schools close to them does not adequately supply the [[school]] with enough teachers. The schools must then outsource their teachers from other areas. Susan Loeb from the School of Education at Stanford did a study and found that teachers who are brought in from the suburbs are 10 times more likely to transfer out of the [[school]] after their initial year. The fact that the teachers from the suburbs leave appears to be an influential factor for schools hiring more teachers from that area. The lack of adequate [[education]] for children is part of what allows for the cycle of [[poverty]] to continue. <ref> Society for The Advancement of Education: MODERN EDUCATIONS CYCLE OF POVERTY. USA Today Magazine Sep. 2006: Vol. 135 Issue 2736, p6-7.</ref>\n\n===<small>Culture of Poverty</small>===\nAnother theory for the perpetual cycle of poverty is that poor people have their own culture with a different set of values and beliefs which keep them trapped within that cycle generation to generation. This theory has been explored by Ruby K. Payne in her book A Framework for Understanding Poverty. In this book she explains how there is a class system in the United States where there is a wealthy upper class, a middle class, and the working poor class. These classes each have their own set of rules and values which differ from each other. In order to understand the culture of poverty and how the poor classs set of rules tend to keep them trapped in this continual cycle Payne describes these rules and how they affect the poor class. Time is something that is treated differently by the poor; they generally do not plan ahead but simply live in the moment which keeps them from saving money which will help their children escape poverty. \n\nPayne expresses how important it is when working with the poor to understand their unique cultural differences so that one does not get frustrated but instead tries to work with them on their ideologies and help them to understand how they can help themselves and their children escape the cycle. One aspect of generational poverty is a learned helplessness that is passed from parents to children and on down the line. This learned helplessness can be explained as the ideology that there is no way for one to get out of poverty and so in order to make the best of their situation one must live in the moment and experience what they can when they can. This leads to people spending money right as they get it and teaches children to do the same which also creates a trap for children keeping them and their children in poverty. Another important point Payne makes is that leaving poverty is not as simple as acquiring a lot of money and moving up but also includes giving up relationships in exchange for achievement. This helps to explain why the culture of poverty tends to keep families in poverty from generation to generation as this is the culture they know and the relationships they have are all within that class.\n<ref>Payne, Ruby K. Framework for understanding poverty. Highlands, Tex: Aha! Process, 2005.</ref>\n\nThe culture of poverty theory has been debated and critiqued by many people including Eleanor Burke Leacock (and others) in her book The Culture of Poverty: A Critique.<ref>Leacock, Eleanor B. (Ed.) The Culture of Poverty: A Critique. New York: Simon & Schuster, 1971.</ref>  Leacock claims that people who use the term, culture of poverty only contribute to the distorted characterizations of the poor.  Aligning with Leacocks beliefs on the subject, Michael Hannan in an essay <ref>Dugan, Dennis J., Leahy, William H. Perspectives on Poverty. New York: Praeger, 1973.</ref> argues that the culture of poverty is essentially untestable.  This is due to many things including the highly subjective nature of poverty and issues concerning the universal act of classifying only some impoverished people as trapped in the culture.\n\n=== Life shocks ===\n\n[http://www.nzherald.co.nz/nz/news/article.cfm?c_id=1&objectid=10390891| 2004 research in New Zealand] [http://media.nzherald.co.nz/webcontent/document/pdf/living-standards-2004.pdf| produced a report] that showed that life shocks can be endured only to a limited extent, after which people are much more likely to be tipped into hardship. The researchers found very little differences in living standards for people who have endured up to 7 negative events in their lifetime. People who had 8 or more life shocks were dramatically more likely to live in poverty than those who had 0 to 7 life shocks. A few of the life shocks studied were:\n\n* Marriage (or similar) break-ups ([[divorce]])\n* Forced sale of house\n* Unexpected and substantial drop in income\n* [[Eviction]]\n* [[Bankruptcy]]\n* Substantial financial loss\n* Redundancy (being laid off from a job)\n* Becoming a sole parent\n* 3 months or more unemployed\n* Major damage to home\n* House burgled\n* Victim of violence\n* [[Incarceration]]\n* A non-custodial sentence ([[community service]], or fines, but not imprisonment)\n* Illness lasting three weeks or more\n* Major injury or health problem\n* Unplanned pregnancy and birth of a child\n\nThe study focused on just a few possible life shocks, but many others are likely as traumatic or more so. Chronic [[Posttraumatic stress disorder|PTSD]], [[complex post-traumatic stress disorder|complex PTSD]], and [[Depression (mood)|depression]] sufferers could have innumerable causes for their mental illness, including those studied above. The study is subject to some criticism<ref>http://www.nzherald.co.nz/social-welfare/news/article.cfm?c_id=322&objectid=10391334</ref>\n\n==Tracking ( How it perpetuates the cycle )==\nHistory in the United States has shown that Americans saw [[education]] as the way to end the perpetual cycle of [[poverty]]. In the present, children from low to middle income households are at a disadvantage. They are twice as likely to be held back and more likely to not graduate from high [[school]]. Recent studies have shown that the cause for the disparity among academic achievement results from the schools structure where some students succeed from an added advantage and others fail as a result of lacking that advantage. Educational institutions with a learning disparity are causing [[education]] to be a sustaining factor for the cycle of [[poverty]]. One prominent example of this type of [[school]] structures is tracking.\n[[Tracking (education)|Tracking]] is predominantly used to help organize a classroom, so that there the [[Statistical dispersion|variability]] of academic ability in classes is decreased. Students are tracked based on their ability level, generally based on a standardized test after which they are given different course requirements. Some people believe that [[Tracking (education)|tracking]] enhances academic achievement and improves the self-concept of students by permitting them to progress at their own pace. <ref name=Ansalone> Ansalone, George. Poverty, Tracking, and the Social Construction of Failure: International Perspectives on Tracking. Journal of Children & Poverty 9.1 (2003): 3.</ref>\n\nThe negative side is that studies have shown that tracking decreases students opportunity to learn. Tracking also has a disproportionate number of [[Latino]]s and [[African American]]s that have low [[socioeconomic status]] in the lower learning tracks. Tracking separates [[social class]]es putting the poor and [[minority group|minority]] children in lower tracks where they receive second-rate [[education]], and the students that are better off are placed in upper tracks where they have many opportunities for [[Goal|success]]. Studies have found that in addition to the higher tracks having more extensive curriculum, there is also a disparity among the teachers and instructional resources provided. There appears to be a race/class bias which results in intelligent children not receiving the skills or opportunities needed for success or social/economic mobility, thus continuing the cycle of [[poverty]]. There is an overall perception that American education is failing and research has done nothing to counter this statement, but instead has revealed the reality and severity of the issue of the existence of tracking and other structures that cause the cycle of [[poverty]] to continue.<ref name=Ansalone/>\n\n==Theories and Strategies for Breaking the Cycle of Poverty==\nWhile many governmental officials are still trying to find an answer to [[poverty]], many states and localities are making an effort to break the cycle. Mayor [[Michael Bloomberg|Bloomberg]] of New York City has been advocating a plan where parents are paid up to $5000 a year for meeting certain goals that will better their lives. This policy was modeled after a [[Mexico|Mexican]] initiative that aims to help poor families make better decisions that will help them in the long-term and break cycle of [[poverty]] and dependence that have been known to last for lifetimes. In addition, many states also have been making an attempt to help break the cycle. For example, a bill has been proposed in the California Assembly that would establish an advisory Childhood Poverty Council to develop a plan to reduce child [[poverty]] in the state by half by 2017 and eliminate it by 2027. <ref name=Billitteri>Billitteri, Thomas. States and Localities.  CQ Researcher 17.31 (2007): 738-739.</ref> Even when the plan has [[poverty]] reduction as the goal, a rise in child [[poverty]] might be the reality for many states as it was in Connecticut. States are attempting to not only decrease the number of people in the cycle of [[poverty]], but to also adjust the stringent work requirements that resulted from Congresss [[Social welfare provision|welfare]] reform. The tougher work restrictions have upset many poverty advocates that believe the new regulations prevent individuals that are vulnerable or that lack skills from preparing for work. California Democrat Representative McDermott believes as a result of this and other effects of the new limitations, it has been harder for individuals to escape a life of [[poverty]]. <ref name=Billitteri/>\n\nIn his book Children in Jeopardy: Can We Break the Cycle Irving B. Harris discusses ways in which children can be helped to begin breaking the cycle of poverty. He stresses the importance of starting early and teaching children the importance of education from a very young age as well as making sure these children get the same educational opportunities as students who are richer. Family values such as nurturing children and encouraging them to do well in school need to be promoted as well as a non-authoritarian approach to parenting. Harris also discusses the importance of discouraging teenage pregnancy and finding ways in which to decrease this phenomenon so that when children are born they are planned and wanted and thus have a better chance at breaking the cycle of poverty. <ref>Harris, Irving B. Children in jeopardy can we break the cycle of poverty? New Haven: Yale Child Study Center, Distributed by Yale UP, 1996.</ref>\n\nThe [[Harlem Childrens Zone]] is working to end generational poverty within a 100-block section of [[Harlem]] using an approach that provides educational support and services for children and their families from birth through college.<ref name=TheHczProject>{{cite web \n| url=http://hcz.org/programs/the-hcz-project \n| title=The Harlem Childrens Zone Project: 100 Blocks, One Bright Future \n| accessdate=2008-10-12\n| work=The Harlem Childrens Zone website\n}}</ref>\nThis approach has been recognized as a model by the [[Presidency of Barack Obama|Obama administration]]s anti-poverty program.<ref name=Obama20Promise>{{cite web\n| url=http://www.barackobama.com/issues/poverty/index_campaign.php#concentrated-poverty\n| title=Barack Obama and Joe Bidens Plan to Combat Poverty\n| date=Fall 2008\n| work=Obama-Biden website\n| accessdate=2009-06-05\n}}</ref>\n\n==Effects on Children==\n\nChildren are most at the mercy of the cycle of poverty.  Because a child is dependent on his or her guardian(s), if a childs guardian is in poverty, then they will be also.  It is almost impossible for a child to pull him or herself out of the cycle due to age, lack of experience, lack of a job, etc.  Because children are at such a young and impressionable age, the scars they gain from experiencing poverty early in life inevitably carry on into their adult life.  Childhood lays the foundations for adult abilities, interests, and motivation. <ref>Ashworth, K., Hill, M., & Walker, R. (1994) Patterns of Childhood Poverty: New Challenges for Policy. Journal of Policy Analysis and Management, 13(4)</ref>  Therefore, if they learn certain poverty-related behaviors in childhood, the behaviors are more likely to perpetuate.\n\nStudies have shown that household structure sometimes has a connection to childhood poverty.  Most studies on the subject also show that the children that are in poverty tend to come from single-parent households (most often matriarchal).  In 1997, nearly 8.5 million (57%) poor children in the US came from single-parent households. <ref>Lichter, D.T. (1997) Poverty and Inequality Among Children. Annual Review of Sociology.</ref>  With the rate of divorce increasing and the number of children born out of wedlock increasing, the number of children that are born into or fall into single-parent households is also increasing. Even though this does not mean that the child/children will be impoverished because of it.\n\nAccording to Ashworth, Hill, & Walker (2004), both urban and rural poor children are more likely to be isolated from the nonpoor in schools, neighborhoods, and their communities.  Human nature is to have relationships with others but when a child is isolated due to their socioeconomic status, its hard to overcome that when the status doesnt improve.  Therefore, poor children also have more tense relationships which sometimes results in abnormal behavior, acting out, or other unexplained behaviors.\n\nThere have been programs developed to specifically address the needs of poor children. [[Francis Marion University]]s Center of Excellence to Prepare Teachers of Children of Poverty has a number of initiatives devoted to equipping teachers to be more effective in raising the acheivement of children of poverty. Located in South Carolina, the Center provides direct teacher training as well as facilitates research in the area of poverty and scholastic acheivement.\n\n'
p128
tp129
a(I1
S'{{otheruses|Substrate}}\n\n[[Image:bubaq.jpg|thumb|270px|right|Gravel in a freshwater aquarium]]\nThe substrate of an [[aquarium]] refers to the material used on the tank bottom.  It can affect water chemistry, filtration, and the well-being of the aquariums inhabitants, and is also an important part of the aquariums aesthetic appeal. The appropriate substrate depends on the type of aquarium; the most important parameter is whether the aquarium contains [[fresh water]] or [[sea water|saltwater]].\n\n==Functions and considerations==\nSubstrate is used in most aquaria, and is primarily aesthetic. However, it can have a greater effect than decoration, and can affect the health of aquarium inhabitants. For example, darker colors are considered to be better for fish, as they will display more colorfully and are less likely to be timid and shy.<ref name=Sanford/><ref name=Axelrod>{{cite book | title = Exotic Tropical Fishes | last = Axelrod | first = Herbert, R. | publisher = T.F.H. Publications | year = 1996 | isbn = 0-87666-543-1}}</ref>\n\nSome substrates are used to alter water chemistry. Crushed coral and coral sand both contain [[calcium carbonate]], which will raise the [[carbonate hardness]] and buffer the [[pH]]. [[Peat]] may be used in some aquaria to mimic some [[soft water]] habitats.\n\nSubstrate may also be used as part of a biological filtration system. Beneficial bacteria colonize all aquarium surfaces that are exposed to aerated water, including the substrate. Because the numerous particles have a high surface area, substrates are often employed in biological filtration. Some common types of filtration involving the substrate include the [[undergravel filter]] and the [[deep sand bed]].\n\nPlanted tanks require a substrate that will remain loose enough for plant roots to penetrate it.  The substrate should be chemically inert and free of sharp edges. Fine gravel (12 mm) is preferred by some aquarists because coarser substrates allow debris to settle within the gaps between grains, which is particularly difficult to clean in a planted aquarium. Sloping the substrate so it is most shallow in front accommodates larger plants with correspondingly larger root systems in the back. The substrate for plants should be at least 5 [[centimeter|cm]] (2 [[inch|in]]) deep. Often, a lower layer of richer substrate such as potting soil, peat, vermiculite, or certain types of clay are used as a source of iron and trace elements for plant roots.<ref name=Randall>{{cite web | last=Randall | first = Karen| title=A Look At Substrate| work=The Krib | url=http://www.thekrib.com/Plants/Fertilizer/substrate-randall.html | accessdate=2006-06-08}}</ref><ref name=handbook />\n\nIn breeding tanks for egg-scattering species, a layer of marbles is sometimes used as a substrate, allowing the eggs to fall into the gaps between the marbles where the parents cannot eat them.<ref name=zebrafish>{{cite web | title=Breeding Zebrafish | format=Chapter 2 | author=S. Russell | work=The Zebrafish Book | url=http://zfin.org/zf_info/zfbook/chapt2/2.6.html | accessdate=2006-05-02}}</ref> Quarantine tanks (sometimes called hospital tanks) often use no substrate at all. This assists in keeping the aquarium as clean as possible as well as monitoring of fish excrements.<ref name=tropical tank>{{cite web | title=Substrate Materials | work=The Tropical Tank | url=http://www.thetropicaltank.co.uk/substrat.htm | accessdate=2006-05-02}}</ref>\n\n==Types of substrate==\nFor [[fresh water|freshwater]] aquaria, gravel is the most common substrate. To prevent damage to fish, gravel should not be sharp. Aquarium gravel can be as coarse as pea-sized or as fine as 12 [[millimeter|mm]].<ref name=Sanford>{{cite book | title = Aquarium Owners Guide | last = Sanford | first = Gina | publisher = [[DK Publishing]] | location = New York | date = 1999 | isbn = 0-7894-4614-6 | page = 172}}</ref> It is available in a number of colors, and may be naturally colored or dyed, and may have a polymer seal to ensure it does not affect water chemistry.<ref name=Sanford/> Gravel sold specifically for use in aquaria is chemically inert. It is commonly composed of quartz or other [[lime (mineral)|lime]]-free minerals.<ref name=handbook>{{cite book | last=Scheurmann | first=Ines | others=(trans. for Barrons Educational Series, Hauppauge, New York: 2000) | title=Natural Aquarium Handbook, The | year=1985 | publisher=Grfe & Unzer GmbH | location=Munich, Germany }}</ref> If the gravel is rough or sharp, it is not suitable for bottom-dwelling fish that like to sift the substrate or dig.<ref name=Sanford/>\n\nShell grit, crushed [[limestone]], crushed [[marble]], crushed [[coral]] skeletons, coral sand, and [[oolite|oolitic]] [[aragonite]] substrates are possible choices. Because [[calcium carbonate]], the primary component of these substrates, increases [[hard water|water hardness]] and [[pH]], these are used most often for hard water species, such as those for African [[rift lake]] [[cichlids]] or for [[sea water|saltwater]] fish and invertebrates. Some invertebrates such as [[mollusk]]s or [[stony coral]]s also use the [[calcium]] and [[strontium]] released. Calcium carbonate substrates are poorly suited to aquaria housing most other freshwater aquarium fish, particularly river species, which are adapted to soft water.<ref name=handbook /> \n\n[[Peat]], or decomposed plant matter, is used most commonly in soft water or [[blackwater river]] systems, such as those mimicking the [[Amazon River]] basin. In addition to being soft in texture and therefore suitable for demersal (bottom-dwelling) species such as [[Corydoras]] catfish, peat is reported to have a number of other beneficial functions in freshwater aquaria. It softens water by acting as an [[ion exchange]]r, it contains substances good for plants and for the reproductive health of fishes, and can even prevent algae growth and kill microorganisms. Peat often stains the water yellow or brown due to the leaching of [[tannin]]s.<ref name=handbook />\n\n[[Sand]] is often recommended for use with certain species, such as the river stingrays of family [[Potamotrygonidae]], which bury themselves in the fine substrate. However, these species can be successfully kept with coarser substrates as well. \n\nIn some aquaria, different substrates are used in different parts of the tank. For example, peat can be used in one corner, while gravel in another portion allows rooted plants.<ref name=handbook />\n\n'
p130
tp131
a(I-1
S'{{Cleanup-rewrite|date=October 2009}}\n{{POV|date=October 2009}}\n\nIn the realm of online games, an exploit is usually a [[software bug]], design flaw, [[hack (technology slang)|hack]] or [[Internet bot|bot]] that contributes to the users prosperity in a manner not intended by the developers.\n\nWhat is or is not considered an exploit varies between games and developers. The [[software license|EULA]] (End-User License Agreement) typically states what type of gameplay is not acceptable. Thus, some developers may consider [[AFK gaming|AFK gameplay]] to be an exploit, while others may not.\n\nMost companies involved in the development or maintenance of online games forbid their employees from sharing information about known exploits or bugs. Doing so is sometimes considered an exploit but is more often merely a vector by which other exploits are shared.\n\n== Known types of exploits in real-time strategy games ==\n\n* [[Maphack]] A cheat that enables the player to see more of the map than the game intends them to see. A common feature in multiplayer real-time strategy games is the inability for the player to see outside the visibility range of the individual units and buildings that the player controls.\n\n== Known types of exploits in MMORPG ==\n\n* Speed Hacking/Teleporting/Subterrain Travel - If [[Fictional character|character]] position in an [[MMORPG]] is determined by the [[Client (computing)|client]] side (usually not the case), it is possible for [[player (game)|player]]s to send out artificial positional data and be instantly transported to any part of the world or used to speed up traveling speed by increasing positional deltas. \n* Holes - Some games may contain accidental holes in the map, allowing the player to get under the map. Holes are mostly harmless, although some use them in [[player vs. player]] situations to sneak around and get behind their opponent, or attack from below the floor.\n* [[Botting]] - A player who runs a third party program to control their [[Fictional character|character]]. The [[bot]] will kill [[monster]]s, loot [[money]], [[Mining|mine]] [[ore]], collect [[herb]]s or gain [[level]]s automatically without the player having to be in front of the computer.<ref> mmoglider.com [http://www.mmoglider.com/FAQ.aspx#G1 Glider bot]</ref>\n* [[Duping]] - Duplicating, or replicating [[Item (gaming)|item]]s or [[money]].\n* [[Twinking]] - Taking advantage of a design flaw in order to gear yourself in a manner that was not intended so that you appear better than you really are.\n* Game Mechanics Exploits / Bug Exploits - There are also other exploits involving the physics of the game, sometimes in conjunction with [[item]]s.  This includes using [[wall-walking]] to get into unfinished areas or [[ability|abilities]] to make ones [[Fictional character|character]] unattackable by mobs or other players and sometimes are able to attack back.\n* Data Mining - Players will try to access files not yet in game and then host them on websites to expose content not yet released (usually new [[zone]]s, [[item]]s, and graphics).<ref>[http://www.mmo-champion.com/index.php?topic=215.0 Known Data mining website]</ref>\n\n==Consequences of exploitation==\nDepending on the EULA and the severity of the exploit, developers may do anything from simply removing the exploited material from the game, to reprimanding the players, or banning their accounts. There are only occasional rare cases of an exploiter being threatened with legal action.<ref>[http://yro.slashdot.org/article.pl?sid=06/11/18/1950203 Blizzard Lawyers Visit Creator of WoW Glider]</ref>\n\n'
p132
tp133
a(I1
S'[[Image:Plain-bob-minor_2.png|200px|right|thumb|The Blue Line of Plain Bob Minor produced by change ringing software.]]\n\nChange ringing software is a generic term that encompasses the several different types of [[software]] in use today in connection with [[change ringing]]. \n\n==Modern day change ringing software==\nThe Central Council of Church Bell Ringers keeps a list of all  [http://www.cccbr.org.uk/ictc/softwareCatalogue.php current change ringing software]\nThere are four general types of software used in connection with change ringing.\n\n===Composition Proving===\nThe most common use of software in change ringing is composition proving. This type of software is used to take the tedium out of calculating [[change ringing]] compositions and then proving that they are true. The software will perform the complex mathematics of proving a composition in seconds rather than the hours or days required for paper based proving methods. \n\nThe main examples of proving software are:\n[http://www.ringingmaster.com/ Ringing Master]\n[http://www.users.globalnet.co.uk/~lupton/excalib.htm Excalibur]\n[http://www.beltower.co.uk/ Beltower]\n\n===Simulator===\nSimulator softwares original use was to allow the practicing of change ringing in the tower, but is perhaps used more in the home now, using a dumbbell or keyboard. There are different scenarios that can now be accommodated by the latest software. Sensors are used to give temporal information to the computer.\n* Single or multiple learner silent practice with computer producing sound of the bell.\n* Whole band silent practice with computer producing sound of all the bells.\n* Practice on more bells than you have with the computer adding in the extra bells.\n* Practice methods that are more advanced that your band is capable with the computer filling in all the bells.\n\nThe main examples of simulator software are:\n[http://www.ringingmaster.com/ Ringing Master]\n[http://www.abelsim.co.uk/ Abel]\n[http://www.beltower.co.uk/ Beltower]\n\n===Record Keeping===\nKeeping records is very important to some change ringers. Records are often kept in the following areas: \n* Grabs (towers visited)\n* Peals.\n* Quarter peals. \nThe main examples of record keeping software are:\n[http://www.ringingmaster.com/ Ringing Master]\n[http://www.winrk.com/ WinRK]\n\n===Tower Directory===\nAn up to date directory of towers is often used to plan outings and, used in conjunction with the record keeping software to decide what towers still need to be grabbed.\n \nThe main examples of tower directory software are:\n[http://www.ringingmaster.com/ Ringing Master]\n[http://www.towerbase.34sp.co.uk/towerbase/index.php TowerBase]\n\n==History of Change Ringing Software==\nThe earliest known change ringing programs can be traced back to the 1950s. Some of this history is traced in this article on software firsts http://www.ringing.info/shaggy.html\n\n'
p134
tp135
a(I-1
S'Game canon is a list of [[video game]]s to be considered for preservation by the [[Library of Congress]]. The creation of this list is an assertion that digital games have a cultural significance and a historical significance.<ref name=New York Times>{{cite web | url=http://www.nytimes.com/2007/03/12/arts/design/12vide.html?_r=4&ref=technology&oref=slogin&oref=slogin&oref=slogin&oref=slogin | title=Is That Just Some Game? No, Its a Cultural Artifact | last=Chaplin | first=Heather | publisher=[[New York Times]]}}</ref> Game canon is modeled on the efforts of the [[National Film Preservation Board]], which produces an annual list of films that are subsequently added to the [[National Film Registry]], which is managed by the Library of Congress. The game canon committee comprises [[Henry Lowood]], game designers [[Warren Spector]] and [[Steve Meretzky]], Matteo Bittanti, and [[Joystiq]] journalist Christopher Grant.\n\n==History==\nGame canon is a project started by Henry Lowood, curator of the History of Science and Technology Collections at [[Stanford University]]. He started to preserve video games and video-game artifacts in 1998, and in the years following, he has noted that video games are something worthy of preserving.<ref name=New York Times /> Henry Lowood submitted the proposal to the Library of Congress in September 2006, and during the 2007 [[Game Developers Conference]], he announced the game canon.\n\n==List of games considered==\nThe initial list consists of 10 video games that are each considered to represent the beginning of a genre that is still vital in the video game industry.<ref name=Joystiq>{{cite web | url=http://www.joystiq.com/2007/03/12/10-most-important-video-games-of-all-time-as-judged-by-2-design/ | title=10 most important video games of all time, as judged by 2 designers, 2 academics, and 1 lowly blogger | last=Ransom-Wiley  | first=James | publisher=[[Joystiq]]}}</ref>\n* [[Spacewar!]]\n* [[Star Raiders]]\n* [[Zork]]\n* [[Tetris]]\n* [[SimCity]]\n* [[Super Mario Bros. 3]]\n* [[Civilization (computer game)|Civilization I/II]]\n* [[Doom (video game)|Doom]]\n* [[Warcraft universe|Warcraft series]]\n* [[Sensible Soccer (series)|Sensible World of Soccer]]\n\n'
p136
tp137
a(I1
S'{{Infobox_Company\n | company_name   = Chambers Corporation\n | company_logo   = [[Image:Chambers Logo Registered.jpg|240px|Chambers Logo]]\n | company_type   = [[Defunct]]\n | foundation     = 1912\n | closed_down    = 1988 (approx.)\n | location_city  = Shelbyville, Indiana\n | location_country = United States\n | industry       = [[Home appliance|Appliance]]s\n | products       = [[gas ranges]], [[electric ranges]], [[built-in gas cooktops and ovens]], [[built-in electric cooktops and ovens]], [[vent hoods]], [[dishwashers]]\n}}\nThe Chambers stove is a generic name for several different kitchen cooking appliances sold under the Chambers brand name from 1912 to approximately 1988. Their ranges and stand-alone ovens were known for their patented insulation methods, which enabled them to cook on retained heat with the fuel turned off.\n\n== History ==\nThe Chambers Fireless Gas Range was a gas cook stove created by [[John E. Chambers]] in 1910,<ref name=Oliver>{{cite book | last = Oliver | first = Beverly | title = Shelbyville, A Pictoral History | publisher = | year = 1996 | pages = 98 | url = | id =  }}</ref><ref name=McFadden>{{cite book | last = McFadden | first = Marian | title = Biography of a Town Shelbyville, IN | publisher = Tippecanoe Pres Inc.| year = 1968 | location = Shelbyville, Indiana | pages = 257 | url = | id =  }}</ref> Two years after inventing his fireless cooker, John Chambers organized the Chambers Company in 1912.<ref name=Oliver/> Chambers patented method of manufacture<ref>U.S. Patent # 1,469,890 - 10/9/1923</ref>  used thick rock wool insulation to insulate the oven on all sides. This made it possible for the heat inside the oven to build up over a short period of time. The gas was then turned off, causing a series of internal dampers to close, which effectively isolated the oven compartment from the outside air. The food would continue to cook on retained heat, thus conserving fuel and reducing food shrinkage. This method of cooking, Chambers literature often claimed, also increased the food value of the cooked items.\n[[Image:Chambers Fireless Model.jpg|thumb|250px|Chambers Fireless Model from 1920s]]The Chambers Corporation manufactured successive versions of this design in Shelbyville, Indiana from 1912 through January, 1955.<ref name=Oliver/><ref name=McFadden/> \n\nThe company was sold by the Chambers family in 1950 to the Flato brothers, who were the Chambers distributors in [[Houston, Texas]]. Rangaire purchased Chambers in 1964, and operated it out of the [[Oxford, Mississippi]] plant built by the Flato brothers in 1963 until 1983, when they sold it to the KitchenAid Division of the [[Hobart]] Corporation.<ref>{{cite paper\n  | author = Lawrence Berkeley National Laboratory\nEnergy & Environment Division\nTechnology and Market Assessment Group\nBerkeley, CA 94720\n  | title = Technical Support Document for Energy Conservation Standards for Room Air Conditioners\n  | version =\n  | publisher = Lawrence Berkeley National Laboratory\n  |date=September 1997\n  | url = http://www.eere.energy.gov/buildings/appliance_standards/pdfs/tsdracv1.pdf\n  | format = PDF\n  | accessdate = 2007-04-20}} Pp. 56.</ref> During Rangaires ownership of the Chambers Corporation, manufacture of the famous insulated range continued into the 1970s. KitchenAid was sold to Whirlpool in 1986.<ref>KitchenAid. International Directory of Company Histories. The Gale Group, Inc, 2006. Answers.com 25 Apr. 2007. http://www.answers.com/topic/kitchenaid-4396712</ref> By the early 1990s,  Chambers-branded appliances were no longer in manufacture.{{citation needed|date=May 2007}}\n\nIn 2007, the [[Thor Corporation]] of [[Los Angeles]] resurrected the Chambers brand name.<ref>[http://www.thorappliances.com/aboutThor/ChambersBrand.php Chambers brand introduced<!-- Bot generated title -->]</ref>\n\nThe earliest Chambers ranges were small, but all were constructed of heavy gauge [[steel]] and porcelain enamel. All models were thickly insulated, which enabled their owners to use them like an ordinary range or cook using retained heat. To help owners of their products learn the proper use of the retained heat cooking feature of their ranges, Chambers developed a large [[Home Economics]] Department in their [[Shelbyville, Indiana]] factory. There, recipes and cooking times using the insulated properties of their products were carefully tested and perfected. These tests resulted in charts which indicated the amount of time - and at what temperature - the gas was to be burned in the oven and the Thermodome<ref> U.S. Patent #1,469,890, 10/9/1923</ref> (which was succeeded by the Thermowell), before it was to be turned off completely while the food continued to cook on retained heat<ref>Chambers Corp.: Time, Temperature, and Retained Heat Chart, various models, originally printed in 1939.</ref>. By 1927, Chambers published a [[Cookbook]] for the homemaker to not only help her learn how to care for and operate the appliance, but also to assist her in menu planning, proper table setting, etc. This publication was called The Idle Hour Cookbook. The Idle Hour Cookbook was revised until it was replaced in the late 1960s by [[Rangaire]] with an actual operation manual<ref>Chambers Corp., div. of Rangaire Corp: Chambers Owners Guide, 1965, 1970.</ref>.   Chambers promoted the ranges using traveling cooking shows which pre-dated television. John Chambers daughter [[Alma Chambers]], traveled coast-to-coast for over twenty years conducting large cooking shows to promote the Chambers Range{{citation needed|date=April 2007}}.\n\nImprovements over the original design were continuously developed over the years, but all were constructed around the concept of a heavily insulated oven, as originally designed by John Chambers{{citation needed|date=May 2007}}. The most refined{{Lopsided|date=September 2008}} version of these was the C-series <ref> U.S. Patent #2,614,620 - Improved top burner for C series ranges. 10/21/1952</ref><ref name=C90 1956>U.S. Patents #2,672,137; #2,755,791 - Back flue for Models C41/61 and C90, respectively. 3/16/1954 and 4/24/1956, respectively.</ref><ref> U.S. Patent #2,763,259 - Removable base trim. 9/18/1956</ref>, which was produced from 1949-1963{{citation needed|date=May 2007}}, followed closely by the B-series (1939-1949){{citation needed|date=May 2007}}. Chambers also built large, industrial-sized units, called the Imperial line, for use in hotels, restaurants, dormitory kitchens, tea rooms, road houses, large homes, etc<ref>Chambers Corp.: Cook With The Gas Turned Off, pages 14-15, 1936.</ref>.\n\nAll residential Chambers ranges beginning with what is now referred to as the A-series (circa 1934) had a top-mounted [[griddle]]/broiler<ref> U.S. Patent #2,011,848</ref>. Some models came with a recessed ThermoWell (descendant of the earlier ThermoDome) for cooking soups, stews, etc., using special [[aluminum]] kettles designed and built for Chambers by the [[Wearever]] Corporation.\n\n== Features ==\nWhile not all models had all the following features, most of the more commonly sold Chambers ranges included:\n*Automatic Oven Safety Systems - to shut off the oven gas should the [[pilot light]] go out.\n*Basket-style oven racks.\n*Built-in Lamps.\n*Child-protective locking thumb-latches on all gas valves.<ref> U.S. Patent #2,134,029 - 10/25/1938</ref>\n*Chrome-Plated cooktop, which Chambers called Duracrome.\n*Full [[porcelain]] finishes - guaranteed by the factory for 25 years.\n*Heat from Range vented out through the backsplash, enabling it to be set flush to the wall<ref name=C90 1956 />\n*Mechanical Timer, which Chambers called a Minute Minder<ref>Chambers Corp.: Cook With The Gas Turned Off, pages 2, 4, 6, 10 - 1936.</ref>.\n*Multi-fuel design - able to operate on natural gas, propane, butane.\n*Patented daisy burners - efficient and uniform in their distribution of heat.<ref> U.S. Patents #1,959,657; #2,180,862; #2,614,620; #2,162,374 </ref>\n*Some of the first built-in ovens and cooktops (early 1950s) made in America.\n*Teardrop design gas handles.\n*The use of [[ThermalEye]] (1950s) - developed by [[Robertshaw]] and marketed by Chambers as The Burner With A Brain, this device made it possible to set the desired cooking temperature of a pot that had been placed on the special burner on the top of the range, and the heat would be regulated automatically<ref>Robertshaw-Fulton Controls Company, Youngwood, Pennsylvania: Thermal Eye Top Burner Control Instructions and Cooking Suggestions, 1954, 1960.</ref>.\n*Thermobaker insert for the Thermowell - enabled baking of small items and meals in the Thermowell<ref>Chambers Corp.: Heres The New ThermoOven, 1950; Accessories For Your Chambers Range, page 3, 1952.</ref>.\n*Top Burner Pilot - could be used as a warming burner.\n*Utility (Service) Cabinet - designed for access to the inner mechanisms and gas pipes of the range, and for storage of pots, pans, and Thermowell kettles. Misunderstood by some to be a warming oven.\n*Wide grates designed to accommodate any size cooking utensil.\n\n==Popularity==\nFamous owners of Chambers ranges included [[Lee DeForest]]<ref>Chambers Corp.: The Idle Hour Cookbook, page 28., 1927</ref> and Mrs. [[Harvey W. Wiley]],<ref name=Chambers Corp page 27>Chambers Corp.: The Idle Hour Cookbook, page 27., 1927</ref> well-known American housewife in the 1920s<ref>Anna Kelton Wiley Papers, http://lcweb2.loc.gov:8081/ammem/amrlhtml/dirwiley.html</ref>. A Chambers oven can also be found in the home of the late [[Sam Rayburn]]{{citation needed|date=July 2007}}.\n\nThe Chambers Range was awarded the [[Good Housekeeping]] Institutes Seal of Approval in 1925,<ref name=Chambers Corp page 27 /> was awarded the Grand Prize and Gold Medal for distinguished service at the International Exposition in Paris, France, 1937,<ref>Chambers Corp.: Cook With The Gas Turned Off, page 13.</ref> and was featured at the [[Worlds Fair]] Exposition of 1939 in [[New York City]]{{citation needed|date=May 2007}}\n\nDemand for refurbished Chambers stoves remains high - some of the Imperial models have been restored and sold for prices up to [[United States dollar|US$]]17,000,<ref>{{cite news | last = Klatt | first = Mary Beth | title = Collectors are hot for the Imperial: Heres why this decades-old oven stands as the holy grail for Americas growing cult of antique-appliance aficionados | publisher = [[USA Today]] | date = [[2003]]-[[01-19]] | url = http://www.usaweekend.com/03_issues/030119/030119appliances.html | accessdate = 2007-05-03 }}</ref> though selling prices of unrestored residential models is far less. Increased interest in the Chambers Range may be due to its exposure on the televised cooking show of [[Rachael Ray]].<ref>{{cite news | last = | first = | title = Television Q&A: Your questions  | publisher = [[The Dallas Morning News]] | date = [[2004]]-[[05-09]] | url = | accessdate =  }}</ref><ref>{{cite news | last = | first = | title = Cook Like Rachel Ray With A Vintage Chambers Range | publisher = [[Austin American-Statesman]] | date = [[2005]]-[[12-13]] | url = | accessdate =  }}</ref>  \n\nWebsites for fans of vintage Chambers products have been developed in order to provide general information about them to those on the internet. Links to service technicians, sources for parts, as well as operational literature may also be found there. Also helpful are the pictorial documentaries on the restoration of Chambers ranges by their owners. In addition to websites such as these, at least two active [[Internet Forums]] exist for those interested in older Chambers products. There, people can find recipes, repair tips, cooking techniques, and restoration advice.\n\n'
p138
tp139
a(I1
S'{{For|the process of transferring a widescreen image to video in a widescreen ratio|letterbox}}\n{{No footnotes|date=April 2009}}\nLetterboxing is an outdoor hobby that combines elements of [[orienteering]], [[art]], and [[puzzle solving]]. Letterboxers hide small, weatherproof boxes in publicly-accessible places (like parks) and distribute clues to finding the box in printed catalogs, on one of several [[#External_links|web sites]], or by word of mouth. Individual letterboxes usually contain a notebook and a rubber stamp.  Finders make an imprint of the letterboxs stamp, either on their personal notebook or on a postcard, and leave an impression of their personal stamp on the letterboxs visitors book or logbook  as proof of having found the box and letting subsequent letterboxers see who have visited.  Many letterboxers keep careful track of their find count.\n\n==History==\nThe origin of letterboxing can be traced to [[Dartmoor]], [[Devon]], England in 1854. [[William Crossing]] in his Guide to Dartmoor states that a well known Dartmoor guide (James Perrott) placed a bottle for visitors cards at [[Cranmere Pool]] on the northern moor in 1854. From this hikers on the moors began to leave a letter or postcard inside a box along the trail (sometimes addressed to themselves, sometimes a friend or relative)hence the name letterboxing. The next person to discover the site would collect the postcards and mail them. In 1938 a plaque and letterbox in Crossings memory were placed at [[Ducks Pool, Dartmoor|Ducks Pool]] on southern Dartmoor.\n\nThe first Dartmoor letterboxes were so remote and well-hidden that only the most determined walkers would find them, allowing weeks to pass before the letter made its way home. Until the 1970s there were no more than a dozen such sites around the moor, usually in the most inaccessible locations. Increasingly, however, letterboxes have been located in relatively accessible sites and today there are thousands of letterboxes, many within easy walking distance of the road. As a result, the tradition of leaving a letter or postcard in the box has been forgotten.\n\nToday there is a club called the 100 Club, membership of which is open to anyone who has found at least 100 letterboxes on Dartmoor. Clues to the locations of letterboxes are published by the 100 Club in an annual catalogue. Some letterboxes however remain word of mouth and the clues to their location can only be obtained from the person who placed the box. Some clues may also be found in other letterboxes or on the Internet, but this is more commonly for letterboxes in places other than Dartmoor, where no 100 Club or catalogue exist.\n\nLetterboxing has become a popular sport, with thousands of walkers gathering for box-hunts and while in some areas of Dartmoor it is particularly popular amongst children, some of the more difficult to find boxes and tougher terrain are better suited to more experienced adults.\n\nLetterboxes can now be found in other areas of the United Kingdom including the [[North York Moors]] and have spread all over the world. \n\nInterest in letterboxing in the U.S. is generally considered to have started with a feature article in the [http://www.smithsonianmag.com/travel/letterboxing.html Smithsonian Magazine] in April 1998. Much of the terminology below is associated with letterboxing in the US and would be unfamiliar to UK letterboxers. The growing popularity of the somewhat similar activity of [[geocaching]] during the 2000s has increased interest in letterboxing as well.\nClues to American letterboxes are commonly published on several different websites.\n\nMany letterboxers feel that publicity, such as conventions, information on this site and others will only do harm to the hobby. It should remain underground, under the wire and NOT mainstream.{{Citation needed|date=July 2009}}\n\n==Types of letterboxes==\nThere are now many different kinds of letterboxes, each with some specific distinction. While purists only recognize those letterboxes planted in the wild, many new variations exist. These include:\n\n; Mystery boxes\n: These are usually traditional boxes, but these mystery boxes have either vague starting areas, no starting areas, no descriptions, no clue -- any number of things to make the box extremely hard to find.\n\n; Hitchhikers\n: A travelling letterbox, it is placed in a traditional letterbox for another boxer to find.  When found, it is stamped just like a traditional letterbox, but is then carried with the boxer to the next box they find.  The hitchhikers stamp should also be recorded in the host boxs log, and vice versa. \n\n; Personal Travellers\n: Much like a traditional box, but instead of being planted, the box is kept with the creator at all times. If another boxer is met on the trail or at a meet it is attainable if requested. In the US this box is usually only attainable if the other letterboxer knows the password or passphrase which is sometimes cryptic, sometimes straightforward, sometimes almost non-existent, and sometimes silly.\n\n; Cooties\n: These are much like hitchhikers, except instead of traveling from letterbox to letterbox, they travel from letterboxer to letterboxer in Personal Travelers or on letterboxers (or their unattended bags) on the trails or at gatherings. Most people are subtle about planting thembut not all.\n\nIn the US, letterboxes have developed new forms: \n\n; Hitchhiker Hostels\n: This is a traditional letterbox with special qualities. Namely, it is a hostel for hitchhikers, sized and specially designated to hold multiple hitchhikers at one time. Normally, there are at least one or two hitchhikers in the box at all times, and any letterboxer who takes a hitchhiker out is required to leave a new one in its place. A hitchhiker hostel has its own stamp and logbook, just like a traditional letterbox, and any hitchhiker that is placed within it should be stamped and recorded within the logbook, preferably with both the date of its being added to the hostel (in order to make it easier to move the older hitchhikers out), and the date it is removed.\n\n; American Parasites (these should not be confused with English Parasites)\n: A parasite is very much like a hitchhiker except, instead of hitchhiking between letterboxes on their own, they hitch rides on other hitchhikers. When a parasite joins with a hitchhiker (infecting it), it is stamped into the hitchhiker like a normal hitchhiker. The parasite also stamps into the letterbox that hitchhiker is placed in, infecting the letterbox, as well. In the event of being placed in a letterbox that has multiple hitchhikers in it (such as a hitchhiker hostel), the parasite infects all of the hitchhikers inside. The boxer that has done the moving also has the choice of sending the parasite along with a different hitchhiker. (This is a relatively new variation of letterbox, and has only just recently begun to take off.)\n\n; Virtuals\n: Online letterboxes; actually a scavenger hunt of sorts through different websites, collecting answers to questions posted as the clues to the box. Answers sometimes are unscrambled or simply emailed to the creator the final answer is put in a blank in a web address, which takes the finder to the image online.\n  Event Boxes\n  A letterbox that has only been planted for a short amount of time. (Like a few days or a week, any time length the planter wants.)\n; Postals \n: Boxes that are made just like traditional letterboxes, but instead of being planted in the wild, they are sent via postal mail to the people on signup lists for the box, or around a ring of people in a postal ring, which is usually focused on a theme of some sort. Postals are also very often very well designed and organized, as well as ornate. Since the box is very unlikely to be stolen, go missing, or be damaged, creators of PLBs tend to get quite creative.\n\n==Letterboxing gatherings==\n\nLetterboxers also organize events, usually called meets or gatherings. The first letterbox meet was held on Dartmoor, and they are now  held twice yearly on clock change days (in March and October). Gatherings in America are usually at parks or places with enough space for a large group of letterboxers to meet up and do exchanges (exchanging of personal stamps and/or personal travelers), as well as talk and discuss box ideas. Gatherings in America usually have a special, one day Event stamp. At some gatherings, boxes are created or donated to be planted nearby specifically for the gathering attendees to find.\n\n==Find counts==\n\nA letterboxers find count or PFX count is organized as follows:\n\n*The P (plants) count is the number of boxes the letterboxer has made and placed. \n*The F (finds) count is the number of boxes the letterboxer has found in the wild. \n*The X (exchanges) count is the number of exchanges the letterboxer has. \n\nSome boxers list individual types of boxes in their PFX counts (e.g.: <code>P12 F76 X45 E4 HH21 V4</code> would mean 12 plants, 76 finds, 45 exchanges, four events or event stamps, 21 hitchhikers, and four virtuals).  Some include virtuals, hitchhikers, and other non-traditional boxes in a single find count, while some exclude them.  Many letterboxers do not bother to keep count at all.\n\nThe PFX count is not a term associated with Dartmoor Letterboxing.\n\n'
p140
tp141
a(I-1
S'Morphological freedom refers to a proposed [[civil right]] of a [[person]] to either maintain or [[body modification|modify his or her own body]], on his or her own terms, through [[informed consent|informed, consensual]] recourse to, or refusal of, available therapeutic or enabling [[medical technology]].<ref name=Carrico 2006>{{cite paper|    author = [[Dale Carrico|Carrico, Dale]]|    title =  The Politics of Morphological Freedom|    date = 2006 |   url = http://amormundi.blogspot.com/2006/08/politics-of-morphological-freedom.html| accessdate=2007-01-28}}</ref>\n\nThe term may have been coined by strategic philosopher [[Max More]] in his 1993 article, Technological Self-Transformation: Expanding Personal Extropy,<ref name=More 1993>{{cite paper| author = [[Max More|More, Max]] | title = Technological Self-Transformation: Expanding Personal Extropy (Extropy #10, vol. 4, no. 2)| date = 1993 | url = http://www.maxmore.com/selftrns.htm | accessdate=2009-01-04}}</ref> where he defined it as the ability to alter bodily form at will through technologies such as surgery, genetic engineering, nanotechnology, uploading. The term was later used by science debater [[Anders Sandberg]] as an extension of ones right to ones body, not just [[self-ownership]] but also the right to modify oneself according to ones desires.<ref name=Sandberg 2001>{{cite paper|    author = [[Anders Sandberg|Sandberg, Anders]]|    title =  Morphological Freedom -- Why We not just Want it, but Need it|    date = 2001 |   url = http://www.nada.kth.se/~asa/Texts/MorphologicalFreedom.htm| accessdate=2007-01-28}}</ref> In March 2008 Sandberg and [[Natasha Vita-More]] gave a joint talk on morphological freedom in [[Second Life]].<ref name=SandbergVitaMore 2008>{{cite paper|title =Natasha Vita-More & Anders Sandberg on Morphological Freedom in Second Life|    date = 2008 |   url =http://transumanar.com/index.php/site/today_natasha_vita_more_anders_sandberg_on_morphological_freedom_in_second/| accessdate=2009-01-05}}</ref>\n\n==Politics==\nAccording to [[technocritic]] [[Dale Carrico]], the politics of morphological freedom imply a commitment to the value, standing, and social legibility of the widest possible variety of desired [[morphology (biology)|morphologies]] and [[lifestyle]]s. More specifically, morphological freedom is an expression of [[Liberalism in the United States|liberal]] [[Pluralism (political philosophy)|pluralism]], [[secularism]], [[progressivism|progressive]] [[cosmopolitanism]], and [[posthumanist]] [[multiculturalism]]s applied to the ongoing and upcoming transformation of the understanding of [[medicine|medical practice]] from one of conventional therapy to one of [[informed consent|consensual]] [[Self-Determination Theory|self-determination]], via [[human genetic engineering|genetic]], [[cyberware|prosthetic]], and [[neuropharmacology|cognitive]] modification.<ref name=Carrico 2006/>\n\n'
p142
tp143
a(I1
S'Barry Halper was an extensive collector of [[baseball]] [[memorabilia]].<ref name=obit>{{Cite web|url=http://www.usatoday.com/sports/baseball/2005-12-19-halper-obit_x.htm|title=Baseball collector Barry Halper dies|accessdate=November 17 2007|dateformat=mdy|publisher=[[USA Today]]|year=2007|author=[[Associated Press]]}}</ref> During the auction of the collection, [[Sothebys]] Auction House called it the World Series of Sports Auctions.<ref name=psa>{{Cite web|url=http://www.psacard.com/articles/article1511.chtml|title=Sothebys Wins World Series Of Sports Auctions: Barry Halper Collection Totals $21,812,577 |accessdate=November 17 2007|dateformat=mdy|publisher=Collectors Universe, Inc.|year=1999|author=Collectors Universe, Inc.}}</ref>  Many items from his collection have since turned out to have been stolen and the FBI has launched an investigation. [http://www.bostonherald.com/news/regional/view/20090710stolen_boston_memorabilia_traced_back_to_dead_yanks_owner/srvc=home&position=2]\n\n==Collection==\nHalpers collection was thought of as the finest, being both extensive and unusual. Many items, such as the uncut strip of [[T-206]] cards with a [[Honus Wagner]], were one of a kind. Halpers collection was housed in his basement, which had been outfitted like a small museum, including a hidden switch to a swing open panel, behind which were some of his most game-worn jerseys of famous players. The collection of game used jerseys included the only known examples of such players as [[Pud Galvin]], [[Christy Mathewson]], [[Cap Anson]], [[King Kelly]], [[Dan Brouthers]], and the famed trio of [[Joe Tinker|Tinker]] / [[Johnny Evers|Evers]] / [[Frank Chance|Chance]]. The infamous [[Shoeless Joe Jackson|Joe Jackson]] was represented with jerseys from his minor league team as well as his [[Cleveland Indians]] jersey. The collection of dead ball era player jerseys was unrivalved.\n\nSome of the notable items in Halpers collection included:<ref name=psa />\n\n* [[Ty Cobb]]s {{by|1928}} [[autograph]]ed [[Philadelphia Athletics (1860-1876)|Philadelphia Athletics]] Jersey. (Sold for over 300,000 USD.)\n* [[Lou Gehrig]]s last [[baseball glove]]. (Sold for nearly 400,000 USD.)\n* Cap Ansons Chicago White Sox jersey\n* A glove from [[Mickey Mantle]]. (Purchased by [[Billy Crystal]] for over 230,000 USD.)\n* Mickey Mantles {{by|1956}} [[New York Yankees]] [[World Series]] Ring.\n* The {{by|1920}} signed sale agreement that marked [[Babe Ruth]]s sale by the [[Boston Red Sox]], to the Yankees \n* A {{by|1903}} ticket to the first World Series.\n* Lou Gehrigs {{by|1930}}s Yankees hat.\n* Ty Cobbs [[dentures]].\n* King Kellys New York jersey\n* Christy Mathewsons first minor league jersey (Taunton)\n\nFollowing the Sothebys auction, Halper remarked:\n{{Cquote|It makes me feel so proud that my collection will be carried on by everyone who participated in the past weeks sale. I am also glad that the Hall of Fame has part of my collection where it will reside in perpetuity.<ref name=psa />}}\n\nSothebys released a three-volume book, The Barry Halper Collection of Baseball Memorabilia, that included over 1,500 color photographs of the collection, giving history for many of the items, details about Halpers collection through the years, and a history of baseball.<ref name=book>{{cite book | last = Sothebys | first = Sothebys | title = The Barry Halper Collection of Baseball Memorabilia | publisher = Sothebys | location = New York | year = 1999 |pages=930 pages| isbn = 9780962258879 }}</ref><ref name=book2>{{cite book | last = Golenbock | first = Peter | title = Barry Halper Collection of Baseball Memorabilia | publisher = Harry N. Abrams | pages=928 pages|location = New York | year = 2000 | isbn = 9780810967045 }}</ref>\n\n==Sale==\nIn 1998, Halper sold the collection, with [[Major League Baseball]] purchasing many items, donating them to the [[Baseball Hall of Fame]]. The rest were [[auction]]ed off by Sothebys for a record 21.8 million [[USD]].<ref name=obit /><ref name=psa />\n\n==Background==\nHalper attended the [[University of Miami]], where he was a pitcher for the baseball team.  He then went into the his familys paper supply business, where he worked until the company closed in 1992.\n<ref name=obit2>{{Cite web|url=http://www.njjewishnews.com/njjn.com/010506/mwsports.html|title=Sports memorabilia maven Barry Halper is remembered for what he gave|accessdate=October 24 2008|dateformat=mdy|publisher=[[New Jersey Jewish News]]|year=2005|author=Ron Kaplan}}</ref> \n\n==Death==\nBarry Halper died at the age of 66, in 2005 due to complications from long-standing health issues.\n<ref name=obit2 /> \n\n'
p144
tp145
a(I1
S'{{portal|Aquarium Fish|Pterois antennata-3.jpg|boxsize=50}}\n[[File:aquarium3.jpg|thumb|350px|An [[aquascaping|aquascaped]] freshwater aquarium]]\nFishkeeping is a popular [[hobby]] concerned with keeping [[fish]] in a home [[aquarium]] or garden [[pond]].\n== Types of fishkeeping ==\n\nThe hobby can be broadly divided into three specific disciplines, [[freshwater]], [[brakish water|brackish]], and [[sea|marine]] (also called saltwater) fishkeeping. \n\n[[Freshwater aquarium|Freshwater fishkeeping]] is by far the most popular branch of the hobby, with even small pet stores often selling a variety of freshwater fish, such as [[goldfish]], [[guppy|guppies]], and [[Pterophyllum|angelfish]]. While most freshwater aquaria are set up as [[community aquarium|community tanks]] containing a variety of peaceful species, many aquarists keep single-species aquaria with a view to breeding. [[Live-bearing aquarium fish|Livebearing]] fish such as mollies and guppies are among the species that are most easily raised in captivity, but aquarists also regularly breed numerous other species, including many types of [[cichlid]], '
p146
tp147
a(I-1
S'Frdric Elmobo Motte (born in 1970 in [[Rethel]], [[France]]) is a music producer and composer. He started toying with computer music when he got his hands on his first computer in 1983. \n\n==Demoscene==\n\nHe made his first steps in the [[demoscene]] using Moby as moniker in 1988 by joining the [[Amiga]] [[demogroup]] Impact Inc. as a musician. Later, he joined other groups like Dragons, Dreamdealers, Alcatraz and finally [[Sanity]], for which he composed the soundtrack of one of the top rated [[amiga]] demo ever : Arte. In 1994, he founded with [[demoscene]] graphic artist Olivier Ra Bechard the PC demo group [[NoooN]].\n\n==Video Games==\n \nIn the beginning of the 90s, he starting composing music for video games. His first gigs were for Coktel Vision. In 1993, he started working as in-house composer and sound designer at [[Atreid Concept]], a young game studio, which later on became [[Kalisto Entertainment]]. There, he produced the soundtrack of quite a few games (Nightmare Creatures 1 & 2, Dark Earth, 4 Wheel Thunder...) before leaving the company in January 2001 to go freelance again. This is when he changed his moniker to Elmobo because of the confusion with the other [[Moby]] He has since worked on a large number of games on [[Game Boy Advance]], [[Nintendo DS]], PC, [[Playstation 2]], [[Wii]] and even mobile phones.\n\n==Bands==\n\nIn 1998, together with guitarist Stephane Fanalo Alaux, he started the band Plug-In, a progressive instrumental metal band, in which he plays the bass. Plug-in released its first EP called #0.9 in 1999, produced, recorded mixed and mastered by Elmobo. In 2002, Fanalo and Elmobo where hired by guitar god Ron [[Bumblefoot]] Thal as bass and guitar player to tour France, and for a few gigs in Europe. Ron Thal joined [[Guns n Roses]] in 2006.\nPlug-In is about to release a new album featuring many guests like Pierre Belleville ([[Lofofora]]), [[Ron Thal]] ([[Guns n Roses]]), [[Patrick Rondat]], [[Andy Timmons]], [[Sylvain Coudret]] ([[Scarve]], [[Soilwork]]), [[Christophe Godin]] ([[Metal Kartoon]])...\n\nIn 2004, Elmobo opened his own recording studio called Conkrete Studio. His studio is dedicated to metal bands, and he has already produced, recorded, mixed or mastered more than 30 albums to date.\n\n== Demography ==\n* [[Impact Inc. (demogroup)]] - Musicdisk\n* [[Impact Inc. (demogroup)]] - Vectorball\n* [[Impact Inc. (demogroup)]] - Tropical Night\n* [[Impact Inc. (demogroup)]] - Generation 4\n* [[Quartex]]/[[Alliance Design]] - Substance (1991)\n* [[Dragons (demogroup)]] - Megademo\n* [[Angels (demogroup)]] - Copper Master\n* [[Apology (demogroup)]] - Megademo\n* [[Alcatraz (demogroup)]] - Megademo IV - Devils Key\n* [[Alcatraz (demogroup)]] - Musicdisc 1\n* [[Alcatraz (demogroup)]] - More Than Music\n* [[Proton (demogroup)]] - Phenomenon\n* [[Quartex]] - Zetaniks\n* [[Dreamdealers]] - Tales of a Dreams\n* [[Dreamdealers]] - Dont Crack Under Pressure\n* [[Dreamdealers]] - Innervision\n* [[The Special Brothers (demogroup)]] - Live #1\n* [[Dreamdealers]]/[[Alliance Design]] - Arkham Asylum\n* [[Dreamdealers]]/[[Alliance Design]] - Drinktro\n* [[Dreamdealers]] - Raging Fire\n* [[Sanity (demogroup)]] - Arte (1993)\n* [[NoooN]] - No! (1994)\n\n== Ludography ==\n* [[Cougar Force]] (1990, [[Coktel Vision]])\n* [[Geisha (video game)]] (1990, [[Coktel Vision]])\n* [[Galactic Empire (Tomahawk computer game)|Galactic Empire (Tomahawk computer game)]] (1990, [[Coktel Vision]])\n* [[No Exit (video game)]] (1990, [[Coktel Vision]])\n* [[Gobliiins]] (1990, [[Coktel Vision]])\n* [[Abracadabra (video game)]] (1991, [[Coktel Vision]])\n* [[Fascination (video game)]] (1991, [[Coktel Vision]])\n* [[A.G.E. (video game)]] (1991, [[Coktel Vision]])\n* [[E.S.S. Mega (video game)]] (1991, [[Coktel Vision]])\n* [[Paragliding (video game)]] (1991, [[Loriciel]])\n* [[Tiny Skweeks]] (1992, [[Loriciel]])\n* [[The Tinies]] (1992, [[Kalisto]])\n* [[S.C.Out]] (1993, [[Kalisto]])\n* [[Cogito (video game)]] (1993, [[Kalisto]])\n* [[Fury of the Furries]] (1993, [[Mindscape]])\n* [[Pac In Time]] (1993, [[Konami]])\n* [[Warriors (aka Savage Warriors) (video game)]] (1994, [[Mindscape]])\n* [[Dark Earth (video game)]] (1995, [[Mindscape]])\n* [[Al Unser Jr Arcade Racing]] (1995, [[Mindscape]])\n* [[Nightmare Creatures]] (1996, [[Kalisto]])\n* [[The Fifth Element (video game)]] (1998, [[Kalisto]])\n* [[Ultim@te Race Pro]] (1998, [[Kalisto]])\n* [[4 Wheel Thunder]] (2000, [[Kalisto]])\n* [[Nightmare Creatures II]] (2000, [[Kalisto]])\n* [[Lucky Luke - Western Fever]] (2000, [[Kalisto]])\n* [[Jimmy Whites Cueball World]] (2001, [[Virgin Interactive]])\n* [[An American Tail - Fievels Gold Rush]] (2001, [[Hokus Pokus]])\n* [[Cubix - Racen Robots]] (2001, [[The 3DO Company]])\n* [[Super Farm (video game)]] (2001, [[Asobo]])\n* [[Popeye Rush for Spinach (video game)]]\n* [[V.I.P. (video game)]]\n* [[Oggy et les Cafards (video game)]]\n* [[Kong - The Animated Series (video game)]]\n* [[Piglets Big Game (video game)]]\n* [[Kaena, The Prophecy (video game)]] ([[Xilam Multimedia]])\n* [[The Saga of Ryzom]] ([[Nevrax]])\n* [[Magic Puz (video game)]] ([[Magic Productions]])\n* [[Totally Spies 3]] ([[Magic Pockets]])\n* [[Totally Spies - Totally Party]] ([[Mad Monkey Studio]])\n* [[Dolphin Island (video game)]] ([[Magic Pockets]])\n* [[Tigerz]] ([[Magic Pockets]])\n* [[Globul-X]] (TV series) ([[Inexvivo]])\n* [[Totally Spies 4 : Around the World]] ([[Ouat Entertainment]])\n* [[Imagine Teacher]] ([[Magic Pockets]])\n* [[Lets Play Fashion Designer]] ([[White Bird Productions]])\n* [[Planet Rescue : Ocean Patrol]] ([[Magic Pockets]])\n* [[Martin Mystery : Monster Invasion]] ([[Ouat Entertainment]])\n* [[Lets Play Firemen]] ([[Mad Monkey Studio]])\n* [[Sam Power Policeman]] ([[Magic Pockets]])\n* [[Sam Power Fire Fighter]] ([[Magic Pockets]])\n* [[Sam Power Handy man]] ([[Magic Pockets]])\n* [[Deal or No Deal]] ([[Mad Monkey Studio]])\n* [[Pirates : Hunt for Black Beards Booty]] ([[Mad Monkey Studio]])\n\n== Discography ==\n* [http://www.myspace.com/pluginband/ Plug-In] - #0.9 (plays bass on all tracks)\n* [http://www.fusecon.com/products/audiophonik/ Audiophonik] - Music for the Scene Generation (electronic music compilation featuring artists from the [[demoscene]]. First track Flow composed by Elmobo)\n* [http://www.guitariste.com/album/cd-concept.html Guitariste.com] - CD Concept (plays bass on the track Le retour de la crpe masque)\n* [http://www.myspace.com/jenxnoise Jenx] - Fuseless (Album produced by Elmobo, plays bass on the track House of Pain)\n* [http://www.myspace.com/olympusmonsband/ Olympus Mons] - Numera Effa Ilb (Album produced by Elmobo, plays bass on the track Fear of Ghosts)\n* [http://www.myspace.com/simplixitymusics/ Simplixity] - The Sheds Skin Chapter (Album produced by Elmobo, plays bass on the track My Thematic)\n\n'
p148
tp149
a(I-1
S'{{Unreferenced|date=June 2008}}\n{{Expert-subject|psychology|date=May 2009}}\nA psychological evaluation or mental examination is an [[examination]] into a persons [[mental health]] by a mental health professional such as a [[psychologist]]. A psychological evaluation may result in a [[diagnosis]]{{Dubious|date=May 2009}} of a [[mental illness]]. It is the [[mental]] equivalent of a [[physical examination]].\n\n==Methodology==\n\n{{Expand-section|date=June 2008}}\n\nThe [[psychologist]] or related licensed professional will start by asking questions of the person being evaluated sometimes but not always. In psychological evaluations the administration of standardized [[psychological test]]s either by a psychologist, or by someone the psychologist supervises,  are often a component of the evaluation.\n\n==Situations requiring psychological evaluations==\n\n[[job applicant|Applicants]] to sensitive jobs, such as jobs in [[Intelligence (information gathering)|intelligence]] or other jobs handling [[state secrets]], may be required to submit to a psychological evaluation before they can be employed, although usually a [[background check]] is much more important.\n\n[[Court]]s may order a [[competency evaluation (law)|competency evaluation]] of a [[defendant]] to determine [[competence (law)|competency]] to stand [[trial]]. An [[insanity defense]] will also usually require the defendant to undergo a psychological evaluation.\n\n'
p150
tp151
a(I1
S'Lewis Evans (18531930) was an [[England|English]] businessman and [[scientific instrument]] collector.\n\nLewis Evans was the son of Sir [[John Evans (archaeologist)|John Evans]], an archaeologist, and younger brother the more famous archaeologist Sir [[Arthur Evans]] (18511941) who discovered [[Knossos]] in [[Crete]]. He studied [[chemistry]] at [[University College London]] and became a businessman. During his career, he rose to [[Chairman]] of the family paper-making firm [[John Dickinson & Co. Ltd]] and lived at [[Russels]], a country house near the companys paper mill, close to [[Watford]]. \n\nOver the course of about fifty years, Evans also built up an important [[Collection (museum)|collection]] of [[Measuring instrument|scientific instrument]]s.<ref>Peter de Clercq, [http://www.mhs.ox.ac.uk/sphaera/index.htm?issue11/articl4  Lewis Evans and the White City Exhibitions], [[Sphra]], Issue 11. Newsletter of the [[Museum of the History of Science]], [[Oxford]].</ref> In 1924, he presented this collection of [[sundial]]s, [[astrolabe]]s, early [[mathematical instrument]]s and associated library of early books to [[Oxford University]]. The Lewis Evans Collection was made accessible to the public in the same year and he was awarded an honorary [[Doctor of Science]] degree by the University in 1925.\n\nThrough the efforts of his friend [[Robert Gunther]], Evans donation helped in the founding of the [[Museum of the History of Science, Oxford]] in 1930 by providing what became known as the Lewis Evans Collection of Historic Scientific Instruments, the core of the museums initial collection. His library is also owned by the museum.<ref>[http://www.mhs.ox.ac.uk/library/lewis/ Lewis Evans Library], Museum of the History of Science, Oxford.</ref>\n\n'
p152
tp153
a(I-1
S'Phan may refer to:\n\n* [[Pan (surname)]], Chinese family name, of which Phan is the Vietnamese spelling\n* [[Amphoe Phan]] district, Chiang Rai Province, Thailand\n* Phan, followers of the [[jam band]] [[Phish]]\n* [[Phan (tray)]] (Thai: ). A tray with a pedestal. Used often for ritual offerings.\n\n{{Disambig}}\n'
p154
tp155
a(I-1
S'[[Image:Marine_da_nang.jpg|right|thumbnail|[[Da Nang]], [[Vietnam]] - A young [[United States Marine Corps|Marine]] private waits on the beach during the Marine landing. - [[August 3]], [[1965]].]]\nFucking New Guy (FNG) is a [[term of disparagement|derogatory term]], used within [[Military of the United States|American Forces]] deployed to [[South East Asia]] during the [[Vietnam War]].<ref>{{Citation  | last1 = Cornell  | first1 = George | title = G.I. Slang in Vietnam  | journal =  The Journal of American Culture  | volume = 4  | issue = 2  | pages = 195200 | publisher = [[Blackwell Publishing]]  | location = Oxford  | date = [[Summer]]  | year = 1981  | doi = 10.1111/j.1542-734X.1981.0402_195.x }}.</ref>\n\n==Overview==\nUsually, but not always, the term referred specifically to recruits fresh from the [[United States]] who joined pre-existing units in [[Vietnam]]. Every unit had an FNG, and the term was used across all unit types, from front line combat through to support and [[Combat medic|medical]] units. Neither was the term gender specificfemale personnel could be FNGs as well.<ref>{{cite paper | author = Sexton, Julia A.  | title = Warrior Women of the Crimea and Vietnam: A Comparison of Fact and Fiction | version = Final | publisher = Unpublished | date = May, 2002 | url = http://www.illyria.com/documents/julia_chap5.pdf | format = [[PDF]] | accessdate = 2008-04-06 }}</ref>\n\nThe FNG phenomenon grew out of the US Militarys individual rotation policy during the Vietnam War, under which individual troops were rotated in and out in twelve-month tours with already deployed units in Vietnam.  In other modern American wars before and since, military units have been maintained and have deployed as a whole.  During this period, because of the [[Cold War]], the United States faced the need of maintaining a large presence of combat troops not only in Southeast Asia, but in [[Korea]] and [[Western Europe]] as well.  The  [[Lyndon Johnson|Johnson]] administration lacked the political capital and will that would have been required to call up the [[United States National Guard|National Guard]] and [[Reserve component of the Armed Forces of the United States|Reserves]] or to convince [[US Congress|Congress]] to extend the tours of duty of draftees beyond twenty-four months. Lacking sufficient [[US Army|Army]] and [[US Marine Corps|Marine]] ground combat units to sustain a unit-based rotation strategy, the individual rotation policy was adopted.<ref>{{Citation | author = Mark DePu | title = Vietnam War: The Individual Rotation Policy | publisher = HistoryNet | url = http://www.historynet.com/vietnam-war-the-individual-rotation-policy.htm | accessdate = 2008-11-19}} </ref>\n\nFNGs were an important part of the [[Group dynamics|group dynamic]] of US units in Vietnam and their treatment had at its core an overall sense of  us (those with experience of the war) and them (those who were back in the United States). As one soldier said, FNGs were still shitting stateside chow.<ref>{{Citation | last1 = Mathers | first1 = Danny L., Rifleman, B Company, 1/61 | title = New Guys | url = http://one-six-one.fifthinfantrydivision.com/161pg14a.htm | accessdate = 2008-04-06 }}.</ref> It was in combat units that the FNG was truly ignored and hated by his fellow soldiers. An FNG in a combat unit was treated as a non-person, a pariah to be shunned and scorned, almost vilified, until he passed that magic, unseen line to respectability.<ref name=NAM>{{Citation |coauthors = Tim Page, John Pimlott, co-editors |title = NAM: The Vietnam Experience 1965-1975, Article: FNGs | publisher = Hamlyn |date = 1988 |pages = 441443 |isbn = 0-600-563-111 |author = consultant editors, Tim Page, John Pimlott}}</ref>\n\nOn the surface, such treatment of new members in the unit happened for simple survival reasons. New recruits had a higher [[Attrition warfare|attrition]] rate than experienced troops, and the small units of veteran [[jungle warfare]] troops simply saw them as a liability. They talked too loud and made too much noise while moving around, didnt know what to take into the bush or even how to wear it properly, couldnt respond to basic combat commands, fired too much ammo, and tended to flake out on even the easiest 10-[[klick]] moves. An Christ, they even got homesick.<ref name=NAM/>\n\nBeyond mere survival though, there were deeper reasons for veterans to hate the new comers. On one level, the FNG represented those men who were still in America and this fomented resentment. As one popular marching song of the era went: Aint no use in lookin back, [[Military cadence|Jodys]] got your [[Cadillac]]; Aint no use in going home, Jodys got your girl and gone.<ref name=NAM/> Until they set foot in Vietnam, every FNG was a Jody, back in the US enjoying life.\n\nWithin a military unit, the FNG was seen as a grunt. A unit would attach an almost mystical quality to any members of the unit with prior combat experience; the FNG was expected to live up to the same standard and would not be accepted into the group until he, too, had made a name for himself.\n\nThe term does not appear to have seen widespread use outside of the US Military.\n\n==Studies==\n\nSeveral specific studies have been undertaken into the FNG phenomenon.\n\nDr. [[Douglas R. Bey]] published Group dynamics and the F.N.G. in Vietnam--a potential focus of stress in 1972 and has been referenced extensively, including having been used in defence of initiation practices within modern US units.<ref>{{Citation  | last1 = Bey | first1 = Douglas R.  | title = Group dynamics and the F.N.G. in Vietnam--a potential focus of stress  | journal = International Journal of Group Psychotherapy  | volume = 22 | issue = 1  | pages = 2250  | publisher = Guilford Press  | location = New York  | date = January | year = 1972  | url = http://www.ncbi.nlm.nih.gov/sites/entrez?Db=pubmed&Cmd=ShowLibraryLinks&TermToSearch=5057967  | pmid = 5057967 | issn = 0343-6993 }}</ref>\n\nDr. [[Charles Figley]] has also written on the effects of being an FNG as part of the development of post traumatic stress disorder in combat veterans.\n\n==Pop Culture==\nThe term FNG and the group dynamics associated with it have been addressed on some level in several major motion pictures in the last couple of decades and is still used in the US military.\n\n[[Oliver Stone|Oliver Stones]] film [[Platoon (film)|Platoon]] traces the experiences of young recruit Private Chris Taylor ([[Charlie_sheen|Charlie Sheen]]) during the Vietnam War.<ref>{{cite video  | people = Stone, Oliver (Director)  | title = [[Platoon_(film)|Platoon]]  | medium = Theatrical Release  | publisher = [[Arnold_Kopelson|Kopelson, Arnold (Producer)]]  | location = USA  | year2 = 1986 }}.</ref>\n\n[[Stanley Kubrick|Stanley Kubricks]] film [[Full Metal Jacket]] follows pragmatic Private Joker ([[Matthew_Modine|Matthew Modine]]) and his fellow new recruits through basic training and deployment into the wars 1968 Tet Offensive.<ref>{{cite video  | people = Kubrick, Stanley (Director)  | title = [[Full_Metal_Jacket|Stanley Kubricks Full Metal Jacket]]  | medium = Theatrical Release  | publisher = Stone, Oliver (Producer)  | location = USA  | year2 = 1987 }}.</ref>\n\nIn [[Robert Zemeckis]]s film [[Forrest Gump]], the titular character ([[Tom Hanks]]) and his best friend ([[Mykelti Williamson]]) are called FNGs by their commanding officer ([[Gary Sinise]]) when they first arrive in Vietnam.\n\nThe backpacker novel [[The Beach (novel)|The Beach]] by [[Alex Garland]], later made into a [[The Beach (film)|film]] of the same title and directed by [[Danny Boyle]], introduced the term into popular culture amongst young tourists in South East Asia.<ref>{{cite book  | last = Garland  | first = Alex  | authorlink = Alex Garland  | title = The Beach  | publisher = [[Viking Press]]  | location = London  | date = 1996  | isbn = 0-670-87014-5 }}</ref><ref>{{cite video |people=[[Danny_Boyle|Boyle, Danny (director)]]|date2= |month2= |year2= |title=[[The Beach (film)|The Beach]]|url= |format= |medium=Theatrical Release|publisher=[[Andrew Macdonald (producer)|Macdonald, Andrew (Producer)]]|location=United States|accessdate=2008-07-21 |time= |quote= }}</ref>\n\n[[Donald Bodey]] has written a fictional account of the FNG experience in his novel titled simply FNG.<ref>{{cite book\n  | last = Bodey\n  | first = Donald\n  | authorlink = Donald Bodey \n  | title = F.N.G., Revised Edition\n  | publisher = Modern History Press\n  | date = 2008\n  | location = Ann Arbor, MI\n  | pages = \n  | url = http://donbodey.com\n  | isbn = 978-1-932690-58-3}}\n</ref>\n\nThe first level in multiplatform game [[Call of Duty 4]] is called F.N.G, and one of the soldiers introduces the player to the commander of the squad by saying Its the FNG, sir, and asking him to go easy on him, sir. Its his first day in Regiment.<ref>[http://callofduty.wikia.com/wiki/FNG F.N.G. - The Call of Duty Wiki<!-- Bot generated title -->]</ref>\n\nThe protagonist in [[Doom 3]] is referred to as the ranking F.N.G. shortly after arriving at Mars City.\n\nIn first episode (Get Some) of the HBO series [[Generation Kill]] Lance Cpl. Trombleys fellow marines refer to him as an FNG during the mess hall scene as he was improperly attired, wearing his [[boonie hat]] after dark.\n\nIn the movie Shooter the people at FBI headquarters call Nick Memphis an F.N.G.\n\nFNG is a half-hour lifestyle show on the [[Pentagon Channel]] featuring useful benefits aimed at young troops new to the military.\n\nA newly-released (Late July 2009) video promoting [[Halo 3 ODST]] has the Sergeant of a squad refer to the rookie as an F.N.G.\n\nThe term is used in the [[Battlestar Galactica (2004 TV series)|Battlestar Galactica]] second season episode [[Scar (Battlestar Galactica)|Scar]], with the F standing for [[Frak (expletive)|frakking]].\n\nIn the movie District 9, the term is used.\n\n'
p156
tp157
a(I1
S'{{otheruses4|Los Angeles-based actor, producer, and collector|radio and TV announcer who died in 2006|Tom Gregory}}\n\n{{Infobox person\n|image=\n|caption=\n|name=Tom Gregory\n|birth_date={{birth date|1960|04|24}}\n|birth_place=[[Camden, New Jersey]]\n|nationality=American\n|known_for=commentary, memorabilia collection\n|occupation=[[writer]], [[collecting|collector]], [[Theatrical producer|producer]]\n}}\n\nTom Gregory (born April 24, 1960 in Camden, New Jersey) is an American entertainer and socio-political commentator.\n\n==Biography==\n\nTom Gregory is an actor, radio personality, and a socio-political and entertainment industry commentator.  He and his significant other, philanthropist and technology entrepreneur, [[David Bohnett]] live in [[Beverly Hills, California]].\n \n==Media==\n\nTom Gregorys ongoing media forums include his website, his Huffington Post column, and regular radio dispatches for Leeza Gibbons internationally syndicated program Hollywood Confidential. He has also been featured on CNN, E!, and Fox News, among other outlets, and is the face of OVGuide.com, one of the Internets leading sources for indexing online video content.<ref name=showbiztom>{{cite web | title=About Tom | publisher=ShowBizTom.com | url=http://www.showbiztom.com/pages/bio}}</ref> Recently, Gregory debuted as a Broadway producer on the 2009 Tony Award-nominated revival of Guys and Dolls at the Nederlander Theatre.<ref name=guysdolls>{{cite web | title=Oscar, Broadway Commitments Keep Tom Gregory Busy on Both Coasts | publisher=The Beverly Hills Courier | url=http://www.showbiztom.com/documents/view/6}}</ref>\n\n==Hollywood Memorabilia==\n\nTom Gregory is a collector of autographed, archival Hollywood photographs.<ref name=georgechristy>{{cite web | url=http://www.bhcourier.com/article/George_Christy/George_Christy/George_Christy_08142009/65375 | title=George Christy 08-14-2009 | publisher=Beverly Hills Courier}}</ref><ref name=signedphotos>{{cite web | url=http://www.27east.com/story_detail.cfm?id=206049 |title=Gregory Dons Producers Hat | author=Brendan OReilly |publisher=Southampton Press}}</ref> Included in his collection are a photo of [[Marilyn Monroe]] circa 1955 that is personalized to [[James Dean]]; an image of [[Boris Karloff]] in full Frankenstein monster regalia; and an exquisite portrait of [[Greta Garbo]] that is one of only a few known copies in the world.\nHollywood memorabilia in his collection are the cowboy shirts worn by [[Heath Ledger]] and [[Jake Gyllenhaal]] in the film [[Brokeback Mountain]]<ref name=brokebackshirts>{{cite web | publisher=Associated Press |title= Brokeback Mountain Shirts Worth Big Bundle for Charity | url=http://abclocal.go.com/kabc/story?section=news/entertainment&id=3932635}}</ref> as well as the suit, shirt, tie and campaign pin worn by [[Sean Penn]] during his Oscar-winning performance in [[Milk]]<ref name=seanpennsuit>{{cite web | publisher=United Press International | title=Penns Milk costume sells for $12,500 | url=http://www.upi.com/Entertainment_News/2009/03/04/Penns-Milk-costume-sells-for-12500/UPI-35021236198004/}}</ref> The auction bids for these items have benefitted different charities.\n\n==Philanthropy==\n\nTom Gregorys philanthropic involvement also spans both coasts. In Los Angeles, where one of his two homes is an A. Quincy Jones-designed architectural wonder originally owned by film icon Gary Cooper, he teaches afterschool acting classes for pre-teens, drawing on his own acting experience gained in repertory companies in East Hampton, NY and Delray Beach, FL. In Southampton, NY, where he also has a home, Tom Gregory helped found the Lake Agawam Conservation Association to clean-up the lakes fragile eco-system.\n\n==LGBT Rights==\n\nAs an ardent supporter of human rights and civil liberties, Tom writes prolifically on LGBT issues in his articles for the Huffington Post. His media and philanthropic efforts on the behalf of the LGBT communities rest on his faith in the institution of Americas promise of equality and justice for all its citizens.  He was also a major contributor to the No on Prop 8 campaign.\n\n'
p158
tp159
a(I1
S'{{Refimprove|date=July 2007}}\nA deep sand bed (sometimes abbreviated DSB) is a [[filtration]] method used in some [[saltwater aquarium]]s. A deep sand bed, similar to the [[Berlin Method]], is designed to cultivate [[Anaerobic organism|anaerobic]] [[bacteria]] in the bottom layers of sand, converting [[nitrate]] to [[nitrogen gas]] to remove toxic nitrates.\n\n==Operation==\nA deep sand bed commonly is defined as a bed of fine sand with a minimum depth of 4 to 6 inches to ensure a layer of water in the lower portion of the sand will receive poor circulation. An established deep sand bed is composed of [[live sand]] which, like [[live rock]], contains bacteria and other marine [[organism]]s such as worms, crabs, snails and stars. The creatures burrow and overturn the top 2 to 3 inches of sand in search of nourishment, which allows water circulation much deeper into the sand than would be possible without the creatures aid.\n\nDeep sand beds can be constructed of a variety of materials, but typically fine or superfine sand is used, with a size between 1 mm and 0.05 mm.  A larger particle size provides improved circulation, which would in turn require a greater depth. Comparatively, the larger particles may be too heavy for the worms and other inhabitants to lift, which would limit circulation into the bed. Additionally, larger particles (2 mm or larger) are prone to [[Detritus (biology)|detritus]] accumulation, which would necessitate periodic siphon cleaning. A well-chosen fine grain sand will create a deep sand bed which reduces cleaning.\n\n'
p160
tp161
a(I1
S'{{Refimprove|date=October 2008}}\n:For the Swedish football defender, see [[Robert Stoltz]].\n\n[[Image:Robert-Stolz.JPG|thumb|right|200px|Bust of Robert Stolz in the [[Stadtpark, Vienna|Viennese City Park]]]]\nRobert Elisabeth Stolz ([[25 August]] [[1880]] &ndash; [[27 June]] [[1975]]) was an [[Austria]]n [[songwriter]] and [[Conducting|conductor]] as well as a [[composer]] of [[operetta]]s and [[Film score|film music]].\n\n== Biography ==\n\nThe great-nephew of the soprano [[Teresa Stolz]], Stolz was born of musical parents in [[Graz]].<ref name=web>{{cite web |url=http://www.johann-strauss.org.uk/composers/index.php3?content=stolz |title=Johann Strauss Society: Robert Stolz |accessdate=2008-10-01|publisher=Johann Strauss Society of Great Britain}}</ref> His father was a conductor and his mother a concert pianist. He studied at the [[University of Music and Performing Arts, Vienna|Vienna Conservatory]] with [[Robert Fuchs]] and [[Engelbert Humperdinck]]. From 1899 he held successive conducting posts at [[Maribor]] (then called Marburg), [[Salzburg]] and [[Brno]] before succeeding [[Artur Bodanzky]] at the [[Theater an der Wien]] in 1907. There he conducted, among other pieces, the first performance of [[Oscar Straus]]s Der tapfere Soldat ([[The Chocolate Soldier]]) in 1908, before leaving in 1910 to become a freelance composer and conductor. Meanwhile, he had begun to compose operettas and individual songs and had a number of successes in these fields.\n\nAfter serving in the [[Military of Austria|Austrian Army]] in [[World War I]], Stolz devoted himself mainly to [[cabaret]], and moved to [[Berlin]] in 1925. Around 1930, he started to compose music for [[film]]s, such as the first German sound film Zwei Herzen im Dreivierteltakt ([[Two Hearts in Waltz Time]]), of which the title-waltz rapidly became a popular favourite. Some earlier Stolz compositions, such as Adieu, mein kleiner Gardeoffizier from his operetta Die lustigen Weiber von Wien, became known to wider audiences through the medium of film.\n\nThe rise of [[Nazi Germany]] led Stolz to return to Vienna, where his title-song for the film [[Ungeksst soll man nicht schlafen gehn]] was a hit, but then came the [[Anschluss]], and he moved again, first to [[Zrich]] and then to [[Paris]], where in 1939 he was [[internment|interned]] as an [[enemy alien]]. With the help of friends he was released and in 1940 made his way to [[New York]].<ref name=web/>\n\nIn America, Stolz achieved fame with his concerts of Viennese music, starting with A Night in Vienna at [[Carnegie Hall]]. As a result, he received many invitations to compose music for shows and films, and he received two [[Academy Awards]] nominations: Waltzing in the Clouds was nominated for Best Original Song in 1941, and his score for [[It Happened Tomorrow]] was nominated for [[Academy Award for Original Music Score|Best Dramatic or Comedy Picture Score]] in 1945.\n\nIn 1946 Stolz returned to Vienna, where he lived for the rest of his life. In the 1960s and 1970s he made a number of [[Gramophone record|recordings]] of operettas by composers such as [[Johann Strauss]], [[Franz Lehr]], [[Emmerich Kalman]], and [[Leo Fall]], whom he had known previously.\n\nIn 1970, to mark his 90th birthday, he was made an [[List of Honorary Citizens of Vienna|Honorary Citizen of Vienna]]. He was also awarded Viennas Grand Medal of Honour, being only the second musician ever to be so honoured (after [[Richard Strauss]]). He also appeared on a series of commemorative [[List of people on stamps of Austria|Austrian postage stamps]].\n\nIn later years he used a baton inherited from [[Franz Lehr]], that had been originally owned by Johann Strauss and contained Strausss initials engraved in silver. \n\nAfter his death in Berlin in 1975, Robert Stolz received the honour of a lying-in-state in the foyer of the [[Vienna State Opera|Vienna State Opera House]].{{Fact|date=October 2008}} He was buried near [[Johannes Brahms]] and [[Johann Strauss II]] in Viennas [[Zentralfriedhof]], and a statue to him was erected in the [[Wiener Stadtpark]].\n\n== Selected operettas ==\n[[Image:Robert Stolz Memorial 1.jpg|thumb|right|300px|Robert Stolz Memorial at the [[Prater]]]]\n*[[Das Glcksmdel]] (1910)\n* [[Der Tanz ins Glck]] (The Dance into Happiness) (1921)\n* Im weien Rl ([[The White Horse Inn]]) (1930), jointly with [[Ralph Benatzky]]\n* Wenn die kleinen Veilchen blhen (When the Little Violets Bloom or Wild Violets) (1932)\n* [[Zwei Herzen im Dreivierteltakt (Der verlorene Walzer)|Der verlorene Walzer]], a stage version of the film Zwei Herzen im Dreivierteltakt (1933)\n\n== Selected songs ==\n\n*Servus Du (1912)\n*Wien wird erst schn bei Nacht\n*Im Prater blhn wieder die Bume\n*Das ist der Frhling in Wien\n*Du, du, du sollst der Kaiser meiner Seele sein. (1916)\n*Hallo, du ssse Klingelfee (1919)\n*Salome, schnste Blume des Morgenlands\n*Ich will deine Kameradin sein\n*Die ganze Welt ist himmelblau\n*Salome\n*Zwei Herzen im Dreivierteltakt\n*Frag nicht warum ich gehe\n*Wiener-Caf Walzer\n\n'
p162
tp163
a(I1
S'{{Citations missing|date=December 2007}}\n\n[[Image:Snowfort.jpg|right|thumb|A snow fort made from piled snowballs]]A snow fort or snow castle is a usually open-topped temporary structure made of [[snow]] walls that is used for recreational purposes.  Snow forts are generally built by children as a [[playground game]] or winter [[hobby|pastime]] and are used as defensive structures in [[snowball fight]]s. They are also built and used for [[Childrens games (role play)|make-believe games]] such as house or store. Along with the [[snowman]], it is one of the two structures commonly built by children out of snow.\n\nSnow structures made for sleeping are called [[igloo|igloos]] when made from snow blocks and [[quinzhee|quinzhees]] when made by hollowing out a pile of snow.\n\n== Variations ==\nSnow forts consist of walls of piled and compacted snow. They may be open or closed, that is, a person in the snow fort may be completely surrounded by the walls on all sides, there may be a door, or the person may be completely exposed except in one direction.  The last variation is used for snowball fights where opponents have forts facing each other and attack exclusively from their own fort. Existing structures such as the walls or concave corners of a building can be used as part of the snow fort, allowing for faster and easier construction. A snow fort can also be a tunneled-out burrow built in a large snow drift.  \n\nSnow forts are usually at least knee-height and one-roomed. Forts built for snowball fights may be higher, and ones built for house may have lower walls and multiple rooms. When used for snowball fights, snow forts often have sections where the wall is lower, through which the occupants throw snowballs.\n\n===Finland===\nThe [[SnowCastle of Kemi]] is the biggest snow castle in the world, built in [[Kemi]] in 1996{{Fact|date=December 2007}} Since then the worlds largest snow castle has been rebuilt annually in Kemi. The area has varied from 13,000 to over 20,000 square meters. Highest towers have been over 20 meters high and longest walls over 1,000 meters long. Sometimes there have been three-storey buildings there. The SnowRestaurant has ice tables and seats covered with [[reindeer]] fur. The [[ecumenism|ecumenical]] SnowChapel decorated with ice sculptures has seen numerous weddings with some couples coming from Japan and Hong Kong. There is also a SnowHotel in the snow castle. The hotel has double rooms and a honeymoon suite with ice decorations.\n\nThere are also ice decorations in Lainio Snow Hotel (near Ylls and [[Levi, Finland]]).{{Fact|date=December 2007}}\n\n===Canada===\n\nIn [[Kingston, Ontario]], the annual FebFest [[snow sculpture]] competition in Confederation Park in features snow forts by [[Royal Military College of Canada]] and [[Queens University]]. The snow fort must not only be pleasing to look at but also safe for children to play on. In 2008, [[Royal Military College of Canada]]s snow fort was modelled after the MacKenzie Building in the [[Second Empire]] style with a [[Mansard roof]], and a central tower incorporating a working clock, flanked by projecting end towers and a slide. Both teams worked through the night, filling rectangular [[recycling]] bins with snow.\n\n==In popular culture==\n[[The Backyardigans]] episode The Snow Fort has [[Mounties]] defending an elaborate version of such a fort while members of the [[ski patrol]] try to get in.\n\n[[The Dog Who Stopped the War]] (1984) is a cult movie and box-office hit in [[Qubec]]. Half of this movie revolves around a very elaborate snow fort.\n\n'
p164
tp165
a(I1
S'{{pp-semi-blp|small=yes}}\n{{Infobox Wrestler\n|name=Dave Batista\n|names=Batista<ref name=wwebio/><br>Dave Batista<br>Deacon Bautista<ref name=officialsite/><br>Leviathan<ref name=officialsite/><br>Kahn / Khan<ref name=officialsite/>\n|image=Batista-closeup.jpg\n|img_capt=Batista at an autograph signing in 2003\n|height={{height|ft=6|in=6}}<ref name=wwebio>{{cite web |url=http://www.wwe.com/superstars/smackdown/batista/bio/|title=Batista Bio|accessdate=2009-09-21|publisher=[[World Wrestling Entertainment]]}}</ref><!-- Official WWE.com stats -->\n|weight={{convert|290|lb|kg|abbr=on}}<ref name=wwebio/><!-- Official WWE.com stats -->\n|birth_date ={{birth date and age|mf=yes|1969|01|18}}<ref name=official/>\n|death_date =\n|birth_place =[[Washington, D.C.]]<ref name=officialsite>{{cite web|url= http://www.demon-wrestling.com/pages/faq.php|title=The Demon FAQ (Frequently Asked Questions)|publisher=Demon Wrestling|accessdate=2007-11-13}}</ref>\n|resides=[[Tampa, Florida]]<ref name=officialsite/>\n|billed=[[Washington, D.C.]]<ref name=wwebio/>\n|trainer=[[Afa Anoai]]<ref name=officialsite/><ref name=OWOW>{{citeweb|url=http://www.onlineworldofwrestling.com/profiles/b/batista.html|accessdate=2008-07-15|title=Batistas Online World of Wrestling profile|work=Online World of Wrestling|publisher=Black Pants}}</ref>\n|debut=1997<ref name=OWOW/>\n|retired=\n|website=[http://www.demon-wrestling.com/ Official website]\n}}\nDavid Michael Bautista, Jr.<ref name=batista6>{{cite book|title=Batista Unleashed|first=Dave|last=Batista|coauthors=Roberts, Jeremy|isbn=1-4165-4410-4|publisher=[[Simon & Schuster]]|origmonth=October|origyear=2007|pages=6}}</ref> (born January 18, 1969),<ref name=official>{{cite web|url=http://www.demon-wrestling.com/pages/about.php|title=About Dave|accessdate=2008-08-03|publisher=Demon Wrestling}}</ref> better known by his [[ring name]], Batista, is an American [[Professional wrestling|professional wrestler]] currently signed to [[World Wrestling Entertainment]] on its [[WWE SmackDown|SmackDown]] [[WWE Brand Extension|brand]].\n\nIn professional wrestling, Batista is a five-time [[World Heavyweight Championship (professional wrestling)|world heavyweight champion]], having won the [[World Heavyweight Championship (WWE)|World Heavyweight Championship]] four times and the [[WWE Championship]] one time. In addition to these championships, Batista has also won the [[World Tag Team Championship (WWE)|World Tag Team Championship]] three times (twice with [[Ric Flair]] and once with [[John Cena]]) and the [[WWE Tag Team Championship]] once (with [[Rey Mysterio, Jr.|Rey Mysterio]]). Batista was also the winner of the 2005 [[Royal Rumble#Royal Rumble match|Royal Rumble match]].<ref name=wwebio/>\n\nAfter trying out at the [[WCW Power Plant]], Batista signed a contract with the World Wrestling Federation (WWF) in 2000 and was sent to its developmental federation, [[Ohio Valley Wrestling]] (OVW), where he won the [[OVW Heavyweight Championship]].\n\n==Early life==\nBautista was born the son of David Michael Bautista, who is [[Filipino people|Filipino]] and Donna Raye Bautista, who is [[Greeks|Greek]].<ref name=batista6/> His parents separated (and eventually [[divorce]]d) after his mother came out as a [[lesbian]].<ref>http://www.advocate.com/exclusive_detail_ektid50106.asp</ref> His paternal grandparents were also from the Philippines as his grandfather served in the military, worked as a taxi driver, barber, and other odd jobs to feed the family. Bautista says he is not ashamed to admit he lived in [[poverty]].<ref>{{cite web |first=Ed|last=Richelle|url=http://www.manilatimes.net/national/2006/sept/16/yehey/life/20060916lif5.html |archiveurl=http://web.archive.org/web/20071021053955/http://www.manilatimes.net/national/2006/sept/16/yehey/life/20060916lif5.html|archivedate =2007-10-21|date=2006-09-16|title=Pinoy hospitality tames The Animal|accessdate=2008-08-05|work=[[The Manila Times]] |publisher=Manila Times Publishing Corporation (via Web Archive)}}</ref>\n\nHe has publicly admitted to having a hard life where, as before he was age nine, three murders occurred on his front lawn.<ref>{{cite book |title = Batista Unleashed |first=Dave |last=Batista |coauthors=Roberts, Jeremy |isbn=1-4165-4410-4 |publisher=[[Simon & Schuster]] |origmonth=October |origyear=2007 |pages=1617}}</ref> As young as age 13, he was [[Motor vehicle theft|stealing automobiles]].<ref name=Manilla>{{cite web | url = http://www.manilastandardtoday.com/?page=goodLife02_sept23_2006 |title = Whos afraid of Batista? | date = 2006-09-23 | accessdate = 2008-08-04 |first=NRJ |last=Ramos |work = [[Manila Standard Today]] | publisher = Kamahalan Publishing Corporation}}</ref> By age 17, he was considered estranged from his parents and on his own,<ref name=WWESS1>{{cite web | url = http://www.wwe.com/inside/news/archive/batista1 |title=Batistas SummerSlam homecoming | first = David | last = Agostino | date = 2005-08-17 | accessdate = 2008-06-04 | publisher = [[World Wrestling Entertainment]]}}</ref> despite admitting later that I am proud of my parents. They are good, honest, hard-working folks. They taught me the values of working hard.<ref name=Manilla/> Bautista became a regular [[Bouncer (doorman)|bouncer]] for clubs until he was [[arrest]]ed after a fight that left two badly injured patrons, one of which could be found lying in the street.<ref name=WWESS1/> After a [[Trial (law)|trial]], he was sentenced to one year of [[probation]].<ref name=WWESS1/> He was also a [[lifeguard]]<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 5051}}</ref> before he pursued a career in [[bodybuilding]].<ref name=WWESS1/> He credits bodybuilding as possibly saving his life.<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors=Roberts, Jeremy |isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October |origyear=2007 |pages=42}}</ref>\n\n==Professional wrestling career==\nBautista tried out at the [[WCW Power Plant]] but was told he would never make it in the wrestling business by [[Dwayne Bruce|Sgt. Buddy Lee Parker]].<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 6162}}</ref> He then went to the [[World Wrestling Entertainment|World Wrestling Federation]], who sent him to train with [[Afa Anoai]]s school in the Wild Samoan Training Centre.<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 7293}}</ref>\n\n===Ohio Valley Wrestling (20002002)===\nHe made his [[Ohio Valley Wrestling]] debut in 2000 under the ring name Leviathan, where he immediately joined forces with Synn.<ref name=OWOW/> As a member of the Disciples of Synn [[List of professional wrestling terms#S|stable]], he went undefeated until being beaten at Christmas Chaos by [[Glenn Jacobs|Kane]] with help from [[Stone Cold Steve Austin]]. He later won the [[OVW Heavyweight Championship]] from The Machine [[Doug Basham]] before losing the belt to [[John Cena|The Prototype]]. A few months later, Bautista left OVW after he was promoted to World Wrestling Entertainment.<ref name=SLAM! Profile>{{cite web|first=John|last=Milner |coauthors=Kamchen, Richard|title=Dave Bautista - Slam! Sports profile|url=http://slam.canoe.ca/Slam/Wrestling/Bios/batista.html|publisher=[[Canadian Online Explorer]]|work=Slam! Sports|accessdate=2007-09-11}}</ref><!-- Ref covers all the paragraph. -->\n\n===World Wrestling Entertainment (2002present)===\n====Debut====\nHe began his WWE career on the May 9, 2002 episode of [[WWE SmackDown|SmackDown!]] as Deacon Bautista, a [[heel (professional wrestling)|villainous]] [[Enforcer (professional wrestling)|enforcer]] for [[Devon Hughes|Reverend D-Von]].<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | page = 95}}</ref> He made his WWE in-ring debut in a [[tag team]] match teaming with D-Von against [[Ron Simmons|Faarooq]] and [[Randy Orton]], [[Pin (professional wrestling)|pinning]] Orton. Over several weeks, Orton tried to beat D-Von and Bautista with different partners, but ultimately lost each time.<ref>{{cite book|first=Michael|last=McAvennie|title=WWE The Yearbook: 2003 Edition|publisher=[[Simon & Schuster]]|origyear=2003|origmonth=April|isbn=0-7434-6373-0|pages=170|year=2003}}</ref> Bautista suffered his first loss in a match against [[Solofa Fatu|Rikishi]] after D-Von accidentally punched him, allowing Rikishi to take advantage and pin Bautista. Bautista and D-Von argued over the forthcoming weeks, with Bautista eventually turning on D-Von.<ref>{{cite book|first=Michael|last=McAvennie|title=WWE The Yearbook: 2003 Edition|publisher=[[Simon & Schuster]]|origyear=2003|origmonth=April|isbn=0-7434-6373-0|pages=203|year=2003}}</ref> After splitting with D-Von, he signed with [[WWE Raw|Raw]] and was renamed to Dave Batista (or simply Batista). He aligned himself with [[Ric Flair]]<ref>{{cite book|first=Michael|last=McAvennie|title=WWE The Yearbook: 2003 Edition|publisher=[[Simon & Schuster]]|origyear=2003|origmonth=April|isbn=0-7434-6373-0|pages=334|year=2003}}</ref> and [[Feud (professional wrestling)|feuded]] with [[Glenn Jacobs|Kane]], whom he defeated at [[Armageddon (2002)|Armageddon]].<ref>{{cite book|first=Michael|last=McAvennie| title=WWE The Yearbook: 2003 Edition|publisher=[[Simon & Schuster]]|origyear=2003|origmonth=April|isbn=0-7434-6373-0|pages=328330|year=2003}}</ref>\n\n====Evolution (20032005)====\n{{Main|Evolution (professional wrestling)|l1=Evolution}}\nIn January 2003, Batista joined [[Triple H]], Ric Flair and Randy Orton to form the villainous stable Evolution.<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 138}}</ref> Batista, however, was sidelined for much of 2003 after he tore his right [[Triceps brachii muscle|triceps muscle]] at a Raw [[house show|live event]] in a tag team match against the [[Dudley Boyz]]. While training after the injury, Batista re-tore his triceps, extending his stay on the sidelines.<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 140142}}</ref> Batista made his return on the October 20 episode of Raw, interfering in a match between [[Bill Goldberg]] and [[Shawn Michaels]] and shattering Goldbergs ankle with a chair. After the interference, Evolution came out, and Triple H rewarded Batista with $100,000.<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 143144}}</ref> On the November 10 edition of Raw, Goldberg defeated Batista by disqualification when Triple H interfered.<ref>{{cite web | url = http://web.archive.org/web/20040610083904/raw.wwe.com/results/111003/results.html | title = The legend lives on... will Stone Cold? | date = 2003-11-10 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]] (via Web Archive)}}</ref>\n\nAt [[Armageddon (2003)|Armageddon]], Batista took part in two matches; losing to Shawn Michaels in a singles match,<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2003/12/15/288020.html | title = WWE Armageddon a flop | date = 2003-12-15 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Nick | last = Tylwalk | coauthors = Plummer, Dale}}</ref> and winning a [[Professional wrestling match types#Gauntlet match|tag team turmoil match]] along with Ric Flair to become one-half of the [[World Tag Team Championship (WWE)|World Tag Team Champions]].<ref name=WT1>{{cite web|url=http://www.wwe.com/inside/titlehistory/worldtagteam/3044541321151|title=Batista and Ric Flairs World Tag Team Title reign|accessdate=2007-09-19|publisher=[[World Wrestling Entertainment]]}}</ref> By the end of the event, all four members of Evolution held every male championship on Raw, with Triple H winning the [[World Heavyweight Championship (WWE)|World Heavyweight Championship]] and Randy Orton winning the [[WWE Intercontinental Championship]].<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 139140}}</ref> They held the title until the February 16, 2004 episode of Raw, when they were defeated by [[Booker Huffman|Booker T]] and [[Rob Van Dam]].<ref>{{cite web | url = http://web.archive.org/web/20040610091854/raw.wwe.com/results/021604/results.html | title = Triple Threat at WrestleMania XX ... cause Stone Cold said so | date = 2004-02-16 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]] (via Web Archive)}}</ref> They later regained the title for a short period.<ref name=WT2>{{cite web|url=http://www.wwe.com/inside/titlehistory/worldtagteam/304454132142|title=Batista and Ric Flairs 2nd World Tag Team title reign|accessdate=2007-09-19|publisher=[[World Wrestling Entertainment]]}}</ref><ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2004/03/23/392732.html | title = Raw: Draft day an unpredictable night | date = 2004-03-23 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Nick | last = Tylwalk}}</ref>\n\nAt [[Survivor Series (2004)|Survivor Series]], Triple H, Batista, [[Gene Snitsky]], and [[Adam Copeland|Edge]] were defeated by [[Maven Huffman|Maven]], [[Chris Jericho]], Chris Benoit, and Randy Orton in an eight-man elimination tag team match for control of Raw over the following month;<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2004/11/15/715092.html | title = Orton survives at Series | date = 2004-11-15 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Chris | last = Sokol}}</ref> the members of the winning team would each be the Raw [[Professional wrestling authority figures#Temporary General Managers|general manager]] for a week. Throughout the next two months, the relationship between Batista and Triple H began to deteriorate. After a loss to Chris Jericho, Triple H verbally insulted Batista. Batista teased leaving Evolution that night, but declared that he was still part of Evolution and that they tricked everyone.<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 156}}</ref> Despite this ploy, Batista began behaving more like a [[Face (professional wrestling)|fan favorite]] over the next few weeks in comparison to Evolutions villainous tactics. One particular moment saw Batista express disgust as Triple H and Ric Flair boasted about how they had intimidated and/or beat up [[Jim Ross]], [[Danny Hodge]], and [[Stacy Keibler]]. Regardless, he continued to show his loyalty to Triple H and Evolution by running down to the ring and assisting them in matches.\n\nAs 2005 began, Triple H realized the possibility of Batista becoming a threat to his World Heavyweight Championship. Triple H suggested that he not enter the [[Royal Rumble (2005)|Royal Rumble]], claiming that it would be selfish of him to do so, and to simply focus on Triple H retaining the title. Batista entered anyway and went on to win the Rumble earning the right to participate in the main event of [[WrestleMania 21]] against the World Champion of his choice.<ref>{{cite web|url= http://www.wwe.com/shows/royalrumble/history/198811/mainevent/|title=Royal Rumble 2005 Main Event|publisher=[[World Wrestling Entertainment]] |accessdate=2008-08-05}}</ref> In an attempt to persuade Batista to challenge [[WWE Championship|WWE Champion]] [[John Layfield|John Bradshaw Layfield]] rather than him, Triple H concocted a scheme to have Batista [[Hit and run (vehicular)|run over]] in a [[limousine]] resembling the one used by Layfield. Initially, Dave did not want help from Evolution and wanted to confront JBL by himself. Triple H insisted that Evolution stick together and accompanied Dave anyway, saving him from the oncoming vehicle.<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2005/02/15/931709.html | title = Raw: Love is in the air | date = 2005-02-15 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Nick | last = Tylwalk}}</ref> Batista became aware of the plot while sneakily eavesdropping on fellow Evolution members and signed a contract guaranteeing him a match with the World Heavyweight Champion Triple H at WrestleMania 21, thus leaving Evolution and officially turning into a fan favorite. Batista initially pretended that he would sign with SmackDown!, giving Triple H and Flair the thumbs up, but turned it into a thumbs down before attacking the pair. He emphasized his departure by [[powerbomb]]ing Triple H through the table used for the contract signing.<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2005/02/22/938787.html | title = Raw: Batista makes his choice | date = 2005-02-22 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Nick | last = Tylwalk}}</ref>\n\n====Move to SmackDown! (20052008)====\n[[Image:DBatista.jpg|left|thumb|150px|Batista in September 2005 as the [[World Heavyweight Championship (WWE)|World Heavyweight Champion]].]]\nBatista won the World Heavyweight Championship on April 3 at WrestleMania 21.<ref name=wwebio/><ref>{{cite web|url= http://www.wwe.com/shows/wrestlemania/history/wm21/mainevent/|title=Batista vs. Triple H - World Heavyweight Championship|publisher=[[World Wrestling Entertainment]] |accessdate=2008-08-05}}</ref> Batista won a rematch with Triple H for the World Heavyweight Championship at [[Backlash (2005)|Backlash]].<ref>{{cite web|url= http://www.wwe.com/shows/backlash/history/backlash2005/mainevent/|title=World Heavyweight Champion Batista def. Triple H to retain|publisher=[[World Wrestling Entertainment]]|accessdate=2008-08-05}}</ref> After Batista retained his title against Edge, he was betrayed by Ric Flair, who helped Triple H viciously attack the champion as Triple H challenged Batista to a [[Hell in a Cell]] match at [[Vengeance (2005)|Vengeance]].<ref>{{cite web | url = http://www.wwe.com/shows/raw/archive/3442301/ | title = Tainted victory | date = 2005-05-23 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref> Batista won the match at Vengeance, retaining his title yet again. With this win, Batista became the first wrestler to pin Triple H in a Hell in a Cell match.<ref>{{cite web|url= http://www.wwe.com/shows/vengeance/history/vengeance2005/mainevent/|title=World Heavyweight Champion Batista def. Triple H in a Hell in a Cell Match to retain|publisher=[[World Wrestling Entertainment]] |accessdate=2007-11-13}}</ref>\n\n[[Image:Batistalive.jpg|right|thumb|175px|Batista at a SmackDown! live event in [[Cincinnati]], [[Ohio]].]]\nOn June 30, Batista was revealed as the last pick in the [[2005 WWE Draft Lottery]]; he made a surprise appearance while JBL was celebrating his victory in a six-man elimination match to win the new SmackDown! Championship.<ref>{{cite web | url = http://www.wwe.com/shows/smackdown/archive/06302005/ | title = Jackpot! | date = 2005-06-30 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref> JBL defeated Batista  at [[The Great American Bash (2005)|The Great American Bash]] by disqualification after the referee saw Batista use a steel chair.<ref>{{cite web|url=http://www.wwe.com/shows/thegreatamericanbash/history/2005/mainevent/|title=Batista vs. JBL for the World Heavyweight Championship|publisher=[[World Wrestling Entertainment]] |accessdate=2007-11-13}}</ref> They had a rematch at [[SummerSlam (2005)|SummerSlam]] in a [[Professional wrestling match types#No Disqualification Match|No Holds Barred match]] in which Batista pinned JBL.<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2005/08/22/1183436.html | title = Hogan-HBK steal SummerSlam | date = 2005-08-22 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Nick | last = Tylwalk | coauthors = Plummer, Dale}}</ref> The feud culminated in a [[Professional wrestling match types#Strap match|Bull Rope match]] with Batista retaining his championshp.<ref>{{cite web | url = http://www.wwe.com/shows/smackdown/archive/08042006/articles/returnofnti | title = Changing Friday nights | date = 2005-09-09 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref> Soon after retaining the title in a feud with [[Eddie Guerrero]],<ref name=NoMercy>{{cite web|url=http://www.wwe.com/shows/nomercy/history/2005/mainevent/|title=Batista vs. Eddie Guerrero for the World Heavyweight Championship|publisher=[[World Wrestling Entertainment]]|accessdate=2007-11-13}}</ref> WWE.com reported that Batista suffered a muscle tear in his back at the taping for the November 11 edition of SmackDown! due to a double chokeslam from [[Paul Wight|Big Show]] and [[Glenn Jacobs|Kane]].<ref>{{cite web | url = http://web.archive.org/web/20051124160846/www.wwe.com/inside/news/batistainjury | title = Batista injury update | date = 2005-11-09 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]] (via Web Archive)}}</ref> Plans had been made for Batista to defend the title in a Triple Threat match with Eddie Guerrero and Randy Orton on the November 18 episode, but the match did not take place due to the unexpected death of Guerrero on November 13, the date of the taping. Batista paid homage to Guerrero during the SmackDown! and Raw tribute shows dedicated to Guerreros memory.<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 215219}}</ref>\n\nBatista led Team SmackDown! against Team Raw in an inter-brand feud before [[Survivor Series (2005)|Survivor Series]]. The feud saw Big Show and Kane chokeslamming Batista several more times in the weeks leading up to Survivor Series in an on-camera explanation for Batistas injury.<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2005/11/24/1321807.html | title = Smackdown: Fighting back the Raw invasion | date = 2005-11-24 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Greg | last = Oliver}}</ref> Batista ultimately helped his team win the match.<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2005/11/28/1327500.html | title = Smackdown wins, but Undertaker the real survivor | date = 2005-11-28 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Dale | last = Plummer | coauthors = Tylwalk, Nick}}</ref> After Batista saved [[Rey Mysterio, Jr.|Rey Mysterio]] from Big Show and Kane,<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2005/12/03/1335038.html | title = Smackdown: Hey babe, you wanna boogey? | date = 2005-12-03 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Jon | last = Waldman}}</ref> it was announced that Mysterio would team with Batista to face the Big Show and Kane at [[Armageddon (2005)|Armageddon]].\n\nOn the December 16 edition of SmackDown!, Batista and Mysterio defeated [[WWE Tag Team Championship|WWE Tag Team Champions]]<ref name=WWEtag>{{cite web|url=http://www.wwe.com/inside/titlehistory/wwetag/1806054|title=Batista and Rey Mysterios WWE Tag Team Title reign|accessdate=2007-09-19|publisher=[[World Wrestling Entertainment]]}}</ref> [[MNM]] to become champions in a match they dedicated to Eddie Guerrero,<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2005/12/16/1356098.html | title = Smackdown: Can Batista capture double gold? | date = 2005-12-16 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Andy | last = McNamara}}</ref> and the clash with Big Show and Kane at Armageddon turned into a Champions vs. Champions encounter. Batista and Mysterio lost to Kane and Big Show at Armageddon.<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2005/12/19/1359743.html | title = Taker-Orton rises above Armageddon | date = 2005-12-19 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Chris| last = Sokol}}</ref> Two weeks later on SmackDown!, MNM defeated Batista and Mysterio after help from the returning [[Mark Henry]] to regain the WWE Tag Team Championships. During the interference, Henry attacked Batista, and performed his [[Powerslam#Falling slam|Worlds Strongest Slam]].<ref>{{cite web | url = http://www.wwe.com/shows/smackdown/archive/12302005/ | title = A shocking return leads to new Champs | date = 2005-12-30 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref> The teams met again in a steel cage match that Henry also became involved in, and Batista and Rey were defeated again.<ref>{{cite web | url = http://www.wwe.com/shows/smackdown/archive/01062006/ | title = Making statements | date = 2006-01-06 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref> On January 9, WWE.com announced that Batista tore his right triceps during a match with Mark Henry at a live event on January 6. Due to his injury, Batista was forced to vacate the World Heavyweight Championship at the SmackDown! tapings on January 13, two days after surpassing Triple Hs previous mark of 280 days for longest reigning champion. In his book, Batista Unleashed, Batista said that he believed that Henry was careless during their match as he never gave Batista any warning that the move was coming. Batista went on to have successful surgery on his arm on January 12.<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 224228}}</ref>\n\n====Return from injury (2006)====\n[[Image:Batista-SD-houseshow.jpg|thumb|left|Batista at a [[WWE Friday Night SmackDown|SmackDown!]] [[house show|live event]].]]\nBatista made an appearance at [[No Way Out (2006)|No Way Out]] and told the crowd that once his arm had healed he would return to regain the World Heavyweight Championship.<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2006/02/20/1452718.html | title = Main events salvage No Way Out | date = 2006-02-20 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Chris| last = Sokol}}</ref> At [[WrestleMania 22]], he interrupted a Randy Orton interview, putting SmackDown! on notice; the World Heavyweight Championship would return to him by [[WrestleMania 23]].<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2006/04/03/1517783.html | title = WrestleMania delivers big time on PPV | date = 2006-02-20 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Dale | last = Plummer | coauthors = Tylwalk, Nick}}</ref> Batista made his official return during the July 7 edition of SmackDown! immediately calling out and entering into a feud with Mark Henry.<ref name=henry-pg246>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 246248}}</ref> At [[Saturday Nights Main Event]], Batista won a six man tag match with Rey Mysterio and [[Bobby Lashley]] taking on [[Booker Huffman|King Booker]], [[Dave Finlay|Finlay]], and Mark Henry.<ref>{{cite web | first = Brett | last = Hoffman | url = http://www.wwe.com/shows/snme/history/july152006/matches/25815983/results/ | title = Animal unleashed on NBC | date = 2006-07-15 | accessdate = 2008-08-06 | publisher = [[World Wrestling Entertainment]]}}</ref> Henry was legitimately injured and was ruled out of the scheduled match between the two at [[The Great American Bash (2006)|The Great American Bash]], thus further delaying a potential feud between the two after being delayed by Batistas initial injury.<ref name=henry-pg246/>\n\nBatista put out an open challenge to replace the injured Henry, which was answered by [[Mr. Kennedy]].<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2006/07/20/1694912.html | title = Smackdown: Rey drops the dime on the King | date = 2006-07-20 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Andy | last = McNamara}}</ref> Batista lost this match via disqualification for failing to stop choking Mr. Kennedy into the turnbuckle with his boot, but continued to attack Kennedy resulting in a laceration on his forehead so severe that it exposed his cranium and required more than 20 stitches to close.<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2006/07/23/1758530.html | title = Booker reigns after the Bash | date = 2006-07-23 | accessdate = 2008-08-06 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Brian | last = Elliot}}</ref><ref>{{cite web | url = http://www.wrestleview.com/news2006/1153769870.shtml | title =  \nMr. Kennedy gets stitches, Chavo turns on Mysterio, King Booker video | date = 2006-07-24 | accessdate = 2008-08-06 | publisher = WrestleView.com | first = Adam | last = Martin}}</ref> Batista lost another match with Kennedy via count out in a rematch on SmackDown! before finally defeating Kennedy by pinfall on the August 4 edition of SmackDown!.<ref>{{cite web | first = Craig | last = Tello | url = http://www.wwe.com/shows/smackdown/archive/07282006/ | title = Coronations and carnage | date = 2006-07-28 | accessdate = 2008-08-06 | publisher = [[World Wrestling Entertainment]]}}</ref><ref>{{cite web | first = Brett | last = Hoffman | url = http://www.wwe.com/shows/smackdown/archive/08042006/ | title = Challenge from the grave | date = 2006-08-04 | accessdate = 2008-08-06 | publisher = [[World Wrestling Entertainment]]}}</ref>\n\nDuring this time, Batista tried to regain a world title, facing both Big Show for his [[ECW Championship|ECW World Championship]] on [[ECW on Syfy|ECW]],<ref>{{cite web | url = http://www.wrestleview.com/news2006/1154488172.shtml | title = ECW on Sci Fi Results - 8/1/06 - New York City, NY (Big Show/Batista) | date = 2006-08-01 | accessdate = 2008-08-06 | publisher = WrestleView.com | first = Adam | last = Martin}}</ref> and [[Booker Huffman|King Booker]] for his World Heavyweight Championship at [[SummerSlam (2006)|SummerSlam]] and on SmackDown!. Batista won the SummerSlam match, but not the title as the contests ended via disqualification meaning Booker retained the title.<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2006/08/21/1768011.html | title = Boston crowd basks in SummerSlam | date = 2006-08-21 | accessdate = 2008-08-06 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Amy | last = Lawson}}</ref> In the SmackDown! bout a few weeks later, Booker retained with help from his [[King Bookers Court|Court]].<ref>{{cite web | first = Brett | last = Hoffman | url = http://www.wwe.com/shows/smackdown/archive/09082006/ | title = All the Kings men | date = 2006-09-08 | accessdate = 2008-08-06 | publisher = [[World Wrestling Entertainment]]}}</ref> Batista remained a top contender to the World Championship, competing against King Booker on several occasions while feuding with Finlay,<ref>{{cite web | url = http://www.wwe.com/shows/smackdown/archive/11102006/ | title = Batista bites back | first = Noah | last = Starr | date = 2006-11-10 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref> before finally defeating Booker to regain the World Heavyweight Championship at [[Survivor Series (2006)|Survivor Series]].<ref name=wwebio/> Ironically, the win occurred at the same arena where he surrendered the title in January.<ref>{{cite web | url = http://www.wwe.com/shows/survivorseries/history/2006/matches/3332480111/results/ | title = Kingdom conquered | first = Louie | last = Dee | date = 2006-11-26 | accessdate = 2008-08-06 | publisher = [[World Wrestling Entertainment]]}}</ref>\n\n====World Heavyweight Championship feuds (2007)====\n[[Image:Batista PR.jpeg|right|thumb|230px|Batista in a [[Puerto Rico|Puerto Rican]] house show as the [[World Heavyweight Championship (WWE)|World Heavyweight Champion]].]]\nAt [[WrestleMania 23]], Batista lost the championship to the winner of the Royal Rumble match, [[The Undertaker]].<ref>{{cite web |url=http://slam.canoe.ca/Slam/Wrestling/2007/04/01/3895847.html |title=Undertaker the champ, McMahon bald |date=2007-04-01 |accessdate = 2008-08-06 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Dale | last = Plummer | coauthors = Tylwalk, Nick}}</ref> They continued to battle over the title to a stalemate in a [[professional wrestling match types#Last Man Standing match|Last Man Standing match]] at [[Backlash (2007)|Backlash]]<ref>{{cite web |url=http://www.wwe.com/shows/backlash/history/2007/matches/396065217/results/ | title = Stalemate | first = Lennie | last = DiFino | date = 2007-04-29 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref> and a [[Professional wrestling match types#Cages|Steel Cage Match]] on the May 11 episode of SmackDown!. Following the latter, [[Adam Copeland|Edge]] took advantage and won the title from The Undertaker by cashing in his [[Money in the Bank ladder match|Money in the Bank]] contract.<ref>{{cite web | url = http://www.wwe.com/shows/smackdown/archive/05112007/ | title = In with the new | first = Noah | last = Starr | date = 2007-05-11 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref> Afterward, Batista challenged Edge unsuccessfully for the World Heavyweight Championship at [[Judgment Day (2007)|Judgment Day]], [[One Night Stand (2007)|One Night Stand]] (in a Steel Cage Match), and [[Vengeance: Night of Champions]] (in a [[Professional wrestling match types#Last Chance match|Last Chance match]]).<ref>{{cite web | url = http://www.wwe.com/shows/judgmentday/history/2007/matches/41244024/results/ | title = The gold standard | first = Lennie | last = DiFino | date = 2007-05-20 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref><ref>{{cite web | url = http://www.wwe.com/shows/onenightstand/history/2007/matches/4362508111/results/ | title = Edge wins by two feet | first = Mike | last = McAvennie | date = 2007-06-03 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref> The loss at Vengeance stipulated that Batista could no longer get another chance at the World Heavyweight Championship while Edge remained champion.<ref>{{cite web | url = http://www.wwe.com/shows/vengeance/matches/40811641/results/ | title = Batistas last stand falls | first = Mike | last = McAvennie | date = 2007-06-24 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref>\n\nBatista accepted an open challenge from [[The Great Khali]] at [[The Great American Bash (2007)|The Great American Bash]]. Edge relinquished the title due to an injury the week before the pay-per-view, and Khali became the new World Heavyweight Champion, winning a [[Battle royal (professional wrestling)|Battle Royal]] and eliminating Batista. Batista and [[Glenn Jacobs|Kane]], Edges title opponent, faced Khali at The Great American Bash in a [[Professional wrestling match types#Basic non-elimination matches|Triple Threat match]] where Khali retained the title.<ref>{{cite web |url=http://www.wwe.com/shows/thegreatamericanbash/history/2007/matches/408116411/results/ | title = The Great Khali wins the big one | first = Mike | last = McAvennie | date = 2007-07-22 | accessdate = 2008-08-05 | publisher = [[World Wrestling Entertainment]]}}</ref> Batista received a disqualification victory against Khali at [[SummerSlam (2007)|SummerSlam]] after Khali used a steel chair, thus retaining the title again.<ref>{{cite web|url=http://www.wwe.com/shows/summerslam/history/2007/matches/39000883/results/|title=Punjabi robbery|first=Louie |last=Dee|accessdate=2007-09-19|date=2007-08-26|publisher=[[World Wrestling Entertainment]]}}</ref> Batista finally claimed his third World Heavyweight Championship after eight consecutive attempts, by defeating Khali in a match that included Rey Mysterio at [[Unforgiven (2007)|Unforgiven]].<ref name=wwebio/><ref name=Un07>{{cite web|url=http://www.wwe.com/shows/unforgiven/matches/48366501/results1/|last=DeFino|first=Lennie|title=Destined for gold|publisher=[[World Wrestling Entertainment]]|accessdate=2008-07-15|date=2007-09-16}}{{Dead link|date=October 2008}}</ref> His first challenge was from The Great Khali in a [[Professional wrestling match types#Punjabi Prison match|Punjabi Prison Match]] at [[No Mercy (2007)|No Mercy]] where Batista retained his title. He won the match by leaping from the inner bamboo structure to the outer one, shortening his escape route and beating Khali to the floor.<ref>{{cite web | url = http://www.wwe.com/shows/nomercy/history/2007/matches/52672881/results/ | title = Batistas Punjabi Prison break | first = Mike | last = McAvennie | date = 2007-10-07 | accessdate = 2008-08-04 | publisher = [[World Wrestling Entertainment]]}}</ref> \n\nAfter the return of the The Undertaker at [[Unforgiven (2007)|Unforgiven]], the duo reignited their feud at [[Cyber Sunday (2007)|Cyber Sunday]] where the fans chose [[Stone Cold Steve Austin]] as the [[Professional wrestling match types#Special referee|Special Guest Referee]]. Batista pinned The Undertaker after two Batista Bombs.<ref>{{cite web | url = http://www.wwe.com/shows/cybersunday/history/2007/matches/5267610/results/ | title = Batista conquers his Phenom-enal demons | first = Mike | last = McAvennie | date = 2007-10-28 | accessdate = 2008-08-04 | publisher = [[World Wrestling Entertainment]]}}</ref> The feud continued with a Hell in a Cell match at [[Survivor Series (2007)|Survivor Series]]. During the match, Edge returned and interfered by giving The Undertaker a [[Professional wrestling attacks#one man con-chair-to|con-chair-to]]. He then pulled an unconscious Batista on top of The Undertaker for the pinfall to retain the World Heavyweight Championship.<ref>{{cite web|first=Louie|last=Dee|url=http://www.wwe.com/shows/survivorseries/matches/4334964/results/|title=On the Edge of Hell|accessdate=2007-11-19|date=2007-11-18|publisher=[[World Wrestling Entertainment]]}}</ref> At [[Armageddon (2007)|Armageddon]], Edge won a Triple Threat Match, alongside The Undertaker for Batistas World Heavyweight Championship.<ref>{{cite web | first = Mike | last = McAvennie|url=http://www.wwe.com/shows/armageddon/matches/554660422/results/|title=Edges three-meditated attack to perfection|date=2007-12-17|accessdate=2008-08-04|publisher=[[World Wrestling Entertainment]]}}</ref>\n\n====Return to Raw (2008-2009)====\nBatista appeared in the [[Royal Rumble (2008)|Royal Rumble]] and was eliminated by Triple H. At [[No Way Out (2008)|No Way Out]], he was part of the SmackDown [[Elimination Chamber]] Match and eliminated [[Nelson Frazier, Jr.|Big Daddy V]], but was last eliminated by The Undertaker. At [[WrestleMania XXIV]], he defeated [[Eddie Fatu|Umaga]] in an interpromotional match. After [[Shawn Michaels]] defeated Ric Flair at the same event,<ref>{{cite web|first=Bryan|last=Robinson|url=http://www.wwe.com/shows/wrestlemania/matches/6464438/results/|title=The End|accessdate=2008-06-25|date=2008-03-30|publisher=[[World Wrestling Entertainment]]}}</ref> Batista began a feud with Michaels, calling him selfish and egotistical. The two faced off at [[Backlash (2008)|Backlash]] with [[Chris Jericho]] as the Special Guest referee. Michaels won after faking a knee injury and performing [[Superkick|Sweet Chin Music]].<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/PPVReports/2008/04/28/5407546.html | title = HHH reigns again after Backlash | date = 2008-04-28 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Dave | last = Hillhouse}}</ref> Batista then defeated Michaels at [[One Night Stand (2008)|One Night Stand]] in a [[Professional wrestling match types#Container-based variations|stretcher match]], thus ending their feud.<ref>{{cite web | url = http://slam.canoe.ca/Slam/Wrestling/2008/05/30/5744466.html | title = One Night Stand WWEs best this year | date = 2008-06-01 | accessdate = 2008-08-05 | publisher = [[Canadian Online Explorer]] | work = Slam! Sports | first = Matt | last = MacKinder}}</ref> \n\nOn June 23, Batista was drafted from [[WWE SmackDown|SmackDown]] to the [[WWE Raw|Raw]] [[WWE Brand Extension|brand]] during the [[2008 WWE Draft]].<ref>{{cite web|url=http://www.wwe.com/shows/raw/archive/06232008/|title=A Draft Disaster|last=Sitterson|first=Aubrey|date=2008-06-23|publisher=[[World Wrestling Entertainment]]|accessdate=2008-06-25}}</ref> Batista became a [[World Tag Team Championship (WWE)|World Tag Team Champion]] for a third time on the August 4 edition of Raw when he teamed up with [[John Cena]] to defeat [[Cody Rhodes]] and [[Ted DiBiase, Jr.|Ted DiBiase]] for the title,<ref>{{cite web|url=http://slam.canoe.ca/Slam/Wrestling/2008/08/05/6353831.html|title=Raw: Rivalry grows between new tag champs|date=2008-08-05|accessdate=2008-08-06|publisher=[[Canadian Online Explorer]]|work=Slam! Sports|first=Dale|last=Plummer}}</ref><ref>{{citeweb|url=http://www.wwe.com/shows/raw/archive/08042008/|accessdate=2008-08-05|date=2008-08-05|last=Sitterson|first=Aubrey|title=Championship scramble|publisher=[[World Wrestling Entertainment]]}}</ref> but they failed to retain the titles against the former champions on the next episode of Raw.<ref>{{cite web|url=http://www.wwe.com/shows/raw/results/|accessdate=2008-08-12|date=2008-08-11|last=Sitterson|first=Aubrey|title=Bracing for a SummerSlam|publisher=[[World Wrestling Entertainment]]}}</ref> Batista narrowly defeated Cena at [[SummerSlam (2008)|SummerSlam]].<ref>{{cite web|url=http://www.wwe.com/shows/summerslam/matches/7719954/results/|accessdate=2008-08-25|date=2008-08-17|last=Tello|first=Craig|title=Batistas blockbuster triumph|publisher=[[World Wrestling Entertainment]]}}</ref> \n\nOn October 26 at [[Cyber Sunday (2008)|Cyber Sunday]], Batista defeated Chris Jericho for his fourth World Heavyweight Championship in a match in which Stone Cold Steve Austin was voted in as the special guest referee.<ref name=WHCTitleMatch>{{cite web|url=http://www.wwe.com/shows/cybersunday/matches/7880726/results/|title=Stunning new champion|last=Tello|first=Craig|date=2008-10-26|publisher=[[World Wrestling Entertainment]]|accessdate=2008-10-27}}</ref> Batistas reign, however, only lasted eight days when Jericho won back the title in a Steel Cage match on a [[WWE Raw#Special episodes|three-hour special episode]] of Raw.<ref name=Y2JBatistaCage>{{cite web|url=http://www.wwe.com/shows/raw/results/7823610/|title=Ch-ch-ch-ch-changes|date=2008-11-04|publisher=[[World Wrestling Entertainment]]|accessdate=2008-11-04}}</ref> \n\nBatista then entered a feud with former Evolution partner, Randy Orton; at [[Survivor Series (2008)|Survivor Series]], Batista led a team of himself, [[CM Punk]], [[Kofi Kingston]], [[Matt Hardy]], and [[Ron Killings|R-Truth]] to face the team of Randy Orton, [[Shelton Benjamin]], [[Darren Matthews|William Regal]], Cody Rhodes, and Mark Henry. Batista was pinned by Orton, winning the match for his team. His feud with Orton continued up to [[Armageddon (2008)|Armageddon]] where Batista defeated Orton. On the December 15 edition of Raw, Batista was put into a handicap match against [[The Legacy (professional wrestling)|The Legacy]] with John Cena as his partner. During the match, Orton struck Batista with a punt to the head. Batista was knocked out and put out of action indefinitely due to a (kayfabe) head injury. WWE.com later reported that Batista elected to undergo surgery to repair a [[hamstring]] tear.<ref name=BatistaHamstring>{{cite web|url=http://www.wwe.com/shows/raw/archive/12222008/articles/batistahamsurgery|title=Batista undergoes hamstring surgery|date=2008-12-27|publisher=[[World Wrestling Entertainment]]|accessdate=2008-12-27}}</ref> The hamstring was injured at SummerSlam, in the same match that former World Heavyweight Champion John Cena was forced out of action with a neck injury. He was expected to be out of action for six to eight months.\n\nBatista returned on the April 6 episode of Raw, to save Triple H, [[Shane McMahon]], and [[Vince McMahon]] from The Legacy. Vince McMahon, then announced that Batista would take his place at Backlash, where he would team up with WWE Champion Triple H, and Shane McMahon, to face The Legacy. During the match, Batista had brought out a chair, but Triple H tried to stop him, so they would not get disqualified. This distraction however, cost Triple H his championship, after he lost it to Orton. The following night on Raw, Batista won a singles match against Big Show due to a distraction by John Cena, to become the number one contender for the WWE Championship at Judgment Day.<ref>{{cite web|url=http://www.wwe.com/shows/raw/results/8909094/ | title = Raw Results, Bringing in the Big Guns | first = Aubrey | last = Sitterson|date = 2009-04-06 | accessdate = 2009-04-07 | publisher = [[World Wrestling Entertainment]]}}</ref> Batista went on to defeat Orton in a rematch at [[WWE Extreme Rules|Extreme Rules]] in a Steel Cage match to capture the [[WWE Championship]].<ref>{{cite web|url=http://www.wwe.com/shows/extremerules/matches/10253106/results/?cid=2009EP-00|accessdate=2009-06-07|date=2009-06-07|last=Tello|first=Craig|title=Steel of fortune|publisher=[[World Wrestling Entertainment]]}}</ref> However, on the June 8th edition of Raw, Batista was to vacate the title due to a staged brutal attack by Orton and the Legacy. It was later revealed that Batista had suffered a legitimate torn left biceps. Legacy was given on-screen credit for his injury<ref>{{cite web|url=http://www.wwe.com/shows/raw/archive/06082009/articles/woundedanimal | title = Raw Results, Wounded Animal | first = | last = |date = 2009-10-06 | accessdate = 2009-10-07 | publisher = [[World Wrestling Entertainment]]}}</ref>.\n\n====Return to SmackDown (2009-present)====\nIt was announced a few weeks before the [[Trish Stratus]]-hosted Raw week that Batista would be making a career-altering announcement come that show. Batista returned on the Sept 14 episode with his arm still in a vice and began his announcement. [[Randy Orton]], assuming Batista was announcing his retirement, then came out and stated that it was he who ended the career of Batista. Batista then went on to remove his arm vice, as it was a fake just to leer out Orton, and proceeded to attack Orton. He then announced that he will not be retiring, but moving to [[SmackDown]] instead. Later that night, he defeated Orton in a no-holds barred match 4 months in the making which was to be his last match on the Raw brand.<ref>{{cite web|url=http://www.wwe.com/shows/raw/results/10533560/|title=Results: Live Raw Results|last=Adkins|first=Greg|date=2009-09-14|accessdate=2009-09-14|publisher=[[World Wrestling Entertainment]]}}</ref> On the September 18 edition of SmackDown, Batista made his return by winning a match against Chris Jericho. Jerichos tag team partner, The Big Show would then challenge Batista to a match the following week in which Batista put in a new move when he used the Ankle Lock on both Show & Jericho. Batista would then announce that he would challenge Jericho & Show for the tag titles at the Hell in the Cell Pay Per View with his tag team partner Rey Mysterio. Batista & Rey would be unsuccessful in their attempt to win the tag titles after Show pinned Rey after a knockout punch.\n\n==Media==\nIn addition to wrestling, Batista has been in several commercials and on several magazine covers. He was shown [[breakdance|breakdancing]] in a commercial promoting [[SummerSlam (2004)|WWE SummerSlam]] in 2004 where he did his take on a floor routine, a routine that arguably mocked the floor routines shown at the [[Olympic Games]].<ref>{{cite video |date2=2004-08-15 |title=[[SummerSlam (2004)|WWE SummerSlam 2004]] |medium=[[DVD]] |publisher=[[World Wrestling Entertainment]] |location=[[Stamford, Connecticut]] |time=Extras}}</ref> He was also on the cover of the April 2005 [[Flex (magazine)|Flex magazine]]<ref>{{cite web |url=http://www.getbig.com/magazine/flex/flex0504.htm |title=Flex Magazine - April 2005 |work=GetBig.com |publisher=[[Flex (magazine)|Flex magazine]] |accessdate= 2008-08-06}}</ref> and [[Muscle & Fitness]] for September 2008.<ref>[http://www.lordsofpain.net/news/2008/articles/1214323781.php WWE News: Batista on the Cover of Muscle & Fitness, WWE Launches New Clothing Line]</ref>\n\nMoreover, Bautista has acted and has guest starred in several television shows as both himself and in-character as Batista. He guest starred in the eighth episode of [[Smallville (season 6)|Season 6]] of the American [[drama]], [[action genre|action]]/[[adventure]] television series [[Smallville]]; he played an extraterrestrial alien named Aldar that escaped from the [[Phantom Zone]], who sucks the bones out of people for nourishment.<ref name=Smallville1>[http://www.wwe.com/inside/news/archive/batistasmallville2 The Animal tames Smallville]</ref> Along with [[John Cena]] and [[Ashley Massaro]], Bautista appeared representing WWE on an episode of [[Extreme Makeover: Home Edition]] in January 2007, giving the kids of the family whose house was renovated WWE merchandise and eight tickets to [[WrestleMania 23]].<ref>{{cite video |title= John Cena, Batista, and Ashley on Extreme Makeover: Home Edition |url=http://www.wwe.com/content/media/video/specialty_clips/wwehomemakeover |medium= WMV |publisher=[[World Wrestling Entertainment]] |accessdate= 2007-08-01}}</ref>\n\nDuring the week of November 5, 2007, he appeared on [[Family Feud]] with several other WWE superstars.<ref>{{cite web |url=http://www.wwe.com/inside/overtheropes/news/familyfeudpreview |first=Kara A. |last=Medalis |publisher=[[World Wrestling Entertainment]] |title=Tune in to WWE week on Family Feud |accessdate=2007-11-04 |date=October 30, 2007}}</ref> On September 7, 2008, he appeared on an episode of [[Iron Chef America]] as one of the judges, with snails as the theme ingredient<ref>{{cite web |url=http://www.wwe.com/superstars/raw/batista/photos01/ironchef/ |title=Batista on Food Networks Iron Chef America, September 2008 |publisher=[[World Wrestling Entertainment]]}}</ref> Batista, along with [[Candice Michelle]], [[Shelton Benjamin]], and [[Josh Mathews]], represented the WWE at the [[2008 Democratic National Convention]] in an effort to persuade fans to register to vote in the [[United States presidential election, 2008|2008 Presidential election]].<ref>{{cite web |url=http://www.wwe.com/inside/overtheropes/wweconventions08/conventionspreview |title=WWE at the Democratic and Republican National Conventions|date=2008-08-22|accessdate=2008-09-13|publisher=[[World Wrestling Entertainment]].com}}</ref> Bautista has also appeared on [[MTV Cribs]] showing his house and his cars.<ref>{{cite web |url=http://www.thesun.co.uk/sol/homepage/sport/wrestling/article1167975.ece |date=2008-05-15 |publisher=[[The Sun]] |title=Batista on Cribs}}</ref>\n\nIn May 2, 2009, he was shown on camera where he accompanied Philippine boxer [[Manny Pacquiao]] in his fight against British boxer [[Ricky Hatton]] in which Pacquiao won in the second round. He told the UK Sun that he loves Hatton, but Manny is in a league of his own, adding that he is thrilled to be there to support Manny before his bout.<ref>{{cite web |url=http://www.thesun.co.uk/sol/homepage/sport/boxing/article2407236.ece |date=2009-05-01 |publisher=[[The Sun]] |title=WWE star Batista will lead Manny Pacquiao to the ring on Saturday night}}</ref>\n\nIn June 2009, Bautista made a cameo appearance in an episode of the Australian [[soap opera]] [[Neighbours]].<ref>{{cite web |url=http://neighbours.com.au/Batista-Wrestles-With-Neighbours.htm |date=2009-03-11 |publisher=[[Neighbours]] |title=Batista Wrestles With Neighbours|accessdate=2009-06-28}}</ref> He has also made a cameo appearance in [[Relative Strangers]].<ref name=Manilla/>\n\nBautista is currently working alongside [[Rob Van Dam]] and [[Ja Rule]] in an upcoming movie titled [[Wrong Side of Town]].<ref>{{cite web |url=http://www.movieset.com/wrongsideoftown |publisher=MovieSet |title=Wrong Side of Town}}</ref> Bautista will also star in the movie Wapakman alongside [[Manny Pacquiao]] and [[Nicole Scherzinger]]. He is confirmed to be portraying the villain of the movie.<ref>{{cite web |url=http://www.gmanews.tv/video/43906/QTV-Pacquiao%27s-Wapakman-begins-shooting-in-July |date=2009-06-24 |publisher=[[GMA News and Public Affairs]] |title=QTV: Pacquiaos Wapakman begins shooting in July|accessdate=2009-06-28}}</ref><ref>{{Tl icon}} {{cite web |url=http://www.gmanews.tv/story/165760/Pacquiao-to-fight-Batista-%E2%80%93-but-only-in-a-movie |date=2009-06-24 |publisher=[[GMA News and Public Affairs]] |title=Pacquiao to fight Batista  but only in a movie|accessdate=2009-06-28}}</ref>\n\nDave Batista has his first biographical DVD being released through WWE productions entitled Batista: I Walk Alone it is currently set to be released October 20, 2009.<ref>http://www.wweshop.com/product_detail.asp?CAT=FEATURED6&productId=50-05523</ref>\n\n==Controversy==\n===Criticism of WWE and TNA===\nIn 2005, Bautista gave two controversial interviews to the [[United Kingdom|British]] [[tabloid]] [[newspaper]] [[The Sun]]. In the first interview, Bautista, then wrestling on the Raw brand of WWE, criticized SmackDown!, stating, Ive watched their tapings live and it seems like a lot of the guys couldnt care less. Theres a lack of passion and pride.<ref name=Sun1>{{cite web|author=The Lilsboys|url=http://www.thesun.co.uk/article/0,,2003560001-2005031802,00.html|title=Batistas bombshells|accessdate=2008-06-25|date=2005-01-21|publisher=[[The Sun]]}}</ref> In the second interview, Bautista acknowledged that his statements had attracted considerable backstage [[Heat (professional wrestling)|heat]] from members of the SmackDown! brand. He then went on to claim, there are guys on both shows who are lazy, couldnt care less and show no dedication. He then criticized rival wrestling promotion [[Total Nonstop Action Wrestling]], claiming, Ive also seen clips of their car wreck matches with [[A.J. Styles]] doing his stunts. Thats not wrestling. Wrestling is storytelling.<ref name=Sun2>{{cite web|author=The Lilsboys|url=http://www.thesun.co.uk/sol/homepage/sport/wrestling/article226357.ece|title=Audience with The Animal|accessdate=2008-06-25|publisher=The Sun|date=2005-10-14|publisher=[[The Sun]]}}</ref> In April 2006, Styles responded to Bautistas comments, stating, I think its funny that a guy who takes a [[Bump (professional wrestling)|bump]] and tears his back tells me that I dont know how to wrestle.<ref>{{cite web|author=Jerzy|url=http://prowrestlingdaily.com/modules.php?name=News&file=article&sid=3471|archiveurl=http://web.archive.org/web/20061119034145/http://prowrestlingdaily.com/modules.php?name=News&file=article&sid=3471|archivedate=2006-11-19|date=2006-04-17|title=A.J. Styles Speaks Out|accessdate=2008-08-05|publisher=Pro Wrestling Daily}}</ref>\n\n===Backstage problems===\nBautistas backstage problems continued at a [[SummerSlam (2006)|SummerSlam]] pay-per-view commercial shoot. It was reported that Bautista got into a real-life fistfight with [[Booker Huffman]] (better known as Booker T). The incident was reported on WWE.com, with both men telling their sides of the story. The fight was believed to stem from the idea that Buatista considered himself to be better than the rest of the roster due to his main event status and relatively quick climb to achieve it. It is believed that Bautista provoked the fight, though Huffman appeared to get the upper hand until they were pulled apart by various superstars. Huffman swore revenge, but the two seemingly put it behind them.<ref>{{cite web | url = http://www.wrestleview.com/news2006/1147287803.shtml | title = Huge correction on Booker T/Batista - WWE sources say fight was legit | date = 2006-05-10 | accessdate = 2008-08-06 | publisher = WrestleView.com | first = Adam | last = Martin}}</ref><ref>{{cite web | url = http://www.wrestleview.com/news2006/1147288158.shtml | title = Batista comments on Booker T: It had been brewing for a long time... | date = 2006-05-10 | accessdate = 2008-08-06 | publisher = WrestleView.com | first = Adam | last = Martin}}</ref><ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 249}}</ref>\n\n===Steroid allegations===\nIn August 2007, Bautista was accused of [[anabolic steroid]] use after an [[ESPN]] article released the names of wrestlers that were clients of Signature Pharmacy of [[Orlando, Florida]], one of many pharmacies under investigation for filling [[wiktionary:illegal#adjective|illegal]] [[prescription drug]]s.<ref name=espn1>{{cite news | url = http://sports.espn.go.com/espn/news/story?id=2998062 | title = WWE suspends 10 for violating policy that requires drug tests | first = Shaun | last = Assael | date = 2007-08-31 | accessdate = 2008-08-06 | work = [[ESPN.com]] | publisher = [[ESPN]]}}</ref> Bautista released a statement denying ESPNs allegations and was reportedly furious over the report. He denied ever being a customer of Signature and stated that he has been tested regularly by the WWE, and I am in full compliance with the [[World Wrestling Entertainment#Wellness Program|WWE Wellness Program]].<ref>{{cite web | url = http://www.wrestleview.com/news2006/1188864566.shtml | publisher = WrestleView.com | first = Adam | last = Martin | date = 2007-09-03 | accessdate = 2008-08-05 | title = Batista issues statement on official website denying ties to ESPN story}}</ref> WWE reportedly suspended ten wrestlers named in the controversy, though Bautista was not one of them.<ref name=espn1/>\n\n==Personal life==\nBautista was married to a woman named Glenda in the early 1990s and had two daughters with her, Keilani (born in 1990) and Athena (born in 1992) before divorcing.<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 4344}}</ref> Bautista married his second wife Angie on October 13, 1998, yet they divorced in 2006. Before the age of 40, Bautista had already become a grandfather of two grandsons: Jacob and Aiden by Keilani, his first daughter.<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 212}}</ref><ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 235&ndash;238}}</ref> During his marriage with Angie, Bautista became an avid collector of vintage metal [[lunch box|lunchbox]]es. He admits his favorite is the 1967 [[The Green Hornet|Green Hornet]] lunch box, as it has [[Bruce Lee]] on it. This collection started when he bought Angie an [[E.T. the Extra-Terrestrial|ET]] lunchbox and she did not want to break it, so he bought a second one.<ref name=lunchbox>{{cite web | first = Jon | last = Robinson | url = http://sports.ign.com/articles/635/635699p3.html | title = Batista: Animal Unleashed | work = [[IGN|IGN.com]] | publisher = [[IGN|IGN Entertainment]] | date = [[2005-07-21]] | accessdate = 2008-08-05}}</ref> Bautista revealed that he and Angie were separated in the August 2006 edition of [[WWE Magazine]].<ref>{{cite journal | journal = [[WWE Magazine]] | publisher = [[World Wrestling Entertainment]] | month = August | year = 2006 | title = Animals House | pages =  54&ndash;58}}</ref> He later revealed, in his autobiography, a relationship with WWE Diva [[Melina Perez]] after the divorce from his wife in 2006, which led to a brief [[List of professional wrestling terms#A|angle]] on SmackDown! during a feud with [[MNM]].<ref>{{cite book | title = Batista Unleashed | first = Dave | last = Batista | coauthors = Roberts, Jeremy | isbn = 1-4165-4410-4 | publisher = [[Simon & Schuster]] | origmonth = October | origyear = 2007 | pages = 263}}</ref>\n\nIn October 2007, his autobiography Batista Unleashed, was released.<ref name=SLAM! Profile/> In an interview about the book, Bautista claims I didnt want to tell my story unless it was honest, and that you have to go through three sets of lawyers: Simon & Schuster lawyers, WWE lawyers, my lawyers. Everything now being the way it is, you can be sued for the simplest thing.<ref name=Bookinterview>{{citeweb|url=http://www.miamiherald.com/675/v-print/story/290473.html|title=Batistas Book Speaks Volumes 10/31/2007|publisher=Miami Herald}}{{Dead link|date=October 2008}}</ref> One source of controversy was the mentioning of [[Chris Benoit]], who was almost completely removed due to the [[Chris Benoit double murder and suicide]]. Bautista responded saying I loved the guy. I despise what he did, but that doesnt erase him from my life. I fought to keep him in there and glad they did.<ref name=Bookinterview/> When asked about his ex-wife, Angie, he says [we] have really become close again, which we really havent been in years. I really learned a lot about her, and she learned a lot about me from reading the book. She actually saw things from a different perspective from reading the book. So that was definitely therapeutic.<ref name=Bookinterview/>\n\nHe has numerous [[tattoo]]s, including a large Chinese dragon on his back, red [[Kanji]] lettering on his upper left biceps which says Angel in tribute to his former wife Angie, a signature design on his upper right biceps, and a small Sun on his stomach which encircles his belly button.<ref>{{cite web|url=http://www.angelfire.com/me4/wrestlertattoos/wwf.html#DB Tattoos of Wrestlers (under Deacon Bautista)|title=Tattoos|publisher=angelfire.com}}</ref> He also has a tattoo on his arm of the flags of the Philippines and Greece merged into one.  While taking time off due to injury in 2009, Bautista had both upper arms covered in large, tribal style tattoos, including the word soldier on his right biceps.\n\n==In wrestling==\n{{Image stack\n|align=right\n|image_size=200\n|image1=BatistaBomb.jpg\n|image1_cap=Batista delivering his finishing move, the [[Powerbomb#Sitout powerbomb|Batista Bomb]], to [[Dave Finlay|Finlay]].\n|image2=Dave Batista - Spinebuster.jpg\n|image2_cap=Batista delivering a [[Professional wrestling throws#Spinebuster|Spinebuster]] to [[Adam Copeland|Edge]].\n}}\n*As Batista\n<!--Do NOT change the order of the moves, as they comply with Wikipedias Manual of Style-->\n**Finishing moves\n***[[Professional wrestling holds#Ankle lock|Ankle lock]] 2009 - present\n***Batista Bomb<ref name=wwebio/> ([[Powerbomb#Sitout powerbomb|Sitout powerbomb]])\n***[[Professional wrestling attacks#Spear|Spear]]<ref>{{cite web|url=http://www.wwe.com/shows/smackdown/archive/06132008/articles/survivalinstincts|accessdate=2008-08-05|date=2008-06-13|last=Passero|first=Mitch|title=Survival instincts|publisher=[[World Wrestling Entertainment]]}}</ref><ref>{{cite web|url=http://www.wwe.com/shows/raw/archive/07072008/articles/7600820|accessdate=2008-08-04|date=2008-07-04|last=Adkins|first=Greg|title=Four on the Floor|publisher=[[World Wrestling Entertainment]]}}</ref> \n***[[Professional wrestling throws#Spinebuster|Spinebuster]]<ref name=officialsite/><ref name=NoMercy/><ref name=Un07/>\n**Signature moves\n<!--Do NOT change the order of the moves, as they comply with Wikipedias Manual of Style-->\n***[[Professional wrestling attacks#Big boot|Big boot]], sometimes to a seated or kneeling opponent\n***[[Professional wrestling aerial techniques#Diving shoulder block|Diving shoulder block]]\n***Multiple [[powerslam]] variations\n****[[Powerslam#Front powerslam|Front]]<ref>{{cite web|first=Jen|last=Hunt|url=http://www.wwe.com/shows/wrestlemania/history/wrestlemania23/matches/3916184/results/|title=The streak lives on for The Deadman|publisher=[[World Wrestling Entertainment]]|accessdate=2008-07-15|date=2007-04-01}}</ref>\n****[[Powerslam#Spinning side slam|Spinning side]]\n****[[Powerslam#Suplex powerslam|Vertical suplex]]\n***[[Professional wrestling attacks#Turnbuckle thrust|Multiple turnbuckle thrusts]]\n***[[Professional wrestling attacks#Clothesline|Running clothesline]]<ref>{{cite web|url= http://www.wwe.com/shows/newyearsrevolution/history/2005/mainevent/|title=New Years Revoulution 2005 Main Event|publisher=[[World Wrestling Entertainment]]|accessdate=2008-07-15}}</ref>\n***[[Professional wrestling holds#Two-handed chokelift|Twohanded chokelift]]<ref name=OWOW/>\n\n*As Leviathan\n**Finishing moves\n***[[Suplex#Belly to back suplex|Belly to back suplex]] lifted and twisted into a [[Powerslam#Front powerslam|running powerslam]]\n***Demon Bomb<ref name=OWOW/> ([[Powerbomb#Sitout powerbomb|Sitout powerbomb]])\n**Signature moves\n***[[Professional wrestling attacks#Big boot|Big boot]], sometimes to a seated opponent\n***[[Boston crab#Elevated Boston crab|Elevated]] [[Boston crab#Single leg Boston crab|single leg Boston crab]]<ref name=OWOW/>\n***[[Professional wrestling holds#Hammerlock|Hammerlock]] / [[Professional wrestling holds#Armbar|Armbar]] combination<ref name=OWOW/>\n***[[Professional wrestling attacks#Spear|Spear]]<ref name=OWOW/>\n\n*[[Manager (professional wrestling)|Managers]]\n**Synn<ref name=OWOW/>\n**[[Devon Hughes|Reverend D-Von]]<ref name=OWOW/>\n**[[Ric Flair]]<ref name=OWOW/>\n**[[Triple H]]<ref name=OWOW/>\n\n*[[Music in professional wrestling|Entrance themes]]\n**[[Voodoo (song)|Voodoo]] by [[Godsmack]] ([[Ohio Valley Wrestling]]; Used while a part of The Disciples of Synn)<ref name=officialsite/>\n**[[WWE Anthology#Now!|Eyes of Righteousness]] by [[Jim Johnston (composer)|Jim Johnston]] (Used while teaming with [[Devon Hughes|Reverend D-Von]])\n**[[WWE ThemeAddict: The Music, Vol. 6#Track listing|Line in the Sand]] by [[Motrhead]] (Used while a part of [[Evolution (professional wrestling)|Evolution]])\n**[[WWE Wreckless Intent#Track listing|I Walk Alone]] by [[Saliva (band)|Saliva]]<ref name=officialsite/> (2005-present)\n\n==Championships and accomplishments==\n{{Image stack\n|align=right\n|image_size=150\n|image1=David-Michael-Bautista-denis-apel-edited.jpg\n|image1_cap=Batista as [[World Heavyweight Championship (WWE)|World Heavyweight Champion]] in 2005.\n|image2=Batista with World Heavyweight Championship.jpg\n|image2_cap=Batista during his second World Heavyweight Championship reign.\n}}\n*[[Ohio Valley Wrestling]]\n**[[OVW Heavyweight Championship]] ([[OVW Heavyweight Championship#Title history|1 time]])<ref name=OVWchamp>{{cite web|url=http://www.wrestling-titles.com/us/ky/ovw/ovw-h.html#last|title=O.V.W. Heavyweight Title|accessdate=2007-07-19|publisher=Wrestling-Titles.com}}</ref>\n\n*[[Pro Wrestling Illustrated]]\n**[[PWI Most Improved Wrestler of the Year]] (2005)<ref>{{cite web|url=http://www.100megsfree4.com/wiawrestling/pages/pwi/pwiimp.htm|title=Wrestling Information Archive - Pro Wrestling Illustrated Award Winners - Most Improved Wrestler of the Year|accessdate=2007-07-19|publisher=Pro Wrestling Illustrated}}</ref>\n**[[PWI Wrestler of the Year]] (2005)<ref>{{cite web|url=http://www.100megsfree4.com/wiawrestling/pages/pwi/pwiwoty.htm|title=Wrestling Information Archive - Pro Wrestling Illustrated Award Winners - Wrestler of the Year|accessdate=2007-07-19|publisher=Pro Wrestling Illustrated}}</ref>\n**PWI ranked him #1 of the 500 best singles wrestlers in the [[Pro Wrestling Illustrated#PWI 500|PWI 500]] in 2005<ref>{{cite web|url=http://www.100megsfree4.com/wiawrestling/pages/pwi/pwi50005.htm|title=Wrestling Information Archive - Pro Wrestling Illustrated Top 500 - 2005|accessdate=2007-09-19|publisher=Pro Wrestling Illustrated}}</ref>\n\n*[[World Wrestling Entertainment]]\n**[[World Heavyweight Championship (WWE)|World Heavyweight Championship]] ([[List of World Heavyweight Champions (WWE)|4 times]])<ref>{{cite web|url=http://www.wwe.com/inside/titlehistory/worldheavyweight/304454142|title=Batistas first World Heavyweight title reign|accessdate=2007-09-19|publisher=[[World Wrestling Entertainment]]}}</ref><ref>{{cite web|url=http://www.wwe.com/inside/titlehistory/worldheavyweight/243931811|title=Batistas second World Heavyweight Title reign|accessdate=2007-09-19|publisher=[[World Wrestling Entertainment]]}}</ref><ref>{{cite web|url=http://www.wwe.com/inside/titlehistory/worldheavyweight/50797501|title=Batistas third World Heavyweight title reign|accessdate=2007-09-19|publisher=[[World Wrestling Entertainment]]}}</ref><ref>{{cite web|url=http://www.wwe.com/inside/titlehistory/worldheavyweight/20081026Batista|accessdate=2008-10-28|title=Batistas    fourth reign|publisher=[[World Wrestling Entertainment]]}}</ref>\n**[[World Tag Team Championship (WWE)|World Tag Team Championship]] ([[List of World Tag Team Champions (WWE)|3 times]])<ref name=WT1/><ref name=WT2 /><ref name=WT3>{{cite web|url=http://www.wwe.com/inside/titlehistory/worldtagteam/09082007111|accessdate=2008-08-05|title=Batista and John Cenas first reign|publisher=[[World Wrestling Entertainment]]}}</ref>  with [[Ric Flair]] (2) and [[John Cena]] (1)\n**[[WWE Championship]] ([[List of WWE Champions|1 time]])<ref>{{cite web|url=http://www.wwe.com/inside/titlehistory/wwechampionship/10437632|accessdate=2009-01-26|title=Batistas first reign|publisher=World Wrestling Entertainment}}</ref>\n**[[WWE Tag Team Championship]] ([[List of WWE Tag Team Champions|1 time]])<ref name=WWEtag/>  with [[Rey Mysterio, Jr.|Rey Mysterio]]\n**[[Royal Rumble]] ([[Royal Rumble (2005)|2005]])<ref name=wwebio/>\n\n*[[Wrestling Observer Newsletter awards]]\n**[[Wrestling Observer Newsletter awards#Feud of the Year|Feud of the Year]] (2005) <small>vs. [[Triple H]]</small>\n**Feud of the Year (2007) <small>vs. [[The Undertaker]]</small>\n**[[Wrestling Observer Newsletter awards#Most Overrated|Most Overrated]] (2006)\n\n'
p166
tp167
a(I1
S'{{Infobox Magazine\n| title           = Fly RC\n| image_file      = \n| image_size      = \n| image_caption   = \n| editor          = \n| editor_title    = \n| previous_editor = \n| staff_writer    = \n| frequency       = Monthly\n| circulation     = \n| category        = \n| company         = \n| publisher       = Maplegate Media Group\n| firstdate       = \n| country         = {{USA}}\n| based           = [[Connecticut]]\n| language        = [[English language|English]]\n| website         = http://www.flyrc.com/\n| issn            = \n}}\nFly RC is a [[magazine]] promoting the hobby of [[Radio-controlled aircraft|remote control planes]]. \n\nFly RC reviews the latest RC aircraft in all sizes, from indoor and park flyers to giant scale, and features product guides, instructional how-tos and educational airplane projects. Flying tips are presented for beginners to expert pilots. Building tips, assembly techniques, radio and power systems are covered in a colorful, family friendly package.\n\n'
p168
tp169
a(I-1
S'{{cleanup|date=February 2008}}\nThe goal of most research on group development is to learn why and how small groups change over time. To do this, researchers examine patterns of change and continuity in groups over time. Aspects of a group that might be studied include the quality of the [[output]] produced by a group, the type and frequency of its activities, its [[cohesiveness]], the existence of [[conflict]], etc. \n\nA number of [[theoretical]] [[Scientific modelling|models]] have been developed to explain how certain groups change over time. Listed below are some of the most common models. In some cases, the type of group being considered influenced the model of group development proposed as in the case of [[therapy]] groups.  In general, some of these models view group change as regular movement through a series of stages, while others view them as phases that groups may or may not go through and which might occur at different points of a groups history.  Attention to group development over time has been one of the differentiating factors between the study of ad hoc groups and the study of [[team]]s such as those commonly used in the workplace, the military, sports and many other contexts.\n\n==Theories and Models==\nIn the early seventies, Hill and Grunner (1973) reported that more than 100 theories of group development existed.  Since then, other theories have emerged as well as attempts at contrasting and synthesizing them. As a result, a number of [[typology|typologies]] of group change theories have been proposed.  A typology advanced by George Smith (2001) based on the work of Mennecke and his colleagues (1992) classifies theories based on whether they perceive change to occur in a linear fashion, through cycles of activities, or through processes that combine both paths of change, or which are completely non-phasic. Other typologies are based on whether the primary forces promoting change and stability in a group are internal or external to the group. A third framework advanced by Andrew Van de Ven and Marshall Scott Poole (1995), differentiates theories based on four distinct motors for generating change.  According to this framework, the following four types of group development models exist: \n\n{|class=wikitable\n|-\n|Life cycle models:\n|Describe the process of change as the unfolding of a prescribed and linear sequence of stages following a program that is prefigured at the beginning of the cycle (decided within the group or imposed on it).\n|-\n|Teleological models:\n|Describe change as a purposeful movement toward one or more goals, with adjustments based on feedback from the environment.\n|-\n|Dialectical models:\n|Describe change as emerging from conflict between opposing entities and eventual synthesis leading to the next cycle of conflict\n|-\n|Evolutionary models:\n|Describe change as emerging from a repeated cycle of variation, selection and retention and generally apply to change in a population rather than change within an entity over time.\n|}\n\nSome theories allow for combinations and interactions among these four motors. For example, Poole (see below) found in his empirical research that seemingly complex patterns of behavior in group decision making result from the interplay of life-cycle and teleological motors. \n\nAn important observation made by McGrath and Tschan (2004) regarding the different models of group development found in the literature is that different models might explain different aspects of the history of a group. On the one hand, some models treat the group as an entity and describe its stages of development as a functioning unit or intact system (p. 101).  In this case, the models should be independent of the specific details of the task that the group is performing.  On the other hand, some models might describe phases of the groups task performance and, because of this, tend to be very sensitive to the type of task that the group is engaged in (the acting system, p. 101).\n\nBelow are descriptions of the central elements of some of the most common models of group development (See Smith, 2001 and Van de Ven & Poole, 1996 for a more complete list of theories and models).\n\n===Kurt Lewins Individual Change Process===\nThe the first systematic study of group development was carried out by [[Kurt Lewin]], who introduced the term [[group dynamics]] (Arrow et al., 2005).  His ideas about mutual, cross-level influence and quasi-stationary equilibria, although uncommon in the traditional empirical research on group development, have resurged recently. His early model of individual change, which has served as the basis of many models of group development, described change as a three-stage process: unfreezing, change, and freezing. \n\n{| class=wikitable\n|-\n| Unfreezing:\n| This phase involves overcoming inertia and dismantling the existing mind set. Defense mechanisms have to be bypassed. \n|-\n| Change\n| In the second stage change occurs. This is typically a period of confusion and transition. One is aware that the old ways are being challenged but does not have a clear picture to replace them with yet. \n|-\n|Freezing\n| In the third stage the new mindset is crystallizing and ones comfort level is returning to previous levels. This is often misquoted as refreezing (see Lewin, 1947).\n|}\n\n===Tuckmans Stages model===\n[[Bruce Tuckman]] reviewed about fifty studies of group development (including [[Bales]] model) in the mid-sixties and synthesized their commonalities in one of the most frequently cited models of group development (Tuckman, 1965).  The model describes four linear stages (forming, storming, norming, and performing) that a group will go through in its unitary sequence of decision making.  A fifth stage (adjourning) was added in 1977 when a new set of studies were reviewed (Tuckman & Jensen, 1977).\n\n{| class=wikitable\n|-\n|Forming:\n|Group members learn about each other and the task at hand. Indicators of this stage might include: Unclear objectives, Uninvolvement, Uncommitted members, Confusion, Low morale, Hidden feelings, Poor listening, etc.\n|-\n|Storming:\n|As group members continue to work, they will engage each other in arguments about the structure of the group which often are significantly emotional and illustrate a struggle for status in the group. These activities mark the storming phase: Lack of cohesion, Subjectivity, Hidden agendas, Conflicts, Confrontation, Volatility, Resentment, anger, Inconsistency, Failure.\n \n|-\n|Norming:  \n|Group members establish implicit or explicit rules about how they will achieve their goal. They address the types of communication that will or will not help with the task. Indicators include: Questioning performance, Reviewing/clarify objective, Changing/confirming roles, Opening risky issues, Assertiveness, Listening, Testing new ground, Identifying strengths and weaknesses.\n|-\n|Performing:  \n|Groups reach a conclusion and implement the solution to their issue. Indicators include: Creativity, Initiative, Flexibility, Open relationships, Pride, Concern for people, Learning, Confidence, High morale, Success, etc.\n|-\n|Adjourning:\n|As the group project ends, the group disbands in the adjournment phase. This phase was added when Tuckman and Jensens updated their original review of the literature in 1977.\n|}\n\nEach of the four stages in the [[Forming-storming-norming-performing|Forming-storming-norming-performing-adjourning]] model proposed by Tuckman involves two aspects: interpersonal relationships and task behaviors. Such a distinction is similar to Bales (1950) equilibrium model which states that a group continuously divides its attention between instrumental (task-related) needs and expressive (socioemotional).  \n\nAs Gersick (1988) has pointed out, some later  models followed similar sequential patterns.  Examples include: define the situation, develop new skills, develop appropriate roles, carry out the work (Hare, 1976); orientation, dissatisfaction, resolution, production, termination (LaCoursiere, 1980); and generate plans, ideas, and goals; choose&agree on alternatives, goals, and policies; resolve conflicts and develop norms; perform action tasks and maintain cohesion (McGrath, 1984).\n\n===Tubbs Systems model===\n\nStewart Tubbs systems approach to studying small group interaction led him to the creation of a four-phase model of group development: \n\n{| class=wikitable\n|-\n| Orientation:\n| In this stage, group members get to know each other, they start to talk about the problem, and they examine the limitations and opportunities of the project.  \n|-\n| Conflict:\n| Conflict is a necessary part of a groups development. Conflict allows the group to evaluate ideas and it helps the group avoid conformity and groupthink \n|-\n| Consensus:\n| Conflict ends in the consensus stage, when group members compromise, select ideas, and agree on alternatives. \n|-\n| Closure\n| In this stage, the final result is announced and group members reaffirm their support of the decision.\n|}\n\n===Fishers theory of decision emergence in groups===\n\nFisher outlines four phases through which task groups tend to proceed when engaged in decision making. By observing\nthe distribution of act-response pairs (a.k.a. interacts) across different moments of the group process, Fisher noted how the interaction changed as the group decision was formulated and solidified. His method pays special attention to the content dimension of interactions by classifying statements in terms of how they respond to a decision proposal (e.g. agreement, disagreement, etc.).\n\n{| class=wikitable\n|-\n| Orientation:\n|During the orientation phase, group members get to know each other and they experience a primary tension: the awkward feeling people have before communication rules and expectations are established. Groups should take time to learn about each other and feel comfortable communicating around new people. \n|-\n| Conflict:\n|The conflict phase is marked by secondary tension, or tension surrounding the task at hand. Group members will disagree with each other and debate ideas. Here conflict is viewed as positive, because it helps the group achieve positive results. \n|-\n| Emergence:\n|In the emergence phase, the outcome of the groups task and its social structure become apparent. Group members soften their positions and undergo and attitudinal change that makes them less tenacious in defending their individual viewpoint.\n|-\n| Reinforcement:\n|In this stage, group members bolster their final decision by using supportive verbal and nonverbal communication.\n|}\n\nBased on this categorization, Fisher created his Decision Proposal Coding System that identifies act-response pairs associated with each decision-making phase.  Interestingly, Fisher observed that the group decision making process tended to be more cyclical and, in some cases, almost erratic. He hypothesized that the interpersonal demands of discussion require breaks from task work.  In particular, Fisher observed that there are a number of contingencies that might explain some of the decision paths taken by some groups.  For instance, in modifying proposals, groups tend to follow one of two patterns.  If conflict is low, the group will reintroduce proposals in less abstract, more specific language. When conflict is higher, the group might not attempt to make a proposal more specific but, instead, because disagreement lies on the basic idea, the group introduces substitute proposals of the same level of abstraction as the original.\n\n===Pooles multiple-sequences model===\n\nMarshall Scott Pooles model suggests that different groups employ different sequences in making decisions. In contrast to unitary sequence models , the multiple sequences model addresses decision making as a function of several contingency variables: task structure, group composition, and conflict management strategies. Poole developed a descriptive system for studying multiple sequences, beyond the abstract action descriptions of previous studies. From Bales Interaction Process Analysis System and Fishers Decision Proposal Coding System, Poole proposes 36 clusters of group activities for coding group interactions and 4 cluster-sets: proposal development, socioemotional concerns, conflict, and expressions of ambiguity. However, in his latter work, Poole rejected phasic models of group development and proposed a model of continuously developing threads of activity. In essence, discussions are not characterized by blocks of phases, one after another, but by intertwining tracks of activity and interaction. \n\nPoole suggests three activity tracks: task progress, relational, and topical focus. Interspersed with these are breakpoints, marking changes in the development of strands and links between them. Normal breakpoints pace the discussion with topic shifts and adjournments. Delays, another breakpoint, are holding patterns of recycling through information. Finally, disruptions break the discussion threads with conflict or task failure. \n\n{| class=wikitable\n|-\n|Task track:\n|  The task track concerns the process by which the group accomplishes its goals, such as dealing doing problem analysis, designing solutions, etc. \n|-\n| Relation track:  \n|The relation track deals with the interpersonal relationships between the group members. At times, the group may stop its work on the task and work instead on its relationships, share personal information or engage in joking. \n|-\n|Topic track:\n|The topic track includes a series of issues or concerns the group have over time\n \n|-\n| Breakpoints:  \n|Breakpoints occur when a group switches from one track to another. Shifts in the conversation, adjournment, or postponement are examples of breakpoints.\n|}\n\n===McGraths Time, Interaction, and Performance (TIP) theory===\nMcGraths (1991) work emphasized the notion that different teams might follow different developmental paths to reach the same outcome. He also suggested that teams engage in four modes of group activity: inception, technical problem solving, conflict resolution, and execution According to this model, modes are potential, not required, forms of activity (p. 153) resulting in Modes I and IV (inception and execution) being involved in all group tasks and projects while Modes II (technical problem solving) and III (conflict resolution) may or may not be involved in any given group activity (Hare, 2003 uses the terms meaning, resources, integration, and goal attainment for these four modes).\n\nMcGrath further suggested that all team projects begin with Mode I (goal choice) and end with Mode IV (goal attainment) but that Modes II and III may or may not be needed depending on the task and the history of the groups activities. McGrath contended that for each identified function, groups can follow a variety of alternative time-activity paths in order to move from the initiation to the completion of a given function. Specifically, TIP theory states that there is a default path between two modes of activity which is satisficing or least effort path, and that such default path will prevail unless conditions warrant some more complex path (1991, p. 159).\n \n{| class=wikitable\n|-\n|Mode I: Inception\n| Inception and acceptance of a project (goal choice)\n|-\n|Mode II: Technical Problem Solving\n| Solution of technical issues (means choice)\n|-\n|Mode III: Conflict Resolution\n| Resolution of conflict, that is, of political issues (policy choice)\n|-\n|Mode IV: Execution\n| Execution of the performance requirements of the project (goal attainment)\n|}\n\nThis model also states that groups adopt these four modes with respect to each of three team functions: production, well-being, and member support. In this sense, groups are seen as always acting in one of the four modes with respect to each of the three functions, but they are not necessarily engaged in the same mode for all functions, nor are they necessarily engaged in the same mode for a given function on different projects that may be concurrent (McGrath, 1991, p. 153). The following table illustrates the relationship between modes and functions.\n\n{|class=wikitable\n|-\n|colspan=4 align=center|Functions\n|-\n|\n|align=center|Production\n|align=center|Well-being\n|align=center|Member Support\n|-\n|Mode I:<br/>Inception\n|Production\nDemand/ Opportunity\n|Interaction\nDemand/ Opportunity\n|Inclusion\nDemand/ Opportunity\n|-\n|Mode II:<br/>Problem Solving\n|Technical\nProblem Solving\n|Role\nNetwork Definition\n|Position/\nStatus Attainment\n|-\n|Mode III:<br/>Conflict Resolution\n|Policy\nConflict Resolution\n|Power/\nPayoff Distribution\n|Contribution/\nPayoff Relationships\n|-\n|Mode IV:<br/>Execution\n|Performance\n|Interaction\n|Participation\n|}\n<small>(Adapted from Figure 1 in McGrath, 1991, p. 154)</small>\n\n===Gersicks Punctuated Equilibrium model===\n\nGersicks study of naturally occurring groups departs from the traditionally linear models of group development. Her punctuated equilibrium model (Gersick, 1988, 1989, 1991) suggests that groups develop through the sudden formation, maintenance, and sudden revision of a framework for performance. This model describes the processes through which such frameworks are formed and revised and predicts both the timing of progress and when and how in their development groups are likely, or unlikely, to be influenced by their environments. The specific issues and activities that dominate groups work are left unspecified in the model, since groups historical paths are expected to vary. Her proposed model works in the following way. \n\n{| class=wikitable\n|-\n|Phase I \n| According to the model, a framework of behavioral patterns and assumptions through which a group approaches its project emerges in its first meeting, and the group stays with that framework through the first half of its life. Teams may show little visible progress during this time because members may be unable to perceive a use for the information they are generating until they revise the initial framework. \n|-\n|Midpoint \n|At their calendar midpoints, groups experience transitions-paradigmatic shifts in their approaches to their work-enabling them to capitalize on the gradual learning they have done and make significant advances. The transition is a powerful opportunity for a group to alter the course of its life midstream. But the transition must be used well, for once it is past a team is unlikely to alter its basic plans again. \n|-\n|Phase 2\n| A second period of inertial movement, takes its direction from plans crystallized during the transition. At completion, when a team makes a final effort to satisfy outside expectations, it experiences the positive and negative consequences of past choices.\n|}\n\n===Wheelans  Integrated Model of Group Development===\n\nBuilding on Tuckmans model and based on her own empirical research as well as the foundational work of [[Wilfred Bion]], Susan Wheelan proposed a unified or integrated model of group development (Wheelan, 1990; Wheelan, 1994a).  This model, although linear in a sense, takes the perspective that groups achieve maturity as they continue to work together rather than simply go through stages of activity.  In this model early stages of group development are associated with specific issues and patterns of talk such as those related to dependency, counterdependency, and trust which precede the actual work conducted during the more mature stages of a groups life.  The table below describes each one of these phases.\n\n{| class=wikitable\n|-\n|Stage I Dependency and Inclusion\n|The first stage of group development is characterized by significant member dependency on the designated leader, concerns about safety, and inclusion issues. In this stage, members rely on the leader and powerful group members to provide direction. Team members may engage in what has been called pseudo-work, such as exchanging stories about outside activities or other topics that are not relevant to group goals.\n|-\n|Stage II Counterdependency and Fight \n|In the second stage of group development members disagree among themselves about group goals and procedures. Conflict is an inevitable part of this process. The groups task at Stage 2 is to develop a unified set of goals, values, and operational procedures, and this task inevitably generates some conflict. Conflict also is necessary for the establishment of trust and a climate in which members feel free to disagree with each other.\n|-\n|Stage III Trust / Structure \n|If the group manages to work through the inevitable conflicts of Stage 2, member trust, commitment to the group, and willingness to cooperate increase. Communication becomes more open and task-oriented. This third stage of group development, referred to as the trust and structure stage, is characterized by more mature negotiations about roles, organization, and procedures. It is also a time in which members work to solidify positive working relationships with each other\n|-\n|Stage IV Work / Productivity \n|As its name implies, the fourth stage of group development is a time of intense team productivity and effectiveness. Having resolved many of the issues of the previous stages, the group can focus most of its energy on goal achievement and task accomplishment\n|-\n|Final \n|Groups that have a distinct ending point experience a fifth stage. Impending termination may cause disruption and conflict in some groups. In other groups, separation issues are addressed, and members appreciation of each other and the group experience may be expressed.\n|}\n\nBased on this model, Wheelan has created and validated both a Group Development Observation System (GDOS) and a Group Development Questionnaire (GDQ).  The GDOS allows researchers to determine the developmental stage of a group by categorizing and counting each complete thought exhibited during a group session into one of eight categories: Dependency statements, Counterdependency, Fight, Flight, Pairing, Counterpairing, Work, or Unscorable statements (Wheelan, 1994).  The GDQ is used to survey group members and assess their individual perception of their groups developmental state (Wheelan, S., & Hochberger, 1996). Her academic work has been transferred into a commercial organization, [http://www.gdqassoc.com/ | GDQ Associates, Inc.]\n\nIn her empirical validation of the model, Wheelan (2003) has analyzed the relationship between the length of time that a group has been meeting and the verbal behavior patterns of its members as well as the members perceptions of the state of development of the group.  Her results seem to indicate that there is a significant relationship between the length of time that a group had been meeting and the verbal behavior patterns of its members.  Also, members of older groups tended to perceive their groups to have more of the characteristics of Stage-3 and Stage-4 groups and to be more productive. Based on these results, Wheelans position supports the traditional linear models of group development and casts doubt on the cyclic models and Gersicks punctuated equilibrium model.\n\n===Morgan, Salas & Glickmans TEAM model===\n\nCombining multiple theories and the development models of Tuckman and Gersick, Morgan, Salas and Glickman (1994) created the Team Evolution and Maturation (TEAM) model to describe a series of nine developmental stages through which newly formed, task-oriented teams are hypothesized to evolve. The periods of development are labeled stages and conceived to be relatively informal, indistinct, and overlapping, because sharp demarcations are not often characteristic of the dynamic situations in which operational teams work and develop. According to this model, teams might begin a given period of development at different stages and spend different amounts of time in the various stages.  Teams are not always expected to progress in a linear fashion through all of the stages. A teams beginning point and pattern of progression through the stages depend on factors such as the characteristics of the team and team members, their past histories and experience, the nature of their tasks, and the environmental demands and constraints (cf. McGrath, 1991).\n\nThe TEAM model identities a total of nine stages, seven central ones supplemented by two additional ones. The seven central stages begin with the formation of the team during its first meeting (forming) and moves through the members initial, and sometimes unstable, exploration of the situation (storming), initial efforts toward accommodation and the formation and acceptance of roles (norming), performance leading toward occasional inefficient patterns of performance (performing-I), reevaluation and transition (reforming), refocusing of efforts to produce effective performance (performing-11), and completion of team assignments (conforming). The development of a team might be recycled from any of the final stages to an earlier stage if necessitated by a failure to achieve satisfactory performance or if adjustments to environmental demands are required or if problematic team interactions develop.\n\nThe core stages of the model are preceded by a pre-forming stage that recognizes the forces from the environment (environmental demands and constraints) that call for, and contribute to, the establishment of the team; that is, forces external\nto the team (before it comes into existence) that cause the team to be formed. The last stage indicates that after the team has served its purpose, it will eventually be disbanded or de-formed. Here. individuals exit from the group (separately or\nsimultaneously) and the team loses its identity and ceases to exist.\n\nThe TEAM model also postulates the existence of two distinguishable activity tracks present throughout all the stages. The first of these tracks involves activities that are tied to the specific task(s) being performed. These activities include interactions of the team members with tools and machines, the technical aspects of the job (e.g., procedures, policies, etc.), and other task-related activities.  The other track of activities is devoted to enhancing the quality of the interactions, interdependencies, relationships, affects, cooperation, and coordination of teams.\n\nThe proponents of the model did not test its components or sequence of stages empirically but did confirm that the perceptions of team members concerning the performance processes of the team are perceived to include both team-centered and task-centered activities and that these perceptions seem to change over time as a result of team training.\n\n'
p170
tp171
a(I1
S'{{nofootnotes|date=April 2009}}\n{{Orphan|date=November 2006}} \nRienk Feenstra (1920--2005) was an international expert in [[Greece|Greek]] [[philately]], writing and editing key reference books in this area, especially on the stamps and postal history of [[Crete]]. \n\nFeenstra was Chairman of the Hellenic Philatelic Society of Netherlands for 6 years and then its Honorary Chairman. He was awarded the [[Resistance Medal]], was a knight of the [[Order of Orange-Nassau]] (Orde van Oranje Nassau) and received numerous awards for his philatelic writing.\n\n'
p172
tp173
a(I1
S'{{Refimprove|date=August 2007}}\nInstitutional racism (also structural racism and systemic racism) is any form of [[racism]] occurring specifically within institutions such as public government bodies, private business [[corporation]]s, and [[university|universities]] (public and private). Institutional racism is one of three forms of racism: (i) Personally-mediated, (ii) internalized, and (iii) institutional. The term institutional racism was coined by [[Stokely Carmichael]], the [[Black nationalism|black nationalist]], [[Pan-Africanism|pan-Africanist]] and honorary prime minister of the [[Black Panther Party]], who, in the late 1960s, defined institutional racism as the collective failure of an organization to provide an appropriate and professional service to people because of their colour, [[culture]], or [[ethnic origin]].<sup>1</sup>\n<!-- Deleted image removed: [[Image:Looting-finding.gif|thumb|250px|Some liberal bloggers thought that these photo captions were an example of subtle institutionalized racism.<ref>[http://dir.salon.com/story/news/feature/2005/09/01/photo_controversy/ Looting or finding?: Bloggers are outraged over the different captions on photos of blacks and whites in New Orleans.] By Aaron Kinney Salon.com</ref>]] -->\n\n== Classification ==\nInstitutional racism is the [[differential]] access to the goods, services, and opportunities of society. When the differential access becomes integral to institutions, it becomes common practice, making it difficult to rectify.  Eventually, this racism dominates public bodies, private corporations, and public and private universities, and is reinforced by the actions of conformists and newcomers. Another difficulty in reducing institutionalized racism is that there is no sole, true identifiable perpetrator. When racism is built into the institution, it appears as the collective action of the population.\n\nThere are three major types of racism: (i) Personally-mediated, (ii) internalized,  and (iii) institutionalized. Personally-mediated racism <!-- (Is this not a matter of opinion?) is what most comes to mind when people hear the word racism.  It -->includes the specific social attitudes inherent to racially-prejudiced action (the [[bigotry|bigots]] differential assumptions about abilities, motives, and the  intentions of others according to), discrimination (the differential actions and behaviours towards others according to their race), stereotyping, commission, and omission (disrespect, suspicion, devaluation, and dehumanization). Internalized racism is the acceptance, by members of the racially-stigmatized people, of negative perceptions about their own abilities and intrinsic worth, characterized by low self-esteem, and low esteem of others like them. This racism is manifested through embracing whiteness (e.g. stratification by skin colour in non-white communities), self-devaluation (e.g. racial slurs, nicknames, rejection of ancestral culture, etc.), and resignation, helplessness, and hopelessness (e.g. [[dropping out]] of school, [[abstention|failing to vote]], engaging in health-risk practices, etc.).\n\nPersistent negative [[stereotype]]s fuel institutional racism, and very much matter because they influence interpersonal relations. Racial stereotyping contributes to patterns of [[racial segregation#United States|racial residential segregation]], and shape the views of white people about crime, crime policy, and welfare policy, especially if the contextual information is stereotype-consistent. A great percentage of white people rate Black Americans and Latino Americans as less intelligent, preferring to live from welfare benefits rather than work, and are more difficult to get along with socially; nevertheless, stereotypes have changed.  \n\nInstitutional racism is distinguished from the racial [[bigotry]], by the existence of institutional systemic policies and practices meant to place non-white racial and ethnic groups at a disadvantage in relation to the institutions white members. Restrictive housing contracts (see [[restrictive covenants]]) and bank lending policies (see [[redlining]]) are effective forms of institutional racism. Other examples are [[racial profiling]] by security guards and police, use of stereotyped racial caricatures (e.g. Indian sport mascots), the under- and mis-representation of certain racial groups in the [[mass media]], and race-based barriers to gainful employment and professional advancement. Additionally, the differential access to goods, services, and opportunities of society are defined within the term institutional racism, such as unpaved streets and roads, inherited socio-economic disadvantage, standardized tests (each ethnic group prepared for it differently; many are poorly prepared), et cetera. \n\nSome sociologic investigators distinguish between institutional racism and structural racism.  The former focus upon the norms and practices within an institution, the latter focus upon the interactions among  institutions, interactions that produce racialized outcomes against non-white people. An important feature of structural racism (structured racialization) is that it cannot be reduced to individual prejudice or to the single function of an institution. Like-wise, it is important to note that once a structure is emplaced, its consequences likely will affect the entire population  not just the racially discriminated people. Structural racialization also underscores many of the institutional arrangements that are often identified as [[American exceptionalism]]  such as the non-existence of a [[labor party]], weak labor [[Trade union|unions]], and a fragmented government system.  Structural racialization borrows from [[system theory]], which examines the interactions among institutions and entities and rejects [[reductionism|reductionist]] thought; thus, there is a mutual, cumulative causation instead of a single cause. Using the systems approach for structural racialization calls into question whether or not race or social class is more important in the US.  Instead, it suggests an interaction, between race and social class, and their consequences upon institutional design and institutional meaning.\n\n==American institutional racism ==\n\nThese historical American examples illuminate the nature and effects of institutional racism.\n#In 1935, the [[U.S. Congress]] passed the [[Social Security Act]], guaranteeing an income for millions of workers after their retirements, however, the Act specifically excluded domestic and agricultural workers  many of whom were Mexican-American, African-American, and Asian-American. These workers, therefore, were not guaranteed an income after retirement, thus had less opportunity to save, accumulate, and pass wealth to their future generations.\n#The U.S. property appraisal system, created in the 1930s, tied property value and eligibility for government loans to race  thus, white-majority neighborhoods received the governments highest property value ratings, and white people were eligible for government loans, thus, between 1934 and 1962, less than 2 percent of government-subsidized housing went to non-white people.<ref>[http://www.pbs.org/race/006_WhereRaceLives/006_00-home.htm Where Race Lives], [[Race: The Power of an Illusion]], [[PBS]], 2003</ref>\n\nThese institutional racism examples depend not on the individual, isolated, and [[idiosyncrasy|idiosyncratic]] beliefs or racial biases of particular persons, but on racist biases embedded to social structures and institutions. Moreover, in the first example, no race was specifically identified for exclusion from the [[Social Security (United States)|Social Security Act]], but the rules of the Act effectively allowed wealth benefits to accrue to white people and not to others  therefore, institutional racism need not be explicit in order for it to benefit certain races over others.\n\nGovernmental, social, and educational policies also have been charged with institutional racism, i.e. it affects general [[health care]] and [[AIDS]] (Acquired Immunodeficiency Syndrome) health intervention and services in non-white [[Minority group|minority communities]]. The over-representation of minorities in disease categories (including AIDS), is partly related to racism. The federal governments national response to the AIDS epidemic in minority communities has been slow, showing insensitivity to ethnic diversity in preventive medicine, community health maintenance, and AIDS treatment services.<ref> Hutchinson J. AIDS and racism in America,  [[Journal of the National Medical Association]], Feb. 1992 Feb  {{pubmed|1602509}}</ref>\n\n[[Standardized testing]] also has been identified as institutional racism, because it is an [[academic]] assessment significantly biased in favor of people with a given socio-cultural background, with the supposed result that racial minorities tend to score poorly in most of the [[Western world]]. Just as unpaved streets and roads in predominantly black communities are a prime example of institutionalized racism, like-wise the use of older-edition (outdated) and used [[textbooks]] in predominantly black schools. Because schools are funded mostly with the [[property tax|property taxes]] of the surrounding areas, a school in a poor black community cannot readily buy new textbooks as can a school in a middle- or a high-income community. Therefore, minority schools are forced to use old textbooks (discarded by other schools), further aggravating the extant socio-economic differential established with institutional racism. Furthermore, the prevalence of used textbooks in mostly black schools supports the contention that standardized texts are inherently racist, because the non-white student knows outdated information that is not tested in the examinations; thus is each ethnic group in the school system prepared differently, and only one is usually prepared adequately.\n\n==Canadian institutional racism==\n===Exclusionary anti-Chinese immigration laws===\nThe Canadian government passed [[The Chinese Immigration Act, 1885]] levying a $50 [[Head Tax]] upon all Chinese immigrating to Canada. When the 1885 act failed to deter Chinese immigration, the Canadian government then passed the [[The Chinese Immigration Act, 1900]], increasing the head tax to $100, and, upon that act failing,  passed [[The Chinese Immigration Act, 1904]] increasing the head tax (landing fee) to $500, equivalent to $8000 in 2003<ref>Inflation data ([[Consumer Price Index]]) since 1914, by [[Statistics Canada]], are at the [http://www.bankofcanada.ca/en/rates/inflation_calc.html Bank of Canada inflation calculator]</ref>   when compared to the head tax  [[Right of Landing Fee]] and [[Right of Permanent Residence Fee]]  of $975 per person, paid by new immigrants in 19952005 decade, which then was reduced to $490 in 2006.<ref>[http://www.cic.gc.ca/EnGlish/applications/fees.html CIC Fee Schedule], accessed 2006-12-02</ref>\n\n[[The Chinese Immigration Act, 1923]], better known as the Chinese Exclusion Act, replaced prohibitive fees with a [[ban]] on Chinese immigration to Canada  excepting merchants, diplomats, students, and special circumstance cases. The Chinese who entered Canada before 1923 had to register with the local authorities, and could leave Canada only for two years or less. Since the Exclusion Act went into effect on 1 July 1923, Chinese-Canadians referred to [[Canada Day]] (Dominion Day) as Humiliation Day, refusing to celebrate it until the Acts repeal in 1947.\n\n==Malaysian institutional racism==\n{{main|Malay supremacy}}\n\nKetuanan Melayu (Malay supremacy and Malay dominance in [[Malay language|Malay]]) is the claim that the [[Malay people]] are the tuan (masters) of [[Malaysia]]. The [[Malaysian Chinese]] and [[Indian Malaysian|Indian-Malaysian]]s  who are significant ethnic minorities in Malaysia  are considered beholden to the Malays for granting them citizenship in return for special privileges, as established in [[Article 153 of the Constitution of Malaysia|Article 153]] of the [[Constitution of Malaysia]].  This [[quid pro quo]] arrangement usually is referred to as the [[social contract (Malaysia)|Malaysian social contract]]. The ketuanan Melayu concept usually is used by politicians of the [[United Malays National Organisation]] (UMNO), the most influential Malaysian political party.\n\nAlthough the ketuanan Melayu idea pre-dates Malaysian independence, the phrase ketuanan Melayu did not come into vogue until the early 2000s. The most vocal opposition to that is from non-Malay-based parties, such as the Malaysian Peoples Movement Party (Gerakan) and [[Democratic Action Party]] (DAP); although pre-independence, the [[Straits Chinese]] also agitated against ketuanan Melayu. The idea of Malay supremacy gained political weight in the 1940s, when the Malays organized to protest the [[Malayan Union]]s establishment, from which they later fought for independence. During the 1960s, there was a substantial political effort challenging ketuanan Melayu led by the [[Peoples Action Party]] (PAP) of [[Singapore]] &mdash; which was a Malaysian state from 1963 to 1965 &mdash; and the DAP, after Singapores [[secession]], however, the Constitutional articles related to ketuanan Melayu were [[Entrenchment clause|entrenched]] after the [[May 13 Incident|racial riots]] of 13 May 1969, consequent to an election campaign focused on the rights of non-Malay people and the ketuanan Melayu matter. From that arose the [[ultra (Malaysia)|ultras]], advocating a one-party government led by UMNO, and increased racist emphasis that the Malays are the definitive people of Malaysia &mdash; i.e. only a Malay could be a true Malaysian.\n\n==Institutional racism in Sri Lanka==\n{{Article issues|disputed=February 2008|POV=February 2008|date=March 2009}}\n{{Main|Origins of the Sri Lankan civil war}}\nThere are four main ethnic groups on the island of [[Sri Lanka]]: the [[Sinhalese people|Sinhalese]] who made up 69% of the population in 1946, [[Indian Tamils of Sri Lanka|Indian Tamils]] (12%), [[Sri Lankan Tamil people|Sri Lankan Tamils]] (11%) and [[Sri Lankan Moors]] (6%).<ref name=census>{{cite web|url=http://www.statistics.gov.lk/Abstract_2008_PDF/abstract2008/table%202008/Chap%202/AB2-10.pdf|title=Population by ethnic group, census years|work=Statistical Abstract 2008|publisher=Department of Census & Statistics, Sri Lanka}}</ref> The discrimination against the Sri Lankan Tamil minority by the Sinhalese controlled [[Politics of Sri Lanka|Sri Lankan state]] was one of the main causes of the 26 year [[Sri Lankan Civil War]] which killed between 80,000 and 100,000 people.<ref>{{cite news|url=http://www.voanews.com/english/2009-09-11-voa14.cfm|title=United Nations Calls for Faster Resettlement of War Refugees in Sri Lanka|last=Pasricha |first=Anjana|date=11 September 2009|publisher=[[Voice of America]] News|accessdate=11 October 2009}}</ref><ref>{{cite web|url=http://www.hrw.org/en/news/2009/05/21/letter-un-secretary-general-ban-ki-moon-his-trip-sri-lanka|title=Letter to UN Secretary-General Ban Ki-moon on His Trip to Sri Lanka|date=21 May 2009|publisher=[[Human Rights Watch]]|accessdate=11 October 2009}}</ref><ref>{{cite web |title=Up to 100,000 killed in Sri Lankas civil war: UN |url=http://www.abc.net.au/news/stories/2009/05/20/2576543.htm |date=20 May 2009 |publisher=[[ABC News (Australia)]] |accessdate=11 October 2009}}</ref>  \n\nImmediately after [[independence]] the Sinhalese dominated government of [[Ceylon]] introduced the [[Ceylon Citizenship Act]] of 1948 which deliberately discriminated against the Indian Tamil ethnic minority by making it virtually impossible for them to obtain [[citizenship]] of Ceylon.<ref name=unhcr>{{cite web |title=Statelessness in Sri Lanka |url=http://www.unhcr.lk/protection/statelessness/ |publisher=[[UNHCR]] in Sri Lanka |accessdate=11 October 2009}}</ref> Approximately 700,000 Indian Tamils were made [[stateless]].<ref>{{cite web|url=http://www.ices.lk/sl_database/ethnic_conflict/time_line.shtml|title=Ethnic Conflict of Sri Lanka: Time Line - From Independence to 1999|publisher=International Centre for Ethnic Studies|accessdate=11 October 2009}}</ref> Over the next three decades more than 300,000 Indian Tamils were deported back to India.<ref name=unhcr/> It wasnt until 2003, 55 years after independence, that all Indian Tamils living in Sri Lanka were granted citizenship but by this time they only made up 5% of the islands population.<ref name=unhcr/><ref name=census/>\n\nIn 1956 the Ceylon government introduced the [[Sinhala Only Act]], replacing [[English language|English]] with [[Sinhala language|Sinhala]] as the [[Languages of Sri Lanka|official language of Ceylon]]. The Act was a deliberate attempt to correct the perceived disproportionately high number of Sri Lankan Tamils working in the [[Ceylon Civil Service]] and other [[public services]].<ref name=NI>{{cite web|url=http://www.newint.org/issue128/pogrom.htm|title=Sri Lankas pogrom|last=R.L. Pereira|date=October 1983|work=Issue 128|publisher=[[New Internationalist]]|accessdate=11 October 2009}}</ref> However, the [[Tamil language]] speaking minorities of the Ceylon (Sri Lankan Tamils, Indian Tamils and Sri Lankan Moors) viewed the Act as [[linguistic]], [[cultural]] and [[economic]] discrimination against them.<ref name=RP>{{cite web|url=http://www.redpepper.org.uk/Background-to-brutality|title=Background to brutality|last=McConnell|first=Deirdre|date=7 April 2009|publisher=Red Pepper|accessdate=11 October 2009}}</ref> Many Tamil speaking [[civil servants]]/[[public servants]] were forced to resign because they werent [[fluent]] in Sinhala.<ref>{{cite web|url=http://www.thenation.com/doc/20090223/raychaudhuri|title=Will Sri Lanka Drive the Tigers to Extinction? |last=Raychaudhuri|first=Sumana|date=6 February 2009|publisher=The Nation|accessdate=11 October 2009}}</ref> The detrimental impact of the Act on the civil/public services forced the government to relax the language laws: in 1977 Tamil was made a national language and in 1987 it was made an official language.<ref name=SriModernAge>{{cite book |last=Wickremasinghe|first= Nira |title=Sri Lanka in the Modern Age: A History of Contested Identities |publisher=University of Hawaii Press|year= 2006 |isbn= 0-8248-3016-4}}</ref>\n\nThe 1971 Universities Act introduced a the [[Policy of standardization]] in a deliberate attempt to correct disproportionately high number of Sri Lankan Tamils students entering universities. Officially the policy was meant to discriminate in favour of students from [[rural]] areas but in reality the policy discriminated against Sri Lankan Tamil students who were in effect required gain more marks than Sinhalese students to gain admission to universities.<ref name=NI/><ref name=RP/> The number of Sri Lankan Tamil students entering universities fell dramatically. The policy was abandoned in 1977.<ref name=SriModernAge/> \n\nOther forms of official discrimination against the Sri Lankan Tamils included the [[Sri Lankan state sponsored colonisation schemes|state-sponsored colonisation]] of traditional Tamil areas by Sinhalese [[peasants]], the [[Banning of Tamil language media importation|banning]] of the import of Tamil language media and the precedence given by the 1978 [[Constitution of Sri Lanka]] to [[Buddhism in Sri Lanka|Buddhism]], the main religion followed by the Sinhalese.<ref name=NI/><ref name=RP/>    \n\nThe Sri Lankan Tamils reacted to the discrimination by calling for political [[devolution]] (federalism) and staging peaceful protests but were met with violence and [[Riots in Sri Lanka|ethnic riots]].<ref name=RP/> This in turn resulted in moderate Tamils calling for [[self determination]] but some young Tamils reacted by forming a number of [[Sri Lankan Tamil militant groups|militant groups]], the most prominent being the [[Liberation Tigers of Tamil Eelam]] (LTTE). By 1983 full scale civil war had erupted between the LTTE and the Sri Lankan government. The civil war ended in May 2009 with the defeat of the LTTE but many independent/international observers recognised that the continued discrimination against the Tamils would leave the ethnic conflict unresolved. The [[United Nations Human Rights Council]] has urged the Sri Lankan goverment to to combat discrimination against persons belonging to ethnic minorities.<ref>{{cite news|url=http://www.reuters.com/article/featuredCrisis/idUSLR170562|title= Sri Lanka urged at U.N. to ensure aid reaches Tamils|last=MacInnis|first=Laura|date=27 May 2009|publisher=[[Reuters]]|accessdate=11 October 2009}}</ref>\n\n==British institutional racism==\n===In the Metropolitan Police Service===\n{{Further|[[Stephen Lawrence]]}}\nIn the [[United Kingdom|UK]], the inquiry about the [[murder]] of the black Briton [[Stephen Lawrence]] found the investigating [[Policing in the United Kingdom|police force]] to be institutionally racist. [[Clan Macpherson#Clan Macpherson Today|Sir William Macpherson]] of Cluny used the term as a description of the collective failure of an organisation to provide an appropriate and professional service to people because of their colour, culture or ethnic origin, which can be seen or detected in processes, attitudes, and behaviour, which amount to discrimination through unwitting prejudice, ignorance, thoughtlessness, and racist stereotyping, which disadvantages minority ethnic people.<ref>[http://www.guardian.co.uk/lawrence/Story/0,,941167,00.html Metropolitan police still institutionally racist], [[The Guardian]], 22 April 2003</ref> Sir Williams definition is almost identical to [[Stokely Carmichael]]s original definition some forty years earlier.\n\nThe [[Stephen Lawrence#The Stephen Lawrence Inquiry Report|Stephen Lawrence Inquiry Report]], and the publics response to it, were among the major factors that forced the [[Metropolitan Police]] to eliminate its institutional racism. More recently, the former [[Commissioner of Police of the Metropolis|Metropolitan Police Commissioner]], [[Ian Blair|Sir Ian Blair]] said that the British news media are institutionally racist, <ref>[http://news.bbc.co.uk/1/hi/england/london/4651368.stm Met chief accuses media of racism], [[BBC]], 26 January 2006</ref> a comment that offended journalists, provoking angry responses from the media, despite the [[National Black Police Association (UK)|National Black Police Association]] welcoming Sir Ians assessment.<ref>[http://media.guardian.co.uk/site/story/0,14173,1696070,00.html?gusrc=rss Met chief labels media institutionally racist], [[The Guardian]], 27 January 2006</ref>\n\n'
p174
tp175
a(I-1
S'Herd mentality describes how people are influenced by their peers to adopt certain behaviors, follow trends, and/or purchase items. Examples of the herd mentality include the early adopters of high technology products such as [[cell phones]] and [[iPods]], as well as [[stock market]] trends, fashions in apparel, cars, home dcor, etc. Social psychologists study the related topics of [[group intelligence]], [[crowd wisdom]], and [[decentralized decision making]].\n \nPeople in these herds are broken up into two groups, explains [[Friedrich Nietzsche]], a philosopher who coined the phrase.  One lended itself to the religious points of views- their beliefs and how those dictated their actions- while the other lended itself to influence by the media-  based upon what others perceive as right (following trends, social norms, etc.). Nietzsche perceived these two forms of subservience to be a weakness among the common man, and that the Superman as Nietzsche terms is the one who overcomes the values of the fallible herd.\n\n== Definition ==\nThe term herd mentality is derived from the word [[herd]], meaning group of animals, and [[mentality]], implying a certain frame of mind. However the most succinct definition would be: how large numbers of people act in the same ways at the same times.\n \n[[Herd behavior]] is distinguished from herd mentality because it applies to all animals, whereas the term mentality implies a uniquely human phenomenon. Herd mentality implies a fear-based reaction to peer pressure which makes individuals act in order to avoid feeling left behind from the group.{{Citation needed|date=September 2009}} Herd mentality is also sometimes known as mob mentality.{{Citation needed|date=September 2009}}\n\n== History ==\nHerd mentality and [[herd behavior]] have been prevalent descriptors for human behavior since people began to form tribes, migrate in groups, and perform cooperative marketing and agricultural functions.\nThe idea of a [[group mind]] or [[mob behavior]] was first put forward by 19th century French social psychologists [[Gabriel Tarde]] and [[Gustav Le Bon]]. Herd behavior in human societies has also been studied by [[Sigmund Freud]] and [[Wilfred Trotter]], whose book Herd Instincts in Peace and War is a classic in the field of social psychology. Sociologist and Economist [[Thorstein Veblen]]s Theory of the Leisure Class illustrates how individuals imitate other group members of higher social status in their consumer behavior. More recently, [[Malcolm Gladwell]] in [[The Tipping Point]], examines how cultural, social, and economic factors converge to create trends in consumer behavior. In 2004, the [[The New Yorker|New Yorker]]s financial columnist [[James Suroweicki]] published, The Wisdom of Crowds.\n\nTwenty-first century academic fields such as marketing and behavioral finance attempt to identify and predict the rational and irrational behavior of investors. (See the work of [[Daniel Kahneman]], [[Robert Shiller]], [[Vernon Smith]], and [[Amos Tversky]].) Driven by emotional reactions such as greed and fear, investors can be seen to join in frenetic purchasing and sales of stocks, creating [[bubbles]] and [[Stock market crash|crashes]].\n\n'
p176
tp177
a(I1
S'In modern slang, a soaper is a person  who practices [[Soap#Soapmaking|soap making]]. It is the origin of the [[surname]]s Soper, Saboni, (Arabic for soap maker) and Soaper.  Roads named Sopers Lane, Soper Street, and so forth are often so named because historically they were centres for soap making.{{Fact|date=February 2008}}\n\nHistorically, in England and in the United States, a [[chandler]] is a person who makes soap and/or candles for profit.<ref>McDaniel, Robert (2000).</ref><ref>Miller Cavitch, Susan (1997).</ref><ref>The Merriam-Webster Doictionary (1994).</ref>\n\nWhilst much soap nowadays is mass-produced by industrial chemical companies, some people still make soap themselves; sometimes out of a desire for a higher-quality or different soap product than can be purchased, sometimes for the sake of keeping the traditional soap making methods alive, and sometimes as technical [[avocation]], in conjunction with an interest in chemistry or manufacturing.\n\nThe hobby of soap making has enjoyed various eras of popularity. In recent years, making soap by hand and using it in place of synthetic detergents is also seen as a way to more [[sustainable]] living.\n\n'
p178
tp179
a(I-1
S'[[Image:social-network.svg|250px|thumb|right|Nodes (individuals) and ties (connections) in [[social network]]s.]]\n\nIn [[mathematical sociology]], interpersonal ties are defined as information-carrying connections between people. Interpersonal ties, generally, come in three varieties: strong, weak, or absent.  Weak social ties, it is argued, are responsible for the majority of the embeddedness and structure of [[social networks]] in [[society]] as well as the transmission of [[information]] through these networks.  Specifically, more novel information flows to individuals through weak rather than strong ties. Because our close friends tend to move in the same circles that we do, the information they receive overlaps considerably with what we already know. Acquaintances, by contrast, know people that we do not, and thus receive more novel information.<ref>Granovetter, M.D. (2004). [http://www.leader-values.com/Content/detail.asp?ContentDetailID=990 The Impact of Social Structures on Economic Development]. Journal of Economic Perspectives (Vol 19 Number 1, pp. 33-50).</ref> \n\nIncluded in the definition of absent ties, according to Granovetter, are those relationships (or ties) without substantial significance, such as nodding relationships between people living on the same street, or the tie, for example, to a frequent vendor one would buy from. Furthermore, the fact that two people may know each other by name does not necessarily qualify the existence of a weak tie. If their interaction is negligible the tie may be absent. The strength of an interpersonal tie is a linear combination of the amount of time, the emotional intensity, the intimacy (or mutual confiding), and the reciprocal services which characterize each tie.<ref>[[Mark Granovetter|Granovetter, M.S.]] (1973). [http://www.stanford.edu/dept/soc/people/mgranovetter/documents/granstrengthweakties.pdf The Strength of Weak Ties], Amer. J. of Sociology, Vol. 78, Issue 6, May 1360-80.</ref>\n\n==History==\nOne of the earliest writers to describe the nature of the ties between people was German scientist and philosopher, [[Johann Wolfgang von Goethe]]. In his classic 1809 novella, [[Elective Affinities]], Goethe discussed the marriage tie. The analogy shows how strong marriage unions are similar in character to particles of [[Mercury (element)|quicksilver]], which find unity through the process of [[chemical affinity]].  \n\nIn 1954, the Russian mathematical psychologist [[Anatol Rapoport]] commented on the well-known fact that the likely contacts of two individuals who are closely acquainted tend to be more overlapping than those of two arbitrarily selected individuals. This argument became one of the cornerstones of [[social network theory]]. \n\nIn 1973, stimulated by the work of Rapoport and Harvard theorist [[Harrison White]], the American sociologist [[Mark Granovetter]] published The Strength of Weak Ties. This paper is now recognized as one of the most influential sociology papers ever written.<ref name=Barabasi >{{cite book | last = Barabasi | first = Albert-Laszlo | title = Linked - How Everything is Connected to Everything Else and What it Means for Business, Science, and Everyday Life | publisher = Plume | year = 2003 | isbn = 0-452-28439-2}}</ref>  \n\nTo obtain data for his doctoral thesis, Granovetter interviewed dozens of people to find out how social networks are used to land new jobs. Granovetter found that most jobs were found through weak acquaintances.  This pattern reminded Granovetter of his freshman chemistry lesson that demonstrated how weak [[hydrogen bond]]s hold huge water molecules together, which are themselves held together by strong [[covalent bonds]].\n\n<center> [[Image:Hydrogen-bonding-in-water-2D.png|200px]] </center>\n\nIn Granovetters view, a similar combination of strong and weak bonds holds the members of [[society]] together.<ref name=Barabasi /> This model became the basis of his first manuscript on the importance of weak social ties in human life.  He submitted his paper to the [[American Sociological Review]] in 1969, but it was rejected. Nevertheless, in 1972, Granovetter submitted a shortened version to the [[American Journal of Sociology]], and it was finally published in May 1973. According to Current Contents, by 1986, the Weak Ties paper had become a citation classic, being one of the most cited papers in sociology.\n\n<center> [[Image:Tie-network.jpg|400px]] </center>\n\nIn a related line of research in 1969, anthropologist [[Bruce Kapferer]], published Norms and the Manipulation of Relationships in a Work Context after doing field work in Africa. In the document, he postulated the existence of multiplex ties, characterized by multiple contexts in a relationship.<ref>Kapferer, B. (1969). Norms and the Manipulation of Relationships in a Work Context, in Social Networks in Urban Situations, edited by J.C. Mitchell. Manchester: Manchester University Press.</ref><ref>[http://www.anthrobase.com/Txt/S/Smedal_Kapferer_01.htm Interview with Bruce Kapferer] (2001) by Olaf H. Smedal</ref>  In [[telecommunication]]s, a [[multiplexer]] is a device that allows a transmission medium to carry a number of separate signals.  In social relations, by extrapolation, multiplexity is the overlap of roles, exchanges, or affiliations in a social relationship.<ref>Verbrugge, Lois M.(1979). [http://links.jstor.org/sici?sici=0037-7732(197906)57%3A4%3C1286%3AMIAF%3E2.0.CO%3B2-I Multiplexity in Adult Friendships], Social Forces, Vol. 57, No. 4 (Jun.), pp. 1286-1309</ref>\n\n==Research data==\nIn 1970 Dr. Granovetter submitted his doctoral dissertation to [[Harvard University]], entitled Changing Jobs: Channels of Mobility Information in a Suburban Community. The thesis of his dissertation illustrated the conception of weak ties. For his research, Dr. Granovetter crossed the Charles River to Newton, Massachusetts where he surveyed 282 professional, technical, and managerial workers in total. 100 were personally interviewed, in regards to the type of ties between the job changer and the contact person who provided the necessary information.  Tie strength was measured in terms of how often they saw the contact person during the period of the job transition, using the following assignment:\n*often = at least once a week\n*occasionally = more than once a year but less than twice a week\n*rarely = once a year or less\n\nOf those who found jobs through personal contacts (N=54), 16.7% reported seeing their contact often, 55.6% reported seeing their contact occasionally, and 27.8% rarely.<ref>Granovetter, M.S. (1970). Changing Jobs: Channels of Mobility Information in a Suburban Community. Doctoral dissertation, Harvard University.</ref>  When asked whether a friend had told them about their current job, the most frequent answer was not a friend, an acquaintance.  The conclusion from this study is that weak ties are an important resource in occupational mobility.  When seen from a macro point of view, weak ties play a role in affecting social cohesion.\n\n==Social networks==\nIn [[social network theory]], social relationships are viewed in terms of nodes and ties.  Nodes are the individual actors within the networks, and ties are the relationships between the actors. There can be many kinds of ties between the nodes. In its most simple form, a social network is a map of all of the relevant ties between the nodes being studied.\n\n===Weak tie hypothesis===\nThe weak tie hypothesis argues, using a combination of [[probability]] and [[mathematics]], as originally stated by [[Anatol Rapoport]] in 1957, that if A is linked to both B and C, then there is a greater-than-chance probability that B and C are linked to each other:<ref name=Rapoport >*Rapoport, Anatol. (1957).  Contributions to the Theory of Random and Biased Nets. Bulletin of Mathematical Biophysics 19: 257-277.</ref>  \n\n<center> [[Image:Weak-strong-ties.svg|300px]] </center>\n\nThat is, if we consider any two randomly selected individuals, such as A and B, from the set S = A, B, C, D, E, ..., of all persons with ties to either or both of them, then, for example, if A is strongly tied to both B and C, then according to probability arguments, the B-C tie is always present.  The absence of the B-C tie, in this situation, would create, according to Granovetter, what is called the forbidden triad.  In other words, the B-C tie, according to this logic, is always present, whether weak or strong, given the other two strong ties.  In this direction, the weak tie hypothesis postulates that clumps or [[clique]]s of social structure will form, being bound predominately by strong ties, and that weak ties will function as the crucial bridge between any two densely knit clumps of close friends.<ref>[[Mark Granovetter|Granovetter, M.S.]] (1983). [http://www.si.umich.edu/~rfrost/courses/SI110/readings/In_Out_and_Beyond/Granovetter.pdf The Strength of the Weak Tie: Revisited] [PDF], Sociological Theory, Vol. 1, 201-33.</ref>  \n\nIt follows, then, that individuals with few weak ties will be deprived of information from distant parts of the [[social system]] and will be confined to the provincial news and views of their close friends. From this basis, other theories can be formulated and tested, e.g. that the diffusion of information, such as [[rumor]]s, may tend to be dampened by strong ties, and thus flow more easily through weak ties.\n\n===Positive ties and negative ties===\nStarting in the late 1940s, [[Anatol Rapoport]] and others developed a probabilistic approach to the characterization of large social networks in which the nodes are persons and the links are acquaintanceship.  During these years, formulas were derived that connected local parameters such as closure of contacts, and the supposed existence of the B-C tie to the global network property of connectivity.<ref name=Rapoport />   \n\nMoreover, acquaintanceship (in most cases) is a positive tie. However, there are also negative ties such as animosity among persons.  To tackle this problem, [[graph theory]] (the mathematical study of abstract representations of networks), can be extended to include these two types of links. This creates models (called [[signed graph]]s) that represent both positive and negative sentiment relations.  \n\nThis effort led to an important and non-obvious Structure Theorem for signed graphs, which was published by [[Frank Harary]] in 1953.  A signed graph is called balanced if the product of the signs of all relations in every cycle (links in every graph cycle) is positive.  A signed graph is unbalanced if the product is ever negative.  The theorem says that if a network of interrelated positive and negative ties is balanced, then it consists of two subnetworks such that each has positive ties among its nodes and negative ties between nodes in distinct subnetworks. In other words, my friends enemy is my enemy. <ref>Cartwright, Dorwin & Harary, Frank. (1956).  Structural Balance: A Generalization of Heiders Theory.  Psychological Review 63:277-293.</ref>  The imagery here is of a social system that splits into two cliques. There is, however, a special case where one of the two subnetworks may be empty, which might occur in very small networks. \n\nIn these two developments, we have mathematical models bearing upon the analysis of the structure.  Other early influential developments in mathematical sociology pertained to process.  For instance, in 1952 [[Herbert Simon]] produced a mathematical formalization of a published theory of social groups by constructing a model consisting of a deterministic system of differential equations.  A formal study of the system led to theorems about the dynamics and the implied [[equilibrium state]]s of any group.\n\n==The individualistic perspective==\nGranovetters work (1973) proved to be crucial in the individualistic approach of the social network theory as seen by the amount of references in other papers. \nHis argument asserts that weak ties (acquaintances, according to Granovetter, 1973; 1983) are less likely to be involved within the social network than strong ties (close friends and family). By not going further in the strong ties, but focusing on the weak ties, Granovetter highlights the importance of acquaintances in social networks. He argues, that the only thing what can connect two social networks with strong ties is a weak tie:  these clumps / [strong ties networks] would not, in fact, be connected to one another at all were it not for the existence of weak ties. (Granovetter, 1973 pp 1363; 1983 pp 202). \n\nIt follows that in an all-covering social network individuals are disadvantageous with a few weak links compared to individuals with multiple weak links as they are disconnected with the other parts of the network. Another interesting observation that Granovetter makes in his work is the fact of forth going specialization of individuals creates the necessity for weak ties as all the other specialist information and knowledge is present in other social networks (Granovetter, 1973). \n\nCross et al., (2001) confirm this by presenting six features which differentiate effective and ineffective knowledge sharing relations: \n1)knowing what other person knows and thus when to turn to them; \n2) being able to gain timely access to that person; \n3) willingness of the person sought out to engage in the problem solving rather than dump information; \n4) a degree of safety in the relationship that promoted learning and creativity; \n5) the factors put by [[Geert Hofstede]]; and \n6) individual characteristics, such as openness  (pp 5). This fits in nicely with Granovetters argument that Weak ties provide people with access to information and resources beyond those available in their own social circle; but strong ties have greater motivation to be of assistance and are typically more easily available. (Granovetter, 1983, pp 209) \n\nThis weak/strong ties paradox is elaborated by myriad authors. The extent in which individuals are connected to others is called centrality. Sparrowe & Linden (1997) argue how the position of a person in a social network confer advantages such organizational assimilation, and job performance (Sparrowe et al., 2001); Burt (1992) expects it to result in promotions, Brass (1984) affiliates centrality with power and Friedkin (1993) with influence in decision power. Other authors, such as Krackhardt and Porter (1986) contemplate the disadvantages of the position is social networks such as organizational exit (see also Sparrowe et al., 2001) and Wellman et al.,(1988) introduce the use of social networks for emotional and material support. Blau and Fingerman (2009), drawing from these and other studies, refer to weak ties as [[consequential strangers]], positing that they provide some of the same benefits as intimates as well as many distinct and complimentary functions. <ref> Blau, Melinda and Fingerman, Karen L.(2009) Consequential Strangers: People Who Dont Seem to Matter...But Really Do, New York: W.W. Norton (in press)</ref>\n\n==Recent views==\nIn the early 1990s, American social economist [[James Montgomery]] contributed to economic theories of network structures in labor market. In 1991, Montgomery incorporated network structures in an adverse selection model to analyze the effects of social networks on [[labor market]] outcomes.<ref>Montgomery, J.D. (1991). Social Networks and Labor-Market Outcomes: Toward an Economic Analysis, American Economic Review, 81 (Dec.): 1408-18.</ref>  In 1992, Montgomery explored the role of weak ties, which he defined as non-frequent and transitory social relations, in labor market.<ref>Montgomery, J.D. (1992). Job Search and Network Composition: Implications of the Strength-of-Weak-Ties Hypothesis, American Sociological Review, 57 (Oct.): 586-96.</ref><ref>Montgomery, J.D. (1994). Weak Ties, Employment, and Inequality: An Equilibrium Analysis, American Journal of Sociology, 99 (Mar.): 1212-36.</ref> He demonstrates that weak ties are positively related to higher wages and higher aggregate employment rates. \n\n'
p180
tp181
a(I-1
S':This article is about fashion victims (or fashionistas). For other uses, see [[Fashionista]].\nFashion victim is a term - claimed to have been coined by [[Oscar de la Renta]]<ref>According to John Fairchild, [Oscar and I] were sitting at the Caravelle and Oscar looked around and said, These people are absolute [[hell]], they look like [[fashion]] victims, and that was the first time anyone had used that expression. {{cite book| last =Coleridge| first =Nicholas| title =The Fashion Conspiracy | publisher =HarperCollins| date =1989| id = 0060916362 }}</ref> - that is used to identify a person who is unable to identify commonly recognized boundaries of [[Fashion|style]].  \n\nFashion victims are victims because they are vulnerable to [[fad]]dishness and [[materialism]], two of the widely recognized excesses of fashion, and consequently are at the mercy of societys prejudices or of the commercial interest of the fashion industry, or of both. According to [[Versace]], When a woman alters her look too much from season to season, she becomes a fashion victim.<ref>{{cite book  | last =Agins | first = Teri| title =The End of Fashion: How Marketing Changed the Clothing Business Forever  | publisher =Harper Paperbacks | date =2000| pages=116|id =  0060958200}}</ref>\n\n== Faddishness ==\nA [[fad]] is an intense but short-lived fashion trend. Fads are also by their nature at the extreme range of currently acceptable style, which means they commonly cross the line from the sublime to the ridiculous. Fashion victims can be seen to have crossed this line. (See [[Sarah Jessica Parker]] and [[Sex in the City]].)\n\n== Materialism ==\nKeeping up with fashion is often very expensive. Expensive clothes signal that the wearer is financially successful, but they are not necessarily [[Cool (aesthetic)|cool]] or fashionable.<ref> Michelle Lee notes that in order to appear casually well-dressed, shoppers pay extra for designers to sew on decorative patches, slash gaping holes into the knees of jeans and fray the hems.  {{cite book|last=Lee|first=Michelle| title =Fashion Victim: Our Love-Hate Relationship with Dressing, Shopping, and the Cost of Style | publisher =Broadway  | date =2003| id = 0767910486 }}</ref> \n\n{{Original research|date=August 2008}} \nDesigner labels have come to form an important part of our identification of style and fashion. We have all become accustomed to the social acceptance that comes with wearing the right brands. The labels have in many cases migrated from the inside of a garment to the outside. Common examples of this types of branding are [[Adidas|Adidas]], [[Kelme (company)|Kelme]], and other sports and leisurewear manufacturers.  A fashion victim, able to recognise this phenomenon but unable to determine its boundary, may become a walking billboard.<ref>{{cite book  | last =Agins | first = Teri| title =The End of Fashion: How Marketing Changed the Clothing Business Forever  | publisher =Harper Paperbacks | date =2000| pages=118|id =  0060958200}}</ref>\n\nDesigner [[brand]]ing is sometimes associated with a higher quality of manufacture and a more expensive price. The ownership and display of such products of quality is frequently [[Marketing|marketed]] to suggest that the wearer will automatically embody a personal characteristic of quality by association. Designers have identified this fact and in some cases are able to exploit this to the extent that prices can be escalated to surprising proportions without reference to the cost of manufacture. Extreme examples of this type of branding are found among accessory manufacturers such as [[Gianni Versace S.p.A.|Versace]], [[Gucci]] and [[Burberry]], scent manufacturers such as [[Chanel]] and [[Guerlain]] and watch manufacturers such as [[Rolex]] and [[Bvlgari]].<ref>{{cite book| last =Arnold | first =Rebecca | title =Fashion, Desire, and Anxiety| publisher = I B Tauris & Co Ltd  | date =2001| pages=43|id = 1860645550 }}</ref>\n\nFashion victims, by their characteristic inability to recognize boundaries, may aspire to the extreme end of what is available, seeking expensive products (or copies of these products), believing that the outward display of such items will draw admiration in proportion to their actual or apparent cost.  Because of this, the term fashion victim became the ultimate insult to the aspirational.<ref>{{cite book| last =Arnold | first =Rebecca | title =Fashion, Desire, and Anxiety| publisher = I B Tauris & Co Ltd  | date =2001| pages=10|id = 1860645550 }}</ref>\n\n'
p182
tp183
a(I1
S'{{Infobox Magazine|\n  title          = Meccano Magazine |\n  image_file     = Meccano Mag cover Feb1963.jpg |\n  image_size     = |\n  image_caption  = Meccano Magazine, February 1963 cover |\n  editor         = [[Frank Hornby]] (first)|\n  editor_title   = |\n  frequency      = monthly / quarterly |\n  circulation    = 70,000 / issue (1930s) |\n  category       = [[Hobby]] |\n  company        = [[Meccano Ltd]] |\n  publisher      = [[Meccano Ltd]] |\n  firstdate      = 1916 |\n  finaldate      = 1981 |\n  finalnumber    = |\n  country        = {{flag|England}} |\n  language       = [[English language|English]] |\n  website        = |\n  issn           = |\n}}\n\nMeccano Magazine was an [[English language|English]] monthly [[hobby]] [[magazine]] published by [[Meccano Ltd]] between 1916 and 1963, and by other publishers between 1963 and 1981. The magazine was initially created for [[Meccano]] builders, but it soon became a general [[hobby]] magazine aimed at boys of all ages. It remained in circulation for over sixty years.\n\n==History==\nThe magazine was launched by [[Frank Hornby]], the inventor of [[Meccano]], as a bi-monthly publication in 1916 in the [[United States]] as Meccano Engineer, and was a month ahead of the [[United Kingdom|UK]] issue. The first copies were given away free but in 1918 readers had to pay two [[Penny|pence]] for postage for four issues.<ref> {{cite web |url=http://www.geocities.com/Area51/Corridor/6981/TMG_files/history_files/meccano_early_years/meccano_the_early_years.htm |title=Meccano, The Early Years |work=Transvaal Meccano Guild |accessdate=2007-07-18}} </ref>\n\nIn 1917 and again in 1932, Hornby published a history of [[Meccano]], its manufacture and marketing in the magazine. In 1919 it doubled its size to eight pages and now cost one penny. New Meccano parts were advertised for the first time in 1920 and in 1922 the magazine became a monthly publication. From the May 1924 issue, the magazine had full-colour covers, and the December 1924 issue was 96 pages, costing six pence. By the 1930s Meccano Magazine had a circulation of 70,000.\n\nDuring the [[World War II|Second World War]] the content and quality of the magazine was reduced greatly, and the size decreased from approximately [[A4 paper size|A4]] to [[Paper size|A5]]. The A5 pocket-size format remained until 1961 when it was increased again to A4.\n\nIn 1963 the magazine started reporting a loss and [[Meccano Ltd]] handed its publishing over to its printers, Thomas Skinner. In August 1967 Thomas Skinner terminated production of the magazine and passed the magazine on to [[Model & Allied Publications]] (MAP) of [[Hemel Hempstead]] in 1968.<ref> {{cite web |url=http://www.zeteo.com/mar/news-jan05.ihtml |title=Model Auto Review News, January 2005 |work=Model Auto Review |accessdate=2007-07-18}} </ref> At the end of 1972 publication stopped due to a decline in popularity.\n\nIn April 1973 it was resurrected again, this time as a quarterly magazine, and from 1977 it incorporated Meccano Engineer and the Meccanomans Journal. Meccano Magazines last issue was [[Spring (season)|Spring]] 1981.\n\n==Content==\nMeccano Magazine was originally aimed at [[Meccano]] builders and featured articles on Meccano construction and new Meccano developments. When Frank Hornby launched the Meccano Guild in 1919, the magazine carried regular Guild news to keep Meccano clubs informed of each others activities. But over time Meccano Magazine became a general [[hobby]] magazine aimed at boys of all ages. Aside from Meccano related articles, it also featured [[Hornby Railways|Hornby]] trains, [[Dinky Toys]] and other products of [[Meccano Ltd]], plus a wide variety of general interest articles, including, [[engineering]], aircraft, trains, modelling, camping, [[photography]] and [[philately]]. [[Commonwealth_of_England|Commonwealth]] countries always featured strongly in articles as Meccano Ltd exported its products to these countries.\n\nThe magazines today are an excellent source of historic information and an invaluable aid to collectors of toys from those years. They have also become [[collectors item]]s and there is a healthy trade in them at [[auction]]s.\n\n'
p184
tp185
a(I-1
S'The Parents Preference Test  the PPT (Westh, 2003a, 2003b)  is a parenting style test completed in 2003. Its purpose is to map parents notion of their own parenthood, disclosed through central dimensions of parenting styles. The test is a picture-based multiple-choice test with 24 items. Each item consists of a large theme picture (enabling the respondent to perceive whether the situation presented concerns e.g. a picnic or cooking at home) followed by four smaller selection pictures  where the respondent is required to choose the one picture most aptly representing the behavior she/he would exhibit in a corresponding setting, and to verbalize her/his reasons for choosing.\n\nThe respondents selections are then coded in relation to the four dimensions used in the PPT: Energy, Focus of Attention, Experiential Modality, and Regulation Style. (Westh, 2006)\nEnergy is described here as a continuum ranging from Active to Passive/expectant in relation to the child: Is it Daddy suggesting a ball game (Active), or is he waiting for his sons request, with which he is happy to comply (Passive  in the most positive version of this behavioral mode)?\n\nThe continuum of Focus of Attention concerns the object of this focus: Are you paying attention mostly to your child (Paedoptic focus) or to yourself (Autoptic focus)?\n\nThe third dimension deals with Experiential Modality, which within the PPT framework goes from Emotional to Rational.\n\nFinally, there is Regulation Style, where light is attempted shed on the favored aspect of ones child raising behavior: the Precepts or the Context.\n\n\nOn the basis of these four perspectives, a parenting style profile is generated. This profile may be combined with family interaction observations, thorough analysis of the reasons offered by the respondents for their selections, and the use of other tests, in order to provide the starting point for the psychologists future sessions with the parents  and, if appropriately, at a later date also with the familys network  in order to arrive at an understanding of the most appropriate actions of everyone involved with the child.\n\nTheoretically, the four dimensions are seen as interpersonal personality functions, and have the four dimensions described by [[Theodore Millon]] as their basis  with the pleasure-pain axis having been replaced with the Regulation axis, since parenting is the one human activity which involves less focus on ones own pleasure/pain, focusing instead on navigating in the infinitely more complex field of balancing the childs needs and desires and ones own needs and desires (Ferrer, 2006a).\n\nThe PPT has been subjected to rigorous testing, which is supposed to ensure interrespondent reliability as well as dimensional construct validity (calculated by means of log-linear Rasch analyses). (Westh, 2006)\n\nThe test and the subsequent research around it has been developed and described by a group of Danish psychologists led by the experienced family therapist Finn Westh, and including Lise-Lotte Westh; Soren Kronberg (focusing on the psychodynamic angle a.m. Stern); Carsten Rosenberg Hansen (focusing on the psychometric angle); and Christian A. Stewart Ferrer (focusing on the cognitive and systemic-narrative angles).\n\nSo far, it has been used as a basis for an advanced family therapy program (Westh, 2004; Ferrer, 2006b); for child custody evaluations; for parental competency examinations (Ferrer & Lumholt, 2005); for caregiving style profiles in regard to treatment facilities for children and adolescents; and for working with foster families. At present, only Danish norms exist; however, Israeli and Italian norms are being collected (as of May, 2008). The test has been presented at [http://www.wewe.dk/English/PPT.htm international conferences], which may in the future lead to more norms being prepared.\n\n\n'
p186
tp187
a(I-1
S'Jeff Strain is a [[game programmer]] and one of the three founders of [[ArenaNet]]. He served ArenaNet and [[NCsoft]] as the leader of the Art and Production teams and President of Product Development respectively. He was previously the lead programmer of [[Blizzard Entertainment|Blizzards]] [[MMORPG]] [[World of Warcraft]]; he also created the [[StarCraft]] campaign editor and worked on [[Diablo (computer game)|Diablo]] and [[Warcraft III]]. He is credited as a programmer and executive producer for [[Guild Wars]].\n\nHe left NCsoft in August 2009 under amicable terms with the company<ref>[http://uk.gamespot.com/news/6215166.html?tag=latestheadlines;title;1]</ref>.\n\n'
p188
tp189
a(I-1
S'{{pp-semi-vandalism|small=yes}}\n\n{{wiktionary}}\n{{for|the EP by My Bloody Valentine|Geek!}}\n{{for|the film|Geeks (2004 film)}}\nThe word geek is a [[slang]] term, noting individuals as a peculiar or otherwise odd person, especially one who is perceived to be overly obsessed with one or more things including those of intellectuality, electronics, etc.<ref>{{cite web|url=http://dictionary.reference.com/browse/geek|title=Dictionary: Geek|date=|accessdate=2007-10-12|work=Dictionary.com-Merriam-Webster entry}}</ref> Formerly, the term referred to a carnival performer often billed as a wild man whose act usually includes biting the head off a live chicken, bat, snake or bugs. The 1976 edition of the [[American Heritage Dictionary]] included only the definition regarding [[geek show]]s. \n\nThis word comes from English dialect geek, geck: fool, [[freak]]; from Low German geck, from Middle Low German. The root geck still survives in Dutch gek: crazy, and in the [[Alsace|Alsatian]] word Gickeleshut: geeks hat, used in carnivals.<ref>[http://fr.wikipedia.org/wiki/Geek French Wikipedia Geek Article]</ref>\n\n==Definitions==\nThe definition of geek has changed considerably over time, and there is no longer a definitive meaning. The terms [[nerd]], [[gimp]], [[dweebs|dweeb]], [[wikt:dork|dork]] and [[wikt:spod|spod]] have similar meanings as geek, but many choose to identify different connotations amongst these terms, although the differences are disputed. In a 2007 interview on [[The Colbert Report]], [[Richard A. Clarke|Richard Clarke]] said the difference between nerds and geeks is geeks get it done.<ref>[http://www.ifilm.com/episode/18527/startsWith/2814949?cmpnid=800&lkdes=VID_2814949 The Colbert Report - 2007 Archive - 1/17/07 - Television - SPIKE Powered By IFILM<!-- Bot generated title -->]</ref> Julie Smith defined a geek as a bright young man turned inward, poorly socialized, who felt so little kinship with his own planet that he routinely traveled to the ones invented by his favorite authors, who thought of that secret, dreamy place his computer took him to as cyberspace&mdash;somewhere exciting, a place more real than his own life, a land he could conquer, not a drab teenagers room in his parents house.<ref>[http://reconstruction.eserver.org/061/christensen.shtml Reconstruction 6.1 (Winter 2006)<!-- Bot generated title -->]</ref>\n\nOther definitions include:\n*A derogatory reference to a person obsessed with intellectual pursuits for their own sake, who is also deficient in most other human attributes so as to impair the persons smooth operation within society.\n*A person who is interested in [[technology]], especially [[computing]] and [[new media]]. Geeks are adept with computers, and use the term [[Hacker (computing)|hacker]] in a positive way, though not all are hackers themselves.\n*A person who relates academic subjects to the real world outside of academic studies; for example, using [[multivariate calculus]] to determine how they should correctly optimize the dimensions of a pan to bake a cake.\n*A person who has chosen concentration rather than conformity; one who passionately pursues skill (especially technical skill) and imagination, not mainstream social acceptance. \n*A person with a devotion to something in a way that places him or her outside the mainstream. This could be due to the intensity, depth, or subject of their interest. This definition is very broad but because many of these interests have mainstream endorsement and acceptance, the inclusion of some genres as geeky is heavily debated. Persons have been labeled as or chosen to identify as [[physics]] geeks, [[mathematics]] geeks, [[engineering]] geeks,  [[sci-fi]] geeks, [[computer]] geeks, various [[science]] geeks, [[movie]] and [[film]] geeks ([[cinephile]]), [[comic book]] geeks, [[theatre]] geeks, [[history]] geeks, [[music]] geeks, [[art]] geeks, [[philosophy]] geeks, [[literature]] geeks, [[historical reenactment]] geeks, [[2012 phenomenon|2012]] geeks, [[video game]] geeks, and [[roleplay]] geeks.\n*A more recent school of thought sees Nerd as being a derogatory phrase, whilst Geek is simply a description. It is taken to be someone who is an enthusiast, often in things outside of the mainstream spectrum, of note is that in this definition, there is no reference to being socially inept in the slightest.\n\n==Reclamation and self-identification==\nAlthough being described as a geek tends to be an insult, the term has recently become more complimentary, or even a badge of honor, within particular fields. This is particularly evident in the technical disciplines, where the term is now often a compliment, denoting extraordinary skill. [[Nerd Pride Day]] has been observed on [[May 25]] in [[Spain]] since 2006. (May 25 being the world premiere date of [[Star Wars]] and also [[Towel Day]] i.e. Birthday of [[Douglas Adams]]) The holiday promotes the right to be nerdy or geeky, and to express it in public without shame. A new convention, [[Geek.Kon]], has sprung up in Madison, Wisconsin with a purpose to celebrate all things geek. The website [[BoardGameGeek]] is an online community of boardgamers who identify themselves as geeks at game conventions; they call their website The Geek, for short. Technical support services such as [[Geek Squad]], [[Geeks on Call]] and [[Dial-a-Geek]] use the term geek to signify helpful technical abilities. In recent history, some geeks have cultivated a geek culture, such as [[geek humor]] and obscure references on T-shirts. The so-called [[geek chic]] trend is a deliberate affectation of geek or nerd traits as a fashion statement. Nonetheless, the derogatory definition of geeks remains that of a person engrossed in his area of interest at the cost of social skills, personal hygiene and status.\n\n==Geek chic==\n[[Image:Stepherrorwear114.jpg|thumb|right|[[Stephanie Pakrul]], or StephTheGeek, a blogger. The t-shirt displays the [[Blue Screen of Death|blue screen of death]], an [[in-joke]] to those who are familiar with [[Microsoft Windows]].]]\nGeek chic refers to the embracing of stereotypically unpopular geek characteristics such as (taped) [[glasses]], [[comic book]]s, and [[video game]]s. \n\nIt is highly debatable whether this trend actually means that real geeks are more popular than they were previously, or if it merely represents a superficial addition of [[nerdy]] elements to current fashion trends. Many elements that arguably define geekiness, such as varying degrees of social awkwardness, [[mathematic]]al ability, strong interest in [[science]] and/or [[science fiction]] and [[fantasy]], and varying degrees of disinterest in ones [[personal appearance]], remain unfashionable.{{Fact|date=February 2008}} Similar trends have often occurred in the past; for example, [[France|French]] [[Orientalism]] and [[exoticism]] of the 19th century incorporated visual elements from Asian and African cultures, but did not necessarily imply that people from these cultures were themselves viewed as fashionable.\n\nSome{{Who|date=February 2009}} agree that the concept was born sometime during the mid 1990s; there is no consensus as to who originated it and where. It is often assumed that it was created by real geeks in an attempt to suppress their widely perceived public image as dull, introverted, and academic. However, there is a noticeable lack of prominent representatives in science and other geek-oriented professions who visibly sport geek chic images. Most, if not all, celebrity exponents of geek chic have emerged from the entertainment field. Actor [[David Tennant]], the [[Tenth Doctor]] in [[Doctor Who]], has described the look of his character as geek chic.<ref>[http://www.bbc.co.uk/doctorwho/news/cult/news/drwho/2005/07/25/20751.shtml BBCs Doctor Who News: Filming starts].</ref>\n\nAside from (taped) eyeglasses, it is also debatable as to whether the geek chic fashion actually borrows at all from the stereotypical geek image which is based on lack of fashion sense, or more specifically an overtly studious, academic appearance, hence the so-called [[Poindexter]] look. Instead, much of the geek chic image borrows from various alternative youth fashions such as [[emo]], [[goth subculture|goth]], [[hippie]], and [[Bohemianism|bohemian]] amongst others. Then again, t-shirts with computer programming in-jokes seems to originate from the widespread Hollywood depiction of [[Silicon Valley]] employees and other computer geeks. This exaggeration is based on the more casual dress code in place in many such companies although in reality, this is still mostly limited to business-appropriate attire.{{Fact|date=February 2008}}\n\n'
p190
tp191
a(I-1
S'{{Refimprove|date=June 2008}}\n{{Globalize/Eng}}\n{{otheruses|Fan translation}}\n[[Image:Top-develshot4.jpg|thumb|320px|Fan translation being done from [[English language|English]] into [[Finnish language|Finnish]] for the game, [[Tales of Phantasia]], using the [[Japanese language]] version as reference.]]\nA fan translation, in video gaming, refers to an unofficial [[translation]] of a [[Personal computer game|computer game]] or [[video game]]. \n\nThe fan translation practice grew with the rise of [[video game console]] [[Console emulation|emulation]] in the late 1990s. A community of people developed that were interested in replaying and modifying the games they played in their youth. The knowledge and tools that came out of this community allowed them to work with translators to [[Software localization|localize]] titles that had never been available outside of their original country of origin.\n\nFan translations of video game console games are usually accomplished by [[ROM hacking|modifying a single binary ROM image]] of the game. Fan translations of [[Personal Computer|PC]] games, on the other hand, can involve translation of many binary files throughout the games [[Directory (file systems)|directory]]. In dealing with translations of console games, a [[console emulator]] is generally utilized to play the final product, although game copiers or similar devices can be used to run the translated ROM image on its native hardware.\n\n==Purpose==\nThe central focus of the fan translation community is historically of Japanese-exclusive computer and video games being made playable in [[English language|English]] for the first time, and sometimes of games recently released in Japan that are import-worthy and are unlikely to be officially localized to English speaking countries. It has since expanded to include other languages as well. Fan translations to English have provided a starting point for translations to many other languages.\n\nFan translations may also be done to titles that have received official localizations that fans perceive as flawed; for example, if the game had controversial content removed (such as [[Bionic Commando (NES)|Bionic Commando]]), or there were unnecessary changes in plot and character names (such as [[Phantasy Star]]).\n\nThe fan translation community was at its most popular, and attracted the most media attention, when certain popular game titles were still being worked on. These were usually parts of popular series such as [[Square Enix]]s [[Final Fantasy]]. Some consider the peak was reached with the translation of [[Seiken Densetsu 3]], a title that was highly desirable to RPG players and also very difficult to translate on a technical basis.\n\n==Origins==\n\nThe earliest fan translations were done by Oasis, a group formed by Dennis Lardenoye and Ron Bouwland, two Dutch fans of the [[MSX]] system. [[Konami]]s RPG [[SD Snatcher]] was translated in April 1993, and [[Dragon Slayer: The Legend of Heroes|The Legend of Heroes]] was translated in 1995. Their other projects include Fray, Rune Master 3, Xak - The Art of Visual Stage, Xak 2, Xak - The Tower of Gazzel, Ys, Ys II: The Final Chapter and Wanderers From Ys.\n\nThese were possible before emulation on PCs became popular (or even adequate enough to play games) because the games were on [[floppy disks]], and were therefore easier to distribute to the users, in comparison to [[Read-only memory|ROM]] cartridges used by video game consoles (the MSX also used cartridges, but methods were discovered to copy the content onto floppy disks and other media too).\n\n==Revival after emulation==\n\n[[Image:FF5 trans compare.png|frame|right|RPGes translation of [[Final Fantasy V]] was one of the early major fan-translated works. Original Japanese is on the left; RPGes translation is on the right.]]\n\nThe development of console emulators led to access to foreign video games.  A revival began in 1996 when a group calling themselves Kowasu Ku formed under the lead of one Hazama. The group stated plans to translate [[Final Fantasy V]], but their efforts were never publicly released. Later that summer, a user called Demi announced work on a Final Fantasy V translation and founded Multiple Demiforce. It was eventually dropped in favor of Final Fantasy II (NES), a more manageable goal at that time. Demi and Som2Freak used Pasofami to post four screenshots of their work to Archaic Ruins, an emulation website. Shortly after, the translation stalled and the group disbanded.\n\nDerrick Sobodash and David Timko both saw the Archaic Ruins website and contacted Som2Freak expressing interest in translating Final Fantasy V. He provided each with some primitive tools, and for the next few months, Shadow and Timko worked against each other. Both projects generated renewed interest in fan translation.\n\nAfter months of working against each other, Shadow and Timko began cooperating.<ref>[http://www.classicgaming.com/emunews/june97.htm EMU News Service (June 97) David Timko and Shadow Join Forces for FFV Translation!]</ref> RPGe, the first major translation group was established on July 8 in the #ff5e [[IRC]] channel, on the EsperNet IRC network by Shadow, Timko, Hooie and Thermopyle.<ref>[http://www.classicgaming.com/emunews/july97.htm EMU News Service (July 97) New SNES Translation Group Formed]</ref> The start of RPGe sparked many other efforts to unify and within months, Translation Corporation, DeJap Translations and Starsoft Translations had formed.\n\nRPGes translation of Final Fantasy V was completed October 16, 1997 (version 0.96).<ref>[http://www.classicgaming.com/emunews/october97.htm EMU News Service (October 97) Final Fantasy 5]</ref>\n\n== Community hubs ==\n\nThe first hub of the fan translation community was The ROM Hack Board, hosted by Demi on Frognet. The board began in fall of 1996 operating on the Matts WWWBOARD script. It reappeared later in 1997.\n\nEarly community news was posted to emulation websites such as EMU News Service, now archived by ClassicGaming.<ref>[http://www.classicgaming.com/emunews/ EMU News Service closed paged]</ref> It wasnt until July 8, 1998 that Cataclysm-X, Jason Li and WildBill opened RPG Dimension (also known as RPGd), a site dedicated to reporting fan translation news as well as releases of general [[ROM hacking]] tutorials and utilities.<ref>[http://rpgd.emulationworld.com/ RPG Dimension]</ref>\n\nRPG Dimension met competition on March 31, 2000 when Spinner 8 and (wraith) opened The Whirlpool, a rival news site focusing exclusively on fan translations. The former met a slow death over the next two years as staff lost more and more interest in updates. The Whirlpool eventually closed on October 4, 2005 following from a dispute between the sites founders, though site owner (wraith) assured users he was working on another project to supersede the old site. Updates ceased by December 27.<ref>[http://donut.parodius.com/ The Whirlpools final update]</ref>\n\nThe English fan translation community is currently centered at ROM Hacking.net.<ref>[http://www.romhacking.net/ ROM Hacking.net]</ref>\n\n==Legal issues==\nWhile unauthorized fan translations are indisputably illegal (Article 8 of the [[Berne Convention for the Protection of Literary and Artistic Works|Berne Convention]] explicitly reserves the right of translation to the copyright holder and whoever receives permission of them, saying Authors of literary and artistic works protected by this Convention shall enjoy the [[exclusive right]] of making and of authorizing the translation of their works throughout the term of protection of their rights in the original works.), it is unusual for copyright holders to object. This is probably largely because the electronic games in question are generally not considered commercially viable in the target language, so the translation is rarely seen as a source of lost revenue.\n\nHowever, in 1999, one well-known incident in which copyright holders took action involved the translation of a Windows game maker called RPG Maker 95. The Japanese company [[ASCII (company)|ASCII]] had their [[lawyer]]s send a cease and desist e-mail to the translation group KanjiHack Translations. The group shut down immediately but others eventually finished the project. Titles from the [[RPG Maker]] series were eventually localized and officially released in the US for the [[PlayStation]] and [[PlayStation 2]].\n\nA popular belief in the fan translation community is that distributing only a binary patch, which must be applied to the full, original game, is legal. The reasoning is that the patch only contains the new data and directives for where it is to be placed, and does not have the original copyrighted material included in any form, and therefore it is useless unless the user applies it to a (copyrighted) ROM, the acquisition and legality of which they are left completely accountable for. This belief, while untested in court, is probably not supported by international copyright law {{Fact|date=June 2008}}, as the patch must still contain a translated script that is derived from the copyrighted script of the original, but this anti-[[Copyright infringement of software|software piracy]] attitude by the fan translation community may have convinced copyright holders to, by and large, [[turn a blind eye]].\n\nThere have never been any legal cases involving fan translation issues, and such projects have been relatively widespread over the Internet for years. In recent years, anime [[fansub]]bers have started to attract the attention of some American anime distributors; and as of 2004 one manga [[scanlation|scanlator]] has been handed a cease and desist by a Japanese company, but most of this attention has been restricted to polite entreaties asking fan translators to refrain from dealing with licensed material. As with the fansub and scanlation scenes, most sites devoted to translation hacks will not acknowledge projects that compete with commercially available localizations, and respected groups will steer clear of projects that may see localization. These estimations are sometimes wrong, however; a fan-translation of [[La Pucelle]] was terminated after a partially complete release when the game was announced for a North American release years after its Japanese debut.\n\n==Game company acknowledgments==\nOn [[July 12]], [[2007]], [[RPGamer]] released an interview they did with Koichiro Sakamoto, a game producer from Square Enix, acknowledging fan translations: \nOn a similar note, we told Mr. Sakamoto that a fan translation had been done some years ago for Front Mission 1, and asked how he felt about such efforts. The producer replied that he actually found them very encouraging -- its something the developers should be doing, but because theyre not, the fans are doing it instead. He stated that hed like to be able to give something back to the fans, and would like to thank personally each of the fans that worked on the translation.<ref>[http://www.rpgamer.com/news/Q3-2007/071207a.html RPGamer E3 - Front Mission Interview]</ref> In response to the fan translation of [[Mother 3]], gaming industry professionals sent translator Clyde Mendelin messages of support.<ref>{{cite web |title=You Say Tomato: A Pro on Fan-Translating Nintendos Mother 3 |url=http://www.gamasutra.com/view/feature/3891/you_say_tomato_a_pro_on_.php |publisher=[[Gamasutra]] |accessdate=2009-08-10 |date=2008-12-26}}</ref>\n\n'
p192
tp193
a(I1
S'{{Infobox Defunct Company\n| company_name     = Ral Partha Enterprises, Inc.\n| company_logo     =<!-- Deleted image removed:  [[Image: Partha logo.png]] -->\n| fate             = Melted & Recast\n| successor        = [[Iron Wind Metals, LLC.]]\n| foundation       = 1975\n| defunct          = 2001\n| location         = [[Cincinnati]], [[Ohio]], [[United States|U.S.]]\n| key_people       = Sculptors:<br/> [[Tom Meier]]<br/>[[Dennis Mize]]<br/>[[Julie Guthrie]]<br/>[[Bob Charrette]]<br/>[[Sandra Garrity]]<br/>[[Richard Kerr]]<br/>[[Dave Summers]]<br/>Presidents:<br/>[[Glenn E. Kidd]]<br/>[[Chuck Crain]]<br/>[[Jack Hesselbrock]]\n| industry         = [[Wargaming]]<br/>[[Role-playing game]]s\n| products         = [[Miniature figure (gaming)|miniature figures]]\n}}\n\nRal Partha Enterprises, Inc. of [[Cincinnati, Ohio]] produced 25mm, 30mm, 15mm, and 54mm scale [[miniature figure (gaming)|miniature figures]] between 1975 and 2001. Their products were manufactured by [[spin-casting]] and depicted soldiers, adventurers and monsters inspired by history and fiction. The miniatures were sold at gaming conventions, in hobby shops, and by mail order for use in [[role playing game]]s, [[wargaming]], dioramas, competitive painting, and collecting. The company was founded by five historical wargamers around the talents of [[Tom Meier (miniature sculptor)|Tom Meier]], a 16-year old sculptor. The company grew with the increasing popularity of miniature gaming and is best known for its historical figures, Fantasy Collectors series of [[elves]], [[dwarf (mythology)|dwarves]] and [[goblins]], and the lines produced for [[TSR, Inc.]]s [[Advanced Dungeons & Dragons]] and [[FASA Corporation|FASA]]s [[BattleTech]] games. Unless otherwise noted, the designs discussed below were produced in 25mm scale.\n\n[[Tom Meier]] became a freelance sculptor in 1988, but retains rights to much of his work for Ral Partha. He currently works on commission and operates [[Thunderbolt Mountain Miniatures]], a boutique company for pet projects involving dioramas, 54mm figurines, and a new series of [[elves]] and [[goblins]]. During its 26-year history Ral Partha employed more than two dozen sculptors, of whom the most prolific were [[Dennis Mize]], [[Julie Guthrie]], [[Sandra Garrity]], [[Bob Charrette]], and [[Dave Summers]]. The owners of Ral Partha Enterprises, Inc. sold the company to [[FASA Corporation|FASA]] in 1998, and was one of the assets acquired by [[Wizards of the Coast]] in 2000. The following year Ral Partha was recast as [[Iron Wind Metals LLC.]] of [[Cincinnati, Ohio]] who continues to produce many of the old lines.\n\n==Licensees and Distributors==\n\nAs early as 1979 [[Citadel Miniatures]] acquired the license to produce and distribute Ral Partha figures in Britain<ref name = WD11>White Dwarf #11, February/March 1979.</ref><ref name = GW84>Citadel Compendium 1, Games Workshop 1984</ref>. [[Citadel Miniatures]] attempted to establish a U.S. division in 1982 with Ral Partha as the local manufacturer<ref name = D82/><ref name = C83>Citadel Miniatures U.S. 1983 Catalog.</ref>. However, by 1984 the [[Citadel Miniatures]] were brought under the Ral Partha logo and marketed as Ral Partha Imports<ref name = RP84I>Ral Partha Enterprises, Inc. 1984 Imports Catalog.</ref>. In 1985 the import lines included the FTx-xx Fantasy Tribes, FAx-xx Fantasy Adventurer, FF/31-xxx Fiend Factory, FS/32-xx Fantasy Special, the popular WF-xx Weird Fantasy series with whimsical themes, FMM-xx Fantasy Mysterious Miniatures, and LB-xx Tabletops Laser Burn line of [[space marines]]. Historical lines included Romans AR-xx, Dark Ages DA-xx, Medievals M-xxx and Samurai SAM-xx<ref name = RP85H/>. At least two figures (FTT 3 Troll hurling rock and FTT 4 Troll in chainmail with scimitar) were sculpted by [[Tom Meier]] while visiting England in 1981<ref name = W24>White Dwarf #24, April/May 1981</ref>. \n\nThe co-operative relationship between Ral Partha and [[Citadel Miniatures]] appears to have dissolved in the mid-1980s. Collectors have noted that as early as 1984 Ral Partha had begun replacing the Citadel figures in the Imports line with new sculpts<ref name = Stuff1>[http://www.cs.cmu.edu/~tpope/sol/ral-partha/history.html], Stuff of Legends, Ral Partha History, Accessed January 10, 2009.</ref>. In 1986 [[Miniature Figurines Production|Minifigs]] gained the rights to manufacture and distribute their fantasy range in Britain<ref name = Minifigs1> [http://www.miniaturefigurines.co.uk/About.aspx], History of Miniature Figurine Production, Accessed December 7, 2008.</ref>. The following year Ral Partha dropped [[Citadel Miniatures]] historical lines and began to distribute [[Denizen Miniatures]] [[dwarf (mythology)|dwarves]] (33-xxx), [[orcs]] (34-xxx), 36-xxx Legion of the Damned skeletons and 39-xxx Fantastic Adventurers<ref name = RP87/>.\n\nIn 1980 Ral Partha licensed select designs to [[Rawcliffe Pewter]] for the gift-ware market <ref name = Tom/>. That same year Ral Partha established a licensing agreement with [[RAFM]], a Canadian miniatures manufacturer<ref name = D36>Ral Partha Advertisement, Dragon Magazine #36, April 1980.</ref>. It was probably about that time, and at least by 1989 that [[Jeux Descartes]] of [[Paris]], [[France]] gained the rights to distribute Ral Partha figures in Continental Europe<ref name = D144>Through the Looking Glass by Robert Bigelow, Dragon Magazine #144, page 73.</ref><ref name = RP91>Ral Partha Enterprises, Inc. 1991 Catalog.</ref>. Some early Ral Partha advertisements give the name as Jeaux Descartes. The relationship was on-going in 1997<ref name=RP97>Ral Partha Enterprises, Inc. 1997 Catalog.</ref>, but was probably severed when [[FASA Corporation|FASA]] purchased Ral Partha the following year. \n\n==Product Codes==\n\nOnly a product code marked Ral Parthas early packaging and customers required a contemporary catalog in order to identify the miniature. In late 1979 the company switched from product codes using descriptive letter and number codes to a numeric system. For example the first figures of the series Personalities and Things that Go Bump in the Night, ES-001 Evil Wizard, casting spell became 01-001, and the first figure of the 15th century Renaissance series 1501 Command Set became 54-001<ref name = RP78>Ral Partha Enterprises, Inc. 1978 Catalog.</ref><ref name = RP79>Ral Partha Enterprises, Inc. 1979 Catalog.</ref><ref name = RP80>Ral Partha Enterprises, Inc. 1980 Catalog.</ref>. The change was not universal. Ral Partha used letter codes for [[Citadel Miniatures]] and [[Denizen Miniatures]] in their line of Ral Partha Imports until 1992<ref name = D82>Ral Partha Advertisement, Dragon Magazine #82, February 1984.</ref><ref name=RP84I/><ref name = RP92>Ral Partha Enterprises Inc. 1992 Catalog.</ref>. Ral Parthas international partners used their own systems. [[RAFM]] of [[Canada]] used the descriptive product codes as late as 1984<ref name =  D90>RAFM advertisement in Dragon Magazine #90, October 1984.</ref>. [[Jeux Descartes]], initially used Ral Parthas numeric codes on packaging of their own design for blisters and early box sets. However, new lines were introduced selectively and given sequential codes which differed from those used in the United States. \n\nThroughout the companies history, figures were modified to improve reproducibility, unpopular designs were re-sculpted, and existing product codes were used for new designs. A common cause of modification was a level of detail or animation which challenged the casting technology. An industry-wide reorientation of scale from 25mm to 30mm in the late 1990s, and interest in removing lines from artists royalties, also prompted new sculpts of existing lines.\n\nFew of Ral Parthas miniatures were marked with product codes and the companys advertisements and catalogs remain a critical resource for collectors. Advertisements by Ral Partha  and its British and Canadian partners appear in most editions of [[TSR Inc.]]s Dragon and [[Games Workshop]]s White Dwarf magazines. Annual catalogs were published between 1978 to 1980, 1982 to 1987, and in 2000. There does not appear to have been a 1981 catalog. The 1980 catalog was delayed to the end of the year by the companys relocation to Carthage Court<ref name = RP80/>, and the collage of past covers on the 1995 20th Anniversary catalog does not include an image for that year<ref name = RP95>Ral Partha Enterprises, Inc. 1995 Catalog.</ref>. The 1985 catalog was split in two, one for fantasy and science fiction miniatures and another for historical games. In addition, Ral Partha released Christmas catalogs in 1982 and 1983, Imports catalog in 1984, 1996 historical catalog, combined 1998/1999 catalog, 2000 Direct Mail Catalog, and numerous order forms which contain all the figures in production.\n\n==History==\n\nRal Partha Enterprises was formed in 1975 by 16-year-old wunderkind sculptor [[Tom Meier (miniature sculptor)|Tom Meier]], Jack Hesselbrock, Marc Rubin, Rich Smethurst, Glenn E. Kidd, and Chuck Crain in order to produce Meiers figures. Meier pioneered the sculpture of miniatures in [[E-Pox-E Putty]], a two-part ribbon epoxy designed for automotive repair, which held detail better than traditional media<ref name = Carin>[https://www.thunderboltmountain.com/bio.html], Tom Meier Biography by Carin Meier, Accessed November 23, 2008</ref>. The company was a fusion of the established hobby of historical wargaming and the growth of role-playing games among young people. The company was named after Ral-Partha a [[Dungeons & Dragons]] [[Wizard (Dungeons & Dragons)|wizard]] created by Toms young friend John Winkler. Like their popular line of 3-stage characters, Ral Partha has had a trio of aspects. The first was a Winklers gaming character, depicted as ES-001 Evil Wizard, casting spell. Then as Ral Winkler himself, who became the companys chief caster. Lastly, Ral was the companys totemic progenitor credited with collaborative projects and depicted as 10-412 Lord of the Balrogs<ref name = RP86>Ral Partha Enterprises, Inc. 1986 Catalog.</ref><ref name = Club1>Ral Partha Gaming Club Newsletter Issue #1 June 30, 1996.</ref>.\n\nProducts were originally cast in the basement of 3642 Hyde Park Avenue, [[Cincinnati, Ohio]], the home of one of the owners<ref name = Club1/><ref name = D4>Ral Partha Advertisement, Dragon Magazine #4, March 1977.</ref>. In the spring of 1978 the company relocated to 3726 Lonsdale Avenue<ref name = D16>Ral Partha Advertisement, Dragon Magazine #16, July 1978.</ref>, and then was briefly at 2732 Lonsdale Avenue<ref name = RP78/>. By November 1980 Ral Partha had relocated to industrial space at 5938 Carthage Court, where it remained until 2001<ref name = RP80/><ref name = D43>Ral Partha Advertisement, Dragon Magazine #43, November 1980.</ref><ref name = RP00> Ral Partha Enterprises, Inc. 2000 Catalog.</ref>.\n\nRal Parthas formative years were the late 1970s, when the company was a part-time basement enterprise producing the art of a teen-age sculptor for a nascent gaming market. In 1979 the company became a full-time endeavor with two professional sculptors designing products for multiple themes made popular by the rapidly expanding gaming market. The number of sculptors and catalog of miniatures grew rapidly. In the mid-1980s the preponderance of work moved from Ral Parthas sculptors lines to manufacturing for nationally-marketed games. In the short-run the move was economically beneficial. However, the lack of product diversity left the company vulnerable to the marketing decisions of clients for whom miniatures were a minor interest. Ral Parthas final years were spent as a subsidiary of large game producers, until the core of the company was recast as Iron Wind Metals in 2001.\n\n===Elves and Hoplites, 1975-1978===\n\nThe young company received early encouragement from the sale of its entire stock at [[Gen Con]] 1975, a convention of gaming enthusiasts<ref name = Club1/>. Ral Parthas lines and customer base grew quickly and they regularly won multiple categories of the [[Origins Award]]<ref name = Orig>[http://www.originsgamefair.com/], Origins Game Fair, Accessed November 24, 2008.</ref>. Ral Parthas figures were popular with historical [[wargamer]]s, but fans of fantasy themed [[role-playing games]], like [[TSR Inc.]]s [[Dungeons & Dragons]] accounted for the majority of their sales<ref name = Tom> [https://www.thunderboltmountain.com/autobio.htm], Tom Meier Autobiography, Accessed November 23, 2008.</ref>. Meiers sculpts tended to carry greater detail than many of his contemporaries, but some early products had casting issues<ref name = D3>Wargaming World, Dragon #3, October 1976</ref>.\n\nOne of Tom Meiers earliest lines was  the Fantasy Line which included about two dozen figures in late 1976<ref name = D4/><ref name = D3/>. Meiers ES18 Adventuress is credited as being the first female character for role-playing games<ref name=D8>From the Fantasy Forge, Dragon Magazine #8, July 1977.</ref>. The fantasy line was renamed ES/01-xxx Personalities and Things that Go Bump in the Night in 1978, and Meier augmented the line throughout the 1980s<ref name = RP87>Ral Partha Enterprises, Inc. 1987 Catalog.</ref><ref name=RP78/><ref name = RP86/><ref name = RP82>Ral Partha Enterprises, Inc. 1982 Catalog.</ref><ref name = RP83>Ral Partha Enterprises, Inc. 1983 Catalog.</ref><ref name = RP84>Ral Partha Enterprises, Inc. 1984 Catalog.</ref><ref name = RP85F>Ral Partha Enterprises, Inc. 1985 Fantasy Catalog.</ref>. \n\nAs early as 1976 Meier had begun a series of soldiers from [[Classical antiquity]] which were collected together as AN/35-xxx The Hoplites<ref name = D11>Ral Partha Advertisement, Dragon Magazine #11, December 1977.</ref>. By 1978 the line was essentially complete and included Greeks, Carthaginians, Persians, Gauls, Early Republic Romans and Macedonians <ref name = RP78/>. A similarly early line was Meiers 11th century knights and footmen called 11/42-xxx 1200 A.D. and put into production by the end of 1976<ref name = D4/>. By 1978 the line was mostly complete and included Vikings, English, French, Spanish, Moorish, Mongol, and Sung Chinese soldiers<ref name = RP78/>.\n\nRal Partha produced series of Meiers earliest work called E-xxx Wizards, Warriors and Warlocks which were put into production in 1976, 1977, and 1979<ref name = RP78/><ref name = RP79/>. This line included some of Tom Meiers earliest work and was xecuted in the style of [[Heritage Models]] for whom he had briefly worked <ref name = Tom2>[http://www.thunderboltmountain.com/forum/viewtopic.php?t=383&sid=f0a0f738517a04c587f5c65be6e05380], Tom Meier on Thunderbolt Mountain Miniatures Forums, December 3, 2008.</ref>. The E-xxx series was retired in 1980, but portions of it were re-released in 1995 as part of the 19-xxx Ral Partha Remembered line commemorating the companys 20th anniversary<ref name = RP80/>.\n\nAs president of the company, Glenn E. Kidd oversaw the 1978 acquisition of [[The Old Guard]]s Legions of the Petal Throne line of figures for [[TSR Inc.]]s Empire of the Petal Throne, a role-playing game based on [[M. A. R. Barker]]s world of [[Tkumel]]<ref name = RP78/><ref name = D4>Ral Partha Advertisement, Dragon Magazine #4, December 1976.</ref>. Ral Partha retained the services of [[William Murray (miniature sculptor)|William Murray]], the lines sculptor. Tom Meier and Brian Apple made contributions to the series (T, Y, P, M, NH-xxx) in 1979, but it was discontinued later that year<ref name = RP79/><ref name = RP80/>.\n\nAs early as 1978 Ral Partha produced three series of 15mm historical miniatures sculpted by [[George Freeman (miniature sculptor)|George Freeman]]. They included [[Napoleonic]] era figures N-xxx Days of the Empire, AW-xxx American Civil War, and AK-xxx Desert Rats modeling the [[North African Campaign]] of World War II. [[Ann Gallup (miniature sculptor)|Ann Gallup]] also contributed an AC-xxx series to the [[American Civil War]] line <ref name = RP78/>. In 1979 Ral Partha added Freemans 25mm W-xxx Waterloo Collectors Series<ref name = RP79/>, but all of Freeman and Gallups figures were discontinued in 1980<ref name = RP80/>.\n\nRal Parthas first venture into science fiction was Meiers 1978 line of [[space marine]]s and [[space alien]]s GG-xxx Galactic Grenadiers: Strike Force Alpha. Their release was in tandem with [[Gamescience]]s Strike Team Alpha, a set of rule designed by Michael Scott Kurtick for Meiers Galactic Grenadiers<ref name = Geek_Alpha>[http://www.boardgamegeek.com/game/10224], Strike Team Alpha, Board Game Geek. Accessed December 22, 2008.</ref><ref name = WD13>Games Workshop Advertisement, White Dwarf Magazine #13, June/July 1979.</ref>. Other early lines included collectible 54mm figures called S/97-xxx Partha Personalities, and lines of 25mm dungeon accessories (D/97-xxx) and weapons (D/97-5xx)<ref name = RP78/>.\n\n===Goblins and Samurai, 1979-1985===\n\nIn the summer of 1978 Tom Meier began reworking the themes of the E-xxx series to create the CS/02-xxx Fantasy Collectors line of [[elves]]<ref name = D19>Ral Partha Advertisement, Dragon Magazine #19, October 1978.</ref>. His lines were successful and Meier began sculpting full-time in 1979 to expand his ranges. The addition of [[dwarf (mythology)|dwarves]] in 1979 and [[goblin]]s in 1980 almost entirely replaced the E-xxx series<ref name = RP79/><ref name = RP80/>. Meier added [[halfing]]s in 1982 and begun a series of fantasy vehicles. The first was 02-030 Dwarf Steam Cannon released in 1983. Meiers contribution to the series was completed when 02-078 The Warmachine and 02-020 The Elf Chariot were put into production in 1984<ref name = RP82/><ref name = RP83/><ref name = RP84/>.\n\nIn 1979 Meier introduced 15/54-xxx Condotitieri, a line of Renaissance era figures<ref name = RP79/>. The first offering were Imperialists to which he added Swiss and Turks in 1980<ref name = RP80/>. Meier expanded the historical ranges with the 1983 addition of 88-xxx The Colonials<ref name=RP83/>. Sculpts for the [[Anglo-Zulu War]] were augmented in 1984 with figures for the [[North-West Frontier (military history)|Northwest Frontier]], and the [[Mahdist War|Sudan Campaign]] in 1985<ref name = RP85H>Ral Partha Enterprises, Inc. 1985 Historical Catalog.</ref><ref name = RP84/>.\n  \nRal Partha hired [[Dennis Mize]] in 1979. With two full-time sculptors, Ral Parthas product lines increases rapidly. Mizes first project was H-xxx Royal Armies of the Hyborean Age to accompany [[Fantasy Games Unlimited]] game of the same name based on the world of [[Robert E. Howard]]s [[Conan]] <ref name = RP79/>. The Hyborean line was dropped in 1980, but Mize introduced 53-7xx The Samurai and a line of 15mm fantasy soldiers called 05-xxx Armies of Myth and Legend<ref name = RP80/>. His popular CN/13-xxx Children of the Night was begun by 1982 and expanded over the course of the next two years<ref name = RP82/><ref name = RP83/><ref name = RP84/>. In 1982 Mize and Meier created figures for small thematic box sets called 98-xxx The Adventurers<ref name = RP82/><ref name = D49>Ral Partha Advertisement, Dragon Magazine #49, May 1981.</ref>. Mize also added and remade parts of Meiers The Hoplites and 1200 A.D. lines in 1984<ref name = RP84/>.\n\nRal Partha  entered the game market in 1980 with the release of 99-001 Witchs Caldron, 99-002 Caverns Deep, 99-003 Final Frontier, and 99-004 Galactic Grenadiers, skirmish games designed by [[Glenn E. Kidd]] and [[Mark Rubin]]. Galactic Grenadiers included miniatures from the GG-xxx series and the 15mm figures from Final Frontiers were released in 1982 as 08-xxx Star Warriors<ref name = RP82/>. War gamers were not yet ready for 15mm fantasy figures and both were taken out of production by 1983. Figures from the Caverns Deep and Witchs Cauldron games were incorporated into 98-xxx The Adventurers that same year<ref name = RP83/>. In 1985 the company joined with Leggett Games Inc. to publish Fortress a skirmish-based board game which used plastic versions of  Ral Partha sculpts<ref name = Fort>[http://www.boardgamegeek.com/game/17429], Fortress, at Board Game Geek.</ref>. In 1985 the company launched 77-xxx Partha Paints and Dragonscale metallic cremes which were packaged with dragon figures<ref name = RP85F/>.\n\n[[Julie Guthrie]] began freelance sculpting for Ral Partha in 1983. Her first line was the 02-9xx All Things Dark and Dangerous and worked with Meier and Mize on 98-xxx The Adventurers <ref name = RP83/>. Later that year box sets of 10-3xx The Best of Ral Partha and Julie Guthries 96-xxx Elfquest figures for [[Chasosium]]s game of the same name were put into production<ref name = RP83X>Ral Partha Enterprises, Inc. 1983 Christmas Catalog.</ref>.  [[Julie Guthrie]] expanded the All Things Dark and Dangerous line in 1984, 1985 and 1986. In 1984 she joined Meier and Mize to develop a short series of miniatures (95-xxx) for [[Nova Games]] [[Lost Worlds (gamebook)|Lost Worlds]] series of combat books<ref name = RP86/><ref name = RP84/><ref name = RP85F/>. In 1985 Guthrie contributed two sculpts of unicorns to PO-3xx Once Upon a Time series designed for the gift-ware market, cast in lead-free alloy, and marketed as Partha Pewter<ref name = D93>Ral Partha Advertisement, Dragon Magazine #93, January 1985.</ref>. The Partha Pewter designs were marketed by [[Rawcliffe Pewter]] and gave Ral Partha the technical expertise necessary to transition to non-lead alloys in the early 1990s. \n\n[[Bob Charrette]] joined Ral Partha in 1984 contributed to Meiers The Hoplites, 1200 A.D., and CS/02-xxx Collector Series lines<ref name = RP84/>. In 1985 Charrette introduced figures for [[Chaosium]]s [[RuneQuest]] and a line of pulp adventurers which was initially called 20th Century Plus but was later renamed 20-xxx The Roaring Twenties<ref name = RP85F/>. Charrette had created a line of the same name in 1979 to accompany [[Fantasy Games Unlimited]]s Gangster!. Ral Parthas line included re-sculpts of some of the same themes Charrette had created for [[Fantasy Figures Unlimited]], FGUs short-lived sculpting shop<ref name = D29>Report on Origins 79, Dragon Magazine #29, September 1979.</ref><ref name = FGU> [http://www.space-opera.net/mirror/fgu/default.htm], Mirror of FGU website, Accessed December 17, 2008</ref>.<ref name = W14>Molten Magic in White Dwarf #14, August/September 1979</ref>. Charrette later updated the line to include new and old cinematic themes such as the intrepid archaeologist. In 1986 Bob Charrette added to Meiers CS/02-xxx line, and inaugurated a line for his own game [[Bushido (role-playing game)|Bushido]] (53-9xx Bushido) published by [[Fantasy Games Unlimited]]<ref name = RP86/><ref name = Bob>[http://www.charrette.parroom.net/minigames1.html], Bob Charrette Games, Accessed November 23, 2008.</ref>. Ral Parthas [[Bushido]] figures included new sculpts of some of the same themes covered by Charrettes earlier line for [[Fantasy Games Unlimited]]<ref name = FGU/>.\n\nRather quietly, Ral Partha began producing a line of miniature robot war machines in 1985. The miniatures were for a game that was first called [[Battledroids]], and then renamed [[BattleTech]] in 1986 for [[FASA Corporation|FASA]]s game of the same name<ref name = RP86/>. It was the beginning of a permanent relationship between the two companies that would eventually lead to Ral Parthas sale to [[FASA Corporation|FASA]].\n\n===Mechs and Dragons, 1986-1995===\n\nAt the same time that integrated campaign worlds like [[Games Workshop]]s [[Warhammer Fantasy Battle]] were showing early success, Ral Partha introduced the Chaos Wars theme into their 1986 and 1987 product lines<ref name = RP87/><ref name = RP86/>. It was the first step toward unifying a collection of disparate themes into an integrated brand. In the 1986 catalog sculptors were no longer credited and a mythical Ral Partha rather than the president of the company addressed customers in the prologue<ref name = RP86/>. At about that same time, the Ral Partha staff had developed a four-page Rules According to Ral for medieval battles. A fantasy version by [[Bob Charrette]] was released in 1987 as part of a boxed set Rules According to Ral: Chaos Wars<ref name = RP86/><ref name = Bob/><ref name = Geek>[http://www.boardgamegeek.com/publisher/547], Board Game Geek, Ral Partha Games, Accessed November 24, 2008.</ref><ref name = TMP2>[http://theminiaturespage.com/rules/fan/chaoswars.html], TMP: Chaos Wars, Accessed November 23, 2008.</ref>. The Chaos Wars theme collected together numerous existing products, many from Meiers ES/01-xxx line and their packaging was marked with stickers. The new initiative was to include 10-2xx Free Companies of Chaos Wars box sets, but they never materialized and the figures were appended to the CS/02-xxx Collectors Series. Among these sets were [[Bob Charrette]]s the popular Fangs of Fury [[beastmen]], [[Tom Meier]]s Korgs Killers [[orcs]], and Meiers Starbrows Select [[elves]]. Having never fully materialized, the Chaos Wars theme was dropped in 1988 in order to give necessary attention to producing official miniatures for [[TSR, Inc.]]s popular [[Dungeons & Dragons]] game.\n\nIn 1986 Ral Partha inaugurated 01-3xx 3-Stage Characters line which consisted of three aspects of the a single characters game career<ref name = RP86/>. The line was folded into the ES/01-xxx line in 1987<ref name= RP87/>. Because of their popularity with collectors and role-players, they regained a status as a separate line and a place of prominence in the 1991catalog<ref name = RP91/>. \n\nIn 1988, [[Tom Meier]] began his own company [[Thunderbolt Mountain Miniatures]], but continued to do freelance work for Ral Partha<ref name = Tom />. Then president, Chuck Crain hired [[Sandra L. Garrity]], [[Dave Summers]] and [[Richard Kerr]] as full-time sculptors<ref name = RP91/><ref name = Gar>[http://miniature-painting.net/SandraGarrity/sandra.html], Interview with Sandra Garrity, Accessed November 24, 2008.</ref><ref name = Chuck>[http://theminiaturespage.com/news/621905/], TMP: In Memory of Charles B. Crain III, Accessed November 24, 2008.</ref> to produce an official line of monsters and personalities for [[Advanced Dungeons & Dragons|AD&D figures]]<ref name = Orig />. The earliest figures included 10-56x Battlesystem Brigades (25mm) which included an entire 25mm military unit in for tabletop wargames, and adventurers (11-0xx) and monsters (11-4xx) for role-playing games<ref name = RP91/>. The following year Ral Partha launched 11-9xx Battlesystem Brigades (15mm), 10-5xx Dragonlance and Dungeons & Dragons boxed sets, and figures for the 11-5xx Ravenloft, 10-54x Dark Sun boxed sets and additions to the existing lines. The 11-05x, 11-06x AD&D Personalities of heroes and villeins was released in 1994, and additional figures for the [[Planescape]], [[Ravenloft]], and [[Forgotten Realms]] game worlds followed in 1995<ref name = RP95/>. By 1997 Ral Partha had also added figures for [[TSR, Inc.]]s [[Dark Sun]], [[Council of Wyrms]], and [[Birthright (campaign setting)|Birthright]] game worlds<ref name = RP97/>. The breadth and earning potential of the [[Dungeons & Dragons]] franchise drove new releases and Ral Partha scrambled to acquire the sculpting talents of British and American sculptors including Nick Bibby, Jeff Wilhelm, Bob Olley, Chris Atkin, Walter Vail, John M. Garrity, and Jim Johnson by 1992, and Chis Fitzpatrick and Geoff Valley by 1995<ref name = RP92/><ref name = RP95/>.\n\nBy 1991 the 20-xxx BattleTech line had grown to include eleven box sets, and more than one hundred Mechs, Aerospace fighters, and ground vehicles. Ral Partha also produced 25mm 20-9xx Mechwarriors depicting pilots, mechanics and guards for role-playing in the [[BattleTech]] game world. That same year, Ral Partha sculptors had begun crafting figures for FASAs games, [[Shadowrun]] a role-playing game set in a futuristic cyber-world<ref name = RP91/><ref name = Orig />. [[Shadowrun]] miniatures had previously been produced by [[Grenadier Models, Inc.|Grenadier Miniatures]]. Ral Partha introduced their sculpts (20-5xx Shadowrun) in 1992<ref name = RP92/>.\n\nThe 12-xxx The All American Line of fighters, [[orcs]], [[magic-users]], [[undead]], [[dwarf (mythology)|dwarves]], and [[elves]] was released in 1991 and 1992<ref name = RP91/><ref name = RP92/>. The name of the line appears to refer to fact that all the figures were sculpted Ral Parthas four staff sculptors. Other new lines included [[Richard Kerr]]s 1992 futuristic tanks for [[Steve Jackson Games]] [[Ogre]]<ref name = Orig /> and the introduction of the  69-xxx series for [[White Wolf, Inc.]]s [[Werewolf: The Apocalypse]] and [[Vampire: The Masquerade]] in late 1993<ref name = D118>Ral Partha Enterprises, Inc. Advertisement, Dragon #118, August 1993.</ref>. Figures for [[White Wolf, Inc.]]s [[Mage: The Ascension]] followed soon after. In 1994 Dennis Mize conceptualized and sculpted 01-7xx Beastmasters a line of carnivores and their trainers. The line was expanded the following year, but wouldnt be completed until 1998<ref name = RP95/><ref name = RP98-99>Ral Partha Enterprises, Inc. Winter 98/99 Catalog.</ref>. In 1995 Ral Parthas sculptors crafted figures for [[Steve Jackson Games]] [[Space Knight]], and multi-piece dioramas called Sculptors Row, The Sterling Collection, and Encounters of the Imagination.<ref name = RP95/>. \n\nInitially, Ral Partha figures were cast from lead and tin alloy, but in 1993 New York legislators nearly passed a public health bill barring the use of lead in toys and miniatures<ref name = D192>Through the Looking Glass by Robert Bigalow, Dragon #192, April 1993.</ref>. Despite the additional cost, numerous manufacturers anticipated parental concerns, similar legislation in other states, and their own workplace safety and began using white metal alloys. Ral Parthas staff had previously developed a lead-free alloy for their Partha Pewter line sold in the gift-ware market. In September 1993 they began using Ralidium in all their products<ref name = D197>Ral Partha Enterprises, Inc. Advertisement, Dragon #197, September 1993.</ref> and its use marks a clear benchmark for dating old figures. The move away from lead was promoted in advertisements and bright red stickers on existing packaging. In time, New York Governor [[Mario Cuomo]] relented to hobbyists concerns and exempted miniatures from the states Public Health Law<ref name = NY2>Through the Looking Glass by Robert Bigalow, Dragon #205, May 1994.</ref>. Ral Partha correctly anticipated the movement away from lead, but the associated price increases came at a time when miniatures and role playing games like [[Dungeons & Dragons]] were being eclipsed by [[collectible card games|CCG]] like [[Wizards of the Coast]]s 1993 hit [[Magic: The Gathering]].\n\nRal Partha introduced Partha Plastics, figures or parts of figures composed of resin into their product line in 1995<ref name = RP95/>. The move was made well after [[Citadel Miniatures]] had successfully introduced plastic figures in 1987, but the figures were not popular with Ral Parthas older customer base<ref name=Club6/>.\n\n===The Trouble with Wizards, 1996-2001===\n\nUnder Ral Parthas third president, Jack Hesselbrock, Ral Partha faced a number of licensing setbacks. [[Steve Jackson Games]] [[Ogre]] miniatures and all three White Wolf  lines were discontinued in 1996<ref name = Club3>Ral Partha Gaming Club Newsletter #3, September 30, 1996.</ref> and Dennis Mizes 18-xxx Runequest figures were discontinued the following year<ref name = RP97/><ref name = Club3/>. In 1997 [[Wizards of the Coast]] acquired [[TSR, Inc.]] and the rights to produce [[Dungeons & Dragons]] miniatures<ref name = Wiz0>[http://www.gamecabinet.com/news/TSRWotC.html], Game Cabinet - Wizards of the Coast to acquire TSR, Accessed November 24, 2008.</ref>. [[Wizards of the Coast]] established their own [[Dungeons & Dragons Miniatures Game]] and, after an extension, did not renew Ral Parthas license for [[Advanced Dungeons & Dragons]] miniatures. The figures went out of production at the end of 1997<ref name = Club3>Ral Partha Gaming Club Newsletter #3, December 31, 1996.</ref>. Ral Parthas [[Advanced Dungeons & Dragons]] line are highly sought after by collectors who believe that [[Wizards of the Coast]] ordered the master molds and all remaining product to be destroyed. Some collectors maintain hope that the lines might return. In October 2008 [[Wizards of the Coast]] announced a new focus on miniatures for role-players, but that is to be carried out within its line of low-detail, large-scale, pre-painted, plastic [[Dungeons & Dragons Miniatures Game]] toys<ref name = WOTC1>[http://www.wizards.com/default.asp?x=dnd/4news/20081023], Wizards of the Coast, D&D Miniatures Changes Explained.</ref>.\n\nThe 1997 Ral Partha catalog included a loose flier for 14-001 Bloodstorm, the first volume of a series in the Fables Gamesystem by a work group of outside developers called Ral Partha Publishing. The project was retitled Battlestorm and published later that year<ref name = RP97>Ral Partha Enterprises, Inc. 1997 Catalog Insert - The Final Battle Begins Bloodstorm.</ref><ref name = Club6>Ral Partha Gaming Club Newsletter #6, September 30, 1997.</ref><ref name = BS> [http://www.ralgames.com] Battlestorm: The Gateway to Gaming, Accessed November 23, 2008.</ref>. Battlestorms sales were less than expected and there were no subsequent installments.\n\nThe loss of the [[Dungeons & Dragons]] and other licenses meant that [[FASA Corporation|FASA]]s [[BattleTech]] figures became the majority of Ral Parthas revenue. Under threat of also losing that license, the owners of Ral Partha sold the company to [[FASA Corporation|FASA]] and Lanier and Mike Hurdle owners of Zocchi Distribution in September 1998 <ref name = SJ> [http://www.sjgames.com/pyramid/sample.html?id=693], Pyramid Magazine Industry News, Accessed November 23, 2008.</ref>. [[FASA Corporation|FASA]] gained sole ownership in the spring of 1999<ref name=SJ/>, and Ral Partha began to produce miniatures for [[FASA Corporation|FASA]]s [[Crimson Skies]], [[Crucible: Conquest of the Final Realm]] and [[VOR: The Maelstrom]] games.<ref name = RP00/>. No sooner were these lines in production when FASA ceased production of all their games<ref name = FAQ>[http://www.carnagecon.com/Files/FASA_Closing_FAQ.html], FASA Closing FAQ.</ref>. \n\nIn January 2001 [[WizKids]] acquired the bulk of Ral Parthas product lines as part of their purchase of [[FASA Corporation|FASA]]s [[BattleTech]] and [[Shadowrun]] games<ref name = Wiz0>[http://www.wizkidsgames.com/wk_article.asp?cid=4501], WizKids press release, January 26, 2001.</ref>. At that time [[WizKids]] purchased the  rights to some figures from Ral Partha sculptors and the remainder reverted to the artist. It was at this time that Tom Meier acquired sole rights to his 15/54-xxx Condotitieri, 88-xxx The Colonials, and most of the CS/02-xxx Fantasy Collectors lines<ref name = Tom3> [http://www.thunderboltmountain.com/forum/viewtopic.php?t=384], Tom Meier, Thunderbolt Miniatures Forums, Accessed December 12, 2008.</ref>. Bob Charrette regained control of his 53-9xx Bushido figures<ref name = Bob/>. In March 2001 Ral Partha began producing collectible metal versions of [[WizKids]] 64 figure [[Mage Knight]] Rebellion set<ref name = Wiz1> [http://www.icv2.com/articles/news/197.html], Mage Knight Metal Collectible Pewter Figures, Accessed November 23, 2008.</ref><ref name= Wiz2> [http://www.wizkidsgames.com/documents/pr/03_01_01MKMetalAnnounce.pdf], WizKids Announces Mage Knight Metal, Accessed November 23, 2008.</ref>.\n\n===Epilogue: An Iron Wind, 2001 - present===\n\nIn late 2001 Ral Partha was spun off from [[WizKids]] and renamed [[Iron Wind Metals]], LLC of [[Cincinnati, Ohio]] with longtime general manager Michael Noe as president<ref name = Wiz4 >[http://www.icv2.com/articles/news/972.html], WizKids to Spin Off Ral Partha on its own in January, Accessed December 1, 2008.</ref>. [[Iron Wind Metals]] reestablished production with a previous owner, some of the same staff, molds, and license agreements. They continue to use the name Ral Partha in reference to the early designs and continue to produce figures under license from Ral Partha era sculptors.\n\n==Sculptors==\n\nRal Parthas sculptors, artists, and mold-makers the years in which they worked for the company:</br>\n\n[[Tom Meier]] (freelance 1975-1978, staff 1979-1988, freelance 1989-1991), \n[[George Freeman]] (freelance 1977-1978), \n[[Ann Gallup]] (freelance 1977), \n[[William Murray]] (freelance 1977-1978), \n[[Jay Adams (sculptor)|Jay Adams]] (staff circa 1979), \n[[Brian Apple]] (freelance 1979), \n[[Dennis Mize]] (staff 1979-1988, freelance 1989-1994), \n[[Julie Guthrie]] (freelance 1983-1992), \n[[Bob Charrette]] (staff 1984-1988), \nBrian Hitsman (mold-maker, staff circa 1985-2001),\n[[Douglas Mize]] (graphics 1987),\n[[Chub Pearson]] (freelance 1987), \n[[Sandra L. Garrity (miniature sculptor)|Sandra Garrity]] (staff 1988-1992), \n[[Dave Summers (miniature sculptor)|Dave Summers]] (staff 1988-1996), \n[[Richard Kerr (miniatures sculptor)|Richard Kerr]] (staff 1987-1994), \n[[Nicholas Bibby|Nick Bibby]] (freelance 1990), \n[[Jeffrey P. Wilhelm (miniature sculptor)|Jeff Wilhelm]] (staff 1991-2000)<ref name = Wilhelm>[http://www.dragonforge.com/Painting%20service/bio.htm], Biography of Jeffrey P. Wilhelm.</ref>, \n[[Bob Olley]] (freelance 1991,1998), \n[[Chris Atkin]] (staff 1991-1997),\n[[John M. Garrity]] (freelance 1991), \n[[Walter B. Vail]] (freelance 1991), \n[[Jim Johnson (miniature sculptor)|Jim Johnson]] (staff 1992-1996), \n[[Steve Saunders]] (freelance 1994-1996, staff 1997-2001),\n[[Robert Kyde]] (staff 1995-1996),\n[[Joseph Kyde]] (freelance 1995-2001),\n[[Geoff Valley]] (1995-2001),\n[[Chris FitzPatrick]] (1995-2001), \n[[Brady Bugge]] (1997-2001), \n[[Jeff Grace]] (1997-2001), \nK. Kersey (1997-2001)\n[[Bobby Jackson]] (1999-2001), and \n[[John Winter]] (1999-2001) <ref name = RP85H/><ref name = RP87/><ref name = RP97/><ref name = RP78/><ref name = RP79/><ref name = RP80/><ref name = RP86/><ref name = RP82/><ref name = RP83/><ref name = RP84/><ref name = RP85F/><ref name = RP83X/>.\n\n==Awards==\n\n[[Origins Award]]s / H.G. Wells Awards<ref name = Orig /> \n\n1977 - Best Fantasy Figure Series (ES/01-xxx Fantasy Line [[Tom Meier]]).<br />\n1978 - Best Historical Figure Series (11/42-xxx 1200 A.D. [[Tom Meier]]).<br />\n1978 - Best Fantasy or Science Fiction Figure Series - Fantasy Collectors Series (CS/02-xxx [[Tom Meier]]).<br />\n1979 - Best Fantasy or Science Fiction Figure Series - Collectibles (CS/02-xxx [[Tom Meier]]).<br />\n1980 - Best Historical Figure Series - Condottieri (15/54-xxx [[Tom Meier]]).<br />\n1980 - Best Fantasy or Science Fiction Figure Series - Personalities (ES/01-xxx [[Tom Meier]]).<br />\n1981 - Best Historical Figure Series - Condottieri (15/54-xxx [[Tom Meier]]).<br />\n1982 - Best Fantasy or Science Fiction Figure Series - Personalities & Things That Go Bump In The Night (ES/01-xxx [[Tom Meier]]).<br />\n1983 - Best Vehicular Series - 25mm Dwarf Steam Cannon (02-030 [[Tom Meier]]).<br />\n1984 - Best Historical Figure Series - 25mm Colonials (88-xxx Zulus and Northwest Frontier, [[Tom Meier]]).<br />\n1984 - Best Fantasy or Science Fiction Figure Series - 25mm Personalities (ES/01-xxx [[Tom Meier]]).<br />\n1985 - Best Historical Figure Series - 25mm Samurai (53-7xx  [[Bob Charrette]], [[Dennis Mize]]).<br />\n1986 - Best Vehicular or Accessory Series - [[BattleTech]] Mech. (20-8xx [[Bob Charrette]], [[Julie Guthrie]], [[Tom Meier]]).<br />\n1987 - Best Historical Figure Series - Shogun Hardguys: The New Samurai (53-7xx [[Dennis Mize]], [[Bob Charrette]])<ref name = D139>And the Winner Is... Dragon Magazine #139, p. 56, November 1988</ref>.<br />\n1988 - Best Historical Figure Series - 1200 A.D., Aztecs (42-3xx [[Richard Kerr]])<ref name = D149>Dragon Magazine #149, September 1989.</ref>.<br />\n1988 - Best Fantasy or Science Fiction Figure Series - [[TSR]]s [[AD&D]] Series (11-xxx [[Tom Meier]], [[Dennis Mize]])<ref name = D149/>.<br />\n1988 - Best Vehicular or Accessory Series - [[BattleTech]] Mechs (20-8xx [[Bob Charrette]], [[Julie Guthrie]], [[Tom Meier]])<ref name = D149/>.<br />\n1989 - Best Fantasy or Science Fiction Figure Series - [[Dragonlance]] Heroes Line (10-502 [[Dennis Mize]], [[Tom Meier]], [[Richard Kerr]]).<br />\n1989 - Best Vehicular Miniatures Series - [[BattleTech]] Mechs and Vehicles (20-xxx [[Dave Summers]], [[Sandy Garrity]], [[Richard Kerr]], [[Tom Meier]], [[Bob Charrette]], [[Julie Guthrie]]).<br />\n1990 - Best Historical Figure Series - 25mm Ancients (35-7xx North African Ancients [[Dave Summers]], [[Sandra Garrity]]).<br />\n1990 - Best Fantasy or Science Fiction Figure Series - [[AD&D]] Monsters (11-4xx [[Dennis Mize]], [[Nick Bibby]], [[Richard Kerr]], [[Sandra Garrity]]).<br />\n1991 - Best Fantasy or Science Fiction Figure Series - [[Shadowrun]] (20-5xx [[Tom Meier]], [[Dennis Mize]], [[Dave Summers]]).<br />\n1991 - Best Vehicular Miniatures Series - [[BattleTech]] Mechs & Vehicles (20-xxx [[Jeff Wilhelm]], [[Dave Summers]], [[Sandy Garrity]], [[Richard Kerr]], [[Tom Meier]], [[Bob Charrette]], [[Julie Guthrie]]).<br />\n1992 - Best Fantasy or Science Fiction Figure Series - [[Ravenloft]] (11-1xx [[Dennis Mize]]).<br />\n1992 - Best Vehicular Miniatures Series - [[BattleTech]] Mechs & Vehicles (20-8xx [[Jeff Wilhelm]], [[Dave Summers]], [[Sandy Garrity]], [[Richard Kerr]], [[Tom Meier]], [[Bob Charrette]], [[Julie Guthrie]]).<br />\n1992 - Best Vehicular Miniatures Series - [[Ogre]] Miniatures ([[Jeff Wilhelm]], [[Dave Summers]], [[Richard Kerr]]).<br />\n1992 - Best Historical Figure Series - [[Hyksos]] Ancient Biblical ([[James Johnson (miniature sculptor)|Jim Johnson]]).<br />\n1993 - Best Fantasy or Science Fiction Figure Series - [[AD&D]] (11-xxx [[Dennis Mize]], [[James Johnson (miniature sculptor)|Jim Johnson]], [[Geoffrey Valley]], [[Dave Summers]], [[Jeffrey Wilhelm]], [[Richard Kerr]]).<br />\n1993 - Best Vehicular Series - [[BattleTech]] (20-8xx [[Dave Summers]], [[James Johnson (miniature sculptor)|Jim Johnson]], [[Richard Kerr]], [[Jeffrey Wilhelm]]).<br />\n1994 - Best Fantasy or Science Fiction Figure Series - [[AD&D]] Personalities (11-xxx [[James Johnson (miniature sculptor)|Jim Johnson]], [[Dennis Mize]], [[Jeffrey Wilhelm]]).<br />\n1994 - Best Vehicular Series - [[BattleTech]]: Vehicles & Mechs (20-xxx [[Chris Atkin]], [[James Johnson (miniature sculptor)|Jim Johnson]], [[Richard Kerr]], [[Dave Summers]], [[Jeffrey Wilhelm]]).<br />\n1995 - Best Vehicular Series - [[BattleTech]]: Vehicles & Mechs (20-xxx [[Chris Atkin]], [[Robert Kyde]], [[James Johnson (miniature sculptor)|Jim Johnson]], [[Dave Summers]], [[Jeff Wilhelm]]).<br />\n1996 - Best Vehicular Miniatures Series - [[BattleTech]]: Mechs & Vehicles (20-xxx [[Charles Chuck Crain]], [[Chris Atkin]], [[James Johnson (miniature sculptor)|Jim Johnson]], [[Robert Kyde]], [[Dave Summers]], [[Jeff Wilhelm]]).\n\nOrigins Hall of Fame<ref name = Orig />\n\n1991 - [[Tom Meier]]<br/>\n1995 - [[Julie Guthrie]]<br/>\n1997 - Ral Partha [[BattleTech]] Mechs & Vehicles ([[Charles Chuck Crain]], Developer).<br />\n2005 - [[Dennis Mize]].<ref>{{cite web | last=Panzeri Jr. | first=Peter F. | date=2006-07-01 | url=http://www.talsorian.com/OA-Hall-of-Fame-2006.pdf | title=32nd Hall of Fame Inductees Announced  | format=PDF | publisher=Talsorian | accessdate=2008-12-04 }}</ref>\n\nStrategist Club Creativity in Wargaming Award<ref name = RP84/>\n\n1978 - Outstanding Miniature Figure Line - Fantasy Collectors Series (CS/02-xxx, [[Tom Meier]]).<br />\n1979 - Outstanding Miniatures Figure Line - Condottieri (15/54-xxx [[Tom Meier]]).\n\nThe Courier Award<ref name = RP84/> \n\n1979 - Best Historical Miniature Line - Condottieri (15/54-xxx [[Tom Meier]]).\n\nGames Day Awards\n\n1979 - Best Range SF/F Figures - Personalities and Things that Go Bump in the Night (ES/01-xxx [[Tom Meier]])<ref name = WD16>White Dwarf Magazine #16, December/January 1979/1980.</ref>.<br/>\n1980 - Best Figures Range, Historical - 1200 A.D. (11-xxx [[Tom Meier]])<ref name = WD22>White Dwarf Magazine #22, December/January 1980/1981</ref>.\n\n'
p194
tp195
a(I1
S'{{Infobox Magazine\n| title           = Live Steam & Outdoor Railroading \n| image_file      = LSmagazine.jpg\n| image_size      = 150px\n| image_alt       = \n| image_caption   = Sept/Oct 2005 issue of Live Steam magazine\n| editor          = Clover McKinley\n| editor_title    = Editor\n| previous_editor = \n| staff_writer    = \n| frequency       = Bi-monthly\n| circulation     = \n| category        = Hobby magazines\n| company         = \n| publisher       = Village Press, Inc.\n| firstdate       = 1966\n| country         = United States\n| based           = Traverse City, Michigan\n| language        = English\n| website         = [http://www.livesteam.net Official Website] \n| issn            = \n}}\n\nLive Steam & Outdoor Railroading magazine (formerly Live Steam Magazine) is a magazine published in the [[United States]] that was founded in 1966. The magazine is devoted to the [[live steam]] [[hobby]] as well as to other uses of miniature and full-size steam equipment. \n\n==Origin==\n\nLive Steam was originally started as the Live Steam Newsletter in the early 1960s by Pershing Scott as a [[mimeograph]]ed [[newsletter]].<ref name=Design>{{cite web| last = Madlinger| first = Gary| authorlink =| coauthors =| title = Designers, Publishers & Builders form a Successful and Historic Partnership| work =  November-December 2002 issue of The Whistle Blast newsletter| publisher = Discover Live Steam| date = June 12, 2009| url = http://www.discoverlivesteam.com/magazine/33/33.html| format =| doi =| accessdate =5 September 2009 }}</ref>\nIn August 1966, Scott gave the publishing rights of the newsletter to William Fitt. By 1967 the newsletter had expanded into magazine format with the name being changed to Live Steam Magazine.<ref name=Design/>\n\n==Present day==\n\nIn 2005, the name was changed to Live Steam & Outdoor Railroading. It is currently published [[bi-monthly]], in full color, with a [[press run]] of slightly over 10,000 as of December 2004.\n\n'
p196
tp197
a(I-1
S'{{unreferenced|date=August 2009}}\nThe generalized other is a concept used in the [[social sciences]], especially in a field called [[symbolic interactionism]]. It is the general notion that a person has of the common expectations that others have about actions and thoughts within a particular society. Any time that an actor tries to imagine what is expected of them, they are taking on the perspective of the generalized other. \n\nAs a concept, it is roughly equivalent to the idea of the Freudian [[superego]].\n\n[[George Herbert Mead]] maintained that the experience of role-play and pretence in early childhood were vital for the formation of a mature sense of self, which may only be achieved by the child learning to take on the role of the other, i.e., seeing things from another persons perspective. By doing this, the child may eventually be able to visualize the intentions and expectations of others and see him/herself from not just anothers point of view but from groups of others. The generalized other represents the common standpoints of those groups. \n\nThe attitude of the generalized other is the attitude of the larger community. According to Mead, the generalized other is the vehicle by which we are linked to society.\n\n==Major works==\n*1934: Mead, G. H. and C. W. Morris Mind,Self, and Society from the Standpoint of a Social Behaviorist, University of Chicago Press, Chicago.\n\n'
p198
tp199
a(I-1
S'Social thought provides general theories to explain actions and behavior of society as a whole, encompassing [[sociology|sociological]], [[political science|political]], and [[philosophy|philosophical]] ideas.  Social theory is used to make distinctions and generalizations among different types of societies, and to analyze [[modernity]] as it has emerged in the past few centuries.<ref>{{cite book |title=Social Theory: A Historical Introduction |author=Callinicos, A. |year=1999 |publisher=New York University Press |pages=10}}</ref>  Classical social theory has generally been presented from a perspective of [[Western philosophy]], and often regarded as [[Eurocentric]].\n\n{{TOCright}}\n==Background==\n===Greek philosophy===\n[[Ancient Greek]] philosophers, including Aristotle and Plato, did not see a distinction between politics and society.  The concept of society did not come until much later, during the [[Age of Enlightenment|Enlightenment period]].  The term, socit, was probably first used as key concept by [[Jean-Jacques Rousseau|Rousseau]] in discussion of social relations.<ref>{{cite book |author=Heilbron, Johan |title=The Rise of Social Theory |publisher=Cambridge University Press |unused_data=|year-1995}}</ref>\n\n===Ibn Khaldun===\n[[Ibn Khaldun]], an influential [[Muslim]] scholar described in [[Muqaddimah]] (Introduction to History), two types of societies including: (1) the city or [[town]]-dweller and (2) the mobile, [[nomadic]] societies.\n\n===Montesquieu===\n[[Charles de Secondat, baron de Montesquieu|Montesquieu]], in The Spirit of Laws, was possibly the first to suggest a universal explanation for [[history]].<ref>{{cite book |author=Althusser, L. |title=Politics and History |year=1972}}</ref>  Another innovative aspect of Montesquieus thinking was that he included changes in [[mores]] and manners as part of his explanation of political and historic events.<ref>{{cite book |title=Social Theory: A Historical Introduction |author=Callinicos, A. |year=1999 |publisher=New York University Press |pages=23}}</ref>\n\n===Enlightenment===\nMany philosophers, including [[Jean-Jacques Rousseau]], [[Voltaire]], and [[Denis Diderot]], developed new social ideas during the [[Age of Enlightenment|Enlightenment]] period that were based on [[reason]] and methods of scientific inquiry.  These ideas did not draw on ideas of the past from classical thinkers, nor involved blindly following [[religion|religious]] teachings and authority of the [[monarch]].  An important idea was that with new [[Discovery (observation)|discoveries]] challenging the status quo way of thinking, scientists were required to find new normativity.  This process allowed [[scientific knowledge]] and society to [[progress]].  French thought during this period focused on [[moral]] critique and criticisms of the [[monarchy]].<ref>{{cite book |title=Social Theory: A Historical Introduction |author=Callinicos, A. |year=1999 |publisher=New York University Press |pages=15}}</ref>\n\n[[Modernity]] arose during the Enlightenment period, with the emergence of the [[world economy]] and exchange among diverse societies, bringing sweeping changes and new challenges for society.  During the Eighteenth century, many [[France|French]] and [[Scotland|Scottish]] intellectuals and [[philosopher]]s embraced the idea of progress and ideas of modernity.  \n\n[[Adam Smith]] addressed the question of whether vast inequalities of wealth represented progress.  He explained that the wealthy often demand [[convenience]], employing numerous others to carry out [[Work|labor]] to meet their demands.  He argued that this allows wealth to be redistributed among inhabitants, and for all to share in progress of society.  Smith explained that social forces could regulate the [[market economy]] with social objectivity and without need for [[government]] intervention.  Smith regarded the [[division of labor]] as an important factor for economic progress.  [[John Millar (philosopher)|John Millar]] suggested that improved status of [[women]] was important for progress of society.  Millar also advocated for [[Abolitionism|abolition]] of [[slavery]], suggesting that personal [[liberty]] makes people more industrious, [[ambition|ambitious]], and [[productivity|productive]].<ref>{{cite book |author=Meek, Rodney L. |title=Economics and Ideology and Other Essays |year=1967}}</ref>\n\n[[Voltaire]]s [[Letters on the English|Lettres Philosophiques]] presented new scientific and philosophical ideas developed by [[Isaac Newton]], [[John Locke]], and others, introducing them to the French.  Methods used to study scientific phenomenon were extended to study social and moral issues.  [[David Hume]] used this approach in his [[Treatise of Human Nature]].\n\n==Social questions==\nPhilosophical questions addressed by social thinkers often centered around [[modernity]], including:\n\n* Can human reason make sense of the social world and shape it for the better?\n* Did the development of modern societies, with vast inequalities in wealth among citizens, constitute progress?\n* How do particular government interventions and regulations impact natural social processes?\n* Should the economy/market be regulated or not?\n\nOther issues relating to modernity that were addressed by social thinkers include [[social atomization]], [[Social alienation|alienation]], [[loneliness]], [[social disorganization]], and [[secularization]].\n\n==European social thought==\n[[Adam Ferguson]], [[Charles de Secondat, baron de Montesquieu|Montesquieu]], and [[John Millar (philosopher)|John Millar]], among others, were the first to study society as distinct from political institutions and processes.  In the nineteenth century, the [[scientific method]] was introduced into study of society, which was a significant advance leading to development of [[sociology]] as a [[discipline]].\n\nAt the time of the Enlightenment, European societies were still largely [[rural]], with minimal involvement of government in everyday life of citizens. With [[industrialization]] and [[urbanization]], societies were significantly transformed, and new ways of thinking about society arose.\n\nIn the 19th century, questions involving [[social order]] gained importance.  The [[French Revolution]] freed French society of control by the monarchy, with no effective means of maintaining social order until [[Napoleon I of France|Napoleon]] came to power.\n\n===French social thought===\n* [[Claude Henri de Rouvroy, comte de Saint-Simon|Claude Henri Saint-Simon]]\n* [[August Comte]]\n* [[Emile Durkheim]]\n\n===British social thought===\nBritish social thought, with thinkers such as [[Herbert Spencer]], addressed questions and ideas relating to [[political economy]] and [[social evolution]]. \n\n===German social thought===\nImportant [[Germany|German]] philosophers and social thinkers included [[Immanuel Kant]], [[Georg Wilhelm Friedrich Hegel]], [[Karl Marx]], [[Max Weber]], and [[Georg Simmel]].\n\n===Italian sociology===\nImportant Italian social scientists include Antonio Gramsci, Gaetano Mosca, and Umberto Eco.\n\n===Chicago school===\nThe [[Chicago school (sociology)|Chicago school]] developed in the 1920s, through the work of [[Albion Woodbury Small]], [[W. I. Thomas]], [[Ernest W. Burgess]], [[Robert E. Park]], [[Ellsworth Faris]], and other sociologists at the [[University of Chicago]].  The Chicago school included focus on patterns and arrangement of social phenomenon across [[time]] and [[place]], and within context of other social variables.<ref>{{cite journal |author=Abbott, Andrew |title=Of Time and Space: The Contemporary Relevance of the Chicago School |journal=Social Forces |year=1997 |volume=75(4) |pages=114982 |doi=10.2307/2580667}}</ref>  [[George Herbert Mead]], a member of the Philosophy department at the University of Chicago, was also influential.\n\n==Theories==\n===Positivism===\n[[August Comte]], [[Herbert Spencer]], [[Emile Durkheim]], and [[Vilfredo Pareto]] were aligned with the [[positivism|positivist]] perspective, which favored use of rigorous scientific methodology in developing and testing theories.  This approach incorporated [[determinism]] and [[empiricism]] in formulating theories.\n\n===Critical theory===\n[[Critical theory (Frankfurt School)|Critical theorists]] including [[Georg Wilhelm Friedrich Hegel|Hegel]] and [[Karl Marx|Marx]] and rejected the objective, scientific approach.  They sought to frame theories within [[ideology|ideologies]] of human [[Freedom (philosophy)|freedom]].\n\n===Marxism===\n[[Karl Marx]] wrote and theorized about the importance of [[political economy]] on society, and focused on the material conditions of life.<ref>{{cite book |title=Social Theory: A Historical Introduction |author=Callinicos, A. |year=1999 |publisher=New York University Press |pages=4}}</ref>\n\n===Other perspectives===\nOther theories include:\n* [[Social constructionist theory]]\n* [[Rational choice theory]]\n* [[Structural functionalism]] - influenced by Spencer and Durkheim\n* [[Action theory]] - influenced by Weber and Pareto\n* [[Conflict theory]] - influenced by Marx, Simmel\n* [[Symbolic interaction]] - influenced by [[George Herbert Mead]]\n\n==Postmodernism==\nPostmodernism was defined by [[Jean-Francois Lyotard]] as incredulity towards [[metanarratives]] and contrasted that with [[Modernism|modern]] which he described as any science that legitimates itself with reference to a [[metadiscourse]]... making an explicit appeal to some grand narrative, such as the dialectics of Spirit the hermeneutics of meaning, the emancipation of the rational or working subject, or the creation of wealth.<ref>{{cite book |author=Lyotard, Jean-Francois |title=The Postmodern Condition |year=1979}}</ref>\n\n'
p200
tp201
a(I-1
S'Occupational segregation is the distribution of groups defined by ascribed characteristics, mostly [[gender]], across occupations.  More basically, it is the concentration of a similar group of people (be they males, females, whites, blacks, etc) in a job.  Occupational segregation levels differ on a basis of perfect segregation and integration.  Perfect segregation occurs where occupation and group membership correspond perfectly, where no job is populated by more than one group.  Perfect integration, on the other hand, occurs where each group holds the same proportion of positions in an occupation as it holds in the labor force <ref> Weeden, Kim. Occupational Segregation. Blackwell Encyclopedia of Sociology. Ritzer, George (ed). Blackwell Publishing, 2007. Blackwell Reference Online. 31 March 2008 [http://www.blackwellreference.com/subscriber/tocnode?id=g9781405124331_chunk_g978140512433121_ss1-4] </ref>.  \n\nOccupational segregation often occurs in patterns.  The pattern of segregation refers to the makeup of a groups under- or overrepresentation in a specific occupation.  Segregation levels are constant if an occupation goes from being overly male to overly female.  Occupational segregation is one of the leading causes of income inequality and to some, it may be the leading cause.  As a matter of fact, according to Blackwell Encyclopedia of Sociology, the gender gap in wages is caused more so by segregation across jobs than by pay discrimination within jobs <ref> Weeden, Kim. Occupational Segregation. Blackwell Encyclopedia of Sociology. Ritzer, George (ed). Blackwell Publishing, 2007. Blackwell Reference Online. 31 March 2008 [http://www.blackwellreference.com/subscriber/tocnode?id=g9781405124331_chunk_g978140512433121_ss1-4] </ref>.  \n\n==Types==\nWithin occupational segregation, there are different types, horizontal and vertical.  Horizontal segregation is where a workforce is made up mostly of one gender, race, or other ascribed characteristic.  Vertical segregation is similar to the [[glass ceiling]], where opportunities for career advancement for a particular gender, race, or other ascribed characteristics, are narrowed <ref> Tackling Occupational Segregation Fact Sheet. Women and Equality Unit. May 2007. Women and Equality . 31 Mar 2008 [http://www.womenandequalityunit.gov.uk/publications/occupseg_facts_jun07.doc] </ref>.\n\n==Causes==\nOccupational segregation is mostly caused by stereotypical, biological and social differences between genders and races.  Segregation arises when preconceived notions about a particular gender or race are carried over into the workforce, and a persons competency is based on these prejudices (i.e. thinking all women are weak and cant engage in heavy labor, thinking all Hispanics wont be able to read memos at a job, etc.).  Occupational segregation is also derived from what is known as gender essentialism, the belief that because of the biological differences between men and women, they are different as far as character and personality are concerned.  Gender essentialists view men as being strong and powerful and women as being meek and emotional <ref> Charles, Maria and Grusky, David.  Occupational Ghettos:  The Worldwide Segregation of Women and Men.  16 April 2008   [http://www.womensmedia.com/new/Occupational-Ghettos.shtml] </ref>\n\n==Statistics==\nBlacks are over- or underrepresented in typical jobs by a factor of 2.1; 21 percent would have to change jobs in order to reach perfect integration with Caucasians.  Men are over- or underrepresented in the average occupation by a factor of 5.5; 51 percent would have to change jobs in order to reach perfect integration with women. <ref> Weeden, Kim. Occupational Segregation. Blackwell Encyclopedia of Sociology. Ritzer, George (ed). Blackwell Publishing, 2007. Blackwell Reference Online. 31 March 2008 [http://www.blackwellreference.com/subscriber/tocnode?id=g9781405124331_chunk_g978140512433121_ss1-4] </ref>.  \n\n==Measuring Occupational Segregation==\nOccupational segregation is measured using Duncans D (or the [[index of dissimilarity]]), which serves as a measure of dissimilarity between two distributions.  D has to be calculated first:\n\n1.\tIdentify N different occupations.  \n2.\tCalculate the percentage of men (or other ascribed category) who work in each of the occupations and the percentage of women who work in each occupation.  Give men and women a variable name (m<sub>1</sub> could = men, w<sub>1</sub> could = women).\n3.\tDuncans D is calculated using this formula:\nD=<sub>i</sub>|m<sub>1</sub>-w<sub>1</sub>|\n\t**It is important to note that Duncans D uses percentages.  So in a given occupation, the number of men (or women) in that occupation should be divided by the total number of men (or women) in all of the occupations.  For example:  You may have 10 men who are nurses out of 600 total men.  The value for the occupation of male nurses should be 10/600, or .0166.\t\n4.\tThe number you get after calculations will be in decimal form, and you will need to multiply it by 100 to get its percentage.  For instance, if your answer is .45, this means that 45% of men or women would have to change jobs for the distribution of men and women across occupations to be exactly the same. <ref> Fain, Dr. Jim . Occupational Segregation. OSU William S. Spears School of Business. 31 Mar 2008 [http://spears.okstate.edu/home/jrfain/legacy/occseg/index.html] </ref>\n\n==Non-Traditional Jobs Held by Women==\n* Pilots\n* Barbers\n* Detectives\n* Construction workers\n* Architects\n* Fire Fighters\n* Engineers\n\n==Non-Traditional Jobs Held by Men==\n* Childcare providers\n* Paralegals\n* Secretaries\n* Public Relations\n* Interior Decorators\n* Nurses\n* Librarians\n* Estheticians\n\n'
p202
tp203
a(I1
S'__NOTOC__\n{{Otherpeople3|the New Zealand lawyer and politician|his father|Robert Heaton Rhodes}}\nSir Robert Heaton Rhodes [[Royal Victorian Order|KCVO]] [[Order of the British Empire|KBE]] [[Volunteer Decoration|VD]] (27 February 186130 July 1956), usually known as Sir Heaton Rhodes, was a [[New Zealand]] [[politician]] and [[lawyer]].\n\nRhodes was born in [[Lyttelton, New Zealand|Lyttelton]], the son of sheep farmer and politician [[Robert Heaton Rhodes]]. He came to [[England]] to attend [[Brasenose College, Oxford]], from which he graduated in 1884. He was [[called to the bar]] by the [[Inner Temple]] in 1887.\n\nHe then returned to New Zealand, joined the [[New Zealand Mounted Rifles Brigade]], and served in the [[Second Boer War]] with the [[8th New Zealand Contingent]]. He later went on to command the [[1st Mounted Rifles]] in the [[New Zealand Territorial Force]]. After retirement he was [[Honorary Colonel]] of the 1st Mounted Rifles.\n\nHe joined the [[New Zealand Reform Party|Reform Party]] and represented the [[Ellesmere (NZ electorate)|Ellesmere]] electorate in the [[New Zealand House of Representatives|House of Representatives]] from [[New Zealand general election, 1899|1899]] to [[New Zealand general election, 1925|1925]], when he retired and was appointed to the [[New Zealand Legislative Council|Legislative Council]], in which he served until 1941, with a short break between 1932 and 1934.\n\nHe served as [[Postmaster-General of New Zealand|Postmaster-General]] and [[Minister for Public Health, Hospitals and Tourist Resorts]] in the [[New Zealand Cabinet|Cabinet]] from 1912 to 1915, when he was appointed Special Commissioner to [[Egypt]] and [[Galilee]] to report on the conditions of New Zealand troops serving there. In 1916 he moved to Europe as Commissioner of the [[New Zealand Red Cross]]. For this role he was appointed [[Knight Commander of the Order of the British Empire]] (KBE) in the 1920 New Year Honours.<ref>{{LondonGazette |issue=31712 |date=30 December 1919 |startpage=6 |supp=yes}}</ref>\n\nIn 1920 he returned to New Zealand and was appointed [[Minister of Defence (New Zealand)|Minister of Defence]]. In 1922 he was also appointed as [[Commissioner of State Forests]] and held both posts until 1926. From 1926 to 1928 he was Deputy Leader of the Legislative Council and [[Minister without Portfolio]]. In 1927 he was Minister in attendance upon the [[George VI of the United Kingdom|Duke]] and [[Lady Elizabeth Bowes-Lyon|Duchess of York]] on their visit to New Zealand, for which he was appointed [[Knight Commander of the Royal Victorian Order]] (KCVO). He was vice-president of the Victoria League for Commonwealth Friendship in Canterbury in the 1930s.\n\nHe bred pedigree cattle at [[Otahuna]], [[Taitapu]], where he also grew [[daffodil]]s. A [[stamp collection|stamp collector]], he had a large collection of New Zealand [[Chalon head]] postage stamps. He was President of the [[Royal Philatelic Society of New Zealand]] and signed the [[Roll of Distinguished Philatelists]] in 1949.<ref>Arthur Ronald Butler, History of the [[Roll of Distinguished Philatelists]], The British Philatelic Federation, December 1990, page 101.</ref>\n\n==Footnotes==\n{{reflist}}\n\n'
p204
tp205
a(I-1
S'{{Cleanup|date=February 2007}}\n\nMeta-Power is a concept of having control not simply of individuals, but of the social structures themselves.  The idea has stemmed from work by sociologists such as [[Tom R. Burns]] and Peter Hall, the economist Thomas Baumgartner, as well as by [[political scientist]]s such as [[James Rosenau]] and [[Stephen D. Krasner]].  Its study often uses the language of [[game theory]] since at some level, having meta-power over a group of people means that one can control the form of the game, thereby controlling the [[expected payoff|outcome]].\n\n==Background==\n[[Power (sociology)|Power]] and [[social control]] are typically conceptualized and investigated in terms of interpersonal or intergroup relationships in which one actor tries to get another to do something, usually against the latters will (e.g., Blau, 1964, Dahl, 1967; Burns and Buckley, 1976; Weber, 1968). That is, power is on the level of interaction or relationships involving situated contests between opposing actors (Hall, 1997). The object of power is more or less direct behavioral control. Such an approach to the study of power captures only a part of the power activities of groups, organizations, and states.\n\nA large, and historically more important part involves attempts to structure or re-structure the [[society|social]] and [[culture|cultural]] matrix within which power activities are played out; such structuring may involve the manipulation of institutional arrangements, norms, and values. A given institutional or socio-cultural structure may be viewed as the macroscopic resultant of the application of structural or meta-power to determine permissible or acceptable activities and relationships of individuals and groups to one another and to resources or forms of property. \n\n==Conceptualization==\nSince the mid-1970s there emerged a substantial body of work on meta-power or relational and structural control, that is control over social relationships and [[social structure]], the structuring of interaction situations and conditions, for instance the opportunity structures of the actors, their payoff structures and incentive systems, and their  orientations, beliefs, and norms vis a vis one another (Adler and Haas, 1992; Baumgartner and Burns, 1975; Baumgartner, Burns and DeVille, 1975; Baumgartner, Buckley, and Burns, 1975; Baumgartner et al., 1975, Baumgartner et al. 1975,  1976; 1977; Burns and Buckley (1976),  Chang, 2004; Hall, 1997, 2003; Himmelstrand et al., 1981; Hollist and Rosenau, 1981; Krasner, 1981; among others).\n\nAlthough structural types of control have specific behavioral consequences and may be used as a means of behavioral control, the purpose of its exercise is generally the long-term structuring of [[international relations#Institutions in international relations|institutional arrangements]], key social processes and their outcomes: the individual and collective activities of those whose social relationships are structured. Structural control is used by social groups to ensure the effective functioning of a social system and/or to promote or stabilize their advantages or dominance over others. Among other things, it may be used to encourage cooperative social organization on the one hand, or to produce competition or conflict between actors on the other, and generally, to increase power in relation to others. \n\nThere are at least three bases of structural control with respect to such systems: control of action opportunities, control of differential payoffs or outcomes of interaction, and control of cultural orientations and ideology. That is, conditions of social action and interaction are structured with the result that certain social relationships and institutional arrangements are established and maintained.\nIn investigations of the exercise of meta-power, one is also interested in differences among actors in resources, skills, strategies, and so forth, but the main focus is on capacities to mobilize power resources to manipulate the matrix of rules or the rules of the game, other conditions of interaction, and the distribution of resources as well as normative and ideological orientations. Meta-power entails the capacity to shape and set the limits of lower order power. Clearly, although an actor B may have social power within an interaction situation or game (e.g., greater ability than others to select a preferred outcome or to realize his will over the opposition of others within that social structural context (e.g., Dahl, Weber), he or she may or may not have power to structure social relationships, to alter the type of game the actors play, the rules and institutions and related conditions governing interactions or exchanges among the actors involved.\n\n==The Case of Capitalist Systems==\nWhen one speaks of power in connection with [[capitalism]], one typically thinks of the powers of the capitalists and their diverse lieutenants. But capitalist systems are characterized by structural forms of power, the exercise of meta-power and various forms of relational control (Himmelstrand et al.,1981).  These systems operate to change the world, not only in [[materialism|material]] terms ([[Manufacturing|production]] systems, products, [[infrastructure]]s as well as depletion of [[resource economics|resources]], [[pollution]] of the [[environmental economics|environment]], alteration of ecological systems) but in social and psychological terms (changing peoples levels of resources, their welfare; changing communities, occupations, lifestyles, cultural perspectives). Capitalist systems impact then not only on individuals, but communities, resource bases, and ecological systems. These are extraordinary powers shaping and reshaping human lives and destinies.\n\nThe multiple powers of capitalism is based on a complex of institutions, which are historical constructions of human agents: property regimes, production and distribution systems, managerial and accounting systems, finance and banking, etc. For [[Max Weber]], possession of property and the lack of property are the basic characteristics of all class situations, but capitalism is more than property regimes, it involves enterprises with their management and control systems, the organization of markets, financial complexes, banks, etc. These entail powers and dis-powers; classes, capitalist owners (whether individuals or collectives), top managers, expert advisors; supervisors, foremen, workers, excluded and marginalized groups  as in the case of any institutional arrangement. There is systematic organized bias distinguishing classes of  people in terms of possession of or access to powers in capitalist systems. And those lacking the means or access to the control functions of capitalism  or to the countervailing powers, for example, political -- are subject to it. \n\nThe powers of capitalism not only impact on our lives in myriad ways but transform us, operating as an external, in many ways invisible force to which most of us are subject. Of course, there are also capitalist agents, what [[Marx]] and [[Engels]] referred to as the bourgeoisie (Karl Marx and Frederick Engels, [[The Communist Manifesto]], 1848). Leading members of the bourgeoisie are powerful, but are nevertheless constrained  to act in particular ways. They are driven by the pursuit of profit and competition, and they rapidly develop and  improve instruments of production. Through developing facilitated means of communication, they draw all, even the most barbarian, nations into civilization. The cheap prices of commodities are the heavy artillery with which it [the bourgeoisie] forces the barbarians intensely obstinate hatred of foreigners to capitulate. It compels all nations, on pain of extinction, to adopt the bourgeois mode of production; it compels them to introduce what it calls civilization into their midst, i.e., to become bourgeois themselves. In one word, it creates a world after its own image.\n\n==Basic Types of Meta-Power==\nThe operation of meta-power on a systemic level, for example, capitalism as a complex of meta-power, can be distinguished from that of particular agents, the bourgeoisie, for instance their positional structuring powers (Himmelstrand et al., 1981; Burns, 2006): \n\n=== Structural meta-power ===\nStructural meta-power shapes and constrains the social conditions of social agents, their interactions, their opportunities, and limitations. For instance, institutions and institutional arrangements such as those of capitalism and the state entail organizational bias, that shapes opportunities, that provides careers, status, income, limited power over others as well as constrains certain activities and developments. Rules, procedures, and programs generate patterns of social activities, effects, and developments. Institutional selection may operate, for instance, to change the frequency of certain activity patterns or to alter the distribution of resources (concentration, and centralization, e.g. through ratchet effects), to determine the parameters of power, the forms and types of games actors play. A system like capitalism entails generative processes of meta-power (based on accumulative processes which provide the resource base (material, knowledge, social, political) combined with knowledge development to set in motion new economic and socio-technical developments.  Major socio-technical systems, once established, operate as legislative bodies shaping and reshaping human conditions. \n\n=== Agential meta-power ===\nAgential meta-power is where some agents shape particular structural conditions and institutional arrangements for other actors: to establish a constitution; to carry out substantial reforms, to restructure an industry, to transform social relationships and interaction opportunities and potentialities. The state launches projects, protects workers vis--vis their employers, supports (or blocks) the development of nuclear power, and outlaws certain chemicals, and, in general, regulates societal interactions with the environment. \n\nAmong the processes and developments in which meta-power researchers are interested, some involve powerful agents, for instance capitalist leaders, using their positions of structural power to mobilize resources in order to develop new systems of production, new products, new institutional arrangements, for example in the shaping of economic [[globalization]]. The initiatives may also come from state agencies, for example, to establish an infrastructure (airport, highway system, water system, electricity networks) or a regulatory agency; or, the initiative may come  from a dominant political leader or party with a mandate (possibly presumed) to reform or transform social conditions. One or more agents is  involved in mobilizing power resources for the purposes of launching a project(s), program(s), and institutional innovations. Such projects may be anticipated  or are experienced  by other agents as having positive and/or negative impacts, or possibly mixed consequences along with negative.  Opposition may emerge and try to block or modify the project(s). This is part of the dialectics of meta-power and social change, as analyzed and illustrated in a number of works of dating back to the mid-1970s. \n\n'
p206
tp207
a(I-1
S'Parental alienation syndrome (abbreviated as PAS) is term coined by [[Richard A. Gardner]] in the early 1980s to refer to what he describes as a disorder in which a child, on an ongoing basis, belittles and insults one parent without justification, due to a combination of factors, including indoctrination by the other parent (almost exclusively as part of a child custody dispute) and the childs own attempts to denigrate the target parent.<ref name = Gardner2001>{{cite journal | last = Gardner | first = RA | authorlink = Richard A. Gardner | title = Parental Alienation Syndrome (PAS): Sixteen Years Later | year = 2001 | journal = Academy Forum | volume = 45 | issue = 1 | url = http://www.fact.on.ca/Info/pas/gard01b.htm | pages = 10-12 | accessdate = 2009-03-31 }}</ref>  Gardner introduced the term in a 1985 paper, describing a cluster of symptoms he had observed during the early 1980s.<ref name = Gardner2001/>\n\nParental alienation syndrome is not recognized as a disorder by the medical or legal communities and Gardners theory and related research have been extensively criticized by legal and mental health scholars for lacking scientific validity and reliability.<ref name=Bernet2008/><ref name = Faller1998>{{cite journal | last = Faller | first = KC | year =1998 | title = The parental alienation syndrome: What is it and what data support it? | journal = Child Maltreatment | volume = 3 | issue = 2 | pages = 100115 | url = http://www.leadershipcouncil.org/docs/Faller1998.pdf  | format = pdf | doi = 10.1177/1077559598003002005}}</ref><ref name=Bruch2001>{{cite journal | last = Bruch | first = CS | coauthors = | year = 2001 | title = Parental Alienation Syndrome and Parental Alienation: Getting It Wrong in Child Custody Cases | journal = Family Law Quarterly | volume = 35 | issue = 527 | pages = 527-552 | url = http://www.law.ucdavis.edu/faculty/Bruch/files/fam353_06_Bruch_527_552.pdf  | format = pdf  }}</ref><ref name=Wood1994>{{cite journal | last = Wood | first = CL | year =1994 | title = The parental alienation syndrome: a dangerous aura of reliability | journal = Loyola of Los Angeles Law Review | volume = 29 | pages = 13671415 | url = http://fact.on.ca/Info/pas/wood94.htm | accessdate = 2008-04-12 }}</ref><ref name=Hoult2006/> However, the separate but related concept of [[parental alienation]], the estrangement of a child from a parent, is recognized as a dynamic in some divorcing families.<ref name=Bernet2008>{{cite journal | last=Bernet | first=W| title= Parental Alienation Disorder and DSM-V | journal = The American Journal of Family Therapy | volume = 36 | issue = 5 | year = 2008 | pages = 349-366 | doi = 10.1080/01926180802405513  | url =  }}</ref><ref>{{cite book|author=Rohrbaugh, Joanna Bunker |title=A comprehensive guide to child custody evaluations: mental health and legal perspectives |publisher= [[Springer Science+Business Media|Springer]] |location=Berlin |year=2008 |pages=[http://books.google.com/books?id=0W3QEqFWXdYC&pg=PA399 399-438] |isbn=0-387-71893-1 |oclc= |doi= |accessdate=}}</ref><ref name = Warshak2001/>\n\nThe [[Admissible evidence|admissibility]] of PAS has been rejected by an expert review panel and the [[Court of Appeal of England and Wales]] in the [[United Kingdom]] and [[Department of Justice (Canada)|Canadas Department of Justice]] recommends against its use, but has appeared in some [[family court]] disputes in the [[United States]].<ref name=Fortin2003>{{cite book | last = Fortin | first = Jane | title = Childrens Rights and the Developing Law | publisher = [[Cambridge University Press]] | year = 2003 | pages = [http://books.google.ca/books?id=etLxpQQQgocC&pg=PA263 263] | isbn = 9780521606486 }}</ref><ref name=Bainham2005>{{cite book | last = Bainham | first = Andrew | title = Children: The Modern Law | publisher = Jordans | year = 2005 | pages = [http://books.google.ca/books?id=FIFWXhTi5AYC&pg=PA161 161] | isbn = 9780853089391 }}</ref>  Gardner portrayed PAS as well accepted by the judiciary and having set a variety of [[precedent]]s, but legal analysis of the actual cases indicates this claim was incorrect.<ref name = Hoult2006/>  \n\nNo professional association has recognized PAS as a relevant medical syndrome or mental disorder, and it is not listed in the [[American Psychiatric Association]]s [[Diagnostic and Statistical Manual of Mental Disorders]].\n\n==Initial description==\nParental alienation syndrome was a term coined by child psychiatrist [[Richard A. Gardner]]  drawing upon his clinical experiences since the early 1980s.<ref name = Gardner2001/>  The concept of one parent attempting to separate their child from the other parent as punishment or part of a divorce have been described since at least the 1940s,<ref name=Bernet2008/><ref name = Warshak2001/> but Gardner was the first to define a specific syndrome.  In a 1985 article, he defined PAS as a disorder that arises primarily in the context of child-custody disputes. Its primary manifestation is the childs campaign of denigration against the parent, a campaign that has no justification. The disorder results from the combination of indoctrinations by the alienating parent and the childs own contributions to the vilification of the alienated parent<ref name = Gardner2001/> also stating that the indoctrination may be deliberate or unconscious on the part of the alienating parent.<ref name=Gardner2001b>{{cite journal | last = Gardner | first = Richard | title = Commentary on Kelly and Johnstons The Alienated Child: A Reformulation of Parental Alienation Syndrome | journal = Family Court Review | volume = 42 | issue = 4 | pages = 611-21 | year = 2004 | format = pdf | url = http://coleur.googlepages.com/GardnerrRichardACommentaryonKellyand.pdf}}</ref><ref name=Baker2007/>  PAS was originally developed of as an explanation for the increase in the number of reports of child abuse in the 1980s.<ref name=Jaffe2002/><ref name=Dallam1999/>  Gardner initially believed that parents (usually mothers) made false accusations of [[child abuse]] and [[child sexual abuse|sexual abuse]] against the other parent (usually fathers) in order to prevent further contact between them.<ref name = Caplan2004/><ref name=Brown2007>{{cite book | last = Brown | first = T | coauthors = Renata A | title = Child Abuse and Family Law: Understanding the Issues Facing Human Service and Legal Professionals | publisher = [[Allen & Unwin]] | date = 2007 | pages =[http://books.google.ca/books?id=USkixwfefC0C&pg=PA11 11-12] | isbn = 9781865087313 | url =}}</ref> While Gardner initially described the mother was the alienator in 90% of PAS cases, he later stated both parents were equally likely to alienate.<ref name=Jaffe2002>{{cite book | last = Jaffe | first = PG | coauthors = Lemon NKD; Poisson SE | title = Child Custody & Domestic Violence | publisher = [[SAGE Publications]] | year = 2002 | pages = [http://books.google.ca/books?id=bbZmp7ALOq4C&pg=PA52 5254] | isbn = 9780761918264 }}</ref><ref name=Gardner2002>{{cite journal | last = Gardner | first =RA | authorlink = Richard A. Gardner | year = 2002 | title = Denial of the Parental Alienation Syndrome Also Harms Women | journal = American Journal of Family Therapy | volume = 30 | issue = 3 | pages = 191202 | doi = 10.1080/019261802753577520}}</ref><ref>{{cite book |author=Baker AJL |title=Adult children of parental alienation syndrome: breaking the ties that bind |publisher= [[W. W. Norton & Company]] |location=New York |year=2007 |pages= |isbn=0-393-70519-6 |oclc= |doi= |accessdate=}}</ref>  He also later stated that in his experience accusations of sexual abuse were not present in the vast majority of cases of PAS.<ref name=Dallam1999/> The initial work was [[Self-publishing|self-published]] by Gardner, but later papers were released in [[peer review]]ed scientific journals.\n\n==Characteristics==\nGardner described PAS as a preoccupation by the child with criticism and deprecation of a parent.<ref name=Ackerman>{{cite book|last=Ackerman, Ph.D|first=Marc J. |title=Clinicians Guide to Child Custody Evaluations|publisher=John Wiley and Sons, |year=2002|pages=7382|isbn=9780471150916|url=http://books.google.ca/books?id=q9E_rg94Cs4C&pg=PA73}}</ref> Gardner stated that PAS occurs when, in the context of child custody disputes, one parent deliberately or unconsciously attempts to alienate a child from the other parent.<ref name=jaffe>{{cite book|last=Jaffe|first= Peter G. |coauthors= Lemon, Nancy K. D., Poisson, Samantha E.|title=Child Custody & Domestic Violence  |publisher=[[SAGE Publications]] |year=2002|pages=5254|isbn=9780761918264|url=http://books.google.ca/books?id=bbZmp7ALOq4C&pg=PA52}}</ref>   According to Gardner there PAS is characterized by clusters of eight symptoms that appear in the child. These include a campaign of denigration and hatred against the targeted parent; weak, absurd, or frivolous rationalizations for this deprecation and hatred; lack of the usual ambivalence about the targeted parent; strong assertions that the decision to reject the parent is theirs alone (the independent-thinker phenomenon); reflexive support of the favored parent in the conflict; lack of guilt over the treatment of the alienated parent; use borrowed scenarios and phrases from the alienating parent; and the denigration not just of the targeted parent but also to that parents extended family and friends.<ref name=Baker2007 /><ref name=Gardner2002 /><ref name=Walker2004 />  Despite frequent citations of these factors in scientific literature, the value ascribed to these factors has not been explored with professionals in the field.<ref name = Bow2009>{{cite journal | last = Bow | first = JN | coauthors = Gould JW; Flens JR | year = 2009 | title = Examining Parental Alienation in Child Custody Cases: A Survey of Mental Health and Legal Professionals | journal = The American Journal of Family Therapy | volume = 37 | issue = 2 | pages = 127145 | doi = 10.1080/01926180801960658 }}</ref>\n\nGardner and others have divided PAS into mild, moderate and severe levels. The number and severity of the eight symptoms displayed increase through the different levels. The recommendations for management differ according to the severity level of the childs symptoms. While a diagnosis of PAS is made based on the childs symptoms, Gardner stated that any change in custody should be based primarily on the symptom level of the alienating parent.<ref name=Gardner2006>{{cite book|last=Gardner|first=Richard A. |title=The International Handbook of Parental Alienation Syndrome: Conceptual, Clinical And Legal Considerations|editor=Gardner, Richard A.;  Sauber, S. Richard;  Lorandos, Demosthenes |publisher=Charles C. Thomas|date=2006|pages=5-11|chapter=Introduction|isbn= 978-0398076474}}</ref>  In mild cases, there is some parental programming against the targeted parent, but little or no disruption of visitation, and Gardner did not recommend court-ordered visitation. In moderate cases, there is more parental programming and greater resistance to visits with the targeted parent. Gardner recommended that primary custody remain with the programming parent if the brainwashing was expected to be discontinued, but if not that custody should be transferred to the targeted parent.  In addition, therapy with the child to stop alienation and remediate the damaged relationship with the targeted parent was recommended.  In severe cases, children display most or all of the 8 symptoms, and will refuse steadfastly to visit the targeted parent, including threatening to run away or commit suicide if the visitation is forced. Gardner recommended that the child be removed from the alienating parents home into a transition home before moving into the home of the targeted parent. In addition, therapy for the child is recommended.<ref name=Gardner2001 /><ref name=Walker2004 /><ref name=Gardner2006/>\nGardners proposed intervention for moderate and severe PAS, including court-ordered transfer to the alienated parent, fines, house arrest, incarceration, have been critiqued for their punitive nature towards the alienating parent and alienated child, and for the risk of abuse of power and violation of their civil rights.<ref name=Bala2007>{{cite journal|last=Bala|first=Nicholas|coauthors=, Fidler, Barbara-Jo,  Goldberg, Dan and Houston, Claire|date=2007|title=Alienated Children and Parental Separation: Legal Responses in Canadas Family Courts|journal=Queens Law Journal|volume=38|pages= 79-138 | url = http://scholar.google.ca/scholar?hl=en&lr=&q=info:pwdqOnkrT8IJ:scholar.google.com/&output=viewport&pg=1 }}</ref><ref name=Johnston2004>{{cite journal|last=Johnston|first=JR |coauthors=Kelly JB |date=2004|title=Rejoinder to Gardners Commentary on Kelly and Johnstons The Alienated Child: A Reformulation of Parental Alienation Syndrome|journal=Family Court Review|volume=42|issue=4|pages=622-628|doi = 10.1111/j.174-1617.2004.tb01328.x | url = http://www3.interscience.wiley.com/journal/118817173/abstract?CRETRY=1&SRETRY=0}}</ref>  With time, Gardner revised his views and expressed less support for the most aggressive management strategies.<ref name=Bala2007 />\n\n==Reception==\nGardners original formulation, which labeled mothers almost exclusively as the alienating parent, was endorsed by fathers rights groups, as it allowed fathers to explain the reluctance of their children to visit them and assign blame to their former wives.<ref name=Bala2007/><ref name=Ottaman2008 /> In contrast, womens groups criticized the syndrome, concerned that it permitted abusers to claim that allegations of abuse by mother or child were reflective of brainwashing.<ref name=Bala2007/> Gardner himself emphasized that PAS only applied in situations where there was no actual abuse or neglect had not occurred,<ref name=Hoult2006 >{{cite journal | last = Hoult | first = JA | year = 2006 | title = The Evidentiary Admissibility of Parental Alienation Syndrome: Science, Law, and Policy | journal = Childrens Legal Rights Journal | volume = 26 | issue = 1 | url = http://papers.ssrn.com/sol3/papers.cfm?abstract_id=910267 }}</ref><ref>{{cite journal | last = Gardner | first = RA | authorlink = Richard A. Gardner | title = Recommendations for Dealing with Parents who Induce a Parental Alienation Syndrome in their Children | journal = Journal of Divorce & Remarriage | year = 1998 | volume = 28 | issue = 3/4 | pages = 121 | doi = 10.1300/J087v28n03_01}}</ref> but by 1998, noted an increase in the awareness of PAS had led to an increase in its misapplication as an exculpatory legal maneuver.<ref name=Gardner2001b/> \n\nPAS has been cited in high-conflict divorce and child custody cases, particularly as a defense against accusations of domestic violence or sexual abuse.<ref name=Bruch2001/><ref name=Walker2004/> The status of the syndrome, and thus its admissibility in the testimony of experts, has been the subject of dispute about the extent to which PAS has been accepted by the professionals in the field, as well as a scientific methodology that is testable, has been tested, has a known error rate, has been published and is peer-reviewed.<ref name=Walker2004/> \n\nPAS has not been accepted by experts in [[psychology]], [[child advocacy]] or the study of [[child abuse]]<ref name = Wood1994/> or legal scholars.<ref name = Hoult2006/>  PAS has been extensively criticized by members of the legal and mental health community, who state that PAS should not be [[Admissible evidence|admissible]] in child custody hearings based on both science and law.<ref name=Bernet2008/><ref name=Bruch2001/><ref name=Wood1994/><ref name = Walker2004>{{cite journal | title = A Critical Analysis of Parental Alienation Syndrome and Its Admissibility in the Family Court  | journal = Journal of Child Custody | last = Walker | first = LEA | coauthors = Brantley KL; Rigsbee JA | volume = 1 | issue = 2 | year = 2004 | doi = 10.1300/J190v01n02_03 | pages = 47-74 | url =}}</ref><ref name=Drozd2009>{{cite book | last = Drozd | first = L | title = The Scientific Basis of Child Custody Decisions, 2nd Edition | editor = Galatzer-Levy RM; Kraus L & Galatzer-Levy J | publisher = [[John Wiley & Sons]] | date = 2009 | chapter = Rejection in cases of abuse or alienation in divorcing families | isbn = 9780470038581 | pages = [http://books.google.ca/books?id=_-z0OIjyPyEC&pg=PA403 403-416] | url=}}</ref>  PAS is not recognized by the [[American Medical Association]] or the [[American Psychiatric Association]].<ref name=Hoult2006 /><ref name=Dallam1999>{{cite book |last=Dallam | first = SJ | year =1999 | editors = St. Charles E; Crook L | title = Expose: The failure of family courts to protect children from abuse in custody disputes | publisher =Our Children Our Children Charitable Foundation | chapter = The Parental Alienation Syndrome: Is It Scientific? | url = http://www.leadershipcouncil.org/1/res/dallam/3.html}}</ref><ref name = Caplan2004>{{cite book | last = Caplan | first = PJ | title = Bias in psychiatric diagnosis | editor = Caplan PJ; Cosgrove L | publisher=[[Rowman & Littlefield]] | year = 2004 | pages = [http://books.google.ca/books?id=6XPLguPHzHoC&pg=PA62 62] | chapter = What is it thats being called Parental Alienation Syndrome | isbn = 9780765700018 | url = }}</ref><ref name=Comeford2009>{{cite book | last = Comeford | first = L | title = Encyclopedia of Gender and Society  | editor = OBrien J | publisher = [[SAGE Publications]] | date = 2009 | volume = 1 | pages = [http://books.google.ca/books?id=_nyHS4WyUKEC&pg=PA285 285] | chapter = Fatherhood Movements | isbn = 9781412909167 | url = }}</ref>  The [[American Psychological Association]] declined to give a position on PAS, but raised concerns over its lack of supporting data and how the term is used<ref name=APA1996>{{cite web | title = APA Statement on Parental Alienation Syndrome | url = http://www.apa.org/releases/passyndrome.html | publisher = [[American Psychological Association]] | year =1996 | location =Washington, DC | accessdate = 2009-03-31 }}</ref> and the APAs 1996 Presidential Task Force on Violence and the Family expressed concern that custody evaluators use PAS as a means of giving custody to fathers despite of a history of violence, a concern shared by other commentators.<ref name=Bruch2001/><ref name= Sparta2006/><ref>{{cite web | title =American Psychological Association Presidential Task Force on Violence And The Family | url= http://www.apa.org/pi/pii/familyvio/issue5.html | archiveurl = http://web.archive.org/web/20000307233013/www.apa.org/pi/pii/familyvio/issue5.html  | archivedate = 2000-03-07 | publisher= [[American Psychological Association]] | year=1996}}</ref> The United States National Council of Juvenile and Family Court Judges rejected PAS, recommending it not be used for the consideration of child custody issues.<ref name=Ottaman2008>{{cite book | last = Ottaman | first = A | coauthors = Lee R | title = Encyclopedia of Interpersonal Violence | editor =  Edleson JL; Renzetti, CM | publisher = [[SAGE Publications]] | year = 2008 | pages = [http://books.google.ca/books?id=BOKAMXEA_jQC&pg=PA252 252] | chapter = Fathers rights movement | isbn = 978-1412918008 | url = }}</ref>   \n\n===Relation to the DSM===\nPAS is not included in the [[Diagnostic and Statistical Manual of Mental Disorders]] (DSM).<ref name=Hoult2006 /><ref name=Dallam1999/><ref name = Caplan2004/><ref name=Comeford2009/>  In 2002, Gardner urged therapists, parents and lawyers to write to the committees working on the fifth publication of the DSM to give evidence that it exists and to include PAS in the next version.<ref name = Caplan2004/><ref name=Gardner2002/>  Gardner stated that it was not included in the 1994 release of the DSM due to a lack of peer reviewed articles, but since then many new publications and court rulings have been released.<ref name=Gardner2002>{{citation | last = Gardner | first = RA | authorlink = Richard A. Gardner | title = PAS and the DSM-V: A Call for Action | publisher = [[Mens News Daily]] | date = 2002-10-06 | accessdate = 2009-05-06 | url = http://mensnewsdaily.com/archive/g/gardner/gardner100602.htm}}</ref>  In a survey of American custody evaluators, half of the respondents disagreed with its inclusion, while a third thought it should be.<ref name=Baker2007>{{cite journal | last = Baker| first = AJL | year = 2007 | title = Knowledge and Attitudes About the Parental Alienation Syndrome: A Survey of Custody Evaluators | journal = American Journal of Family Therapy | volume = 35 | pages = 119 | doi = 10.1080/01926180600698368}}</ref>\n\nIn 2008, psychiatrist William Bernet argued that parental alienation disorder, a clinical entity related to, but distinct from, PAS should be included in the next version of the DSM.<ref name=Bernet2008/>\n\n===Scientific status===\nGardners formulation of PAS is critiqued as lacking a scientific basis,<ref name = Emery2005>{{cite journal | last = Emery | first = RE | title = Parental Alienation Syndrome: Proponents bear the burden of proof | journal = Family Court Review | volume = 43 | issue = 1 | pages = 8-13 | year = 2005 | format = pdf | url = http://www.ncdsv.org/images/PASProponentsBeartheBurdenofProof_Emery_2005.pdf }}</ref><ref name=bond2008>{{cite journal|last=Bond|first=Richard|date=2008|title=The Lingering Debate Over the Parental Alienation Syndrome Phenomenon|publisher=Journal of Child Custody|volume=4|issue=1|pages=37-54}}</ref><ref name=Martindale2008>{{cite book |author=Martindale, David; Gould, Jonathan W. |title=The Art and Science of Child Custody Evaluations |publisher=The Guilford Press |location=New York |year=2007 |pages= |isbn=1-59385-488-9 |oclc= |doi= |accessdate=}}</ref> and as a [[hypothesis]] whose proponents have failed to meet the scientific [[burden of proof]] to establish its existence.<ref name=Hoult2006 /><ref name=Emery2005 /><ref name=Martindale2008/> The first publications about PAS were [[self-publishing|self-published]] and not [[peer review]]ed,<ref name = Warshak2001/> and though there have been subsequent articles have been published in peer reviewed journals, most have consisted of [[anecdotal evidence]] in the form of [[Case study|case studies]];<ref name=Ackerman2001 /><ref>{{cite journal | url = http://www.ndaa.org/publications/newsletters/update_volume_16_number_6_2003.html | title = Parental Alienation Syndrome: What Professionals Need to Know Part 1 of 2 Update | volume = 16 | issue = 6 | year = 2003 | last = Ragland | first = ER | coauthors = Fields H | journal = American Prosecutors Research Institute Newsletter }}</ref> in addition, the limited research into PAS has lacked evidence of its [[validity]] and [[reliability]].<ref name=Bruch2001/><ref name=Wood1994/>\nThe lack of objective research and [[replication (statistics)|replication]], [[falsifiability]], and independent publication has led to claims that PAS is [[pseudoscience]] or junk science.<ref name=Emery2005 /><ref name=bond2008 /><ref name=Faller1998 />  Proponents of PAS concur that large scale systematic [[Scientific control|controlled studies]] into PASs validity and reliability are required,<ref name=Warshak2001 /><ref name=Baker2007 /><ref name=Warshak2003>{{cite journal|last=Warshak|first=Richard A. |title=Bringing sense to Parental Alienation: A Look at the Disputes and the Evidence|journal=Family Law Quarterly|volume=37|issue=2|pages=273-301}}</ref>  supplementing a single small study in 2004 which suggested practitioners could come to a consensus based on written reports.<ref name=Drozd2009/>\n\nThe theoretical foundation of PAS has been described as incomplete, simplistic and erroneous for ignoring the multiple factors (including the behaviors of the child, parents and other family members) that may contribute to [[parental alienation]], family dysfunction and a breakdown in [[Attachment (psychology)|attachment]] between a parent and a child.<ref name = Warshak2001>{{cite journal | last = Warshak | first = RA | year = 2001 | title = Current controversies regarding parental alienation syndrome | journal = American Journal of Forensic Psychology | volume = 19 | issues = 3 | pages = 29-59 | format = pdf | url = http://www.rhfinc.org.au/docs/controversies.pdf }}</ref><ref name=Jaffe2002/><ref name= Sparta2006/><ref name=Ackerman2001>{{cite book | author = Ackerman MJ | title = Clinicians guide to child custody evaluations | publisher = [[John Wiley & Sons]] | location = New York | year = 2001 | pages = [http://books.google.ca/books?id=q9E_rg94Cs4C&pg=PA73 73-82] | isbn = 0-471-39260-X | oclc = | doi = | accessdate = }}</ref><ref name=Waldron1996>{{cite journal | last = Waldron | first = KH | coauthors = Joanis DE | url = http://fact.on.ca/Info/pas/waldron.htm | title = Understanding and Collaboratively Treating Parental Alienation Syndrome | journal = American Journal of Family Law | volume = 10 | pages = 121133 | year = 1996 }}</ref> In this view, PAS confuses a childs developmental reaction to a divorce with [[psychosis]], vastly overstates the number of [[false allegations of child sexual abuse]], ignores the [[scientific literature]] suggesting most allegations of child sexual abuse are well founded and thus well-meaning efforts to protect a child from an abusive parent, exaggerates the damaging effects of parental alienation on children and proposes an unsupported and endangering remedy for PAS.<ref name = Bruch2001/><ref name = Drodz2009>{{cite book | last = Drozd | first = L | title = The Scientific Basis of Child Custody Decisions, 2nd Edition | editor = Galatzer-Levy RM; Kraus L & Galatzer-Levy J | publisher = [[John Wiley & Sons]] | date = 2009 | chapter = Rejection in cases of abuse or alienation in divorcing families | isbn = 9780470038581 | pages = [http://books.google.ca/books?id=_-z0OIjyPyEC&pg=PA403 403-416] | url=}}</ref>  \nConcern has been expressed that PAS lacks adequate scientific support to be considered a syndrome, and that Gardner has promoted PAS as a syndrome based on a vague clustering of behaviors.<ref name = Warshak2001/><ref name = Caplan2004/>  Despite concerns about the validity of testimony regarding PAS, it has been  inappropriately viewed as reliable by family court judges.<ref name = Hoult2006/>   Proponents of PAS and others agree that using the designation of syndrome may be inappropriate as it implies more scientific legitimacy than it currently deserves.<ref name=Warshak2003 /><ref name=Bala2007 /><ref name=Ackerman />  \n\nWhile PAS is not accepted as a syndrome, parental alienation is a somewhat less controversial dynamic that has appeared in the mental health and legal literature.<ref name = Bow2009/><ref name = Bala2007>{{cite journal | last = Bala | first = N | coauthors = Fidler B; Goldberg D; Houston C | year = 2007 | journal = Queens Law Journal | volume = 33 | title = Alienated Children and Parental Separation: Legal Responses from Canadas Family Courts | pages = 79-138}}</ref>\n\n===Clinical status===\nPAS has been criticized for making [[Clinical psychology|clinical work]] with children who are alienated more confusing<ref name = Warshak2001/> and Gardners analysis as been criticized for inappropriately assigning all responsibility of the childs behavior to one parent when the childs behavior is oftentimes, but not always, the result of a dynamic in which both parents and the child play a role.<ref name=Johnston2004 /><ref name=Waldron1996/>\n\nGardner disagreed with criticism of PAS as overly simplistic, stating that while there are a wide variety of causes on why a child may become alienated from a parent, the primary etiological factor in cases of PAS is the brainwashing parent, and that otherwise, there is no PAS.<ref name=Gardner2001b/>  Gardner also stated that those initially critical of PAS for being a [[caricature]] were not directly involved with families in custody disputes and that criticisms of this nature faded by the late 1980s because the disorder was widespread.<ref name=Gardner2001/>\n\n===Views of PAS as sexist===\nPAS has been criticized by for being sexist, being used by fathers to marginalize legitimate fears and concerns about abuse, and womens groups and others oppose the legitimacy of PAS as a danger to children.<ref name= Sparta2006>{{cite book | last = Sparta | first = SN | coauthors = Koocher GP | title = Forensic Mental Health Assessment of Children and Adolescents | publisher = [[Oxford University Press]] | year = 2006 | pages = [http://books.google.ca/books?id=6bmBtQ2Zl-IC&pg=PA83 83], [http://books.google.ca/books?id=6bmBtQ2Zl-IC&pg=PA219 219221] | isbn = 9780195145847 }}</ref>  After his initial publications, Gardner revised his theory to make fathers and mothers equally likely to alienate or be indoctrinators and disagreed that recognition of PAS is sexist.  Garner later indicated he believed men were equally likely to be PAS indoctrinators.<ref name=Gardner2001b/>  Studies of children and adults labelled as suffering from PAS have suggested that mothers were more likely than fathers to be the alienator.<ref name=Baker2007/>\n\n==In courts==\n===Canada===\nEarly Canadian court cases accepted expert opinions about PAS, used the term syndrome and concurred with Gardners theory that only one parent was fully responsible for it. Gardner testified in one case (Fortin v. Major, 1996) but the court did not accept  his opinion, concluding that the child was not alienated based on the evaluation of a court-appointed expert who, unlike Gardner, had met with the family members.<ref name=Bala2007 />  More recent cases, while accepting the concept of alienation, have noted the lack of recognition in the DSM-IV, and have generally avoided syndrome terminology, emphasizing that changes in custody are stressful for the child and should only occur in the most severe cases.<ref name=Bala2007 />  A 2006 research report by the [[Department of Justice (Canada)|Canadian Department of Justice]] described PAS as empirically unsupported and favored a different framework for dealing with issues of alienation that has more research support.<ref>{{citation | last = Jaffe | first = PG | coauthors = Crooks CV & Bala N | publisher = [[Department of Justice (Canada)|Department of Justice]] | year = 2006 | title = Making Appropriate Parenting Arrangements in Family Violence Cases: Applying the Literature to Identify Promising Practices | url = http://www.justice.gc.ca/eng/pi/pad-rpad/rep-rap/2005_3/2005_3.pdf | format = pdf | accessdate = 2009-05-05}}</ref> Decisions about possible parental alienation are considered a legal decision, to be determined by the judge based on the facts of the case, rather than a diagnosis made by a mental health professional. There is recognition that rejection of a parent is a complex issue, and that a distinction must be made between pathological alienation and reasonable estrangement.<ref name=Bala2007 />\n\n===United Kingdom===\nIn the [[United Kingdom]], the admissibility concerning the evaluation of PAS was rejected both in an expert review,<ref>{{cite journal | last = Sturge | first = C | coauthors = Glaser D | title = Contact and domestic violence  the experts court report | journal = Family Law| volume = 615 | year = 2000 }}</ref> and by the [[Court of Appeal of England and Wales|Court of Appeal]].<ref name= Fortin2003/><ref name = Bainham2005/>\n\n===United States===\nPAS has been cited as part of the [[child custody]] determination process in the [[United States]].<ref name = Fortin2003/>  Based on the evaluation of PAS, courts in the US have awarded sole custody to some fathers.<ref name = Hoult2006/>  PAS has been challenged under the [[Scientific evidence (law)#Frye test|Frye test]], to evaluate if it has been accepted by the scientific community.<ref name = Hoult2006/><ref>{{cite book |author=Myers, John E. B. |title=Myers on evidence in child, domestic, and elder abuse cases |publisher= [[Wolters Kluwer|Aspen Publishers]] |location=Gaithersburg, Md |year=2005 |pages= [http://books.google.com/books?id=-krZZF9dl-sC&pg=PA415 415] |isbn=0-7355-5668-7 |oclc= |doi= |accessdate=}}</ref>  Despite Gardner claiming PAS was generally accepted by the scholarly community and passed the Frye test in two states,<ref name=Gardner2001b/> a 2006 analysis of court cases involving PAS and cited by Gardner concluded that these decisions did not set legal precedent, that PAS is viewed negatively in most legal scholarship, and that Gardners writings do not support the existence of PAS.  Of sixty-four precedent-bearing cases, only two decisions, both in [[New York State]] and both in [[Criminal justice|criminal courts]] actually set precedents.  Both held PAS inadmissible and one case found that PAS failed the Frye test as the appropriate professional community did not generally accept; this decision was upheld in an [[appellate court]].  Gardner listed fifty cases on his website that he claimed set precedents that made PAS admissible, but none actually did; forty six set no precedents or did not discuss admissibility and the remaining four were problematic.  One case stated that PAS passed the Frye test, but the appeal did not discuss the Frye test and actually [threw] out the words parental alienation syndrome and focused on the willingness and ability of each parent to facilitate and encourage a close and continuing relationship between the parents and the child.  In the second case the appellate court did not discuss PAS; the third case specifically chose not to discuss the admissibility of PAS and the fourth made no decision on PAS.<ref name = Hoult2006/>\n\n==Reformulations==\nSince Gardner proposed PAS, other researchers in the field have suggested focussing less on diagnosing a syndrome and more on what has been described as the alienated child, and the dynamics of the situation that have contributed to the alienation.<ref name=Jaffe2002 /><ref name=Bala2007 /> In this view, alienation is seen as a breakdown of [[Attachment (psychology)|attachment]] between parent and child, and may be caused by multiple factors.  The behaviors of all family members, including those of the alienated parent, may lead to the family dysfunction and rejection of a parent.<ref name=Ackerman2001 /><ref name=Waldron1996/>  The evaluation of all contributing factors and all possible remedies are recommended in evaluating cases where children has estranged from a parent.<ref name=Bala2007 /><ref name=Sparta2006 />\n\n'
p208
tp209
a(I1
S'{{Unreferenced|date=June 2008}}\n[[Image:BessTrumanGirlScoutsARC200404.gif|thumb|200px|American First Lady [[Bess Truman]] with Girls Scouts and their volunteer leaders]]\nAn avocation is an activity that a person does as a [[hobby]] outside their main occupation. There are many examples of people whose profession was the way they made a living, but whose activities outside their workplace were their true passion in life.\n\nMany times a persons regular [[vocation]] may lead to their avocation. Many forms of humanitarian campaigning, such as work for organizations such as [[Amnesty International]] and [[Greenpeace]] may be done by people involved in the [[law]] or [[human rights]] issues as part of their work.<ref name=10202006Boyd>Boyd, B. (2006, October 20). A secret history of the old Ball game. Irish Times. Retrieved July 04, 2007, from http://www.irishtimes.com/theticket/articles/2006/1020/1160606784745.html</ref>\n\n'
p210
tp211
a(I1
S'{{Infobox Engineer\n|image                = \n|image_size           = (if image is smaller than 250px)\n|caption              =    \n|name                 =    Dr. Mohamed Dadkhah\n|nationality          = Iran\n|birth_date           =    [[1910]]\n|birth_place          =    \n|death_date           =    [[1980]]\n|death_place          =    \n|education            =    \n|spouse               =    \n|parents              =    \n|children             =    \n|discipline           =    \n|institutions         =   Iranian Philatelic Society\n|practice_name     =     \n|significant_projects =    Wrote the book The Lion Stamps of Persia \n|significant_design   =     \n|significant_advance  =    \n|significant_awards   =   [[Crawford Medal]] <br/> [[APS Hall of Fame]] \n}}\n\nDr. Mohamed Dadkhah (1910-1980), was a world-renown [[Philately|philatelist]] of [[Iran]].\n\n==Collecting interests==\nDr. Dadkhah specialized in the collection of postage stamps of Iran and [[Bushehr|Bushire]].  His collections were outstanding, and his Iran presentation at the philatelic exhibition PHILYMPIA in 1970 at [[London]] won him the gold award.\n\n==Philatelic literature==\nDr. Dadkhah, in 1960, wrote the book Emissions du Type Lion de lIran 1865-1879 (also entitled The Lion Stamps of Persia in English) and received the Crawford Medal for his effort.\n\n==Philatelic activity==\nDr. Dadkhah was active in the Iranian Philatelic Society which he founded, and remained president of, for the remainder of his life.\n\n==Honors and awards==\nDr. Dadkhah was awarded the [[Crawford Medal]] in 1961, and he signed the Roll of Distinguished Philatelists in 1965. In 1983, he was named to the [[American Philatelic Society Hall of Fame]].\n\n'
p212
tp213
a(I1
S'{{Otheruses2|Twister}}\n{{Infobox Film\n| name           = Twister\n| image          = Twistermovieposter.jpg\n| caption        = theatrical poster\n| director       = [[Jan de Bont]]\n| producer       = [[Ian Bryce]]<br />[[Michael Crichton]]<br />[[Kathleen Kennedy (movie producer)|Kathleen Kennedy]]\n| writer         = Michael Crichton<br />Anne-Marie Martin\n| starring       = [[Helen Hunt]]<br>[[Bill Paxton]]<br>[[Jami Gertz]]<br>[[Cary Elwes]]<br>[[Philip Seymour Hoffman]]<br>[[Alan Ruck]]<br>[[Zach Grenier]]\n| music          = [[Mark Mancina]]\n| cinematography = [[Jack N. Green]]\n| editing        = [[Michael Kahn (film editor)|Michael Kahn]]\n| studio         = [[Amblin Entertainment]]\n| distributor    = USA/Canada<br>[[Warner Bros.]]<br>International<br>[[Universal Studios]]\n| released       = [[May 10]], [[1996]]\n| runtime        = 113 minutes\n| country        = [[United States]]\n| awards         = [http://imdb.com/title/tt0117998/awards]\n| language       = [[English language|English]]\n| budget         = [[United States dollar|US$]]92,000,000 (estimated)\n| gross          = $494,471,524   \n| preceded_by    = \n| followed_by    = \n}}\n\nTwister is a {{fy|1996}} [[Cinema of the United States|American]] [[disaster film]] starring [[Helen Hunt]] and [[Bill Paxton]] as [[Storm chasing|storm chasers]]  researching [[tornado]]es. It was directed by [[Jan de Bont]]. The film was based upon a script by [[Michael Crichton]] and [[Anne-Marie Martin]]. Twister was the second-highest grossing film of 1996, with an estimated 55 million tickets sold.\n\nIn the movie, a team of storm chasers try to perfect a data-gathering instrument, designed to be released into the funnel of a tornado, while competing with another better-funded team with a similar device during a [[tornado outbreak]] across [[Oklahoma]].  \n\nTwister is notable for being both the first Hollywood feature film to be released on the [[DVD]] format<ref>[http://www.imdb.com/title/tt0117998/trivia Twister (1996) - Trivia<!-- Bot generated title -->]</ref> and the last to be released on [[HD DVD]].<ref>[http://hddvd.highdefdigest.com/releasedates_historical.html HD DVD Disc Historical Release Dates | High Def Digest<!-- Bot generated title -->]</ref> Twister has since been released in [[High-definition video|high definition]] on [[Blu-ray disc]]. It was nominated for two [[69th Academy Awards| Academy Awards]] for [[Best Visual Effects]] and [[Best Sound]] in 1997.\n\n==Plot==\n\nThe film begins in June 1969 on a rural Oklahoma farm as severe weather looms. A family (including five-year-old Jo) seeks shelter in a storm cellar as an F5 tornado strikes. However, the storm is so strong that the locks on the cellar door fail and Jos father is caught up in the storm and killed as young Jo struggles to catch a glimpse of the powerful storm.  \n\nYears later, Dr. Jo Harding (Hunt) is reunited with her estranged husband, Bill Harding (Paxton). Bill is a former weather researcher and storm chaser who has taken a job as a weather reporter.  He is planning to marry his new girlfriend, Dr. Melissa Reeves, and arrives at Jos research lab seeking Jos signature for the final divorce papers. Bill discovers that Jo has built a tornado research device called DOROTHY based upon his own design; the device is designed to release hundreds of sensors into the center of a tornado to study its structure.  The team later meets up with Dr. Jonas Miller, a smug and unscrupulous (but well-funded) fellow meteorologist and storm chaser.  When Bill discovers that Jonas has invented a device almost identical to DOROTHY, he vows to help Jo deploy DOROTHY before Miller can claim credit for the idea.  Bill and Melissa join Jo and her eccentric team of storm chasers.\n\nTensions rise between Jo and Bill when they have several close calls with dangerous tornadoes as the team tries unsuccessfully to deploy the new device.  One tornado hits [[Wakita, Oklahoma]], destroying the home of Jos aunt Meg. Melissa, frightened by the dangers of storm chasing and recognizing the unresolved feelings between Jo and Bill, leaves. The team then attacks their goal with even more fervor, chasing an increasingly intense storm in an attempt to deploy DOROTHY.  The rival teams hubris and lack of instinct proves fatal as their lead truck is caught up in a tornado due to overzealous chasing, despite Bills warnings.  \n\nEventually Jo and Bill set out on their own and, in a risky maneuver, are able to deploy DOROTHY successfully, surviving a direct contact with a huge tornado and re-sealing their personal bond in the process.\n\n==Main characters==\n*Dr. Jo Harding ([[Helen Hunt]]): The leader of her storm-chasing research team. \n*Bill Harding ([[Bill Paxton]]): Jos estranged husband and former fellow storm-chaser.\n*Dustin Dusty Davis ([[Philip Seymour Hoffman]]): A wise-cracking member of Jos chase team. \n*Robert Rabbit Nurick ([[Alan Ruck]]): The navigator for Jos chase team. \n*Laurence: ([[Jeremy Davies (actor)|Jeremy Davies]]): A quiet member of the team, in charge of photographing tornadoes on film. \n*Joey: ([[Joey Slotnick]]): In charge of taking measurements of wind and taking care of their doppler radar.\n*Alan Sanders ([[Sean Whalen]]): Rabbits driver, usually chastised by Rabbit for folding instead of rolling the maps.\n* Tim Beltzer Lewis ([[Todd Field]]): Driver of the van that holds the doppler and one of the more wild, and dedicated, members of the team.\n*Haynes ([[Wendle Josepher]]): The youngest member (and only other female) of the team, rides with Beltzer.\n*Jason Preacher Rowe: ([[Scott Thomson (actor)|Scott Thomson]]): Member of Jos team, called Preacher because of the numerous religious references he gives.\n*Dr. Melissa Reeves ([[Jami Gertz]]): Bills new fiancee.  \n*Aunt Meg Greene ([[Lois Smith]]): Jos aunt and mother-figure to her team.\n*Dr. Jonas Miller ([[Cary Elwes]]): The leader of the rival storm-chasing team. \n*Eddie ([[Zach Grenier]]): Jonas reluctant assistant.\n*Young Jo ([[Alexa Vega]]): Witnesses her father  killed by a powerful tornado.\n\n==Production==\nTwister was a joint production between [[Warner Bros.]] and [[Universal Studios]]. (This fact is reflected in the movies comprising a double-bill advertised on the marquee of a [[drive-in theater]] featured in the film: [[The Shining (film)|The Shining]], a Warner Bros. release, and [[Psycho (1960 film)|Psycho]], a Universal owned production). Both studios had often collaborated with another of the films production companies, [[Amblin Entertainment]], prior to this film.\n\nAfter spending more than half a year on pre-production on [[Godzilla (1998 film)|Godzilla]], director Jan De Bont left after a dispute over the budget and quickly signed on for Twister.<ref name=Daly>{{cite news|last=Daly |first=Steve |title=The War of the Winds |work=[[Entertainment Weekly]] |date=May 17, 1996 |url=http://www.ew.com/ew/article/0,,292610,00.html |accessdate=2009-06-14}}</ref> The production was plagued with numerous problems. [[Michael Crichton]] and his wife, Anne-Marie Martin, were paid a reported $2.5 million to write the screenplay. [[Joss Whedon]] was brought in to do rewrites through the early spring of 1995. When he got [[bronchitis]], [[Steve Zaillian]] was brought in. Whedon returned and worked on revisions right through the start of shooting in May 1995. He left the project after getting married and two weeks into production, [[Jeff Nathanson]] was flown in to the set and worked on the script until principal photography ended.<ref name=Daly/>\n\nHalfway through filming both Bill Paxton and Helen Hunt were temporarily blinded by bright electronic lamps used to get the exposure down to make the sky behind the two actors look dark and stormy because it was too bright outside. Paxton remembers, and these things literally sunburned our eyeballs. I got back to my room, I couldnt see.<ref name=Daly/> To solve the problem, a Plexiglas filter was placed in front of the beams. The actors took eye drops and wore special glasses for a few days to recuperate. After filming in a ditch that contained bacteria, Hunt and Paxton had to have hepatitis shots. During the same scene, she repeatedly hit her head on a low wooden bridge because she was so exhausted from the demanding shoot that she forgot not to stand up so quickly.<ref name=Daly/> Hunt did one stunt in which she opened the door of a vehicle that was speeding through a cornfield, stood up on the passenger side and was hit by the door on the side of her head when she let it go momentarily. As result, some sources claim that Hunt got a concussion. De Bont said, I love Helen to death, but you know, she can be also a little bit clumsy, to which she responded, Clumsy? The guy burned my retinas, but Im clumsy ... I thought I was a good sport. I dont know ultimately if Jan chalks me up as that or not, but one would hope so.<ref name=Daly/>\n\nSome crew members felt De Bont was out of control and left five weeks into filming.<ref name=Daly/> The camera crew led by [[Don Burgess (cinematographer)|Don Burgess]] left the production after five weeks, claiming that De Bont didnt know what he wanted till he saw it. He would shoot one direction, with all the equipment behind the view of the camera, and then hed want to shoot in the other direction right away and wed have to move [everything] and hed get angry that we took too long ... and it was always everybody elses fault, never his.<ref name=Daly/> De Bont claims that they had to make schedules for at least three different scenes every day because the weather changed so often that Don had trouble adjusting to that.<ref name=Daly/> When De Bont knocked over a camera assistant who had missed a cue, Burgess and his crew left, much to the shock of the cast. Burgess and his crew stayed on one more week until a replacement was found in [[Jack N. Green]]. Just before the end of the shoot, Green was injured when a hydraulic house set, designed to collapse on cue, was mistakenly activated with him inside it. A rigged ceiling hit him in the head and he injured his back and had to go to the hospital. Green missed the last two days of principal photography and De Bont took over as his own director of photography.<ref name=Daly/>\n\nDe Bont had to shoot many of the films tornado-chasing scenes in bright sunlight when they could not get overcast skies and asked [[Industrial Light & Magic]] to more than double its original plan for 150 digital sky-replacement shots.<ref name=Daly/> Principal photography had a certain time limit because Hunt had to return to film another season of [[Mad About You]] but [[Paul Reiser]] was willing to delay it for two-and-a-half weeks when the Twister shoot was extended. De Bont insisted on using multiple cameras and this led to the exposure of 1.3 million feet of raw film (most films use no more than 300,000 feet).<ref name=Daly/>\n\nDe Bont claims that Twister cost close to $70 million with $23 million going to the director. It was speculated that last-minute re-shoots in March and April 1996 (to clarify a scene about Jo as a child) and overtime requirements in post-production and at ILM, raised the budget to $90 million.<ref name=Daly/> Warner Bros. moved up the films release date from May 17 to May 10 in order to give it two weekends before [[Mission: Impossible (film)|Mission: Impossible]] opened.\n\n==Soundtrack==\nTwister featured both a traditional orchestral film score (by [[Mark Mancina]]) and several [[rock music]] songs, including an instrumental theme song composed and performed for the film by [[Van Halen]].  Both the rock soundtrack and the orchestral score were released separately on [[compact disc]].\n\n====Rock Score====\n#[[Van Halen]] - [[Humans Being]]\n#[[Rusted Root]] - Virtual Reality \n#[[Tori Amos]] -  Talula(BTs Tornado Mix)\n#[[Alison Krauss]] - Moments Like This\n#[[Mark Knopfler]] - Darling Pretty\n#[[Soul Asylum]] - Miss This\n#[[Belly (band)|Belly]] - Broken\n#[[K.D. Lang]] - Love Affair\n#[[Nine Stories]] Feat. [[Lisa Loeb]] - How\n#[[Red Hot Chili Peppers]] - Melancholy Mechanics\n#[[Goo Goo Dolls]] - Long Way Down\n#[[Shania Twain]] - No One Needs to Know\n#[[Stevie Nicks]] Feat. [[Lindsey Buckingham]] - Twisted\n#[[Edward Van Halen|Edward]] And [[Alex Van Halen]] - [[Respect the Wind]]\n\n====Orchestral Score====\n#Oklahoma: Wheatfield\n#Oklahoma: Wheres My Truck?\n#Oklahoma: Futility\n#Oklahoma: Downdraft\n#Its Coming: Drive In\n#Its Coming: The Big Suck\n#The Hunt: Going Green\n#The Hunt: Sculptures\n#The Hunt: Cow\n#The Hunt: Ditch\n#The Damage: Wakita\n#Hailstorm Hill: Bobs Road\n#Hailstorm Hill: Were Almost There\n#F5: Dorothy IV\n#F5: Mobile Home\n#F5: Gods Finger\n#Other: William Tell Overture/Oklahoma Medley\n#Other: End Title/Respect the Wind - written by Edward and Alex Van Halen\n\n==Reception==\n[[Roger Ebert]] gave the film two-and-a-half stars out of four and wrote, You want loud, dumb, skillful, escapist entertainment? Twister works. You want to think? Think twice about seeing it.<ref name=Ebert>{{cite news|last=Ebert |first=Roger |title=Twister |work=[[Chicago Sun-Times]] |date=May 10, 1996 |url=http://rogerebert.suntimes.com/apps/pbcs.dll/article?AID=/19960510/REVIEWS/605100302/1023 |accessdate=2009-09-03 }}</ref> In her review for [[The New York Times]], [[Janet Maslin]] wrote, Somehow Twister stays as uptempo and exuberant as a roller-coaster ride, neatly avoiding the idea of real danger.<ref name=Maslin>{{cite news|last=Maslin |first=Janet |title=Twister |work=[[The New York Times]] |date=May 10, 1996 |url=http://www.nytimes.com/library/filmarchive/twister.html |accessdate=2009-09-03 }}</ref> [[Entertainment Weekly]] gave the film a B rating and Lisa Schwarzbaum wrote, Yet the images that linger longest in my memory are those of windswept livestock. And that, in a teacup, sums up everything thats right, and wrong, about this appealingly noisy but ultimately flyaway first blockbuster of summer.<ref name=Schwarzbaum>{{cite news|last=Schwarzbaum |first=Lisa |title=Twister |work=[[Entertainment Weekly]] |date=May 24, 1996 |url=http://www.ew.com/ew/article/0,,292676,00.html |accessdate=2009-09-03 }}</ref> In his review for the [[Los Angeles Times]], Kenneth Turan wrote, But the ringmaster of this circus, the man without whom nothing would be possible, is director De Bont, who now must be considered Hollywoods top action specialist. An expert in making audiences squirm and twist, at making us feel the rush of experience right along with the actors, De Bont choreographs action and suspense so beautifully he makes it seem like a snap.<ref name=Turan>{{cite news|last=Turan |first=Kenneth |title=Twister |work=[[Los Angeles Times]] |date=May 10, 1996 |url=http://www.calendarlive.com/movies/reviews/cl-movie960513-6,0,4826494.story |accessdate=2009-09-03 }}</ref> [[Time (magazine)|Time]] magazines [[Richard Schickel]] wrote, when action is never shown to have deadly or pitiable consequences, it tends toward abstraction. Pretty soon youre not tornado watching, youre special-effects watching.<ref name=Schickel>{{cite news|last=Schickel |first=Richard |title=Twister |work=[[Time (magazine)|Time]] |date=May 20, 1996 |url=http://www.time.com/time/magazine/article/0,9171,984563,00.html?iid=digg_share |accessdate=2009-09-03 }}</ref> In his review for the [[Washington Post]] Desson Howe wrote, its a triumph of technology over storytelling and the actors craft. Characters exist merely to tell a couple of jokes, cower in fear of downdrafts and otherwise kill time between tornadoes.<ref name=Howe>{{cite news|last=Howe |first=Desson |title=Twister: Special Effects and Hot Air |work=[[Washington Post]] |date=May 10, 1996 |url=http://www.washingtonpost.com/wp-srv/style/longterm/movies/videos/twister.htm#howe |accessdate=2009-09-03 }}</ref>\n\n==Release==\nOn May 21, 1996, a tornado destroyed a [[drive-in theater]] in [[St. Catharines, Ontario]] which was scheduled to show the movie Twister in a real-life parallel to a scene in the film in which a tornado destroys a drive-in during a showing of the film [[The Shining (film)|The Shining]].  \n<ref>\n[http://nl.newsbank.com/nl-search/we/Archives?p_product=BG&p_theme=bg&p_action=search&p_maxdocs=200&p_topdoc=1&p_text_direct-0=0EADDC4B7A93E4D0&p_field_direct-0=document_id&p_perpage=10&p_sort=YMD_date:D&s_trackval=GooglePM TORNADO DESTROYS TWISTER THEATER] Boston Globe May 22nd, 1996.  \n</ref> \nThe facts of this incident were exaggerated into an [[urban legend]] that the theater was actually playing Twister during the tornado.<ref>[http://www.snopes.com/movies/films/twister.htm Twister] - Snopes.com</ref>\n\n==Theme park attraction==\n{{Main|Twister...Ride it Out}}\nThe film was used as the basis for the attraction Twister...Ride It Out at [[Universal Studios Florida]], which features filmed introductions by Helen Hunt and Bill Paxton.\n\n'
p214
tp215
a(I-1
S'{{Orphan|date=February 2009}}\n[[Image:PMSClanatE3.jpg|thumb|Members of the PMS Clan in LA for E3 (Electronic Entertainment Expo).]]\n\nPandoras Mighty Soldiers, abbreviated to PMS Clan is an all-female [[gaming clan]], which was co-founded in 2002 with Amber Athena Twin Dalton <ref>[http://2007.sxsw.com/interactive/programming/panels/?action=bio&id=133081 south by southwest festivals + conferences<!-- Bot generated title -->]</ref> and her sister Amy Athena Brady. PMS Clan currently has over eight hundred female members across Xbox, PC, PlayStation, and Nintendo platforms and games. They also have an International branch and male counter-part group [[H2O Clan]].\n\nPMS Clan members compete in various co-ed competitions and online ladder tournaments. PMS has become a well-known group in a male dominated gaming industry, and is committed to continue gaining ground for women in the industry. Their ultimate goal is to provide a safe, fun and competitive playing environment for female gamers, and they are also driven to bring females into the top ranks of tournament champions. Their members range from casual players to the ultra-competitive which balances these two goals.\n\nIn various interviews, clan members have stated that their mission is to change the perception that competitive online and offline gaming is dominated solely by male hardcore gamers.<ref>[http://cbs11tv.com/consumer/local_story_018171937.html cbs11tv.com - Female Gamers Growing In Numbers<!-- Bot generated title -->]</ref>  \nTheir open recruitment is based on interest and attitude rather than skill. Increased publicity over the years has made PMS Clan one of the largest female gaming clans in the industry. <ref>[http://www.xbox.com/en-US/live/pmsclan/default.htm Xbox.com | Xbox Live Gold - The PMS Clan on Xbox Live<!-- Bot generated title -->]</ref> \n\n\nAmber Dalton, the clan leader, was voted as one of Game Industrys 100 Most Influential Women by Next Generation Business, because the setting up of PMS clan has helped to break the stereotype of gamers and offers a safe and friendly environment for female gamers to play. <ref>[http://www.next-gen.biz/index.php?option=com_content&task=view&id=3783&Itemid=2&limit=1&limitstart=2 GAME INDUSTRYS 100 MOST INFLUENTIAL WOMEN: Page 3 : Next Generation - Interactive Entertainment Today, Video Game and Industry News - Home of Edge Online<!-- Bot generated title -->]</ref> \n\n'
p216
tp217
a(I-1
S'{{Unreferenced|date=November 2007}}\n\nLow culture is a [[derogatory]] term for some forms of [[popular culture]]. The term is often encountered in discourses on the nature of [[culture]]. Its opposite is [[high culture]]. It has been said by [[culture theory|culture theorists]] that both high culture and low culture are [[subculture]]s.\n\n[[Kitsch]], [[slapstick]], [[Camp (style)|camp]], [[bathroom humor]], [[media manipulation]],  [[yellow media]], [[reality shows]], [[Big Brother]], [[escapist fiction]], social networking websites, [[popular music]] (especially [[Pop music|Pop]]) and [[exploitation film]]s are often cited examples of low culture. It has often been stated that in [[postmodernism|postmodern]] times, the boundary between high culture and low culture has blurred. See the 1990s artwork of [[Jeff Koons]] for examples of [[Appropriation (art)|appropriation]] of low art tropes. [[Rhys Chatham]]s musical piece Guitar Trio 1977 is also an example of incorporating (low culture) primitive punk rock esthetics with (high art) [[contemporary classical music]].\n\n[[Romanticism]] was one of the first movements to reappraise low culture, when previously maligned [[Romance (genre)|medieval romances]] started to influence literature.\n\nIt is claimed that in simple terms, low culture is another term for popular culture. This means everything in society that has mass appeal. In todays society, this would involve things like take-away meals, gossip magazines, books that are current best sellers and sports such as football and basketball.\n\n'
p218
tp219
a(I-1
S'Inequity is injustice or unfairness or an instance of either of the two.<ref>Merriam Webster Online. [http://m-w.com/dictionary/inequity Inequity.] 3 Dec 2007.</ref>  Aversion is a feeling of repugnance toward something with a desire to avoid or turn from it; a settled dislike; a tendency to extinguish a behavior or to avoid a thing or situation and especially a usually pleasurable one because it is or has been associated with a noxious stimulus.<ref>Merriam Webster Online.  [http://m-w.com/dictionary/aversion Aversion.]  3 Dec 2007.</ref>  The given definition of [[inequity aversion]] is the preference for fairness and resistance to inequitable outcomes.\n\n==Clarifying  Social Inequity Aversion Through Experiment==\nTo better understand and breakdown the concept of social inequity aversion would be to use the study done by [http://www.physiology.emory.edu/FIRST/sarah.htm Sarah Brosnan, Ph. D.] (as well as with Frans B. M. de Waal),<ref name=Henrich>Henrich, Joseph.[http://www.nature.com/nature/journal/v428/n6979/full/428139a.html#B1 Animal Behaviour (Communication Arising):  Inequity Aversion in Capuchins?] 11 Mar 2004. Nature. Iss.  428.  3 Dec 2007.</ref> who specializes in social behavior and social cognition.<ref>Brosnan, Sarah.  [http://www.physiology.emory.edu/FIRST/sarah.htm Sarah Brosnan, Ph.D.]  Fellowships in Research and Science Teaching.  Emory University School of Medicine.  Department of Physiology.  3 Dec 2007.</ref>  In their experiment, Monkeys Reject Unequal Pay five female capuchin monkeys were used and given an unequal distribution of rewards by the human experimenter.  The female monkeys alternated in pairs under four different conditions with the experimenter.  Of the female monkeys, two received the same reward, one female received a superior reward, one female received a superior reward without exchange (for example without work), and a single female observed a superior reward in the absence of a partner.<ref name=Mardle>Mardle, Earl. [http://www.kn.com.au/networks/2003/09/inequity_aversi.html Inequity Aversion  Even a Monkey Can Pick a Raw Deal.]  A Networked World.  3 Dec 2007.</ref>  The females were much less likely to complete a trade with the human experimenter when their corresponding partner received a food item of higher value item (a grape; the lower item was a cucumber<ref name=Henrich />), and when that partner received the higher food item with no exchange of work of any kind, the likelihood of not completing a trade intensified.<ref name=Mardle />  All of these refusals of exchange included both passive and active rejections ranging from refusing to take the awards to throwing the reward, respectively.  These negative responses of situation made with the monkeys support the early evolutionary origin of [[inequity aversion]]<ref name=Mardle /> and thus helps (in combination with the definitions of inequity and aversion) give an overall idea of what social inequity aversion is:  the tendency to reject or avoid situations in which there is social inequality, unfairness, or injustice. \n \n==Humans & Social Inequity Aversion==\nIt is important to note that this experiment is with capuchin monkeys and not humans, and because humans are not the only cooperative animals, monkeys being one of many examples, we cannot assume that inequity aversion is an exclusive human trait or nature.<ref>Brosnan, Sarah and de Waal, Frans B. M.  [http://www.nature.com/nature/journal/v425/n6955/abs/nature01963.html#a1 Monkeys Reject Equal Pay.]  23 Jul 2003.  Nature.  Iss. 428.  3 Dec 2007.</ref>   There have been other experiments done with humans to test the validity of the inequity aversion theory proposed by Brosnan and de Waal.  An experiment performed by Urs Fischbacher, Christina M. Fong, and Ernst Fehr called Fairness, Errors, and the Power of Competition<ref>Fehr, Ernst. Fischbacher, Urs.  Fong, Christina M.  [http://www.iew.unizh.ch/wp/iewwp133.pdf Fairness, Errors, and the Power of Competition.]  Institute for Empirical Research in Economics.  University of Zurich.  Dec 2003.</ref> consisted of a multi-lateral ultimatum game where one contestant was put up against multiple ones.<ref name=Henrich />  In this experiment when the responders accepts the offer from the person giving the reward (say the provider), the person giving the reward (the provider) gets his full pay.  The key to this experiment is that the ability of one responder to affect the pay of the provider is lessened by all of the other responders willingness to accept the reward.  As a result, the concept of [[inequity aversion]] is followed, which says that the responders willingness to reject the reward is lessened as well as the providers offers.<ref name=Henrich /> (This is because in order to evade inequality or injustice due to unequal pay, all of the participants reduce their amounts to reduce the chance of unfairness).  Whats most important to realize in this experiment is that the out come does not seem to agree with those of Brosnan and de Waals capuchin experiment; humans will not reject the offer unless it affects others reward and/or pay.<ref name=Henrich />  So for humans, the original Fehr-Schmidt inequity aversion model, which was cited by Brosnan and de Waal in their capuchin experiment saying that the capuchin monkeys should always eat the lower value food, seems to hold validity.  By not rejecting the reward offered, the humans decreased the amount of inequality.  This was the opposite for the capuchins as they rejected the lower value food (cucumbers) when they couldnt get the higher value food (grapes) thus increasing the inequality, especially when the capuchins who received the grapes stole the discarded cucumbers, leaving the other monkeys with nothing.  That increased the amount of inequality amongst the capuchinsThe humans would only reject the reward if it reduced the reward of the individual who received the most.<ref name=Henrich />\n\n==Combining Social Inequality & Inequity Aversion==\nAccording to Sarah Brosnan, human beings have a similar approach, we do not live in a world of absolute values but one in which we are constantly comparing ourselves with those about us and, like a capuchin, we can tell when we are being short changed.<ref name=Mardle /> This can directly be connected to [[social inequality]] in that we as humans know what social inequality is and can identify it as an injustice; it is how we know that something such as unequal pay based on socioeconomic status is social inequality.  However, according to the concept of social inequity aversion, we will not reject what is offered to us unless we realize that by rejecting what we are offered we will reduce another persons earnings or the earnings of the person who is giving to us, thus making our earnings closer to theirs, thus lessening the inequality.\n\nOne key example that links these two concepts could be that of the Neoclassical Labor-Market Theory.  Based on several important facts, this theory is based on the supposition that (1) a relatively free and open market exists in which individuals compete for position. (2) Position in that markets depends heavily on the individuals efforts, abilities, experience, training, or human capital. (3) There are automatic mechanisms that operate in the marketplace to ensure that imbalances between ones input (human capital) and ones rewards (wages) are corrected in a way to restore balance (Hurst 231)<ref name=Hurst>Hurst, Charles E.  Social Inequality: Forms, Causes, and Consequences.  6th Ed. Pearson Education, Inc. USA. 2007.</ref>.  This concept is interesting in that the third fact that is assumed to be true in a labor-market theory would apply greatly to the concept of social inequity aversion.  This is because it would seem that in order to get the reward that is expected we as people will take what is given to us for our skill.  But when it becomes possible that our fellow citizen can get more than us, or that the company that is providing us with the reward (payments) gets more money from our labor/skill, then we as people in this labor market theory will reject the payments, and try to obtain a better one.  We do this by trying to attain better resources for ourselves, such as education, training, skills, and intelligence (Hurst 231)<ref name=Hurst />.  So take for example an African American woman, she will take the payment that all African American women are receiving.  But once another African American woman begins to get better payments via her better resources, other African American women will reject their current position as well as resources and seek more to in order to, maybe not directly lessen the payment that other African American woman, but to get more for themselves.  This greatly illustrates the social inequity aversion concept when it comes to humans and how it crosses with the neoclassical labor market theory.  However, because it is a continuous process in which different opportunities open up doors for individuals based on their life changes and access to better resources, an imbalance is made and a gap develops, thus separating  individuals and creating on-going social inequality (Hurst 231).<ref name=Hurst />\n\n'
p220
tp221
a(I-1
S'The term perpetual traveler (PT, permanent tourist or prior taxpayer) refers to both a lifestyle and a philosophy. \n\n== Background ==\nIn practical terms, perpetual travelers (PTs) are people who live in such a way that they are not considered a [[Residency (domicile)|legal resident]] of any of the countries in which they spend time.\n\nBy lacking a legal permanent residence status, they seek to avoid the legal obligations which may accompany residency, such as income and asset [[tax]]es, [[jury|jury duty]] and [[military service]].\n\nFor example, while PTs may hold citizenship in one or more countries that impose taxes based solely on residency, their legal residence will most likely be in a [[tax haven]]. PTs may spend the majority of their time in other countries, never staying long enough to be considered a resident.\n\n== Rationale ==\nSome PTs are wealthy individuals whose primary motivation is [[tax avoidance and tax evasion|tax avoidance]]. It is possible for a non-national to live for several months, and in some cases even own property, in many countries without paying [[income tax]]. For example, most European countries allow tourists to spend up to three months (and in some cases six months) in the country without being considered a resident or being required to file a local [[tax|tax return]]. Similarly, one can spend up to 122 days each year in the [[United States]] without being considered a resident -- or being required to file a US tax return. This workaround is applicable only for non-US citizens who are not permanent residents and earn no income in the United States.\n\nIn general PTs can, by moving between countries on a regular basis -- be able to legally reduce or eliminate their [[tax]] burden. Other PTs and [[itinerant]]s may adopt this lifestyle for primarily [[self-ownership]] reasons, seeking to be free from government authority, interference and [[Government|The System]].\n\n== Five Flag Theory ==\nPerpetual travelers may attempt to organize their affairs around the Five Flags theory<ref>[http://speculationrules.com/sovereign/pt.php Three Flag Theory for Expats] Some PTs add even more flags to create a five flag theory...</ref><ref>[http://www.amazon.com/PT-Stress-free-Properous-Government-intereference/dp/0906619246 Amazon Book Description] To succeed as a PT you will compartmentalize your life under these FIVE FLAGS...</ref><ref>[http://www.bean-d.com/oasis/glossary.php Five Flags Theory] Persons utilizing this philosophy are called PTs...</ref>, arranging for different facets of their lives to fall under the jurisdiction of separate countries, or flags. This is an extension of W.G. Hills original Three Flags approach.\n\nWhether to minimize governmental interference (via taxes or otherwise), or to maximize privacy, the theory proposes that you arrange for each of the following to be in a separate country:\n\n# [[Passport]] and [[Citizenship]] - in a country that does not tax money earned outside the country\n# [[Law|Legal]] [[Tax residence|Residence]] - in a [[tax haven]]\n# Business Base - where you earn your money, ideally somewhere with low [[Corporate tax]] rates\n# [[Asset]] Haven - where you keep your money, ideally somewhere with low taxation of savings interest and capital gains\n# Playgrounds - where you spend your money, ideally somewhere with low [[consumption tax]] and [[Value added tax|VAT]]\n\n== Philosophy ==\nOn the surface, perpetual tourists have some things in common with [[world citizen]]s, in that they see themselves as untethered to any one nation. However, PTs generally seem to eschew the humanistic and [[utopia]]n overtones of world citizenship. Many PTs align themselves closely with the [[libertarianism|libertarian]] or [[anarchism|anarchist]] schools of thought, which advocate [[self-ownership|individual sovereignty]] - sovereignty vested in the individual rather than in [[nation state]]s.\n\n'
p222
tp223
a(I-1
S'{{globalize|date=April 2009}}\n{{Sex and the Law}}\nSexual harassment is intimidation, [[bullying]] or [[coercion]] of a [[Human sexuality|sexual]] nature, or the unwelcome or inappropriate promise of rewards in exchange for sexual favors.<ref>{{cite book | last = Paludi | first = Michele Antoinette | authorlink = | coauthors = Barickman, | title = Academic and Workplace Sexual Harassment | publisher = SUNY Press | date = 1991 | location = | pages = 2-5 | url = | doi = | id = | isbn = 0791408299 }}</ref> In some contexts or circumstances, sexual harassment may be illegal. It includes a range of behavior from seemingly mild transgressions and annoyances to actual [[sexual abuse]] or [[sexual assault]].<ref>Dziech et al. 1990, Boland 2002</ref> Sexual harassment is a form of [[Law|illegal]] [[employment discrimination]] in many countries, and is a form of [[abuse]] ([[sexual abuse|sexual]] and [[Psychological abuse|psychological]]) and [[bullying]]. For many businesses, preventing sexual harassment, and defending employees from sexual harassment charges, have become key goals of legal decision-making. In contrast, many scholars complain that [[sexual harassment in education]] remains a forgotten secret, with educators and administrators refusing to admit the problem exists in their schools, or accept their legal and ethical responsibilities to deal with it (Dziech, 1990).\n\n==Early history of the use of the term==\nIn her book In Our Time: Memoir of a Revolution (1999), journalist Susan Brownmiller quotes the Cornell activists who in 1975 thought they had coined the term sexual harassment: Eight of us were sitting in an office ... brainstorming about what we were going to write on posters for our speak-out. We were referring to it as sexual intimidation, sexual coercion, sexual exploitation on the job. None of those names seemed quite right. We wanted something that embraced a whole range of subtle and un-subtle persistent behaviors. Somebody came up with harassment. Sexual harassment! Instantly we agreed. Thats what it was. (p.&nbsp;281). These activists went on to form Working Womens Institute which, along with the Alliance Against Sexual Coercion, founded in 1976 by Freada Klein, Lynn Wehrli, and Elizabeth Cohn-Stuntz, were among the pioneer organizations to bring sexual harassment to public attention in the late 1970s.\n\t\nThe term sexual harassment was used in 1973 by Dr Mary Rowe in a report to the then President and Chancellor of MIT about various forms of gender issues. (See Saturns Rings, 1973). Rowe has stated that she believes she was not the first to use the term, since sexual harassment was being discussed in womens groups in Massachusetts in the early 1970s, but that MIT may have been the first or one of the first large organizations to discuss the topic (in the MIT Academic Council), and to develop relevant policies and procedures. MIT at the time also recognized the injuries caused by racial harassment and the harassment of women of color which may be both racial and sexual. The President of MIT also stated that harassment (and favoritism) are antithetical to the mission of a university as well as intolerable for individuals.\n\n==Harassment situations==\nSexual harassment can occur in a variety of circumstances.  Often, but not always, the harasser is in a position of power or authority over the victim (due to differences in age, or social, political, educational or employment relationships).  Forms of harassment relationships include:\n\n* The harasser can be anyone, such as  a client, a co-worker, a teacher or professor, a student, a friend, or a stranger.\n\n* The victim does not have to be the person directly harassed but can be anyone who finds the behavior offensive and is affected by it.\n\n* While adverse effects on the victim are common, this does not have to be the case for the behavior to be unlawful.\n\n* The victim can be any gender. The harasser can any gender.\n\n* The harasser does not have to be of the opposite sex.\n\n* The harasser may be completely unaware that his or her behavior is offensive or constitutes sexual harassment or may be completely unaware that his or her actions could be unlawful. [http://www.eeoc.gov/types/sexual_harassment.html Adapted from the U.S. EEOC definition]\n\n==Varied behaviors==\n\nOne of the difficulties in understanding sexual harassment is that it involves a range of behavior, and is often difficult for the recipient to describe to themselves, and to others, exactly what they are experiencing.  Moreover, behavior and motives vary between individual harassers. \n\n===Behavioral classes===\nDzeich et al. has divided harassers into two broad classes:\n\n*Public harassers are flagrant in their seductive or sexist attitudes towards colleagues, subordinates, students, etc. \n\n*Private harassers carefully cultivate a restrained and respectable image on the surface, but when alone with their target, their demeanor changes completely. \n\nLangelan describes three different classes of harassers.\n\n*Predatory harasser who gets sexual thrills from humiliating others. This harasser may become involved in sexual extortion, and may frequently harass just to see how targets respondthose who dont resist may even become targets for rape.\n\n*Dominance harasser the most common type, who engages in harassing behaviour as an ego boost.\n\n*strategic or **territorial harassers who seek to maintain privilege in jobs or physical locations, for example a mans harassing female employees in a predominantly male occupation.\n\n===Types of harassment===\nThere is usually more than one type of harassing behavior present, so a single harasser will often fit more than one category.  These are brief summations of each type. \n\n*Power-player - Legally termed [[quid pro quo]] harassment, these harassers insist on sexual favors in exchange for benefits they can dispense because of their positions in hierarchies: getting or keeping a job, favorable grades, recommendations, credentials, projects, promotion, orders, and other types of opportunities.\n\n*Mother/Father Figure(a.k.a. The Counselor-Helper) - These harassers will try to create mentor-like relationships with their targets, all the while masking their sexual intentions with pretenses towards personal, professional, or academic attention. \n\n*One-of-the-Gang -  harassment occurs when groups of men or women embarrass others with lewd comments, physical evaluations, or other unwanted sexual attention. Harassers may act individually in order to belong or impress the others, or groups may gang up on a particular target. \n\n*Serial Harasser - Harassers of this type carefully build up an image so that people would find it hard to believe they would do anyone any harm. They plan their approaches carefully, and strike in private so that it is their word against that of their victims. \n\n*[[Groping|Groper]] - Whenever the opportunity presents itself, these harassers eyes and hands begin to wander, engaging in unwanted physical contact that may start innocuous but lead to worse.\n\n*Opportunist - Opportunist use physical settings and circumstances, or infrequently occurring opportunities, to mask premeditated or intentional sexual behavior towards targets. This will often involve changing the environment in order to minimize inhibitory effects of the workplace or school or taking advantage of physical tasks to accidentally grope a target.\n\n*Bully - In this case, sexual harassment is used to punish the victim for some transgression, such as rejection of the harassers interest or advances, or making the harasser feel insecure about himself or herself or his or her abilities.  The bully uses sexual harassment to put the victim in his or her proper place.\n\n*Confidante - Harassers of this type approach subordinates, or students, as equals or friends, sharing about their own life experiences and difficulties, sharing stories to win admiration and sympathy, and inviting subordinates to share theirs so as to make them feel valued and trusted. Soon these relationships move into an intimate domain.\n\n*Situational Harasser - Harassing behavior begins when the perpetrator endures a traumatic event (psychological), or begins to experience very stressful life situations, such as psychological or medical problems, marital problems, or divorce.  The harassment will usually stop if the situation changes or the pressures are removed.\n\n*Pest - This is the stereotypical wont take no for an answer harasser who persists in hounding a target for attention and dates even after persistent rejections. This behavior is usually misguided, with no malicious intent.\n\n*Great Gallant - This mostly verbal harassment involves excessive compliments and personal comments that focus on appearance and gender, and are out of place or embarrassing to the recipient. Such comments are sometimes accompanied by leering looks.\n\n*Intellectual Seducer - Most often found in educational settings, these harassers will try to use their knowledge and skills as an avenue to gain access to students, or information about students, for sexual purposes. They may require students participate in exercises or studies that reveal information about their sexual experiences, preferences, and habits. \n\n*Incompetent - These are socially inept individuals who desire the attentions of their targets, who do not reciprocate these feelings. They may display a sense of entitlement, believing their targets should feel flattered by their attentions.  When rejected, this type of harasser may use bullying methods as a form of revenge.\n\n*[[Stalking]] - The persistent watching, following, contacting or observing of an individual, sometimes motivated by what the stalker believes to be love, or by sexual obsession, or by anger and hostility.\n\n*Unintentional - Acts or comments of a sexual nature, not intended to harass, can constitute sexual harassment if another person feels uncomfortable with such subjects.\n\n====Sexualized environments (aka environmental harassment)====\nSexualized environments are environments where obscenities, sexual [[joke|joking]], sexually explicit graffiti, viewing Internet pornography, sexually degrading posters and objects, etc., are common.  None of these behaviors or objects may necessarily be directed at anyone in particular or intended as harassment.  However, they can create an offensive environment, and one that is consistent with hostile environment sexual harassment.\n\n====Rituals and initiations====\nSexual harassment can also occur in group settings as part of rituals or ceremonies, such as when members engage newcomers in abusive or sexually explicit [[Rite of passage|rites]] as part of hazing or initiation. While such traditions have historically remained in arenas of male bonding or female bonding, such as team sports, fraternities, and sororities, it is becoming increasingly common for girls/womens groups to engage in similar ceremonies.\n\n==Retaliation and backlash==\nRetaliation and backlash against a victim are very common, particularly a complainant. Victims who speak out against sexual harassment are often labeled troublemakers who are on their own power trips, or who are looking for attention.  Similar to cases of [[rape]] or sexual assault, the victim often becomes the accused, with their appearance, private life, and character likely to fall under intrusive scrutiny and attack.<ref>[http://www.apa.org/monitor/oct03/harass.html Sexual harassment too often leads to humiliation for victims]</ref> They risk hostility and isolation from colleagues, supervisors, teachers, fellow students, and even friends. They may become the targets of [[mobbing]] or [[relational aggression]].<ref name=SHSF_effects>[http://www.sexualharassmentsupport.org/effects.html Effects of Sexual Harassment]</ref>\n\nWomen are not necessarily sympathetic to female complainants who have been sexually harassed. If the harasser was male, internalized sexism, and/or jealousy over the sexual attention towards the victim, may encourage some women to react with as much hostility towards the complainant as some male colleagues.<ref name=webcom>[http://www.webcom.com/wcs/harass.html Dealing With Sexual Harassment]</ref> Fear of being targeted for harassment or retaliation themselves may also cause some women to respond with hostility.<ref name=backlash>[http://www.sexualharassmentsupport.org/Backlash.html Sexual harassment retaliation, backlash, and victim blaming]</ref> For example, when Lois Jenson filed her lawsuit against Eveleth Taconite Co., the women placed a hangmans noose above her workplace, and [[shunning|shunned]] her both at work and in the communitymany of these women later joined her suit.(Bingham et al. 2002) Women may even project hostility onto the victim in order to bond with their male coworkers and build trust.<ref name=backlash />\n\nRetaliation has occurred when a sexual harassment victim suffers a negative action as a result of the harassment. For example, a complainant be given poor evaluations or low grades, have their projects [[sabotage]]d, be denied work or academic opportunities, have their work hours cut back, and other actions against them which undermine their productivity, or their ability to advance at work or school. They may be suspended, asked to resign, or be [[fired]] from their jobs altogether.  Moreover, a professor or employer accused of sexual harassment, or who is the colleague of a perpetrator, can use their power to see that a victim is never hired again, or never accepted to another school. Retaliation can even involve further sexual harassment, and also [[stalking]] and [[cyberstalking]] of the victim.<ref name=webcom /><ref name=backlash />\n\nOf the women who have approached her to share their own experiences of being [[Sexual harassment in education|sexually harassed by their teachers]], feminist and writer [[Naomi Wolf]] writes, \n\n<blockquote>I am ashamed of what I tell them: that they should indeed worry about making an accusation because what they fear is likely to come true. Not one of the women I have heard from had an outcome that was not worse for her than silence. One, I recall, was drummed out of the school by peer pressure. Many faced bureaucratic stonewalling. Some women said they lost their academic status as golden girls overnight; grants dried up, letters of recommendation were no longer forthcoming. No one was met with a coherent process that was not weighted against them. Usually, the key decision-makers in the college or universityespecially if it was a private universityjoined forces to, in effect, collude with the faculty member accused; to protect not him necessarily but the reputation of the university, and to keep information from surfacing in a way that could protect other women. The goal seemed to be not to provide a balanced forum, but damage control.<ref>[http://newyorkmetro.com/nymetro/news/features/n_9932/index.html The Silent Treatment]</ref></blockquote>\n\nAnother woman who was interviewed by Helen Watson, a sociologist, reported that, Facing up to the crime and having to deal with it in public is probably worse than suffering in silence. I found it to be a lot worse than the harassment itself. (Watson, 1994)\n\n== Effects of sexual harassment and the (often) accompanying retaliation ==\n\nEffects of sexual harassment can vary depending on the individual, and the severity and duration of the harassment.  Often, sexual harassment incidents fall into the category of the merely annoying. However, many situations can, and do, have life-altering effects particularly when they involve severe/chronic abuses, and/or retaliation against a victim who does not submit to the harassment, or who complains about it openly.  Indeed, psychologists and social workers report that severe/chronic sexual harassment can have the same psychological effects as rape or sexual assault.  (Koss, 1987)  For example, in 1995, [[Judith Coflin]] committed suicide after chronic sexual harassment by her bosses and coworkers. (Her family was later awarded 6 million dollars in punitive and compensatory damages.) Backlash and victim-blaming can further aggravate the effects.  Moreover, every year, sexual harassment costs hundreds of millions of dollars in lost educational and professional opportunities, mostly for girls and women. (Boland, 2002)\n\n===Common effects on the victims===\n\nCommon professional, academic, financial, and social effects of sexual harassment:\n\n*   Decreased work or school performance; increased absenteeism\n*   Loss of job or career, loss of income\n*   Having to drop courses, change academic plans, or leave school (loss of tuition)\n*   Having ones personal life offered up for public scrutinythe victim becomes the accused, and his or her dress, lifestyle, and private life will often come under attack. (Note: this rarely occurs for the perpetrator.)\n*   Being objectified and humiliated by scrutiny and gossip\n*   Becoming publicly sexualized (i.e. groups of people evaluate the victim to establish if he or she is worth the sexual attention or the risk to the harassers career)\n*   Defamation of character and reputation\n*   Loss of trust in environments similar to where the harassment occurred\n*   Loss of trust in the types of people that occupy similar positions as the harasser or his or her colleagues\n*   Extreme stress upon relationships with significant others, sometimes resulting in divorce; extreme stress on peer relationships, or relationships with colleagues\n*   Weakening of support network, or being ostracized from professional or academic circles (friends, colleagues, or family may distance themselves from the victim, or shun him or her altogether)\n*   Having to relocate to another city, another job, or another school\n*   Loss of references/recommendations\n\nSome of the psychological and health effects that can occur in someone who has been sexually harassed:\n[[clinical depression|depression]], [[anxiety]] and/or [[panic attack]]s, sleeplessness and/or [[nightmare]]s, [[shame]] and [[guilt]], difficulty concentrating, headaches, [[fatigue (physical)|fatigue]] or loss of motivation, stomach problems, [[eating disorder]]s (weight loss or gain), [[alcoholism]], feeling betrayed and/or violated, feeling angry or violent towards the perpetrator, feeling powerless or out of control, increased blood pressure, loss of confidence and self esteem, withdrawal and [[Solitude|isolation]], overall loss of [[Trust (sociology)|trust]] in people, traumatic stress, [[post-traumatic stress disorder]] (PTSD), [[complex post-traumatic stress disorder]], suicidal thoughts or attempts, [[suicide]].<ref name=SHSF_effects /><ref>[http://www.webcom.com/wcs/harass.html#effects Common Effects of Sexual Harassment]</ref><ref>[http://www.uoregon.edu/~counsel/harass.htm Sexual Harassment: Myths and Realities]</ref><ref name=VAW_effects>[http://www.stopvaw.org/Effects_of_Sexual_Harassment.html StopVAW: Effects of Sexual Harassment]</ref><ref name=org_factor>[http://www.ilo.org/public/english/protection/safework/gender/encyclo/psy14ae.htm Psychosocial and Organizational Factors: Sexual Harassment]</ref>\n\n===Effects of sexual harassment on organizations===\n\n* Decreased productivity and increased team conflict\n* Decrease in success at meeting financial goals (because of team conflict)\n* Decreased job satisfaction\n* Loss of staff and expertise from resignations to avoid harassment or resignations/firings of alleged harassers; loss of students who leave school to avoid harassment\n* Decreased productivity and/or increased absenteeism by staff or students experiencing harassment\n* Increased health care costs and sick pay costs because of the health consequences of harassment\n* The knowledge that harassment is permitted can undermine ethical standards and discipline in the organization in general, as staff and/or students lose respect for, and trust in, their seniors who indulge in, or turn a blind eye to, sexual harassment\n* If the problem is ignored, a companys or schools image can suffer \n* Legal costs if the problem is ignored and complainants take the issue to court.(Boland 1990)<ref name=VAW_effects /><ref name=org_factor /><ref>[http://qnc.queensu.ca/story_loader.php?id=42b98262192e9 Sexual harassment bad for victims and for business] June 22, 2005</ref><ref>[http://www.ottawabusinessjournal.com/311209712945483.php Sexual harassment: Poisoning profit prospects] August 10, 2005</ref><ref>[http://www.capegateway.gov.za/eng/pubs/guides/S/63925/7 For Help with the Handling of Harassment]</ref>\n\n==The effect of the organization on sexual harassment ==\nStudies show that [[organizational climate]] (an organizations tolerance, policy, procedure etc.) and workplace environment are essential for understanding the conditions in which sexual harassment is likely to occur, and the way its victims will be affected (yet, research on specific policy and procedure  and awareness and prevention strategies is lacking).another element which increases the risk for sexual harassment is the jobs gender context (having few women in the close working environment or practicing in a field which is atypical for women)<ref>CHELSEA R. WILLNESS & PIERS STEEL & KIBEOM LEE, A META-ANALYSIS OF THE ANTECEDENTS AND CONSEQUENCES OF WORKPLACE SEXUAL HARASSMENT , PERSONNEL PSYCHOLOGY 2007</ref>.\n\nAccording to Prof. Orit Kamir, the most effective way to avoid sexual harassment in the work place, and also influence the publics state of mind, is for the employer to adopt a clear policy prohibiting sexual harassment and to make it very clear to their employees .Many women prefer to make a complaint and to have the matter resolved  within the workplace rather than to air out the dirty laundry with a public complaint and be seen as a traitor by colleagues, superiors and employers, adds Kamir<ref> ,     -     ?</ref>. See also: Rowe,Mary People Who Feel Harassed Need a Complaint System with both Formal and Informal Options, in Negotiation Journal, April, 1990, Vol. 6, No. 2, pp.&nbsp;161172., and \nRowe,Mary, Dealing with Harassment: A Systems Approach, in Sexual Harassment: Perspectives, Frontiers, and Response Strategies, Women & Work, Vol. 5, Margaret Stockdale, editor, Sage Publications, 1996, pp.&nbsp;241271.\nMost prefer a pragmatic solution that would stop the harassment and prevent future contact with the harasser rather than turning to the police.  More about the difficulty in turning an offence into a legal act can be found in  Felstiner & Sarats (1981) study<ref> W. L. Felstiner, R. L. Abel & A. Sarat, The Emergence and Transformation of Dispute: Naming, blaming, Claiming, 15 Law & Society Rev. (1980-1981)</ref>, which describes three steps a victim (of any dispute) must go through before turning to the justice system: naming  giving the assault a definition, Blaming  understanding who is responsible for the violation of rights and facing them, and finally, claming  turning to the authorities. In sexual offences there is great difficulty for the victims to go through these steps, and the closer the relationship between victim and assailant; the harder it is to take each step.\n\n==Evolution of sexual harassment law==\n===United States===\n====Workplace====\nIn the US, the [[Civil Rights Act of 1964|Civil Rights Act of 1964 Title VII]] prohibits [[employment discrimination]] based on [[race]], [[sex]], [[color]], [[national origin]] or [[religion]]. The prohibition of [[sex discrimination]] covers both females and males. This discrimination occurs when the sex of the worker is made as a condition of employment (i.e. all female waitpersons or male carpenters) or where this is a job requirement that does not mention sex but ends up barring many more persons of one sex than the other from the job (such as height and weight limits).\n\n[[Barnes v. Train]] (1974) is commonly viewed as the first sexual harassment case in America, even though the term sexual harassment was not used.<ref>[http://www.wendymcelroy.com/ifeminists/2004/1027.html The Sad Evolution of Sexual Harassment] October 27, 2004</ref> In 1976, [[Williams v. Saxbe]] established sexual harassment as a form of sex discrimination when sexual advances by a male supervisor towards a female employee, if proven, would be deemed an artificial barrier to employment placed before one gender and not another. In 1980 the [[Equal Employment Opportunity Commission]] (EEOC) issued regulations defining sexual harassment and stating it was a form of sex discrimination prohibited by the Civil Rights Act of 1964.  In the 1986 case of [[Meritor Savings Bank v. Vinson]], the Supreme Court first recognized sexual harassment as a violation of Title VII, established the standards for analyzing whether the conduct was welcome and levels of employer [[legal liability|liability]], and that speech or conduct in itself can create a [[hostile environment sexual harassment|hostile environment]].   The [[Civil Rights Act of 1991]] added provisions to Title VII protections including expanding the rights of women to sue and collect compensatory and punitive [[damages]] for sexual discrimination or harassment, and the case of [http://shsf.invisionzone.com/index.php?showtopic=445 Ellison v. Brady] resulted in rejecting the [[reasonable person]] standard in favor of the reasonable woman standard which allowed for cases to be analyzed from the perspective of the complainant and not the defendant.  Also in 1991, [[Jenson v. Eveleth Taconite Co.]] became the first sexual harassment case to be given [[class action]] status, paving the way for others. Seven years later, in 1998, this case would establish new precedents for setting limits on the [[Discovery (law)|discovery]] process in sexual harassment cases, and allowing psychological injuries from the [[litigation]] process to be included in assessing damages awards.  In the same year, the courts concluded in [http://caselaw.lp.findlaw.com/scripts/getcase.pl?court=us&vol=000&invol=97-282 Faragher v. City of Boca Raton, Florida], and [http://caselaw.lp.findlaw.com/scripts/getcase.pl?court=us&vol=000&invol=97-569 Burlington v. Ellerth], that employers are liable for harassment by their employees.  Moreover, [[Oncale v. Sundowner Offshore Services]] set the precedent for same-sex harassment, and sexual harassment without motivation of sexual desire, stating that any discrimination based on sex is actionable so long as it places the victim in an objectively disadvantageous working condition, regardless of the gender of either the victim, or the harasser. \n\nIn the 2006 case of [http://docket.medill.northwestern.edu/archives/003256.php Burlington Northern & Santa Fe Railway Co. v. White], the standard for retaliation against a sexual harassment complainant was revised to include any adverse employment decision or treatment that would be likely to dissuade a reasonable worker from making or supporting a charge of discrimination.\n\nDuring 2007 alone, the U.S. Equal Employment Opportunity Commission and related state agencies received 12,510 new charges of sexual harassment on the job <ref>[http://www.kmblegal.com/index.php/160/Sexual_Harassment_Law_A_Brief_Introduction_for_New_Practitioners Sexual Harassment Law: A Brief Introduction]KMB Legal</ref>\n\n====Education====\n[[Title IX]] of the Education Amendments of 1972 (United States) states No person in the United States shall, on the basis of sex, be excluded from participation in, be denied the benefits of, or be subjected to discrimination under any education program or activity receiving Federal financial assistance.\n\nIn [http://www.law.cornell.edu/supct/html/historics/USSC_CR_0503_0060_ZS.html Franklin v. Gwinnett County Public Schools] (1992), the U.S. Supreme Court held that private citizens could collect damage awards when teachers sexually harassed their students.  In [http://www.law.umkc.edu/faculty/projects/ftrials/firstamendment/bethel.html Bethel School District No. 403 v. Fraser] (1986) the courts ruled that schools have the power to discipline students if they use obscene, profane language or gestures which could be viewed as substantially interfering with the educational process, and inconsistent with the fundamental values of public school education. Under regulations issued in 1997 by the U.S. [[United States Department of Education|Department of Education]], which administers [[Title IX]], school districts should be held responsible for harassment by educators if the harasser was aided in carrying out the sexual harassment of students by his or her position of authority with the institution.<ref>[http://www.ed.gov/about/offices/list/ocr/docs/sexhar00.html Sexual Harassment Guidance]</ref> In [http://caselaw.lp.findlaw.com/scripts/getcase.pl?court=US&vol=000&invol=97-843 Davis v. Monroe County Board of Education], and [http://www.kscourts.org/CA10/cases/1999/08/97-1055.htm Murrell v. School Dist. No. 1], 1999, schools were assigned liability for peer-to-peer sexual harassment if the plaintiff sufficiently demonstrated that the administrations response shows deliberate indifference to actual knowledge of discrimination.\n\n===Evolution of sexual harassment law in other jurisdictions===\n\nIn India, the case of Vishaka Vs. State of Rajasthan in 1997 has been credited with establishing sexual harassment as illegal.<ref name=india_rape>[http://www.legalserviceindia.com/articles/rape_laws.htm Sexual Harassment and Rape Laws in India]</ref> In Israel, the 1988 Equal Employment Opportunity Law made it a crime for an employer to retaliate against an employee who had rejected sexual advances, but it wasnt until 1998 that the Israeli Sexual Harassment Law made such behavior illegal. (Kamir, 2005)\n  \nIn May 2002, the [[Europe]]an Union Council and Parliament amended a 1976 Council Directive on the equal treatment of men and women in employment to prohibit sexual harassment in the workplace, naming it a form of sex discrimination and violation of dignity. This Directive required all Member States of the European Union to adopt laws on sexual harassment, or amend existing laws to comply with the Directive by October 2005.<ref>[http://www.stopvaw.org/Domestic_Legal_Framework.html?Type=B_BASIC&SEC={D7FABC81-256E-41C1-BF3A-563AD89AA809} Domestic Legal Framework] November 1, 2003</ref>\n\nIn 2005, China added new provisions to the Law on Womens Right Protection to include sexual harassment.<ref>[http://news.bbc.co.uk/2/hi/business/4625913.stm China to outlaw sexual harassment]</ref>  In 2006 The Shanghai Supplement was drafted to help further define sexual harassment in China.<ref> [http://www.chinadaily.com.cn/china/2006-10/27/content_718147.htm China Daily]</ref>\n\n==Varied legal guidelines and definitions==\n[[The United Nations]] General Recommendation 19 to the Convention on the Elimination of all Forms of Discrimination Against Women defines sexual harassment of women to include: \n<blockquote>such unwelcome sexually determined behavior as physical contact and advances, sexually colored remarks, showing pornography and sexual demands, whether by words or actions. Such conduct can be humiliating and may constitute a health and safety problem; it is discriminatory when the woman has reasonable ground to believe that her objection would disadvantage her in connection with her employment, including recruitment or promotion, or when it creates a hostile working environment. </blockquote>\nWhile such conduct can be harassment of women by men, many laws around the world which prohibit sexual harassment are more enlightened and recognize that both men and women may be harassers or victims of sexual harassment. It is important to note, most claims of sexual harassment are made by women.\n\nThere are many similarities, and also important differences in laws and definitions used around the world.\nAfter covering one country in some detail (the United States), approaches in other countries are covered alphabetically.\n\n===United States===\nThere are a number of legal options for a complainant in the U.S.: [[mediation]], filing with the EEOC or filing a claim under a [[U.S. state|state]] Fair Employment Practices (FEP) statute (both are for workplace sexual harassment), filing a common law [[tort]], etc.<ref name=whattodo>[http://www.feminist.org/911/harasswhatdo.html What to Do if You or Someone You Know is Sexually Harassed]</ref> Not all sexual harassment will be considered severe enough to form the basis for a legal claim.  However, most often there are several types of harassing behaviors present, and there is no minimum level for harassing conduct under the law.(Boland, 2002)  Many experienced sexual harassment than have a solid legal case against the accused. Because of this, and the common preference for settling, few cases ever make it to federal court.<ref name=whattodo /> The section below describes the legal definitions that have been created for sexual harassment in the workplace.  Similar definitions have been created for academic environments in the [http://www.ed.gov/about/offices/list/ocr/docs/shguide.html U.S. Department of Education Sexual Harassment Guidance].\n\n====EEOC definition====\nIn 1980 the [[Equal Employment Opportunity Commission]] produced a set of guidelines for defining and enforcing Title VII (in 1984 it was expanded to include educational institutions). The EEOC defines sexual harassment as: \n\nUnwelcome sexual advances, requests for sexual favors, or other verbal or physical conduct of a sexual nature when: \n\n1. Submission to such conduct was made either explicitly or implicitly a term or condition of an individuals employment,\n\n2. Submission to or rejection of such conduct by an individual was used as the basis for employment decisions affecting such individual, or\n\n3. Such conduct has the purpose or effect of unreasonably interfering with an individuals work performance or creating an intimidating, hostile, or offensive working environment.\n\n1. and 2. are called [[quid pro quo]] (Latin for this for that or something for something). They are essentially sexual bribery, or promising of benefits, and sexual coercion.\n\nType 3. known as hostile work environment, is by far the most common form. This form is less clear cut and is more subjective.<ref name=webcom />\n\nNote: a workplace harassment complainant must file with the EEOC and receive a right to sue clearance, before they can file a lawsuit against a company in federal court. (Boland, 2002)\n\n=====Quid pro quo sexual harassment=====\n\nQuid pro quo means this for that. In the workplace, this occurs when a job benefit is directly tied to an employee submitting to unwelcome sexual advances. For example, a supervisor promises an employee a raise if he or she will go out on a date with him or her, or tells an employee he or she will be fired if he or she doesnt sleep with him or her.<ref>[http://www.abanet.org/publiced/practical/sexualharassment_quidproquo.html The Law & Your Job: What is quid pro quo harassment?]</ref> Quid pro quo harassment also occurs when an employee makes an evaluative decision, or provides or withholds professional opportunities based on another employees submission to verbal, nonverbal or physical conduct of a sexual nature. &nbsp;Quid pro quo harassment is equally unlawful whether the victim resists and suffers the threatened harm or submits and thus avoids the threatened harm.<ref>[http://www.sexualharassmentsupport.org/SHworkplace.html Sexual Harassment In The Workplace]</ref>\n\n=====Hostile environment sexual harassment=====\n\nThis occurs when an employee is subjected to comments of a sexual nature, unwelcome physical contact, or offensive sexual materials as a regular part of the work environment. For the most part, a single isolated incident will not be enough to prove hostile environment harassment unless it involves extremely outrageous and egregious conduct. The courts will try to decide whether the conduct is both serious and frequent.  Supervisors, managers, co-workers and even customers can be responsible for creating a hostile environment.<ref>[http://www.abanet.org/publiced/practical/sexualharassment_hostileenvironment.html The Law & Your Job: What is hostile environment harassment?]</ref> Probably the most famous hostile environment sexual harassment case to date is [[Jenson v. Eveleth Taconite Co.]] which inspired the movie [[North Country]].  (See [[Hostile environment sexual harassment]])\n\nThe line between quid pro quo and hostile environment harassment is not always clear and the two forms of harassment often occur together. For example, an employees job conditions are affected when a sexually hostile work environment results in a constructive discharge.  At the same time, a supervisor who makes sexual advances toward a subordinate employee may communicate an implicit threat to retaliate against her if she does not comply.<ref>[http://www.eeoc.gov/policy/docs/currentissues.html Policy Guidance on Current Issues of Sexual Harassment] 03/19/90</ref>\n\n<blockquote>Hostile environment harassment may acquire characteristics of quid pro quo harassment if the offending supervisor abuses his authority over employment decisions to force the victim to endure or participate in the sexual conduct. Sexual harassment may culminate in a retaliatory discharge if a victim tells the harasser or her employer she will no longer submit to the harassment, and is then fired in retaliation for this protest. Under these circumstances it would be appropriate to conclude that both harassment and retaliation in violation of section 704(a) of Title VII have occurred.</blockquote>\n\n=====Retaliation=====\n\nRetaliation has occurred when an employee suffers a negative action after he or she has made a report of sexual harassment, file a grievance, assist someone else with a complaint, or participate in discrimination prevention activities.  Negative actions can include being fired, demotion, suspension, denial of promotion, poor evaluation, unfavorable job re-assignmentany adverse employment decision or treatment that would be likely to dissuade a reasonable worker from making or supporting a charge of discrimination. ([http://docket.medill.northwestern.edu/archives/003256.php See Burlington Northern & Santa Fe Railway Co. v. White]) Retaliation is as illegal as the sexual harassment itself, but also as difficult to prove.  Also, retaliation is illegal even if the original charge of sexual harassment was not proven.\n\n===Australia===\nThe Sex Discrimination Act 1984 defines sexual harassment as  ... unwanted conduct of a sexual nature, in circumstances in which a reasonable person, having regard to all the circumstances, would have anticipated that the person harassed would be offended, humiliated or intimidated.\n\n===Czech Republic===\nUndesirable behavior of a sexual nature at the workplace if such conduct is unwelcome, unsuitable or insulting, or if it can be justifiably perceived by the party concerned as a condition for decisions affecting the exercise of rights and obligations ensuring from labor relations.<ref name=each_law>[http://www.avrio.net/593.0.html Employment Law in Each Country]</ref>\n\n===Denmark===\nSexual harassment is defined as, when any verbal, non-verbal or physical action is used to change a victims sexual status against the will of the victim and resulting in the victim feeling inferior or hurting the victims dignity. Man and woman are looked upon as equal, and any action trying to change the balance in status with the differences in sex as a tool, is also sexual harassment. In the workplace, jokes, remarks, etc., are only deemed discriminatory if the employer has stated so in their written policy. Women are viewed as being responsible for confronting harassment themselves, such as by slapping the harasser in the face. Law number 1385 of December 21, 2005 regulates this area.<ref name=Denmark law>[http://www.ku.dk/regel/2/2002.html#LOV%20nr%201385 Denmark Law]</ref>\n\n===France===\nArticle 222-33 of the French Criminal Code describes sexual harassment as, The fact of harassing anyone using orders, threats or constraint, in order to obtain favors of a sexual nature, by a person abusing the authority that functions confer on him... This means the harasser can only be someone with authority on the harassed (basically, there cant be sexual harassment between coworkers of the same rank). However, moral harassment occurs when an employee is subjected to repeated acts (one is not enough) the aim or effect of which may result in a degradation (deterioration) of his conditions of employment that might undermine his rights and his dignity, affect his physical or mental health or jeopardize his professional future.  Sexual as well as the moral harassment is recognized by the law.<ref>[http://www.nla.org/library/spring97/pg22.html Sexual Harassment in the Workplace in France and in the United States] Spring 1997</ref>\n\n===India===\nSexual harassment in India (and [[Pakistan]])is termed [[Eve teasing]] and is described as: unwelcome sexual gesture or behaviour whether directly or indirectly as sexually coloured remarks; physical contact and advances;  showing pornography; a demand or request for sexual favours; any other unwelcome physical, verbal/non-verbal conduct being sexual in nature. The critical factor is the unwelcomeness of the behaviour, thereby making the impact of such actions on the recipient more relevant rather than intent of the perpetrator.<ref name=india_rape />\n\n===Israel===\nThe 1998 Israeli Sexual Harassment Law interprets sexual harassment broadly, and prohibits the behavior as a discriminatory practice, a restriction of liberty, an offence to human dignity, a violation of every persons right to elementary respect, and an infringement of the right to privacy.  Additionally, the law prohibits intimidation or retaliation that accommodates sexual harassment. Intimidation or retaliation thus related to sexual harassment are defined by the law as prejudicial treatment. (Kamir, 2005)\n\n===Pakistan===\nPakistan has adopted a Code of Conduct for Gender Justice in the Workplace that will deal with cases of sexual harassment.  The Alliance Against Sexual Harassment (AASH) announced they would be working with the committee to establish guidelines for the proceedings.  AASH defines sexual harassment much the same as it is defined in the U.S. and other cultures.<ref>[http://www.aasha.org.pk/ AASHA - (Pakistan) Alliance Against Sexual Harassment]</ref>\n\n===Philippines===\nThe Anti-Sexual Harassment Act of 1995 was enacted primarily to protect and respect the dignity of workers, employees, and applicants for employment as well as students in educational institutions or training centers. This law, consisting of ten (10) sections, provides for a clear definition of work, education or training-related sexual harassment and specifies the acts constituting sexual harassment. It likewise provides for the duties and liabilities of the employer in cases of sexual harassment, and sets penalties for violations of its provisions. It is to be noted that a victim of sexual harassment is not barred from filing a separate and independent action for damages and other relief aside from filing the charge for sexual harassment. <ref>[http://filipiniana.net/read_content.jsp?filename=L00000000018 Full text of the Philippine Anti Sexual Harassment Law]</ref>\n\n===Poland===\nThere is no special provision in the employment law that provides for moral or sexual harassment; however it is commonly accepted by the jurisprudence, that sexual harassment occurs when the employee is subjected to acts of another person in order to obtain favours of a sexual nature.  Moral harassment occurs when en employee is subjected to acts which may result in a deterioration of his conditions of employment or undermine his rights and dignity as well as affect his physical or moral health. These definitions are not legal ones, but definitions accepted by the jurisprudence.<ref name=each_law />\n\n===Russia===\nIn the Criminal Code, Russian Federation, (CC RF), there exists a law which prohibits utilization of an office position and material dependence for coercion of sexual interactions (Article 118, current CC RF). However, according to the Moscow Center for Gender Studies, in practice, the courts do not examine these issues.<ref>[http://shsf.invisionzone.com/index.php?s=a1f5e83af0f492d74310d4d1a073b792&showtopic=279 Sexual Harassment in Russian Workplaces - Sexual Harassment Support Forum]</ref>\n\n===United Kingdom===\nThe Discrimination Act of 1975, was modified to establish sexual harassment as a form of discrimination in 1986.<ref>[http://www.eoc-law.org.uk/default.aspx?page=4666 Strathclyde Regional Council v Porcelli [1986&#93; IRLR 134 Court of Session]</ref>   It states that harassment occurs where there is unwanted conduct on the ground of a persons sex or unwanted conduct of a sexual nature and that conduct has the purpose or effect of violating a persons dignity, or of creating an intimidating, hostile, degrading, humiliating or offensive environment for them. If an employer treats someone less favourably because they have rejected, or submitted to, either form of harassment described above, this is also harassment.<ref>[http://www.eoc.org.uk/Default.aspx?page=15657 Sexual Harassment: what the law says]</ref>\n\n==Debates==\nThough the phrase sexual harassment is generally acknowledged, by everyone, to include clearly damaging and morally deplorable behavior, its boundaries can be broad and controversial. Accordingly, misunderstandings can abound.  Moreover, sexual harassment law has been highly criticized by experts, such as [[Alan Dershowitz]] and [[Eugene Volokh]], for imposing on the right to free speech.<ref>[http://www.law.ucla.edu/volokh/harass/ Freedom of Speech vs. Workplace Harassment Law]</ref> Some feminist groups criticize sexual harassment policy as helping maintain archaic stereotypes of women as delicate, asexual creatures who require special protection.<ref>[http://www.ffeusa.org/html/statements/statements_harassment.html Feminism and Free Speech]</ref> [[Camille Paglia]], for example says that young girls can end up acting in such ways as to make sexual harassment easier, such that for example, by acting nice they can become a target.  Paglia commented in an interview with Playboy, Realize the degree to which your niceness may invoke people to say lewd and pornographic things to you--sometimes to violate your niceness. The more you blush, the more people want to do it.<ref>[http://privat.ub.uib.no/bubsy/playboy.htm Playboy interview, Camille Paglia] May 1995</ref>\n\nSexual harassment policy and legislation have been criticized as attempts to regulate romance which goes against human urges.<ref>[http://www.abanet.org/genpractice/magazine/1996/winter/w96shi.html Sexual Harassment: The employers role in prevention]</ref> Other critics assert that sexual harassment is a very serious problem, but current views focus too heavily on sexuality rather than on the type of conduct that undermines the ability of women or men to work together effectively.  Viki Shultz, a law professor at [[Yale University]] comments, Many of the most prevalent forms of harassment are designed to maintain work-particularly the more highly rewarded lines of work-as bastions of male competence and authority.<ref>[http://www.aaup.org/publications/Academe/1998/98so/SO98Alg.HTM Love, Lust, and the Law Sexual Harassment in the Academy]</ref> Feminist [[Jane Gallop]] sees this evolution of the definition of sexual harassment as coming from a split between what she calls power feminists who are pro-sex (like herself) and what she calls victim feminists, who are not.  She argues that the split has helped lead to a perversion of the definition of sexual harassment, which used to be about sexism but has come to be about anything thats sexual. (Gallop, 1997)\n\nThere is also concern over abuses of sexual harassment policy, and employers and administrators using accusations as a way of expelling employees they want to eliminate for other reasons. (Westhues, 1998).\n\nThere is also discussion of whether some recent trends towards more revealing clothing and permissive habits have created a more sexualized general environment, in which some forms of communication are unfairly labeled harassment, but are simply a reaction to greater sexualization in everyday environments.<ref> [http://www.nydailynews.com/lifestyle/2008/06/30/2008-06-30_save_the_males_ho_culture_lights_fuses_b.html Save the males: Ho culture lights fuses, but confuses], By KATHLEEN PARKER, NY Daily News, June 30th 2008.  Based on Save the Males by Kathleen Parker, Copyright  2008, Random House, an imprint of Random House Publishing Group.</ref>\n\nThere are many debates about how organizations should deal with sexual harassment. Some observers feel strongly that organizations should be held to a zero tolerance standard of Must report - must investigate - must punish. \n\nOthers write that those who feel harassed should in most circumstances have a choice of options.  See Workplace Justice, Zero Tolerance, and Zero Barriers, 2001, by Mary Rowe and Corinne Bendersky, in Negotiations and Change, From the Workplace to Society, Thomas Kochan and Richard Locke (editors), Cornell University Press, 2002; Mary Rowe in Dealing with Harassment: A Systems Approach, in Sexual Harassment:  Perspectives, Frontiers, and Response Strategies, Women & Work, Vol. 5, Margaret Stockdale, editor, Sage Publications, 1996, pp.&nbsp;241271; Mary Rowe, People Who Feel Harassed Need a Complaint System with both Formal and Informal Options, in Negotiation Journal, April, 1990, Vol. 6, No. 2, pp.&nbsp;161172.  Sexual harassment, by definition, is unwanted and not to be tolerated but there often are a number of effective ways for offended and injured people to deal with harassment.\n\n'
p224
tp225
a(I1
S'Otto Hornung (Born [[Ostrava]]<ref name=gsm>The Slania I Knew by Otto Hornung in Gibbons Stamp Monthly, June 2005, p.90.</ref>, Czechoslovakia 1920<ref name=fip>http://hps.gr/fipliterature/bureau/hornung.html FIP Literature Commission profile retrieved 30 September 2009.</ref>) is a distinguished [[philatelist]] and philatelic journalist who has won Gold medals at several [[philatelic exhibition]]s and is a Fellow of The [[Royal Philatelic Society London]]. He signed the [[Roll of Distinguished Philatelists]] in 1993 and lives in London.\n\n== Early life ==\nWhilst in Ostrava, Hornung witnessed the German invasion of Czechoslovakia in March 1939 but managed to escape to [[Bohumin]], then in unoccupied Poland, dressed as a postman in the mail wagon of a goods train.<ref name=gsm/> After that he joined the Czechoslovakian Legion. Hornung spoke Polish and Czech fluently as both were used freely in Ostrava.\n\n== Philatelic career ==\nHornung is a former Secretary of the [[Philatelic Traders Society]] and organiser of the [[Stampex]] show.<ref name=fip/> He was also a founder member of the Association Internationale des Journalistes Philateliques (AIJP) in 1952 and its former President.<ref name=fip/> As a philatelist, Hornung specialises in the stamps and [[postal history]] of Turkey and has won large Gold medals at India 1989, New Zealand 1990, London 1990, Philatokyo 1991 and Granada 1992.<ref name=fip/>\n\n== Philatelic memberships ==\nHornung is a member of the following societies (amongst others):\n*Czechoslovak Philatelic Society of Great Britain\n*The [[Oriental Philatelic Association of London]]\n*International Association of Philatelic Journalists\n*Royal Philatelic Society London\n\n== Philatelic publications ==\n*The Illustrated Encyclopedia of Stamp Collecting, Hamlyn, London, 1970. ISBN 0600017974\n*Wie Sammle Ich Richtig Briefmarken, Verlag Werner Dausien, 1972. ISBN 3768442330 (German language)\n*The Czecho-Slovak Legion in Poland and Russia 1939-1945 and Czechoslovaks in the Middle East, 1940 - 1943, [[Czechoslovak Philatelic Society of Great Britain]], 2003. (With Dr. Vratislav Palkoska)\n*The Early Postal History of Carpatho-Ukraine with Particular Reference to The Usage Of The First Postage Stamps of Austria, 2007. ISBN 9780953655595\n\n'
p226
tp227
a(I1
S'{{dablink|For the Irish-born make-up artist, see [[Michle Burke]]}}\n{{Infobox actor\n| name = Michelle Burke\n| image = \n| imagesize =\n| caption = \n| birthname = Michelle Gray\n| birthdate = {{birth date and age|mf=yes|1970|11|30}}\n| birthplace = [[Defiance, Ohio]]\n| occupation = [[Actor|Actress]]\n| yearsactive = 1993 &ndash; present\n| othername = Michelle Rene Thomas<br>Michelle Thomas\n| spouse = Scott Thomas\n| domesticpartner = \n}}\n\nMichelle Burke (born Michelle Gray on November 30, 1970) is an American actress.  She is best known for her roles as Jodi Kramer in the 1993 [[Richard Linklater]] film [[Dazed and Confused (film)|Dazed and Confused]] and as Connie Conehead in the 1993 film [[Coneheads (film)|Coneheads]]. She also appeared in 1994s [[Major League II]].\n\nBurkes hobbies include collecting antiques and playing the guitar.\n\nBurke is sometimes credited as Michelle Rene Thomas and Michelle Thomas, especially in works after 1997.\n\n==Personal life==\nBurke is married to [[Ringside]] band member Scott Thomas. Together, they have 3 children.\n\n==Filmography==\n{| border=2 cellpadding=4 cellspacing=0 style=margin: 1em 1em 1em 0; background: #f9f9f9; border: 1px #aaa solid; border-collapse: collapse;\n|-style=background:#B0C4DE;\n! Year\n! Title\n! Role\n! Notes\n|-\n|rowspan=3| 1993 || [[Parker Lewis Cant Lose]] || Stacy || TV guest role; episode: The Bitch is Back\n|-\n|[[Coneheads (film)|Coneheads]] || Connie Conehead || \n|-\n|[[Dazed and Confused (film)|Dazed and Confused]] || Jodi Kramer || \n|-\n|rowspan=2| 1994 || [[Major League II]] || Nikki Reese || \n|-\n|[[Tales from the Crypt (TV series)|Tales from the Crypt]] || || TV guest role; episode: Operation Friendship\n|-\n|rowspan=3| 1995 || Caged Hearts || Ranch Inmate || \n|-\n|[[Diagnosis Murder]] || Tara Sampson || TV guest role; episode: My Baby is Out of This World\n|-\n|The Last Word || Sara || \n|-\n|rowspan=2| 1996 || [[Midnight in Saint Petersburg]] || Brandy || \n|-\n|[[Sliders]] || Melinda || TV guest role; episode: Dragonslide\n|-\n|rowspan=2| 1997 || The Notorious 7 || Sarah Valentine || \n|-\n|[[The Last Don#Mini-series|The Last Don]] || Claudia De Lena || TV mini-series\n|-\n|rowspan=3| 1998 || Scattering Dad || Taylor || \n|-\n|[[The Last Don#Mini-series|The Last Don II]] || Claudia De Lena || TV mini-series\n|-\n|Telling You || Kristens Friend || \n|-\n| 1998-1999 || [[Little Men (TV series)|Little Men]] || Josephine Bhaer || TV series\n|-\n|rowspan=2| 2001 || [[Diagnosis Murder]] || Claire Sheldrake || TV guest role; episode: Less Than Zero\n|-\n|[[Mysterious Ways (TV series)|Mysterious Ways]] || Jena Owens || TV guest role; episode: Dead Dog Walking\n|-\n| 2002 || [[The Division]] || Melissa Llewellyn || TV guest role; episode: Hide and Seek\n|-\n| 2009 || Struggle || Nita || Post-production\n|}\n\n'
p228
tp229
a(I-1
S'{{nofootnotes|date=September 2008}}\n{{wikify|date=September 2008}}\n\nGroup affective tone represents the consistent or homogeneous affective reactions within a group<sup>5,6</sup>. Group affective tone is an aggregate of the moods of the individual members of the group and refers to mood at the group level of analysis. If the moods of the individual group members are consistent, then group affective tone can be treated as a group property. If, for example, members of a group tend to be excited, energetic and enthusiastic, then the group itself can be described as being excited, energetic and enthusiastic. If the group members tend to be distressed, mistrustful and nervous, then the group can also be described in these terms.\nNot all groups possess an affective tone; members of some groups do not experience similar moods. Even so, past research indicates that a majority of groups possess an affective tone<sup>6</sup>.\n\nTwo dimensions of group affective tone have been identified: positive affective tone and negative affective tone<sup>5,6</sup>. Research shows that the two dimensions of affect emerge as independent factors<sup>16,22</sup> and display independent patterns of relationships with other variables<sup>2,20,21</sup>.\n\nGroup members tend to experience similar moods based on several theoretical mechanisms, including the selection and composition of group members, the [[socialization]] of group members, and exposure of group members to the same affective events, such as task demands and outcomes<sup>6,23</sup>.\n\nMoods tend to be shared among group members through processes such as mood contagion<sup>15</sup> and impression management<sup>14</sup>. Group affective tone is associated with various organizational outcomes such as group prosocial behavior<sup>6,14</sup>.\n\nGeorges (1990)<sup>5</sup> demonstration that characteristic levels of the [[personality traits]] of [[PA]] and [[NA]], within work groups, are positively associated with their corresponding (positive and negative) affective tones. \nGroup affective tone is influenced by characteristic levels of [[personality traits]] within groups. These characteristic levels of personality have been theorized to be brought about by member similarity resulting from attraction-selection-attrition processes described by Schneider<sup>18</sup> (1987). Beyond personality, a number of other factors have been posited to explain why work group members tend to share moods and emotions<sup>1,6,7</sup>, for example, (a) common [[socialization]] experiences and common social influences<sup>8</sup>; (b) similarity of tasks and high task interdependence<sup>4,9</sup>; (c) membership stability; (d) mood regulation norms and rules<sup>19</sup>; and (d) [[emotional contagion]]<sup>17</sup>.\n\nGeorge believes that a groups affective tone will determine how [[innovative]] (and effective) the group will be. An evidence to this belief is that when individuals feel positive they tend to connect and integrate divergent stimulus materialsthey are more creative<sup>3,10-13</sup>.\nGeorge suggests that if all or most individuals in a work group tend to feel positive at work (the group has a high positive affective tone), then their cognitive flexibility will be amplified as a result of social influence and other group processes. As a result of these individual and group level processes, the group will develop shared (and flexible) mental models. In effect, groups with a high positive affective tone will be creative.\n\nAnalyses suggested that positive group affective tone fully mediated, and negative group affective tone partially mediated, the association between [[leader]] mood and group coordination. Successful leaders must efficiently regulate the affective tones of their groups. Leaders who are effective at managing the groups affective tone should have more impact on group processes than will their counterparts.\n\n\n'
p230
tp231
a(I-1
S'Downshifting is a [[social behavior]] or [[Social Trends|trend]] in which individuals live simpler lives to escape from the [[rat race]] of [[affluenza|obsessive materialism]] and to reduce the stress, overtime, and psychological expense that may accompany it.<ref>Nelson 2007, p. 141</ref> It emphasizes finding an improved [[work-life balance|balance between leisure and work]]<ref>Juniu 2000, p. 69</ref> and focusing life goals on personal fulfillment and relationship building instead of the all-consuming pursuit of economic success.  \n\nDownshifting, as a concept, shares many characteristics with [[voluntary simplicity]], but is distinguished, as an alternative form, by its focus on moderate change and concentration on an individual comfort level, a dip your toes in gently <ref>Tracy Smith, 2008</ref> approach. In the 1990s this new form of [[voluntary simplicity]] began appearing in the [[mainstream media]] and has continually grown in popularity among populations living in [[industrial societies]] especially the United States, the United Kingdom, and Australia.<ref>Schor 1998, p. 67;</ref> \n\n==Values and Motives==\n\nExcerpt from the Downshifting Manifesto written by Tracy Smith:\n\n<blockquote>\n\nMoney - Were surrounded by the Buy Now, Pay Later credit culture and have forgotten the value of our true earnings. Curb your debt and prevent overspending by cutting up a [credit] card. Mantra - The more money you spend, the longer you need to work to pay for it. Remember - The best things in life are free. Re-learn the value of money and live within your means.\n\nTime - Everybody can claw back time here and there. When you change your perspective on the best ways to spend it, a whole new world opens up. What happened to playing games, reading, talking and interacting as a family? Weve just forgotten the joys of doing them all. Mantra - Whats the point of owning a fortune, it you havent the time to spend it? Remember - The most important gift is time. Spend quality time with the most important people in your life.\n\nI hereby pledge to slow my life down a gear, for the benefit of my health, my well being, my environment and for those around me whom I dearly love.\n\n</blockquote>\n\nSlowing down the pace of life and spending time meaningfully while not spending money wastefully are principle values of downshifting.  Another main tenet is enjoying [[leisure time]] in the company of others, especially loved ones, and shunning self-absorption because it resists the normality of individualism and isolation of [[post-modern]] society.     \n\nThe primary motivations for downshifting are gaining leisure time, escaping from [[consumerism|work-and-spend cycle]], and removing the clutter of unnecessary possessions that are accrued while existing in those societies with the highest [[standards of living]] and levels of production. The personal goals of downshifting are simple:  To reach a holistic self-understanding and satisfying meaning in life.<ref>Levy 2005, p.176</ref>  \n\nDownshifting successfully demands sustained commitment and trying financial and lifestyle sacrifices. It tests the will and self-control of all adherents, regardless of pre-downshifting economic class. However, because of its personalized nature and emphasis on many minor changes rather than complete lifestyle overhaul, it attracts downshifters or participants across the socio-economic spectrum<ref>Both of Hamiltons case studies in 2003</ref>.  An intrinsic consequence of downshifting is increased time for non-work related activities which, combined with the diverse demographics of downshifters, cultivates higher levels of [[Civic engagement|community or civic engagement]] and [[social interaction]]<ref>Nelson 2007, p. 142</ref>.\n\nThe scope of participation is limitless because all members of society, adults, children, businesses, institutions, organizations and governments are able to downshift<ref>Tracey Smith, 2008</ref>.\n\nIn practice, downshifting involves a variety of [[behavioral change|behavioral and lifestyle changes]].  The majority of these downshifts are voluntary choices, but natural, life course events, such as the loss of a job or birth of a child, can prompt involuntary downshifting.  There is also a [[Temporal|temporal dimension]] because a downshift could be either temporary or permanent. <ref>Schor 1998, p. 68</ref>\n\n==Methods of Downshifting==\n===Work and Income===\nBecause downshifting is fundamentally based on dissatisfaction with the conditions and consequences of the workplace environment<ref>Schor 1998, p. 66</ref>, the most common form of downshifting is work (or income) downshifting.  The philosophy of work-to-live replaces the dominant social [[ideology]] of live-to-work. Reorienting economic priorities shifts the [[work-life balance]] away from the workplace.\n\nEconomically, work downshifts are defined in terms of reductions in either actual or potential [[income]], work hours, and spending levels.<ref>Schor 1998, p. 68</ref>  Following a path of earnings, that is lower than the established market path, is a downshift in potential earnings in favor of gaining other non-material benefits. \n\nOn an individual level, work downshifting is a voluntary reduction in annual income.  Downshifters desire meaning in life outside of work and, therefore, will opt to decrease the amount of time spent at work or work hours.  Reducing the number of hours work, consequently, lowers the amount earned.<ref>Schor 1998, pps. 66-69</ref>  Simply not working [[overtime]] or taking a half-day for leisure time, are work downshifts.  \n\nCareer downshifts are another way of downshifting economically and entail lowering previous aspirations of wealth, a promotion or higher [[social status]]<ref>Juniu 2000, pps. 3-4</ref>.  Quitting a job to work locally in the community, from home or to start a business are examples of career downshifts.  Although more radical, these changes do not mean stopping work altogether. \n\nMany reasons are cited by workers for this choice and usually center on a personal [[cost-benefit analysis]] of current working situations and the quality extracurricular activities. High stress, pressure from employers to increase productivity , and long commutes are the costs of a job<ref>Schor 1998, p. 68</ref>.  If the downshifter wants more [[quality time|non-material benefits]] like leisure time, a healthy family life, or personal freedom, then, switching jobs could be a desirable option. \n\n===Downshifting Spending Habits===\n\nAnother aspect of downshifting is being a [[Ethical consumerism|conscious consumer]] or actively practicing alternative forms of consumption. Proponents of downshifting point to [[consumerism]] as a primary source of stress and dissatisfaction because it creates a society of individualistic consumers who measure both social status and general happiness by an [[affluenza|unattainable quantity of material possessions]].   Instead of buying goods for personal satisfaction, consumption downshifting, purchasing only the necessities, is a way to focus on quality of life rather than quantity.<ref>Nelson 2007, p. 142</ref>    \n\nThis realignment of spending priorities promotes the functional utility of goods over their ability to convey status which is evident in downshifters being, in general, less brand-conscious.<ref>Nelson 2007, p. 145</ref>  These consumption habits also facilitate the option of working and earning less because annual spending is proportionally lower. Reducing spending is less demanding than more extreme downshifts in other areas, like employment, as it requires only minor lifestyle changes. \n\n=====[http://downshiftingweek.com/top10tipsforsuccess.html International Downshifting Weeks Spending Tips]=====\n\n* Making a list of weekly purchases and eliminating non-essential items\n* Cutting up a [[credit card]]\n* Not buying impulsively for instant gratification\n* Hand-making items\n* Donating, [[recycling]] or reusing old items\n* Buying quality [[Used good|secondhand goods]]   \n\nAlternative dietary choices and supplements, which include buying [[local foods]], raising food-producing animals like chickens, and planting a [[sustainability|sustainable garden]], lower the cost of food by minimizing [[food miles]] and significantly reduce the [[transaction costs]] of trips to the grocery.<ref>Tracey Smith, 2008</ref>  These practices also reflect consumption downshifting.\n\n====Environment Consequences====\n\nThe catch-phrase of International Downshifting Week is Slow Down and Green Up.<ref>Tracey Smith, 2008</ref>  Whether intentional or unintentional, generally, the choices and practices of downshifters nurture environmental health because they reject the fast-paced lifestyle fueled by [[fossil fuels]] and adopt more sustainable lifestyles. The [[latent function]] of consumption downshifting is to reduce, to some degree, the [[carbon footprint]] of the individual downshifter.\n\n===Downshifting Geographically===\n\nAs a response the hectic pace of life and stresses in urban areas, downshifting geographically is a relocation to a smaller, rural, or more slow-paced community<ref>Schor 1998, p. 68</ref>.  This is a more drastic change, but because the access to the internet is widespread and possible, downshifting geographically does not bring total removal from mainstream culture.\n\nDownshifting is doing the job with simple way,. makes fast do the time at work.\n\n== Socio-Political Implications==\n\nAlthough downshifting is primarily motivated by personal desire and not by a conscious political stance, it does define societal [[overconsumption]] as the source of much personal discontent. By redefining life satisfaction in non-material terms, downshifters assume an alternative lifestyle but continue to coexist in a society and political system preoccupied with the economy.  In general, downshifters are politically apathetic because mainstream politicians mobilize voters through the hip-pocket nerve, proposing governmental solutions to periods of financial hardship and [[recession|economic recessions]]. This economic rhetoric is meaningless to downshifters who have forgone worrying about money.<ref>Hamilton Jan. 2003, pps. 11-12</ref>\n\nAlthough consumers do hold the majority in the US, the UK and Australia, a significant minority, approximately 20 to 25 percent<ref>Hamilton, Both 2003 Studies</ref>  , of these countries citizens identify themselves in some respect as downshifters.  Downshifting is not an isolated or unusual choice.  Politics still centers around consumerism and unrestricted growth, but downshifting value, such as family priorities and workplace regulation, are appearing in political debates and campaigns.  \n\nLike downshifters, the [[Cultural Creatives]] is another social movement whose ideology and practices diverge from mainstream consumerism and according to Paul Ray, are followed by at least one-fourth of US citizens.<ref>Hamilton Nov. 2003, 14</ref>\n\nIn his book In Praise of Slowness, Carl Honre relates followers of downshifting and [[voluntary simplicity]] to the global [[Slow Movement]]. \n\nThe emergence of a large and diverse class of downshifters in the US, the UK and Australia challenges the economically bias ideas for improving society.<ref>Hamilton Nov. 2003, pps. 35-37</ref>  Downshifting and similar, [[post-materialist]] ideologies are rising in popularity, but as a result of their grassroots nature, and relatively inconspicuous, non-confrontational subcultures, they represent unorganized [[List of social movements|social movements]] without political aspirations or motivating grievances.\n\n'
p232
tp233
a(I-1
S'Fan fiction (alternately referred to as fanfiction, fanfic, FF, or fic) is a broadly-defined term for [[fan labor]] regarding stories about characters or settings written by fans of the original work, rather than by the original creator. Works of fan fiction are rarely commissioned or authorized by the original works owner, creator, or publisher; also, they are almost never professionally published. Fan fiction, therefore, is defined by being both related to its subjects [[Fan fiction terminology#Canon|canonical]] fictional universe and simultaneously existing outside the canon of that universe.<ref>{{citeweb|url=http://www.britannica.com/EBchecked/topic/1017613/fan-fiction|title=Fan Fiction - Literature|author=Schulz, Nancy|publisher=[[Encyclopedia Britannica]]|accessdate=2008-04-24}}</ref> Most fan fiction writers assume that their work is read primarily by other fans, and therefore tend to presume that their readers have knowledge of the canon universe (created by a professional writer) in which their works are based.\n\n==History==\nBefore about 1965, the term fan fiction was used in [[science fiction fandom]] to designate original, though [[amateur]], works of [[science fiction]] published in [[science fiction fanzine]]s, as differentiated from fiction that was professionally published by professional writers; or fiction about fans and fandom;<ref>[http://fanac.org/Fannish_Reference_Works/FandBook/FandBook.html] Franson, Donald. FANDBOOK No. 1: A Key to the Terminology of Science-Fiction Fandom. [[National Fantasy Fan Federation]], 1962.</ref>  but this usage is now obsolete. Modern definitions of the term exclude such entirely original writing from the category. Today, fan fiction writers are those who use characters and situations already created by other writers in order to develop their personal and preferred views of the story.<ref name=TIME>{{citenews|url=http://www.time.com/time/business/article/0,8599,1657764,00.html|title=Life after Potter, Bonanza and Gunsmoke|author=Tancer, Bill|publisher=[[TIME Magazine]]|date=2007-08-30|accessdate=2008-04-24}}</ref> \n\n===Historical predecessors===\nFan fiction as it is now understood began at least as early as the 17th century, with unauthorized published sequels to such works as [[Don Quixote]].<ref>{{citeweb|url=http://www.britannica.com/eb/article-9034070/Alonso-Fernandez-de-Avellaneda|title=\nAlonso Fernndez de Avellaneda|published=[[Encyclopedia Britannica]]|accessdate=2008-04-24}}</ref><ref>[Constant, Paul. Where No Man Has Gone Before Newsweek Web Exclusive May 5, 2009\nhttp://www.newsweek.com/id/195963]</ref> Older precursors include the [[Epic Cycle]] supplementing the works of [[Homer]] and the various re-tellings of [[King Arthur]]s tale which spread around [[Europe]] from the 8th century AD onward.{{Citation needed|date=October 2008}} (For example, there were no fewer than four continuations by other hands of [[Chrtien de Troyes]] [[Perceval, the Story of the Grail|Perceval]].) \n\nAnother precursor is in medieval [[Arabic literature|Arabic fiction]], where story cycles were formed as different storytellers added sequels to an original story, such as story cycles revolving around [[Harun al-Rashid]] or [[Sinbad the Sailor]]. Some tales were also [[Parody|parodied]] by other storytellers. Many of these story cycles and parodies were incorporated into the [[One Thousand and One Nights|Arabian Nights]]. For example, Wardan the Butchers Adventure With the Lady and the Bear is parodied by The Kings Daughter and the Ape, Harun al-Rashid and the Two Slave-Girls is parodied by Harun al-Rashid and the Three Slave-Girls, and The Angel of Death With the Proud King and the Devout Man is parodied by The Angel of Death and the Rich King. Sometimes even parodies were parodied, such as The Angel of Death and the King of the Children of Israel being a parody of The Angel of Death and the Rich King.<ref>{{citation|title=The Arabian Nights and Orientalism: Perspectives from East & West|last=Yuriko Yamanaka|first=Tetsuo Nishio|publisher=[[I.B. Tauris]]|year=2006|isbn=1850437688|pages=81-2}}</ref> When the Arabian Nights was translated into French at the beginning of the 18th century, many imitations of it were written in France.<ref name=arabianNights2>John Grant and John Clute, The Encyclopedia of Fantasy, Arabian fantasy, p 52 ISBN 0-312-19869-8</ref>\n\nThe turn of the 20th century saw parodies and revisions of [[Lewis Carroll]]s [[Alice in Wonderland]] by authors including [[Frances Hodgson Burnett]] and [[E. Nesbit]]. In addition, there were several fan-authored versions of [[Arthur Conan Doyle]]s [[Sherlock Holmes]] stories. \n\nIn the 1920s and 1930s, fans of [[Jane Austen]] wrote stories based on her characters and published them in [[fanzine]]s.  In 1945, [[C. S. Lewis]] adopted certain elements from [[J. R. R. Tolkien]]s then largely unpublished [[legendarium]] (mostly Nmenor, there spelt Numinor) and incorporated these into the last novel, [[That Hideous Strength]], of his [[Space Trilogy]]. (Given that Lewis and Tolkien were personal friends, this could be seen more as an homage).\n\n=== Modern phenomenon ===\n[[Image:Spockanalia2.jpg|left|thumb|The magazine, Spockanalia, is the first known contemporary form of any type of fan-written stories.]]\nHowever, the modern phenomenon of fan fiction as an expression of fandom and fan interaction was popularized and defined via the [[Trekkie|Star Trek fandom]] and [[fanzines]] published in the 1960s. The first [[Star Trek]] [[fanzine]], Spockanalia, was published in 1967 and contained some fan fiction.<ref>Spockanali, #1</ref> In 1970, Mary Ellen Curtin, a [[Princeton University]] graduate, researched the authors of various [[Star Trek]] fanfics, and her results showed an outstanding 83% female as opposed to 17% male writers; in 1973, fan writers were 90% female.<ref name = Coppa in Hellekson and Busse>{{Citation | first = Francesca  | last = Coppa  | author-link = Francesca Coppa  | editor-last = Hellekson  | editor-first = Karen  | editor2-last = Busse  | editor2-first = Kristina  | contribution = A Brief History of Media Fandom  | title = Fan Fiction and Fan Communities in the Age of the Internet  | year = 2006  | pages = 41-59  | place = Jefferson, North Carolina  | publisher = [[McFarland & Company]]  | isbn = 978-0-7864-2640-9}}</ref>\n\nFan fiction has become more popular and widespread since the advent of the World Wide Web.<ref name=stats/>  In addition to traditional zines and conventions, [[Usenet group]] [[electronic mailing lists]] were established for fan fiction as well as fan discussion.  Online, searchable fan fiction archives were also established.  The online archives were initially non-commercial hand-tended and fandom- or topic-specific. These archives were followed by non-commercial automated databases. In 1998, the not-for-profit site [[FanFiction.Net]] came online, which allowed anybody to upload content in any fandom.{{Citation needed|date=October 2008}}  The ability to self-publish fan fiction at an easily-accessible common archive that did not require insider-knowledge to join, and the ability to review the stories directly on the site, became popular quite quickly.  FanFiction.net now hosts millions of stories in dozens of languages, and is widely considered the largest and most popular fan fiction archive online.<ref name=stats>{{citeweb|url=http://www.alternateuniverses.com/ffnstats.html|title=Fanfiction.net Statistics|publisher=Alternate Universes-Fanfiction Studies|author=Ellen, Mary|accessdate=2008-04-24}}</ref>\n\n[[LiveJournal]] (founded in 1999) and other [[blog]]ging services played a large part in the move away from [[mailing list]]s (both [[electronic mailing lists|electronic]] and [[amateur press associations]]) to blogs as a means for fan communication and the sharing of fan fiction.  Although much fan fiction today is published to archives, it would be impossible to tell whether more or less fan fiction today is posted directly to blogging services than to fan-fiction-specific archives.\n\n=== Japanese djinshi===\nA similar trend in [[Japanese literature|Japan]] also began appearing around the 1960s and 1970s, where [[Self-published|independently published]] [[manga]] and novels, known as [[djinshi]], are frequently published by [[djin]] circles; many of these djinshi are based on existing [[manga]], [[anime]], and [[video game]] franchises. [[Mangaka|Manga authors]] like [[Shotaro Ishinomori]] and [[Fujiko Fujio]] formed djin groups such as Fujios {{nihongo|New Manga Party||Shin Manga-to}}. At this time djin groups were used by artists to make a professional debut. This changed in the coming decades with djin groups forming as school clubs and the like. This culminated in 1975 with the [[Comiket]] in Tokyo.\n\n==Varieties and subgenres==\nFanfiction is written in as many ways as any other genre of literature. Modern fan fiction is found in a variety of subgenres, with writers specializing in each. \n\nFanzines have been published, and websites can be found, specializing: by star; by TV show, book(s), or film(s); by genre of the underlying material (such as mystery/crime, western, etc.); by sexual content (gen, [[slash fiction|slash]], etc.); or by type of story: crossover, AU (an [[alternative universe]], or [[alternate history]], within the context of a particular fandom), or romance (for the [[Shipping (fandom)|shippers]]).  In some cases, these will be combined, generating specialized zines or websites dedicated solely and specifically to, e.g., crossovers involving the [[Buffyverse]]; [[lesbian]] [[erotica]] about [[Xena]]; etc.  Most fan fiction falls into the short story range, but works from novel-length to very short are also commonly seen. \n\nFor common terminology relating to fan fiction, including some specialized subgenre terms, see the sub-article [[Fan fiction terminology]].\n\n===Genres===\nIn [[Alternative universe (fan fiction)|Alternate universe]] (often abbreviated as AU) stories, the author deliberately alters the original setting of the story, thereby creating an entirely new world. This happens when a story transplants familiar characters into situations totally different from canon, as presented by the source author.<ref name=terms/> The purpose of creating alternate universes are to answer potential what-if questions. These can be created by fabricating a [[Fictional crossover|crossover]], an alternate timeline, or altering the nature of the setting or characters, among other methods.\n\nA crackfic is a story that is written in a nonsensical, stream-of-consciousness style, as if the author were under the influence of cocaine (crack) or another similar drug.{{Citation needed|date=July 2009}} While few stories are actually written under the influence of illegal drugs, a related, more common story is the sugarfic, where the author is affected by a sugar rush and is writing to blow off steam.{{Citation needed|date=July 2009}}\n\n[[Mary Sue]], sometimes shortened simply to Sue, is a [[pejorative]] term used to describe a [[fictional character]] who plays a major role in the plot and is particularly characterized by overly [[ideal]]ized and hackneyed mannerisms, lacking noteworthy flaws, or having too many, and primarily functioning as wish-fulfillment fantasies for their authors or readers. Mary Sues can be either male or female, but male characters are often dubbed Marty Stu, Gary Stu, or similar names.<ref name=gary>http://missy.reimer.com/library/marysue.html</ref> While the label Mary Sue itself originates from a parody of this type of character, most characters labeled Mary Sues by readers are not intended by authors as parodies; few authors set out to write Mary Sue fiction.\n\n===Format Variants===\nA [[drabble]] is traditionally a vignette exactly 100 words in length. However, when a story is referred to as a drabble, it often is a short scene or idea that does not tell an entire story, or a story at all. It is simply a reflections of a moment in time, somewhat similar to a character sketch.<ref name=terms>{{citeweb|url=http://www.subreality.com/glossary/terms.htm|title=The Fanfiction Glossary|accessdate=2008-04-24}}</ref> \n\nOn FanFiction.Net, authors may refer to oneshots or twoshots.  By this term, the author signals the audience that the story is only intended to be one or two chapters long, respectively, in an environment that has many works-in-progress.<ref>{{citeweb|url=http://www.harrypotterfanfiction.com/docs/terms.html#o|title=Fanfiction Terms - O|publisher=Harry Potter Fanfiction|accessdate=2008-04-24}}</ref> A different meaning of one-shot is often used by authors who write series of stories, generally in their own [[Alternative universe (fan fiction)|alternate universe]] of a given fandom.  Often an author will write several disjoint series, but additionally, single stories (of any length, but generally comparatively shorter) which are standalone, not tying into any of the writers other continuity; these are called one-shots, as the author doesnt plan to extend or revisit them.\n\nAnother variant of fan fiction is known as a songfic, where authors take the lyrics of a song and, with the song as inspiration, construct a piece of writing around the lyrics. Usually this is done by quoting lines of the lyrics, while writing original pieces relating to the nearby lyrics.<ref name=terms/> Songfic often comes in for some disdain, particularly when the song is used literally in the context of the story.\n\nPoem fics are a less popular type of fan fiction, and can include a variety of fanfics, including poems that describes a character(s), poems that tell a story, poems about how a character(s) felt in a certain situation, etc.\n\n== Story creation in the online era==\nFanfiction is often posted serialized as a work in progress or WIP, with new chapters published in sequence, sometimes as soon as they are finished. Chapters may take anything from a day to several months to be updated and often remind readers of their place in the story with each new installment. Most archives allow authors to upload individual chapters sequentially under a single title with a main link to the first chapter, and each chapter easily linked to via a drop down menu.\n\nIt is often considered wise in fan fiction circles to acquire the aid of a [[beta reader]], sometimes shortened to beta, whose responsibilities are roughly those of a professional editor to a commercial authorwith the exception that the beta is most commonly a volunteer who works without pay and on a casual basis and communicates through [[E-mail]] or [[private message]] systems.<ref name=beta>{{citeweb|url=http://www.fanfiction.net/betareaders/|title=Fanfiction.net Beta Writers|publisher=[[Fanfiction.net]]|accessdate=2008-04-24}}</ref> Writers are discouraged in some circles from posting fan fiction that has not at least been checked for grammatical, spelling, consistency and plot errors by a beta reader.<ref name=guideline>{{citeweb|url=http://www.englishchick.com/badfic/whybeta.htm|title=Bad Fanfic, why Beta?|author= Siubhan|accessdate=2008-04-24}}</ref> In late February 2008, FanFiction.net set up an area of their site that contains a list of authors willing to beta other authors fic.<ref name=beta/>\n\n==Interactivity in the online era==\nUnlike traditional print publication, the internet offers the option of giving and receiving instantaneous [[feedback]].<ref name=review>{{citeweb|url=http://www.angelfire.com/falcon/moonbeam/terms.html|title=Fanfiction Terminology|author=Moonbeam|publisher=Angel Fire|accessdate=2008-04-24}}</ref> or reviews. Reviews can be given by both [[anonymity|anonymous]] and registered users of most sites, and sites are often programmed to notify the author of new feedback, making them a common way for readers and authors online to communicate directly.<ref>{{citeweb|url=http://www.fanfiction.net/secure/review.php?storyid=3058878&chapter=1&storytextid=9301416|title=Fanfiction.Net Review Form|publisher=[[Fanfiction.net]]|accessdate=2008-04-24}}</ref> This system is intended for a type of bond between the reader and the writer, as well as helping the author improve his or her writing skills through [[constructive criticism]], enabling him or her to produce a better work next time.<ref name=Merlin>{{citeweb|url=http://firefox.org/news/articles/650/11/Dr-Merlin039s-Guide-to-Fanfiction/Page11.html|title=Dr. Merlins Guide to Fanficion|author=Merlin, Missy|publisher=[[Firefox]]|date=2007-09-13|accessdate=2008-05-07}}</ref> Occasionally unmoderated review systems are abused to send [[Flaming (Internet)|flames]], [[spam (electronic)|spam]] or [[Internet troll|trolling]] messages. As a result, the author of the story can either disable or enable anonymous reviews, depending on his preference. Internet fanfiction, particularly of large fandoms like The Lord of the Rings or Harry Potter, gives young writers a wider audience for their literary efforts than ever before, resulting in improved literacy.<ref>Tosenberger, Catherine (2008) Homosexuality at the Online Hogwarts: Harry Potter Slash Fanfiction Childrens Literature 36 pp.185-207 {{doi|10.1353/chl.0.0017}}</ref>\n\nRecently fan fiction has seen greater use of the [[web forum|forum]] or [[LiveJournal]] [[blog]] format.<ref>{{citeweb|url=http://www.fanfiction.net/forums/|title= Fanfiction.net Forums|publisher=[[Fanfiction.net]]|accessdate=2008-04-24}}</ref> Built around message board systems, stories are posted on threads with feedback interlaced and immediate. This style of fan fiction is more interactive but also can be a distraction since the stories and comments are between each other. These communication methods make fan fiction sites and blogs useful [[affinity spaces]] as writers are able to take readers feedback and improve their skills and abilities as writers.  This [[informal learning]] is a side benefit for many fan fiction authors, some of whom eventually attempt or go on to writing professionally.\n\n==Legality==\n{{Main|Legal issues with fan fiction}}\nFan fiction is a [[derivative work]] under [[United States copyright law]].<ref name=legal-derivativeWork>{{citeweb|url=http://www.whoosh.org/issue25/lee1a.html#41|title=Whats Derivative Work?|work =A Brief Introduction to Copyright for Fanfiction Authors|author=Lee, A.T.|publisher=Woosh!|date=10-1998|accessdate=2008-04-24}}</ref>  \n\nSome argue that fan fiction does not fall under fair use.<ref>[http://www.schoollibraryjournal.com/article/CA6673573.html Burns, Elizabeth and Webbr, Carlie. When Harry Met Bella: Fanfiction is all the rage. But is it plagiarism? Or the perfect thing to encourage young writers? [[School Library Journal]], 8/1/2009]</ref>. The 2009 ruling by [[United States District Court]] judge Deborah A. Batts, permanently prohibiting publication in the United States of a book by a Swedish writer whose protagonist is a 76-year-old version of [[Holden Caulfield]] of [[The Catcher in the Rye]], may be seen as upholding this position regarding publishing fanfic, as the judge stated, To the extent Defendants contend that 60 Years and the character of Mr. C direct parodic comment or criticism at Catcher or Holden Caulfield, as opposed to Salinger himself, the Court finds such contentions to be post-hoc rationalizations employed through vague generalizations about the alleged naivety of the original, rather than reasonably perceivable parody.<ref>[http://cityroom.blogs.nytimes.com/2009/07/01/judge-rules-for-salinger-in-copyright-suit/?hp Chan, Sewell. Ruling for Salinger, Judge Bans Rye Sequel New York Times, July 1, 2009]</ref>\n\nOthers such as the [[Organization for Transformative Works]] uphold the legality of non-profit fan fiction under the [[fair use]] doctrine, as it is a creative, [[Transformation (law)|transformative]] process.<ref name = legal-fairUse>{{cite web  | title = Frequently Asked Questions - Legal  | publisher = [[Organization for Transformative Works]]   | url = http://transformativeworks.org/faq/legal  | accessdate = 2009-09-05}}</ref>\n\nIn 1981 [[Lucasfilm|Lucasfilms Ltd.]] sent out a letter to several fanzine publishers asserting Lucasfilms copyright to all [[List of Star Wars characters|Star Wars characters]] and insisting that no fanzine publish [[pornography]].{{Citation needed|date=October 2008}} The letter also alluded to possible legal action that could be taken against fanzines that did not comply. Later that year, the director and legal counsel of the Official Star Wars Fan Club sent fanzine publishers a set of official guidelines. Lucasfilms supported fan publications contingent on their upholding these guidelines.{{Citation needed|date=October 2008}}\n\nIn recent years, several prominent authors have given their blessings to fanfiction, notably [[J.K. Rowling]]. Rowling said she was flattered that people wanted to write their own stories based on her characters.<ref name = bcc-rowling>{{citeweb|url=http://news.bbc.co.uk/1/hi/entertainment/arts/3753001.stm|title=Rowling backs Potter fan fiction|author=Waters, Darren|publisher=[[BBC]]|date=2004-05-27|accessdate=2008-04-24}}</ref> Similarly, [[Stephenie Meyer]] has put links on her website to fanfiction sites about her characters from the [[Twilight (series)|Twilight series]].<ref>http://stepheniemeyer.com/ts_fansites.html</ref>\n\nHowever, [[Anne Rice]] has consistently and aggressively prevented fan fiction based on any of her characters (mostly those from her famous [[Interview with the Vampire]] and its sequels in [[The Vampire Chronicles]]). She, along with [[Anne McCaffrey]] and [[Raymond Feist]], have asked to have any fiction related to their series removed from [[FanFiction.Net]].<ref name=bcc-rowling/>\n\nMost authors, however, seem to turn a blind eye towards fan fiction - not actively approving it, but not discouraging it, either.{{Citation needed|date=May 2009}} In some cases this tolerance may be due to the fact that, due to the internet, preventing fan fiction from being published would be an expensive and almost impossible task.{{Nonspecific|date=May 2009}}\n\n'
p234
tp235
a(I1
S'Baron Johann Knoop ([[22 July]] [[1846]], Moscow &ndash; 1882, [[St. Magnus]]), was a collector of musical instruments who possessed a total of 29 great violins, violas, and cellos at one time or another including some four Stradivari violas. Several instruments are named after him:\n\n* [[Baron Knoop Stradivarius]] (1698)\n* [[Alard-Baron Knoop Stradivarius]] (1715)\n* [[Baron Knoop; ex-Bevan Stradivarius]] (1715)\n\nKnoops father, Johann [[Ludwig Knoop]] (1821-1894), emigrated from Germany to Russia, founded a textile industry in Narva, Estonia, and was granted the Russian title of Baron, which he passed to his sons.\n\n'
p236
tp237
a(I1
S'{{otheruses4|visiting mines|searching for minerals|Mineral exploration}}\n[[Image:BoxCathedral.jpg|thumb|right|250px|The Cathedral at [[Box Mine]] ]]\n\n[[Mining|Mine]] [[exploration]] is a [[hobby]] in which people visit [[abandoned mine]]s, [[quarry|quarries]], and sometimes operational [[mining|mines]]. Enthusiasts usually engage in such activities for the purpose of [[explore|exploration]] and documentation, sometimes through the use of [[surveying]] and [[photography]]. In this respect, mine exploration might be considered a type of amateur [[industrial archaeology]]. In many ways, however, it is closer to [[caving]], with many participants actively interested in exploring both mines and [[cave]]s. Mine exploration typically requires equipment such as [[helmet]]s, [[Flashlight|head lamps]], [[Wellington boots]], and climbing gear.\n\nMine exploration typically involves less crawling and more [[walking]] than caving, since mines were purposefully excavated to allow human access. Some disused mines have been adapted for [[tourism]], or use by organized outdoor recreation groups. Conversely, gaining access to other mines may require technical skills such as [[rappelling]] or [[Single Rope Technique]]. Such techniques may also be used inside a mine to explore a winze, shaft, or steep incline. Similarly, some traverses and slopes may be roped for safety, particularly if organized groups are taken into the mine.\n\nMine exploration shares some interests with [[Urban Exploration]], primarily that of gaining access to abandoned or sometimes restricted locations. Most mine explorers share an unspoken code of ethics, that of leaving sites in the same condition as they were found. A common phrase illustrating this viewpoint is the Baltimore Grotto caving societys motto: take nothing but pictures, leave nothing but footprints.\n\n== Rationale ==\n\n[[Image:MineBoating.jpg|thumb|right|Mine Exploration by Boat]]\n\nLike many [[hobbies]] or [[sports]], mine exploration appeals to a specific subset of people. An interest in industrial archaeology may be a motivating factor for some enthusiasts. Relics and artifacts found in abandoned mine workings may include equipment such as pumps, cranes, drills, [[narrow gauge railway|narrow gauge]] [[Rail tracks|railway tracks]], [[wagon]]s and [[locomotives]]. Abandoned mines may occasionally contain larger features such as timber [[bridge]]s, [[cable railway]]s, or [[waterwheel]]s.\n\nPhotography is often a significant component of enthusiasts motivation for exploration. Underground photography requires specialized techniques such as [[light painting]] or an open flash. Such techniques may require considerable practice for mastery.\n\nMany mine explorers probably view their hobby as another way of escaping the busy world through recreation.\n\n==Access==\n\nThere are many abandoned mines in the world - for example, it is estimated that there are approximately 500,000 abandoned mines in the United States alone, with Nevada having the largest percentage of this number. However, access to many of these is not possible for a variety of reasons, including:\n\n[[Image:JonAscends.jpg|thumb|left|SRT in a mine]]\n\n* Restricted Access: Legal access to explore mines is not always possible, even though it may be physically possible to get in. The sites of old mines are often taken over by the public bodies such as the Forestry Commission, National Trust or by private land owners who consider the liability risks of access to be sufficient to justify blocking off access permanently, a common approach being to bulldoze the [[adit]]s and cap any [[shaft mining|shafts]]. In other instances, entrances may be gated in order to restrict access to those approved by the landowner.\n\n* Re-use: The sites of old mines are sometimes taken over for new uses such as data storage or mushroom cultivation, or re-mining: the owner will rarely permit public access.\n\n* Collapse: As workings age, the roofs of passageways and chambers can fail. In doing so, the collapsed area itself is no longer accessible and any workings beyond that point will become inaccessibe if there remains no other way around. There are many mines that have suffered a small collapse right at the entrance (often the most vulnerable part) sealing off significant sized workings beyond.\n\n* Flooding: Almost all working mines require pumps to remove water, with the exception of those being self-draining via deep drainage adits. Once a mine is abandoned, the pumps are usually turned off and the mine slowly fills with water until a level is reached where water can drain out: this is usually the lowest adit. However, it is possibly to find flooded sections in mines which are above a dry adit as workings are often very complex: in some cases reservoirs may have been created in higher chambers to provide power for machinery below.\n\n* Technical Limitations: Some mines are easy walkabouts, while others require expertise, skill and equipment to explore; for example SRT may be needed to gain access via a vertical shaft.\n\n==Potential dangers==\n\nMine exploration is considered a dangerous activity by many. In the [[USA]], the [[Mine Safety and Health Administration]] (MSHA) has run an annual Stay Out-Stay Alive national public safety campaign to warn children about the dangers of exploring and playing on mine property. They claim that since 1999, nearly 150 children and adults have died in recreational accidents at active and abandoned mine and quarry sites, although the majority of these were not related to mine exploration.[http://www.msha.gov/MEDIA/PRESS/2005/NR050412.asp] For those who are prepared and educated on proper safety and gear, exploration can be a very safe and enjoyable hobby.\n\nSadly, many accidents by inexperienced curiosity-seekers cause knee-jerk reactions by government agencies to close mines. In most cases, a mine entrance will be fenced and warning signs erected, but the [[BLM]], [[NPS]] and other organizations are increasingly resorting to bulldozing, plugging or gating mine entrances, denying everyone access. Fortunately, most mine closures of this nature are done in areas near large population centers and parks that receive a large number of visitors, like [[Death Valley]]. An adept explorer with a 4x4 and some time off will find a plethora of mines to explore in more remote areas, many in pristine condition.\n\nCommon features in a mine include drifts (horizontal tunnels), shafts (vertical tunnels) and winzes or air vents that are much smaller and can be at any angle underground. Climbing through these shafts, tunnels, and winzes can be very dangerous due to their unseen entrances and exits. A drift with a portal to the outside is called an adit.\n\n[[Stoping (mining method)|Stopes]] (areas where ore was removed) usually follow the ore vein and are often at steep angles to horizontal. Many stopes are shored with wooden 2x4s or 4x4s. Contrary to what one might think, the wood isnt there to keep the stope from collapsing, but rather to hold loose rock in place. Some stopes are narrow and convoluted (explorers like to call them spider holes); others resemble giant rooms. One famous recreation of an immense stope is the Glory Hole in the mine ride at [[Knotts Berry Farm]]. Many stopes have a lot of loose material on or around them; extreme caution must be exercised.\n\nRaises are often used to transit vertically between levels of a mine. A raise is often a 6-12 foot square vertical shaft divided into two sections. One half is a straight drop to the bottom and is used for haulage, and the other section is a series of platforms, 10 or more feet apart, with holes cut in them in an alternating manner. Beneath each hole is a ladder leading to the next platform. This style of construction affords safety: if one falls off the ladder, the fall is only to the next platform, not the bottom of the shaft.\n\nMines were generally constructed and maintained to be safe while they were operational. After they are abandoned, workings may decay to a point where they could become dangerous. For instance, some support structures may have been removed before abandonment for re-use elsewhere, or supporting pillars may have been quarried away, leaving the chambering unstable. Ventilation and water pumping systems that once maintained safe working conditions are removed.\n\nThere are a number of potential hazards that mine explorers face:\n\n[[Image:MineBridge.jpg|thumb|right|Bridge over a chamber]]\n\n* Surface shafts: the ground around abandoned mine shafts and open pits may be weak and could cave-in without warning. Undergrowth may hide shafts, while timber used for capping may have rotted to a point where it will collapse if weight is put on it. Even scarier is the so-called ant-lion trap effect: loose earth around a surface shaft crumbles away over time, leaving a funnel-shaped drop-off around the shaft. If a curious person attempts to look down the shaft, he or she could begin sliding into it with nothing to stop the fall.\n\n* Collapses: the effects of blasting, weathering, and earthquakes destabilize once-strong bedrock through time. Portals (adits) in particular are affected, but tunnel and chamber roofs and walls can also destabilize. Support timber props, ladders and other similar structures may appear safe but could have degraded. Similarly, waste rock tipped down chambers may be unstable and rockslides may occur if they are walked on. If it doesnt look right, its better to leave it unexplored than to risk ones life unnecessarily.\n\n* Darkness: As with most underground places, the darkness in a mine is total. If you lose light, it may be difficult or impossible to exit the mine. An experienced explorer will carry at least three independent sources of illumination and a set of spare batteries.\n\n* Falling down vertical openings is the most common cause of death and injury in abandoned mines. [[Winze]]s are vertical or inclined shafts sunk from a tunnel and these can be hidden by darkness, water, loose debris or false floors. False floors may also be present in substantial lengths of tunnel, where the floor level has been worked ([[understoped]]). Such floors may be supported by rotten wood, but surfaced with rock and not clearly distinguishable from a solid floor. A prudent explorer wears a hard hat or climbers helmet: even if one doesnt fall, many passages are irregular and low, and a protruding rock can carve a nice gash in ones head while walking through.\n\n* Water: Water in mines is often deep and can be dangerously cold; if it fills an area with steep sides, then it may not be easy to climb out. Seemingly shallow water can conceal sharp objects, drop-offs, and other hazards. Furthermore, a wet mine can rot or rust timbers, shoring and ladders, making conditions hazardous. Desert mines tend to be dry and therefore relatively safe in this regard; however, dry rot can weaken wood. All ladders and wooden floors should be tested before trusting body weight to them.\n\n* Bad Air: Old mine workings may be hazardous due to pockets of [[blackdamp]] (still air with low oxygen levels), or high concentrations of [[methane]], [[carbon monoxide]], [[carbon dioxide]] or [[hydrogen sulfide]] which can displace oxygen, poison someone outright, or create an explosion. Coal mines are especially prone to containing these gases. The mines of the Comstock Lode Nevada are also very prone to this. If a mine is not well-ventilated or conditions are unknown, use of a properly-calibrated 4-gas detector (O<sub>2</sub>, CO<sub>2</sub>, CO, and H<sub>2</sub>S) is recommended.\n\n* [[Explosives]] such as [[dynamite]], [[black powder]] or [[blasting cap]]s may have been abandoned in old mines. Many explosives become increasingly unstable with age and could be detonated by the slightest movement or even the vibrations from a footfall.\n\n* [[Wildlife]]: Snakes, various mammals, and bats can call a mine home. Exercise caution, especially near mine portals.\n\n* Hazardous chemicals: Mines dug in wet areas give underground water a path to percolate through rock and exit via the tunnel systems. In some areas, the mine water can contain various types of heavy metals. Bacterial action can create acids and other compounds that are hazardous to humans. Acid mine drainage is of great concern in some areas. Also, mills and other processing areas may contain traces of cyanide and mercury compounds that were once used to separate precious metals from the ore.\n\n* Remoteness: Most mines are a long way from medical assistance, and depending on the circumstances, just getting to the surface could be an ordeal if one is injured. The cardinal rule of mine exploring is to never do it alone. Also, someone not with the party should be informed of where the group is going and when it plans to return.\n\nIn spite of the potential risks involved in mine exploration, the danger to the experienced mine explorer is relatively low: as the MHSA state, the majority of accidents involve people who are unprepared.\n\n== Locations ==\n===USA===\nThere are thought to be approximately 500,000 mines within the United States. Listed below are regions containing a high number of both abandoned and operational mines:\n\n* [[New York]] and [[New Jersey]]: The [[New York-New Jersey Highlands|Highlands Region]].\n* [[Pennsylvania]]: The [[Coal Region]].\n* [[California]]: The [[Mojave Desert]], [[Death Valley]], and the surrounding areas.\n* [[Nevada]]\n* [[Arizona]]\n* [[Utah]]: The [[Wasatch Range]] and Tintic Mountains\n* [[Montana]]\n* [[Colorado]]\n\n===UK===\nBritains man-made underground world is extensive. Some abandoned mines range as deep as 1.1 km. Some of the more extensive tunnel systems span mountain ranges or extend underneath populous cities.\n\nSome typical [[mining|mine]] [[exploration]] locations and type of [[mining|mines]] are:\n* [[Bath stone]] - [[Corsham]], [[Combe Down]].\n* [[Slate industry|Slate mines]] - [[North Wales]].\n* [[Lead]] Mines - [[Nenthead]], [[Cumbria]], [[The Lake District]] and [[Derbyshire lead mining history]].\n* [[Tin]] Mines - [[Devon]] [[Cornwall]], [[Geevor Tin Mine]]\n\n===Canada===\n\nSome examples of mines frequented by explorers includes:\n\n* British Columbia - There are hundreds of explored and unexplored mines in British Columbia.\n* Monarch/Kicking Horse Mine Field BC\n* Mineral King Panoroama BC\n\n===Russia===\n* [[Moscow oblast]] and adjacent regions - tens of 19-th century limestone quarries. <ref>http://speleo.ru/wiki/index.php/%D0%94%D0%BB%D0%B8%D0%BD%D0%BD%D0%B5%D0%B9%D1%88%D0%B8%D0%B5_%D0%B8%D1%81%D0%BA%D1%83%D1%81%D1%81%D1%82%D0%B2%D0%B5%D0%BD%D0%BD%D1%8B%D0%B5_%D0%BF%D0%B5%D1%89%D0%B5%D1%80%D1%8B_%D0%A0%D0%BE%D1%81%D1%81%D0%B8%D0%B8</ref>\n* [[Samara region]] - XX century limestone quarries.\n* [[Leningradskaya oblast]] - sandstone quarries.\n\n'
p238
tp239
a(I1
S'<!-- This article was automatically created by [[User:polbot]] from http://bioguide.congress.gov/scripts/biodisplay.pl?index=A000023. The prose may be stilted, and there may be grammatical and Wikification errors. Please improve in any way you see fit. -->\n[[Image:Joseph H. Acklen.jpg|thumb|200px|Joseph Hayes Acklen]]\nJoseph Hayes Acklen ([[May 20]] [[1850]]  [[September 28]] [[1938]]) was a [[United States House of Representatives|U.S. Representative]] from [[Louisiana]].\n\n==Biography==\nJoseph Hayes Acklen was born in [[Nashville, Tennessee]], to Adelicia and Joseph Alexander Smith Acklen, a wealthy couple whose main home was in Louisiana.  During the [[American Civil War]] Joseph Hayes Acklens parents sided with the [[Confederate States of America|Confederacy]], and the father fled to the familys Louisiana plantation, where he died in 1863.<ref>Findagrave.coms biosketches of [http://www.findagrave.com/cgi-bin/fg.cgi?page=gr&GSln=Acklen&GRid=21012245& Adelicia Hayes Acklen] and [http://www.findagrave.com/cgi-bin/fg.cgi?page=gr&GRid=7742953 Joseph Alexander Smith Acklen.]</ref> Joseph Hayes Acklen was educated by private tutors. He attended Burlington Military College, near [[Burlington, New Jersey]], in 1864 and 1865, and was graduated from two foreign institutions (cole de Neuilly, Paris, and [[Swiss University]], [[Vevey]]).  Joseph Hayes Acklen returned to the United States and was graduated from [[Cumberland School of Law]], [[Lebanon, Tennessee]], in 1871. He commenced practicing law in Nashville and later practiced in [[Memphis, Tennessee]], but abandoned the practice of law and moved to Louisiana to superintend the familys sugar plantations near Pattersonville (now [[Patterson, Louisiana|Patterson]]) in [[Saint Mary Parish]]. He served as colonel in the [[Louisiana_Army_National_Guard#History|Louisiana Militia]] in 1876.  In November of that year, claiming [[voting fraud]], Acklen and other [[Democratic Party (United States)|Democrats]] objected to the reelection of [[Republican Party (United States)|Republican]] [[Chester Bidwell Darrall]] to represent [[Louisianas 3rd congressional district]] ; after protracted settlement of the various controversies surrounding the [[1876 presidential election]], on 1878 February 20 Darrall left the seat and was replaced by Acklen, for the remaining half of the [[Forty-fifth Congress]]. Acklen was reelected, to the [[Forty-sixth Congress]], and served from [[1878]] [[February 20]] to [[1881]] [[March 3]].  He was not a candidate for renomination in 1880, and Darrall regained the seat for one term (the [[47th United States Congress|Forty-seventh congress]]). On leaving Congress, Acklen declined an appointment by [[President (United States)|President]] [[Rutherford B. Hayes]] to be a judge on the [[United States District Court for the Eastern District of Louisiana|Federal district court of Louisiana]] and instead resumed the practice of law, in [[Franklin, Louisiana]].  He was an unsuccessful candidate for election in 1882 to the Forty-eighth Congress.\nHe returned to [[Nashville, Tennessee]], in 1885 and continued the practice of law.\nHe served as chairman of the [[Davidson County, Tennessee]], Democratic executive committee from 1886 to 1894. He served as member of the Nashville City Council from 1900 to 1904.\nHe served as president of the Tennessee State bar association in 1901 and 1902.\nHe served as general insurance counsel of Tennessee from 1903 to 1907. He was State warden of the Tennessee department of game, fish, and forestry from 1903 to 1913. He served as general counsel of the National Association of Game and Fish Commissioners of the United States from 1905 to 1912, when he was elected president of the Association.  He was [[Middle Tennessee]] counsel for the [[St. Louis & San Francisco Railroad]] from 1907 to 1911.  From 1913 to 1914 he served under Democrat U.S. President [[Woodrow Wilson]] as chief game warden of the United States.  Acklen was author of numerous articles on [[ornithology]], [[fish culture]], [[forestry]], and [[field sports]]. He served as chairman of the State central committee on the Tennessee constitutional convention from 1923 to 1927.  \n\nAcklen died in [[Nashville]] on [[1938]] [[September 28]]. He is interred there in [[Mount Olivet Cemetery (Nashville)|Mount Olivet Cemetery]].<ref>[http://www.findagrave.com/cgi-bin/fg.cgi?page=gr&GSln=Acklen&GRid=6404544& Mount Olivet grave information.]</ref>  His familys Nashville property[[Belmont Mansion (Tennessee)|Belmont Mansion]] and its groundsnow forms a large part of the campus of [[Belmont University]], where the home continues as a museum. It is on the [[National Register of Historic Places]].<ref>http://www.pastigo.com/index.php?option=com_mtree&task=viewlink&link_id=160&Itemid=57 - Belmont Mansion, Nashville.</ref> \n\n'
p240
tp241
a(I1
S'{{otheruses}}\n{{refimprove|date=October 2009}}\nA hobby is an activity or interest that is undertaken for pleasure or relaxation in ones [[leisure|spare time]].\n\n== Etymology ==\n[[File:George Cruikshank - Tristram Shandy, Plate V. My Uncle Toby on his Hobby-horse.jpg|thumb|250px|In the 18th-century novel [[The Life and Opinions of Tristram Shandy, Gentleman]], the characters hobby-horses, or particular obsessions, are discussed in detail. Here, Uncle Tobys obsession with the military leads to him and Trim - who gets caught up in Tobys enthusiasm - to begin acting out military actions. Illustration by [[George Cruikshank]].]]\nA [[hobby horse]] is a wooden or [[wickerwork]] toy made to be ridden just like a real horse (which was sometimes called a [[Horses_in_the_Middle_Ages#Hobbies|Hobby]]). From this came the expression to ride ones hobby-horse, meaning to follow a favorite pastime, and in turn, hobby in the modern sense of recreation.<ref>Chicago Manual Style (CMS): hobby.</ref><ref>{{OEtymD|hobby}}</ref><ref>Dictionary.com. http://dictionary.reference.com/browse/hobby (accessed: July 12, 2007).</ref>\n\nHobbies are practiced for interest and enjoyment, rather than financial reward.  Examples include [[collecting]], creative and artistic pursuits, making, tinkering, [[sport]]s and adult education.  Engaging in a hobby can lead to acquiring substantial skill, knowledge and experience. However, personal fulfillment is the aim.\n\nWhat are hobbies for some people are professions for others: a [[chef]] may enjoy playing [[video game|computer games]] as a hobby, while a professional [[game tester]] might enjoy cooking. Generally speaking, the person who does something for fun, not remuneration, is called an [[amateur]] (or hobbyist), as distinct from a [[professional]].\n\nAn important determinant of what is considered a hobby, as distinct from a [[profession]] (beyond the lack of remuneration), is probably how easy it is to make a living at the activity.  Almost no one can make a living at [[cigarette card]] or stamp collecting, but many people find it enjoyable; so it is commonly regarded as a hobby.\n\n[[Amateur astronomy|Amateur astronomers]] often make meaningful contributions to the professionals. It is not entirely uncommon for a hobbyist to be the first to discover a [[celestial body]] or [[celestial event|event]].{{Fact|date=December 2007}}\n\nIn the [[United Kingdom|UK]], the pejorative noun [[Anorak (slang)|anorak]] (similar to the Japanese [[otaku]], meaning a geek or enthusiast) is often applied to people who obsessively pursue a particular hobby that is otherwise considered boring, such as [[Trainspotting (hobby)|train spotting]] or [[stamp collecting]].\n\n== Development of hobbies into other ventures ==\nWhilst some hobbies strike many people as trivial or boring, hobbyists have found something compelling and entertaining about them.  Much early scientific research was, in effect, a hobby of the wealthy; more recently, [[Linux kernel|Linux]] began as a students hobby. A hobby may not be as trivial as it appears at a time when it has relatively few followers. Thus a British [[conservationist]] recalls that when seen wearing field glasses at a London station in the 1930s he was asked if he was going to the (horse) races.{{Fact|date=March 2007}} The anecdote indicates that at the time an interest in nature was not widely perceived as a credible hobby. Practitioners of that hobby went on to become the germs of the [[conservation movement]] that flourished in Britain from 1965 onwards and became a global political movement within a generation. Conversely, the hobby of [[aircraft spotting]] probably originated as part of a serious activity designed to detect arriving waves of enemy aircraft entering English airspace during [[World War II]].{{Fact|date=March 2007}} In peacetime it usually has no such practical or social purpose.\n\n== Developing a Hobby Into Hobby Business ==\nIt is easier to turn a Hobby Business into a money making opportunity because the driver is passion and to some degree obsession. Turning your passion into a business say for example in arts and crafts, a home studio is all you need; a space to be creative. Gift shops, specialty stores, galleries and arts cafes are the best avenues to exhibit and sell artworks, pottery, woodcraft, sewing craft.\n\nAnother example of Hobby Business is a hobby farm. Breeding alpacas is very popular among early retirees as is the old fashioned hobby of preserving and [[pickling]]. Homemade, specialty foods, such as, puddings, [[preserves]] and sauces are taking over in popularity over the more mainstream commercial varieties, because of the trending attitude to buy [[organic food|organic]] especially if they are homemade produce grown from the manufacturers own farm.<ref name=unm>{{cite web |url=http://www.workfromhomeworld.net/start-a-home-business-/hobby-business.html |title=Hobby Business|author=R.Dimou|year=2009 |accessdate=2009-05-28|quote=}}</ref>\n[[Scrapbooking]] is a modern profitable hobby. Known as scrappers, these hobbyists, have created a new industry from their passion. Scrapbooking websites are growing and thriving worldwide.\n\n\n== Types of hobbies ==\n=== Collecting ===\n{{main|Collecting}}\nThe hobby of collecting consists of acquiring specific items based on a particular interest of the collector. These collections of things are often highly organized, carefully cataloged, and attractively displayed.\nSince collecting depends on the interests of the individual collector, it may deal with almost any subject. The depth and breadth of the collection may also vary. Some collectors choose to focus on a specific subtopic within their area of general interest: for example, 19th Century [[postage stamp]]s, milk bottle labels from [[Sussex]], or Mongolian harnesses and tack. Others prefer to keep a more general collection, accumulating [[Star Trek]] merchandise, or stamps from all countries of the world. There are also individuals, who take up collection of coins ([[Numismatics]]) or [[autographs]] (Philography) as their hobby; in both the cases the people try to hold on to the identities.\nSome collections are capable of being completed, at least to the extent of owning one sample of each possible item in the collection (e.g. a copy of every [[book]] by [[Agatha Christie]]). Collectors who specifically try to assemble complete collections in this way are sometimes called [[completist]]s. Upon completing a particular collection, they may stop collecting, expand the collection to include related items, or begin an entirely new collection.\nThe most popular fields in collecting have specialized commercial dealers that trade in the items being collected, as well as related accessories. Many of these dealers started as collectors themselves, then turned their hobby into a profession.\nThere are some limitations on collecting, however. Someone who has the financial means to collect stamps might not be able to collect [[Sports car|sports-cars]], for example. One alternative to collecting physical objects is collecting experiences of a particular kind. Examples include collecting through observation or [[photography]] (especially popular for transportation, e.g. [[train spotting]], [[aircraft spotting]], [[metrophile]]s, [[bus spotting]]; see also [[I-Spy]]), [[bird-watching]], and systematically visiting continents, countries (and collecting stamps in their passports), states, national parks, [[county collecting|counties]] etc.\n\n===Games===\n[[Image:Paul Czanne, Les joueurs de carte (1892-95).jpg|thumb|[[Card game]], [[1895]].]]\n\nA [[game]] is a structured or semi-structured recreational [[wiktionary:activity|activity]], usually undertaken for [[enjoyment]] (although sometimes for physical or vocational [[training]]). A goal that the [[player (game)|players]] try to reach and a set of [[wiktionary:rule|rules]] concerning what the players can or cannot do create the [[wiktionary:challenge|challenge]] and [[structure]] in a game, and are thus central to its definition.\nKnown to have been played as far back as [[prehistoric]] times, games are generally distinct from [[Manual labour|work]], which is usually carried out for [[wiktionary:remuneration|remuneration]]. Because a wide variety of activities are enjoyable, numerous types of games have developed.\n<!-- This sentence appears to be unnecessary and self-contradictory: Although enjoyment is not a requirement for a games design, the need for a game to be enjoyable is important. -->What creates an enjoyable game varies from one individual to the next. Age, understanding (of the game), intelligence level, and (to some extent) [[wiktionary:personality|personality]] are factors that determine what games a person enjoys. Depending on these factors, people vary the number and complexity of objectives, rules, challenges, and participants to increase their enjoyment.\nGames generally involve mental and/or physical stimulation. Many games help develop practical [[skills]] and serve as [[exercise]] or perform an [[education]]al, [[simulation]]al or [[psychology|psychological]] role & also roaming.\n\n===Outdoor recreation===\n\n[[Outdoor pursuits]] can be loosely considered to be the group of [[sports]] and [[Action (philosophy)|activities]] which are dependent on the great [[outdoors]], incorporating such things as [[hill walking]], [[hiking]], [[Backpacking (wilderness)|backpacking]], [[canoeing]], [[kayaking]], [[climbing]], [[caving]], and arguably broader groups such as [[Water sport (recreation)|watersport]]s and [[Winter sport|snowsport]]. Outdoor sports most often include nature in the sport.\n\nWhile obviously enjoyed by many as a bit of fun, an adrenaline rush, or an escape from reality, outdoor sport is also frequently used as an extremely effective medium in education and [[teambuilding]]. It is this ethos that has given rise to links with young people, such as the [[Duke of Edinburghs Award]] and PGL, and large numbers of outdoor education centres being established, as the stress on the importance of a balanced and widespread education continues to grow. Depending on the persons desired level of adrenaline, outdoors can be considered a type of hobby.\n\nAs interest increases, so has the rise of commercial outdoor pursuits, with outdoor kit stores opening up in large numbers and thriving, as well as outdoor pursuits [[journalism]] and magazines, both on paper and online.\n\nThe increased accessibility of outdoor pursuits resources has been the source of some negative publicity over the years also, with complaints of destroying the [[landscape]]. A widely-seen example is the destruction of [[hill]]sides as [[trail|footpath]]s are eroded by excessive numbers of visitors.\n\n===Performing arts===\n[[Image:Magicianatparty.jpg|thumb|An [[amateur]] magician performing.]]\nMany hobbies involve performing by the hobbyist, such as [[singing]], [[acting]], [[juggling]], [[magic (illusion)|magic]], [[dancing]] and other [[performing arts]].\n\n===Creative Hobbies===\nSome hobbies result in an end product of sorts.  Examples of this would be woodworking, [[photography]], [[moviemaking]], [[jewellery making|jewelry making]], playing a [[musical instrument]], software projects, [[art|artistic projects]] (such as drawing, painting, etc.), creating models out of card or paper called [[papercraft]] up to higher end projects like building or restoring a car, such as a [[Jowett]] or building a computer from scratch.  While these may just be for the enjoyment of the hobbyist, they sometimes have potential to be a small business.\n\n===Scale Modeling / Dioramas===\n\nReplicas of real things in a smaller scale go all the way back to prehistoric times, as small clay dolls and other childrens toys have been found near known population areas.  [[Greeks]], [[Roman Empire|Romans]], and [[Persians]] took the form to a greater depth during their years of world domination, using scale replicas of enemy [[fortifications]], coastal defense lines, and other geographic fixtures to plan battles.\n\nAt the turn of the Industrial Age through the 1920s, families could more often afford things such as [[Rail transport modelling|electric trains]], wind up toys (typically boats or cars) and the increasingly valuable tin toy soldiers.\n\n[[Model engineering]] refers to building functioning machinery in metal, such as [[internal combustion]] motors and [[live steam]] models or locomotives. This is a demanding hobby, requiring a multitude of large and expensive tools, e.g. [[lathe]]s and [[Milling machine|mill]]s. This hobby originated in the UK in the late 1800s, later spread and flourished in the mid-1900s. Due to the expense and space required, it is becoming more rare. \n\nScale modeling as we know it today became popular shortly after [[World War II]].  Prior to 1946, children as well as adults were content in carving and shaping wooden replicas from block wood kits, often depicting enemy aircraft to help in identification in case of invasion.\n\nWith the advent of modern plastics, the amount of skill required to get the basic shape accurately shown for any given subject was lessened, making it easier for people of all ages to begin assembling replicas in varying scales.  Superheros, aeroplanes, boats, cars, tanks, artillery, and even figures of soldiers became quite popular subjects to build, paint and display.  Although almost any subject can be found in almost any scale, there are common scales for such miniatures which remain constant today... The most popular scales for each subject are (in order of popularity):\n\n[[Image:zrail.jpg|thumb|400px|A night shot of a coffee-table sized [[Z scale]] [[Rail transport modelling|model railroad]] layout.]]\n\n*Cars     (1:24, 1:25, 1:32) \n*Railroads (1:87/1:76, 1:160, 1:220, plus ridable [[backyard railroad]]s, 1:8 and smaller.)\n*Planes   (1:48, 1:72, 1:32)\n*Armor    (1:35, 1:72: 1:48)\n*Soldiers (1:32, 1:35, 1:48, 1:6) \n\nFigures are probably the most variable of all subjects in terms of scale, and are often referred to as their metric equivalent... for example, a 1:32 scale figure soldier is more commonly described as 54mm.  Likewise other popular sizes are 90mm, 120mm and almost every increment in between. An example of a Diorama hobbie is [[Warhammer 40,000]], from [[Games Workshop]]\n\nIn addition to plastic kits, resin has become a popular material for short run productions.  The level of detail is often quite exquisite, and while more expensive than the typical plastic soldier, is much easier to work with and modify than White Metal or Pewter figures.\n\nScale modeling is no longer a high growth industry as it was during the 60s and 70s, but there are still thousands of retail shops selling kits, supplies, paints, and tools to support both the new and established hobbyist.  There are certainly more companies producing more varieties of kits on various subjects than ever before, and the levels of detail has become unbelievably accurate with the advent of modern drafting and molding equipment, and digitized [[CAD]] software to drive accuracy to the 1000th of an inch.\n\nWith the increased costs of good kits moving upward, and entertainment competition for youth moving more towards computers and video gaming in the home, the average age of the avid hobbyist is now much older than ever before - with adults making up the vast majority of enthusiasts.  At the same time, there are probably more people building now than ever, and there is a large selection of supportive magazines such as Fine Scale Modeller, Military Miniatures in Review (MMiR) and Tamiya Magazine to please almost every niche and taste of interest, from every imaginable era.  There are also several modeling clubs in most cities, with the largest and best known [[International Plastic Modelers Society]] (IPMS) supporting chapters and contests around the world.\n\n===Cooking===\n[[Cooking]] is an act of preparing [[food]] for [[eating]]. It encompasses a vast range of methods, tools and combinations of [[ingredient]]s to improve the [[flavor|flavour]] or [[digestion|digestibility of food]]. It generally requires the selection, measurement and combining of ingredients in an ordered procedure in an effort to achieve the desired result. Constraints on success include the variability of ingredients, ambient conditions, [[tool]]s and the skill of the individual cooking.\nThe diversity of cooking worldwide is a reflection of the myriad nutritional, aesthetic, agricultural, economic, cultural and religious considerations that impact upon it.\nCooking requires applying heat to a food which usually, though not always, chemically transforms it, thus changing its flavor, texture, appearance, and nutritional properties. Cooking proper, as opposed to roasting, requires the boiling of water in a receptacle, and was practised at least since the 10th millennium BC with the introduction of [[pottery]]. There is archaeological evidence of roasted foodstuffs, both animal and vegetable, in human ([[Homo erectus]]) campsites dating from the earliest known use of [[fire]] some 800,000 years ago.{{Fact|date=February 2007}}\n\n===Gardening===\n[[Gardening]] is the art of growing [[plant]]s with the goal of crafting a purposeful landscape. [[Residential garden]]ing most often takes place in or about a residence, in a space referred to as the [[garden]]. Although a garden typically is located on the land near a residence, it may also be located in a [[roof garden|roof]], in an [[Atrium (architecture)|atrium]], on a [[balcony]], in a [[windowbox]], or on a [[patio garden|patio]] or [[vivarium]].\n\n[[Image:gardening.jpg|thumb|right|200px|A gardener]] Gardening also takes place in non-residential green areas, such as [[park]]s, public or semi-public gardens ([[botanical garden]]s or [[zoological garden]]s), [[amusement park|amusement]] and [[theme park]]s, along transportation corridors, and around [[tourism|tourist attractions]] and [[garden hotels|hotels]]. In these situations, a staff of [[gardener]]s or [[groundskeeper]]s maintains the gardens.\n\nIndoor gardening is concerned with the growing of [[houseplant]]s within a [[House|residence]] or building, in a [[conservatory (greenhouse)|conservatory]], or in a [[greenhouse]]. [[Indoor garden]]s are sometimes incorporated as part of [[air conditioning]] or [[heating]] systems.\n\nWater gardening is concerned with growing plants adapted to pools and ponds. [[Bog]] gardens are also considered a type of water garden. These all require special conditions and considerations. A simple water garden may consist solely of a tub containing the water and plant(s).\n\n===Reading===\n[[Reading (process)|Reading]], such as reading [[book]]s, [[magazine]]s, [[comic]]s, or [[newspaper]]s, is a common hobby and one that can its origins back many hundreds of years. A love of [[literature]] later in life may be sparked by an interest in reading childrens literature as a child <ref>[http://www.bartleby.com/191/3.html Childrens reading Sir Arthur Quiller-Couch (18631944). On the Art of Reading.  1920. (retrieved21 April 2009)]</ref> One of the great benefits of reading as a hobby is that it can be taken up and put down whenever a free moment presents itself. When reading [[paperback]] books, it is easy to take the reading material on [[holiday]] or on [[public transport]] with very little inconvenience. One great advantage is that it allows the human mind to create its own view of the world portrayed in the book, something that can be disappointing when a book is made into a play for [[television]] or into a [[film]].\n\n'
p242
tp243
a(I-1
S'{{sociology}}\n{{cleanup|date=April 2009}}\n\nIn [[sociology]] and [[critical social theory]], alienation refers to an individuals estrangement from traditional community and others in general. It is considered by many that the [[Atomism (social)|atomism]] of [[modernity|modern society]] means that individuals have shallower relations with other people than they would normally. This, it is argued, leads to difficulties in understanding and adapting to each others uniqueness (see [[normlessness]]). It is also sometimes referred to as [[commodification]], emphasizing the compatibility of [[capitalism]] with alienation (a common theme of the early work of [[Karl Marx]]; see [[Marxs theory of alienation]]).\n\n==History==\n===Marxs theory of alienation===\n{{quote|The ultimate and most important revolutionary aspiration: to see human beings liberated from their alienation ... The individual will reach total consciousness as a social being, which is equivalent to the full realization as a human creature, once the chains of alienation are broken. This will be translated concretely into the reconquering of ones true nature through liberated labor, and the expression of ones own human condition through culture and art.| [[Che Guevara]], [[Marxist]] revolutionary <ref>[http://www.marxists.org/archive/guevara/1965/03/man-socialism.htm Socialism and Man in Cuba] A letter to Carlos Quijano, editor of Marcha, a weekly published in Montevideo, Uruguay; published as From Algiers, for Marcha: The Cuban Revolution Today by [[Che Guevara]] on March 12, 1965</ref>}}\n\n[[Marxs theory of alienation]] argues that things that naturally belong together are kept separate, or things that are properly in harmony are made to be antagonized. In the concepts most important use, it refers to the [[wikt:alienate|alienation]] of people from aspects of their human nature (Gattungswesen, usually translated as species-essence or species-being). Marx believed that alienation is a systematic result of capitalism. His theory relies on [[Ludwig Feuerbach|Feuerbachs]] [[The Essence of Christianity]] (1841), which argues that the idea of God has alienated the characteristics of the [[human being]]. [[Stirner]] would take the analysis further in [[The Ego and Its Own]] (1844), declaring that even humanity is an alienating ideal for the individual, to which Marx and Engels responded in [[The German Ideology]] (1845).\n\nMarxs Theory of Alienation is based upon his observation that in emerging industrial production under capitalism, workers inevitably lose control of their lives and selves, in not having any control of their work.  Workers never become autonomous, self-realized human beings in any significant sense, except the way the bourgeois want the worker to be realized. Alienation in [[capitalism|capitalist]] societies occurs because in [[labour (economics)|work]] each contributes to the common wealth, but can only express this fundamentally social aspect of individuality through a production system that is not publicly social, but privately owned, for which each individual functions as an instrument, not as a social being.\n\nThere is a commonly noted problem of translation in grappling with ideas of alienation derived from German-language philosophical texts: the word alienation, and similar words such as estrangement, are often used to translate two quite distinct German words, [[:de:Entfremdung|Entfremdung]] and [[:de:Entuerung|Entuerung]], interchangeably.\n\n===Late 1800s-1900s===\nMany sociologists of the late 19th and early 20th century were concerned about alienating effects of modernization. German sociologists [[Georg Simmel]] and [[Ferdinand Tnnies]] wrote critical works on [[individualization]] and [[urbanization]]. Simmels Philosophie des Geldes (Philosophy of Money) describes how relationships become more and more mediated through money. Tnnies [[Gemeinschaft and Gesellschaft|Gemeinschaft und Gesellschaft]] (Community and Society) is about the loss of primary relationships such as [[family|familial]] bonds in favour of [[Objective (goal)|goal]] oriented secondary [[Interpersonal relationship|relationships]]. This idea of alienation can be observed in some other contexts, although the term may not be as frequently used. In the context of an individuals relations within society, alienation can mean the unresponsiveness of the society as a whole to the individuality of each member of the society. When collective decisions are made, it is usually impossible for the unique needs of each person to be taken into account.  This form of alienation was criticized by many of the [[Young Hegelians]].{{Fact|date=November 2007}}\n\nIn a broader [[philosophy|philosophical]] context, especially in [[existentialism]] and [[Phenomenology (philosophy)|phenomenology]], alienation describes the inadequacy of human [[being]] or [[mind]] in relation to the world. The human mind, as the [[subject (philosophy)|subject]] of perception, relates to the world as an object of its perception, and so is distanced from the world rather than living within it. This line of thought can be found in [[Sren Kierkegaard]], who examined the [[emotion]]s and [[feeling]]s of individuals when faced with life choices. Many [[20th-century philosophy|20th-century philosophers]], both theistic and atheistic, and theologians drew many concepts from Kierkegaard, including the notions of angst, despair, and the importance of the individual. [[Martin Heidegger]]s concepts of anxiety (Angst) and mortality drew on Kierkegaard and are indebted to the way in which the latter lays out the importance of our subjective relation to truth, our existence in the face of death, the temporality of existence, and the importance of passionate affirmation of ones individual being-in-the-world. \n\n[[Jean-Paul Sartre]] described the thing-in-itself which is infinite and overflowing, and claimed that any attempt to describe or understand the thing-in-itself is reflective consciousness. Since there is no way for the reflective consciousness to subsume the pre-reflective, Sartre argued that all reflection is fated to a form of anxiety, i.e. the human condition. As well, Sartre argued that when a person tries to gain knowledge of the Other  (meaning beings or objects that are not the self), their self consciousness has a masochistic desire to be limited, which is expressed metaphorically in the famous line of dialogue from the play [[No Exit]], Hell is other people.  \n\n[[Andr Gorz]], [[Albert Camus]] and [[Theodor Adorno]], among others.\n\n'
p244
tp245
a(I-1
S'Taro Kudou is a [[Japan]]ese [[game designer|video game designer]] and [[video game music]] [[composer]]. He began his career working for [[Konami]] and [[Square Co.|Square]] in the 1990s, then joined fellow ex-Square designers at [[Love-de-Lic]] in 1996, where he designed [[UFO: A Day in the Life]]. Kudou currently works as director for the developing company [[Vanpool (company)|Vanpool]] <ref name=interview1>Interview with Taro Kudou Pt. 1, [http://www.asahi-net.or.jp/~hi3m-tkuc/int13.html]</ref><ref name=interview2>Interview with Taro Kudou Pt. 2, [http://www.asahi-net.or.jp/~hi3m-tkuc/int14.html]</ref>.\n\nHe is often mistaken for [[Sotaro Tojima]].\n\n==Works==\n*[[Axelay]] (composer, credited as Taro)\n*[[Freshly-Picked Tingles Rosy Rupeeland]] (design)\n*[[Mario & Luigi: Superstar Saga]] (design)\n*[[Super Castlevania IV]] (composer with [[Masanori Adachi]], credited as Souji Taro)\n*[[Super Mario RPG: Legend of the Seven Stars]] (design)\n*[[Moon: Remix RPG Adventure]] (design)\n*[[UFO: A Day in the Life]] (design)<ref>{{cite web | author=Bruno de Figueiredo | title=LOVE-de-LIC | url=http://hg101.classicgaming.gamespy.com/lovedelic/lovedelic2.htm | work=GameSpy.com | accessdate=2008-09-06}}</ref>\n*[[Endonesia]] (design)\n\n'
p246
tp247
a(I1
S':Nikoli is also a village on the island of [[Lefkada]]\n\nNikoli (, nikori) Co., Ltd. is a [[Japan|Japanese]] publisher that specializes in [[game|games]] and, especially, [[logic puzzle]]s. Nikoli is also the nickname of a quarterly magazine (whose full name is Puzzle Communication Nikoli) issued by the company. Nikoli became prominent worldwide with the popularity of [[Sudoku]].\n\nThe name Nikoli comes from the [[racehorse]] who won the [[Irish 2,000 Guineas]] in 1980; the president of Nikoli, [[Maki Kaji]], is fond of horse-racing and betting. {{Fact|date=April 2008}}\n\nNikolis claim to fame is its vast library of culture independent puzzles. An example of a [[language]]/[[culture]]-dependent genre of puzzle would be the [[crossword]], which relies on a specific language and [[alphabet]]. For this reason Nikolis puzzles are often purely logical, and often numerical.\n\nNikolis [[Sudoku]], the most popular logic problem in Japan, <ref>{{cite web | title = Nikoli Co. | url=http://www.nikoli.co.jp/en/puzzles/sudoku/index_text.htm | accessdate = 2008-04-23}}</ref> was popularized in the [[English language|English]]-speaking world in 2005, although it should be noted it was an American puzzle, since [[Dell Magazines]] had created it and distributed it for years. <ref name=Garns>{{cite web | url = http://www.maa.org/editorial/mathgames/mathgames_09_05_05.html | title = Ed Pegg Jr.s Math Games: Sudoku Variations | dateformat = mdy | accessdate = October 3 2006 | last = Pegg | first = Ed, Jr. | date = 2005-09-15 | work = MAA Online | publisher = The Mathematical Association of America }}</ref>\n\nThe magazine has invented several new genres of puzzles, and introduced several new games to Japan.\n\n== Nikoli puzzles ==\n[[Image:Sudoku-by-L2G-20050714.svg|thumb|right|200px|A Sudoku puzzle (image hyperlinked to solution)]]\nThese are just some of the most popular Nikoli puzzles, along with their [[Japanese language|Japanese]] names; terms in parentheses are published English titles for the same puzzles.\n\n*[[Crossword]] \n*[[Fillomino]]  (Allied Occupation)\n*[[Hashiwokakero]]  (Bridges)\n*[[Heyawake]] \n*[[Hitori]] \n*[[Light Up]] \n*[[Cross Sums|Kakuro]]  (Cross Sums)\n*[[Masyu]] \n*[[Number Link]] \n*[[Nurikabe]]  (Cell Structure)\n*[[Ripple Effect (puzzle)|Ripple Effect]] \n*[[Shikaku]]  (Divide by Squares)\n*[[Slitherlink]]  (Fences)\n*[[Sudoku]]  (Number Place, Nine Numbers)\n*[[Kuromasu]] \n*[[Yajilin]]  (Arrow Ring)\n\nFor a more complete list, see the [[List of Nikoli puzzle types]].\n\n'
p248
tp249
a(I-1
S'The Iron Law of Institutions is a proposition in the field of [[political science]].  The proposition states that the people who hold power in [[institutions]] are guided principally by preserving power within the institution, rather than the success of the institution itself.  As originally stated, there is some ambiguity between whether the people who control the institution are prepared to ignore the success of the institution, or its power.  However, in most cases it may be safely assumed that the two things being ignored amount to the same thing.\n\n==As originally stated==\nThe expression was coined by [http://www.tinyrevolution.com/mt/archives/000370.html Jonathan Schwarz] at his blog, A Tiny Revolution.  He phrases it thus:\n:The Iron Law of Institutions is: the people who control institutions care first and foremost about their power within the institution rather than the power of the institution itself. Thus, they would rather the institution fail while they remain in power within the institution than for the institution to succeed if that requires them to lose power within the institution.\n:This is true for all human institutions, from elementary schools up to the United States of America. If history shows anything, its that this cannot be changed. What can be done, sometimes, is to force the people running institutions to align their own interests with those of the institution itself and its members.\n\nThe context in which Schwarz is speaking is his contention that the [[Democratic Party (United States)|Democratic Party]] leadership is willfully indifferent to the huge potential numbers of [[Voter turnout|disaffected voters]] who would most likely vote for it in droves if it embraced (in this case) the standing [[Peace_movement#The_Iraq_War|antiwar movement]].  Put another way, Schwarz, et al.., assume that adopting policies much closer to their own is so obviously a huge vote-getter, that no compelling explanation exists for the Democratic Party failing to do so, than the Iron Law of Institutions: the existing leadership fears losing power within the Democratic Party if it embraced the incoming hordes of enthusiastic new antiwar voters.\n\nOther examples cited by Schwarz include the late [[Saddam Hussein|President Saddam Hussein]] of [[Iraq]], whose decision [[IranIraq War|to invade Iran]], then [[Gulf War|Kuwait]], resulted in catastrophes that he ought to have been capable of anticipating; a [[cabal]] by the Democratic Party leadership in 1972 to undermine the chances of George McGoverns election<ref>Allusion to Walter Karp, [http://www.amazon.com/Buried-Alive-Walter-Karp/dp/1879957043/ Buried Alive: Essays on Our Endangered Republic ], Franklin Square Press (June 1992).</ref>; and [[Joseph Stalin|Stalins]] [[Great_Purge#Purge_of_the_army|purging]] of the [[Red Army]] prior to 1941.  In each of these cases, as understood by the writer, the leader obviously placed his own power within the organization above the survival or success of the organization itself.\n\n==Origins of the phrase==\nThe term is a [[Word play|play]] on Ferdinand Lassalles expression, [[Iron law of wages]].<ref>[[Ferdinand Lassalle]], Herr Bastiat-Schulze von Delitzsch, der konomische Julian, oder: Capital und Arbeit (1864)</ref> Numerous iron laws exist, such as [http://www.jerrypournelle.com/archives2/archives2mail/mail408.html#Iron Pournelles iron law of bureaucracy], the [[Iron law of oligarchy]], and so on.  \n\n'
p250
tp251
a(I1
S'Andrew Andy Joseph Michael Sr. (June 3, 1924&ndash;June 1, 2007) was a [[sports memorabilia|baseball memorabilia]] collector. He was known as Mr. Baseball, Duke, and Flash. Born in [[Concord, New Hampshire|Concord]], [[New Hampshire]], Michael served in the [[United States Army]] during [[World War II]]. Later, he became a [[scout (sport)|scout]] for the [[New York Yankees]] and a [[collecting|collector]] of baseball memorabilia.\n\n==Early life==\nAndrew Joseph Michael was born on June 3, 1924, to Frank and Lena Michael in [[Concord, New Hampshire|Concord]], [[New Hampshire]].<ref name=Obituary>{{cite news |title=Andrew J. Michael Sr. |url=http://www.highbeam.com/doc/1P2-9559648.html |work=[[Concord Monitor]] |date=06-05-2007|accessdate=14 July 2009 }}</ref> Andrew Michaels brothers, Johnny and Tommy, also served in the Army, while his brother, Frankie, worked at the Navy Yard.<ref name=Another 1944/>\n\n==Marriage, Military Career and Family Life==\nAfter growing up playing [[baseball]], and an injury that ended his hopes for a pro career,<ref name=Another 1944>{{cite news |first= |last= |title=Another 1944 Article |url=http://www.flickr.com/photos/40373106@N06/3720996760/ |work= |date=1944 |accessdate=14 July 2009 }}</ref> Michael married his wife of 58 years, Doris Gasper Michael, at the age of 18. He then joined the [[United States Army]] on March 8, 1943.<ref name=Abbott1>{{cite news |first=Stephen |last=Abbott |title=Joe DiMaggio: Legend to legions, but a friend to Dunbarton man, page A1 |url=http://www.flickr.com/photos/40373106@N06/3712402163/ |work=[[Boston Globe]] |date=1994-08-19|accessdate=14 July 2009 }}</ref> During [[World War II]], he served in [[Germany]] and [[France]].<ref name=Abbott2>{{cite news |first=Stephen |last=Abbott |title=Joe DiMaggio: Legend to legions, but a friend to Dunbarton man, page A14 |url=http://www.flickr.com/photos/40373106@N06/3713215092/ |work=[[Boston Globe]] |date=1994-08-19 |accessdate=14 July 2009 }}</ref> As a [[Private First Class]], Michael, an explosives expert, was primarily responsible for destroying roads and bridges.<ref>{{cite news |first= |last= |title=1944 Newspaper Article |url=http://www.flickr.com/photos/40373106@N06/3720995598/ |work= |date=03-11-1944|accessdate=14 July 2009 }}</ref> He was a highly-decorated [[veteran]] who was severely injured by enemy [[shrapnel]] during combat operations in 1943. Michael returned to Concord after being [[Military discharge#Honorable|honorably discharged]].\n\nUpon returning to Concord, Michael and Doris started a family. Their first-born was a daughter, Bonnie Lena Michael, born in 1947. Their next child was a son, Andrew J. Michael Jr. born in 1951, followed by twin boys born in 1955, Frank Joseph Michael and Robert Joseph Michael.  The couple also took in their grandson, Andrew J. Michael III, at the age of 13, after the death of Andrew Jr. in 1983.\n\n==Joe Dimaggio==\nMichael had grown up around many baseball greats including [[Ray Dobens]] and [[Red Rolfe]]<ref>{{cite web |title=1939 Letter from Red Rolfe |url=http://farm4.static.flickr.com/3420/3720182597_4402a59f38_o.jpg |date=August 8, 1939 |accessdate=15 July 2009 }}</ref>\n, who introduced Michael to [[Joe DiMaggio]] in 1936 when he was 12-years-old.<ref name=Abbott1/> The two became lifelong friends and Michael began meeting players and management for the [[New York Yankees]] as he traveled with DiMaggio and the team. Michael received many personal letters from DiMaggio over the years.<ref>{{cite web |title=Andy |url=http://www.flickr.com/photos/40373106@N06/3712406295 |date=1993-12-26 |accessdate=14 July 2009 }}</ref>\n\n==Baseball==\nMichael was a [[scout (sport)|scout]] for the [[New York Yankees]] from 1978 to 1982 and was responsible for the signing of [[Bob Tewksbury]] and [[Joe Lefebvre]] who were both drafted by the Yankees out of Concord, New Hampshire. Michael left the Yankees in 1982 to pursue full time his lifelong love of collecting [[sports memorabilia|baseball memorabilia]].\n\nOver the next 25 years, Michael amassed one of the largest baseball memorabilia collections in the United States, including many pieces that he personally traveled the country carrying to get [[autograph]]ed by dozens of old-time baseball stars. His [[trademark]] is his Yankees cap, which he removed only when he showered and slept.<ref>{{cite news |first= |last= |title=Natural Pastime: Collecting Old Hat for Andy Michael |url=http://farm4.static.flickr.com/3520/3712405329_36c0e85925.jpg |work=[[Concord Monitor]] |date=1985 |accessdate=14 July 2009 }}</ref> \n\nMichael became nationally recognized for his collection and declined dozens of offers to purchase it as a whole. Michael refused to sell anything until after the death of his wife in 2004.  \n\nWhile Michael sold much of his collection to private investors, the location of some of the most valuable pieces remains unknown. \n\nMichael was inducted into the [[National Baseball Hall of Fame]] in 2005 as a lifetime member for his numerous donations to the museum of rare baseball memorabilia over five decades. <ref>{{cite news |title=Hall of Fame Induction |url=http://farm3.static.flickr.com/2649/3712405845_f738cecb7d_o.jpg |work=[[Boston Globe]] |date=1999-09-22 |accessdate=15 July 2009 }}</ref>\n\n==Death==\nMichael suffered a stroke and died a few days later at the Concord Hospital on June 1, 2007.<ref name=Obituary/> He was preceded in death by his wife, Doris, his first son, Andrew Michael, Jr. and his daughter Bonnie.\n\n'
p252
tp253
a(I1
S'{{Unreferenced|date=September 2008}}\n[[Image:Urbanlumberjack1.JPG|thumb|left|Beginning to take the pallet apart]]\n\nUrban lumberjacking is a particular type of [[skipping|dumpster diving]] (UK) or [[dumpster diving]] (US) where the focus is to salvage wood either for home construction projects or for home heating.  It is specifically celebrated for being a carbon negative activity.\n\n==Carbon implications==\nUrban Lumberjacking is an overall carbon negative activity as opposed to [[carbon offset|carbon neutral]], meaning that it actually reduces the amount of carbon that would have been released into atmosphere compared to the amount that would have been released should it not have been performed.  (Many people believe that reducing human carbon dioxide emissions will help reduce [[climate change]], otherwise referred to as [[global warming]]).\n\n[[Image:Urbanlumberjack2.JPG|thumb|right|Pallet fully taken apart]]\n\nThis reduction is achieved in two different ways:\n\n* Firstly, by removing the wood from a [[skip]] you are reducing the amount of [[gasoline|petrol]] or [[Diesel fuel|diesel]] burnt that would have been used transporting it to a [[landfill]].  A [[landfill]] is known as a dump (US) or tip (UK).  If the [[skip]] is entirely emptied then this figure is reduced to zero.\n\n[[Image:Urbanlumberjack3.jpg|thumb|left|Ready for burning in the stove]]\n\n* Secondly, should the proceeds of the urban lumberjacking be home heating, then there may also be a reduction of fossil fuel based home heating methods otherwise in use i.e. either coal, natural gas or heating oil. This process is considered as carbon neutral.\n\n==Tips and Tools==\n*[[Pallet|Wooden pallets]] are a good source of wood due to their relative abundance, ease of transport and lack of paint and preserver.\n*A [[Crowbar (tool)|crowbar]] is useful for breaking up pallets and most other wooden structures.  In addition, a crowbar is a good tool for removing any remaining nails.\n*A [[saw]] or [[axe]] can be used for breaking the wood into desired lengths.\n*A [[wheelbarrow]] is a good substitute for a strong pair of arms, especially when salvage goods need to be carried over considerable distances.\n*A wood or multi-fuel burning [[stove]] or open [[fireplace]] is recommended for home heating.  It is essential that care is taken to reduce the fire spreading from its designated area.  In addition, sufficient ventilation should be provided to avoid carbon monoxide and smoke inhalation.\n\n'
p254
tp255
a(I-1
S'Henrique Olifiers is a [[Brazil]]ian [[game designer]] specialized in creating media convergent game formats.\n\n==Career==\nOlifierss last position in Brazil was as Head of Games at [[Rede Globo|Globo TV]]. There he developed around 30 web-based games, some of them multiplayer, such as [[Thorvarium]] 1 and 2. He developed one [[massive multiplayer online role-playing game]] called [[Herois e vampiros]] (Heroes and Vampires). He was also the lead designer in the production of the games [[Conquista de Tit]], and [[My Big Brother]].\n\nInterestingly, Olifiers is better known not as a game designer but as a gaming journalist. He conducted [[GamesMania Brazil]], the South American arm of the worldwide GamesMania online magazine. As a chief-editor, he led the gaming portal in the early 90s. \n\nAfter GamesMania Olifiers founded [[LagZero]], a multiplayer-oriented gaming portal that later became the wider [http://www.FinalBoss.com/ FinalBoss.com], actually the largest hardcore gaming portal in Latin America. FinalBoss.com is also a startup game development company.\n\nOlifiers worked as Head of [[MechScape]] at [[Jagex]] Ltd <ref name=massivelymechscape>{{Cite web|url=http://www.massively.com/2008/07/15/jagex-teases-sci-fi-successor-to-runescape-mechscape/|title=E308: Jagex teases sci-fi successor to Runescape, Mechscape|accessdate=2008-07-19|publisher=Massively|year=2008|author=Michael Zenke|language=English}}</ref> until he left in 2009.\n\n'
p256
tp257
a(I-1
S'{{For|the collection of novellas by [[L. Sprague de Camp]]|Divide and Rule (collection)}}\n{{Cleanup|date=March 2008}}\n{{See also|counter-insurgency}}\n{{wiktionary}}\nIn [[politics]] and [[sociology]], divide and rule (derived from [[Latin]] divide et impera) (also known as divide and conquer) is a combination of [[political psychology|political]], [[military strategy|military]] and [[economic strategy|economic]] [[strategy]] of gaining and maintaining power by breaking up larger concentrations of power into chunks that individually have less power than the one implementing the strategy. In reality, it often refers to a strategy where small power groups are prevented from linking up and becoming more powerful, since it is difficult to break up existing power structures.\n\nThe maxims divide et impera or divide ut regnes are traditionally identified with the principle of government of the Old French Republic. This attribution is not entirely reliable, insofar as the Roman ruler, Caesar, also used this tactic in earlier times. It is, however, borne out by the example of [[Gabinius]] parting [[Iudaea Province|the Jewish nation]] into five conventions, reported by [[Flavius Josephus]] in Book I, 169-170 of The Wars of the Jews (De bello Judaico) [http://www.perseus.tufts.edu/cgi-bin/ptext?lookup=J.+BJ+1.159]. Likewise, [[Strabo]] reports in Geography, 8.7.3 [http://www.perseus.tufts.edu/cgi-bin/ptext?lookup=Strab.+8.7.1], that the [[Achaean League]] was gradually dissolved under the Roman possession of the whole of [[Greece]], owing to them not dealing with the several states in the same way, but wishing to preserve some and to destroy others.\n\nIn modern times, [[Traiano Boccalini]] cites Divide et impera in La bilancia politica, 1,136 and 2,225 as a common principle in politics. The use of this technique is meant to empower the sovereign to control subjects, populations, or factions of different interests, who collectively might be able to oppose his rule. [[Machiavelli]] identifies a similar application to military strategy, advising in Book VI of The Art of War [http://etext.library.adelaide.edu.au/m/machiavelli/niccolo/m149a/chapter6.html] (Dellarte della guerra [http://www.intratext.com/IXT/ITA1109/_P7.HTM]), that a Captain should endeavor with every art to divide the forces of the enemy, either by making him suspicious of his men in whom he trusted, or by giving him cause that he has to separate his forces, and, because of this, become weaker.\n\nThe strategy of division and rule has been attributed to sovereigns ranging from [[Louis XI]] to [[Habsburgs|the Habsburgs]]. Its historical reception has been mixed. Thus [[Edward Coke]] denounces it in Chapter I of the Fourth Part of the Institutes, reporting that when it was demanded by the [[House of Lords|Lords]] and [[British House of Commons|Commons]] what might be a principal motive for them to have good success in [[Parliament of England|Parliament]], it was answered: Eritis insuperabiles, si fueritis inseparabiles. Explosum est illud diverbium: Divide, & impera, cum radix & vertex imperii in obedientium consensus rata sunt. [You would be insuperable if you were inseparable. This proverb, Divide and rule, has been rejected, since the root and the summit of authority are confirmed by the consent of the subjects.] On the other hand, in a minor variation, [[Francis Bacon|Sir Francis Bacon]] touts the cunning maxim of separa et impera in a letter to [[James I of England|James I]] of 15 February 1615. Likewise [[James Madison]] recommends in a letter to [[Thomas Jefferson]] of 24 October 1787 [http://press-pubs.uchicago.edu/founders/documents/v1ch17s22.html], summarizing the thesis of [[Federalist Papers|The Federalist #10]] [http://www.constitution.org/fed/federa10.htm]: Divide et impera, the reprobated axiom of tyranny, is under certain qualifications, the only policy, by which a republic can be administered on just principles. In Perpetual Peace: A Philosophical Sketch\nby Immanuel Kant (1795), Appendix one. divide et impera is the third of three political maxims. The other being Fac et excusa and Si fecisti, nega. \n<ref>http://www.constitution.org/kant/append1.htm</ref>\nTypical elements of this technique are said to involve\n* creating or encouraging divisions among the subjects in order to forestall alliances that could challenge the sovereign. \n* aiding and promoting those who are willing to cooperate with the sovereign. \n* fostering distrust and enmity between local rulers. \n* encouraging frivolous expenditures that leave little money for political and military ends. \n\nThe use of this strategy was imputed to administrators of vast empires, including the [[Roman Empire|Roman]] and [[British Empire|British]], who were charged with playing one tribe against another to maintain control of their territories with a minimal number of imperial forces. The concept of Divide and Rule gained prominence when India was a part of the British Empire, but was also used to account for the strategy used by the Romans to take Britain, and for the [[Anglo-Normans]] to take Ireland. It is said that the British used the strategy to gain control of the large territory of India by keeping its people divided along lines of religion, language, or caste, taking control of petty princely states in India piecemeal.\n\nAlso mentioned as a strategy for market action in [[economics]], it can be applied to get the most out of the players in a competitive market.\n\n==Examples of Divide and Conquer strategies==\n{{Articleissues|section=y|cleanup=June 2007|POV=August 2007|refimprove=November 2007|OR=August 2007|weasel=August 2007}}\n\n\n===Africa===\n\nWestern countries have used the divide and conquer strategy in [[Africa]] during the [[Scramble for Africa|colonial]] and post-colonial period.\n\n*[[Germany]] and [[Belgium]] both ruled [[Rwanda]] and [[Burundi]] in a colonial capacity. Germany used the strategy of divide and conquer by placing members of the [[Tutsi]] minority in positions of power. When Belgium took over in 1916, the [[Tutsi]] and [[Hutu]] groups were rearranged according to race rather than by occupation. Belgium defined Tutsi as anyone with more than ten cows or a long nose, while Hutu meant someone with less than ten cows and a broad nose. The socioeconomic divide between Tutsis and Hutus continued after independence and was a major factor in the [[Rwandan Genocide]].\n\n*When the [[British Empire]] ruled [[Sudan]], it restricted access between the North and the South. The British also neglected to develop [[southern Sudan]] or include southern Sudanese in governance. The disparity between the North and South helped lead to the [[First Sudanese Civil War|First]] and [[Second Sudanese Civil War|Second]] Sudanese Civil Wars. See also [[History of the Anglo-Egyptian Condominium]].\n\n*During [[British Colony and Protectorate of Nigeria|British]] rule of [[Nigeria]] from 1900 to 1960 different regions were frequently reclassified for administrative purposes. The British used conflict between [[Igbo people|Igbo]] and [[Hausa people|Hausa]] as a means of consolidating their power in the region. Regional, ethnic, and religious splits remain a barrier to uniting [[Nigeria]]. [http://www.historyworld.net/wrldhis/PlainTextHistories.asp?historyid=ad41]\n\n\n===Cyprus ===\n*Cyprus was placed under [[United Kingdom|British]] control on [[4 June]] [[1878]] as a result of the [[Cyprus Convention]], which granted control of the island to Britain in return for British support of the Ottoman Empire in the [[Russo-Turkish War, 18771878|Russian-Turkish War]].\n*[[Famagusta]] harbour was completed in June 1906; by this time the island was a strategic naval outpost for the [[British Empire]], shoring up influence over the Eastern [[Mediterranean]] and [[Suez Canal]], the crucial main route to [[India]].\n*A British colonial strategy was to keep the [[Greek Cypriots|Greek Cypriot]] majority and [[Turkish Cypriots|Turkish Cypriot]] minority of the island separate and discourage intermingling. The British hoped and succeeded to strengthen their hold on this strategically important colony. [http://countrystudies.us/cyprus/52.htm]\n*Cyprus Independence was attained in 1960 after exhaustive negotiations between the [[United Kingdom]], as the colonial power, and [[Greece]] and [[Turkey]], the cultural motherlands for both of the communities in Cyprus. The UK ceded the island under a constitution allocating government posts and public offices by ethnic quota, but retained two [[Sovereign Base Areas]]. The British drafted constitution, reflected mutual distrust bred earlier between the communities by the colonial power. Today, two British [[Sovereign Base Areas]] are found in [[Cyprus]] and the divide et impera effects endure as the [[Cyprus dispute]].\n\n===Europe===\n* The first large-scale application of this rule was in [[Macedon]]ia.{{Fact|date=October 2008}} Romans entered Macedonia from the south and helped by Latin, Italian and Greek allies, they defeated King [[Perseus of Macedon]] in the [[battle of Pydna]] in 168 BC. Immediately afterwards, they divided Macedonia into four republics that were heavily restricted from intercourse or trade with one another and with Greece. There was a ruthless purge, with allegedly anti-Roman citizens being denounced by their compatriots and deported in large numbers.\n*Following the [[October revolution]], the [[Bolsheviks]] engaged at various times in alliances with the [[Left Socialist-Revolutionaries]], certain [[anarchists]], and various non-Russian ethnic [[nationalist]] groups, against the [[White movement]], [[Right Socialist-Revolutionaries]], and other anarchist and ethnic nationalist groups. This was done in the context of establishing the [[Communist Party of the Soviet Union]] (the Bolshevik party) as the sole legal party in the [[Soviet Union]]. Similar shifting alliances were played out amongst various dissident factions within the CPSU, such as the [[Workers Opposition]] and [[Left Communists]], with [[Joseph Stalin]] and his supporters gaining absolute power within the party by the mid-1920s.\n\n*The [[Salami strategy]] of Hungarian Communist leader, [[Mtys Rkosi]].{{Fact|date=August 2007}}\n\n*Alliances with various parties played a role in the Nazi [[Machtergreifung]] and [[Gleichschaltung]], the seizure and consolidation of total power by the [[National Socialist German Workers Party]]. The [[Enabling Act]], which banned the [[Communist Party of Germany|Communist]] and [[Social Democratic Party of Germany|Social Democratic]] parties, was supported by the Nazis coalition partner, the [[German National Peoples Party]], as well as by the [[Centre Party (Germany)|Centre Party]]. Several months later, these parties were themselves banned, along with all other political parties other than the NSDAP.\n\n===India===\n{{Expand|date=January 2007}}\nThe British employed Divide and Rule in [[British India]] as a means of preventing an uprising against the Raj. The [[partition of India]] is often attributed to these policies <ref>[http://www.english.emory.edu/Bahri/Part.html The Partition of India<!-- Bot generated title -->]</ref>. \n\nIn his historical survey [[Constantines Sword]], [[James P. Carroll]] writes, \n:Typically, imperial powers depend on the inability of oppressed local populations to muster a unified resistance, and the most successful occupiers are skilled at exploiting the differences among the occupied.  Certainly that was the story of the [[British Empire]]s success, and its legacy of nurtured local hatreds can be seen wherever the [[Union Flag]] flew, from [[Muslim]]-[[Hindu]] hatred in [[Pakistan]] and [[India]], to '
p258
tp259
a(I1
S'{{for|the Japanese footballer|Takashi Amano (footballer)}}\n{{Infobox Artist\n| bgcolour      = #6495ED\n| name          = Takashi Amano\n| image         = \n| imagesize     = \n| caption       = \n| birthname     = \n| birthdate     = {{Birth date|1954|7|18|df=y}}\n| location      = \n| deathdate     = \n| deathplace    = \n| nationality   = [[Japan]]\n| field         = [[photographer]],[[Aquarist]]\n| training      = \n| movement      = \n| works         = \n| patrons       = \n| influenced by = \n| influenced    = [[Freshwater aquarium]]\n| awards        = Fuji Film Nature Photo Contest, Grand Prix, 1992\n}}\n\n{{BLP unsourced|date=March 2009}}\n{{Original research|date=September 2007}}\n{{nihongo|Takashi Amano||Amano Takashi}} is a [[photographer]], [[designer]] and [[Aquarist]]. \nHis interest in [[aquarium|aquaria]] led him to create the Japanese company [[Aqua Design Amano]].\n\nTakashi Amano is one of the most influential people in the [[freshwater]] [[aquascaping]] community. He can largely be credited with introducing Japanese gardening concepts such as [[Wabi-sabi]] and [[Zen]] rock arrangement to the aquascaping hobby.  His tank compositions involve intricate, and typically asymmetrical (though balanced) arrangements of aquatic plants often augmented by river rocks and [[driftwood]].  His aquascapes are notable in that they often mimic nature in their appearance, and can be regarded as a form of art. \n\nAmano is the author of [[Nature Aquarium World]](T.F.H. Publications, 1994), a three-book series on aquascaping and [[Freshwater aquarium plant species|freshwater aquarium plants]] and [[List of freshwater aquarium fish species|fish]]. He has also published the book Aquarium Plant Paradise(T.F.H. Publications, 1997).\n\nAmano can also be credited with popularizing the use of [[Glossostigma elatinoides]] and [[Riccia fluitans]] in aquascaping and the use of [[shrimp]] as a means of controlling the growth of [[algae]].  \n\nA species of freshwater shrimp is named the Amano shrimp or Yamato shrimp ([[Caridina multidentata]]; previously Caridina japonica) after him. After discovering this species ability to eat large quantities of algae, Amano asked a local distributor to special order several thousand of them.<ref name=NAW1>{{cite book\n  | last = Amano\n  | first = Takashi\n  | title = Nature Aquarium World: Book 1\n  | publisher = TFH Publications\n  | date = March 1994\n  | location = Neptune, NJ\n  | isbn = 0-7938-0089-7 }}</ref> They have since become a staple in the freshwater planted aquarium hobby.\n\nHe has also developed a line of aquarium components that are known as ADA, and his Nature Aquarium article series appears monthly in [[Tropical Fish Hobbyist]] magazine in the U.S. \n\n==Aquarist==\nTakashi Amano has established own style of plant layout, Nature Aquarium: plants, fishes and microorganisms cohabit and create an ecological system in an aquarium tank; plants absorb CO2, photosynthesize and produce oxygen, and this rich oxygen creates the best environment for fishes and microorganism. He founded Aqua Design Amano Co., Ltd. in 1982 and became attention for its development of aquatic plant growing equipments, Nature Aquarium Goods. His photo book of Nature Aquarium Glass no Naka no Daishizen published in 1992 followed by Mizu-Shizen eno kaiki, were translated into 7 languages and created a great sensation among planted aquarium hobbyists around the world.\n\n==Biography of Photographer==\nSince 1975, Takashi Amano has visited tropical rainforests in Amazon, Borneo and West Africa and pristine forests in Japan, and he has been working on series of photos focusing on untouched nature with his large-format cameras. He captures minute details of nature found at site on extra large size films (up to 8x20 inches). His works have been introduced internationally through the several exhibitions and publications. Amano is now taking on a challenge to record the existing precious nature of Japan on large-format films and pass down to posterity.\nIn recent years, Amano has given numbers of lectures on his photography expeditions and his experiences in nature around the world, and he has advocated the importance of tree-planting programs to protect the earths environment. He is a member of the [[Japan Professional Photographers Society]], the [[Japan Advertising Photographers Association]], and the Society of Scientific Photography.\n\n===G8 Hokkaido Toyako Summit===\nTwo landscape photos of Takashi Amano were displayed at [[34th G8 summit]] Working Lunch / Outreach Working Session of Hokkaido Toyako Summit held from July 7 till 9th 2008. The photos of pristine cedar tree forest in Sado Island taken by 8x20 inches large format camera were exhibited on the 4.0x1.5m panel.\n* [http://www.amanotakashi.net/info/080708.html Official web site News release]\n\n==Bibliography==\n{| class=wikitable border=1\n|-\n! YEAR\n! TITLE\n! PUBLISHER\n! COUNTRY\n|-\n| 1992\n| Glass no Naka no Daishizen\n| Marine Planning\n| Japan\n|-\n| 1994\n| Mizu-Shizen eno Kaiki\n| Marine Planning\n| Japan\n|-\n| \n| Nature Aquarium World\n| T.F.H. Publications\n| U.S.A.\n|-\n| \n| Pflanzenparadies unter Wasser\n| Natur Buch Verlag\n| Germany\n|-\n| 1996\n| Nature Aquarium World Book 2\n| T.F.H. Publications\n| U.S.A.\n|-\n| \n| Nature Aquarium World Book 3\n| T.F.H. Publications\n| U.S.A.\n|-\n| \n| De wonderlijke wereld onder water\n| Natur Design Verlag\n| Netherlands\n|-\n| \n| Faszinierendes Aquarium\n| Natur Buch Verlag\n| Germany\n|-\n| \n| Le Nouveau Monde des Plantes Aquatiques\n| Natur Design Verlag\n| France\n|-\n| 1997\n| Aquarium Plant Paradises\n| T.F.H. Publications\n| U.S.A.\n|-\n| \n| Amanos Naturaquarien\n| Editoriale Giorgio Mondadori\n| Italy\n|-\n| 1998\n| Ihr Hobby-Naturaquarien\n| Natur Buch Verlag\n| Germany\n|-\n| \n| Diskus im Naturaquarium\n| Natur Buch Verlag\n| Germany\n|-\n| \n| Das Groe Buch der Naturaquarien\n| Natur Buch Verlag\n| Germany\n|-\n| \n| Les aquariums naturels dAmano\n| JEH Productions\n| France\n|-\n| 2004\n| The Rio Negro\n| Marine Planning\n| Japan\n|-\n| 2007\n| SADO - To Pristine Forest From Bottom of Sea\n| ADA\n| Japan\n|-\n| 2009\n| SADO - To Pristine Forest From Bottom of Sea<br />Revised and Enlarged Edition\n| ADA\n| Japan\n|}\n\n==Exhibitions==\n{| class=wikitable border=1\n|-\n! YEAR\n! EXHIBITION TITLE\n! PLACE\n! COUNTRY\n|-\n| 1998\n| Urin-Ujou\n| Fuji Photo Salon, Tokyo\n| Japan\n|-\n| 2004\n| Dare mo Shiranai Amazon\n| Niitsu Art Forum, Niigata\n| Japan\n|-\n| \n| The Rio Negro\n| Nizayama Forest Art Museum, Toyama\n| Japan\n|-\n| 2006\n| The Rio Negro\n| Nature Info PlazaMarunouchi Saezurikan, Tokyo\n| Japan\n|-\n| \n| Sozo no Genten Amazon\n| Toki Messe, Niigata\n| Japan\n|-\n| \n| Kusatsu-Amazon\n| Niigata Daiwa, Niigata\n| Japan\n|-\n| 2007\n| Sado-From bottom of the Sea to the Pristine Forest\n| Tokyo Metropolitan Museum of Photography\n| Japan\n|-\n| \n| Daremo Shiranai Sado\n| Niigata Prefectual Civic Center\n| Japan\n|-\n| 2008\n| Daremo Shiranai Sado\n| Amusement Sado, Niigata\n| Japan\n|-\n| 2009\n| [http://www.amanotakashi.net/info/090127.html SADO - a Natural Treasure of Japan]\n| Qatar Photography Society, Doha\n| Qatar\n|-\n| 2009\n| [http://www.amanoinindia.com/posteramano.html Takashi Amano in India for Aquatika 2009]\n| NIMHANS Convention Hall, Bangalore\n| India\n|}\n\n'
p260
tp261
a(I1
S'{{redirect|Fishtank}}\n{{pp-move-indef}}\n{{alternateuses}}\n\n[[Image:Amaterske akvarium.jpg|right|thumb|A [[freshwater aquarium]] with plants and [[tropical fish]]]]\n[[Image:Home aqua 240 litres.png|thumb|A [[aquascaping|well planted]] aquarium (240&nbsp;l)]]\nAn aquarium (plural aquariums or aquaria) is a [[vivarium]] consisting of at least one [[transparent materials|transparent]] side in which [[water]]-dwelling [[plant]]s or [[animal]]s are kept. [[fishkeeping|Fishkeepers]] use aquaria to keep [[fish]], [[invertebrate]]s, [[amphibian]]s, [[marine mammal]]s, [[turtle]]s, and aquatic plants. The term combines the Latin root aqua, meaning water, with the suffix -arium, meaning a place for relating to.<ref>{{cite web | url = http://www.m-w.com/dictionary/aquarium | title = Definition of aquarium | publisher = Merriam-Webster Online Dictionary | accessdate = 2007-04-03 }}</ref>\n\nAn aquarist owns fish or maintains an aquarium, typically constructed of [[glass]] or high-strength [[plastic]]. [[Cuboid]] aquaria are also known as fish tanks or simply tanks, while [[bowl (vessel)|bowl]]-shaped aquaria are also known as fish bowls. Size can range from a small glass bowl to immense [[public aquarium|public aquaria]]. Specialised equipment maintains appropriate water quality and other characteristics suitable for the aquariums residents. \n\n== History and popularization ==\nIn the [[Roman Empire]], the first fish to be brought indoors was the [[Barbel (fish species)|sea barbel]], which was kept under guest beds in small tanks made of marble. Introduction of glass panes around the year 50 allowed Romans to replace one wall of marble tanks, improving their view of the fish. In 1369, the [[Emperor of China|Chinese Emperor]], [[Hongwu]], established a [[porcelain]] company that produced large porcelain tubs for maintaining [[goldfish]]; over time, people produced tubs that approached the shape of modern fish bowls.<ref>{{cite book | last = Brunner | first = Bernd | title = The Ocean at Home | publisher = Princeton Architectural Press | year = 2003 | location = New York | isbn = 1-56898-502-9 | pages = 2122}}</ref> Leonhard Baldner, who wrote Vogel-, Fisch- und Tierbuch (Bird, Fish, and Animal Book) in 1666, maintained [[weather loach]]es and [[newt]]s.<ref name = duqmbv>Brunner, B: The Ocean at Home, page 25</ref>\n\nIn 1836, soon after his invention of the [[Wardian case]], Ward proposed to use his tanks for tropical animals. In 1841 he did so, though only with aquatic plants and toy fish. However, he soon housed real animals. In 1838, [[Flix Dujardin]] noted owning a [[saltwater aquarium]], though he did not use the term.<ref name=Brunner35>Brunner, B: The Ocean at Home, page 35</ref> In 1846, Anna Thynne maintained [[Scleractinia|stony corals]] and [[seaweed]] for almost three years, and was credited as the creator of the first balanced marine aquarium in London.<ref>Brunner, B: The Ocean at Home, pages 35-36</ref> At about the same time, Robert Warington experimented with a 13-gallon container, which contained goldfish, [[Vallisneria|eelgrass]], and [[snail]]s, creating one of the first stable aquaria. He published his findings in 1850 in the [[Chemical Society|Chemical Societys]] [[scientific journal|journal]].<ref>Brunner, B: The Ocean at Home, page 36</ref>\n\n[[Image:Pike aquarium c1908.jpg|thumb|right|[[Esox|Pike]] in an aquarium c. 1908, at the [[Belle Isle Aquarium]], [[Belle Isle Park]]]]\nThe keeping of fish in an aquarium became a popular hobby and spread quickly. In the United Kingdom, it became popular after ornate aquaria in cast iron frames were featured at the [[The Great Exhibition|Great Exhibition]] of 1851. In 1853, the first large public aquarium opened in the [[London Zoo]] and came to be known as the Fish House.<ref>Brunner, B: The Ocean at Home, pages 99</ref> [[Philip Henry Gosse]] was the first person to actually use the word aquarium, opting for this term (instead of vivarium) in 1854 in his book The Aquarium: An Unveiling of the Wonders of the Deep Sea. In this book, Gosse primarily discussed saltwater aquaria.<ref>Brunner, B: The Ocean at Home, page 38</ref> In the 1850s, the aquarium became a fad in the United Kingdom.<ref>Brunner, B: The Ocean at Home, page 57</ref>\n[[Image:What an Aquarium Should Be.png|thumb|left|upright|What an Aquarium Should Be - an 1876 British engraving]]\nGermans soon rivaled the British in their interest. In 1854, an anonymous author had two articles published about the saltwater aquaria of the United Kingdom: Die Gartenlaube (The Garden House) entitled Der Ocean auf dem Tische (The Ocean on the Table). However, in 1856, Der See im Glase (The Lake in a Glass) was published, discussing freshwater aquaria, which were much easier to maintain in landlocked areas.<ref>Brunner, B: The Ocean at Home, pages 60-61</ref> During the 1870s, some of the first [[Aquarium fish clubs|aquarist societies]] were appearing in Germany.<ref name=Brunner75>Brunner, B: The Ocean at Home, page 75</ref> The United States soon followed. Published in 1858, Henry D. Butlers The Family Aquarium was one of the first books written in the United States solely about the aquarium.<ref>Brunner, B: The Ocean at Home, page 69</ref> According to the July issue of The North American Review of the same year, William Stimson may have owned some of the first functional aquaria, and had as many as seven or eight.<ref>Brunner, B: The Ocean at Home, page 71</ref> The first aquarist society in the United States was founded in [[New York City]] in 1893, followed by others.<ref name=Brunner75/> The New York Aquarium Journal, first published in October 1876, is considered to be the worlds first aquarium magazine.<ref>Brunner, B: The Ocean at Home, pages 76-77</ref>\n\nIn the [[Victorian era]] in the [[United Kingdom]], a common design for the home aquarium was a glass front with the other sides made of wood (made watertight with a [[pitch (resin)|pitch]] coating). The bottom would be made of [[slate]] and heated from below.<ref name=Sanford>{{cite book | title = Aquarium Owners Guide | last = Sanford | first = Gina | publisher = [[DK Publishing]] | location = New York | year = 1999 | pages = 913 | isbn = 0-7894-4614-6}}</ref> More advanced systems soon began to be introduced, along with tanks of glass in metal frames.<ref name=Sanford/> During the latter half of the 19th century, a variety of aquarium designs were explored, such as hanging the aquarium on a wall, mounting it as part of a [[window]], or even combining it with a [[birdcage]].<ref>Brunner, B: The Ocean at Home, pages 86-89</ref> \n\nAquaria became more widely popular as houses had an electricity supply after [[World War I]]. [[Electricity]] allowed artificial lighting as well as [[aeration]], [[filtration]], and heating of the water.<ref>Brunner, B: The Ocean at Home, page 93</ref> Initially, amateur aquarists kept native fish (with the exception of goldfish); the availability of exotic species from overseas further increased the popularity of the aquarium.<ref>Brunner, B: The Ocean at Home, page 78</ref> Jugs made from a variety of materials were used to import fish from overseas, with a [[bicycle pump|bicycle foot pump]] for aeration.<ref>Brunner, B: The Ocean at Home, pages 82-83</ref> Plastic shipping bags were introduced in the 1950s, making it easier to ship fish.<ref>Brunner, B: The Ocean at Home, page 82</ref> The eventual availability of air freight, allowed fish to be successfully imported from distant regions.<ref name = duqmbv/> In the 1960s metal frames made [[marine aquarium|marine aquaria]] almost impossible due to corrosion, but the development of [[tar]] and [[silicone]] sealant allowed the first all-glass aquaria made by Martin Horowitz in Los Angeles, CA. The frames remained, however, though purely for aesthetic reasons.<ref name=Sanford/>\n\nThere are now around 60 million aquarists worldwide.{{Citation needed|date=April 2007}} In the United States, aquarium keeping is the second-most popular hobby after [[stamp collecting]].<ref name=baensch>{{cite book |last=Riehl |first=Rdiger. Editor. |coauthors=Baensch, HA |title=Aquarium Atlas |year=1996. 5th Edn. |publisher=Tetra Press |location=Germany |isbn=3-88244-050-3}}</ref> In 1999 it was estimated that over nine million U.S. households own an aquarium. Figures from the 2005/2006 APPMA National Pet Owners Survey report that Americans own approximately 139 million freshwater fish and 9.6 million saltwater fish.<ref>{{cite web|url=http://directmag.com/mag/marketing_aquarium_hobbyists/|title=Aquarium Hobbyists|last=Emerson|first=Jim|date=1999-08-01|accessdate=2007-05-02}}</ref><ref>{{cite web|url=http://www.appma.org/newsletter/may2005/npos.html|title=National Pet Owners Survey|publisher=American Pet Products Manufacturers Association|year=2005|accessdate=2007-05-02}}</ref> Estimates of the numbers of fish kept in aquaria in Germany suggest at least 36 million.<ref name=baensch/> The hobby has the strongest following in Europe, Asia, and North America. In the United States, 40 percent of aquarists maintain two or more tanks.{{Citation needed|date=April 2007}}\n\n== Design ==\n[[Image:Aquarium 60cm.JPG|thumb|right|An 80 liter home aquarium]]\n=== Materials ===\nMost aquaria consist of [[glass]] panes bonded together by [[silicone]], with plastic frames that are attached to the upper and lower edges for decoration. The glass aquarium is standard for sizes up to about 1000&nbsp;[[litre]]s (250&nbsp;[[gallon|gal]]). However, glass is brittle and has very little give before fracturing, though generally the sealant fails first.<ref name=Adey>{{citation|title=Dynamic Aquaria|last1 = Adey|first1 = Walter H.|last2 = Loveland|first2 = Karen|publisher=Academic Press|location=San Diego|date=1991|isbn=0-12-043792-9}}</ref> Aquaria come in a variety of shapes such as [[cuboid]], [[hexagonal prism|hexagonal]], angled to fit in a corner (L-shaped), bow-front (the front side curves outwards).<ref name=Sanford2>{{cite book | title = Aquarium Owners Guide | last = Sanford | first = Gina | publisher = [[DK Publishing]] | location = New York | year = 1999 | pages = 162169 | isbn = 0-7894-4614-6}}</ref> Fish bowls are generally either plastic or glass, either spherical or some other round configuration.\n\n[[acrylic glass|Acrylic]] aquaria are also available and are the primary competitor with glass. Acrylic aquariums are stronger than glass, and much lighter<ref>{{cite web|url =http://www.reef-one.com/technology/benefits-of-acrylic.html|title = Benefits of Acrylic for Home Aquariums|publisher = Reef One | publisher=reef-one.com|last=Crosswell|first=Tom|accessdate=2009-05-10}}</ref>. Acrylic-soluble cements are used to directly fuse acrylic together (as opposed to simply sealing the seam).<ref name=Adey/> Acrylic allows for the formation of unusual shapes, such as hexagonal.<ref name=Sanford/> Compared to glass, acrylics are easy to scratch; but it is possible to polish out scratches in acrylic, unlike glass.<ref name=Adey/>\n\n[[Laminated glass]] might be used, which combines the advantages of both glass and acrylic.<ref name=Adey/>\n\nLarge aquaria might use stronger materials such as [[fiberglass]]-reinforced [[plastic]]s. However, this material is not transparent.<ref name=Adey/> Reinforced [[concrete]] is used for aquaria where weight and space are not factors. Concrete must be coated with a waterproof layer to prevent the water from breaking down the concrete as well as prevent contamination from the concrete.<ref name=Adey/>\n\n=== Styles ===\n\nAquariums have been fashioned into coffee tables, sinks, and even toilets. Another such example is the [[Macquarium]], an aquarium made from the shell of an [[Apple Macintosh]] [[computer]].<ref>{{cite web|url=http://www.cs.tut.fi/~ace/macquarium.html|title=The Original MacQuarium|first=Andy|last=Ihnatko|year=1992|accessdate=2007-04-04}}</ref> \n\nA kreisel tank is a [[circle|circular]] aquarium designed to hold delicate animals such as [[jellyfish]]. These aquariums provide slow, circular water flow with a lack of physical objects.<ref>{{cite web|url=http://www.advancedaquarist.com/issues/dec2004/lines.htm|title=Delicatessen Part I: Creating a system for rare and delicate animals|last=Blundell|first=Adam|publisher=Advanced Aquarists Online Magazine|month=December | year=2004|accessdate=2007-04-04}}</ref> Originally a German design (kreisel means spinning top), the tank has no sharp corners, and keeps the housed animals away from the [[plumbing]]. Water moving into the tank gives a gentle flow that keeps the inhabitants suspended, and water leaving the tank is covered by a delicate screen that prevents the inhabitants from getting stuck. There are several types of kreisel tanks. In a true kreisel, a circular tank has a circular, submerged lid. Pseudokreisels have a curved bottom surface and a flat top surface, similar to the shape of either a U or a [[semicircle]].<ref>{{cite web | author = Wrobel, Dave |url=http://jellieszone.com/captivejellies.htm|title=Captive Jellies: Keeping Jellies in an Aquarium | publisher = The Jellies Zone |accessdate=2007-04-04}}</ref> Stretch kreisels or Langmuir kreisels are a double gyre kreisel design, where the tank length is at least twice the height. Using two downwelling inlets on both sides of the tank lets gravity create two gyres in the tank. A single downwelling inlet may be used in the middle as well. The top of a stretch kreisel may be open or closed with a lid. There may also be screens about midway down the sides of the tank, or at the top on the sides.<ref>{{cite web | author = Raskoff et al 2005 |url=http://www.jstor.org/stable/1543497|title=Collection and culture techniques for gelatinous zooplankton }}</ref> It is possible to combine these designs; a circular shaped tank is used without a lid or cover, and the surface of the water acts as the continuation of circular flow.\n\n===Aquarium size and volume===\n[[Image:Male whale shark at Georgia Aquarium.jpg|thumb|right|The large [[Georgia Aquarium]] houses a [[whale shark]].|alt=Photo - silhouettes of people in foreground. One large fish with many smaller fish in background.]]\nAn aquarium can range from a small glass bowl containing less than a [[litre]] (34&nbsp;[[Fluid ounce|fl.oz.]]) of water to immense public aquaria that house entire ecosystems such as [[kelp forest]]s. Relatively large home aquaria resist rapid fluctuations of temperature and [[pH]], allowing for greater system stability.<ref name=Sanford2/>\n\nUnfiltered bowl-shaped aquaria are now widely regarded as unsuitable for most fish. Advanced alternatives are now available.<ref>{{cite web\n|url =http://www.reef-one.com/technology\n|title = Advanced filtered bowl aquariums - biOrb Aquariums\n|publisher = Reef One \n|publisher=reef-one.com\n|last=Crosswell|first=Tom\n|accessdate=2009-05-10}}\n</ref> Aquariums should contain three forms of filtration: biological, mechanical and chemical to keep water conditions at suitable levels.\n\nReef aquaria under 100&nbsp;litres (20&nbsp;gal) have a special place in the aquarium hobby; these aquaria, termed [[nano reef]]s (when used in reefkeeping), have  a small water volume.{{Citation needed|date=February 2008}}.\n\nPractical limitations, most notably the [[weight]] (one litre of fresh water has a mass of 1&nbsp;kilogram ({{nowrap|8.3 lb}} gal<sup>1</sup>), and salt water is even denser) and internal [[fluid pressure|water pressure]] (requiring thick glass siding) of a large aquarium, keep most home aquaria to a maximum of around 1 cubic metre in volume ({{nowrap|1,000 kg}} or {{nowrap|2,200 lb}}).<ref name=Sanford2/> Some aquarists, however, have constructed aquaria of many thousands of litres.<ref>{{cite web\n|url =http://www.cichlid-forum.com/articles/diy_1700g_tank_1.php\n|title = Building a 1700 gallon Shark Tank\n|publisher = cichlid-forum.com \n| publisher=Cichlid-Forum.com\n|last=Salvatori|first=Joe\n|accessdate=2007-04-03\n}}</ref><ref>{{cite web\n|url=http://www.monsterfishkeepers.com/forums/showthread.php?t=8952\n|title=Building My 50,000 Gallon Monster Mega Tank\n|publisher=MonsterFishKeepers.com\n|date=2005-10-30\n|accessdate=2007-04-04\n}}</ref>\n \n[[Public aquarium]]s designed for exhibition of large species or environments can be dramatically larger than any home aquarium. The [[Georgia Aquarium]], for example, features an individual aquarium of {{convert|6300000|USgal|m3}}.\n\n==Components==\n[[Image:Aquarium.png|thumb|[[Filter (aquarium)|Filtration|]] system in a typical aquarium: (1) intake, (2) mechanical filtration, (3) chemical filtration, (4) biological filtration medium, (5) outflow to tank|alt=Drawing of transparent 3-dimensional rectangle with two boxes and one cylinder above it and one longer, thin cylinder within it. Arrows point from the rectangle long cylinder to the top box, from the top box to the lower box, from the lower box to the other cylinder, from that cylinder back to itself, and from the cylinder to the rectangle.]]\n\nThe typical hobbyist aquarium includes a filtration system, an artificial lighting system, and a heater or chiller depending on the aquariums inhabitants. Many aquaria incorporate a hood, to decrease evaporation and prevent fish from leaving the aquarium (and anything else from entering the aquarium). They also often hold lights.<ref name=Sanford2/> \n\nCombined biological and mechanical aquarium [[Filter (aquarium)|filtration systems]] are common. These either convert ammonia to nitrate (removing nitrogen at the expense of aquatic plants), or to sometimes remove [[phosphate]]. Filter media can house [[microbes]] that mediate [[nitration]]. Filtration systems are the most complex component of home aquaria.<ref name=dakin>{{cite book\n|title=The Macmillan book of the Marine Aquarium\n|publisher=[[Macmillan Publishers|Macmillan Publishing Company]]\n|location=New York\n|last=Dakin|first=Nick\n|year=1992\n|isbn = 0-02-897108-6\n}}</ref>\n\n[[Heater (aquarium)|Aquarium heater]]s combine a heating element with a [[thermostat]], allowing the aquarist to regulate water temperature at a level above that of the surrounding air, whereas coolers and chillers (refrigeration devices) are for use anywhere, such as cold water aquaria, that the ambient room temperature is above the desired tank temperature.<ref name=Sanford2/> [[Thermometer]]s used include glass alcohol thermometers, adhesive external plastic strip thermometers, and battery-powered LCD thermometers.<ref name=Sanford2/> In addition, some aquarists use air pumps attached to [[airstone]]s or water pumps to increase water circulation and supply adequate gas exchange at the water surface. Wave-making devices have also been constructed to provide wave action.<ref name=Adey/> \n\nAn aquariums physical characteristics form another aspect of aquarium design. Size, lighting conditions, density of floating and rooted plants, placement of [[bogwood]], creation of caves or overhangs, type of [[substrate (aquarium)|substrate]], and other factors (including an aquariums positioning within a room) can all affect the behavior and survival of tank inhabitants. \n\nAn aquarium can be placed on an aquarium stand. Because of the weight of the aquarium, a stand must be strong as well as level. A tank that is not level may distort, leak, or crack.<ref name=Sanford2/> These are often built with cabinets to allow storage, available in many styles to match room [[decor]]. Simple metal tank stands are also available.<ref name=Sanford2/> Most aquaria should be placed on [[polystyrene]] to cushion any irregularities on the underlying surface or the bottom of the tank itself.<ref name=Sanford2/>  However, some tanks have an underframe making this unnecessary: the manual should state if this is the case.\n\n==Aquarium maintenance==\n[[Image:KelpAquarium.jpg|thumb|right|A 335,000&nbsp;U.S. gallon (1.3 million liter) aquarium at the [[Monterey Bay Aquarium]] in California, displaying a [[kelp forest]] ecosystem|alt=Photo of 50 foot-tall yellow plants in water behind glass wall divided into sections.]]\n\nLarge volumes of water enable more stability in a tank by diluting effects from death or contamination events that push an aquarium away from equilibrium. The bigger the tank, the easier such a [[systemic shock]] is to absorb, because the effects of that event are diluted. For example, the death of the only fish in a three&nbsp;U.S. gallon tank (11&nbsp;L) causes dramatic changes in the system, while the death of that same fish in a 100&nbsp;U.S. gallon (400&nbsp;L) tank with many other fish in it represents only a minor change. For this reason, hobbyists often favor larger tanks, as they require less attention.\n\nSeveral [[nutrient cycle]]s are important in the aquarium. Dissolved oxygen enters the system at the surface water-air interface or via an air pump. Carbon dioxide escapes the system into the air. The phosphate cycle is an important, although often overlooked, nutrient cycle. Sulfur, iron, and micronutrients also cycle through the system, entering as food and exiting as waste. Appropriate handling of the [[nitrogen cycle]], along with supplying an adequately balanced food supply and considered biological loading, is enough to keep these other nutrient cycles in approximate equilibrium.\n\n===Water conditions===\nThe [[Solution|solute]] content of water is perhaps the most important aspect of water conditions, as [[total dissolved solids]] and other constituents dramatically impact basic water chemistry, and therefore how organisms interact with their environment. Salt content, or [[salinity]], is the most basic measure of water conditions. An aquarium may have [[fresh water]] (salinity below 500&nbsp;parts per million), simulating a lake or river environment; [[brackish water]] (a salt level of 500 to 30,000&nbsp;PPM), simulating environments lying between fresh and salt, such as [[estuary|estuaries]]; and salt water or [[sea water]] (a salt level of 30,000 to 40,000&nbsp;PPM), simulating an ocean environment. Rarely, higher salt concentrations are maintained in specialized tanks for raising brine organisms.\n\nSaltwater is typically alkaline, while the [[pH]] ([[alkali]]nity or [[acid]]icity) of fresh water varies more. Hardness measures overall dissolved mineral content; [[hard water|hard or soft water]] may be preferred. Hard water is usually alkaline, while soft water is usually neutral to acidic.<ref name=Axelrod/> [[Chemical oxygen demand|Dissolved organic content]] and dissolved gases content are also important factors.\n \n[[Image:Aquarium-Tank.jpg|right|thumb|A typical home 10 gallon tropical [[freshwater]] aquarium|alt=Photo of water-filled glass tank containing with two green plants and pebbles on the bottom.]]\n\nHome aquarists typically use tap water supplied through their local [[water supply network]] to fill their tanks. Straight tap water cannot be used in countries that pipe chlorinated water. In the past, it was possible to condition the water by simply letting the water stand for a day or two, which allows the [[chlorine]] time to dissipate.<ref name=Axelrod/> However, [[chloramine]] is now used more often and does not leave the water as readily. Additives formulated to remove chlorine or chloramine are often all that is needed to make the water ready for aquarium use. Brackish or saltwater aquaria require the addition of a commercially available mixture of salts and other minerals.\n\nMore sophisticated aquarists modify waters alkalinity, hardness, or dissolved content of organics and gases, before adding it to their aquaria. This can be accomplished by additives, such as sodium bicarbonate, to raise pH.<ref name=Axelrod/> Some aquarists [[filter (water)|filter]] or purify their water prior to using it. The two processes are [[deionized water|deionization]] or [[reverse osmosis]]. In contrast, public aquaria with large water needs often locate themselves near a natural water source (such as a river, lake, or ocean) to reduce the level of treatment.\n\nWater [[temperature]] determines the two most basic aquarium classifications: [[tropics|tropical]] vs. [[Coldwater fish|cold water]]. Most fish and plant species tolerate only a limited temperature range: Tropical aquaria, with an average temperature of about {{convert|25|C|F}}, are much more common. Cold water aquaria are for fish that are better suited to a cooler environment. More important than the range is consistency; most organisms are not accustomed to sudden changes in temperatures, which can cause shock and lead to disease.<ref name=Axelrod/> Water temperature can be regulated with a [[thermostat]] and heater (or cooler).\n\nWater movement can also be important in simulating a natural ecosystem. Aquarists may prefer anything from still water up to swift [[current (fluid)|currents]], depending on the aquariums inhabitants. Water movement can be controlled via aeration from air pumps, powerheads, and careful design of internal water flow (such as location of filtration system points of inflow and outflow).\n\n===Nitrogen cycle===\n[[Image:Aquarium Nitrogen Cycle.svg|thumb|The [[nitrogen cycle]] in an aquarium]]\n{{main|Nitrogen cycle|alt=Drawing showing cross-section of the ocean. The bottom is labeled Decomposing plant & animal matter. An arrow points from seaweed to the bottom. Another arrow points to a rectangle labeled Ammounium ({{chem|NH|+|4}}). A two-headed arrow is labeled Nitrosomonas and points back to the seaweed and also to another rectangle labeled Nitrites ({{chem|NO|-|2}}). Another arrow labeled Nitrospira points to another rectangle labeled Nitrates ({{chem|NO|-|3}}). Another arrow points back to the seaweed. Another arrow points to the air above the ocean surface and is labeled Water change. Another arrow, labeled Food points from the air to a fish below the surface. A final arrow points to the rectangle labeled Ammonium ({{chem|NH|+|4}}).}}\n\nOf primary concern to the aquarist is management of the [[waste]] produced by an aquariums inhabitants. Fish, invertebrates, [[fungus|fungi]], and some bacteria excrete [[nitrogen]] waste in the form of [[ammonia]] (which converts to [[ammonium]], in acidic water) and must then pass through the [[nitrogen cycle]]. Ammonia is also produced through the [[decomposition]] of plant and animal matter, including [[feces|fecal]] matter and other [[detritus]]. Nitrogen waste products become [[toxic]] to fish and other aquarium inhabitants at high concentrations.<ref name=Axelrod>{{cite book | title = Exotic Tropical Fishes | last = Axelrod | first = Herbert, R. | publisher = T.F.H. Publications. | year = 1996 | isbn = 0-87666-543-1}}</ref>\n\n====The process====\nA well-balanced tank contains organisms that are able to [[metabolism|metabolize]] the waste products of other aquarium residents. This process is known in the aquarium hobby as the [[nitrogen cycle]]. [[bacterium|Bacteria]] known as [[nitrification|nitrifiers]] (genus [[Nitrosomonas]]) metabolize nitrogen waste. Nitrifying bacteria capture ammonia from the water and metabolize it to produce [[nitrite]]. Nitrite is toxic to fish in high concentrations. Another type of bacteria, genus Nitrospira, converts nitrite into [[nitrate]], a less toxic substance. ([[Nitrobacter]] bacteria were previously believed to fill this role. While biologically they could theoretically fill the same niche as Nitrospira, it has recently been found that Nitrobacter are not present in detectable levels in established aquaria, while Nitrospira are plentiful.) Commercial products sold as kits to jump start the nitrogen cycle, often still contain Nitrobacter. \n\nIn addition to bacteria, aquatic plants also eliminate nitrogen waste by metabolizing ammonia and nitrate. When plants metabolize nitrogen compounds, they remove nitrogen from the water by using it to build [[biomass]] that decays more slowly than ammonia-driven [[plankton]] already dissolved in the water.\n\n====Maintaining the nitrogen cycle====\nWhat hobbyists call the nitrogen cycle is only a portion of the complete cycle: nitrogen must be added to the system (usually through food provided to the tank inhabitants), and nitrates accumulate in the water at the end of the process, or become bound in the biomass of plants. The aquarium keeper must remove water once nitrate concentrations grow, or remove plants which have grown from the nitrates.\n\nHobbyist aquaria often do not have sufficient bacteria populations to adequately denitrify waste. This problem is most often addressed through two [[filtration]] solutions: [[Activated carbon]] filters absorb nitrogen compounds and other [[toxins]], while biological filters provide a medium designed to enhance [[colony (biology)|bacterial colonization]]. Activated carbon and other substances, such as ammonia absorbing resins, stop working when their pores fill, so these components have to be replaced regularly. \n\nNew aquaria often have problems associated with the nitrogen cycle due to insufficient beneficial bacteria, known as <ref>{{cite web\n|url=http://www.bestfish.com/breakin.html \n|title=New Tank Syndrome\n}}</ref>. Therefore fresh water has to be matured before stocking them with fish. There are three basic approaches to this: the fishless cycle, the silent cycle and slow growth. \n\nIn a [[fishless cycling|fishless cycle]], small amounts of ammonia are added to an unpopulated tank to feed the bacteria. During this process, [[ammonia]], [[nitrite]], and [[nitrate]] levels are tested to monitor progress. The silent cycle is basically nothing more than densely stocking the aquarium with fast-growing aquatic [[plant]]s and relying on them to consume the [[nitrogen]], allowing the necessary bacterial populations time to develop. According to anecdotal reports, the plants can consume nitrogenous waste so efficiently that ammonia and nitrite level spikes seen in more traditional cycling methods are greatly reduced or disappear. Slow growth entails slowly increasing the population of fish over a period of 6 to 8 weeks, giving bacteria colonies time to grow and stabilize with the increase in fish waste.\n\nThe largest bacterial populations are found in the filter; efficient filtration is vital. Sometimes, a vigorous cleaning of the filter is enough to seriously disturb the biological balance of an aquarium. Therefore, it is recommended to rinse mechanical filters in an outside bucket of aquarium water to dislodge organic materials that contribute to nitrate problems, while preserving bacteria populations. Another safe practice consists of cleaning only half of the filter media during each service.\n\n===Biological loading===\n[[Image:Small aquarium.jpg|thumb|Small aquarium (19 liter) with [[Paracheirodon innesi]], [[Trigonostigma heteromorpha]], and [[Hemigrammus erythrozonus]]|alt=Photo displaying plants, small fish, and what appear to be tipped-over orange vases]]\nBiological load is a measure of the burden placed on the aquarium ecosystem by its inhabitants. High biological loading presents a more complicated tank ecology, which in turn means that equilibrium is easier to upset. Several fundamental constraints on biological loading depend on aquarium size. The waters [[surface area]] limits [[Oxygen saturation|oxygen]] intake. The bacteria population depends on the physical space they have available to colonize. Physically, only a limited size and number of plants and animals can fit into an aquarium while still providing room for movement. Biologically, biological loading refers to the rate of biological decay in proportion to tank volume.\n\n====Calculating capacity====\n[[Limiting factor]]s include the oxygen availability and filtration processing. Aquarists have   [[rule of thumb|rules of thumb]] to  [[estimate]] the number of fish that can be kept in an aquarium; the examples below are for small freshwater fish, larger freshwater fishes and most marine fishes need much more generous allowances.\n*3&nbsp;[[centimetre|cm]] of adult fish length per 4&nbsp;[[litre]]s of water (i.e., a 6&nbsp;cm-long fish would need about 8&nbsp;litres of water).<ref name=Ulrich Baensch>{{cite book\n|first=Ulrich |last=Baensch\n|title=Tropical Aquarium Fish\n|publisher=Tetra\n|date=1983\n}}</ref>\n*1&nbsp;[[centimetre|cm]] of adult fish length per 30&nbsp;[[square centimetre]]s of surface area.<ref name=Scott>{{cite book\n|first=Peter |last=Scott\n|title=The Complete Aquarium\n|publisher=Dorling Kindersley\n|date=1996\n|ISBN=0-7513-0427-1\n}}</ref>\n*1&nbsp;[[inch]] of adult fish length per [[gallon]] of water.<ref name=Ulrich Baensch/>\n*1&nbsp;[[inch]] of adult fish length per 12&nbsp;[[square inch]]es of surface area.<ref name=Scott/>\n\nExperienced aquarists warn against applying these rules too strictly because they do not consider other important issues such as growth rate, activity level, social behaviour, surface area of plant life, and so on.<ref>{{cite book\n|authors=Chris Andrews, Adrian Exell, & Neville Carrington\n|title=The Interpet Manual of Fish Health\n|publisher=Salamander Books\n|date=1988\n|ISBN=0-86101-368-9\n}}</ref> Establishing maximum capacity is often a matter of slowly adding fish and monitoring water quality over time, following a [[trial and error]] approach.\n\n====Other factors affecting capacity====\nOne variable is differences between fish. Smaller fish consume more oxygen per gram of body weight than larger fish. [[Labyrinth fish]] can breathe atmospheric oxygen and do not need as much surface area (however, some of these fish are territorial, and do not appreciate crowding). [[Barb]]s also require more surface area than [[tetra]]s of comparable size.<ref name=Axelrod/>\n\nOxygen exchange at the surface is an important constraint, and thus the surface area of the aquarium matters. Some aquarists claim that a deeper aquarium holds no more fish than a shallower aquarium with the same surface area. The capacity can be improved by surface movement and water circulation such as through aeration, which not only improves oxygen exchange, but also waste decomposition rates.<ref name=Axelrod/>\n\nWaste density is another variable. Decomposition in solution consumes oxygen. Oxygen dissolves less readily in warmer water; this is a double-edged sword since warmer temperatures make fish more active, so they consume more oxygen.<ref name=Axelrod/>\n\nIn addition to bioload/chemical considerations, aquarists also consider the mutual compatibility of the fish. For instance, predatory fish are usually not kept with small, passive species, and territorial fish are often unsuitable tankmates for shoaling species. Furthermore, fish tend to fare better if given tanks conducive to their size. That is, large fish need large tanks and small fish can do well in smaller tanks. Lastly, the tank can become overcrowded without being overstocked. In other words, the aquarium can be suitable with regard to filtration capacity, oxygen load, and water, yet still be so crowded that the inhabitants are uncomfortable.<ref>http://sites.google.com/site/moashowmanyfish/</ref>\n\n==Aquarium classifications==\n[[Image:58g aquascape.jpg|thumb|A planted freshwater aquarium|alt=Photo showing a tank filled with water and multiple aquatic plants.]]\nFrom the outdoor ponds and glass jars of antiquity, modern aquaria have evolved into a wide range of specialized systems. Individual aquaria can vary in size from a small bowl large enough for only a single small fish, to the huge public aquaria that can simulate entire marine [[ecosystem]]s. \n\nOne way to classify aquaria is by salinity. [[Freshwater aquarium|Freshwater aquaria]] are the most popular due to their lower cost and ease of maintenance.<ref name=Sanford3>{{cite book \n| title = Aquarium Owners Guide \n| last = Sanford | first = Gina \n| publisher = [[DK Publishing]]\n| location = New York \n| year = 1999 \n| pages = 180199 \n| isbn = 0-7894-4614-6\n}}</ref> [[Marine aquarium|Marine aquaria]] require more complex equipment to set up and maintain. Along with fish species, marine aquaria frequently feature a diverse range of [[invertebrates]].<ref name=dakin/><ref name=Sanford3/> [[Brackish water aquarium|Brackish water aquaria]] combine elements of both marine and freshwater fishkeeping.<ref name=Sanford3/> Fish kept in brackish water aquaria generally come from habitats with varying salinity, such as [[mangroves]] and [[estuaries]]. Subtypes exist within these types, such as the [[reef aquarium]], a type of marine aquarium that houses [[coral]].<ref name=Sanford3/>\n\nAnother classification is by [[temperature]] range. Many aquarists choose a [[tropical fish|tropical aquarium]] because tropical fish tend to be more colorful.<ref name=Sanford3/> However, the [[coldwater fish|coldwater aquarium]] is also popular, which may include fish such as [[goldfish]].<ref name=Sanford3/>\n[[Image:Aquarium fg01.jpg|thumb|A [[Seawater|saltwater]] aquarium|alt=Photo of water, coral, and fish behind a glass wall.]]\n\nAquaria may be grouped by their species selection. The [[community tank]] is the most common today, where several non-aggressive species live peacefully. In these aquaria, the fish, [[invertebrate]]s, and [[aquatic plant|plants]] probably do not originate from the same geographic region, but tolerate similar water conditions. Aggressive tanks, in contrast, house a limited number of species that can be aggressive toward other fish, or are able to withstand aggression well. Specimen tanks usually only house one fish species, along with plants, perhaps found in the fishes natural environment and decorations simulating a natural ecosystem. This type is useful for fish that cannot coexist with other fish, such as the [[electric eel]], as an extreme example. Some tanks of this sort are used simply to house adults for breeding. \n\nEcotype, ecotope, or [[biotope]] aquaria is another type based on species selection. In it, an aquarist attempts to simulate a specific natural ecosystem, assembling fish, invertebrate species, plants, decorations and water conditions all found in that ecosystem. These biotope aquaria are the most sophisticated hobby aquaria; public aquaria use this approach whenever possible. This approach best simulates the experience of observing in the wild. It typically serves as the healthiest possible artificial environment for the tanks occupants.\n\n==Public aquaria==\n[[Image:Georgia Aquarium - Ocean Voyager Tunnel Jan 2006.jpg|thumb|right|Tunnel at the worlds largest aquarium, [[Georgia Aquarium]], USA|alt=Photo looking upward through {{convert|15|ft|m}}-diameter glass tube into a fish-filled aquarium]]\n\n{{Main|Public aquarium}}\nMost public aquarium facilities feature a number of smaller aquaria, as well those too large for home aquarists. The largest tanks hold millions of gallons of water and can house large species, including [[shark]]s or [[Beluga (whale)|beluga whales]]. [[Dolphinarium|Dolphinaria]] are specifically for dolphins. Aquatic and semiaquatic animals, including [[otter]]s and [[penguin]]s, may also be kept by public aquaria. Public aquaria may also be included in larger establishments such as a [[marine mammal park]] or a [[marine park]].\n\n==Virtual aquariums==\nA virtual aquarium is a [[computer program]] which uses [[3D graphics]] to reproduce an aquarium on a [[personal computer]].  The swimming fish are [[rendering engine|rendered]] in [[Real-time computer graphics|real time]], while the [[background]] of the tank is usually static.  Objects on the floor of the tank may be mapped in simple [[plane (geometry)|plane]]s so that the fish may appear to swim both in front and behind them, but a relatively simple 3D map of the general shape of such objects may be used to allow the light and ripples on the surface of the water to cast realistic [[shadow]]s.  Bubbles and water noises are common for virtual aquariums, which are often used as [[screensaver]]s.\n\nThe number of each type of fish can usually be selected, often including other animals like [[starfish]], [[jellyfish]], [[seahorse]]s, and even [[sea turtles]].  Most companies that produce virtual aquarium software also offer other types of fish for sale via Internet [[download]].  Other objects found in an aquarium can also be added and rearranged on some software, like [[treasure chest]]s and giant [[clam]]s that open and close with air bubbles, or a bobbing [[deep-sea diving|diver]].  There are also usually features that allow the user to tap on the glass or put food in the top, both of which the fish will react to.  Some also have the ability to allow the user to edit fish and other objects to create new varieties.\n\n'
p262
tp263
a(I-1
S'{{Original research|date=May 2009}}\n{{Unreferenced section|date=January 2007}}\n{{Race}}\nRacial realism is a term used to describe two directly opposed positions, both motivated by the perceived durability and social importance of racial distinctions.\n\nThe term racial realism has been used to describe the claim that racial distinctions are [[socially constructed]] but enduringly important because dominant social forces continually reinforce them.\n\nThe term has also been used to describe the claim that races are real rather than social constructs, and that racial distinctions are enduringly important because racial groups differ by nature (genetically) with regard to such important behavioral tendencies as [[intelligence (trait)|intelligence]] and [[impulsiveness]]. This claim holds that racial distinctions are real and measurable, and further claims those measurable differences are based in [[science]] instead of [[idealism]]. \n\nExamples of scientifically demonstrable racial distinctions are said to include different [[Race and intelligence#Reaction time|decision and reaction times]], [[race and intelligence|intelligence]], crime rates, and [[medical]] characteristics, such as differing tendencies toward [[disease]]s such as [[osteoporosis]] or [[sickle cell anemia]].<ref>{{cite web\n  | last = Andrews\n  | first = Louis\n  | title = Does Race Matter - Recent Developments\n  | url = http://www.euvolution.com/articles/racematters.html\n  | accessdate = 10 September 2009}}\n</ref>\n\nThe second definition is the older and far more common definition. Critics often claim that racial realism is a [[euphemism]] for [[scientific racism]].\n\n== Self-described racial realists ==\nThe following is a list of notable individuals and organizations who have self-identified as racial realist.\n\n===Individuals===\n*[[Chris Brand]] - psychological and psychometric researcher<ref>[http://lrainc.com/swtaboo/late/cb_camb.html Stalking the Wild Taboo - Chris Brand -The Cambridge Debate, Jan 28, 1997<!-- Bot generated title -->]</ref>\n*[[David Duke]] - white nationalist, politician<ref>[http://www.davidduke.com/index.php?p=266 The Official Website of Representative David Duke, PhD  Are you a racist?<!-- Bot generated title -->]</ref>\n*[[Nick Griffin]] - [[British National Party]]\n*[[Ian Jobling]] - Former writer and webmaster for American Renaissance, and owner of the White America website.<ref>[http://inverted-world.com/index.php/articles/articles/the_improvident_races/ The Improvident Races]</ref><ref>[http://inverted-world.com/index.php/articles/articles/the_reality_of_racial_differences/ The Reality of Racial Differences]</ref><ref>[http://whiteamerica.us/ whiteamerica.us]</ref>\n*[[Michael Levin]] - Philosophy professor at [[City University of New York]]<ref>{{cite book\n  | last = Levin\n  | first = Michael\n  | authorlink = http://web.gc.cuny.edu/Philosophy/people/levin.html\n  | title = Why Race Matters: Race Differences and What They Mean\n  | publisher = Praeger\n  | date = 1997\n  | location = Santa Barbara, CA\n  | pages = 415\n  | isbn = 0275957896}}\n</ref>\n*[[J. Philippe Rushton]] - Psychology professor at the [[University of Western Ontario]]<ref>{{cite journal\n  | last = Rushton\n  | first = Philippe\n  | authorlink = http://www.charlesdarwinresearch.org/JPRvitae.htm\n  | title = Race is More Than Just Skin Deep: A Psychologists View\n  | journal = Mankind Quarterly\n  | volume = 39\n  | issue = 2\n  | pages = 231-250\n  | publisher = \n  | location = Washington, DC\n  | date = 1998\n  | url = http://www.geocities.com/race_articles/rushton_view_race.html\n  | issn = 0025-2344\n  | accessdate = 10 September 2009}}\n</ref>\n*[[Charles_Murray_(author)|Charles Murray]] - [[columnist]] of the [[American Enterprise Institute]] ,Co-Author of [[The Bell Curve]]\n*[[Jared Taylor]] - American Renaissance\n*[[Steve Sailer]] - American writer for [[VDARE]]<ref>[http://www.isteve.com/RealityofRace.htm The Reality of Race]</ref>\n\n===Groups===\n*[[American Renaissance (magazine)|American Renaissance]] - Paleoconservative and racial thinking magazine<ref>[http://www.amren.com/siteinfo/index.html About American Renaissance<!-- Bot generated title -->]</ref>\n*[[British National Party]]<ref>http://www.bnp.org.uk/articles/race_reality.htm</ref><ref>http://www.bnp.org.uk/candidates2005/manifesto/manf4.htm</ref>\n\n'
p264
tp265
a(I1
S'{{POV|date=July 2009}}\nHenri Max Corwin (1903  January 1962) was a [[Netherlands|Dutch]] businessman, [[Philately|philatelist]] and [[Humanitarianism|humanitarian]].  He became famous both for his efforts to shield Jewish [[Holocaust|victims of Nazi persecution]] during [[World War II]], and later for his efforts to document instruments of propaganda utilized during national conflict.[[Image:Henri Max Corwin.jpg||right|thumb|Henri Max Corwin (Cohen) in his twenties.]]\n\n==Biography==\nHenri Max Cohen was born in 1903, the youngest of four children, in the eastern Netherlands village of [[Oldenzaal]], where his family had lived since at least 1770.  After completing secondary schooling Cohen entered the [[Lawyer|study of Law]] at [[Leiden University]], but soon had to return to Oldenzaal to run the family business when his father suffered health problems.\n\nAs a youth Cohen had two abiding pastimes, [[stamp collecting]] and the theater.  He wrote plays, directed plays and acted in plays.\n\nWhen the persecution of Jewish people in Germany became apparent in the years before the outbreak of WW2, he began escorting people from that nation to safe havens in the Netherlands.  He was often assisted in these trips by his fiance Geraldine.\n\nSoon after the start of WW2, his nation was invaded and occupied by German troops.  At that time he became active in providing hiding places for people who would be arrested and deported under the German antisemitism policies.  For this effort, he was arrested on 16 October 1943 by 2 Dutch members of the [[Sicherheitsdienst]], on the charge of providing safe houses.  He was sentenced to imprisonment at [[Assen]], but while being transported there, he managed to jump from the train and escaped.  He remained in hiding until the war ended, after which he returned to Oldenzaal and resumed managing his familys affairs.\n\nDuring the [[Cold War]] fears of the 1950s he noted a renewed [[antisemitism]] in Europe.  He saw many of the Dutch Jews moving to safe areas (usually [[United States|America]]), and considered moving his family away also.  In the end he decided to remain in the Netherlands, but changed his name (and thus the familys name) from Cohen to Corwin, hoping that this would buy them a margin of safety if anti-jewish persecution did resume.\n\nHenri died in January 1962, at the age of 58.  A street in Oldenzaal was named in his honor.<ref> http://www.corwincollection.com Official website of Henri Max Corwin </ref>\n\n== A Philatelist Wrote the History of the Nazis in Stamps and Documents ==\nCorwin assembled a unique collection of documents regarding The [[Second World War]] and The [[Holocaust]]. Most of the collected items can be categorized under the title of [[Propaganda]]. This war collection contains 24 albums on various aspects of the period from approximately 1900 until 1945, including the rise of nationalism, the [[1936 Summer Olympics|1936 Olympic Games]], Nazi occupation of various countries, [[anti-Semitic]] measures and the massacre of the [[Jews]]. The collection was exhibited in 1959/1964 in the Netherlands and in [[Israel]] at the [[Yad Vashem]] and at the [[Kibbutz]] Lohamei Hagethaot.\n\n==Humanitarian efforts==\nIn the 1930s when the situation for the Jews in [[Germany]] became unbearable, he acted as a [[courier]] for the Jewish Refugee Committee in [[Amsterdam]], taking refugees or their belongings across the Dutch border. For this he was granted [[membership]]<ref> http://www.corwincollection.com/ferryman.html</ref> in the U.N.A.P.E.F. (Union Nationale des Passeurs & Filieristes Benevoles). A letter<ref>http://www.corwincollection.com/letter.html</ref> from [[Albert Einstein]] confirms these activities (a copy is shown on the [http://www.corwincollection.com site]). When in 1940 the [[History of the Netherlands (1939-1945)|Germans occupied the Netherlands]] and began arresting Jewish citizens, Cohen organized (in cooperation with the [[Resistance during World War II|Resistance]]) hiding places for family and friends. This illegal activity led to his arrest by the SD (the Sicherheits Dienst) in 1943. On the way to prison he managed to escape and went into hiding himself until the end of the war.\n\nIn the early fifties, when Russian politics threatened European peace, many Dutch Jews fled the country. Mr. Cohen thought best to protect his family by changing his name in Corwin, a name several of his family living in the States already had adopted.\n\n==Genealogy efforts==\nIn his later years Corwin became an enthusiastic historian and genealogist. He tracked down family trees of Jewish families and gave lectures on the ups and downs of the Jewish population in the [[Twente]] region. The results of this research can be found in the Central Institute for Genealogy in [[The Hague]], in the Rosentaliana Library and the [[Jewish Historical Museum]] in Amsterdam, in periodicals, newspapers and the Yearbook Twente 1962. In 1960 he received the Order of<ref>http://www.corwincollection.com/press-9.html</ref> [[Oranje Nassau]].\n\nCorwin died of [[heart failure]] at the age of 58 in January 1962. In Oldenzaal a street is named after him.\n\nDetailed information with regard to the collection of H.M. Corwin and his interesting life, including his war diary, photo albums, press articles and more can be found on the personal site, created by his daughters in 2008. A book about his life will appear in 2009.\n\n== The Color of Propaganda ==\n\n[[Image:PropagandaStudy 1.jpg||left|thumb|90px|propaganda_1]]\n[[Image:PropagandaStudy 4.jpg||right|thumb|90px|propaganda_4]]\n[[Image:PropagandaStady 2.jpg||left|thumb|90px|propaganda_2]]\n[[Image:PropagandaStudy 5.jpg||right|thumb|90px|propaganda_5]]\n[[Image:PropagandaStady 3.jpg||left|thumb|90px|propaganda_3]]\n[[Image:PropagandaStudy 6.jpg||right|thumb|90px|propaganda_6]]\n\nThese red pages are in no way related to one specific country or ideology, although on first glance it is very easy to recognize in them the signs of national-socialist Germany or communist Russia. In reality, propaganda has many colours and shades: red, brown, orange, green, blue, and not to mention black and even white. Its main aim is to manipulate the minds of the masses. It uses rhetoric, memorable images (books, children...), concepts that are difficult to argue against (fidelity, honesty, kindness, brotherhood...), the notion of a common destiny and of the ultimate goal, and most importantly a charismatic leader who is capable of enticing, stupefying and getting the people to follow him. \n\nThe six pages of comparative analysis presented here are only a small, yet nevertheless the most demonstrative example of the documents that constitute this unique collection. They are the concise guide to the methods of propaganda  the recipe for the poisonous potion commonly known as Propaganda. You will find here all the necessary ingredients: the need for order and stability, democracy and demonstration of the will of the people, power and greatness, history (the older the better, and it must always be legendary), most definitely a book (though of course, there is only one book- The Book!), and let us not forget the heroes, the martyrs and the spiteful enemies.\n\nUnfortunately, the majority of the documents and facts presented in this collection are not so easy to identify. In this lies their main strength as propaganda items and also their greatest danger, the danger of which the creator of this collection  Henri-Max Corwin  wanted to warn future generations. When studying the documents within this collection, it is crucial to always remember the terrible lessons of history, the price one must pay for gullibility and for the reluctance to analyse and think.\n\n'
p266
tp267
a(I-1
S'The National Longitudinal Surveys (NLS) are a set of surveys conducted by the [[United States|US]] [[United States Department of Labor|Department of Labor]]s [[Bureau of Labor Statistics]], designed to gather information at multiple points in time on significant life events of several population samples of US citizens, especially their [[labor market]] activities. The NLS data has been an important tool since the 1970s for [[economics|economists]], [[sociology|sociologists]], and other researchers.\n\n'
p268
tp269
a(I1
S'{{for|the Teen Titans supervillain|Control Freak (villain)}}\n\nIn [[psychology]]-related slang, control freak is a derogatory term for a person who attempts to dictate how everything around them is done. It can also refer to someone with a limited number of things that they want done a specific way; professor of clinical psychology [[Les Parrott]] wrote that Control Freaks are people who care more than you do about something and wont stop at being pushy to get their way.<ref>{{cite book | last = Parrott | first = Les | title = The Control Freak | publisher = Tyndale House Publishers | location = Carol Stream | year = 2001 | isbn = 0842337938 }}</ref>\n\nIn some cases, the control freak sees their constant intervention as beneficial or even necessary; this can be caused by feelings of superiority, believing that others are incapable of handling matters properly, or the fear that things will go wrong if they dont attend to every detail. In other cases, they may simply enjoy the feeling of power it gives them so much that they automatically try to gain control of everything around them. So dont be a control freak.\n\n== Also see ==\n\n* [[Micromanagement]]\n\n'
p270
tp271
a(I-1
S'{{BLP unsourced|date=July 2009|bot=yes}}\nShun Nakamura is a game designer for [[Sonic Team]], whose works include [[Samba de Amigo]], [[Billy Hatcher and the Giant Egg]], and [[Sonic the Hedgehog (2006 game)|Sonic the Hedgehog]].\n\nSince [[Yuji Naka]]s departure from [[Sonic Team]] and [[Sega]], it is unsure whether Shun Nakamura shall carry on designing the rest of the Sonic the Hedgehog series on his own, or every 3D Sonic title afterwards.\n\n==Production History==\n* [[Sonic R]] (1997)  Game Designer\n* [[Sonic Adventure]] (1999)  Field Designer\n* [[ChuChu Rocket!]] (2000)  Puzzle Editing\n* [[Samba de Amigo]] (2000)  Director, Main Planner\n* Samba de Amigo Ver.2000 (2000)  Director, Main Planner\n* [[Sonic Adventure 2: Battle]] (2002)  Special Thanks\n* [[Billy Hatcher and the Giant Egg]] (2003)  Director, Lead Game Designer\n* [[Sonic Heroes]] (2004)  Development Support\n* [[Sonic the Hedgehog (2006 game)|Sonic the Hedgehog]] (2006)  Director, Chief Game Designer, Game Story, Game Title\n* [[Sonic Rivals]] (2006)  Game Title\n* [[Sonic Rivals 2]] (2007)  Game Title\n* [[Sonic and the Secret Rings]] (2007)  Game Title\n* [[Mario & Sonic at the Olympic Games]] (2007)  Planning Supervisor\n* [[Sonic Riders: Zero Gravity]] (2008)  Game Title\n* [[Sonic Unleashed]] (2008)  Level Design Special Thanks (PS3 & Xbox 360 Version), Game Title\n* [[Sonic and the Black Knight]] (2009)  Game Title\n\n{{videogame-bio-stub}}\n\n{{DEFAULTSORT:Nakamura, Shun}}\n'
p272
tp273
a(I1
S'{{Infobox Magazine|\n title = ReadyMade |\n image_file = Readymade issue.gif | image_size = 200px | image_caption = |\n editor = Kitty Morgan |\n frequency = Bimonthly|\n circulation = |\n category = [[Do it yourself|Do it yourself (DIY)]]|\n company = [[Meredith Corporation]] |\n firstdate = |\n country = [[United States]] |\n language = [[English language|English]] |\n website = [http://www.readymademag.com/ ReadyMade] |\n issn = 1544-2950 |\n}}\n\nReadyMade (or Ready Made) is a bimonthly [[magazine]] which focuses on [[Do it yourself|do it yourself (DIY)]] projects involving [[interior design]], making [[furniture]], [[home improvement]], [[sewing]], [[metalworking]], [[woodworking]] and other disciplines.  It also has increasingly focused on [[sustainable design]], [[independent music]] and [[DIY culture]]. The magazine is marketed to people who enjoy creating unique items to have at home and wear, and features projects which can often be completed with everyday materials, such as household items.\n\nReadyMade was founded by chief editor [[Shoshana Berger]] and publisher [[Grace Hawthorne]] in [[Berkeley, California]].<ref name=sfgate2009-02-22>{{cite news |first=Joe |last=Garofoli |title=ReadyMade magazine faces makeover in Iowa |url=http://www.sfgate.com/cgi-bin/article.cgi?f=/c/a/2009/02/20/LVOV15VMIM.DTL |format=HTML |work=[[San Francisco Chronicle]] |publisher=Hearst Communications Inc. |location=San Francisco |date=2009-02-22 |accessdate=June 9, 2009 |language=English}}</ref>    In 2006, the [[Meredith Corporation]] purchased the magazine.<ref name=sfgate2009-02-22 />  In January 2009, Meredith announced it was relocating the magazines creative staff (along with that of [[Parents (magazine)|Parents]]) to [[Des Moines, Iowa]] due to company-wide budgetary concerns (though the ReadyMade title itself was reportedly successful).<ref name=sfgate2009-02-22 />  None of the editorial staff chose to relocate, and [[Better Homes and Gardens (magazine)|Better Homes and Gardens]] executive editor Kitty Morgan assumed editorial duties for ReadyMade on an interim basis.<ref name=sfgate2009-02-22 />\n\n==Subjects==\nUnlike more traditional home improvement magazines and [[how-to]] books, ReadyMades projects are aimed at a younger (21-39) audience. Projects in their issues include:<br>\n* making a lamp out of a cd spindle\n* altering a car stereo to accept an [[iPod]] input jack\n* instructions on how to run for local office in the United States\n* [[recycling]] broken speakers to become light fixtures, coffee tables, or bookcases\n\nand similar projects with an emphasis on creating an urban [[Indie design|indie]] aesthetic.\n\n==Demographic==\nReadyMade is aimed at the emerging [[DIY culture]] in North America that enjoys not only the fashion of [[handmade]] items and [[interior design]], but also the philosophy and politics inherent in [[recycling]], [[DIY]] attire, and [[ecology]]. The ads featured in the magazine target a readership that is largely [[Liberalism|liberal]], and interested in [[localism|locally produced]], [[handmade]], [[ecological]], and [[organic product|organic]] goods, but also features ads from companies such as [[PF Flyers]] shoes, [[Urban Outfitters]], and similar corporations looking to appeal to a young [[Hipster (contemporary subculture)|hipster]] audience. The music featured in the articles is generally [[independent rock]], featuring such artists own [[DIY]] projects, such as an article where [[The Flaming Lips]] show how to make a mock space station out of junkyard parts.\n\n'
p274
tp275
a(I1
S'[[Image:Deltec skimmer 902.jpg|thumb|250px|Protein skimmer]]\n\nA protein skimmer or foam fractionator is a device used mostly in [[Marine aquarium|saltwater aquaria]] to remove [[organic compound]]s from the water before they break down into [[nitrogen]]ous waste. Protein skimming is the only form of aquarium [[Filter (aquarium)|filtration]] that physically removes organic compounds before they begin to decompose, lightening the load on the biological filter and improving the waters [[redox]] potential.  Although the process of [[foam fractionation]] is commonly known for removal of waste from aquaria, it is, in fact, a rapidly developing [[chemical process]] used in the large-scale removal of contaminants from wastewater streams and the enrichment of solutions of biomolecules.\n\n==Function==\nProtein skimming removes certain organic compounds, including [[protein]]s and [[amino acid]]s, by using the [[chemical polarity|polarity]] of the protein itself. Due to their intrinsic charge, water-borne proteins are either repelled or attracted by the air/water interface and these molecules can be described as [[hydrophobic]] (such as fats or oils) or [[hydrophilic]] (such as salt, sugar, ammonia, most amino acids, and most inorganic compounds). However, some larger organic molecules can have both hydrophobic and hydrophilic portions. These molecules are called [[amphipathic]] or [[amphiphilic]]. Commercial protein skimmers work by generating a large air/water interface, specifically by injecting large numbers of bubbles into the water column. In general, the smaller the bubbles the more effective the protein skimming is because the surface area of small bubbles occupying the same volume is much greater than the same volume of larger bubbles<ref>P. R. Escobal: Aquatic Systems Engineering: Devices and How They Function, Dimension Engineering Press, 2000, ISBN 1888381108 </ref>. Large numbers of small bubbles present an enormous air/water interface for the organic molecules which are hydrophobic and those which are amphipathic to collect on the bubble surface (the air/water interface). The diffusion of organic molecules is hastened by water movement, which effectively brings more organic molecules to the air/water interface and allows the organic molecules to accumulate on the surface of the air bubbles. This process will continue until the interface is saturated, unless the bubble is removed from the water or it bursts, in which case the accumulated molecules are released back into the water column. However, it is important to note that further exposure of a saturated air bubble to organic molecules may continue to result in changes as compounds that bind more strongly may replace those molecules with a weaker binding that have already accumulated on the interface. Although some aquarists believe that increasing the contact time (or dwell time as it is sometimes called) is always good, it is incorrect to claim that it is always better to increase the contact time between bubbles and the aquarium water<ref>Holmes-Farley, Randy, What is Skimming?, Reefkeeping, August 2006, http://www.reefkeeping.com/issues/2006-08/rhf/index.php </ref>. As the bubbles increase near the top of the protein skimmer water column, they become denser and the water begins to drain and create the foam that will carry the organic molecules to the skimmate collection cup or to a separate skimmate waste collector and the organic molecules, and any inorganic molecules that may have become bound to the organic molecules, will be exported from the water system. \n\nIn addition to the proteins removed by skimming, there are a number of other organic and inorganic molecules that are typically removed. These include a variety of fats, fatty acids, carbohydrates, metals such as copper and trace elements such as iodine. Particulates and other detritus is also removed, along with phytoplankton and bacteria. This removal is highly desired by the aquarist and is often emphasized by the placement of the skimmer before other forms of filtration; lessening the burden of the filtration system as a whole. There is at least one published study that provides a detailed list of the export products found in protein skimmer skimmate<ref>Shimak, Ronald L, Ph. D., Down the Drain, Exports From Reef Aquaria, Reefkeeping, Dec. 2002, http://www.reefkeeping.com/issues/2002-12/rs/feature/index.php</ref>.\n\n==Design==\n\nAll skimmers have key features in common: water flows through a chamber and is brought into contact with a column of fine bubbles. The bubbles collect proteins and other substances and carry them to the top of the device where the foam, but not the water, collects in a cup. Here the foam condenses to a liquid, which can then be easily removed from the system. The material that collects in the cup can range from pale greenish-yellow, watery liquid to a thick black tar.\n\nConsider this summary of optimal protein skimmer design by Randy Holmes-Farley<ref>Holmes-Farley, Randy, What is Skimming?, Reefkeeping, August 2006, http://www.reefkeeping.com/issues/2006-08/rhf/index.php </ref>: \n<blockquote>\nFor a skimmer to function maximally, the following things must take place:<br />\n1. A large amount of air/water interface must be generated.<br />\n2. Organic molecules must be allowed to collect at the air/water interface.<br />\n3. The bubbles forming this air/water interface must come together to form a foam.<br />\n4. The water in the foam must partially drain without the bubbles popping prematurely.<br />\n5. The drained foam must be separated from the bulk water and discarded.<br />\n</blockquote>\n\n\nAlso under considerable recent attention has been the general shape of a skimmer as well.  In particular, much attention has been given to the introduction of cone shaped skimmer units.  Originally designed by Klaus Jensen in 2004, the concept was founded on the principle that a conical body allows the foam to accumulate more steadily through a gently sloping transition.  This reduces the overall turbulence, resulting in more efficient skimming.  While research into the specific benefits of the design are still being measured, early reviews of many conical skimmers have been positive overall.<ref>http://proteinskimmerinfo.com/vertex-royal-exclusiv-alpha-cone-250-protein-skimmer-review/</ref>\n\n\nOverall, protein skimmers can be classed in two ways depending on whether they operate by co-current flow or counter-current flow. In a co-current flow system, air is introduced at the bottom of the chamber and is in contact with the water as it rises upwards towards the collection chamber. In a counter-current system, air is forced into the system under pressure and moves against the flow of the water for a while before it rises up towards the collection cup. Because the air bubbles may be in contact with the water for a longer period in a counter-current flow system, protein skimmers of this type are considered by some to be more effective at removing organic wastes.<ref>[[#Reference-idEscobal2000|Escobal 2000]]</ref>\n\n===Co-current flow systems===\n====Air stone==== \nThe original method of protein skimming, running pressurized air through a diffuser to produce large quantities of micro bubbles, remains a viable, effective, and economic choice, although newer technologies may require lower maintenance.  The air stone is most often an oblong, partially hollowed block of wood, most often of the genus [[Tilia]]. The most popular wooden air-stones for skimmers are made from limewood ([[Tilia europaea]] or European limewood) although basswood ([[Tilia americana]] or American Linden), works as well, may be cheaper and is often more readily available. The wooden blocks are drilled, tapped, fitted with an air fitting, and connected by air tubing to one or more air pumps delivering at least 1 cfm.  The wooden air stone is placed at the bottom of a tall column of water. The tank water is pumped into the column, allowed to pass by the rising bubbles, and back into the tank. To get enough contact time with the bubble, these units can be many feet in height.  \n\nAir stone protein skimmers may be constructed as a DIY project from pvc pipes and fittings at low cost  [http://www.angelfire.com/ok/dog1/skimmer.html] [http://www.hawkfish.org/snailman/diy8inskimmer.htm] and with varying degrees of complexity [http://ozreef.org/diy_plans/protein_skimmers/air_stone_protein_skimmer.html].\n\nWhile this method has been around for many years, many regard it as inefficient for larger systems or systems with large bio-loads.\n\n====Venturi====\nThe premise behind these skimmers is that a venturi pump, or [[aspirator]], can be used to introduce the bubbles into the water stream.  The tank water is pumped through the venturi, in which fine bubbles are introduced, then enters the skimmer body.  This method was popular due to its compact size and high efficiency but venturi designs are now more likely to be included in other skimmer designs rather than as a simple venturi design.\n\n===Counter-current flow systems===\n====Aspirating: Adrian-Wheel/Needle-Wheel/Mesh-Wheel====\n\nThis basic concept is more correctly known as an aspirating skimmer, since some skimmer designs using an aspirator do not use a Adrian-Wheel or Needle-Wheel. Adrian-Wheel describes the look of an [[impeller]] which consists of a disk with pins mounted perpendicular (90) to the disc and parallel to the rotor. Needle-Wheel describes the look of an impeller which consists of a series of pins projecting out perpendicular to the rotor from a central axis.  Mesh-Wheel describes the look of an impeller which consists of a mesh material that is attached to a plate or central axis on the rotor. The purpose of these modified impellers is to chop or shred the air that is introduced via a venturi apparatus or external air pump into very fine bubbles. The Mesh-Wheel design is fairly new and, while providing excellent results in the short term because of its ability to draw in more air and create finer bubbles with its thin cutting surfaces, it is still being developed and will likely continue to evolve over a few more years. \n\nThis style of protein skimmer has become very popular and is believed to be the most popular type of skimmer used with residential reef aquariums today. It has been particularly successful in smaller aquariums due to its usually compact size, ease of set up and use, and quiet operation. Since the pump is pushing a mixture of air and water, the power required to turn the rotor can be decreased and may result in a lower power requirement for that pump vs. the same pump with a different impeller when it is only pumping water.\n\n====Downdraft====\n\nThe Downdraft skimmer is both a [[proprietary]] skimmer design and a style of protein skimmer that injects water under high pressure into tubes that have a foam or bubble generating mechanism and carry the air/water mixture down into the skimmer and into a separate chamber. The proprietary design is protected in the United States with patents and commercial skimmer products in the US are limited to that single company. Their design uses one or more tubes with plastic media such as bio balls inside to mix water under high pressure and air in the body of the skimmer resulting in foam that collects protein waste in a collection cup. This was one of the earlier high performance protein skimmer designs and large models were produced that saw success in large and public aquariums.\n\n====Beckett skimmer====\nThe Beckett skimmer has some similarities to the downdraft skimmer but introduced a foam nozzle to produce the flow of air bubbles. The name Beckett comes from the patented foam nozzle developed and sold by the Beckett Corporation (United States), although similar foam nozzle designs are sold by other companies outside the United States (e.g. Sicce (Italy)). Instead of using the plastic media that is found in downdraft skimmer designs, the Beckett skimmer uses design concepts from previous generations of skimmers, specifically the downdraft skimmer and the venturi skimmer (the Beckett 1408 Foam Nozzle is a modified 4 port venturi) to produce a hybrid that is capable of using powerful pressure rated water pumps and quickly processing large amounts of aquarium water in a short period of time. Commercial Beckett skimmers come in single Beckett, dual Beckett, and quad Beckett designs. Well engineered Beckett skimmers are quiet and reliable but the powerful pumps used in larger Beckett skimmer designs can take up additional space, introduce additional noise, and use more electricity than less powerful pumps. Unlike the Downdraft and Spray Induction skimmers, Beckett skimmer designs are produced by a number of companies in the United States and elsewhere and are not known to be restricted by patents.\n\n====Spray Induction====\nThis method is related to the downdraft, but uses a pump to power a spray nozzle, fixed a few inches above the water level. The spray action entraps and shreds the air in the base of the unit, which then rises to the collection chamber. In the United States, one company has patented the spray induction technology and the commercial product offerings are limited to that single company.\n\n===Recirculating Skimmer Designs ===\nA recent trend is to change the method by which the skimmer is fed dirty water from the aquarium as a means to recirculate water within the skimmer multiple times before it is returned to the sump or the aquarium. Aspirating pump skimmers are the most popular type of skimmer to use recirculating designs although other types of skimmers, such as Beckett skimmers are also available in recirculating versions. While there is a popular belief among some aquarist that this recirculation increases the dwell or contact time of the generated air bubbles within the skimmer there is no authoritative evidence that this is true. Each time water is recirculated within the skimmer any air bubbles in that water sample are destroyed and new bubbles are generated by the recirculating pump venturi apparatus so the air-water contact time begins again for these newly created bubbles. In non-recirculating skimmer designs, a skimmer has one inlet supplied by a pump that pulls water in from the aquarium and injects it with air into the skimmer and releasing the foam or air/water mix into the reaction chamber. With a recirculating design, the one inlet is usually driven by a separate feed pump, or in some cases may be gravity fed, to receive the dirty water to process, while the pump providing the foam or air/water mix into the reaction chamber is set up separately in a closed loop on the side of the skimmer. The recirculating pump pulls water out of the skimmer and injects air to generate the foam or air/water mix before returning it to the skimmer reaction chamber -- thus recirculating it. The feed pump in a recirculating design typically injects a smaller amount of dirty water than co/counter-current designs. The separate feed pump allows easy control of the rate of water exchange through the skimmer and for many aquarists this is one of the important attractions of recirculating skimmer designs. Because the pump configuration of these skimmers is similar to that of aspirating pump skimmers, the power consumption advantages are also similar.\n\n'
p276
tp277
a(I1
S'{{Inappropriate tone|article|April 2007|date=December 2007}}\n{{Otheruses}}\n\nHospitality refers to the relationship process between a [[guest]] and a host, and it also refers to the act or practice of being hospitable, that is, the reception and entertainment of guests, visitors, or strangers, with liberality and goodwill.  Hospitality frequently refers to the hospitality industry jobs for [[hotel]]s, [[restaurant]]s, [[casino]]s, '
p278
tp279
a(I-1
S'Backpacker Magazine is an American publication that features information on wilderness [[hiking]] and [[adventure]]. It has been published since 1973. Backpacker magazine is currently published by [[Active Interest Media]] and is based in [[Boulder, Colorado]]. The magazine moved from [[Emmaus, Pennsylvania]] to Boulder in August 2007.\n\n==History==\nThe first issue of Backpacker appeared in the spring of 1973. The editors note written by founding editor William Kemsley explains, It took us three years to put together the first issue of Backpacker. In that time we debated some serious questions among ourselves. The note describes the founding editors worries that America in the early 1970s did not contain a backpacking community large enough  to support a magazine. It also expresses Kemsleys goal to support the magazine primarily through [[subscriptions]] rather than [[advertising]]. \n\nThe Winter/Spring 2007 issue of the journal Appalachia includes an essay by Kemsley in which he describes how he developed the idea to create a magazine about backpacking. The article, titled [http://www.outdoors.org/publications/appalachia/2007/1970s-backpacking-boom.cfm How the 1970s Backpacking Boom Burst Upon Us,] explains several pivotal moments that showed Kemlsey that an audience could exist for such a magazine. \n\nBackpacker was owned first by Kemsley, who sold it to [[Ziff Davis]] in 1980, which sold it to [[CBS Corporation|CBS Publishing]].  In the late 1980s, it was bought by [[Rodale Press]], which also publishes [[Mens Health]], [[Bicycling (magazine)|Bicycling]], and [[Runners World]]. In May 2007 Rodale sold Backpacker to [[Active Interest Media]] and the magazine moved to Boulder, CO in August 2007.\n\n==Current status==\nOn May 17, 2007 Active Interest Media, an El Segundo, CA-based magazine publisher, announced that it would buy Backpacker magazine from Rodale Press. A May 10th article in the [[New York Post]] reported a sale price of $14.5 million.<ref name=nypost>{{cite web|url=http://www.nypost.com/seven/05102007/business/rodale_unloading_backpacker_business_keith_j__kelly.htm|title=RODALE UNLOADING BACKPACKER|last=Kelly|first=Keith|date=May 10, 2007|work=New York Post|accessdate=2009-07-18}}</ref> Active Interest Media, which also publishes [[Yoga Journal]] and [[American Cowboy]], moved Backpacker to Boulder, CO in the summer of 2007, and Jon Dorn continues to lead the magazine as editor-in-chief. \n\nBackpacker publishes nine issues per year, which includes an annual gear guide in March. Combined issues are published for January-February, July-August, and November-December. The magazine is divided into the service-centric Basecamp section (which won a [[National Magazine Award]] for 2005), a feature well, a gear review section, and concludes with maps of local trails corresponding to six regional editions. Every April Backpacker presents its Editors Choice awards to highlight the best gear of the year.\n\nStarting in 2004 Backpacker began publishing regional editions of the magazine that include map cards for local trails. The regional concept developed from survey results that showed the magazines readers were interested in hikes near where they lived. It discontinued these map cards in the April 2008 as part of their effort to become a 100% [[carbon neutral]] magazine. The regional sections are now on-line. An all digital version of the magazine was also made available.\n\nIn November 2006 Backpacker began posting [[podcasts]] and videos on its website to complement the content that appears in the magazine issues. Additional videos appear on Backpackers [[YouTube]] channel. \n\nIn April 2007 Backpacker received its third National Magazine Award nomination in two years, this time in the single-topic issue category for its October 2006 Survival issue. National Magazine Awards are presented each May by the American Society of Magazine Editors, and are considered the magazine industrys highest editorial honor. Also in 2006 Backpacker received the MIN Best of the Web award in the Uses of Interactivity category for the backpacker.com/hikes website.\n\nIn May 2008 Backpacker won a first-ever National Magazine Award for General Excellence in the circulation category, 250,000 to 500,000. To win this honor, Backpacker beat national magazines like [[Cookie (magazine)|Cookie]], [[New York (magazine)|New York]], [[Wondertime]], and [[W (magazine)|W]]. <ref name=mpa>{{cite web|url=http://www.magazine.org/asme/magazine_awards/nma_winners/index.aspx|title=2009 National Magazine Awards Winners and Finalists|work=Magazine Publishers of America|accessdate=2009-07-18}}</ref>\n\nBackpacker is also used as part of the [[American Hiking Society]]s membership package.\n\nBackpackers primary competition in the magazine world includes [[Outside (magazine)|Outside]], [[National Geographic Adventure]], and [[Mens Journal]].\n\n'
p280
tp281
a(I1
S'{{Notability|date=September 2009}}\n{{Cleanup|date=September 2009}}\n{| class=wikitable\n|-\n| The [http://www.ulscr.org.uk/ University of London Society of Change Ringers] was founded just after the end of the Second World War. The objectives of the Society are the promotion of the art and science of [[change ringing]] in the University of London and ringing for church services.\n\nMembership of the Society is open to all past and present members of the University of London, persons undertaking courses of tertiary education at City University, Brunel University, or any other college in London and past and present full time employees of the University of London.\n\nThe society includes ringers of all standards from [http://www.heatons.fsnet.co.uk/Ringing/Articles/CChange.htm rounds and call changes] to spliced Maximus ringers, and also teaches students with no previous experience of ringing.  It has an active [http://www.ulscr.org.uk/events/ social calendar] including outings, picnics and parties together with an annual dinner and ringing tour during the summer vacation.  The society also attends the [[Southern Universities Association|SUA]] competition each year.\n| [[Image:Hartst.jpg]]\n|}\n\n== The Early Years ==\n\nMemories of the Societys early years by Denis Layton<ref>extracts taken from pages 49-53 of University of London Society of Change Ringers 60th Anniversary, Annual Report 2005-2006</ref> -extracts taken from pages 4953 of University of London Society of Change Ringers 60th Anniversary, Annual Report 2005-2006\n\n...In October 1945 Vernon Benning, Philip Gray, Paul Williamson, Ted Challis and I met at Imperial College and adopted a constitution for the University of London Society of Change Ringers. I was the first Master, Philip Gray the Secretary, and we invited Dr James C E Simpson - a very well known and respected ringer, and lecturer in the University at Kings from 1935 to 1939 - to be the first President. Of the founding members, Vernon Benning died in July 2004 but at the time of writing (May 2006) the other four are still alive. Vernon played a big part in ringing and teaching learners in the early years and was Master 1947-8...\n\nAt the very beginning, the Society had its base at [[St Gabriels Pimlico|St Gabriels]], [[Pimlico]]. The bells had not been rung since before the War, and Philip and I spent an exhausting afternoon clearing out what felt like tons of pigeon manure and nesting material from the bell chamber and cleaning the ringing chamber. The ropes were rotten at the top so, because we couldnt afford new proper bell ropes, I obtained a large amount of hemp rope from a chandler in Dockland that my father knew, and we spent another afternoon splicing the bottom ends of the existing ropes, which were good enough for up to about 10 feet from the sallies, on to the new rope. Since the total draught was long and the hemp rope was initially very elastic we had some rather exciting times ringing!\n\nWe taught learners with silenced bells on Thursday evenings, and practised with open bells on Mondays.  Regular Sunday ringing was not possible because most of us were attached to other local towers, but we did sometimes ring quarter peals for special occasions. The arrangement lasted for a couple of years or so, but eventually we were asked to leave because the level of complaints from residents in the area became too high -the church was completely surrounded by houses and we had no means of sound reduction. We then led a somewhat nomadic existence for a while - ringing on the 8 bells at S Marys Lambeth (by the gates to Lambeth Palace) and for quite a period at S Stephen, Belsize Park, Hampstead with 10 bells though we mostly rang the back eight or the front six.\n\nOur headquarters became S Olave, Hart Street [1954]. In the very early years we rang a lot of call changes (very good for our striking), Grandsire Triples, Stedman Triples and Bob Major. The repertoire widened as we gained more members and experience, and, for example, on the Yorkshire tour, centered on Ilkley in 1948 we scored good peals of London Surprise Major and Little Bob Royal and rang a good half course of Cambridge Major on the back eight at York Minster with Bill Simpson on the tenor (he was in fact one of the highest rated heavy bell ringers in the country at that time).\n\nWhen the ULSCR was founded in 1945, Dr J C E Simpson agreed to become the first President on condition that it should be for a reasonable but limited time - he was adamant that the Society must be the institution, not any of the officers. In the event, his untimely death in 1952 at the age of 43 coincided with the time he had in mind as the limit of his period in office. The principle he laid down concerning periods in office has been adhered to throughout the Societys history...\n\nAfter ten years of existence the members of the ULSCR reckoned that the Society was sufficiently well established to be affiliated to the Central Council. Application was therefore made and affiliation was approved at the Councils meeting at Leicester on 22 May 1956. I was admitted as the first representative of the ULSCR at that meeting.\n\nDenis Layton, May 2006\n\n== Current Activities ==\n\nULSCR ringing is based at [http://london.lovesguide.com/olave_hart.htm St Olaves Church, Hart Street] in the City of London (near Tower Hill Tube - District & Circle Lines).\n\nPractices take place on Thursday evenings between 7:00pm and 8:30pm during term time and Sunday service ringing is from 10:15am until 11:00am on the 1st and 3rd Sundays in the month.\n\nRinging including some practices also takes place at various other towers in the London area (see [http://www.ulscr.org.uk/events/ Upcoming Events]) or contact the Master for details.\n\nStudents interested in joining can turn up to any practice, contact the Society by [mailto:newmember@ulscr.org.uk emailing], or view the [http://www.ulscr.org.uk/ website] for more information.\n\n'
p282
tp283
a(I1
S'{{Redirect|Overclocked}}\n[[Image:Overclock.jpg|thumb|350px|right|AMD [[Athlon XP]] Overclocking [[BIOS]] Setup on ABIT NF7-S. [[Front side bus]] frequency (External clock) has increased from 133 [[MHz]] to 148 MHz, and [[clock multiplier]] factor has changed from 13.5 to 16.5.]]\n\nOverclocking is the process of running a [[computer hardware|computer component]] at a higher [[clock rate]] (more clock cycles per second) than it was designed for or was specified by the manufacturer, usually practiced by [[enthusiast computing|enthusiasts]] seeking an increase in the performance of their computers. Some of them purchase low-end computer components which they then overclock to higher speeds, or overclock high-end components to attain levels of performance beyond the specified values. Others overclock outdated components to keep pace with new [[system requirements]], rather than purchasing new hardware.<ref>{{cite book | title = The Book of Overclocking | first = Scott | last = Wainner | coauthors = Robert Richmond | pages = 12 | isbn = 188641176X | publisher = No Starch Press | year = 2003}}</ref>\n\nUsers who overclock their components mainly focus their efforts on [[Central processing unit|processors]], [[video card]]s, [[motherboard]] [[chipset]]s, and [[Random access memory|Random Access Memory (RAM)]]. It is done through manipulating the [[CPU multiplier]] and the motherboards [[front side bus]] (FSB) speed until a maximum stable operating frequency is reached, although with the introduction of Intels new X58 chipset and the [[Core i7]] Processor, the Front Side Bus has been replaced with the QPI (Quick Path Interconnect); often this is called the Baseclock (BCLK). While the idea is simple, variation in the electrical and physical characteristics of computing systems complicates the process. CPU multipliers, bus dividers, [[voltage]]s, thermal loads, cooling techniques and several other factors can affect it.<ref>{{cite book | title = The Book of Overclocking | first = Scott | last = Wainner | coauthors = Robert Richmond | pages = 29 | isbn = 188641176X | publisher = No Starch Press | year = 2003}}</ref> \n\n==Considerations==\n\nThere are several considerations when overclocking. First is to ensure that the component is supplied with adequate power to operate at the new speed. However, supplying the power with improper settings or applying excessive [[voltage]] can permanently damage a component. Since tight tolerances are required for overclocking, only more expensive motherboards&mdash;with advanced settings that computer enthusiasts are likely to use&mdash;have built-in overclocking capabilities. Motherboards with fewer settings, such as those found in [[Original Equipment Manufacturer]] (OEM) systems, do not support overclocking.\n\n=== Cooling ===\n{{Main|Computer cooling}}\n[[Image:Copper heat sink with pipes.jpg|thumb|High quality [[heatsink]]s are often made of [[copper]].]]\n\nAll [[Electrical network|electronic circuits]] produce heat generated by the movement of [[electron]]s. As clock frequencies in [[digital circuit]]s and voltage applied increase, the heat generated by components running at the clock speed also increases. Because of increased heat produced by overclocked components, effective cooling is necessary to avoid damaging the hardware. In addition, some digital circuits slow down at high temperatures due to changes in [[MOSFET|metaloxidesemiconductor field-effect transistor]] (MOSFET) device characteristics. Wire resistance also increases slightly at higher temperatures, contributing to decreased circuit performance{{Citation needed|date=January 2009}}.\n\nBecause most stock cooling systems are designed for the amount of power produced during non-overclocked use, overclockers typically turn to more effective cooling solutions, such as powerful [[fan (mechanical)|fans]], larger [[heatsinks]], [[heat pipe]]s and water cooling. Size, shape, and material all influence the ability of a heatsink to dissipate heat. Efficient heatsinks are often made entirely of [[copper]], which has high [[thermal conductivity]], but is expensive.<ref name=Wainner38>{{cite book | title = The Book of Overclocking | first = Scott | last = Wainner | coauthors = Robert Richmond | pages = 38 | isbn = 188641176X | publisher = No Starch Press | year = 2003}}</ref> [[Aluminium]] is more widely used; it has poorer thermal conductivity, but is significantly cheaper than copper. [[Heat pipe]]s are commonly used to improve conductivity. Many heatsinks combine two or more materials to achieve a balance between performance and cost.<ref name=Wainner38/>\n\n[[Image:DIY PC watercooling T-Line.JPG|Interior of a water-cooled computer, showing CPU [[water block]], tubing, and pump|left|thumb]]\n[[Water cooling]] carries [[waste heat]] to a radiator. [[Thermoelectric cooling]] devices, also known as Peltier devices, are recently popular with the onset of high [[Thermal Design Power]] (TDP) processors made by Intel and AMD. Thermoelectric cooling devices create temperature differences between two plates by running an [[electric current]] through the plates. This method of cooling is highly effective, but itself generates significant heat. For this reason, it is often necessary to supplement thermoelectric cooling devices with a convection-based heatsink or a water-cooling system.\n\n[[Image:2007TaipeiITMonth IntelOCLiveTest Overclocking-6.jpg|right|thumb|[[Liquid nitrogen]] may be used for cooling an overclocked system, when an extreme measure is needed.]]\nOther cooling methods are [[forced convection]] and [[phase change]] cooling which is used in [[refrigerator]]s. [[Liquid nitrogen]], [[liquid helium]], and [[dry ice]] are used as coolants in extreme cases,<ref name=Wainner44>{{cite book | title = The Book of Overclocking | first = Scott | last = Wainner | coauthors = Robert Richmond | pages = 44 | isbn = 188641176X | publisher = No Starch Press | year = 2003}}</ref> such as record-setting attempts or one-off experiments rather than cooling an everyday system. In June 2006, [[IBM]] and [[Georgia Institute of Technology]] jointly announced a new record in silicon-based chip speed above 500&nbsp;GHz, which was done by cooling the chip to {{Convert|4.5|K|C F|1|lk=on}} using liquid helium.<ref>{{cite web | last = Toon| first = John| date = 20 June 2006 | url = http://www.gatech.edu/news-room/release.php?id=1019| title = Georgia Tech/IBM Announce New Chip Speed Record| publisher = Georgia Institute of Technology | accessdate = 2 February 2009 }}</ref> These extreme methods are generally impractical in the long term, as they require refilling reservoirs of vaporizing coolant, and [[condensation]] can be formed on chilled components.<ref name=Wainner44/> Moreover, [[silicon]]-based [[junction gate field-effect transistor]]s (JFET) will degrade below temperatures of roughly {{convert|100|K|C F|0}} and eventually cease to function or freeze out at {{convert|40|K|C F|0}} since the silicon ceases to be semiconducting<ref>{{cite web | title = Extreme-Temperature Electronics: Tutorial - Part 3 | url = http://www.extremetemperatureelectronics.com/tutorial3.html | year = 2003 | accessdate = 2007-11-04}}</ref> so using extremely cold coolants may cause devices to fail.\n\nSubmersion cooling, used by the [[Cray-2]] [[supercomputer]], involves sinking a part of computer system directly into a chilled liquid that is thermally conductive but has low [[electrical conductivity]]. The advantage of this technique is that no condensation can form on components.<ref name=Wainner48/> A good submersion liquid is [[Fluorinert]] made by [[3M]], which is expensive and can only be purchased with a permit.<ref name=Wainner48/> Another option is [[mineral oil]], but impurities such as those in water might cause it to conduct electricity.<ref name=Wainner48>{{cite book | title = The Book of Overclocking | first = Scott | last = Wainner | coauthors = Robert Richmond | pages = 48 | isbn = 188641176X | publisher = No Starch Press | year = 2003}}</ref>\n\n===Stability and functional correctness===\n\n{{See also| Stress testing#hardware }}\n\nAs an overclocked component operates outside of the manufacturers recommended operating conditions, it may function incorrectly, leading to system instability. Another risk is [[Reliability, Availability and Serviceability|silent data corruption]] by undetected errors.  Such failures might never be correctly diagnosed and may instead be incorrectly attributed to software bugs in applications or the operating system. Overclocked use may permanently damage components enough to cause them to misbehave (even under normal operating conditions) without becoming totally unusable. \n\nIn general, overclockers claim that testing can ensure that an overclocked system is stable and functioning correctly. Although software tools are available for testing hardware stability, it is generally impossible{{Citation needed|date=July 2009}} for any private individual to thoroughly test the functionality of a processor. Achieving good [[fault coverage]] requires immense engineering effort; even with all of the resources dedicated to validation by manufacturers, faulty components and even design faults are not always detected.\n\nA particular stress test can verify only the functionality of the specific instruction sequence used in combination with the data and may not detect faults in those operations. For example, an arithmetic operation may produce the correct result but incorrect [[status register|flags]]; if the flags are not checked, the error will go undetected. \n\nTo further complicate matters, in process technologies such as [[silicon on insulator]], devices display [[hysteresis]]&mdash;a circuits performance is affected by the events of the past, so without carefully targeted tests it is possible for a particular sequence of state changes to work at overclocked speeds in one situation but not another even if the voltage and temperature are the same.  Often, an overclocked system which passes stress tests experiences instabilities in other programs.<ref>{{cite web | url = http://blogs.msdn.com/oldnewthing/archive/2005/04/12/407562.aspx | first = Raymond | last = Chen | title = The Old New Thing: Theres an awful lot of overclocking out there | date = [[April 12]], [[2005]] | accessdate = 2007-03-17 }}</ref>\n\nIn overclocking circles, stress tests or torture tests are used to check for correct operation of a component.  These workloads are selected as they put a very high load on the component of interest (e.g. a graphically-intensive application for testing video cards, or different math-intensive applications for testing general CPUs).  Popular stress tests include [[Prime95]], Superpi, OCCT, IntelBurnTest/Linpack/LinX, [[Sisoft Sandra|SiSoftware Sandra]], [[BOINC]], Intel Thermal Analysis Tool and [[Memtest86]].  The hope is that any functional-correctness issues with the overclocked component will show up during these tests, and if no errors are detected during the test, the component is then deemed stable. Since fault coverage is important in [[Software testing|stability testing]], the tests are often run for long periods of time, hours or even days.\n\n===Factors allowing overclocking===\n[[Image:Pentium-Dual-Core-E2140-100%-overclock-2.PNG|right|thumb|[[CPU-Z]] screenshot demonstrating an [[Intel Pentium Dual-Core|Intel Pentium Dual-Core E2140]] overclocked to twice its rated frequency.]]\nOverclockability arises in part due to the economics of the manufacturing processes of CPUs and other components. In most cases components with different rated clock speeds are manufactured by the same process, and tested after manufacture to determine their actual ratings. The clock speed that the component is rated for is at or below the speed at which the CPU has passed the manufacturers functionality tests when operating in worst-case conditions (for example, the highest allowed temperature and lowest allowed supply voltage).  Manufacturers must also leave additional margin for reasons discussed below.  Sometimes manufacturers produce more high-performing parts than they can sell, so some are marked as medium-speed chips to be sold for medium prices. Pentium architect [[Bob Colwell]] calls overclocking an uncontrolled experiment in better-than-worst-case system operation.<ref>Bob Colwell, The Zen of Overclocking, Computer, vol. 37,  no. 3,  pp. 9-12,  Mar.,  2004.</ref>\n\n===Measuring effects of overclocking===\n[[Benchmark (computing)|Benchmark]]s are used to evaluate performance. The benchmarks can themselves become a kind of sport, in which users compete for the highest scores.  As discussed above, stability and functional correctness may be compromised when overclocking, and meaningful benchmark results depend on correct execution of the benchmark.  Because of this, benchmark scores may be qualified with stability and correctness notes (e.g. an overclocker may report a score, noting that the benchmark only runs to completion 1 in 5 times, or that signs of incorrect execution such as display corruption are visible while running the benchmark).\n\nGiven only benchmark scores it may be difficult to judge the difference overclocking makes to the overall speed of a computer. For example, some benchmarks test only one aspect of the system, such as memory [[Bandwidth (computing)|bandwidth]], without taking into consideration how higher speeds in this aspect will improve the system performance as a whole. Apart from demanding applications such as video encoding, high-demand [[database]]s and [[scientific computing]], [[memory bandwidth]] is typically not a [[bottleneck (engineering)|bottleneck]], so a great increase in memory bandwidth may be unnoticeable to a user depending on the applications used. Other benchmarks, such as [[3D Mark|3DMark]] attempt to replicate game conditions.\n\n===Variance===\nThe extent to which a particular part will overclock is highly variable. Processors from different vendors, production batches, [[Stepping (version numbers)|steppings]], and individual units will all overclock with varying degrees of success.\n\n==Manufacturer and vendor overclocking==\nCommercial system builders or component resellers sometimes overclock to sell items at higher profit margins. The retailer makes more money by buying lower-value components, overclocking them, and selling them at prices appropriate to a non-overclocked system at the new speed. In some cases an overclocked component is functionally identical to a non-overclocked one of the new speed, however, if an overclocked system is marketed as a non-overclocked system (it is generally assumed that unless a system is specifically marked as overclocked, it is not overclocked), it is considered [[fraud]]ulent.\n\nOverclocking is sometimes offered as a legitimate service or feature for consumers, in which a manufacturer or retailer tests the overclocking capability of processors, memory, video cards, and other hardware products. Several video card manufactures now offer factory overclocked versions of their graphics accelerators, complete with a warranty, which offers an attractive solution for enthusiasts seeking an improved performance without sacrificing common warranty protections. Such factory-overclocked products may cost a little more than standard components, but may be more cost-effective than product with a higher specification.\n\nNaturally, manufacturers would prefer enthusiasts to pay additional money for profitable high-end products, in addition to concerns of less reliable components and shortened product life spans affecting brand image. It is speculated that such concerns are often motivating factors for manufacturers to implement overclocking prevention mechanisms such as [[CPU locking]]. These measures are sometimes marketed as a [[consumer protection]] benefit, which typically generates a negative reception from overclocking enthusiasts.\n\n==Advantages==\n* The user can, in many cases, purchase a slower, cheaper component and overclock it to the speed of a more expensive component. \n\n* Faster performance in games, encoding, video editing applications, and system tasks at no additional expense, but at increased cost for electrical power consumption. Particularly for enthusiasts who regularly upgrade their hardware, overclocking can increase the time before an upgrade is needed.\n\n* Some systems have bottlenecks, where small overclocking of a component can help realize the full potential of another component to a greater percentage than the limiting hardware is overclocked. For instance, many [[motherboards]] with [[Athlon 64|AMD Athlon 64]] processors limit the speed of four units of RAM to 333 [[Megahertz|MHz]]. However, the memory speed is computed by dividing the processor speed (which is a base number times a [[CPU multiplier]], for instance 1.8 GHz is most likely 9x200 MHz) by a fixed [[integer]] such that, at stock speeds, the RAM would run at a clock rate near 333 MHz. Manipulating elements of how the processor speed is set (usually lowering the multiplier), one can often overclock the processor a small amount, around 100-200 MHz (less than 10%), and gain a RAM clock rate of 400 MHz (20% increase), releasing the full potential of the RAM.  \n\n* Overclocking can be an engaging hobby in itself and supports many dedicated online communities. The [[PCMark]] website is one such site that hosts a leaderboard for the most powerful computers to be benchmarked using the program.\n\n* A new overclocker with proper research and precaution or a guiding hand can gain useful knowledge and hands-on experience about their system and PC systems in general.\n\n==Disadvantages==\nMany of the disadvantages of overclocking can be mitigated or reduced in severity by skilled overclockers. However, novice overclockers may make mistakes while overclocking which can introduce avoidable drawbacks and which are more likely to damage the overclocked components (as well as other components they might affect).\n\n===General===\nThese disadvantages are unavoidable by both novices and veterans.\n\n* The lifespan of a processor may be reduced by higher operating frequencies, increased voltages and heat, although processors rapidly become obsolete in performance due to technological progress.\n\n* Increased clock speeds and/or voltages result in higher power consumption.\n\n* While overclocked systems may be tested for stability before use, stability problems may surface after prolonged usage due to new workloads or untested portions of the processor core.  Aging effects previously discussed may also result in stability problems after a long period of time.  Even when a computer appears to be working normally, problems may arise in the future.  For example, [[Microsoft Windows|Windows]] may appear to work with no problems, but when you re-install or upgrade [[Microsoft Windows|Windows]], you may receive error messages such as a file copy error during Windows Setup <ref>http://support.microsoft.com/kb/310064/en-us</ref>. Microsoft says this of errors in upgrading to Windows XP: Your computer [may be] over-clocked. Because over-clocking is very memory-intensive, decoding errors may occur when you extract files from your Windows XP CD-ROM.\n\n* High-performance fans used for extra cooling can be noisy. Older popular models of fans used by overclockers can produce 50 [[decibels]] or more. However, nowadays, manufacturers are overcoming this problem by designing fans with aerodynamically optimized blades for smoother airflow and minimal noise (around 20 decibels at approximately 1 metre). The noise is not always acceptable, and overclocked machines are often much noisier than stock machines. Noise can be reduced by utilizing strategically-placed larger fans, which are inherently less noisy than smaller fans; by using alternative cooling methods (such as liquid and phase-change cooling); by lining the chassis with foam insulation; and by installing a fan-controlling bus to adjust fan speed (and, as a result, noise) to suit the task at hand. Now that overclocking is of interest to a larger target audience, this is less of a concern as manufacturers have begun researching and producing high-performance fans that are no longer as loud as their predecessors. Similarly, mid- to high-end PC cases now implement larger fans (to provide better airflow with less noise) as well as being designed with cooling and airflow in mind.\n\n* Even with adequate CPU cooling, the excess heat produced by an overclocked processing unit increases the ambient air temperature of the system case; consequently, other components may be affected. Also, more heat will be expelled from the PCs vents, raising the temperature of the room the PC is in - sometimes to uncomfortable levels.\n\n* Overclocking has the potential to cause component failure (heat death). Warranties do not cover damage caused by overclocking.  Some motherboards offer safety measures that will stop this from happening (eg. limitations on FSB increase) so that only voltage control alterations can cause such harm.\n\n* Overclocking a PC component may void its warranty (depending on the conditions of sale).\n\n* There is a risk of fire if devices are not properly cooled.\n\n===Incorrectly performed overclocking===\n* Increasing the operation frequency of a component will usually increase its thermal output in a linear fashion, while an increase in voltage usually causes heat to increase as the square of the voltage.  Excessive voltages or improper cooling may cause chip temperatures to rise almost instantaneously, causing the chip to be damaged or destroyed.\n* More common than hardware failure is functional incorrectness. Although the hardware is not permanently damaged, this is inconvenient and can lead to instability and [[data loss]]. In rare, extreme cases entire [[filesystem]] failure may occur, causing the loss of all data.<ref>{{cite web | url = http://www.pcguide.com/opt/oc/risksRisksCPU-c.html | title = Risks of Overclocking the Processor | publisher = The PC Guide | year = 2001| first = Charles M. | last = Kozierok | accessdate = 2007-03-17}}</ref> \n* With poor placement of fans, turbulence and vortices may be created in the computer case, resulting in reduced cooling effectiveness and increased noise.  In addition, improper fan mounting may cause rattling or vibration.\n* Improper installation of exotic cooling solutions like [[Watercooling|liquid]] or [[Refrigeration cycle|phase-change]] cooling may result in failure of the cooling system, which may result in [[water damage]] or damage to the processor due to the sudden loss of cooling.\n* Sometimes products claim to be intended specifically for overclocking and may be just decoration. Novice buyers should be aware of the marketing hype surrounding some products. Examples include heat spreaders and [[heatsinks]] designed for chips which do not generate enough heat to benefit from these devices. (Memory chips, for example)\n\n===Limitations===\nThe utility of overclocking is limited for a few reasons:\n\n* [[Personal computer]]s are mostly used for tasks which are not computationally demanding, or which are performance-limited by bottlenecks outside of the local machine. For example, web browsing does not require a very fast computer, and the limiting factor will almost certainly be the speed of the [[internet]] connection of either the user or the server. Overclocking a processor will also do little to help speed up application loading times as the limiting factor is reading data off of the hard drive. Other general office tasks such as [[word processor|word processing]] and sending email are more dependent on the efficiency of the user than on the speed of the hardware. In these situations any speed increases through overclocking are unlikely to be noticeable.\n* It is generally accepted that, even for computationally-heavy tasks, speed increases of less than ten percent are difficult to discern. For example, when playing video games, it is difficult to discern an increase from 60 to 66 [[Frame rate|frames per second]] (FPS) without the aid of an on-screen frame counter. Overclocking of a processor will rarely improve gaming performance noticeably, as the frame rates achieved in most modern games are bound almost exclusively by the [[GPU]] at resolutions beyond 1024x768.\n\n== Graphics cards ==\n[[Image:DSC00193.jpg|thumb|200px|right|The BFG GeForce 6800GSOC ships with higher memory and clock speeds than the standard 6800GS.]]\nGraphics cards can also be overclocked<ref>{{cite web\n  | last = Coles\n  | first = Olin \n  | title = Overclocking the NVIDIA GeForce Video Card\n  | url=http://benchmarkreviews.com/index.php?option=com_content&task=view&id=205&Itemid=38\n  | accessdate = 2008-09-05 }}</ref>, with utilities such as [[EVGA]]s Precision, [[RivaTuner]], [[ATI]] Overdrive (on [[ATI]] cards) or the [[PEG Link Mode]] on [[ASUS]] [[motherboard]]s. Overclocking a GPU will often yield a marked increase in performance in synthetic benchmarks, and usually will improve game performance too.\n\nSometimes, it is possible to see that a graphics card is pushed beyond its limits before any permanent damage is done by observing on-screen distortions known as artifacts.  Two such discriminated warning bells are widely understood: green-flashing, random triangles appearing on the screen usually correspond to overheating problems on the GPU itself, while white, flashing dots appearing randomly (usually in groups) on the screen often mean that the cards RAM is overheating. It is common to run into one of those problems when overclocking graphics cards. Showing both symptoms at the same time usually means that the card is severely pushed beyond its heat/speed/voltage limits.  If seen at normal speed, voltage and temperature, they may indicate faults with the card itself.\n\nSome overclockers use a hardware voltage modification where a [[potentiometer]] is applied to the video card to manually adjust the voltage.  This results in much greater flexibility, as overclocking software for graphics cards is rarely able to freely adjust the voltage. Voltage mods are very risky and may result in a dead video card, especially if the voltage modification (voltmod) is applied by an inexperienced individual. A pencil volt mod refers to changing a resistors value on the graphics card by drawing across it with a graphite pencil. This results in a change of GPU voltage. It is also worth mentioning that adding physical elements to the video card immediately voids the warranty.\n\n=== Alternatives ===\n\nFlashing and Unlocking are two popular ways to gain performance out of a [[Graphics Card|video card]], without technically overclocking.  \n\nFlashing refers to using the [[firmware]] of another card, based on the same core and design specs, to override the original firmware, thus effectively making it a higher model card; however, flashing can be difficult, and sometimes a bad flash can be irreversible. Sometimes [[stand-alone]] software to modify the firmware files can be found, i.e. [[NiBiTor]], (GeForce 6/7 series are well regarded in this aspect). It is not necessary to acquire a firmware file from a better model video card (although it should be said that the card in which firmware is to be used should be compatible, i.e. the same model base, design and/or manufacture process, revisions etc.). For example, video cards with 3D accelerators (the vast majority of todays market) have two voltage and speed settings - one for 2D and one for 3D - but were designed to operate with three voltage stages, the third being somewhere in the middle of the aforementioned two, serving as a fallback when the card overheats or as a middle-stage when going from 2D to 3D operation mode. Therefore, it could be wise to set this middle-stage prior to serious overclocking, specifically because of this fallback ability - the card can drop down to this speed, reducing by a few (or sometimes a few dozen, depending on the setting) percent of its efficiency and cool down, without dropping out of 3D mode (and afterwards return to the desired full-speed clock and voltage settings).\n\nSome cards also have certain abilities not directly connected with overclocking. For example, NVIDIAs [[GeForce|GeForce 6600GT]] (AGP flavor) features a temperature monitor (used internally by the card), which is invisible to the user in the vanilla version of the cards BIOS. Modifying the BIOS can allow a Temperature tab to become visible in the card drivers advanced menu.\n\nUnlocking refers to enabling extra [[Graphics pipeline|pipelines]] and/or [[shaders|pixel shaders]].  The [[Geforce 6|6800LE]], the [[Geforce 6|6800GS]] and [[Geforce 6|6800]] ([[Accelerated Graphics Port|AGP]] models only) and [[Radeon R420|Radeon X800]] Pro VIVO were some of the first cards to benefit from unlocking.  While these  models have either 8 or 12 pipes enabled, they share the same 16x6 [[Graphics Processing Unit|GPU]] core as a [[GeForce 6 Series|6800GT]] or Ultra, but may not have passed inspection when all their pipelines and shaders were unlocked. In more recent generations, both ATI and Nvidia have laser cut pipelines to prevent this practice.{{Citation needed|date=June 2007}}.\n\nIt is important to remember that while pipeline unlocking sounds very promising, there is absolutely no way of determining if these unlocked pipelines will operate without errors, or at all (this information is solely at the manufacturers discretion). In a worst-case scenario, the card may not start up ever again, resulting in a [[Brick (electronics)|dead piece of equipment]].  It is possible to revert to the cards previous settings, but it involves manual firmware flashing using special tools and an identical but original firmware chip.\n\n'
p284
tp285
a(I-1
S'{{Unreferenced|date=March 2009}}\nZX Spectrum demos are [[demo (computer programming)|demos]] made for the [[ZX Spectrum]] and compatible computers.  The [[demo scene]] on the Spectrum can probably be traced back to [[Castor Cracking Group]], [[The Lords (demogroup)|The Lords]] and a few other groups and individuals back in 1986.  The ZX Spectrum demo scene was slow to start, but it started to rise in the late 1980s, most noticeably in [[Eastern Europe]].\n\n== Hardware ==\n\nAlthough there are many demos made for the 48K Spectrums, most current Spectrum demos require the additional features found in the Spectrum 128K, that is, 128 [[Kibibyte|KiB]] of RAM and the [[AY-3-8912]] sound chip. Also, many demos have been designed to run from a [[floppy disk]] rather than a [[Compact Cassette|cassette tape]].\n\nIn many eastern European countries, the various [[:Category:ZX Spectrum clones|Spectrum clones]] used to be more common than the original models, a fact that also reflects in the choices of hardware among the demoscene. For example, on most Russian demoscene events, the standard compo Spectrum is the [[Pentagon (computer)|Pentagon 128]] with a floppy disk drive. Since there are considerable technical differences between the Pentagon and the original Spectrum, particularly in the video timing, there are also many demos that require a Pentagon to run properly.\n\n== Status ==\n\nIn the former Soviet Union and Eastern/Central Europe, the ZX Spectrum often has a cult status similar to the [[Commodore 64]] in the Western Europe: it was the most popular 8-bit homecomputer and also the first computer for many computer and demoscene enthusiasts. Therefore, whereas many major Western European demo parties organize demo, music and graphics competitions for the Commodore 64, the parties in the east often have the corresponding ZX Spectrum competitions instead.\n\n== Design ==\n\nThe earliest demos were simple music players with music ripped from games and perhaps simple effects or text scrollers.  Many later demos feature so-called multicolor effects (changing attributes in the middle of character blocks), which have to be fixed to a specific ZX Spectrum model.  Megademos, demos with more content, usually split into several parts, appeared in the beginning of 90s, with the advent of the The Lyra II by ESI.  Most of the demos since 1996 have been trackmos (effects fixed to music), often featuring 3D objects, sometimes in low resolutions, to achieve more colours.\n\n== Demoparties ==\n\nZX Spectrum have been shown in multi-platform parties, such as Assembly and there used to be a lot of ZX Spectrum only parties, such as Funtop in [[Moscow]].  The largest party today featuring ZX Spectrum regularly is Chaos Constructions in [[Saint Petersburg]]. Outside of Russia is very famous Forever demoparty.\n\n== Groups ==\n*4th Dimension\n*Code Busters\n*CoolguysLimited\n*Cyberpunks Unity\n*Digital Reality\n*Excess Team\n*Eternity Industry\n*Extreme\n*HOOY-PROGRAM\n*Phantasy\n*Zero\n*The Mad Guys\n\n'
p286
tp287
a(I-1
S'{{Refimprove|date=February 2009}}\n\n{{Infobox VG\n| title          = Hunt the Wumpus\n| developer      = [[Gregory Yob]]\n| collapsible    = yes\n| publisher      =\n| distributor    =\n| image          = [[File:Ti hunt the wumpus boxart.jpg]]\n| caption        = TI-99/4A boxart showing the visualization of the Wumpus and the graphics-based labyrinth\n| license        =\n| series         =\n| engine         =\n| version        =\n| released       = Original BASIC Version<br />1972<br />TI-99/4A Version<br />1980\n| genre          = [[Adventure game]]\n| modes          = [[Single-player]]\n| ratings        =\n| platforms      = [[BASIC]], [[TI-99/4A]]\n| media          = Download, Cartridge\n| requirements   =\n| input          =\n}}\n\nHunt the Wumpus is an early [[computer game]], based on a simple [[hide and seek]] format featuring a mysterious monster (the Wumpus) that lurks deep inside a network of rooms.  It was originally a [[text-based game]] written in [[BASIC]].  It has since been ported to various programming languages and platforms including graphical versions.\n\n== About the game ==\n\n[[Image:Dodecahedron.png|right|150px|thumb|The shape of the [[labyrinth]] of the Hunt the Wumpus game.]]\nThe original [[text-based game|text-based]] version of Hunt the Wumpus uses a [[command line]] text interface.  A player of the game enters commands to move through the rooms or to shoot crooked arrows along a tunnel into one of the adjoining rooms. There are twenty rooms, each connecting to three others, arranged like the vertices of a [[dodecahedron]] (or the faces of an [[icosahedron]]). Hazards include bottomless pits, super bats (which drop the player in a random location, a feature duplicated in later, commercially published [[adventure game]]s, such as [[Zork I]], [[Valley of the Minotaur]], and [[Adventure (Atari 2600)|Adventure]]), and the Wumpus itself. When the player has deduced from hints which chamber the Wumpus is in without entering the chamber, he fires an arrow into the Wumpuss chamber to slay it. The player wins if he slays the Wumpus. However, firing the arrow into the wrong chamber startles the Wumpus, which may cause it to move to an adjacent room. The player loses if he is in the same room as the Wumpus or a bottomless pit.\n\nOriginally written by [[Gregory Yob]] in [[BASIC programming language|BASIC]] while attending [[University of Massachusetts Dartmouth]] and noticed on mainframes at least by 1972, Hunt the Wumpus was first published in the [[Peoples Computer Company]]<ref>Peoples Computer Company, founded in October 1971, was a small non-profit group of independent educators who met in a small storefront on Menalto Rd. in [[Menlo Park, California]] during the 1970s.  The first issue of their journal, Peoples Computer Company, was published in October 1972.</ref> journal in 1973, again in 1975 in [[Creative Computing]], and finally in 1979 in the book MORE BASIC Computer Games. Out of frustration with all the grid-based hunting games he had seen ([[Snark (game)|Snark]], [[Mugwump (game)|Mugwump]], and [[Hurkle]] included), Yob decided to create a map-based game.  Yob injected adversarial humor into the computers hints, prefiguring the voice of the [[Infocom]] narrator.<ref>[http://jerz.setonhill.edu/if/canon/Hunt_the_Wumpus.htm Hunt the Wumpus (1972?)<!-- Bot generated title -->]</ref>  Later versions of the game offered more hazards and other cave layouts.  An implementation of Hunt the Wumpus was typically included with [[MBASIC]], Microsofts BASIC interpreter for CP/M and one of the companys first products. Hunt the Wumpus was adapted as an early game for the [[Commodore PET]] entitled Twonky, which was distributed in the late 1970s with [[Cursor (magazine)|Cursor Magazine]].  A version of the game can still be found as part of the bsdgames package on modern [[BSD]] operating systems, (where its known as wump).\n\nThe 1980 port of the game for the [[TI-99/4A]] differs quite a bit from the original while retaining the same concept. It is a graphical rather than text-based game, and uses a [[regular grid]] equivalent to a [[torus]] rather than an icosahedron. In this version, the Wumpus is depicted as a large red head with a pair of legs growing out of its sides.<ref>[http://www.mobygames.com/game/ti-994a/hunt-the-wumpus/screenshots/gameShotId,95676/ Hunt the Wumpus - TI-99/4A Screenshots - MobyGames<!-- Bot generated title -->]</ref>\n\n== Hunt the Wumpus in other games ==\nThe card game [[Magic: The Gathering]] has featured several Wumpus cards. The Wumpus seen on Magic cards is a beast with a characteristically-shaped head, jaw and mane. [[Mercadian Masques]] featured [http://ww2.wizards.com/gatherer/CardDetails.aspx?name=hunted_wumpus Hunted Wumpus] (reprinted in several core sets, including [[10th Edition (Magic: The Gathering)|10th Edition]]), as well as [http://ww2.wizards.com/gatherer/CardDetails.aspx?name=thrashing_wumpus Thrashing Wumpus]. [[Planar Chaos]], a set concentrating on new takes on popular cards, contained [http://ww2.wizards.com/gatherer/CardDetails.aspx?name=shivan_wumpus Shivan Wumpus].\n\nThe Wumpus is also found in the open source game [[NetHack]] and the game [[M.U.L.E]], with capture of the wumpus in the latter game leading to an in-game cash prize for the player.<ref>[http://nethack.wikia.com/wiki/Wumpus Wumpus - Wikihack, the NetHack wiki]</ref><ref>[http://www.spod-central.org/~psmith/nh/gazetteer/quest/ran.html#locate NetHack Gazetteer: Ranger Quest<!-- Bot generated title -->]</ref><ref>[http://www.steelypips.org/nethack/experience-spoiler.html#t3 NetHack Experience Values Spoiler<!-- Bot generated title -->]</ref><ref>[http://www.mobygames.com/game/c64/mule M.U.L.E. for Commodore 64 - MobyGames<!-- Bot generated title -->]</ref>\n\nThe Wumpus is mentioned in the Thy Dungeonman games in Homestarrunner.com.\nIt is also mentioned in the October 18, 2000 cartoon at userfriendly.org.\n\nThe Wumpus gets his revenge on Wumpus hunters in the audio-only game [http://bethewumpus.sourceforge.net/ Be the Wumpus].\n\nA zone in [[Kingdom of Loathing]] was introduced in June of 2009 which features an icosahedral map and the goal of which is to find the Wumpus and defeat it in combat.<ref>[http://kol.coldfront.net/thekolwiki/index.php/Hunt_the_Wumpus Kingdom of Loathing Wiki]</ref>\n\n== Notes ==\n{{reflist}}\n\n'
p288
tp289
a(I-1
S'{{Expert-subject|Psychology|date=August 2008}}\n{{Expert-subject|Neuroscience|date=August 2008}}\n\n{{portalpar|Neuroscience|Neuro logo.png}}\nNeuropsychophysiology is a branch of [[psychophysiology]] that focuses on the interaction between the [[mind]] and the [[nervous system]].\n\nNeuropsychophysiologal studies have focused on subjects such as the physiology of [[consciousness]], the pathology of [[emotions]], and the physiology of [[communication]].<ref>http://www.neuropsychophysiology.org/ISN_NPF_eng.html</ref>  The field has also been applied in [[hypnosis]]<ref>{{cite book|title=\t\nTrancework: an introduction to the practice of clinical hypnosis|author=Michael D. Yapko|url=http://books.google.com/books?id=uYKaMWAfcewC&pg=PA95&dq=Neuropsychophysiology&ei=g08lSqvXIoewzASlwa2bBw#PPA96,M1}}</ref> and the treatment of [[schizophrenia]].<ref>{{cite journal|journal=Schizophrenia Bulletin |title=Functional Neuropsychophysiological Asymmetry in Schizophrenia: A Review and Reorientation |author=John H. Gruzelier|url=http://schizophreniabulletin.oxfordjournals.org/cgi/content/abstract/25/1/91}}</ref>\n\n'
p290
tp291
a(I-1
S'==Definition==\n\nThe comfort zone is a behavioural state within which a person operates in an [[anxiety]]-neutral condition, using a limited set of behaviours to deliver a steady level of performance, usually without a sense of [[risk]] ([[Alasdair A. K. White]] From Comfort Zone to Performance Management [http://www.pm-solutions.com/Performance_ManagementApril2008.pdf]\n\n==Theory==\nOnes comfort zone refers to the set of environments and behaviours with which one is comfortable, without creating a sense of [[risk]]. A persons personality can be described by his or her comfort zones. Highly successful persons may routinely step outside their comfort zones, to accomplish what they wish. A comfort zone is a type of [[mental conditioning]] that causes a person to create and operate mental boundaries. Such boundaries create an unfounded sense of security.  Like [[inertia]], a person who has established a comfort zone in a particular axis of his or her life, will tend to stay within that zone without stepping outside of it. To step outside a persons comfort zone, they must experiment with new and different behaviours, and then experience the new and different responses that then occur within their environment.\n\n==Comfort Zone and Performance Management==\n\nTo step out of the comfort zone raises the anxiety level engendering a stress response, the result of which is an enhanced level of concentration and focus. White (2008) refers to this as the Optimal Performance Zone - a zone in which the performance of a person can be enhanced and in which their skills can be optimised. However, White (2008) also observes that if the work of [[Robert Yerkes]] (1907) is considered in which he reported Anxiety improves performance until a certain optimum level of arousal has been reached. Beyond that point, performance deteriorates as higher levels of anxiety are attained, if a person steps beyond the optimum performance zone they enter a danger zone in which performance will decline rapidly as higher levels of anxiety or discomfort occur.\n\nIn terms of performance management or development, the objective of the trainer or manager is to cause the person to enter the optimum performance zone for a sufficient period of time so that new skills and performance can be achieved and become embedded. The same reasoning is used with goal setting: change the anxiety level and the performance will change. (However, it should be noted that in performance terms, the term incentive is used to describe the process of changing the anxiety level - an incentive being anything that causes a change in behaviour.)\n\n\n===Other Implications===\n\nAn example of stepping out of the comfort zone could be a recognized need to leave an unsatisfactory job but the fear of doing so as it would result in losing the sense of security the individual derives from the job. The sense of security the individual perceives could be attributed to the mental conditioning formed initially.\n\nA comfort zone may result when the mental concept that (a) person(s) has/have about something and actual reality of it, are not congruent with one another. A classic example to take would be of [[self image]]. \n\nSelf-image may consist of three types:\n\n#Self image resulting from how the individual sees himself or herself\n#Self image resulting from how others see the individual \n#Self image resulting from how the individual perceives others see him or her\n\nThese three types may or may not be an accurate representation of the person. All, some or none of them may be true.\n\n='
p292
tp293
a(I-1
S'{{for|the German [[board game]] award|Spiel des Jahres}}\nGame of the Year (abbreviated GotY) is a distinction awarded by various [[magazine]]s and [[website]]s to a deserving [[Personal computer game|PC]] or [[Console game|console]] [[video game]]. Many publications will award a single Game of the Year to a single title that they feel represents the pinnacle of gaming achievement that year, as well as smaller awards (e.g. Best [[Strategy game|Strategy]] Game or Best [[Shooter game|Shooter]]). Organizations and publications awarding some form of Game of the Year include:\n\n<!-- Deleted image removed: [[Image:InteractiveAchievementAwardOrb.PNG|thumb|right|Academy of Interactive Arts & Sciences Interactive Achievement Award trophy|{{deletable image-caption|1=Tuesday, 15 September 2009}}|{{deletable image-caption|1=Tuesday, 15 September 2009}}]] -->\n*[[Academy of Interactive Arts & Sciences]]\n*[[British Academy Video Games Awards|British Academy of Film and Television Arts]]\n*[[Computer Gaming World]]\n*[[Crispy Gamer]]\n*[[Edge (magazine)|Edge]]\n*[[Electronic Gaming Monthly]]\n*[[Eurogamer]]\n*[[Games (magazine)|Games]]\n*[[GameFAQs]]\n*[[Game Informer]]\n*[[Gamereactor]]\n*[[GameSpot]]\n*[[GameSpy]]\n*[[GameTrailers]]\n*[[G-Phoria]]\n*[[Giant Bomb]] \n*[[IGN]]\n*[[JIVE Magazine]]\n*[[Kotaku]]\n*[[Nintendo Power]]\n*[[PC Gamer]]\n*[[PC World (magazine)|PC World]]\n*[[Pelit]]\n*[[Penny Arcade (webcomic)|Penny Arcade]] \n*[[Play (UK magazine)|Play]]\n*[[Spike Video Game Awards|Spike TV]]\n*[[X-Play]]\n\n==AIAS Overall Game of the Year winners==\n{{Main|Interactive Achievement Awards#Overall}}\n\n==GameSpot Game of the Year winners==\nThe winners of the GameSpot Game of the Year are chosen by GameSpot editors.<ref>[http://www.gamespot.com GameSpot Website]</ref>\n\n{|class=wikitable width=95%\n!Year\n!Game\n!Genre\n!Platform(s)\n!Developer(s)\n|-\n| 2008 || [[Metal Gear Solid 4: Guns of the Patriots]] || [[Action game|Stealth Game]], [[Action game|Action]] || [[PS3]]|| [[Kojima Productions]]\n|-\n| 2007 || [[Super Mario Galaxy]] || [[Platformer]] || [[Wii]] || [[Nintendo]]\n|-\n| 2006 || [[Gears of War]] || [[Tactical Shooter]] || [[Xbox 360]] || [[Epic Games]]\n|-\n| 2005 || [[Resident Evil 4]] || [[Survival horror]], [[Shooter game|Shooter]] || [[GameCube]], [[PS2]] || [[Capcom]]\n|-\n| 2004 || [[World of Warcraft]] || [[MMORPG]] || [[Microsoft Windows|Windows]], [[Mac OS X]] || [[Blizzard]]\n|-\n| 2003 || [[The Legend of Zelda: The Wind Waker]] || [[Action-adventure game|Action-Adventure]] || [[GameCube]]  || [[Nintendo]]\n|-\n| 2002 || [[Metroid Prime]] || [[Action-adventure game|Action-Adventure]] || [[GameCube]] || [[Nintendo]]\n|}\n*From 1996 to 2001, console and PC awards were selected separately. There were no console awards given pre-1998.\n\nPC\n{|class=wikitable width=95%\n!Year\n!Game\n!Genre\n!Platform(s)\n!Developer(s)\n|-\n| 2001 || [[Serious Sam: The First Encounter]] || [[Shooter game|Shooter]] || [[Microsoft Windows|Windows]], [[Linux]] || [[Croteam]]\n|-\n| 2000 || [[The Sims]] || [[Life simulation game]] || [[Microsoft Windows|Windows]], [[Mac OS]], [[Linux]] || [[Maxis]]\n|-\n| 1999 || [[EverQuest]] || [[MMORPG]] || [[Personal Computer|PC]] || [[Sony Online Entertainment]] \n|-\n| 1998 || [[Grim Fandango]] || [[Adventure Game|Adventure]] || [[Microsoft Windows|Windows]] || [[LucasArts]] \n|-\n| 1997 || [[Total Annihilation]] || [[Real-time strategy]] || [[Microsoft Windows|Windows]], [[Mac OS]] || Cavedog Ent.\n|-\n| 1996 || [[Diablo (video game)|Diablo]] || [[Action RPG]], [[Hack and Slash]] || [[Microsoft Windows|Windows]], [[Mac OS]] || [[Blizzard North]]  \n|}\nConsole\n{|class=wikitable width=95%\n!Year\n!Game\n!Genre\n!Platform(s)\n!Developer(s)\n|-\n| 2001 || [[Grand Theft Auto III]] || [[Open world game|Open World]], [[Action game|Action]] || [[PS2]] || [[Rockstar North]]\n|-\n| 2000 || [[Chrono Cross]] || [[Role-playing game|RPG]] || [[Playstation]] || [[Square Co.]]\n|-\n| 1999 || [[Soulcalibur|Soul Calibur]] || [[Fighting game|Fighter]] || [[Dreamcast]] || [[Namco]] \n|-\n| 1998 || [[The Legend of Zelda: Ocarina of Time]] || [[Action-adventure game|Action-Adventure]] || [[Nintendo 64]] || [[Nintendo]] \n|}\n\n==GameSpot Readers Game of the Year winners==\nIn addition to the editors picks, GameSpot also hosts a [[Opinion poll|poll]] for the Readers GOTY\n{|class=wikitable width=95%\n!Year\n!Game\n!Genre\n!Platform(s)\n!Developer(s)\n|-\n| 2008 || [[Metal Gear Solid 4: Guns of the Patriots]] || [[Action game|Stealth Game]], [[Action game|Action]] || [[PS3]]|| [[Kojima Productions]]\n|-\n| 2007 || [[Call of Duty 4: Modern Warfare]] || [[Action game|Action]] || [[PS3]], [[Xbox 360]], [[Personal computer|PC]] || [[Infinity Ward]]\n|-\n| 2006 || [[Gears of War]] || [[Tactical Shooter]] || [[Xbox 360]] || [[Epic Games]]\n|-\n| 2005 || [[Resident Evil 4]] || [[Survival horror]], [[Shooter game|Shooter]] || [[GameCube]], [[PS2]] || [[Capcom]]\n|-\n| 2004 || [[Halo 2]] || [[FPS]] || [[Microsoft Windows|Windows]], [[Xbox]] || [[Bungie]]\n|}\n\n==IGN Game of the Year winners==\nThe winners of the IGN Game of the Year are chosen by the professional editors at IGN. Results are released about two to three weeks into January so all editors have time to play the most highly esteemed games. IGN is the worlds most visited video game web site as of 2008.<ref>[http://www.ebizmba.com/articles/video-games Most visited video game web sites]</ref><ref>[http://www.ign.com IGN Website]</ref>\n\n{|class=wikitable width=95%\n!Year\n!Game\n!Genre\n!Platform(s)\n!Developer(s)\n|-\n| 2008 || [[Fallout 3]] || [[Shooter game|Shooter]], [[Role-playing game|RPG]] || [[Microsoft Windows|Windows]], [[PS3]], [[Xbox 360]] || [[Bethesda Game Studios]]\n|-\n| 2007 || [[Super Mario Galaxy]] || [[Platformer]] || [[Wii]] || [[Nintendo]]\n|-\n| 2006 || [[kami]] || [[Adventure]] || [[PS2]] || [[Capcom]]\n|-\n| 2005 || [[God of War (video game)|God of War]] || [[Hack and slash]], [[Action Game|Action]] || [[PS2]] || [[SCE Studios Santa Monica]]\n|-\n| 2004 || [[Half-Life 2]] || [[Shooter game|Shooter]] || [[Microsoft Windows|Windows]] || [[Valve Corporation]]\n|-\n| 2003 || [[Star Wars: Knights of the Old Republic]] || [[Role-playing game|RPG]] || [[Xbox]], [[Microsoft Windows|Windows]]  || [[BioWare]]\n|-\n| 2002 || [[Battlefield 1942]] || [[Shooter game|Shooter]] || [[Microsoft Windows|Windows]] || [[Digital Illusions CE]]\n|-\n| 2001 || [[Halo: Combat Evolved]] || [[Shooter game|Shooter]] || [[Xbox]] || [[Bungie Studios]]\n|}\n* Pre 2001 awards were limited to specific platforms with no overall winner announced.\n\n==Spike TV VGAs Game of the Year winners==\nSpike TVs Video Game Awards have been presented yearly since 2004. It markets itself in a similar vein to the Oscars except for video games. Initially awards were determined by popular vote, however since 2007 it has redefined itself to be based purely on the vote of industry professionals across the globe including journalists and developers.<ref>[http://www.spike.com/event/vga Spike TV VGAs]</ref>\n\n{|class=wikitable width=95%\n!Year\n!Game\n!Genre\n!Platform(s)\n!Developer(s)\n|-\n| 2008 || [[Grand Theft Auto IV]] || [[Open world game|Open World]], [[Action game|Action]] || [[Microsoft Windows|Windows]], [[PS3]], [[Xbox 360]] || [[Rockstar North]]\n|-\n| 2007 || [[BioShock]] || [[Shooter game|Shooter]] || [[Microsoft Windows|Windows]], [[PS3]], [[Xbox 360]], [[Mac OS X]] || [[2K Boston/2K Australia]]\n|-\n| 2006 || [[Elder Scrolls IV: Oblivion]] || [[Action RPG]] || [[Microsoft Windows|Windows]], [[PS3]], [[Xbox 360]] || [[Bethesda Game Studios]]\n|-\n| 2005 || [[Resident Evil 4]] || [[Survival horror]], [[Shooter game|Shooter]] || [[GameCube]], [[PS2]] || [[Capcom]]\n|-\n| 2004 || [[Grand Theft Auto: San Andreas]] || [[Open world game|Open World]], [[Action game|Action]] || [[PS2]] || [[Rockstar North]]\n|}\n\n'
p294
tp295
a(I1
S'{{Howto|date=May 2008}}\nFigure painting is the [[hobby]] of painting [[miniature figure]]s and/or [[model figure]]s, either in its own right or as an adjunct to [[role-playing game]]s, [[wargame]]s, [[military model]]ing, etc.\n\nBecause of the small scale of these figures, the often finely sculpted detail can be lost by simply applying solid color. Many of special techniques allow the painter to emphasize the detail in the figure and make it come alive.\n\n==Materials==\n===Paints===\nMost hobbyists use [[acrylic paint]], maybe [[artist]]s paint (such as [[Daler Rowney]]s Cryla) but more often that sold especially for painting minis and other scale models (such as Acrylicos Vallejos Model Color and Game Color or [[Games Workshop]]s Citadel Colour). Some mini painters use [[enamel paint]] (e.g., [[Humbrol]] or Testors) or even artists [[oil paint]].  Some hobbyists use synthetic [[Lacquer]] paints, such as Gunze-Sangyos Mr. Color paint line.  Lacquer paints are less commonly available in the United States due to safety issues.\n\nBecause the properties of oils, enamels, lacquers, and acrylics differ, different techniques (see below) suit different paints.\n\n===Thinners===\nEach kind of paint has a different thinner, used to thin the paint for a smoother coverage, and maybe to clean brushes.\n* acrylic: water\n* enamel: enamel thinners or white spirit\n* lacquer: lacquer thinner\n* oil: white spirit\n\nThinners for thinning should be kept separate from thinners for cleaning to avoid contaminating one color with another. Ideally, thinners for thinning should be added to the paint using an eye-dropper ([[pipette]]) or something similar; paint brushes must be kept out of the thinners bottle!\n\n===Inks===\nWater-based inks can be used for washes (see below).\n\n===Agents===\nDifferent agents can be used with different kinds of paint.\n* retarder: makes paints slower drying\n* flow aid: used with acrylics and inks, this reduces the surface tension of the water, to improve washes\n\n===Varnishes===\nFigures are very often [[varnish]]ed (especially if they will be used for game play). \n\nGloss varnishes are harder wearing than matte varnishes, but matte varnish often gives a more realistic finish. (Exceptions are naturally glossy materials, such as polished leather and metals,  and wet surfaces.) Some enthusiasts use matte varnish over gloss varnish. This can also minimize the tendency of matte varnish to form a whitish residue when applied directly to paint.\n\n==Tools==\n===Brushes===\nSculptors can pack an incredible amount of detail into these figures, and painting may require the finest [[brush#Artists brushes|brush]]es... maybe as fine as 00000 (5/0). Most painters will use a range of different brush sizes; 1, 00, and 0000 is a likely minimum set. \n\nGood quality brushes are important for the best results. [[Kolinsky sable]] brushes that take a fine point are preferred, although hog or synthetic brushes are better for rough work: undercoating and dry brushing (see below). \n\nAn [[Airbrush]] is also a commonly used tool.  Airbrushing facilitates leveled painting surfaces and allows for effects like gradiants and soft blended edges.  Because of the detail work involved, airbrushes with a small tip diameter are considered more useful.\n\n===Brush care===\nThe number one rule is to clean brush frequently and thoroughly to avoid contamination of one color with another.  For other brush care, see [[brush]].\n\n===Palettes===\nA palette is essential for mixing and thinning paints before application. It doesnt have to be elaborate: a plain [[ceramic]] [[tile]] will do. But it should be non-porous to avoid sucking the solvent out of the paint. \n\n===Wet palette===\nA wet palette is especially useful with acrylics that dry quickly on a dry palette. A wet palette is a sealable container with a layer of absorbent material (such as tissue paper) that can be soaked with water and a [[semi-permeable membrane]] (such as [[greaseproof paper]] or [[baking paper]] (silicone paper)) over that. The paint sits on the membrane and is kept wet by [[osmosis]].  Wet palettes can be bought, but are easily made.\n\n==Techniques==\n===Undercoating===\nUndercoating, commonly known as priming, is essential to good results. It provides a better surface for the paint to adhere to and  with [[white metal]] minis  inhibits corrosion of the alloy.\n\nThe undercoat may be any color. Some painters always use black, which provides the deepest shadows in hard-to-reach areas that later painting might miss, but which can be difficult to cover with paler colors.\n\n===Highlighting and shading===\nHighlighting and shading are complementary techniques used to emphasize the light and shade across the surface texture of the figure, such as creases and folds in fabric, fur, etc.\n\nHighlighting is the application of lighter tones than the base color to raised areas. Shading is the application of darker tones to recessed areas.\n\n===Blending===\nBlending ensures the smooth transition of the different tones into one another to improve the verisimilitude of the faux light and shade. This different tones are simply worked into one another  on the figure while the paint is still wet.\n\nBlending works well with enamels (and oils) but not with acrylics, which dry too quickly, unless a retarder is used.   \n\n===Layering and feathering===\nThe same effect as blending can be achieved with acrylics by applying successive layers of color in smaller and smaller areas (feathers). The layers of paint build up a hill of successively lighter (or darker) tones.\n\n===Dry brushing===\nDry brushing is a highlighting technique that works especially well with finely textured surfaces such as fur, feathers, and [[chainmail]]. After applying the base color and initial highlighting and shading, a very light tone is applied by lightly dragging an almost-dry brush across the surface.\n\n===Using washes===\nWashes of thinned paint or inks can be used to fill in the shadows.\n\n===Toning===\nA very diluted transparent layer of color can be applied to soften harsh contrasts.\n\n===Outlining and edging===\nOutlining is painting a  solid dark thin line that separates areas and defines details by acting as a bold shadow. The darkest tone should be used. Black gives the greatest contrast and might suit minis rather than larger-scale model figures; this would be blacklining.   \n\nEdging is a less-often used complementary technique with the lightest tone.  \n\n===Painting metals===\nMetallic paints are available in all kinds of paint and can be used for metals. Some blending etc. may be required; for example, gunmetal might be highlighted with silver. Black or brown ink washes can provide suitable shading and can be particularly effective for large areas of metal such as plate [[armour]].  Most of these paints, however, are relatively dull and lack the lustre of true metal. \n\nSome painters use [[alcohol]]-based metallic paints that have a brilliant finish... but these need to be used with care, especially in conjunction with acrylics, as contact with water can cause tarnishing.  \n\nBright steel can be achieved with [[white metal]] and [[pewter]] figures by burnishing and gloss varnishing the unpainted metal. This works particularly well with swords, axes, etc.\n\n===Non-metallic metals (NMMs)===\nMany painters prefer to simulate the appearance of metals using non-metallic paints. \n\nFor example, steel can by mimicked by using various shades of grey from black to white. The aim is not to define light and shadow but the play of light across a polished surface. This is really the same technique that [[airbrush]] artists might use to simulate a [[glossy]] surface, but applied to a 3D model.\n\n==Competition==\nSome figure producers promote Figure painting through competition.  As an example, [[Games Workshop]] runs their [[Golden Demon]] competitions at Games Day events, which is restricted to Games Workshops own figures or scratch-built figures for Games Workshop game settings.\n\n'
p296
tp297
a(I-1
S'{{Infobox Magazine\n|              title =16 Magazine\n|             editor = Gloria Stavers\n|       editor_title = Editor-in-Chief\n|          frequency = Quarterly\n|           category = [[Teen magazine]]\n|          firstdate = May 1957\n|            country = {{USA|US}}\n|           language = [[USA|English]]\n\n}}\n\n{{Unreferenced|date=April 2008}}\n16 Magazine was a [[fan magazine]] based out of [[New York City]]. It was the first magazine marketed to [[adolescents]] that focused exclusively on celebrities.{{Fact|date=February 2007}} 16 Magazine is sometimes credited by those in the publishing and entertainment industries{{Who|date=March 2009}} as a primary influence in shaping rock [[journalism]].\n\n==Origins==\n\nFounded in 1956, the first issue hit the newsstands in May 1957, with [[Elvis Presley]] on the cover.{{Fact|date=February 2007}} It was published quarterly.{{Fact|date=February 2007}} The cost was 15 cents an issue. The magazine was, initially, edited by men writing under female [[pseudonyms]],{{Fact|date=February 2007}} and it closely followed the style of more traditional [[movie magazines]] such as [[Photoplay]]. \n\nHowever, its longtime editor in chief, former [[fashion model]] and subscriptions clerk, [[Gloria Stavers]], transformed the magazine from a standard general interest movie magazine into a major fan magazine that focused on the pre-teen female as its primary readerbase. Stavers was the editor in chief from 1958 until 1975.{{Fact|date=February 2007}} She chose to cater to that particular [[demographic]] because of the many [[fan letter]]s she had read from girls aged nine through 12 who were writing to popular celebrities in care of the magazine. She remembered how she felt at that age,[http://weeklywire.com/ww/06-14-99/austin_music_feature1.html]and she developed a formula as to how to increase the readership of the magazine within that demographic.\n\n==Content==\n\nThe magazine covers attracted readers by featuring sensational and [[hyperbole]]-laden headlines such as The Day He Almost DIED!, head shots of various male actors and singers, and very whimsical artwork. Although the newsprint type of paper was used for the articles, the magazine did feature colorful, glossy [[pin-up]] poster art. Many pre-teens purchased 16 Magazine primarily for the posters, rather than the articles,{{Fact|date=February 2007}} and those posters often helped to bolster, and in some cases hinder, the careers of many [[teen idols]].{{Fact|date=February 2007}}\n\nPrior to the 1970s, most of the [[pin-ups]] of the celebrities were kept clean cut, but the magazine began to increasingly sexualize the posters they featured, in keeping with the more permissive times. 16 Magazine also often offered contests that would give the winning person an opportunity to have a meet and greet with their favorite performer.\n\nMost of the articles and features tended to lean on the lighter side. Rather than asking the artist serious questions about musical influences and [[social issues]], it would offer the readers interviews asking a celebrity about his favorite color or meal, or would have him describe his ideal girl or dream date. If the celebrity was married, in a long term relationship or was not [[heterosexual]] in orientation, that information was kept out of the magazine, as was any news about the celebrity that even hinted at scandal. \n\nHowever, there were times when 16 Magazine did push the envelope in its content, such as when Stavers published an obituary for her friend, the controversial comedian [[Lenny Bruce]].{{Fact|date=February 2007}} She also attempted to expand the perception of teen idols by featuring such unlikely candidates as [[Star Trek]] actor [[Leonard Nimoy]] and [[shock rock]] pioneer [[Alice Cooper]].\n\nIn 1997, in honor of its 40th year of publication, former 16 magazine editors Randi Reisfeld and music critic [[Danny Fields]] published the commemorative book Whos Your Fave Rave?. It is a history of the magazine, and a [[biography]] on its long-time editor in chief. It was styled to resemble an issue of the magazine. There was also an accompanying [[CD]] of the same name, featuring many of the pop acts promoted in the magazine throughout the years.\n\n==No Advertising Policy==\n\nDespite the lack of serious journalistic content and fierce competition from [[Tiger Beat]] and other celebrity magazines, 16 remained the top selling teen celebrity magazine for many years. They accomplished this feat without accepting any outside advertising.{{Fact|date=February 2007}} Even without advertising revenue, at the height of its popularity, 16 Magazine had more than 5,000,000 readers.{{Fact|date=February 2007}}\n\nFor at least 30 years of publishing, 16 Magazine was entirely self-supporting. The no advertisements policy changed when 16 Magazine was acquired by [[Primedia]] in the 1990s.{{Fact|date=February 2007}} In 2001, 16 became part of their Teen Magazines groups and is considered a monthly specials issue focusing on a specific topic or act. \n\nDespite this, no regular or special issue of 16 Magazine was seen or published since--not even a website.  By this time, newer teen magazines had taken over like J14, M Magazine, Popstar! Magazine, and the resurrected [[Tiger Beat]].  \n\n==Celebrities featured and promoted in 16 Magazine==\n===1950s===\n\nIn the 1950s, some of the teen idols featured in the pages of 16 Magazine included [[Elvis Presley]], [[Paul Anka]], [[Dion DiMucci|Dion]], and [[Mousketeer]] [[Annette Funicello]].\n\n===1960s===\n\nDuring the 1960s, 16 magazine introduced its readers to a variety of rock and roll/pop music acts, referred to by the editor and readers as Faves. Some of those acts include the [[Beatles]], [[Hermans Hermits]], [[Paul Revere and the Raiders]],[[The Monkees]], [[Jim Morrison]], and [[The Doors]]. The appearance of the faves was highly selective. Other acts such as the [[Rolling Stones]] were virtually ignored by 16 Magazine, as were many of the popular [[Motown]] acts.\n\n===1970s===\n\nIn the 1970s, the magazine began focusing its attention primarily on [[bubblegum music|bubblegum]] and pop acts, such as the [[Osmond Brothers]] (with particular emphasis on [[Donny Osmond]]), [[David Cassidy]], [[Bobby Sherman]], [[The Bay City Rollers]], [[Rick Springfield]] and other performers. With the exception of [[The Jackson 5]] and [[Sajid Khan]], racial minorities were seldom featured on the covers.{{Fact|date=February 2007}} The appearance of female celebrities on its covers was also rare, but from time to time, a female star such as [[Maureen McCormick]] or [[Karen Carpenter]] might write the occasional beauty or dating advice column for the magazine.\n\n===1980s and Beyond===\n\nDuring the 1980s and well into the 1990s, the magazine continued to serve up one [[boy band]] after another, from [[New Wave music|New Wave]] artists like [[Duran Duran]] to [[NSync]]. However, [[Destinys Child]] broke the [[Race (classification of human beings)|racial]] and [[gender]] barrier when they appeared on the cover.\n\n'
p298
tp299
a(I-1
S'{{wikify|date=September 2009}}\n{{orphan|date=September 2009}}\nDirect Behavior Rating (DBR) is a category of social behavioral assessment frequently used by school psychologists and teachers to monitor student behavior.  Direct behavior ratings typically involve four steps:\n# specifying a target behavior that one wishes to monitor\n# rating that behavior following a specified observation period\n# sharing the obtained information across individuals (e.g., parents, teachers, students)\n# utilizing the outcome data to monitor the target behavior over time<ref>{{cite book|last=Chafouleas|first=S.M.|coauthors=Riley-Tillman, T.C., & Sugai G.|year=2007|title=School Based Behavior Assessment: Informing Instruction and Intervention|location=New York, NY|publisher=The Guilford Press}}</ref><ref>{{cite journal|last=Chafouleas|first=S.M.|coauthors=Riley-Tillman, T.C., & McDougal, J.|year=2002|title=Good, bad, or in-between: How does the daily behavior report card rate?|journal=Psychology in the Schools|volume=39|pages=157-169}}</ref>  \n\nDirect Behavior Ratings combine positive aspects of other behavior collection systems including the specificity of systematic direct observation and the flexibility of behavior rating scales in order to create a measure that is feasible for teachers, parents, and other school professionals to use in order to rate student behavior.  According to a recent survey, over 60% of classroom teachers report that they employ DBR or a DBR-like tool within their classrooms and view it as a highly acceptable intervention tool.<ref>{{cite journal|last=Chafouleas|first=S.M.|coauthors=Riley-Tillman, T.C., & Sassu, K.A.|year=2006|title=Acceptability and reported use of Daily Behavior Report Cards among teachers|journal=Journal of Positive Behavior Interventions|volume=8|pages=174-182}}</ref>  Recent research further indicates the acceptability of the meaure to school psychologists who are frequently responsible for monitoring the effectiveness of reserach-based classroom interventions.<ref>{{cite journal|last=Riley-Tillman|first=T.C.|coauthors=Chafouleas, S.M., & Eckert, T.|year=2008|title=Daily Behavior Report Cards and Systematic Direct Observation: An Investigation of the Acceptability, Reported Training and Use, and Decision Reliability among School Psychologists|journal=Journal of Behavioral Education}}</ref>\n\nDirect behavior ratings may vary according to the type of behavior to be rated (e.g., academic or social), rating frequency (e.g., daily, weekly), rater (e.g., child, teacher), etc.  \n\n'
p300
tp301
a(I1
S'The Berlin Method of biological [[filtration]] is a method for maintaining a clean and stable environment within a [[saltwater aquarium]], typically a [[coral reef]] system.  This method relies on the use of ample [[live rock]] (rock with live marine organisms and bacteria on or in it). The theory is that [[Aerobic organism|aerobic]] [[bacteria]] covering the surface of the porous live rock and sand convert harmful [[ammonia]] (from fish and invertebrate waste) into [[nitrites]], then [[nitrates]], which are much less harmful to the tanks inhabitants.  Through the process of [[diffusion]], the [[nitrates]] move deep within the rock where they are converted by [[Anaerobic organism|anaerobic]] [[bacteria]] to free [[nitrogen]] gas.  Left over [[nitrates]] are removed through regular partial water changes. As an added measure, a [[protein skimmer]] is used to remove some of the dissolved organic compounds before they break down into [[ammonia]].\n\nThe typical [[rule of thumb]] is to use from  1-2 [[pound (mass)|lb]] (.45 to .9 [[kilogram|kg]]) of [[live rock]] per gallon (US) (~ 4 liters) of aquarium water depending on the density of the rock  or filling the tank up 2/3 of the way to the top.  The benefit of using [[live rock]] is fourfold: First, live rock acts as a biological filter, adding beneficial bacteria.  Secondly, it introduces an abundance of marine life into the aquarium that many [[fish]], [[invertebrates]] and [[corals]] use for food.  Thirdly, it provides a natural reef appearance with ample places to locate corals. Lastly, live rock will also help balance and stabilize [[PH]] in the aquarium.\n\nCalcium, alkalinity and other trace elements which are consumed by corals, are replaced through water changes (using natural seawater or a quality synthetic salt mix) or the use of a [[calcium reactor]], kalkwasser (calcium water) or a balanced two-part solution.\n\n{{Aquarium}}\n{{Expand|date=September 2008}}\n\n'
p302
tp303
a(I1
S'{{Cleanup|date=January 2009}}\n\nZack Hample (born [[September 14]], 1977) is a [[New York City|New York]] based writer and [[Major League Baseball|Major League]] baseball collector. In 1999, he published the book How to Snag Major League Baseballs, and in 2007 he finished Watching Baseball Smarter, a detailed guide to the intricacies of the game of baseball, which was the eighth best selling American sports book of the year. Hample wrote part-time for minorleaguebaseball.com from 2005 to 2007 and contributed the foreword for Major League Baseball: An Interactive Guide to the World of Sports in 2008. His third book, tentatively titled The Baseball: Five Ounces and 108 Stitches of Glory, will be published by [[Vintage Books]] in March 2011.\n\nAs of [[October 9th]], 2009, Hample has collected 4,352 baseballs from 46 different Major League stadiums. He acquired his first Major League baseball from a Mets reliever at [[Shea Stadium]] on [[June 20]], 1990, snagged his 3,000th ball by using his famous baseball glove trick at [[Yankee Stadium]] on [[May 7]], 2007, and set a personal, one-game record with 32 baseballs at [[Kauffman Stadium]] on [[June 18]], 2009. Hample caught [[Barry Bonds]] 724th career home run at [[PETCO Park]] on [[August 16]], 2006 and caught the first home run of the [[2007 Home Run Derby]], hit by [[Justin Morneau]] at [[AT&T Park]].\n\nDuring the final week ever at Yankee Stadium, Hample gained worldwide recognition by catching home run balls on consecutive nights. On [[September 16]], 2008, he made a leaping catch on a [[Jason Giambi]] home run and immediately celebrated with a goofy dance that was captured by the TV cameras. The following night, in nearly the exact same spot in the right field bleachers, Hample reached far over a railing to make a backhanded catch on a [[Johnny Damon]] home run ball and celebrated with the same dance. The Yankees announcers quickly recognized him from the previous game, and within the next 24 hours the story was covered by ESPN, CBS, NBC, FOX, CNN International, and many other media outlets. Yahoo! Sports initially acknowledged Hamples snagging skills, but did not know that it was him who made the catches. <ref>[http://sports.yahoo.com/mlb/blog/big_league_stew/post/Yankees-fan-in-right-place-at-right-time-on-two-?urn=mlb,108739 Fan In Right Place at Right Time on Two Straight Nights] (Yahoo! Sports)</ref>\n\nOn September 28, 2008, Hample caught the last ever New York Mets home run hit at Shea Stadium, this one hit by [[Carlos Beltran]].<ref>[http://blogs.wsj.com/numbersguy/another-unlikely-but-not-that-unlikely-home-run-catch-422/ Another Unlikely (But Not That Unlikely) Home-Run Catch] (The Wall Street Journal)</ref> On October 8, Hample made an appearance on [[The Tonight Show]] with [[Jay Leno]]. One year later on October 9th, he appeared on [[The Tonight Show]] with [[Conan OBrien]]. Prior to his three notable home run catches of 2008, he had been featured on [[The Rosie ODonnell Show]], the [[CBS Evening News]] with [[Katie Couric]], and on an episode of the [[John OHurley]] version of the game show [[To Tell The Truth]], during which he managed to trick the audience and two of the four celebrities. <ref>[http://www.youtube.com/watch?v=jeSBG9qK-SQ Appearance on To Tell The Truth] (YouTube)</ref>\n\nHample, a competitive video game player, appeared briefly in the 2007 documentary [[The King of Kong: A Fistful of Quarters]]. According to [[Twin Galaxies]], he holds official world records on half a dozen classic video games including [[Breakout (arcade game)|Breakout]] (896 points)<ref>[http://www.twingalaxies.com/index.aspx?c=22&pi=2&gi=799&vi=672 All-time Breakout high scores] (www.twingalaxies.com)</ref> and [[Arkanoid]] (1,658,110 points)<ref>[http://www.twingalaxies.com/index.aspx?c=22&pi=2&gi=947&vi=639 All-time Arkanoid high scores] (www.twingalaxies.com)</ref>.\n\n'
p304
tp305
a(I1
S'An electronic [[kit]] is a package of [[electrical components]] used to build an [[electronics|electronic]] [[machine|device]].  Generally, kits are comprised of electronic components, a circuit diagram (schematic), assembly instructions and often a PCB. People primarily purchase electronic kits to have fun and learn how things work. They were once popular as a means to reduce the cost of buying goods, but there is usually no cost saving in buying a kit today.\n\nSome kits used to be quite complex devices such as color [[television]] set, [[oscilloscope]]s, high end [[audio amplifier]]s and even computers such as the [[Heathkit]] [[Heathkit H-8|H-8]], and the [[LNW-80]].  Many of the early [[microprocessor]] computers where sold as either electronic kits or assembled and tested. \n\n[[Heathkit]] sold millions of electronic kits during its 45 year history.\n\nToday, building devices from scratch for hobbyists and beginners has fallen in popularity due to the emerging complexity of miniature electronics and embedded software. People still build custom devices and special purpose electronics for professional and educational use, and as a hobby.\n\nAlso emerging is a trend to simplify the complexity by providing pre programmed or modular kits and this is provided by many suppliers online often. The fun and thrill of making your own electronics has shifted in many cases from easy to comprehend application and analog devices to more sophisticated and digital devices.\n\n==Examples==\n*The [[Altair 8800]], (the first [[home computer]]), was also sold as a kit, as were the [[Sinclair ZX80]], [[Sinclair ZX81]] and [[Acorn Atom]] computers.\n*Many [[S100 bus]] [[Expansion card|system cards]] were sold only as kits.\n*Building a [[Robot kit]], most often with a [[micro controller]] inside, is now in fashion. \n\n'
p306
tp307
a(I-1
S'{{Inappropriate tone|date=May 2008}}\nIn [[futures studies]], especially in Europe, the term foresight has become common as of 2005, embracing activities of \n\n* [[critical thinking]] concerning long-term developments, \n* [[debate]] and effort to create wider [[participatory democracy|participation in decisions]], \n* [[anticipatory democracy|shaping the future]], especially by influencing [[public policy]] and [[strategic management|strategic decisions]] (European Commission Foresight Website 2005; FOREN project; FORERA [http://forera.jrc.es/index.html]).\n \nto make an impact (shaping the future).\n\nIn the last decade, scenario methods, for example, have become widely used in some European countries in policy-making (van Steenbergen 2005). the FORSOCIETY network [http://www.eranet-forsociety.net/ForSociety/index.html] brings together national Foresight teams from most European countries, and the European Foresight Monitoring Project [http://www.efmn.info/index.shtml?s=560FF9CB-7D7224212830-641C] is collating material on Foresight activities around the world.  In addition, foresight methods are being used more and more in [[regional planning]] and decision making (regional foresight). At the same time, the use of foresight for companies (corporate foresight) is becoming more professional and widespread (Ratcliffe 2005, Neef/Daheim 2005). It is not only used in strategy development, but also increasingly in innovation development as well as marketing and generally in R&D.\n\nForesight differs from much futures research and [[strategic planning]].  It encompasses a range of approaches that combine the three components mentioned above, which may be recast as: \n\n\tfutures (forecasting, forward thinking, prospectives), \n\n\tplanning (strategic analysis, priority setting), and \n\n\tnetworking (participatory, dialogic) tools and orientations.  \n\nMuch futures research has been rather [[Ivory Tower|ivory tower]] work, but Foresight programmes were designed to influence policy - often R&D policy.  Much technology policy had been very elitist; Foresight attempts to go beyond the usual suspects and gather widely distributed intelligence.  These three lines of work were already common in Francophone futures studies going by the name la prospective.  But in the 1990s we began to see what became an explosion of systematic organisation of these methods in large scale TECHNOLOGY FORESIGHT programmes in Europe and more widely.  Foresight thus draws on traditions of work in long-range planning and strategic planning, horizontal policymaking and democratic planning, and participatory futures studies - but was also highly influenced by systemic approaches to innovation studies, science and technology policy, and analysis of critical technologies.  \n\nMany of the methods that are commonly associated with Foresight - Delphi surveys, scenario workshops, etc. - derive from the futures field.  So does the fact that Foresight is concerned with:\n\n\tThe longer-term - futures that are usually at least 10 years away(though there are some exceptions to this, especially in its use in private business).   Since Foresight is action-oriented (the planning link) it will rarely be oriented to perspectives beyond a few decades out (though where decisions like [[Aeronautics|aircraft design]], [[power station]] construction or other major infrastructural decisions are concerned, then the [[planning horizon]] may well be half a century).\n\n\tAlternative futures: it is helpful to examine alternative paths of development, not just what is currently believed to be most likely or business as usual. Often Foresight will construct multiple scenarios.  These may be an interim step on the  way to creating what may be known as positive visions, success scenarios, aspirational futures.  Sometimes alternative scenarios will be a major part of the output of Foresight work, with the decision about what fuure to build being left to other mechanisms. \n\nForesight[http://www.emeraldinsight.com/info/journals/fs/fs.jsp] is also the name of a journal active in this field; and the term is used in the name of the International Journal of Foresight and Innovation Policy[http://www.inderscience.com/browse/index.php?journalID=78].  The latter journal has played a useful role in documenting activity in Foresight programmes that was previously recorded in a wide variety of locations.\n\n'
p308
tp309
a(I-1
S'Retrogaming, also known as classic gaming and old-school gaming, is the [[hobby]] of playing and collecting older [[computer game|computer]], [[video game|video]], and [[arcade game]]s. These games are played either on the original [[hardware]], on modern hardware via [[emulator|emulation]], or on modern hardware via [[Porting|ports]] or compilations. Participants in the hobby are sometimes known as retro gamers in the [[United Kingdom]], while the terms classic gamers, or [[old school]] gamers are more prevalent in the [[United States]]. Similarly, the games are known as retrogames, classic games, or old school games. Retrogaming is often linked to, although not the same as, [[indie gaming]], the hobby of playing games that are not published by any conventional publisher.<ref>\n{{cite web\n|url=http://arstechnica.com/articles/columns/game/gars-07142004.ars\n|title=NES Classics: retro gaming, at a price: Page 1\n|publisher=arstechnica.com\n|accessdate=2008-04-14\n|last=\n|first=\n}}\n</ref>\n\n== Games ==\nAmong the most popular retro games are those produced around the 1980s{{Fact|date=January 2009}}, and include games for the [[Atari 2600]], [[Commodore 64]], [[MSX]], [[ZX81]]. [[ZX Spectrum]], [[Amstrad CPC]], and the [[Nintendo Entertainment System]]. [[Arcade games]] are also popular, especially early games by [[Konami]], [[Sega]], [[Atari]], and [[Williams Electronics]]. Games in this era were frequently attributed to individual programmers, and many retro gamers seek out games by particular developers, such as [[Eugene Jarvis]], [[Dave Theurer]], [[Jeff Minter]], [[Tony Crowther]], and [[Andrew Braybrook]]. Some games are played on the original hardware; others are played through [[emulator|emulation]], and in some cases entirely new versions of the games are written (so-called retro remakes).\n\nAs well as playing games, a subculture of retrogaming has grown up around the music in retro games. Since older hardware did not have the facility to play music CDs or sampled music, the music in many retro games had to be synthesised on the fly by the game hardware; writing music for these platforms therefore became a hybrid of traditional music composition and programming. One of the most popular genres is [[MOS Technology SID|SID]] music, music written to be synthesised by the [[Commodore 64]]. As with programming, attribution to individual composers is commonplace and more easily assigned; popular composers include [[Rob Hubbard]], [[Martin Galway]] and [[Chris Hlsbeck]].\n\nVarious compilations of retro games have been published for modern [[video game console]]s in recent years. Examples include compilations of retro games by [[Sega]], [[Taito Corporation|Taito]], [[Midway Games|Midway]], [[Capcom]], and [[Namco]]. Retrogame compilations for the [[PlayStation 2]] and [[Xbox]] usually feature 10 to 30 games each. In addition, [[TV game|plug-and-play units]] (simple systems that look like a [[game controller]] and feature built-in games) released in North America have featured retrogames by [[Electronic Arts]], Sega, [[Atari]], and several other game publishers. Moreover, illegal (unlicensed) plug-and-play systems featuring retro games for the [[NES]] have made their way to shops all over the world from [[China]] in recent years.<ref>[http://www.usatoday.com/tech/news/2004-10-29-nintendo-piracy-busts_x.htm USATODAY.com - Nintendo: Seattle-area piracy case tip of the iceberg<!-- Bot generated title -->]</ref> The British based company [[Alten8]] has in the recent past licensed nearly 600 retro games (such as the first ever isometric 3D game [[Ant Attack]], and also what are recognized as the first ever commercial games by Scott Adams), and is now starting to release these on formats such as [[Personal computer|PC]], [[Game Boy Advance|GBA]], and [[Wii]], with legally licensed emulators for machines such as the Commodore 64 and Amiga computers. Console makers now allow players to purchase retro games though online services such as the [[Virtual Console]], [[Xbox Live Arcade]] and the [[PlayStation Store]]. The [[Sega Mega Drive Handheld]] which contains 20 Sega Mega Drive games, was also recently released.\n\n==Modern retro==\nIn the wake of increasing nostalgia and the success of retro-compilations in the sixth and seventh generations of consoles, retrogaming has become a [[Motif (visual arts)|motif]] in modern games, as well. Modern Retro games will impose limitations on color palette, resolution, and memory well below the actual limits of the hardware in order to mimic the look of older hardware. These may be based on a general concept of retro, as with [[Cave Story]], or an attempt to imitate a specific piece of hardware (as with [[La Mulana]] and its [[MSX]] color palette). \n\nModern retrogaming began to gain traction thanks in part to the independent gaming scene, where the short development time was attractive and commercial viability was not a concern. More recently major publishers have started to embrace modern retro with releases like [[Mega Man 9]] (an attempt to ape NES hardware), [[Retro Game Challenge]] (a compilation of new games on faux-NES hardware, and Segas [[Fantasy Zone II]] remake, which actually used emulated [[System 16]] hardware running on [[PlayStation 2]] to create a 16-bit reimagining of the 8-bit original. \n\nModern retro may sometimes be more broadly applied to games that feature retro-style designs with more modern graphics, like [[Pac-Man: Championship Edition]] or [[Space Invaders Extreme]].\n\n'
p310
tp311
a(I1
S'{{POV|date=December 2007}}\n\nHermit kingdom is a label that Westerners have often applied to Korea, particularly to the [[Joseon period|Joseon]] dynasty and to contemporary [[North Korea]]. The claim that Korea was a hermit kingdom has increasingly been seen as erroneous in recent times.  However, the term is still in common currency throughout Korea and is often used by Koreans themselves to describe pre-modern Korea.\n\nThe first documented use of hermit to refer to Korea is in the title of [[William Elliot Griffis]] 1882 book, [[Corea: The Hermit Nation]].  The writer of the book had never visited Korea, did not speak the language, and had no first-hand experience with the country. He supported the invasion and occupation of Korea by Japan, and in his works often attempted to prove the superiority of Japan. The publication of The Hermit Kingdom, and its circulation, particularly in North America, led to tacit approval of Japans incursions into Korea.  It was used to justify Japanese actions by showing the Korean people as primitive, uncultured, unable to function internationally, and needing Japanese direction.\n\nThe expression quickly gained currency in Western discussions of Korea.  As early as Carpenters Geographical Reader of Asia (NY, America Book Company, 1897) reference is made to the hermit nation which is largely controlled by Japan. Comments are also made that Koreans until lately driven travellers away from their shores; and that the United States...opened Korea to the rest of the world. \n\n<!-- Empty headings, to be filled out maybe?\n\n==Background==\n===Korean foreign relations===\n\n===Korean international relations===\n\n===Korean relations with the West before 1900===\n-->\n\n'
p312
tp313
a(I1
S'[[Image:Jean-Baptiste Moens.jpg|thumb|Jean-Baptiste Moens, 1887]]\nJean-Baptiste Philippe Constant Moens ([[27 May]] [[1833]][[28 April]] [[1908]]) was a [[Belgium|Belgian]] [[philatelist]] recognized as the first [[stamp dealer|dealer in stamps for collectors]].<ref>[http://www.helenmorgan.net/bm/biogs/E000073b.htm Helen Morgan, Moens, Jean-Baptiste (1833-1908), Blue Mauritius Research Companion]</ref> He was one of the original [[philatelic literature|philatelic journalists]].\n\n== Youth ==\nMoens began [[stamp collecting|collecting stamps]] from his familys mail as a boy in [[Tournai]]. He was the son of Colette Blangenois and Phillipe Moens, a soldier. He began with a small business in coins. By 1853, at age nineteen, he was buying and selling new and second-hand books, and [[Postage stamp|stamps]], from the [[Galerie Borthier]], a covered walkway in central [[Brussels]]. Within a decade he was putting out a [[stamp catalog]] with illustrated supplements.\n\n== First catalog ==\nIn March, 1862, with Louis Francois Hanciau, Moens published a catalog of stamps, the Manuel des collectionneurs de timbres-poste (Handbook for Stamp Collectors). This work is the first of its kind in Belgium and the second in the French language, following that of the Parisian, [[Alfred Potiquet]]. Also in 1862, he published De la falsification des timbres-poste (On the falsification of postage stamps) to alert stamp enthusiasts to the abundance of [[Philatelic fakes and forgeries|forgeries]]. He began the first French language philatelic monthly, Le Timbre-poste, which ran from 1863 until 1900, as well as a series on [[revenue stamp|fiscal stamps]] from 1874 until 1896.<ref>[[:fr:Jean-Baptiste Moens|Jean Baptiste Moens, French Wikipedia]]</ref>\n\n== The Mauritius Post Office stamps ==\nMoens became the owner of eight of the [[Mauritius Post Office|Post Office Mauritius stamps]]. In 1878 Moens published the first of his works on the early stamps of Mauritius, Les Timbres de Maurice depuis leur origine jusqu nos jours, (The Stamps of Mauritius from their Origin until Today), benefiting from the studies of [[Edward B. Evans]], the [[Royal Philatelic Society London|Philatelic Society of London]], and Judge Frederick Adolphus Philbrick. Helen Morgan noted, All that is known of the discovery of the first specimens of the Post Office issue, indeed of much of the history of the handful of those stamps eventually found, came from his pen in the late 1890s. He handled most of the Post Office stamps discovered by Madame Borchard in the late 1860s.\n\n== Retirement ==\nAs Moens business prospered, he assembled a large stock of collectibles of all kinds and a library devoted to music and antiquities, as well as stamps. By [[November 1]], [[1899]], to preserve his health, Jean-Baptiste announced in Le Timbre-poste that the time had come to free himself from the duties of publication and to liquidate most of his stock in trade.<ref>[http://web.archive.org/web/20050828172529/http://student.ulb.ac.be/~charveng/moens/biograph.htm Christelle Harvengt, Biography, web.archive.org] (Retrieved 2008-04-02)</ref> Moens collections were sold the following year and his [[Philatelic literature|philatelic publications]] were eventually sold to [[H. Edgar Weston]], in London, in 1907.\n\n== Death ==\nJean-Baptiste Moens died in [[Ixelles]] in 1908 and was interred there in the [[Ixelles Cemetery]]. His passing was noted by the philatelic press, many referring to him as The Father of Philately.\n\n'
p314
tp315
a(I1
S'In [[marine aquarium|marine]] and [[reef aquarium]]s, a calcium reactor is a device used to create a balance of [[Alkali|alkalinity]] in the system. An acidic solution is produced by injecting [[carbon dioxide]] into a chamber with [[seawater|salt water]] and [[calcium]] rich media. The carbon dioxide lowers the [[pH]], [[solvation|dissolving]] the calcium media, and producing a solution high in [[carboxylic acid]].  The effluent is then returned to the [[reef aquarium]] where the calcium is consumed by organisms, primarily [[coral]]s when building skeletons.  A calcium reactor is one of the most efficient methods of supplying calcium to a reef aquarium.\n\n==Reaction==\nThe objective is to dissolve the calcium laden media to provide both bicarbonates HCO<sub>3</sub><sup>-</sup> (alkalinity) and calcium (Ca<sup>++</sup>) ions at the sames rate as consumed during calcification. Effectively dissolving the media requires an acidic pH. Saltwater typically has a pH of at least 7.8, so to reduce the pH carbon dioxide (CO<sub>2</sub>) is used. The general reaction form is: \n\nCaCO<sub>3</sub> + H<sub>2</sub>O + CO<sub>2</sub> <> Ca<sup>2+</sup> + 2HCO<sub>3</sub><sup>-</sup>\n\n==Design and operation==\n===CO<sub>2</sub> Chamber===\nInside the reaction chamber, a calcium rich media ([[aragonite]]), mainly CaCO<sub>3</sub>, is forced into contact with water injected with [[carbon dioxide]] (CO<sub>2</sub>) in order to create [[carbonic acid]](H<sub>2</sub>CO<sub>3</sub>).  This increases the solubility of the [[calcium carbonate]].  The reaction frees the calcium and carbonate, supplying the aquarium with water rich in Ca<sup>2+</sup> and CO<sub>3</sub><sup>2-</sup>, important for maintaining both alkalinity and calcium levels.\n\n===Bubble Counter===\nThe bubble counter is used to measure the rate of carbon dioxide introduced to the system.  The [[Volumetric flow rate|flow rate]] of carbon dioxide must be monitored so that the maximum amount of gas dissolves into the solution with a minimum left unconsumed.  A [[needle valve]] or [[solenoid valve]] is used to regulate the CO<sub>2</sub> bubble rate. Valves with precise adjustment abilities will improve bubble control characteristics.\n\n===Feed Pump===\nThe feed pump controls the volume of water exchange in the system.  This is important because a high rate of water flow into the reactor reduces its efficiency, thus resulting in underproduction and a waste of CO<sub>2</sub>.\n\nA number of methods exist to supply the reactor with water from the tank. Some reactors [[siphon]] water into the input of the reactors re-circulation pump. A potential complication is the medium in the reactor becoming compacted, increasing [[back pressure]] onto the pump and reducing water into the reactor. Placing a gate or needle valve on the reactors outlet side will improve flow characteristics compared to control from the inlet side.\n\nAlternately, [[peristaltic pump]]s are effective operating against pressure, capable of supplying a precisely adjustable and continuous flow over a variety of flow rates with minimal maintenance.\n\n===pH Control=== \nThe pH control is connected to a probe in the reactor and adjusts the rate at which the calcium media dissolves. This probe constantly monitors the pH level within the calcium reactor. The pH range for the typical calcium reactor is 6.5 - 6.8. When the pH rises above a certain level, a valve opens, allowing carbon dioxide to enter the reactor.  The control also closes the valve as the pH falls below this level.\n\nMany pH controllers also incorporate an interface for an air pump. This air pump is usually connected to an airstone located within the sump or main tank. If the probe detects a pH level below the set range, the pump will activate and the resulting bubbles raise the pH by helping to dissipate the CO<sub>2</sub> gas.\n\n'
p316
tp317
a(I1
S'{{Infobox Magazine|\n title = Craft: (transforming traditional crafts) |\n image = \n editor = Carla Sinclair |\n frequency = Quarterly|\n circulation = |\n category = [[Do it yourself|Do it yourself (DIY)]]|\n company = [[OReilly Media]] |\n firstdate = April 2006 |\n country = [[United States]] |\n language = [[English language|English]] |\n website = [http://www.craftzine.com/ CraftZine] |\n isbn-10 = 0-596-52928-7 |\n isbn-13 = 978-0-596-52928-4\n}}\n\nCraft: (or CRAFT:) was a quarterly [[magazine]] published by<ref>[http://makezine.com/faq/ Makezine FAQ]</ref> [[OReilly Media]] which focused on [[Do it yourself|do it yourself (DIY)]] projects involving [[knitting]], [[sewing]], [[jewelry]], [[metalworking]], [[woodworking]] and other disciplines. The magazine was marketed to people who enjoy crafting things and features projects which can often be completed with cheap materials, including household items.\n\n==Subjects==\nUnlike more traditional craft magazines and [[how-to]] books, Craft: projects were aimed at a younger (18-35) audience. Projects in the first issue included making a stitched robot doll, a silver-thread and microprocessor-based programmable [[LED]] [[tank top]], knit slouch boots, a minimalist catnip castle, and an ant-farm room divider.<ref name=LeChron>{{cite web |url= http://www.sfgate.com/cgi-bin/article.cgi?f=/c/a/2006/11/22/HOGC7MFHAQ1.DTL |title= Low-tech crafts for DIYers |author= Anh-Minh Le |work= [[San Francisco Chronicle]] |date= [[22 November]] [[2006]] |quote= }}</ref>  Articles with names like Subversive [[Cross-stitch|Cross Stitch]], Battle Chic - craft a wardrobe of medieval armor with DIY [[chainmail]], and The Lost [[Ipu]] Art of [[Niihau|Niihau]]<ref name=Bordessa>{{cite web |url= http://www.craftzine-digital.com/craft/vol04/?pg=30&liid=659d5683f1 |title= The Lost Ipu Art of Niihau |author= Kris Bordessa |work= Craft: Vol. 4 |date= 2007 |quote= }}</ref>  are typical of the magazines eclectic [[Indie design|indie]] themes.\n\n==Demographic==\nCraft: was aimed at the emerging [[DIY culture]] in North America and Europe, particularly female, that enjoys not only the fashion of [[handmade]] items and [[crafts]], but also the philosophy and politics inherent in [[recycling]], [[DIY]] clothing, and [[ecology]]. The ads featured in Craft: targeted a readership that is largely [[Liberalism|liberal]], and interested in [[localism|locally produced]], [[handmade]], [[ecological]], and [[organic product|organic]] goods and craft supplies. The demographic also is heavily [[computer literate]], and [[blogs]] about their crafts and the crafts of their peers, thus ads for services such as [[web hosting]] and [[flickr]] were also found in the magazines pages.\n\n==Cancellation of the print version==\nOn 11 February 2009, e-mails were sent to Craft: subscribers explaining that due to rising production costs and shrinking ad markets, the print version of Craft: would be discontinued but would remain as an online presence. Also, all further printed content would be incorporated into Make:. The website for Craft: included the following announcement from publisher [[Dale Dougherty]]:\n\n<blockquote>All along, we have noticed that Craftzine.com has been growing steadily. At the same time, weve come to realize that there were more and more challenges in publishing CRAFT as a print magazine, especially with the costs of print and distribution rising, and diminishing interest among advertisers in print. So weve decided that Volume 10, our Celebrate Like Crazy issue, will be our last print issue and that the future of CRAFT is online.\n<P>\nCreating a print magazine was a great pleasure for all of us on our amazing team, and weve appreciated the many readers who told us how much they enjoyed CRAFT. Our print magazine helped to gain recognition that craft is thriving today, more than ever. Were going online exclusively with CRAFT because thats where we can best reach and serve our audience.\n<P>\nI also want to assure you that craft and crafters will continue to be an important part of the program for Maker Faire. We have always regarded crafters as we do makers, a creative vanguard who are remaking the world in ways that are especially vital today. Also, we will continue to publish MAKE magazine in print. The closure of CRAFT in print allows us to focus our limited resources on growing a single DIY magazine instead of two.[http://craftzine.com/]</blockquote>\n\nUnder the Craft Print FAQ, he added the following:\n\n<blockquote>The CRAFT site will grow to combine its current blog style plus more original content including weekly and bimonthly columns, and tutorials. We hope youll stick with us and visit often![http://blog.craftzine.com/archive/2009/02/craft_print_faq.html]</blockquote>\n\n'
p318
tp319
a(I1
S'[[Image:Geocaching.svg|thumb|One of the most widely used symbols for Geocaching]]\n\nGeocaching is an outdoor activity in which the participants use a [[Global Positioning System]] (GPS) [[GPS receiver|receiver]] or other [[navigation]]al techniques to hide and seek containers (called geocaches or caches) anywhere in the [[world]]. A typical cache is a small [[waterproof]] container (usually a [[Tupperware#Product lines|tupperware]] or [[ammo box]]) containing a logbook.  Larger containers can also contain items for trading, usually toys or trinkets of little value.  Geocaching is most often described as a game of high-tech hide and seek, sharing many aspects with [[orienteering]], [[Treasure hunt (game)|treasure-hunting]], and [[waymarking]].\n\nGeocaches are currently placed in over 100 [[country|countries]] around the world and on all seven [[continents]], including [[Antarctica]].<ref>{{cite web|last=|title=List of caches in Antarctica|publisher=[[Groundspeak]]|date=2007-12-11|url=http://www.geocaching.com/seek/nearest.aspx?lat=-77.532717&lon=167.081967|accessdate=2007-12-11}}</ref> As of October 02 2009, there are over 912,900 active geocaches over the world.<ref> Geocaching.com http://www.geocaching.com/</ref>\n\n==History==\n[[Image:ConstellationGPS.gif|frame|right|GPS satellite visibility as the satellites orbit and the Earth rotates.]]\n\nGeocaching is similar to the 150-year-old game [[letterboxing]], which uses clues and references to [[landmarks]] embedded in stories.  Geocaching was imagined shortly after the removal of [[Global Positioning System#Selective availability|Selective Availability]] from GPS on [[May 1]], [[2000]], because the improved accuracy<ref>[http://pnt.gov/public/sa/diagram.shtml Improved GPS accuracy]</ref> of the system allowed for a small container to be specifically placed and located.  The first documented placement of a GPS-located cache took place on [[May 3]], 2000, by Dave Ulmer of [[Beavercreek, Oregon|Beavercreek]], [[Oregon]].<ref> Geocaching.com http://www.geocaching.com/about/history.aspx</ref> The location was posted on the [[Usenet]] [[newsgroup]] [news://sci.geo.satellite-nav sci.geo.satellite-nav]<ref name=Ulmer>{{cite newsgroup |title=GPS Stash Hunt... Stash #1 is there! |author=Dave Ulmer |date=2000-05-03 |newsgroup=sci.geo.satellite-nav |id=99c847733cb3547a/d45188eaf9eae761 |url=http://groups.google.ca/group/sci.geo.satellite-nav/browse_thread/thread/99c847733cb3547a/d45188eaf9eae761?lnk=gst&q=stash&rnum=148 |accessdate=2008-12-15}}</ref> as {{Coord|45|17.460|N|122|24.800|W |region:US-OR_type:landmark}}. By [[May 6]], 2000, it had been found twice and logged once (by Mike Teague of [[Vancouver, Washington|Vancouver]], [[Washington]]).  According to Dave Ulmers message, the original stash was a black plastic bucket buried most of the way in the ground and contained software, videos, books, food, [[money]], and a [[slingshot]].<ref name=Ulmer/>\n\n===Origin of the name===\nThe activity was originally referred to as GPS stash hunt or gpsstashing. This was changed after a discussion in the gpsstash discussion group at [[eGroups]] (now [[Yahoo!]]). On May&nbsp;30, 2000, Matt Stum suggested that stash could have negative connotations, and suggested instead geocaching.<ref>{{cite web|title=Cache vs Stash |first=Matt|last=Stum |date=2000-05-30 |url=http://tech.groups.yahoo.com/group/gpsstash/message/62 |publisher=[[Yahoo!]] |accessdate=2007-05-21}}</ref>\n\n==Geocaches==\n[[Image:Geocaching.jpg|thumb|Geocache [http://www.geocaching.com/seek/cache_details.aspx?guid=a7f2159e-6559-4c3f-a08d-1f91bb2408dc Pfalz Werla] in [[Germany]]]]\nFor the traditional geocache, a geocacher will place a waterproof container containing a log book (with [[pen]] or [[pencil]]) and trade items then record the caches [[Latitude and longitude|coordinates]]. These coordinates, along with other details of the location, are posted on a [[website|listing site]] (see list of some sites below). Other geocachers obtain the coordinates from that listing site and seek out the cache using their GPS handheld receivers. The finding geocachers record their exploits in the logbook and online. Geocachers are free to take objects (except the logbook, pencil, or stamp) from the cache in exchange for leaving something of similar or higher value, so there is [[treasure]] for the next person to find.\n\n[[File:Geocoin at Spiers.JPG|thumb|left|A [[Geocoin]].]]Typical cache treasures are not high in monetary value but may hold personal value to the finder. Aside from the logbook, common cache contents are unusual [[coin]]s or [[currency]], small toys, ornamental buttons, CDs, or books. Also common are objects that are moved from cache to cache called hitchhikers, such as [[Travel Bug]]s or [[Geocoin]]s, whose travels may be logged and followed online. Cachers who initially place a Travel Bug or Geocoin often assign specific goals for their trackable items. Examples of goals are to be placed in a certain cache a long distance from home, or to travel to a certain country, or to travel faster and farther than other hitchhikers in a race.  Higher value items are occasionally included in geocaches as a reward for the First to Find (called FTF), or in locations which are harder to reach. Dangerous or illegal items, weapons, and pornography are generally not allowed and are specifically against the rules of most geocache listing sites.  \n[[Image:TravelBug.jpg|thumb|A [[Travel Bug]]]]\n\nGeocache container sizes range from containers as small as the tip of your little finger (nanos), to film canisters (often called microcaches), too small to hold anything more than a tiny paper log, to five-gallon buckets or even larger containers.<ref>{{cite web |last=Team Desert Eagle|title=Big Boy |publisher=Groundspeak |date=2006-08-19 |url=http://www.geocaching.com/seek/cache_details.aspx?guid=1008aa58-1224-45ce-8acc-f6502cb61c2d |accessdate=2007-05-21}}</ref>\n\nIf a geocache has been vandalized or stolen, it is said to have been muggled or plundered. The former term plays off the fact that those not familiar with geocaching are called geo-muggles or just [[muggle]]s, a term popularised by the [[Harry Potter]] series of books.<ref>{{cite web |first=Amy|last=Matthew |title=Global treasure hunts catching on among geocache fans |work=[[The Pueblo Chieftain]] |url=http://www.chieftain.com/life/1176964526/1 |accessdate=2007-05-21}}</ref>\n\nIf a cacher discovers that a cache has been muggled, it can be logged as needing maintenance, which sends an e-mail to the cache owner so it can be repaired, replaced, or archived (deactivated).\n\nPutting food in a cache is not advised. Animals can smell food through the container and will find a way to get into the container or just take it.\n\n==Variations==\nGeocaches vary in size, difficulty, and location. Simple caches are often called drive-bys, park n grabs (PNGs), or cache and dash. Geocaches may also be complex, involving lengthy searches or significant travel. Examples include staged multi-caches;<ref>{{cite web |last=NFA |title=Adirondack Murder Mystery |publisher=Groundspeak |date=2005-07-06 |url=http://www.geocaching.com/seek/cache_details.aspx?guid=bfd77652-25cd-487d-8a6d-5bc9c204ad53 |accessdate=2007-05-21}}</ref> underwater caches,<ref>{{cite web|last=Freefloat |title=Ambitious Snorkeller |publisher=Groundspeak |date=2004-06-06 |url=http://www.geocaching.com/seek/cache_details.aspx?guid=e357a41d-80c8-4979-b46d-088247b9660c |accessdate=2007-05-21}}</ref><ref>{{cite web |first=Doug|last=Mathieson |title=Scuba Cache:Innerkip Quarry |publisher=Groundspeak |date=2005-07-17 |url=http://www.geocaching.com/seek/cache_details.aspx?guid=e4552463-fe71-4905-96a5-cf04cb3d3aeb |accessdate=2007-05-21}}</ref> caches located 50&nbsp;feet (15&nbsp;m) up a tree,<ref>{{cite web |last=Team Bridgebuilder |title=Hypostyle Hall |publisher=Groundspeak |date=2004-10-07 |url=http://www.geocaching.com/seek/cache_details.aspx?wp=GCKR3C |accessdate=2007-05-21}}</ref> caches found only after long offroad drives,<ref>{{cite web |last=Headybrew |title=Clamshell offroad and hike |publisher=TerraCaching.com |date=2006-04-18 |url=http://www.terracaching.com/viewcache.cgi?C=TC7QL |accessdate=2007-05-21}}</ref> caches on high mountain peaks,<ref>{{cite web |last=GPearl |title=9 Summits - Krnten |publisher=Groundspeak |date=2004-07-25 |url=http://www.geocaching.com/seek/cache_details.aspx?guid=1c322b4e-2f8d-40f9-9f3e-4d1bf9daeb6e |accessdate=2007-05-21}}</ref>   caches located in challenging environments (such as Antarctica <ref>{{cite web |last=Arbalo |title=Magnums Cache |publisher=Navicache.com |date=2003-02-05 |url=http://www.navicache.com/cgi-bin/db/displaycache2.pl?CacheID=1273 |accessdate=2007-05-21}}</ref> or north of the [[Arctic Circle]]<ref>{{cite web |last=Iceshelf 2002 Research Team |title=As North As It Gets! |publisher=Groundspeak |date=2002-05-05 |url=http://www.geocaching.com/seek/cache_details.aspx?wp=GC5803 |accessdate=2007-05-21}}</ref>), and magnetic caches attached to metal structures and/or objects. Different geocaching websites list different variations per their own policies (e.g. Geocaching.com does not list new [[Webcam]], Virtual, Locationless, or Moving geocaches).\n\n[[File:Geocache CZ 06.JPG|thumb|A small traditional geocache in the [[Czech Republic]].]]\n{{Unreferenced section|date=September 2009}}\nVariations of geocaches include:\n* Traditional: The basic cache type, a traditional cache must include a log book of some sort.  It may or may not include trade or traceable items.  A traditional cache is distinguished from other cache variations in that the geocache is found at the coordinates given and involves only one stage.\n\n* Multi-cache: This variation consists of multiple discoveries of one or more intermediate points containing the coordinates for the next stage; the final stage contains the log book and trade items.\n\n:* Offset: This cache is similar to the multi-cache except that the initial coordinates are for a location containing information that encodes the final cache coordinates. An example would be to direct the finder to a plaque where the digits of a date on the plaque correspond to coordinates of the final cache.\n\n:* Night Cache: These multi-stage caches are designed to be found at night and generally involve following a series of reflectors with a flashlight to the final cache location.\n\n* Mystery/puzzle: This cache requires one to discover information or solve a puzzle to find the cache. Some mystery caches provide a false set of coordinates with a puzzle that must be solved to determine the final cache location. In other cases, the given location is accurate, but the name of the location or other features are themselves a puzzle leading to the final cache. Alternatively, additional information is necessary to complete the find, such as a padlock combination to access the cache.\n\n* Letterbox Hybrid:   A [[Letterboxing|letterbox]] hybrid cache is a combination of a geocache and a letterbox in the same container.  A letterbox has a rubber stamp and a logbook instead of tradable items. Letterboxers carry their own stamp with them, to stamp the letterboxs log book and inversely stamp their personal log book with the letterbox stamp.  The hybrid cache contains the important materials for this and may or may not include trade items. Whether the letterbox hybrid contains trade items is up to the owner.\n\n* Locationless/Reverse: This variation is similar to a [[scavenger hunt]].  A description is given for something to find, such as a one-room schoolhouse, and the finder locates an example of this object.  The finder records the location using their GPS hand-held receiver and often takes a picture at the location showing the named object and his or her GPS receiver.  Typically others are not allowed to log that same location as a find.\n\n* Moving/Travelling: Similar to a traditional geocache, this variation is found at a listed set of coordinates. The finder uses the log book, trades trinkets, and then hides the cache in a different location. By updating this new location on the listing, the finder essentially becomes the hider, and the next finder continues the cycle.  The hitchhiker concept (see above) has superseded this cache type on geocaching.com.\n\n[[File:Virtual Cache.JPG|thumb|A Geocacher finding a Virtual Cache at [[McMurdo Station]], [[Antarctica]]]]\n* Virtual: Caches of this nature are coordinates for a location that does not contain the traditional box, log book, or trade items. Instead, the location contains some other described object.  Validation for finding a virtual cache generally requires you to email the cache hider with information such as a date or a name on a plaque, or to post a picture of yourself at the site with GPS receiver in hand.\n:* Earthcache: A type of virtual-cache which is maintained by the [[Geological Society of America]]. The cacher usually has to perform a task which teaches him/her an educational lesson about the earth science of the cache area.\n* Webcam: Similar to a virtual cache; there is no container, log book, or trade items for this cache type. Instead, the coordinates are for a location with a public [[webcam]]. Instead of signing a log book, the finder is often required to capture their image from the webcam for verification of the find.\n* Event Cache: This is a gathering organized and attended by geocachers. Physical caches placed at events are often active only for the event date.\n:* Cache-In Trash-Out (CITO) Events: This variation on event caching is a coordinated activity of trash pickup and other maintenance to improve the environment.\n:* Mega Event: An  event that is attended by over 500 people. Mega Events are typically annual events, usually attracting geocachers from all over the world.\n:*GPS Adventures Maze Exhibit: An exhibit at various museums and science centers in which participants in the maze learn about geocaching. These events have their own cache type on Geocaching.com and include many non-geocachers.\n* Wherigo cache: A [[Wherigo]] cache is similar to a multi-stage cache hunt that uses a [[Wherigo]] cartridge to guide the player. The player plays the cartridge and finds a physical cache sometime during cartridge play, usually at the end. Not all Wherigo cartridges incorporate geocaches into game play. Wherigo caches are unique to the geocaching.com website.\n\n===Project A.P.E. Cache Type.===\nIn 2001, [[20th Century Fox]] in conjunction with Geocaching.com released a series of caches intended to promote the movie [[Planet of the Apes (2001 film)|Planet of the Apes]]. The containers were all 60mm [[ammo can]]s with the phrase Project A.P.E. stencilled on the side. Clues were given to the location of the cache each week, getting more and more specific. Eventually, the cache would be published. Inside each container was an item from the movie. <ref name=What the Heck is Project A.P.E>{{cite web | title=What the Heck is Project A.P.E.? | url=http://www.markwell.us/projectape.htm}}</ref> In 2003, 20th Century Fox separated themselves from the promotion completely and most of the caches were adopted by their respective owners. Many were soon archived, and only two Project A.P.E. caches of the Project A.P.E. cache type remain today as a result of this, however one cache that is now a traditional cache was a former Project A.P.E. cache as well. Two Project A.P.E. caches still remain, one near [[Rio de Janeiro, Brazil]], and one 35 miles outside of [[Seattle, Washington]]. <ref name=What the Heck is Project A.P.E/>\n\n===Obtaining data===\nGPX files contain information such as a cache description and information about recent visitors to the cache. Geocachers may upload geocache data (also known as [[waypoint]]s) from various websites in various formats, most commonly in file-type [[GPX (data transfer)|GPX]], which uses [[XML]] <ref>{{cite web |title=GPX: The GPS Exchange Format |url=http://www.topografix.com/gpx.asp |accessdate=2009-07-20}}</ref>. Some websites allow geocachers to search (build queries) for multiple caches within a geographic area based on criteria such as [[Zip Code]] or [[Geographic coordinate system|coordinates]], downloading the results as an email attachment on a schedule. Although often a time-consuming process with many possibilities for error, appropriate client software allows cachers to build individual GPX files.\n\n===Converting and filtering data===\nA variety of geocaching applications are available for geocache data management, file-type translation, and personalization. Geocaching [[software]] can assign special icons or search (filter) for caches based on certain criteria (e.g. distance from an assigned point, difficulty, date last found).\n\nPaperless geocaching employs [[Personal digital assistant|PDAs]] or other electronic devices to carry geocache information instead of paper. Various applications are able to directly upload and read [[GPS eXchange Format|GPX]] files without further conversion. Newer GPS devices released by [[Garmin]] have the ability to read GPX files directly, thus eliminating the need for a [[Personal digital assistant|PDA]].<ref> {{cite news |url=http://www.connect.de/themen_spezial/Outdoor-Navigation-mit-dem-Garmin-Colorado-300_1596951.html |title=Outdoor-Navigation mit dem Garmin Colorado 300 |date=2008-04-01 |publisher=connect.de |pages=1 |language=German |accessdate=2008-11-25}}</ref> The release of numerous cellphones which have a GPS chip built in, has enabled another platform for paperless geocaching.\n\n==Terminology==\nThere are various acronyms and phrases commonly used in logs, both online and in logbooks. These words and phrases include, but are not limited to:\n*DNF is an acronym for Did Not Find, or when a geocacher hunts for a particular cache however is unable to find the container.\n*FTF is an acronym for First To Find, used by the first person to locate the cache and sign the log.\n*ICT is an acronym for Ivy Covered Tree, used in the description on where a cache may be hidden.\n*TFTC is one of the more commonly used acronyms, standing for Thanks For The Cache. This is often used at the end of logs to thank the cache owner, or CO.\n*TFTH is an acronym similar to TFTC, however it stands for Thanks For The Hunt or Thanks For The Hike or Thanks For the Hide. It shares the same purpose as TFTC.\n*TNLN is an acronym for Took Nothing, Left Nothing, used when a finder of a cache does not trade any items in the cache. Just TN or LN can be used individually as well.\n*SL is an acronym for Signed Log, used when the participant visited the cache and signed its logbook. This acronym can be combined with the one above, and then condensed to make XNSL, which stands for exchanged nothing, signed log.\n<ref>{{cite web |title=Glossary of Terms |url=http://www.geocaching.com/about/glossary.aspx |accessdate=2009-07-20}}</ref>\n\n==Ethics==\nIndividual geocaching websites have developed their own guidelines for acceptable geocache publications. Though not universally required, the Geocachers Creed provides ethical search guidelines. Government agencies and others responsible for public use of land often establish their own guidelines for geocaching.<ref name=WP070927>Fredrick Kunkle, [http://www.washingtonpost.com/wp-dyn/content/article/2007/09/26/AR2007092600843_pf.html Geocaching Craze Pushes Officials To Set Guidelines], [[Washington Post]], September&nbsp;27, 2007. Retrieved March&nbsp;11, 2008.</ref><ref>{{Cite web |url=http://www.msnbc.msn.com/id/10894835/ |title=Geocaching puts some authorities on edge |accessdate=January 2, 2009 |publisher=Associated Press |date=January 17, 2006}}</ref> Generally accepted rules are to not endanger others, to minimize the impact on nature, to respect [[private property]], and to avoid public alarm.\n\n==Controversy and issues==\nCachers have been approached by [[police]] and questioned when they were seen as acting suspiciously.<ref>{{cite web |title=GAGB - Agreements Database |url=http://www.gagb.co.uk/gagb/glad/agreement_view.php?p=40 |work=GAGB Land Agreements Database |accessdate=02 October 2009}}</ref>  Other times, investigation of a cache location after suspicious activity was reported has resulted in police and bomb squad discovery of the geocache. Schools have been occasionally evacuated when a cache has been seen by teachers or police, as in the case of Fairview High School in 2009. <ref> [http://www.stuff.co.nz/4399742a10.html Geocache causes bomb scare, Auckland, New Zealand] </ref><ref name=Mike Vogel>{{cite web |author=Mike Vogel |title=Geocache player broke all the rules of Internet treasure hunt |publisher=[[Boise, Idaho]] |url=http://www.ktvb.com/news/topstories/stories/ktvbn-sept2805-geocaching.a28aee2c.html |accessdate=2005-09-28}}</ref><ref> [http://www.santacruzsentinel.com/localnews/ci_12426411 Bomb scare closes main entrance at the University of California, Santa Cruz on the morning of May 21, 2009.]</ref> A number of caches have been destroyed by bomb squads.<ref>{{cite news |title =Detonated bomb turns out to be box of toys | work =The Deseret News | date = November 12, 2005 | url =http://www.deseretnews.com/article/635160668/Detonated-bomb-turns-out-to-be-box-of-toys.html | accessdate = }}</ref><ref>{{cite news|title =One persons game is anothers bomb scare| work =Ottawa Citizen | date = July&nbsp;29, 2008 | url =http://www.canada.com/ottawacitizen/news/story.html?id=c7628126-a0f6-4a9e-a396-a40fa1948eab}}</ref>\n\nThe placement of geocaches has critics among governmental personnel and the public at large who consider it littering. Some geocachers try to mitigate this perception by picking up litter while they search for geocaches. Geocaching is not [[illegal]], and is usually positively received when explained to law enforcement officials (e.g. police officers).  However, certain types of placements can be problematic.  Although disallowed, hiders could place caches on private property without adequate permission (intentionally or otherwise), which encourages cache finders to trespass.  Caches might also be hidden in places where the act of searching can make a finder look suspicious (e.g. skulking near schools, childrens playgrounds, banks, courthouses, or in residential neighborhoods), or where the container placement could be mistaken for a [[drug]] stash or potential [[bomb]] threat (often in urban settings, under bridges, near banks, courthouses, or embassies). Hides in these areas are discouraged<ref name=Mike Vogel/>, and cache listing websites enforce guidelines that disallow certain types of placements.  However, as cache reviewers typically cannot see exactly where and how every particular cache is hidden, problematic hides can slip through.  Ultimately it is also up to cache finders to use discretion when attempting to search for a cache, and report any problems.\n\n==Websites==\nNumerous websites list geocaches around the world. In the [[United States]], where most geocaching services are hosted, only a caches coordinates are in public domain. Other cache information, including the description, is protected by copyright law. Geocaching websites vary in active protection of cache data.\n\n===First page===\nThe first website to list geocaches was announced by Mike Teague on May&nbsp;8, 2000. On September&nbsp;2, 2000, Jeremy Irish emailed the gpsstash mailing list that he had registered the domain name geocaching.com and had setup his own Web site. He copied the caches from Mike Teagues database into his own. On September&nbsp;7, Mike Teague announced that Jeremy Irish was taking over cache listings.\n\n===Geocaching.com===\n[[Image:GPS Receivers.jpg|thumb|right|Typical [[GPS receiver]]s as used to locate the co-ordinates of a Geocache.]]\nThe largest site is Geocaching.com, owned by [[Groundspeak]] Inc., which began operating on September&nbsp;2, 2000. With a worldwide membership, Geocaching.com lists hundreds of thousands of caches. Each cache is reviewed by regional cache reviewers before publication with an emphasis on family-oriented caching.  Free basic membership allows users to see coordinates for most caches in its database; premium membership includes a fee for additional features, including advanced search tools and caches designed for premium members. The website includes about 904,000 caches in over 200 countries around the world, as of September 2009. <ref>http://www.geocachingpolicy.org/whatisgeocaching.php</ref>\n\nGeocaching.com no longer lists new caches without a physical container, including locationless/reverse and webcam; however, older caches of these types have been [[Grandfather clause|grandfathered]] in (except for locationless/reverse, which are completely archived). Earthcaches are the exception to the no-container rule; they are caches in which players must answer geological questions to complete the cache. Groundspeak created a [[waymarking]] website to handle all other non-physical caches.\n\nGeocaching.com also supports the discovery of benchmarks, which are a location (only in the USA) known to a high degree of accuracy<ref>[http://www.geocaching.com/mark/#Whatis Benchmark Hunting]</ref> Sometimes these can be metal disks, radio towers, or a bolt in central locations or on a highway. Their main purpose is for surveying an area. Geocaching gives the longitude and latitude to this location and the user must rely on given clues to find the benchmark.\n\n===NaviCache===\nNavicache.com started as a regional listing service around February 2001, but quickly gained popularity among those looking for a less restrictive alternative to what was currently available. While many of Navicache.coms listings have been posted to other sites, they also offer many unique listings. Navicache.com also lists nearly any type of geocache (within reason) and does not charge to access any of the caches listed in their database. While all submissions are reviewed and approved, Navicache is more liberal in approving caches believing that the pastime belongs to participants rather than a governing agency.\n\n===TerraCaching===\nTerracaching seeks to provide high-quality caches made so by the difficulty of the hide or from the quality of the location. Membership is managed through a sponsorship system, and each cache is under continual peer review from other members. Terracaching.com embraces virtual caches alongside traditional/multi-stage caches and includes many locationless caches among the thousands of caches in its database. It is increasingly attracting members who like the point system. In Europe TerraCaching is supported by Terracaching.eu. This site is translated in different European languages, has an extended FAQ and extra supporting tools for TerraCaching.\n\n===Other sites===\nIn many countries there are regional geocaching sites, but these mostly only compile lists of caches in the area from the three main sites. Many of them also accept unique listings of caches for their site, but these listings tend to be less popular than the international sites. There are some exceptions though, e.g. in the former Soviet Union the site Geocaching.su remains popular because it accepts listings in the [[cyrillic alphabet]]. An additional international site is Geocaching.de, a German website. Statistics websites such as CacherStats and CachingTree allow cachers to track statistics online.\n\n'
p320
tp321
a(I1
S'Kjell Hallbing (born [[November 5]], [[1934]] in [[Brum]], died [[May 6]], [[2004]] in [[Tnsberg]]) was a [[Norway|Norwegian]] [[author]] of [[Western (genre)|Western books]]. \n\nUnder the [[pseudonym]] Louis Masterson, he wrote a series of books about the fictitious Texas Ranger (later U.S. Marshal) [[Morgan Kane]] during 1966-1978. The 83 Morgan Kane books have been sold in more than 11 million copies.\nHe has also written another nine book series known as the Diablo- and Diablito books.\n\nEarlier in his career Hallbing used the pseudonyms Ward Cameron, Leo Manning, Lee Morgan and Colin Hawkins. His debut Ubt-kontakt was released in 1961, written  under his real name. The same year he released his first book set in the old West, Portrett av en revolvermann (Portrait of a gunslinger). In addition Kjell Hallbing was an eager weapon collector, resulting in his collection being one of the biggest privately owned weapon collections in Norway at the time of his death. He also owned a little house at [[Bolkesj]], where he actually wrote most of the books in the Morgan Kane series.\n\nOther heroes Hallbing/Masterson wrote about, were [[Jesse Rawlins]], [[Owen Metzgar]] and [[Clay Allison]].\n\nBefore he started to write full-time in 1969, Hallbing worked as a bank-employee.\n\n{{DEFAULTSORT:Hallbing, Kjell}}\n'
p322
tp323
a(I-1
S'{{Refimprove|date=April 2008}}{{wiki|date=April 2009}}\nPsychomotor retardation or Psychomotor Slowing comprises a slowing down of [[thought]] and a reduction of physical movements in an individual. This is most commonly seen in people with [[major depressive disorder|major depression]] , and indicates a certain degree of severity. Particularly in inpatient settings, psychomotor retardation can require increased [[nursing care]] to ensure adequate food and fluid intake as well as sufficient personal care. [[Informed consent]] for treatment is more difficult to achieve when this is present.\n\nPsychomotor retardation is also referred to as motormental retardation, commonly seen in depression and [[bipolar disorder]].\n\nSome examples of psychomotor retardation may include the following:\n\n# Unaccountable difficulty with carrying out what are usually considered automatic or mundane self-care tasks for healthy people (i.e., without depressive illness), such as taking a shower, putting on clothes, self-grooming, preparing food, brushing teeth and exercising.\n# Real physical difficulty performing activities that normally would require little thought or effort, such as walking up a flight of stairs, getting out of bed, preparing meals and clearing dishes from the table, household chores, returning phone calls, etc.\n# Tasks requiring mobility suddenly or gradually and inexplicably seem to be impossible. Activities such as shopping, getting groceries, caring for the daily needs of ones children, and meeting the demands pertaining to employment or school are commonly affected. Individuals experiencing these symptoms typically sense that something is wrong, and may be confused over their inability to perform these tasks.\n# Activities usually requiring little mental effort can become challenging. Balancing ones checkbook, making a shopping list, making decisions about mundane tasks, (such as deciding what errands need to be done) are often difficult.\n\n\n'
p324
tp325
a(I-1
S'{{Refimprove|date=December 2007}}\n{{Lead too short|date=September 2009}}\n\n{{VG history|expandmenu=2}}\n\nThe first generation of [[video game consoles]] lasted from 1972, with the release of the [[Magnavox Odyssey]], until 1977, when pong-style console manufacturers left the market en masse due to the introduction and success of microprocessor-based consoles. <ref name=1stcrash>{{cite book\n  | last = Wolf\n  | first = Mark J.P.\n  | title = The Video Game Explosion\n  | publisher = Greenwood Publishing Group\n  | date = 2008\n  | pages = Page xviii\n  | url = http://books.google.com/books?id=to5zEwOC9BcC&pg=PR18&dq=1st+video+game+crash+1977#PPR18,M1\n  | isbn = 031333868X, 9780313338687}}\n</ref>\n\n== Interactive television ==\n\n[[Television]] engineer [[Ralph Baer]] conceived the idea of an interactive television while building a television set from scratch for [[Loral Corporation|Loral]] in 1951 in [[The Bronx, New York]]. He explored these ideas further in 1966 when he was the Chief Engineer and manager of the Equipment Design Division at [[Sanders Associates]]. Baer created a simple two-player video game that could be displayed on a standard [[television]] set called Chase, where two dots chased each other around the screen. After a demonstration to the companys director of R&D [[Herbert Campman]], some funding was allotted and the project was made official. In 1967 [[Bill Harrison]] was brought on board, and a [[light gun]] was constructed from a toy rifle that was aimed at a target moved by another player.\n\n[[Bill Rusch]] joined the project to speed up development and soon a third machine-controlled dot was used to create a [[Table tennis|ping-pong]] game. With more funding additional games were created, and Baer had the idea of selling the product to [[cable television|cable TV]] companies, who could transmit static images as game backgrounds. A prototype was demonstrated in February 1968 to [[Teleprompter]] Vice President [[Hubert Schlafly]], who signed an agreement with Sanders. The Cable TV industry was in a slump during the late 60s and early 70s and a lack of funding meant other avenues had to be pursued. Development continued on the hardware and games resulting in the final Brown Box prototype, which had two controllers, a light gun and sixteen switches on the console that selected the game to be played. Baer approached various U.S. Television manufacturers and an agreement was eventually signed with [[Magnavox]] in late 1969. Magnavoxs main alterations to the Brown Box were to use plug-in circuits to change the games, and to remove the color graphics capabilities in favor of color overlays in order to reduce manufacturing costs. It was released in May 1972 as the [[Magnavox Odyssey]].\n\n== Digital electronics ==\n\nThe Odyssey was built using a combination of [[analog circuit|analog]] (for the output, game control) and digital circuitry.  Many collectors confuse the use of discrete components to mean the system is analog.  However, the games and logic itself are implemented in [[DTL]], a common pre-[[Transistor-transistor logic|TTL]] digital design component using discrete transistors and diodes.  Likewise, [[Ralph Baer]] himself considers the system digital. <ref>{{cite web\n| url = http://www.gamerdad.com/detail.cfm?itemID=1049\n| title = The Original GamerDad: Ralph Baer\n| accessdate = 2006-10-20\n| work =\n| publisher =\n}}</ref>\n\nIt was not a large success due to restrictive marketing, although other companies with similar products (including Atari) had to pay a licensing fee for some time. For a time it was Sanders most profitable line, even though many in the company had been unsupportive of game development.\n[[Image:Pong.png|thumb|right|170px|[[Pong]] arcade version]]\nMany of the earliest games utilising [[digital electronics]] ran on [[university]] [[mainframe computer]]s in the [[United States]], developed by individual users who programmed them in their spare time.\nIn 1961, a group of students at the [[Massachusetts Institute of Technology]] programmed a game called [[Spacewar!]] on a [[Digital Equipment Corporation|DEC]] [[PDP-1]].\nIn 1970 [[Nolan Bushnell]] saw Spacewar! for the first time at the [[University of Utah]]. Deciding there was commercial potential in an [[Arcade game|arcade]] version, he hand-wired a custom computer capable of playing it on a black and white [[television]]. The resulting game, [[Computer Space]], did not fare well commercially and Bushnell started looking for new ideas. In 1971 he saw a demonstration of the [[Magnavox Odyssey]], and hired [[Al Alcorn]] to produce an arcade version of the Odysseys ping-pong game (using [[Transistor-transistor logic]]), called [[Pong]].\n\nHome video games achieved widespread popularity with the release of a home version of Pong in the Christmas of 1975. Its success sparked hundreds of clones, including the [[Coleco Telstar]], which went on to be a success in its own right, with over a dozen models.\n\nThe first generation of video games did not feature a [[microprocessor]], and were based on custom codeless [[Finite state machine|state machine computers]] consisting of [[Logic gate|discrete logic]] circuits comprising each element of the game itself.  Later consoles of this generation moved the bulk of the circuitry to custom pong on a chip ICs such as Ataris custom Pong chips and General Instruments [[AY-3-8500]] series.<ref name =customic>http://www.pong-story.com/gi.htm</ref>\n\n== Comparison ==\n\n{| class=wikitable\n!style=width: 10%|Name\n!style=width: 18%; | [[Magnavox Odyssey]]\n!style=width: 18%; | [[Magnavox Odyssey 100]]\n!style=width: 18%; | [[Tele-Spiel ES 2201]]\n!style=width: 18%; | [[Magnavox Odyssey 200]]\n!style=width: 18%; | Atari/Sears Telegames [[Pong]]\n!style=width: 18%; | [[Coleco Telstar]]\n!style=width: 18%; | Nintendo [[Color TV Game]]\n|- align=center\n!Console\n| [[Image:Odysseye2m.png|140px]]\n|\n|\n| [[Image:ODYSSEY200 Konsole.JPG|120px]]\n| [[Image:Atarisearspong.png|120px]]\n| [[Image:ctelstar.jpg|120px]]\n| [[Image:Nintendo tvgame 6.jpg|120px]]\n|-\n!Launch price\n| [[US$]]100\n| US$100\n| US$100\n| US$100230\n| US$98.95\n| n/a\n|- style=vertical-align: top\n!Release date\n| {{vgrelease|NA=May {{vgy|1972}}}} {{vgrelease|JP={{vgy|1975}}}} {{vgrelease|EU={{vgy|1974}}}}\n| {{vgrelease|NA={{vgy|1975}}}}\n| {{vgrelease|NA={{vgy|1975}}}}\n| {{vgrelease|NA={{vgy|1975}}}}\n| {{vgrelease|NA={{vgy|1975}}}}\n| {{vgrelease|NA={{vgy|1976}}}} {{vgrelease|JP={{vgy|1977}}}}\n| {{vgrelease|JP={{vgy|1977}}}}\n|-\n!Media\n| Cartridge\n| n/a\n| Cartridge\n| n/a\n| n/a\n| Cartridge (Telstar Arcade)\n| n/a\n|-\n!Accessories (retail)\n| Light gun\n| n/a\n| n/a\n| n/a\n| n/a\n| Controller styles\n| n/a\n|}\n\n'
p326
tp327
a(I1
S'{{Notability|date=March 2009}}\nAllan Detrich is an American professional [[photographer]] who was found to have digitally altered news photos for publication. He is a native of [[Attica, Ohio]], and attended the Ohio Institute of Photography in [[Dayton, Ohio]]. In 1998 his photo-essay Children of the Underground made it to the finals of the [[Pulitzer Prize]] for Feature Photography.<ref>{{cite news |first=Ron |last=Winslow |title=Toledo Blades Detrich Resigns Over Digitally Altered Photograph |url=http://www.nppa.org/news_and_events/news/2007/04/toledo03.html |work=News Photographer magazine |publisher=National Press Photographers Association |date=2008-04-09 |accessdate=2008-05-12 }}</ref> In 2002 his photograph of a [[tornado]] in [[Tiffin, Ohio]] was chosen by [[Time magazine]] as one of their Best Photos of the Year.<ref>[http://www.time.com/time/yip/2002/nature/8.html Best Photos of the Year] [[Time magazine]] 2002 Year in Pictures</ref>\n\nDetrich worked at the [[Toledo Blade]] from 1989-2007. He left the Blade in April 2007 when it was discovered that he had digitally altered a photo that was published on the front page of the March 31, 2007 edition. A subsequent investigation revealed that he had digitally altered and submitted 79 photos during the first 14 weeks of 2007, 58 of which ran either in the Blade or on its website.<ref>{{cite news |first=Ron |last=Royhab |title=A basic rule: Newspaper photos must tell the truth |url=http://www.toledoblade.com/apps/pbcs.dll/article?AID=/20070415/NEWS08/704150316/-1/NEWS |work= |publisher=ToledoBlade.com |date=2008-04-15 |accessdate=2008-05-12 }}</ref> \n\nAn article on the [[National Press Photographers Association]] (NPPA) Web site has referred to Detrich as a serial digital manipulator of news photographs,<ref>[http://www.nppa.org/news_and_events/news/2007/04/toledo05.html Toledo Blade Discovers Dozens Of Doctored Detrich Photos]</ref>\n\nSince 1998 Detrich has been a [[Storm chasing|storm chaser]].  He spends several weeks each spring photographing [[supercell]] thunderstorms in the American [[Great Plains]] with [[MESO]].<ref>[http://www.usatoday.com/weather/tornado/chase2001/2001-06-18-chase-paper.htm The thrill of the chase, the fury of the storm] [[USA Today]]</ref>\n\n'
p328
tp329
a(I-1
S'Social Dominance Theory is a social psychological theory of [[Group (sociology)|group]] [[conflict]] which describes human [[society]] as consisting of oppressive group-based [[hierarchy|hierarchical]] structures.  According to the theory, individual people possess varying levels of preference for social dominance, which can be measured by the social psychological measure [[Social Dominance Orientation]].\n\n==History of SDT==\n===Origin===\nSocial Dominance Theory was first formulated<ref name=Sidanius>Jim Sidanius and Felicia Pratto: [http://www.amazon.com/dp/0521805406 Social Dominance: An Intergroup Theory of Social Hierarchy and Oppression]</ref>  by Psychology Professors [http://lieber.bol.ucla.edu/Sidanius/Sidanius.html Jim Sidanius] and [http://socialpsych.uconn.edu/feliciapratto.htm Felicia Pratto].  The key principles of the theory are that societies are stratified by age, sex and group. These group divisions are based on ethnicity, religion, nationality, and so on.  Human social hierarchies consist of a hegemonic group at the top and negative reference groups at the bottom.  More powerful social roles are increasingly likely to be occupied by a hegemonic group member (for example, an older white male).  Males are more dominant than females, and they possess more political power (the iron law of [[Androcracy|andrarchy]]).  Most high-status positions are held by males (<ref name=Sidanius/>, 1992).  Prejudiced beliefs such as racism, sexism, nationalism and classism are all manifestations of this same principle of social hierarchy.  The origin of social hierarchies is given an evolutionary explanation:  prehistoric human societies organized in hierarchies were more efficient at combat than non-hierarchical groups, giving a competitive advantage to groups disposed towards social hierarchies (<ref name=Sidanius/>, 1992).\n\n===Legitimization===\nVarious processes of hierarchical [[discrimination]] are driven by legitimizing [[myth]]s (Sidanius, 1992), which are beliefs justifying social dominance, such as [[paternalism|paternalistic]] myths ([[hegemony]] serves society, looks after incapable [[Minority group|minorities]]), reciprocal myths (suggestions that hegemonic groups and outgroups are actually [[Social equality|equal]]), and [[sacred]] myths (the divine right of kings - a religion-approved mandate for hegemony to govern).  Pratto et al. (1994) suggest the Western idea of [[meritocracy]] and individual achievement as an example of a legitimizing myth, and argues that meritocracy produces only an illusion of [[fairness]].  SDT draws on [[social identity]] theory, suggesting that social comparison processes drive individual discrimination (ingroup favouritism).  [[Discrimination|Discriminatory]] acts (such as insulting remarks about minorities) are performed because they increase the actors [[self-esteem]].\n\n===Gender and dominance===\nConsistent with the assumption that [[male]]s tend to be more dominant than [[female]]s, SDT predicts that males will tend to have a higher social dominance orientation (SDO). As such, males will tend to function as hierarchy [[enforcer]]s, that is, they will carry out acts of [[discrimination]] such as the systematic [[state terrorism|terror]] by police officers (Sidanius, 1992) and the extreme example of [[death squad]]s and [[concentration camps]].  This is supported by evidence such as police officers possessing measurably higher levels of SDO <ref>Pratto, F., Stallworth, L., Sidanius, J. & Siers, B. The gender gap in occupational role attainment: A social dominance approach. Journal of Personality and Social Psychology, 1997</ref>. SDT posits that males will tend to have a higher social dominance orientation.\n\n===Hegemonic group===\nSocial Dominance Theory is a consideration of group conflict which describes human society as consisting of oppressive group-based hierarchy structures. The key principles of Social Dominance Theory are:\n*Individuals are stratified by age, sex and group. Group identification is based on ethnicity, religion, nationality, and so on.\n*Human social hierarchy consists of a hegemonic group at the top and negative reference groups at the bottom\n*As a role gets more powerful, the probability it is occupied by a hegemonic group member increases (Law of increasing proportion)\n*Males are more dominant than females; they possess more political power (the iron law of andrachy). Most high-power positions will be held by males.\n*Racism, Sexism, Nationalism and Classism are all manifestations of this same principle of social hierarchy.\n\n===Group hierarchy===\nThe reason that social hierarchies exist in human societies is that they were necessary for survival of inter-group competition during conflict over resources. Essentially, groups organised in hierarchies were more efficient at combat than groups who were organised in other ways, giving a competitive advantage to groups disposed towards social hierarchies.\n     \nSocial Dominance Theory explains the mechanisms of group hierarchy oppression using three basic mechanisms:\n*Aggregated individual discrimination (ordinary discrimination)\n*Aggregated institutional discrimination (discrimination by governmental and business institutions)\n**Systematic Terror (police violence, death squads, etc)\n*Behavioural asymmetry\n**systematic outgroup favouritism or deference (minorities favour hegemony individuals)\n**asymmetric ingroup bias (as status increases, opposition to interracial mixing increases)\n**self-handicapping (low expectations of minorities are self-fulfilling prophecies)\n**ideological asymmetry (as status increases, so do discriminatory political beliefs eg conservatism)\n\nThese processes are driven by legitimizing myths, which are beliefs justifying social dominance:\n*paternalistic myths (hegemony serves society, looks after incapable minorities)\n*reciprocal myths (suggestions that hegemonic and outgroups are actually equal)\n*sacred myths (Divine right of kings - religion-approved mandate for hegemony to govern)\n     \n===Meritocracy and social dominance===\nIt is suggested that the Western idea of [[meritocracy]] (individual achievement) is an example of a legitimizing myth, i.e. meritocracy is false and produces only an [[illusion]] of fairness. \nSDT draws on social identity theory, suggesting that social comparison processes drive individual\ndiscrimination (ingroup favouritism). Such acts are performed because they increase the actors [[self-esteem]].\n\nSDT states that an individuals level of discrimination and [[domination]] can be conceptualised, or measured, with the social dominance orientation. This is an individual set of [[beliefs]], sometimes viewed as something akin to a [[Personality psychology|personality]]-trait, which describes the actors views on social domination and the extent to which they will aspire to gain more power and climb the social ladder. For instance, the SDO6 scale measures social dominance orientation by agreement with statements such as Sometimes other groups must be kept in their place and Its probably a good thing that certain groups are at the top and other groups at the bottom.\n\n===SDT and Marxism===\nSDT is influenced by [[Marxism|Marxist]] and socio-biological ideas.  [[Marx]] described the oppressive hierarchy of hegemonic group(s) dominating negative reference groups, in his examples the [[bourgeoisie]] (owning class) dominate the [[proletariat]] (working class) by controlling [[Capital (economics)|capital]] (the means of production), not paying workers enough, and so on. However Marx thought that the working class would eventually grasp the solution to this oppression and destroy the bourgeoisie in a [[revolution]].  Sidanius has similar ideas of oppressive social hierarchies, albeit broadened to include many more types of group, but is pessimistic about change; social dominance is described as a permanent state of society caused by human nature.\n\nSocio-biology views human psychological traits to be ultimately understandable in terms of evolutionary fitness. SDT views group hierarchies as an evolutionary adaptation. Similarly the androgen-mediated dominance of males is explained by reproductive strategy differences between men and women.  \n\n===Criticisms===\nSome attend that recent examples of women in positions of high power disproves the iron law of [[andrarchy]] in which positions of high-power tend to be filled by men.  While such instances do suggest the continuing trend of attenuation in gender-based hierarchy that has been evident in western culture for centuries, no example of a non-subsistence society where males do not dominate in positions of high power or that is free of sex-based discrimination has yet emerged. Social Dominance Theory suggests that extreme gender-group discrimination arises in societies where economic surplus creates the opportunity for large power dynamics.  This view suggests gender based hierarchy will persist in some form until radical political, economic, and cultural changes take place.\n\nSome see Social Dominance Theory as inherently negative because of its focus on oppression, and that it dooms society to endless oppression and exploitation. The stated purpose of the authors, however, is to illuminate the means by which oppression is reinforced in order that it might be lessened, and the theory notes hierarchy attenuating ideologies and structures as well as those that extenuate hierarchy.\n     \nSome argue that oppression is only a result of past historical injustices and will work itself out naturally.  While social dominance theory incorporates inequality and injustice as an important component to the maintenance of group-based hierarchy, defining the unequal distribution of social value, the theory also recognizes the importance of a variety of factors in maintaining oppression which are both empirically and theoretically supported.\n\n===Duckitt and Right Wing Authoritarianism===\n[http://www.victoria.ac.nz/cacr/people/bio/associate%20profiles/john-duckitt.aspx Duckitt] accepts the concept of Social Dominance Orientation and attempts to pair it to a related set of beliefs, Right Wing [[Authoritarianism]] (RWA). This is a set of beliefs which include a rigid view of morality, often fundamentalist religious views, but overall the feeling that the government should have a strong leader, taking action to censor certain social groups (often those who are viewed as physically or morally threatening).\n     \n====Duckitts model====\nDuckitt proposes a model of RWA and SDO including their production by socialization in childhood, personality, and worldview beliefs. Punitive socialisation causes social conformity. This leads to a view of the world as a dangerous, dog-eats-dog place. This fits with RWA beliefs, which influence ingroup and outgroup attitudes.\n     \nSimilarly, unaffectionate socialisation causes a tough-minded attitude. The world is then viewed as a competitive place, similar to the jungle of the evolutionary past. A desire to compete fits with social dominance orientation, which, again, influences ingroup and outgroup attitudes.\n\nThere is a close interaction between the two streams. Firstly the two parenting styles, punitive socialisation and unaffectionate socialisation, are not mutually exclusive but are potentially both present. A competitive-jungle worldview is entirely compatible with seeing the world as a dangerous place. Also, once a person has RWA beliefs, it is likely that they will adapt matching, compatible SDO beliefs, and vice versa.  Finally, outgroup and ingroup attitudes influence each other.\n\n====Testing the model====\nAfter developing this extensive theoretical model, Duckitt tested his model using more than 500 Auckland University students. He used structural equation modeling with correlational data to test the predictions of relations between the SDO, RWA, worldviews, parenting styles, and ingroup/outgroup attitudes. All the predicted pathways were found to have significant (p < 0.05) correlational connections in the correct direction, vindicating the theoretical model.\n     \nThere were a few unpredicted significant correlations. Dangerous-world beliefs directly affected anti-minority attitudes. Unaffectionate socialization had a negative correlation with social conformity - unaffectionate parenting style reduces social conformity beliefs. These correlations were significant at the p < 0.1 level. A repetition of the study in South Africa produced broadly similar results, with differences in the level of overall prejudice (higher in South Africa).\n\nDuckitt further examines the complexities of the interaction between RWA, SDO and a variety of specific ideological/prejudicial beliefs and behaviour. For instance:\n*RWA beliefs are activated by social threat or threatening outgroups\n*SDO beliefs are activated by competition and intergroup inequalities in status and power\n*RWA is a stronger predictor of prejudice when the outgroup is threatening\n*When group status is unstable, SDO is associated with higher ingroup bias (than stable status situations)\n*Outgroup liking is best predicted by similarity to ingroup, while outgroup respect is predicted by status and technological advancement\n     \nDuckitt concludes that RWA and SDO have been well studied, and points out that this way of examining belief-paradigms and motivation-schemas could also be useful for an examination of anti-authoritarian-libertarian and egalitarian-altruistic ideologies.\n\n='
p330
tp331
a(I1
S'A hobby store (or hobby shop) sells recreational modelling and craft supplies and specialty magazines for [[model airplane]]s (both military craft and [[airliner]]s), train models, ship models, house and building models. Some hobby shops may also sell dolls, and collectible coins and stamps.  A subtype of hobby store is a [[game store]],which sells [[board game]]s and [[role playing game]]s. In other cases, some hobby stores sells Rc cars, boats, and model or remote control planes.  \n\n'
p332
tp333
a(I1
S'{{Infobox Person\n| name        = George Kourounis\n| image       =George Kourounis.jpg\n| image_size  = \n| caption     = \n| birth_date  = {{Birth date and age|1970|05|22|df=yes}}\n| birth_place = [[Hull, Quebec|Hull]], [[Quebec]], [[Canada]]\n| residence   = [[Toronto]], [[Canada]]\n| occupation  = professional [[adventurer]],<br />[[storm chaser]],<br />[[motivational speaker]],<br />[[presenter#television presenters|television presenter]] <ref>http://www.adventure-speakers.com/kourounis.htm One Step Beyond Keynote Speakers - George Kourounis</ref>\n| website     = [http://www.stormchaser.ca Stormchaser.ca]\n| footnotes   =\n}}\n\nGeorge Kourounis (born 22 May 1970), is a Canadian [[adventurer]], television presenter, [[storm chaser]], and explorer, currently best known for his television series [[Angry Planet]]. He specializes in documenting extreme weather and worldwide natural disasters.\n\n==Storm Chasing==\n\nKourounis has been a storm chaser since 1997 and documents all forms of severe weather including tornadoes, hurricanes, blizzards, floods, hail and lightning.\n\nIn January 2005, George brought his camera to the remote Danakil Depression in the harsh Ethiopian desert and was lowered 60 feet into the smoking crater of the active [[Erta Ale]] volcano. He spent a half hour filming on top of the freshly hardened surface of the [[lava lake]] wearing a protective heat suit. <ref>http://www2.canada.com/national/features/extreme_weather/story.html?id=89312919-8c94-4d35-8b6a-f9986fbd2040 </ref>\n\nThis made him the first person to have ever filmed from the inside of three of worlds most fearsome forces  a [[tornado]], the eye of a [[hurricane]], and an active [[volcano]]. He was able to intercept all four of the major U.S. land falling hurricanes in 2005, including devastating [[Hurricane Katrina]] in [[Gulfport, Mississippi]]. While he filmed the storm, the city around him was disintegrating in the incredible winds.\n\nSome of his other accomplishments include:\nDocumenting [[Mountain Gorilla]]s in Rwanda, climbing [[Mount Nyiragongo]] volcano in the Democratic Republic of Congo, and documenting numerous destructive tornadoes across the United States. He has also filmed forest fires, floods, lightning and great white sharks. In 2006, he and his wife Michelle were married on the craters edge of the erupting Yasur volcano on the island of Tanna in Vanuatu. The ceremony was documented for his television series, Angry Planet. <ref>http://www.angryplanet.tv/Season01.html </ref>\n\n==Television==\n\nKourounis entered television work with numerous appearances in weather documentary programs featuring severe weather and natural disasters. Kourounis has been a guest on television programs, including CTV Newsnet, Anderson Cooper 360, BBC-TV and Discovery Channels [[Daily Planet]]. <ref>http://www.oln.ca/details.php?id=22 </ref>\n\n===Angry Planet===\n\nKourounis co-created and hosts a television series titled [[Angry Planet]]. for OLN in Canada, The Travel Channel in Europe and The Weather Channel in Australia.\n\nThe series features Kourounis traveling to worldwide locations and examining various extreme forces of nature, typically at close range. The series premiered in March 2007 and production of the third season is currently underway. <ref>http://www.angryplanet.tv/ </ref>\n\nThe show has featured such Kourounis participating in such adventures as tornado chasing, rappelling into erupting volcanoes, driving into the eye of hurricanes, enduring extremes of heat and cold and boating on a lake of sulphuric acid in Indonesia. Kourounis often teams up with scientists or local experts who assist in the adventures. Filming has taken place on all 7 continents.\n\nKourounis was nominated for a 2008 Gemini award for his work on Angry Planet.\n\n'
p334
tp335
a(I-1
S'__NOTOC__\n[[Image:ISSP-map.png|thumb|Map of the 41 member nations of ISSP.]]\nThe International Social Survey Programme (ISSP) is a collaboration between different nations conducting surveys covering topics which are useful for social science research. The ISSP researchers develop questions which are meaningful and relevant to all countries which can be expressed in an equal manner in different languages. The results of the surveys provide a cross-national and cross-cultural perspective to individual national studies. As of 2009 there were 45 member countries.\n\n== History ==\nThe ISSP was founded in [[1984]] by research organizations from four countries:\n* [[Zentrum fr Umfragen, Methoden, und Analysen]] (ZUMA), [[Mannheim]], [[Germany]].\n* [[National Opinion Research Center]] (NORC), [[University of Chicago]], [[Chicago]], [[Illinois]], [[USA]].\n* [[Social and Community Planning Research]] (SCPR), [[London]], [[United Kingdom]].\n* [[Research School of Social Sciences]] (RSSS), [[Australian National University]], [[Canberra]], [[Australia]].\n\n== Members ==\n{| width=100% style=background: transparent\n|- valign=top\n| width=25% |\n{| style=background: transparent\n|-\n| {{flagicon|Australia}} [[Australia]]\n|-\n| {{flagicon|Austria}} [[Austria]]\n|-\n| {{flagicon|Belgium}} [[Belgium]]\n|-\n| {{flagicon|Brazil}} [[Brazil]]\n|-\n| {{flagicon|Bulgaria}} [[Bulgaria]]\n|-\n| {{flagicon|Canada}} [[Canada]]\n|-\n| {{flagicon|Chile}} [[Chile]]\n|-\n| {{flagicon|Croatia}} [[Croatia]]\n|-\n| {{flagicon|Cyprus}} [[Cyprus]]\n|-\n| {{flagicon|Czech Republic}} [[Czech Republic]]\n|-\n| {{flagicon|Denmark}} [[Denmark]]\n|}\n| width=25% |\n{| style=background: transparent\n|-\n| {{flagicon|Dominican Republic}} [[Dominican Republic]]\n|-\n| {{flagicon|Finland}} [[Finland]]\n|-\n| {{flagicon|France}} [[France]]\n|-\n| {{flagicon|Germany}} [[Germany]]\n|-\n| {{flagicon|Hungary}} [[Hungary]]\n|-\n| {{flagicon|Ireland}} [[Republic of Ireland|Ireland]]\n|-\n| {{flagicon|Israel}} [[Israel]]\n|-\n| {{flagicon|Japan}} [[Japan]]\n|-\n| {{flagicon|Latvia}} [[Latvia]]\n|-\n| {{flagicon|Mexico}} [[Mexico]]\n|-\n| {{flagicon|Netherlands}} [[Netherlands]]\n|}\n| width=25% |\n{| style=background: transparent\n|-\n| {{flagicon|New Zealand}} [[New Zealand]]\n|-\n| {{flagicon|Norway}} [[Norway]]\n|-\n| {{flagicon|Philippines}} [[Philippines]]\n|-\n| {{flagicon|Poland}} [[Poland]]\n|-\n| {{flagicon|Portugal}} [[Portugal]]\n|-\n| {{flagicon|Russia}} [[Russia]]\n|-\n| {{flagicon|Slovakia}} [[Slovakia]]\n|-\n| {{flagicon|Slovenia}} [[Slovenia]]\n|-\n| {{flagicon|South Africa}} [[South Africa]]\n|-\n| {{flagicon|South Korea}} [[South Korea]]\n|-\n| {{flagicon|Spain}} [[Spain]]\n|}\n| width=25% |\n{| style=background: transparent\n|-\n| {{flagicon|Sweden}} [[Sweden]]\n|-\n| {{flagicon|Switzerland }} [[Switzerland]]\n|-\n| {{flagicon|Taiwan}} [[Republic of China]]\n|-\n| {{flagicon|Turkey}} [[Turkey]]\n|-\n| {{flagicon|Uruguay}} [[Uruguay]]\n|-\n| {{flagicon|UK}} [[United Kingdom|UK]]\n|-\n| {{flagicon|USA}} [[United States|USA]]\n|-\n| {{flagicon|Venezuela}} [[Venezuela]]\n|}\n|}\n\n=== Australia ===\n* ACSPRI Centre for Social Research (ACSR), [[Australian National University]].\n\n=== Austria ===\n* Institute of Sociology, [[University of Graz]].\n\n=== Belgium ===\n* The Administration of Planning and Statistics of the Ministry of Flanders.\n* Walloon Institute of Assessment, Forecasting and Statistics (IWEPS).\n* Department of Sociology, [[Katholieke Universiteit Leuven]].\n\n=== Brazil ===\n* Instituto Universitrio de Pesquisas do Rio de Janeiro. (former member)\n\n=== Bulgaria ===\n* The Agency for Social Analyses (ASA).\n\n=== Canada ===\n* School of Journalism and Communication, [[Carleton University]].\n\n=== Chile ===\n* Centro de Estudios Publicos.\n\n=== Croatia ===\n* Institute for social research.\n\n=== Cyprus ===\n* Center of Applied Research (CAR), [[Cyprus College]].\n\n=== Czech Republic ===\n* Institute of Sociology, Academy of Sciences of the Czech Republic.\n\n=== Denmark ===\n* Dept. of Economics, Politics, and Public Administration, [[Aalborg University]].\n\n=== Dominican Republic ===\n* Fundacion Global Democracia y Desarrollo (FUNGLODE).\n\n=== Finland ===\n* Department of Sociology and Social Psychology, [[University of Tampere]].\n* Statistics Finland.\n* Finnish Social Science Data Archive.\n\n=== France ===\n* Centre for the Informationisation of Socio-Political Data (CIDSP).\n* Institute for Longitudinal Studies.\n* Quantitative Sociology Laboratory, National Institute for Statistics and Economic Studies (INSEE).\n* Centre for the Study of Social Change (CNRS and FNSP).\n\n=== Germany ===\n* Centre for Survey Research and Methodology (Zentrum fr Umfragen, Methoden und Analysen) (ZUMA).\n\n=== Hungary ===\n* The Social Research Informatics Center (TRKI RT).\n\n=== Ireland ===\n* Social Science Research Centre, [[University College Dublin]].\n\n=== Israel ===\n* The B.I. and Lucille Cohen Institute for Public Opinion Research, [[Tel Aviv University]].\n\n=== Japan ===\n* NHK Broadcasting Culture Research Institute.\n\n=== Latvia ===\n* Institute of Philosophy and Sociology.\n\n=== Mexico ===\n* The [http://www.imocorp.com.mx Institute of Marketing and Opinion].\n\n=== The Nederlands ===\n* Faculty of Social Sciences, [[Vrije Universiteit]].\n\n=== New Zealand ===\n* Department of Marketing, [[Massey University]].\n\n=== Norway ===\n* Norwegian Social Science Data Services (NSD).\n\n=== The Philippines ===\n* Social Weather Stations.\n\n=== Poland ===\n* Institute for Social Studies (ISS), [[University of Warsaw]].\n\n=== Portugal ===\n* Instituto de Cincias Sociais (ICS), [[University of Lisbon]].\n\n=== Russia ===\n* The Levada Center.\n\n=== Slovakia ===\n* The Institute for Sociology of the Slovak Academy of Sciences.\n\n=== Slovenia ===\n* Public Opinion and Mass Communication Research Centre (CJMMK).\n\n=== South Africa ===\n* Human Science Research Council.\n\n=== South Korea ===\n* Survey Research Center (SRC), [[Sungkyunkwan University]].\n* Samsung Economic Research Institute (SERI).\n\n=== Spain ===\n* Anlisis Sociolgicos, Econmicos y Polticos (ASEP).\n\n=== Sweden ===\n* Department of Sociology, [[University of Ume]].\n\n=== Switzerland ===\n* Swiss Information and Data Archive for the Social Sciences (SIDOS). \n\n=== Taiwan ===\n* Institute of Sociology; Center for Survey Research, [[Academia Sinica]].\n\n=== Turkey ===\n* Istanbul Policy Centre (IPC).\n\n=== Uruguay ===\n* Department of Economics (deCON), Faculty of Social Sciences; Institute of Statistics (IEsta), Faculty of Economics and Administration, [[University of Uruguay]].\n\n=== United Kingdom ===\n* [[The National Centre for Social Research]].\n\n=== United States ===\n* [[National Opinion Research Center]] (NORC), [[University of Chicago]].\n\n=== Venezuela ===\n* Laboratorio de Ciencias Sociales (LACSO).\n\n== National pride survey ==\nA survey of 34 countries was conducted and the results were released on [[June 27]], [[2006]]. The survey asked respondents to rate how proud they were of their country in ten areas:\n# political influence\n# social security\n# the way their democracy works\n# economic success\n# science and technology\n# sports\n# arts and literature\n# military, history\n# fair treatment of all groups in society.\n\nThe United States ranked first in terms of overall [[patriotism|national pride]] with Venezuela coming in a close second. Ireland, South Africa, and Australia came in third, fourth, and fifth respectively. The researchers commented that patriotism is a [[New World]] concept and that former colonies and newer nations tend to rank higher on the list.\n\nWestern European, East Asian, and former socialist countries tend to rank between the middle and bottom of the list. Countries formerly part of the [[Soviet Union]] are still struggling to find their own new [[national identity]] while cultural differences in East Asia could provide a possible explanation for their low ranking in the list. Japan, Taiwan, and South Korea ranked 18th, 29th, and 31st possibly due to the common belief that it is both bad luck and poor manners to be boastful.\n\n[[Venezuela]] has been ranking high on the list due to President [[Hugo Chvez]] challenging the United States, particularly the [[George W. Bush administration|Bush administration]] and generating a new sense of national pride and an emphasis on what it means to be Venezuelan.\n\n'
p336
tp337
a(I1
S'Sarah Sophia Banks ([[October 28]] [[1744]] - [[September 27]] [[1818]]) was an English  collector of antiquarian items and sister of the naturalist [[Joseph Banks]].\n\nSarah collected coins and medals and ephemera which is now historically valuable like broadsheets, newspaper clippings, visiting cards, engravings, advertisements, and playbills. Joseph Banks lived with his sister until 1779, and she lived with him and his wife until her death. \n\nHer collections were given to the [[British Museum]] and [[British Library]].\n\n'
p338
tp339
a(I-1
S'Edholms law, named for [[Phil Edholm]], says the [[wireless]], nomadic and wired network capabilities will converge. Soon, even slower communications channels like cellphones and radio modems will eclipse the capacity of early [[Ethernet]], thanks to upcoming standards known as [[UMTS]] and [[MIMO]], which will boost bandwidth by maximizing antenna usage.\n\nExtrapolating forward indicates a convergence between the rates of nomadic and wireless technologies around 2030. \n\n'
p340
tp341
a(I-1
S'In [[multiplayer game|multiplayer online video games]], ping refers to the network [[latency (engineering)|latency]] between a players computer, called a [[client (computing)|client]], and the game [[server (computing)|server]] (or another client). This could be reported quantitatively as an averaged time in [[second|milliseconds]], or qualitatively as low ping or high ping. This usage is common with players of a variety of [[first-person shooter]] and [[real-time strategy]] games. Having a low ping is always desirable because lower latency provides smoother [[gameplay]] by allowing faster updates of game data.\n\nIn this sense, ping is conflated with [[lag]]  one may lag out due to unacceptably high ping. Servers will often  disconnect a client if the connection is too bad and it poses a detriment to others gameplay; or, clients will often mandate disconnection if their ping is too high and they can infer their user is not going to have an enjoyable experience because of network complications.\nHowever, this doesnt mean that a high ping causes lag. The high ping is the result of the lag. In theory, there can be more reasons of having a high ping (for example, you are transmitting data over a very, very long distance), but most servers of commercial games are associating a high ping with network lag directly.\n\nThe method used by the [[game programmer]]s to determine ping times will often not use the traditional [[Internet Control Message Protocol|ICMP]] echo request and reply [[packet (information technology)|packet]]s, but instead piggyback the functionality onto existing game data packets (often using [[User Datagram Protocol|UDP]]).\n\nSome factors that might affect ones ping include: [[protocol (computing)|network protocol]] engineering, internet [[throughput|connection speed]], quality of the internet service provider and the configuration of [[firewall]]s. Ping is also affected by geographical locations. For instance if someone is in China playing a server from America, the distance between the two are farther and it takes a longer time for the data to be sent to China. The amount of packet-switching and network hardware in between the two hosts is often more significant. For instance, [[wireless network interface cards]] must modulate digital signals into [[radio waves|radio signals]], which is often more costly than the time it takes an electrical signal to traverse a reasonable span of cable.\n\n== Cheating ==\nIn some cases, games seem to give unfair advantage to high-ping users, as in some implementations of the [[Half-Life (video game)|Half-Life]] [[protocol (computing)|network protocol]] and [[game engine]]. In these games, the player aided by the higher ping skips around, making it hard to judge where the character is exactly, and thus more elusive to target. For this reason, many servers automatically remove players with higher than average ping - with thresholds going as low as 130 milliseconds.\n\nIn more modern [[multiplayer video game|multiplayer online video games]] implementations, the server keeps track of where the users [[avatar (computing)|avatar]] is, so having a high latency will always be the users peril.\n\n'
p342
tp343
a(I1
S'Aquarium fish feeders are [[electric]] or [[Electronics|electronic]] gadgets that are designed to feed [[aquarium]] fish at regular intervals. They are often used to feed fish when the [[aquarist]] is on vacation or is too busy to maintain a regular feeding schedule.<ref>{{cite web | title =Feeding Your Fish While Youre Gone on a Vacation | publisher =AquariumFish.net | url =http://www.aquariumfish.net/information/feeding_fish_2.htm | accessdate =2009-05-15 }}</ref>\n\n==Design==\nFish feeders are usually clamped to the wall of the tank just over the water. They consist of a hopper which is loaded with a variety of dry food, a timer which rotates the hopper at regular intervals (dispensing food in the process), and a method of setting the interval between feeding and the amount of food dispensed. \n\nMost feeders can dispense [[Flake food|flake]], [[Pellet food|pellet]], or [[Freeze dried food|freeze dried]] food.<ref>{{cite web | last =Hauter | first =Stan | coauthors =Hauter, Debbie | title =Top 9 Automatic Fish Feeders | publisher =About.com | url =http://saltaquarium.about.com/cs/foodcare/tp/TPautofeeders.htm | accessdate =2009-05-15 }}</ref>\n\n==Limitations==\nThough some feeders are designed specifically to keep food dry, many designs allow moisture to seep into the food hopper. This can cause clumping, and can result in the failure of the mechanism. Because fish feeders generally cannot feed [[Frozen food|frozen]] or [[Live food|live]] food, they are not effective options for feeding most [[predatory]] fish.<ref>{{cite web | title =Automatic Fish Feeders | publisher =About.com | url =http://saltaquarium.about.com/od/autofeeders/Automatic_Fish_Feeders.htm | accessdate =2009-05-15 }}</ref>\n\n'
p344
tp345
a(I1
S'Lenco is now a [[netherlands|Dutch]] brand of audio & video equipment and part of the STL Group of brands.<ref>{{cite web\n  | title = STL Group bv Homepage\n  | url = http://www.stl.nl\n  | accessdate = 2007-11-16 }}</ref> \n\nHowever, when audio hobbyists refer to Lenco turntables, they are typically referring to the defunct Lenco AG of Oberburg, Switzerland, a turntable manufacturer of the 1950-1980s. <ref>{{cite web\n  | last = resus\n  | first = (MAX)\n  | title = There is more than the L 75s and L 78s and their derivates\n  | url = http://www.lenco-lovers.com/forum/posting.php?mode=quote&p=20372\n  | date = [[2007-10-05]]\n  | accessdate = 2007-11-18 }}</ref>{{dead link|date=February 2009}}This article will discuss why vintage (used) Lenco turntables are of interest to audio hobbyists.\n\n== Why are vintage Lenco turntables interesting? ==\n\n[[Phonograph|Turntables]] are electromechanical systems used to extract musical signals cut as modulations into vinyl or shellac records. As a system, a turntable typically consists of a platter and drive system (mounted on a [[plinth]]), a tonearm, and a [[Phonograph#Pickup systems|phono cartridge]]. The platter provides the rotational energy to the record placed upon it via the platter drive system, energy which the phono cartridge [[transducer]] (held above the record by the tonearm) needs to trace and convert the modulations into electrical signals. These electrical signals are then amplified and re-equalized, and finally converted into musical sound-waves by loudspeakers. A key functional requirement of a turntable system is the consistency of the platters rotational velocity, especially when high level modulations (loud sounds, typically with low frequency content) provide greater friction to the phono transducer, creating a dynamic load on the platter drive system <ref>{{cite web\n  | last = Brady\n  | first = Chris\n  | date = [[2008-10-06]]\n  | title = Teres MicroPrecise Speed Technology PDF\n  | url = http://www.teresaudio.com/manuals/teres_speed_tech.pdf\n  | accessdate = 2009-01-15\n  | quote = Dealing with stylus drag is another important aspect of a quality turntable drive system.  It would seem that the tiny forces exerted by the stylus would fade into insignificance. However, given our extraordinary sensitivity to micro speed variations, the uneven force from stylus drag is audible and degrades sound reproduction. With a microscopic view, loud passages slightly slow the platters rotation. Contrary to popular beliefs platter mass changes how stylus drag affects speed but does not counteract the effects of stylus drag. A massive platter will reduce the magnitude of the variation but extends it over a longer period of time. A light platter will conversely allow a larger speed variation but it enables more rapid recovery. Heavy vs. light platters exhibit quite different sounding degradations but they are still degradations.  We find the longer shallower variations that result from a heavy platter to be more benign. However, there are others that prefer the degradations from a light platter. The point is that stylus drag causes degradations that are changed but not eliminated by platter mass.  The only effective mechanism for truly reducing stylus drag effects is application of torque from the motor. Increasing the available motor torque makes stylus drag proportionately smaller and therefore will result in a net reduction in the effects of stylus drag. However, increasing torque usually  will at the same time increase cogging. Once again we are back to the need of finding a balance between two competing objectives. To further complicate the situation a compliant coupling between the motor and platter reduces the motors ability to control platter speed. Any compliance between the motor and platter causes a delay in the delivery of torque. When a rubber belt is used additional torque from the motor will cause the belt to stretch. This energy will eventually be delivered to the platter but only after a time delay making it impossible for the motor to compensate for short term effects of stylus drag.}}</ref>. Various techniques are used to rotate the platter and to generate the required rotational energy; a rather unique system was made by the defunct [[Swiss]] turntable manufacturer Lenco.\n\nVintage Swiss made Lenco and Lenco OEM/re-badged Barthe, Benjamin, Bogen, [[Goldring]], Grundig, Komet, and Voxon turntables used a unique vertical idler-drive to rotate the platter, as opposed to a belt drive or more recent [[direct drive turntable]]s. This idler-driver has the advantage of directly coupling the rotating motor force to the platter,  via a solid rubber disc or rubberized wheel.<ref>{{cite web \n|title=More Lencos -\n|url=http://www.freewebs.com/bornin50-2/idlerwheels.htm \n|accessdate=2007-11-16 \n| pageid=13651847}}\n</ref> When coupled to a heavy platter (early model Lencos have cast [[non-ferrous metal]] platters of almost 4 kg), and modified<ref>{{cite web \n|title=The Weekly Grove \n|date=[[2006-12-01]] \n|url=http://www.vinylsa.co.za/pdf/theweeklygroove_20061201.pdf\n|format=PDF\n|accessdate=2007-11-16\n|language=English \n}}\n</ref>\n<ref>{{cite web \n|title=A Lenco motor controller to solve everything\n|date=[[2007-11-10]] \n|url=http://www.lenco-lovers.com/forum/viewtopic.php?t=1802 \n|format= HTML\n|accessdate=2007-11-22 \n|language=English}}\n</ref>{{dead link|date=February 2009 }},the idler-drive can provide excellent rotational consistency, even when heavily modulated passages are tracked by a phono cartridge. Many audiophiles believe that this rotational consistency translates into bass slam (audiophile jargon for impactful bass) and rhythmic fidelity.\n<ref>\n{{cite web\n  | last = melomane\n  | first = Music-Lover-Audiophile-in-Canada\n  | date = [[2005-02-10]]\n  | title = Re: Vintage Turntables (EMT, Garrard, Thorens) Opinions please\n  | url = http://db.audioasylum.com/scripts/t.pl?f=vinyl&m=385552\n  | accessdate = 2007-11-18\n  | quote = Anyway, as a representative of the idler-wheel technology which majors in slam, powerful bass and musical excitement, the Lenco has also easily beaten the tricked-out Linn LP12 (Cetech carbopn-fibre subchassis etc.) in every area including detail, and in all the usual audiophile categories.}}</ref> As a system to impart the needed rotational energy to a vinyl record, the idler-drive is something of a brute-force technique, and the engineering that Lenco used, especially in older models, was both simple and cost effective. As a result, many Lenco turntables were sold throughout the world in its heyday.\n\nBut idler-drive turntable systems are not without drawbacks -- coupling the platter directly to the motor means that vibrations from the motor can be passed to the platter, where they can be picked up and amplified by the sensitive phono cartridge transducer. This will color and degrade the musical signals being amplified. Moreover, the fabrication techniques used to build Lenco turntables exacerbated problems with vibration control, as the idler-drive motor was housed in a cavity that allowed resonance reinforcement, and the motor was not sufficiently damped or decoupled from the plinth to prevent certain colorations.\n\nModern day hobbyists have addressed these short-comings in vintage Lenco turntables by modifying them, eliminating the cavities and providing a high mass chassis/plinth for the turntable. The results are very satisfying to these hobbyists,<ref>{{cite web\n  | last = Steinfeld\n  | first = Richard \n  | title = An article by Richard Steinfeld (Cartridges)\n  | url = http://homepage.ntlworld.com/maddogmcq/myart/lencoheaven/cartridges2.htm\n  | accessdate = 2007-11-17\n  | quote = The cast platter machines bring the Lenco design very close to the audiophile realm, and can make for a very satisfying turntable. }}</ref> especially as the cost to refurbish and modify a used vintage Lenco turntable is small in comparison with the cost of buying a new audiophile-grade turntable (provided that one has invested in the tools needed to tackle such a project -- chief among these a [[table saw|table-saw]] and [[Router (woodworking)|router]]). Subjectively, these turntables are often compared to turntable systems costing many thousands of dollars more. <ref>{{cite web\n  | last = Ebaen\n  | first = Srajan\n  | title = 6moons audio reviews: Lenco L75\n  | date = [[2007-03-01]]\n  | url = http://www.sixmoons.com/audioreviews/lenco/lenco.html\n  | accessdate = 2007-11-18\n  | quote = Some of these folks already owned hi-cred tables. Their hi-massd Lencos either stomped their modern decks or pulled even - for a lot less money.. }}\n</ref>\n\n== Lenco Turntables Models ==\n\n[[Goldring Lenco GL75]] (re-badged Lenco L75)  The ubiquitous Lenco model that many Lenco lovers modify.\n\n'
p346
tp347
a(I-1
S'Professionalization is the social process by which any [[trade]] or [[List of occupations|occupation]] transforms itself into a true [[profession]] of the highest integrity and competence.<ref>{{cite web |last=Nilsson |first= Henrik |title= Professionalism, Lecture 5, What is a Profession? |publisher=[[University of Nottingham]] |date=undated| url=http://www.cs.nott.ac.uk/~nhn/G52GRP/LectureNotes/lecture05-4up.pdf |accessdate=2007-08-05|format=PDF}}</ref> This process tends to involve establishing acceptable [[qualification]]s, a [[professional body]] or association to oversee the conduct of members of the [[profession]] and some degree of demarcation of the qualified from unqualified [[amateurs]]. This creates a hierarchical divide between the knowledge-authorities in the professions and a deferential citizenry.<ref name=polaris.gseis.ucla.edu>http://polaris.gseis.ucla.edu/pagre/conservatism.html What Is Conservatism and What Is Wrong with It? Philip E. Agre, August 2004</ref> This demarcation is often termed occupational closure,<ref>http://www.journals.uchicago.edu/cgi-bin/resolve?id=doi:10.1086/344121&erFrom=-9070006284381187248Guest Kim A. Weeden, Why Do Some Occupations Pay More than Others? Social Closure and Earnings Inequality in the United States, American Journal of Sociology, 108, 2001, pp.55101</ref> <ref>http://soc.sagepub.com/cgi/content/abstract/24/4/675 Anne Witz, Patriarchy and Professions: The Gendered Politics of Occupational Closure, Sociology, 24.4, 1990, pp.675-690</ref> <ref>http://www.ingentaconnect.com/content/routledg/cgee/2003/00000015/00000001/art00004 S. A. L. Cavanagh, The Gender of Professionalism and Occupational Closure: the management of tenure-related disputes by the Federation of Women Teachers Associations of Ontario 1918-1949, Gender and Education, 15.1, March 2003, pp. 39-57</ref> <ref>http://www.eric.ed.gov/ERICWebPortal/custom/portlets/recordDetails/detailmini.jsp?_nfpb=true&_&ERICExtSearch_SearchValue_0=EJ422280&ERICExtSearch_SearchType_0=eric_accno&accno=EJ422280 Karen Mahony & Brett Van Toen, Mathematical Formalism as a Means of Occupational Closure in Computing--Why Hard Computing Tends to Exclude Women, Gender and Education, 2.3, 1990, pp.319-31</ref> as it means that the [[profession]] then becomes closed to entry from outsiders, [[amateurs]] and the unqualified: a stratified occupation defined by professional demarcation and grade.<ref>http://careerfocus.bmj.com/cgi/content/full/328/7431/s19 Rhona Macdonald, The Hospital at Night, British Medical Jnl, 2004</ref> The origin of this process is said to have been with guilds during the Middle Ages, when they fought for exclusive rights to practice their trades as journeymen, and to engage unpaid apprentices.<ref>see Benton, 1985</ref> \n\nProfessions also possess [[Power (sociology)|power]],<ref>see Johnson, 1972</ref> [[prestige]], [[high income]], high [[status]] and [[privileges]];<ref>http://64.233.183.104/search?q=cache:3bUoc0ranJ0J:www.usca.edu/essays/vol62003/tinsley.pdf+professional+esteem&hl=en&ct=clnk&cd=9&gl=uk Ron Tinsley & James C Hardy, Faculty Pressures and Professional Self-Esteem: Life in Texas Teacher Education.</ref> <ref>http://www.rcpath.org/index.asp?PageID=28 Royal College of Pathologists, The role of the College and benefits of membership, 16 Dec 2005</ref> their members soon come to comprise an [[elite]] [[Social class|class]] of people, cut off to some extent from the common people, and occupying an elevated station in society: a narrow elite...a hierarchical social system: a system of ranked orders and classes. <ref name=polaris.gseis.ucla.edu/>\n\nThe professionalization process tends to establish the group [[Norm (sociology)|norms]] of conduct and [[qualification]] of members of a [[profession]] and tends also to insist that members of the [[profession]] achieve [[conformity]] to the norm.<ref>http://ndpr.nd.edu/review.cfm?id=4281 Steven Hetcher, Norms in a Wired World, Cambridge University Press, 2004, 432pp, Reviewed by Stefan Sciaraffa, University of Arizona</ref> <ref>http://www.medialens.org/bookshop/guardians_of_power.php David Edwards and David Cromwell, Guardians of Power: The Myth of the Liberal Media, Medialens, 2005, Ch. 11</ref> and abide more or less strictly with the established procedures and any agreed [[code of conduct]], which is policed by [[professional bodies]], for accreditation assures conformity to general expectations of the profession. \n<ref>http://www.acpe-accredit.org/deans/accreditation.asp Introduction to the Professional Degree Program Accreditation Process, Accreditation Council for Pharmacy Education, Chicago</ref>\n\n'
p348
tp349
a(I1
S'{{Mergeto|Society of American Magicians|date=May 2009}}\nThe Society of Young Magicians (S.Y.M.) is a group of magicians under the age of 18 which is sponsored by the [[Society of American Magicians]]. The Society of Young Magicians has clubs, known as assemblies around the world usually associated with an adult S.A.M group.\n\nYouth aged 7 through 17 may seek membership in the S.Y.M. When a member turns 18, he or she graduates to full membership in the Society of American Magicians.\n\nThe purpose of the Society of Young Magicians is to promote interest in [[Magic (illusion)|magic]] as a hobby that develops skill and self-confidence, the ability to speak in public, discipline that comes from learning, practicing and performing magic and a sense of service to others through helping others learn magic and by performing magic at charitable events.\n\nThe Society of Young Magicians has nearly 100 local chapters, or assemblies, around the world. Adult members of the Society of American Magicians supervise and instruct members of the S.Y.M.\n\nJann Goodsell is the current S.Y.M.s National Director. S.Y.Ms principle means of communication among its members is its e-zine, The Magic SYMbol.\n\n'
p350
tp351
a(I1
S'Hybridity refers in its most basic sense to mixture. The term originates from [[biology]] and was subsequently employed in linguistics and in racial theory in the nineteenth century. Its contemporary uses are scattered across numerous academic disciplines and is salient in [[popular culture]]. This article explains the history of hybridity and its major theoretical discussion amongst the discourses of race, [[post-colonialism]], [[Identity (social science)]], [[anti-racism]] & [[multiculturalism]], and [[globalization]]. This article illustrates the development of hybridity rhetoric from biological to cultural discussions.\n\n==Hybridity as racial mixing==\nHybridity originates from the Latin hybrida, a term used to classify the offspring of a tame sow and a wild boar. A hybrid is something that is mixed, and hybridity is simply mixture. As an explicative term, hybridity became a useful tool in forming a fearful discourse of racial mixing that arose toward the end of the 18th Century. Scientific models of anatomy and [[craniometry]] were used to argue that Africans and Asians were racially inferior to Europeans. The fear of [[miscegenation]] that followed responds to the concern that the offspring of racial interbreeding would result in the dilution of the European race. Hybrids were seen as an aberration, worse than the inferior races, a weak and diseased mutation. Hybridity as a concern for racial purity responds clearly to the zeitgeist of colonialism where, despite the backdrop of the humanitarian [[age of enlightenment]], social hierarchy was beyond contention as was the position of Europeans at its summit. The social transformations that followed the ending of colonial mandates, rising immigration, and economic liberalisation profoundly altered the use and understanding of the term hybridity. (For the history of hybridity as a concept, see [[Robert J.C. Young]]s Colonial Desire, 1995)\n\n==The postcolonial turn==\nThe rhetoric of hybridity, sometimes referred to as hybrid talk is fundamentally associated with the emergence of postcolonial discourse and its critiques of [[cultural imperialism]]. This second stage in the history of hybridity is characterised by literature and theory that focuses on the effects of mixture upon identity and culture. Key theorists in this realm are [[Homi Bhabha]], [[Stuart Hall (cultural theorist)|Stuart Hall]], [[Gayatri Spivak]], and [[Paul Gilroy]], whose work responds to the increasing multicultural awareness of the early nineteen nineties. Often the literature of postcolonial and magical realist authors such as [[Salman Rushdie]], [[Gabriel Garca Mrquez]], [[Milan Kundera]], and [[J. M. Coetzee]] recur in their discussions. \nA key text in the development of hybridity theory is Homi Bhabhas The Location of Culture (1994) which analyses the [[liminality]] of hybridity as a paradigm of colonial anxiety. His key argument is that colonial hybridity, as a cultural form, produced ambivalence in the colonial masters and as such altered the authority of power. Bhabhas arguments have become key in the discussion of hybridity. While he originally developed his thesis with respect to narratives of cultural imperialism, his work also develops the concept with respect to the cultural politics of migrancy in the contemporary metropolis. \nThis critique of cultural imperialist hybridity meant that the rhetoric of hybridity became more concerned with challenging [[essentialism]] and has been applied to sociological theories of identity, multiculturalism, and racism.  Another key component of hybridity theory is [[Mikhail Bakhtin]], whose concept of polyphony is employed by many analysts of hybrid discourses in folklore and anthropology (see Theorizing the Hybrid).\n\n==A rhetorical cul-de-sac==\nThe development of hybridity theory as a discourse of anti-essentialism marked the height of the popularity of academic hybridity talk. However the usage of hybridity in theory to eliminate essentialist thinking and practices (namely racism) failed as hybridity itself is prone to the same essentialist framework and thus requires definition and placement. A number of arguments have followed in which promoters and detractors argue the uses of hybridity theory. Much of this debate can be criticised as being excessively bogged down in theory and pertaining to some unhelpful quarrels on the direction hybridity should progress e.g. attached to racial theory, post-colonialism, cultural studies, or globalization. Sociologist [[Jan Nederveen Pieterse]] (2004) highlights these core arguments in a debate that promotes hybridity. Some on the left, such as cultural theorist [[John Hutnyk]], have criticised hybridity as politically void.\n\n==The cultural effect of globalization==\nThe next phase in the use of the term has been to see hybridity as a cultural effect of globalization. For example, hybridity is presented by Kraidy (2005:148) as the cultural logic of globalization as it entails that traces of other cultures exist in every culture, thus offering foreign media and marketers transcultural wedges for forging affective links between their commodities and local communities. Another promoter of hybridity as globalization is Nederveen Pieterse, who asserts hybridity as the [[rhizome]] of culture. He argues that globalization as hybridization opposes views which see the process as homogenising, modernising, and westernising, and that it broadens the empirical history of the concept. However neither of the scholars have reinvigorated the hybridity theory debate in terms of solving its inherent problematics. The term hybridity remains contested precisely because it has resisted the appropriations of numerous discourses despite the fact that it is radically malleable.\n\n'
p352
tp353
a(I1
S'The CoroBot is a small (approx. 20 pound) [[mobile robot]] made by [[CoroWare]], Inc.  This 4 wheeled [[robot]] has an on board mini-ITX computer and an optional 4 [[DOF]] arm.  Out of the box, the robot does not have any [[autonomous robot|autonomous]] behavior, instead, it comes with two optional operating systems: Windows XP with [[Microsoft Robotics Studio]], or Linux with [[Player Project|Player Stage]].  It is then up to the user to add additional capabilities to the robot.  \n\nBuilt from mostly off-the-shelf components, the platform carries a web-cam , two Sharp [[IR]] distance sensors, a wireless Ethernet card, and miscellaneous other sensors.  These allow the robot to be easily [[Telerobotics|teleoperated]].  The robot is primarily marketed towards research institutions and hobbyists.\n\nThe first CoroBot was developed for [[Robonexus]] 2004 and was based on [[Windows XP]] Professional.  CoroBot was later renamed CoroWare Surveyor, and is being used at [[Vassar College]] for cognitive sciences research.\n\nIn May 2007, CoroWare relaunched [http://www.corobot.net CoroBot] as the first product line of mobile robotic platforms from the companys Robotics and Automation group <ref>{{cite web|url=http://www.prweb.com/releases/2007/5/prweb526448.htm|publisher=PR Web|title=CoroWare Introduces CoroBot|accessdate=2007-11-07}}</ref>.\n\n'
p354
tp355
a(I-1
S'Blackhawk Films, from the 1950s through the early 1980s, marketed motion pictures on [[16mm]], [[8mm]] and  [[Super 8]] film. Most were vintage one- or two-reel short subjects, usually comedies starring [[Laurel and Hardy]], [[Our Gang]], [[Charlie Chaplin]], [[Buster Keaton]], and other famous comedy series of the past. Blackhawk also offered [[newsreels]], [[documentaries]], and silent feature films. With the rise of the [[video]] market in the early 1980s, Blackhawk began producing video versions of many of their titles in 1981 and within a few years no longer manufactured film copies. The company was later purchased by [[Republic Pictures]], and the film elements still later by archivist [[David Shepard (film preservationist)|David Shepard]].\n\n==History of Blackhawk Films==\nThe company was founded in 1927 as Eastin Pictures by Kent D. Eastin, who made movie ads for merchants, filmed local news events for theater newsreels and sold independent 35 mm theatrical film prints for home projectors of the day. Eastin worked from his parents home in [[Galesburg, Illinois]]. With the advent of 16 mm sound film in 1934, Eastin moved his company to [[Davenport, Iowa]], operating a rental library until 1957 when business slowed due to television. Davenport was also home to the Victor Animatograph Corporation, a pioneer motion picture equipment manufacturer.\n\nWith a background in direct mail and management, Martin D. Phelan left [[Montgomery Ward]] to become Eastins business partner in 1947. The Blackhawk name was first used for a secondary business, liquidating stocks of used 16 mm prints from British Information Services, Mills Panoram Soundies and other libraries and producers. Blackhawk began publishing monthly catalogs in 1949. More than 2,500,000 used films were sold by mail order before this business was discontinued in 1981.\n\nIn 1952, Blackhawk introduced its own releases in both 8 mm and 16 mm. Included in this Collector Series were [[Laurel and Hardy]] silents from [[Hal Roach Studios]], authorized editions of Keystone comedies licensed by Sennetts original backer, Roy Aitken, and a group of railroad films (Eastin was a lifelong rail fan). Consumer interest grew, and soon Blackhawk was offering a wide variety of vintage comedies, dramas, westerns, musicals, documentaries, serials, and cartoons. Blackhawk continued to cater to dyed-in-the-wool silent-film enthusiasts; [[Art Acord]], [[Theda Bara]], Charles Hutchinson, Lige Conley, [[Lloyd Hamilton]], [[Alice Howell]], and [[Richard Talmadge]] were just some of the silent-era personalities whose work had almost totally vanished until Blackhawk brought some representative reels to light. The company issued a tabloid-sized catalog, the Blackhawk Bulletin, which heralded the latest releases and sales promotions each month.\n\nBoasting up to 18 new releases every month, an in-house film restoration facility as good as any owned by film archives, and more than 90 employees working in a picturesque, century-old building of roughly {{convert|30000|sqft|m2}}, Blackhawk grew to dominate the home-movie field with a base of 125,000 customers. Fox [[Movietone News]], silent-film revivalist Paul Killiam, and [[National Telefilm Associates]] joined Hal Roach as important sources for Blackhawks releases. Other rare finds were offered to Eastin by private collectors, for reprinting in the home-movie gauges.\n\nSince the late 1960s, [[David Shepard (film preservationist)|David Shepard]] of the [[American Film Institute]] had been working closely with Kent Eastin to ensure permanent preservation of Blackhawks unique original films at the Library of Congress. Shepard joined the Blackhawk Films staff in 1973, and spearheaded the ambitious restoration of [[Charlie Chaplin]]s twelve Mutual comedies of 1916-17. Shepard later became vice president of Blackhawk Films.\n\nIn 1975, with business booming in the Super 8 and 16 mm film formats, Eastin and Phelan sold Blackhawk to Lee Enterprises, a successful newspaper and broadcasting conglomerate. The rapid rise in the price of silver (essential to black-and-white film processing) caused home-movie retail prices to skyrocket, and many collectors abandoned film in favor of then-new home video. Lee Enterprises decision to emphasize mail-order sales instead of a unique product line, and heavy investments in the [[Betamax]] and CED ([[RCA]] mechanical video disc) formats, proved very costly.\n\nLee Enterprises sold the company to its Blackhawk management team, who continued until 1985 when [[Republic Pictures]] bought the company. Republic discontinued film sales and closed the Davenport facility in 1987. \n\nShepard is now owner of Film Preservation Associates, specializing in restoration of silent film classics. He started FPA with the purchase of the Blackhawk film library. Although the film-sales business had slowed dramatically, Shepard continued to serve serious hobbyists by selling new 16 mm prints of Blackhawk subjects, made to order. In July 2007 he announced that Blackhawk Films would discontinue the 16 mm business. Shepard now devotes his energies to video restorations of classic motion pictures.\n\n==Links==\n*[http://www.fesfilms.com/16mmFilms.html 16mm Blackhawk Films Collections]\n*[http://www.spencersundell.com/blog/2006/07/22/melies_titles_from_the_blackhawk_anthologies/ George Melies Titles from the Blackhawk Films Anthologies]\n*[http://www.filmclassic.com/Blackhawkhistory.htm Mark Roths The Story of Blackhawk Films]\n*[http://8mmforum.film-tech.com/ubb/ultimatebb.php 8mm Forum] \n\n'
p356
tp357
a(I-1
S'The Microbric I-Bot is a small [[robot]] that was distributed as a [[build-it-yourself]] kit by the [[Adelaide Advertiser]] newspaper in [[South Australia]], in November-December 2005. It is designed to be used as an introduction to [[electronics]] and to teach [[robotics]].\n\nThe I-Bot was created by [[Microbric]], manufactured by [http://www.tytronics.com.au Tytronics], distributed by The Advertiser/[[Sunday Mail]] (Newspapers in Education) and supported by the [[Electronics Industry Association]] in Australia.\n\nWith the aid of internet forums, a community of I-bot users has rapidly grown around this little electronic gizmo.   \n\n==Programming==\nPrograms can be created and uploaded to the I-Bot, via [[Microsoft Windows|Windows]] and [[Mac OS|Mac]] software available from the I-Bot website. A simple [[graphical interface]] is used to create programs\nwhich can then be uploaded to the I-Bot via holding it up to a flashing square on the display. \n\nThe programmer requires internet access, but I-Bot programs can be shared with others using a shareId number.\n\n==Available programs==\n* 312 - Plays We wish you a Merry Christmas music (by Zetter)\n* 318 - As 312, but with cycling lights (by Zetter)\n* 341 - Reverse Parallel Park (by Jimbot)\n* 480 - Plays Can Can music (by Joshua Bost)\n* 714 - Take a Bow (by pschulz01)\n* 748 - As 714, but with IR control (by pschulz01)\n* 725 - Turn, Twist and Shake (by Aquaspoon)\n* 847 - Timer Demonstration (by sgregory)\n* 969 - Bump-n-go (by sgregory)\n* 1188 - Play Jingle Bells music (by craig)\n* 1274 - Play Swan Lake music (by brenton)\n\n'
p358
tp359
a(I-1
S'{{DIY party}}\n[[image:Cztk2000.gif|thumb|Cztk00]]\nCzechTek was an annual [[teknival]] normally held on the weekend at the end of July in the [[Czech Republic]]. It attracted thousands of [[free tekno]] dancers from several European countries (40,000 people attended in 2003 and 2006). Open invitations were usually  made to all soundsystems, performers and all human beings with positive thinking. \n\nThe first CzechTek was in 1994 at [[Hostomice]]. Every year the festival was being held in different locations around the Czech Republic on the same date. The festival was not the same as more commercial festivals such as the [[Love Parade]] or the [[Street Parade]]. It was usually set on ex-military land or in a meadow near the forest. There was little or no organisation, since the idea of free tekno is based on personal freedom and responsibility, although later teknivals required organization due to large number of attendees. The style (or image) of the people was also different (from that the Love Parades participants) - it was more underground. The location of the meeting was always revealed one day before the action on Czech rave websites.\n\nThe Czech media highly publicized the last two technivals of 2005 and 2006, which largely added to its demise since media it attracted many people that did not understand free tekno culture.\n\n== History ==\n[[Image:Czechtek04Flash.jpg|thumb|right|<small> 2004, Techno.cz. Foto: flash </small> CzechTek 2004]]\n\n{| class=wikitable\n|-\n! Date\n! colspan=2 | Location\n! Number of people\n|-\n| 28 July  ? 1994\n| Hostomice pod Brdy\n| legal\n| 300\n|-\n| 26 July - ? 1995\n| Hostomice pod Brdy\n| legal\n| 300\n|-\n| 26  28 July 1996\n| Hostomice pod Brdy\n| legal\n| 1.500\n|-\n| 25  27 July 1997\n| Star Hu near Dobr\n| legal\n| 5.000\n|-\n| 30 July  4 August 1998\n| Star Hu near Dobr\n| legal\n| 5.000\n|-\n| 30 July - 4 August 1999\n| Hradany nad Plounic near Ralsko\n| illegal\n| 5.000\n|-\n| 28 July  2 August 2000\n| Lipnice near Tebo\n| illegal\n| 10.000\n|-\n| 27  30 July 2001\n| Doksy\n| illegal\n| 10.000\n|-\n| 26  31 July 2002\n| Andlka near Viov\n| legal\n| 20.000\n|-\n| 25 July - 3 August 2003\n| Letkov near Kopidlno\n| legal\n| 40.000\n|-\n| 30 July  3 August 2004\n| Bonnov near Chodov Plan\n| illegal\n| 20.000\n|-\n| 29 - 31 July 2005\n| Mlnec pod Pimdou\n| legal*\n| 5.000\n|-\n| 27  30 July 2006\n| Military Area Hradit\n| legal\n| 40.000\n|}\n\n==CzechTek 2005==\n[[Image:Freetekno police czech.jpg|thumb|Riot police at CzeckTek in 2005]]\nIn 2005 shortly after the start, the CzechTek festival was broken up. The organizers of CzechTek have claimed to be permissed to set up the event around Mlynec, in the west of the country close to the German border. However police arrived with around 1,000 [[riot police]] using heavy equipment including [[tear gas]], [[water cannon]]s and the military [[BVP M-80|BVP vehicle]] stating damage of private property. Allegedly in reaction one collector of army vehicles arrived with his own to see the others response{{Fact|date=June 2009}}. The standoff between police and public resulted in one death among the public{{Fact|date=June 2009}}, and approximately 30 civilians and 50 police injured. Protests arose outside the Czech [[interior ministry]]. The Czech president criticized the heavy use of police force. The [[Prime Minister of the Czech Republic|Prime Minister]], [[Ji Paroubek]], defended the action, stating that the [[techno music|techno]] fans were not dancing children but dangerous people.\n\nSeveral months after the clash all charges against police were dropped{{Clarify me|June 28 2009|date=June 2009}}{{Fact|date=June 2009}}. In April 2006, there was a march followed by a [[free party]] in Strasbourg, France to protest against police repression in general and against the actions of the Czech police in closing CzechTek in specific.\n\n==CzechTek 2006==\nOn 14 June 2006 an agreement was signed between the Ministry of Defence and the Association of Czech Sound Systems. The festival was held on land which was part of the Hradit Military Region. It took place without any repeat of the previous years violence.\n\n==Czechtek Discontinued==\n\nAs the co-ordinators stated (on official site of CZTK) after last event(2006), Czechtek is discontinued.<br />\n\nManifest<br />\nIn regard of fact that situation around Czechtek isnt bearable anymore, the representatives \nof czech freetekno community came to this radical decision. This year, and very probably even \nnever again, any action of size and under name Czechtek wont be realized.\n</blockquote>\nAnd these are the reasons: \n* step-by-step abolition of original thoughts of freetekno \n* parasitic behavior of subject not connected to the scene including major part of visitors themselves \n* disability and reluctance to respect elementary principles of behavior in shared space\n\nSigned by:<br />\nOktekk, Strahov, NSK, AKA.IO, Komatsu, Spiritual, Mayapur, Layka, Pentatonika, Merkur, \nFatal Noise, Matchbox, Luxor, Cirkus Alien, Vosa, Bazooka, Koryto, Shamanic, Zuqwa, \nCzajovna, Figura, Machine Works, Metro, Ultimate Crew, Basswood, Mutaphone, FDM, Jednota, \nTMC, NabaziGangoo, Massive Elementz, UANDU Tribe, MHD, Hondzik Sound, Witacid, Iluzor, \nDetox23, Pandemic, Spectro, Radiator, Swampsound, Gummo, EskanoiZZe, Tsunami, Yaga, \nSynthetik, MiMiK, Squakka, Mandala, Alkaline, Dynamodestroy, Triptekk, Tekkirk, Remek, \nFSS, Shadow cabaret, Invaders, Mushroom, Bassmekk, Swazarm, Techamin, Laydakk, Othersidesystem, \nInkognito, T2B ...\n\n'
p360
tp361
a(I-1
S'{{for|the Los Angeles councilperson|Dennis Zine}}\n{{Refimprove|date=June 2008}}\n{{Original research|date=November 2008}}\n\nA zine (an abbreviation of the word [[fanzine]], or magazine; {{pron-en|zin}} zeen) is most commonly a small circulation [[publication]] of original or appropriated texts and images. More broadly, the term encompasses any [[self-publishing|self-published]] work of minority interest usually reproduced via photocopier on a variety of colored paper stock.\n\nA popular definition includes that circulation must be 5,000 or less, although in practice the significant majority are produced in editions of less than 100, and profit is not the primary intent of publication.\n\nZines are written in a variety of formats, from computer-printed text to comics to handwritten text (an example being [[Cometbus]]). Print remains the most popular zine format, usually photo-copied with a small circulation. Topics covered are broad, including fanfiction, [[politics]], art and design, ephemera, personal journals, social theory, single topic obsession, or sexual content far enough outside of the [[mainstream]] to be prohibitive of inclusion in more traditional [[Mass media|media]]. The time and materials necessary to create a zine are seldom matched by revenue from sale of zines. Small circulation zines are often not explicitly [[copyright]]ed and there is a strong belief among many zine creators that the material within should be freely distributed. In recent years a number of photocopied zines have risen to prominence or professional status and have found wide bookstore and online distribution. Highly notable among these are [[Giant Robot (magazine)|Giant Robot]], [[Dazed & Confused (magazine)|Dazed & Confused]], [[Bust (magazine)|Bust]], [[Bitch (magazine)]] and [[Maximum RocknRoll]].\n\n==History==\n===Origins and overview===\nSince the invention of the [[printing press]] (if not before), dissidents and marginalized citizens have published their own opinions in leaflet and pamphlet form. [[Thomas Paine]] published an exceptionally popular pamphlet titled [[Common Sense (pamphlet)|Common Sense]] that led to insurrectionary revolution. Paine is considered to be a significant early independent publisher and a [[zinester]] in his own right, but then, the [[mass media]] as we now know it did not exist. A countless number of obscure and famous literary figures would self-publish at some time or another, sometimes as children (often writing out copies by hand), sometimes as adults.\n\nThe exact origins of the word zine is uncertain, but it was widely in use in the early 1970s, and most likely is a shortened version of the word Magazine.<ref>{{cite web|url=http://www.diplomacyzines.org.uk/library/zines/Ethil%20the%20Frog/Ethil%20the%20Frog%202%20(Feb72).pdf|title=February 1972 Issue|publisher=Tapeworm Productions|accessdate=2009-01-07}}</ref> with at least one zine lamenting the abbreviation.\n<ref>{{cite web|url=http://www.diplomacyzines.org.uk/library/zines/1901aat/1901aat%20Issue%2084%20(Aug77).PDF|title=August 1977 Issue of Zine|publisher=1901 and all that|accessdate=2009-01-07}}</ref>  The Merriam-Webster OnLine dictionary dates the word to 1965.<ref>{{cite web|url=http://www.merriam-webster.com/dictionary/zine|title=Merriam-Webster OnLine Dictionary|publisher=Merriam-Webster, Incorporated|accessdate=2009-02-11}}</ref>\n\nIn the 18th century, [[Benjamin Franklin]] also started a literary magazine for psychiatric patients at a Pennsylvania hospital, which was distributed amongst the patients and hospital staff. This could be considered the first zine, since it captures the essence of the philosophy and meaning of zines. The concept of zines clearly had an ancestor in the [[Amateur Press Association|amateur press]] movement (a major preoccupation of [[H. P. Lovecraft]]), which would in its turn cross-pollinate with the [[subculture]] of [[science fiction fandom]] in the 1930s.\n\n===1930s1960s and SF===\nDuring and after the [[Great Depression]], editors of pulp SF magazines became increasingly frustrated with letters detailing the impossibilities of their science fiction stories. Over time they began to publish these overly-scrutinizing letters, complete with their return addresses. This caused these fans to begin writing to each other, now complete with a mailing list for their own science fiction fanzines.\n\nFanzines enabled fans to write not only about [[science fiction]] but about fandom itself and, in soi disant [[perzine]] (i.e. personal zine), about themselves. As the [[Damien Broderick]] novel Transmitters (1984) shows, unlike other, isolated, self-publishers, the more fannish (fandom-oriented) fanzine publishers had a shared sensibility and at least as much interest in their relationships between fans as in the literature that inspired it.\n\nA number of leading SF and Fantasy authors rose through the ranks of fandom, such as [[Frederik Pohl]] and [[Isaac Asimov]]. [[George R. R. Martin]] is also said to have started writing for Fanzines, but has been quoted condemning the practice of fans writing stories set in other authors worlds.<ref>{{cite web|url=http://www.examiner.com/x-1765-Underground-Examiner~y2009m2d18-Zines-copyrights-and-Creative-Commons|title=Zines, copyrights and Creative Commons|publisher=examiner.com|accessdate=2009-02-16}}</ref> \n\n===1970s and punk===\nThe [[punk zine]]s emerged as part of the [[Punk subculture|punk]] movement in the late 1970s. These started in the UK and the U.S.A. and by March 1977 had spread to other countries such as Ireland.<ref>{{cite web|url=http://www.loserdomzine.com/earlyirishfanzines.htm|title=Early Irish fanzines|publisher=Loserdomzine.com|accessdate=2007-08-16}}</ref> Cheap [[photocopying]] had made it easier than ever for anyone who could make a band flyer to make a zine.\n\n===1980s and Factsheet Five===\nDuring the 1980s and onwards, [[Factsheet Five]] (the name came from a short story by [[John Brunner (novelist)|John Brunner]]), originally published by [[Mike Gunderloy]] and now defunct, catalogued and reviewed any zine or small press creation sent to it, along with their mailing addresses. In doing so, it formed a networking point for zine creators and readers (usually the same people). The concept of zine as an art form distinct from fanzine, and of the zinesters as member of their own subculture, had emerged. Zines of this era ranged from perzines of all varieties to those which covered an assortment of different and obscure topics which web sites (such as [[Wikipedia]]) might cover today but for which no large audience existed in the pre-internet era.\n===1990s and riot grrrl===\nThe early 1990s [[riot grrrl]] scene encouraged an explosion of zines of a more raw and explicit, more confrontational and definitely more gender-balanced nature [[citation needed]](until this time, males tended to make up the majority of zinesters[[citation needed]]). Following this, zines enjoyed a brief period of attention from conventional media and a number of zines were collected and published in book form, such as [[Donna Kossy]]s [[Kooks Magazine]] (19881991), published as [[Kooks (book)|Kooks]] (1994, [[Feral House]]).\n\n===Decline and websites===\nZines faded from public awareness in the late 1990s. It can be argued that this was the natural course of a declining [[fad]], though it can also be stated with some justification that the sudden growth of the [[internet]], and the ability of private web-pages to fulfill much the same role of personal expression, was a stronger contributor to their [[pop culture]] expiration. Indeed, many zines were transformed into websites, such as [[Boingboing]].\n\nAfter 1997, now out of the limelight, zines have been adopted by those particularly attached to the print medium; for artistic expressions not replicable on a computer, functional purposes or for subcultural reasons.[[citation needed]]\n\n===DIY and blogs===\nZines continue to be popular. Currently zines are important to the [[DIY ethic|Do-It-Yourself]] (DIY) movement. Recently galvanizing social issues such as [[globalization]], [[environmentalism]], media conglomeration, American [[imperialism]] and [[consumerism]] have been addressed within the pages of zines. [[citation needed]].  Not all zines endorse any particular [[ideology]].\n\n==Distribution and circulation==\nZines are sold through many different outlets, from zine symposiums and publishing fairs to record stores, book stores, at concerts, independent media outlets, zine distros and via mail order. They are also sold online either via websites or social networking profiles.\n\nZines which are distributed for free are either traded directly between zinesters or given away at the outlets mentioned.\n\n[[Webzine]]s are to be found in many places on the Internet.\n\n===Distributors===\nZines are most often obtained through mailorder distributors. There are many catalogued and online based mailorder distros for zines. Some of the longer running and more stable operations include [http://www.lastgasp.com/ Last Gasp] in San Francisco, [http://parcellpress.com/ Parcell Press] in Philadelphia, [[Microcosm Publishing]] in [[Bloomington, IN]], [http://www.loopdistro.com/ Loop Distro] in Chicago, [http://greatworm.ca Great Worm Express Distribution] in Toronto, and in the UK [http://www.caferoyal.org Caf Royal zines + underground press] and [http://corndog.co.uk/zine-distro/ CornDog Publishing] in Ipswich. Zine distros often have websites which you can place orders on. Because these are small scale [[DIY]] projects run by an individual or small group, they often close after only a short time of operation. Those that have been around the longest are often the most dependable.\n\n===Bookstores===\nSeveral bookstores stock zines. Notable examples include [http://www.polyester.com.au/ Polyester Books] in Melbourne, Australia; [http://www.caferoyal.org Cafe Royal] in the UK; [[Reading Frenzy]] and [[Powells]] in Portland, OR; [[Needles and Pens]] in San Francisco; Quimbys in Chicago; Macs Backs Paperbacks in Cleveland, OH; [[Arise Books]] in Minneapolis; [[Boxcar Books]] in Bloomington, IN; Wooden Shoe Books in Philadelphia; [[Civic Media Center]] in Gainesville, FL; [http://www.bluestockings.com/ Bluestockings] in NYC; Five in Charleston, SC; Brian MacKenzie Infoshop in Washington, DC; and [[Book Beat & Co]]. in Oklahoma City, OK.\n\n===Zinestores===\n[http://www.stickyinstitute.com/ Sticky Institute] in Melbourne, Australia is unique internationally amongst zine outlets, being a not for profit Artist Run Initiative dedicated solely to the distribution of zines.\n\n===Libraries===\nA number of major public and academic [[library|libraries]] carry zines and other small press publications, often with a specific focus (e.g. womens studies) or those that are relevant to a local region.\n\nIn Australia there is:\n* the Copy & Destroy Zine Library at the [http://www.visibleink.org/?p=773 Visible Ink] Valley space, Brisbane, Queensland\n* the [http://www.slq.qld.gov.au/__data/assets/pdf_file/0005/39236/caboolture1.pdf Caboolture Library Zine Collection], Caboolture, Queensland\n* the Womens House Library Zine Collection at the [http://www.brissc.org.au Brisbane Rape and Incest Survivors Support Centre], Brisbane, Queensland\n* the [http://www.octapod.org/ Octapod Association Zine Library], Newcastle, New South Wales\n* the [http://www.nla.gov.au/collect/s-clarke.html Susan Smith-Clarke Fanzine Collection] at the [http://www.nla.gov.au National Library of Australia], Canberra, Australian Capital Territory\n* the [http://www.library.act.gov.au/find/history ACT Heritage Library] Zine Collection, Canberra, Australian Capital Territory\n* the [http://www.slv.vic.gov.au State Library of Victoria] Zine Collection, Melbourne, Victoria\n* the [http://www.citylibrary.org.au/wetink.htm City Library Zine Collection], Melbourne, Victoria\n* the [http://www.lib.monash.edu.au Monash University Library] [http://nla.gov.au/anbd.bib-an41404375 Zine Collection], Melbourne, Victoria\n\nIn Canada, there is:\n* [http://bibliograph.ca/ Bibliograph/e] in Montral\n* the [http://www.sitekreator.com/zinelibrary Toronto Zine Library] (Tranzac, 292 Brunswick Ave. Toronto, ON)\n* the Welland Zine Library (11 Ascot Ct., Welland Ontario, Canada, L3C 6K7)\n* the [http://anchorarchive.robertsstreet.org Anchor Archive Zine Library] (5684 Roberts Street, Halifax, Nova Scotia, Canada)\n* the Hamilton Zine Library (27 King William St Hamilton Ontario)\n\nIn the UK:\n* There is a special collection held at the [http://www.londonmet.ac.uk/thewomenslibrary/searchthecollections/printed-collections/zines/ London Met Womens Library].\n* [http://www.envf.port.ac.uk/illustration/zineopolis/index.htm Zineopolis at the University of Portsmouth]\n\nNotable U.S.A. public and academic library zine collections include:\n*[[Fales Library]] at [[NYU]], [http://www.nyu.edu/library/bobst/research/fales/ Link to the Fales Library]\n* the Salt Lake City Public Library\n* [[Multnomah County Library]] in Portland\n* the San Francisco Public Library\n* the [http://www.ypsilibrary.org Ypsilanti District Library] in Ypsilanti, Michigan\n* [http://barnard.edu/library/zines Barnard College Library]\n* DePaul University Library [http://library.depaul.edu/Collections/resourceList.aspx?t=202]\n* The original Factsheet Five collection at the [[New York State Library]] in [[Albany, New York]][http://www.nysl.nysed.gov/]\n* The [[Sarah Dyer]] Collection at [http://library.duke.edu/specialcollections/bingham/zines/collections.html Duke University]\n* The [http://infodome.sdsu.edu/about/depts/spcollections/collections/zinesfindingaid.shtml West Coast Zine Collection] at the San Diego State University Library\n\n\nThe U.S.A. also has a number of libraries devoted entirely to zine production and/or archiving, including:\n* the [http://www.abcnorio.org/facilities/zine_library.html ABC No Rio Zine Library] in New York\n* the [[Chicago Underground Library]]\n* the [http://www.denverzinelibrary.org/ Denver Zine Library]\n* the [http://www.hugohouse.org/events/zapp/ Zine Archive and Publishing Project] in Seattle, Washington\n* the Olympia Zine Library, housed in Last Word Books in Olympia, Washington\n* the [[Papercut Zine Library]] in Cambridge, Massachusetts\n* the [http://www.iprc.org/ Independent Publishing Resource Center], a Portland, Oregon zine library and resource for writing and distributing zines.\n\n==Zine events==\n\nIn Australia there is:\n* The biannual [http://www.stickyinstitute.com/ Festival of the Photocopier] and [http://www.stickyinstitute.com/ International Literary Conspiracy Week Festival], held in alternating years each February, run by the Sticky Institute, Melbourne.\n* The [http://www.emergingwritersfestival.org.au/ Emerging Writers Festivals] annual Independent Press and Zine Fair held each May in Melbourne, which is an offshoot of [http://www.expressmedia.org.au/ Express Media]s Make It Up zine fair.  This is no longer a zine fair as they have chosen to shun the zinester in favour of Emerging book writers.\n* The [http://www.youngwritersfestival.org/ National Young Writers Festivals] annual Sunday Artists Market & Zine Fair], part of the This is Not Art festival in Newcastle, NSW.\n* The [http://www.format.net.au/ Format Festival] held every March.\n* The [http://www.actwriters.org.au/ACT Writers Festival zine fair] each June\n\nIn Canada, there is:\n* [http://brokenpencil.com/canzine/index.php Canzine] in Toronto and Vancouver, the largest annual Canadian zine event, organised by the publishers of [http://brokenpencil.com Broken Pencil].\n* [http://www.expozine.archivemontreal.org/ Expozine] held annually in Montral\n* [http://www.lerendezvous.org Le Rendez-vous des publications parallles] held annually in Qubec city\n* [http://www.edmontonsmallpress.org/non2005.html North of Nowhere (NoN) Expo] in Edmonton.\n\nIn France there is:\n* The [http://explozine.propagande.org/ Explosion du Zine] in Toulouse\n\nIn Germany there is:\n* The [http://zinefestmh.wordpress.com/ Zinefest Mlheim] in Mlheim an der Ruhr\n\nIn the United Kingdom, there are:\n* The [http://www.londonzinesymposium.org.uk London Zine Symposium].\n* The [http://www.manchesterzinefest.org.uk Manchester Zine Fest].\n* [[Publish And Be Damned]]\n* [http://www.zineswap.com Zineswap].\n\nIn the United States, there is:\n* The [http://www.24hourzines.com/ 24 Hour Zine Thing]\n* The [http://www.zine-a-polooza.info/ Zine-A-Palooza]\n* The [http://www.phillyzinefest.com/ Philly Zine Fest]\n* The [http://www.sfzinefest.com/ San Francisco Zine Festival].\n* The [http://www.comic-con.org/ape/index.shtml Alternative Press Expo] in San Francisco, California.\n* The [http://www.pdxzines.com/ Portland Zine Symposium] in Portland, Oregon.\n* The [http://alliedmediaconference.org/node/ Allied Media Conference] in Bowling Green, Ohio.\n* The [http://www.bostonzinefair.org/ Boston Zine Fair], formerly known as Beantown Zinetown.\n* The [http://madisonzinefest.org/ Madison Zine Fest] in Madison, Wisconsin.\n* The [http://www.richmondzinefest.org/ Richmond Zine Fest] in Richmond, Virginia.\n* The NJ Zine Fest in New Brunswick, New Jersey.\n* Ephemera Festival in Chicago [http://indigozine.com/ Ephemera Festival]\n* The [http://nyczinefest.org/ NYC Zine Fest] in Brooklyn, New York\n\n==alt.zines==\n{{Unreferenced section|date=January 2009}}\nThe [[Usenet]] [[newsgroup]] alt.zines was created in 1992 by Jerod Pore and Edward Vielmetti for the [[discussion]] of [[zine]]s and zine-related topics. Since that time, alt.zines has seen more than 26,000 postings.\n\nFrom the original alt.zines charter: alt.zines is a place for reviews of zines, announcements of new zines, tips on how to make zines, discussions of the culture of zines, news about zines, specific zines and related stuff. \n\nRelated stuff has included almost everything under the sun. Throughout the 1990s alt.zines was really the only forum for zinesters to promote, talk, and discuss [[small publishing]] issues and tips. And of course argue. It was a place where a [[zine]] reader or first time [[publisher]] could rub elbows with infamous zinesters. Some of the more infamous alt.zines personalities have included [[R. Seth Friedman]], [[Rev. Randall Tin-Ear]], [[Doug Holland]], [[Jeff Kay]], Ninjalicious (AKA [[Jeff Chapman]]), [[Sky Ryan]], Tim Brown, [[Josh Saitz]], [[Dan Halligan]], Heath Row, [[Jeff Koyen]], [[Bob Conrad]], [[Jen Angel]], [[Seth Robson]], [[Karl Wenclas]], [[Asha Anderson]], [[Emerson Dameron]], [[Jerod Pore]], [[Jim Goad]], [[Cullen Carter]], [[Steen Sigmund]], [[Darby Romeo]], [[Jim Hogshire]], [[Debbie Goad]], [[Cali Macvayia]], [[Don Fitch]], [[Jeff Potter]], [[Joel McClemore]], [[Kris Kane]], [[Marc Parker]], [[Paul T. Olson]], [[Robert W. Howington]], [[Sean Guillory]], [[Ruel Gaviola]], [[Jeff Somers]], [[Tom Hendricks]], [[Chip Rowe]], [[Brent Ritzel]] and [[Shaun Richman]].\n\nWhile today there are many other online forums for zinesters and traffic on alt.zines has slowed down dramatically since the zinester flame wars of yesteryear, alt.zines remains one of the most influential places on the web for zine publishers and readers alike. Many long-time alt.zines participants now contribute to [[ZineWiki]].\n\n==Zines in fiction==\nThe main character of a Canadian television show produced by the CBC called [[Our Hero]], Kale Stiglic ([[Cara Pifko]]) created her own zine.\n\n[[Damien Broderick]]s novel Transmitters follows a small group of Australian science fiction fans through their lives over several decades. [[Pastiche]]s of fanzine writing (from fictitious fanzines) form some of the text of the novel.\n\nSet in the 80s and 90s zine heyday, Walking Man by [[Tim W. Brown]] is a comic novel written in the form of a scandalous tell-all biography that portrays the life and times of Brian Walker, publisher of the zine Walking Man, who rises from humble origins to become the most famous zinester in America.\n\nIn the novel Hard Love by Ellen Wittlinger, the main character John begins writing a zine called Bananafish after reading other peoples zines he found at Tower Records. One of these zines is written by a girl named Marisol who writes a zine called Escape Velocity. After reading her zine, John decides to meet her and their friendship grows from there.\n\nLunch Money, a childrens book by Andrew Clements, has sixth-grader Greg Kenton creating and selling mini comic books, as a way to make money, which leads to one of his classmates making her own publication.\n\nIn the Nickelodeon cartoon show [[Rocket Power]], one of main cast characters, Reggie, publishes her own zine about [[action sports]].\n\nTales of a Punk Rock Nothing is a semi-fictional depiction of the [[anarcho-punk]] and [[riot grrrl]] scene in early 90s [[Washington, DC]].\n\n'
p362
tp363
a(I-1
S'{{for|the biologist|Jakob von Uexkll}}\n{{unreferencedBLP|date=July 2009}}\n\n{{Infobox Person \n|name= Jakob von Uexkull\n|image= Jakob_von_Uexkull_portrait.JPG\n|image_size = 150px\n|caption= Jakob von Uexkull\n|birth_date= {{Birth date and age|1944|8|19|df=y}}\n|birth_place= [[Uppsala]], [[Sweden]]\n|death_date= \n|death_place= \n|occupation = [[writer]], [[lecturer]], <br> professional [[philatelist]]\n}}\n\nJakob von Uexkull (born [[19 August]] [[1944]]) is a [[writer]], [[lecturer]], professional [[philatelist]] and past member of the [[European Parliament]] who, in [[1980]], founded the [[Right Livelihood Award]]s (a.k.a. the Alternative Nobel Prize). He holds both [[Sweden|Swedish]] and [[Germany|German]] citizenship.\n\nUexkull stems from a [[Baltic Germans|Baltic German]] family that was forced to leave [[Estonia]] after [[World War I]]. He was born in [[Uppsala]], [[Sweden]]. After studying in Sweden and Germany, he won a scholarship to [[Christ Church, Oxford]], graduating in [[Philosophy, Politics and Economics]].  \n\nUexkull provided an initial [[Financial endowment|endowment]] for the awards by selling his collection of [[postage stamps]] for US$ 1 million; the awards have subsequently attracted additional funding from private individuals enabling it to donate annual prizes worth 2 million [[Swedish krona|Swedish Kronor]].\n\nUexkull created the awards out of a recognition that [[Nobel Prize]]s were relatively narrow in scope and usually recognised the work of those in [[industrialisation|industrialised countries]].\n\nVon Uexkull first approached the Nobel Foundation with the suggestion that it establish two new awards, one for [[ecology]] and one relevant to the lives of the poor majority of the worlds population. He offered to contribute financially but his proposal was turned down.\n\nUexkull then decided to set up the Right Livelihood Awards, presented in the [[Swedish parliament]] on the day before the Nobel Prizes and often referred to as the alternative Nobel Prize. In recognition of his initiative in founding the Right Livelihood Award, the [[German Green Party]] has several times nominated Jakob von Uexkull in [[elections]] to the European Parliament. As an [[Member of the European Parliament|MEP]], he served on the Political Affairs Committee and the Science and Technology Committee. He was also a member of the Delegation for Relations with the Supreme Soviet of the [[USSR]] and the Baltic Intergroup (1987-89).\n\nUexkull is a co-founder of [[The Other Economic Summit]]. He is a patron of [[Friends of the Earth]] International. He has been a Trustee of the [[New Economics Foundation]], London, and a member of the [[Global Commission to Fund the United Nations]]. He has served on the Board of [[Greenpeace]], Germany, and on the Council of Governance of [[Transparency International]]. He lectures widely on environment, justice and peace issues. He is also a recognised philatelic expert with publications including The Early Postal History of Saudi Arabia (2001).\n\nUexkull created the [[Estonian Renaissance Award]] after the independence of the [[Estonia]]n country in 1991.\n\nUexkull also founded the [[World Future Council]], bringing the interests of future generations to the centre of policy making. Its 50 eminent members from around the globe have already successfully promoted change. The Council addresses challenges to our common future and provides decision-makers with effective policy solutions. In-depth research underpins advocacy work for international agreements, regional policy frameworks and national lawmaking and thus produces practical and tangible results.\n\nJakob von Uexkll has been honored by Time Magazine as a European Hero (2005). In 2006, he received the Binding-Prize (Liechtenstein) for the protection of nature and the environment, and, in 2008, the Erich-Fromm-Prize in Stuttgart, Germany, for his future-orientated commitment dedicated for a life in human dignity for our children and grandchildren in a globalised world.\n\nUexkulls grandfather [[Jakob von Uexkll]] is the founder of the study of [[biosemiotics]].\n\n'
p364
tp365
a(I-1
S'Biogenetic structuralism is a body of theory in [[anthropology]].  The perspective grounds discussions of learning, culture, personality and social action in [[neuroscience]]. The original book of that title (Laughlin and dAquili 1974) represented an interdisciplinary merger of anthropology, psychology and the neurosciences. It presented the view that the universal structures characteristic of human language and culture, cognition about time and space, affect certain psychopathologies, and the like were due to the genetically predisposed organization of the nervous system. It seemed to the authors preposterous that the invariant patterns of behavior, cognition and culture being discussed in various structuralist theories in anthropology, psychology and literary criticism could be lodged anywhere other than in the nervous system. After all, every thought, every image, every feeling and action is demonstrably mediated by the nervous system. Moreover, it seemed possible to develop a theoretical perspective that:  was non-dualistic in modelling mind and body, was not reductionistic in the positivist sense (i.e., that the physical sciences can give a complete account of all things mental/cultural), and was informed by all reasonable sources of data about human consciousness and culture. In other words, no explanatory account of culture is complete without encompassing what we know about the structures in the nervous system mediating culture -- for example, music, which is a cultural universal mediated by  demonstrable neurophysiological structures (see [[Biomusicology]]). \n\nThis project had to be lodged within an evolutionary frame due to:  (1) the evidence of dramatic [[encephalization]] found in the [[fossil]] record of extinct human ancestors, and the fact that cultural variation was conceived as the primary mode of human adaptation (see [[Evolutionary neuroscience]]).  We thus explored the different areas of the nervous system that seem to have evolved during the course of [[hominid]] encephalization and that produce the distinctly human quality of mentation, learning, communication, and social action characteristic of our species today (see [[Human Evolution]]). \n\n== Neurognosis and the cognized environment ==\n\n \nThe groups first book presented some general concepts which were later refined and used in other studies. One important concept was [[neurognosis]], a term coined to label the inherent, rudimentary knowledge available to cognition in the initial organization of the pre- and perinatal nervous system (see [[Pre- and perinatal psychology]]). A human baby was conceived as taking its first cognitive and perceptual stance toward the world from the standpoint of a system of initial, genetically predisposed neurognostic models that come to develop in somatosensory interaction with the world. \n\nThe principal function of the human nervous system at the level of the cerebral cortex is the construction of a vast network of these models. This network of neural models in each individual is called the [[cognized environment]], contrasted with the actual operational environment that includes both the real nature of that individual as an organism and the effective external environment (see Laughlin and Brady 1978:6, dAquili et al. 1979:12, Rubinstein et al. 1984:21, Laughlin, McManus and dAquili 1990). The notions of cognized and operational environments were borrowed by the biogenetic structuralist group from [[Roy Rappaport]] who coined the terms in his 1968 classic, Pigs for the Ancestors (see Rappaport 1968, 1979, 1984, 1999).  The perspective began to take on a more developmental perspective as it incorporated the works of [[Jerome Bruner]], [[Jean Piaget]] and others. Biogenetic structural theory now holds that not only the initial organization of the babys cognized environment is essentially neurognostic, but so too is the course of development of those models and patterns of entrainment of models -- a view not dissimilar to [[Carl Jung]]s notion of [[archetype]] (see Laughlin 1996 on archetypes and the brain).\n\n== Major foci: ritual and the symbolic function ==\n \nThe first book-length application of biogenetic structural theory was an account of the evolution and structure of human [[ritual]]. In The Spectrum of Ritual (dAquili et al. 1979) the group generated a theory of ritual behavior as a mechanism by which intra- and interorganismic [[entrainment]] of [[neurocognitive]] processes are evoked, thus making concerted action among [[social animal]]s possible. The general model was used to examine formalized behavior among animals generally, then specifically among [[mammals]], [[primates]] and finally humans. They also looked at the various neurocognitive processes mediating [[arousal]], [[affect]], physical and social [[cognition]], etc. As it has turned out, ritual has been a major focus of the groups work (see also dAquili 1983, dAquili and Laughlin 1975, Laughlin and McManus 1982, Laughlin et al. 1986, Laughlin 1988c) because of rituals ubiquitous nature and its role in controlling cognition and experience. \n\nAnother major focus of biogenetic structural analysis has been what the group calls the symbolic function -- that is, the process by which meaning and form are integrated to become [[symbols]] in the brain (see Laughlin, McManus and Stephens 1981, Laughlin and Stephens 1980, MacDonald et al. 1988, Young- Laughlin and Laughlin 1988). The group has been particularly interested in how [[sensory]] stimuli as symbols are able to penetrate (i.e., find their way) to those neurocognitive models mediating [[meaning (semiotics)|meaning]] and [[signification]], and how models express themselves in symbolic action and [[cultural artifact]]s. Among other things, the biogenetic structuralists developed a theory of the evolution of the symbolic function that proceeds from primordial symbol, through cognized SYMBOL systems to sign systems, and finally to formal sign systems, any or all of which may operate at any moment in adult human cognition (Laughlin, McManus and Stephens 1981).\n\n== Recent trends in biogenetic structural theory ==\n\n \nThere have been several recent trends in biogenetic structuralism that are of interest to anthropology:\n\n===Transpersonal experience===\n\nOne trend is toward a greater attention to [[transpersonal experience]] (see also [[transpersonal]] and [[transpersonal anthropology]]) as data relevant to the study of ritual; that is, to extraordinary experiences and states of consciousness, and the relation of these to patterns of symbolism, cognition and practice found in religions and cosmologies cross-culturally (see dAquili 1982, Laughlin 1985, 1988a, 1988c, Laughlin et al. 1986, Laughlin McManus and Shearer 1983, Laughlin, McManus and Webber 1984, MacDonald et al. 1988, Webber et al. 1983). Taking their inspiration from [[William James]], the group has tracked the greatest range of human experience and related this to transformations in [[neurocognitive]], [[autonomic]] and [[neuroendocrine]] entrainments. By expanding their scope to include all possible human experience, they hope to understand:\n  \n# The maximum potential genetic and developmental limits to patterns of [[brainwave synchronization|entrainment]] and therefore to human experience,\n# The mechanisms by which societies condition patterns of entrainment so as to control (limit or extend) the range of human experience,\n# The mechanisms by which societies produce recurrent extraordinary experiences in some or all of their members so as to verify and vivify the societies [[world view]]s,\n# And by extrapolation, the possible future limits of human consciousness (Laughlin and Richardson 1986).\n\n=== Pre- and perinatal anthropology ===\n\nAnother trend in biogenetic structural theory has been to extend the age at which society influences neurocognitive development back into very early life. There is now sufficient evidence from clinical psychology and developmental neurobiology that experiences occurring in [[pre- and perinatal psychology|pre- and perinatal life]] (in the womb, during birth and during early infancy) are formative on later patterns of neurocognitive entrainment and adaptation. The methodological import of this view is that anthropologists and others interested in the [[ontogenesis]] of cognitive systems and cultural patterns need to look more carefully at how society conditions the environment of the human being during that early formative period (see Laughlin 1989a, 1990).\n\n===Neurophenomenology===\n\nAnother recent interest has been in making a case for the importance of a [[neurophenomenology]] to the study of brain, consciousness and culture -- an approach that is often considered to be antithetical to the anti-introspectionist bias of positivist science, and particularly to some schools of cognitive science (Laughlin, McManus and dAquili 1990). [[Phenomenology (philosophy)|Phenomenology]] (a la [[Edmund Husserl]], [[Maurice Merleau-Ponty]], [[Aron Gurwitsch]], and others, as well as eastern mystical and cross-cultural [[shamanistic]] traditions) is the study of the invariant processes of consciousness (i.e., [[essences]]) by the practice of mature contemplation. Neurophenomenology is thus the attempt to explain such processes by reference to what is known about the brain. Two recent studies by the group exemplify this merging of contemplative and neuroscientific perspectives. One study discusses the wired-in [[intentionality]] of consciousness (noted in fact by all phenomenologies) in terms of a systemic dialectic between [[prefrontal cortex]] and [[sensory cortex]] (Laughlin 1988b). Another study suggests the relationship between invariant temporal patterns of perceptual sequencing and the neuropsychological literature available on [[perceptual framing]] (Laughlin 1992).\n\n===Contributions to cyborg anthropology===\n\nBecause biogenetic structural theory rejects any disembodied account of consciousness or culture, it was quite natural for the group to consider the implications of the direct [[Brain-computer interface|interfacing]] of [[information system|information processing technologies]] (e.g., computers) and the development and evolution of the brain -- an inevitable outcome considering the modern research intended to bring that eventuality about.  These considerations led to studies in the area of what has been called [[cyborg anthropology]] and [[cyberculture]].  A [[cyborg]], short for cybernetic organism,  is a being that is part cybernetic machine and part organism, a term coined by two NASA scientists, Manfred Clynes and Nathan Kline (1960, reprinted in Gray 1995).  These men suggested some of the advantages for [[space exploration]] of altering the human body with machines.\n\nThe groups analysis of the cyborg is grounded in the findings of modern neuroscience.  The perspective is grounded upon the presumption that human consciousness and culture are functions of the human nervous system.  In other words, consciousness is as much the function of the brain as digestion is the function of the stomach and grasping the function of the hand.  Their reasoning and research led ultimately to a four stage account of the evolution of the cyborg -- a natural, but special case of the evolution of technology as a whole.  The group hypothesizes that the emergence of the cyborg is following these stages:\n\n* Stage I:  Replacement or augmentation of the human skeleton.  Examples:  wooden leg, hook for lost hand, armor, false teeth, etc.  This has been going on for centuries.\n\n* Stage II:  Replacement or augmentation of muscle.  Examples:  mechanical hand for lost hand, other prosthetic devices, mechanical heart valve, replacement of lens in eye, etc.  Began to emerge in the mid-20th century.\n\n* Stage III:  Replacement or augmentation of parts of the peripheral nervous system, autonomic nervous system and the neuroendocrine system.  Examples:  bionic arms and legs, pacemakers, automatic biochemical pumps, etc.  Emerging in the later 20th century.\n\n* Stage IV:  Replacement or augmentation of parts of the central nervous system.  Examples:  video eyes for blind, Air Force cyborg fighter plane control, etc.  Rudimentary steps in the later 20th century.\n\nOf course, this model is an over-simplification of the unfolding of the cyborg process, but it has the advantage of letting one see the progressive complexity involved.  Stage I cyborg is equivalent to the external extension of the hands with a hammer, knife or other primitive tool.  It essentially replaces or augments the skeletal physiology of the limbs.  Thus the wooden leg and hook as [[artificial limb|prosthetic devices]] represent the more primitive innovations leading to the process of cyborg transformation.  Portions of the nervous system have been eliminated with the loss of the amputated appendage.\n\nStage II cyborg sees the technical replacement or augmentation of both [[Prosthetics in fiction|skeletal and muscle systems]] in the body.  This stage is equivalent to the external replacement of muscles with engines.  The hand is replaced with a movable machine, perhaps manipulated by servomechanisms that are triggered by movements of particular muscle groups.  The diseased heart valve is replaced by a mechanical valve.  The lens of the eye is replaced by a synthetic lens, and so on.  Such mechanisms depend upon intact neuro-muscular systems for their control.\n\nAt Stage III cyborg, technical penetration reaches the nervous system and replaces or augments neural structures in the peripheral, autonomic or endocrine systems involved in the regulation of internal states.  This stage is equivalent to simple regulatory systems in the external world, such as the thermostat controlling the temperature of a heater.  Clynes and Kline addressed their original cyborg paper to problems in space exploration that might be solved by Stage III cyborg measures.  The bionic arms and legs of the Six Million Dollar Man are fictional examples of Stage III developments, as is the more realistic contemporary heart pacemaker.\n\nFinally, Stage IV cyborg produces the replacement or augmentation of [[Neuroprosthetics|structures in the central nervous system]].  This stage is equivalent to the supplementation or replacement of human brain power with computers in industry.  This stage may involve modification of structures mediating the cognitive aspects of emotion, as well as imagination, intuition, perception, rational thought, intentionality, language, etc. -- all of which require higher cortical processing.  Examples of developments at this stage are technologies such as the miniature video camera eyes wired to an electrode array implanted in the visual cortex of certain blind people.  And rumor has it that the United States Air Force underwrites research on technologies that would allow direct brain to aircraft interfacing for fighter pilots.  Scientists at Tokyo University have fitted microprocessors to the nervous systems of cockroaches using electrodes, and are able to control the roaches behavior via computer link.  \n\nThe point to emphasize in all of this is that the emergence of the cyborg is a process of progressive technological penetration into the body, eventually replacing or augmenting the structures that mediate the various physical and mental attributes that we normally consider natural to human beings, including emotion, sensory modes, imagination and rational thought, the organization of intentional acts, etc.  Clearly then, progressive penetration into the cortex of the brain will inevitably result in the [[neurotechnology|technical alteration]] of human consciousness (Laughlin 1997), its optimal functioning and development in childhood (Laughlin 2000).\n\n===Quantum brain===\n{{seealso|Quantum brain dynamics}}\nBiogenetic structural theory was expanded in the 1990s in order to account for how the human brain and mind may interact directly with the quantum universe. This step was an attempt to resolve anomalous evidence developed by a few scientists in [[quantum physics]], [[parapsychology]] and the ethnology of [[altered states of consciousness]] -- evidence that is claimed to mean that human consciousness is capable of producing [[causality|causation at a distance]] and communication through [[telepathic]] means (see e.g., Radin 1997). One proposal to answer to these anomalous experiences is that the human brain may operate somewhat as a [[quantum computer]] and is able to translate patterned activity in the quantum universe into [[information]], and conversely to transform information into patterned activity in the quantum universe (see Laughlin 1996, Throop and Laughlin 2001). However, there have been no convincing hypotheses on the physics of how quantum states might be sustained, and decoherence avoided, in the messy, high-temperature environment of the brain. (See [[Max Tegmark]]s, paper in Physical Review E,<ref name=Tegmark2000>{{citation  | last = Tegmark | first =  M.  | year = 2000  | title = Importance of quantum decoherence in brain processes  | journal = Phys. Rev. E  | volume = 61  | pages = 41944206  | doi = 10.1103/PhysRevE.61.4194  | url = http://arxiv.org/abs/quant-ph/9907009 }}</ref>)\n\n===Cultural neurophenomenology===\n\nThe groups most recent work has focused upon developing a [http://www.biogeneticstructuralism.com/cult-neuro-phen.htm cultural neurophenomenology] (see Laughlin & Throop 2001, 2006, 2007, Throop & Laughlin 2002, 2003).  Cultural neurophenomenology is the view that the most productive research strategy for discovering the invariant properties of consciousness is trained [[introspection]].  After all, they argue, our own experience and awareness are the only ones we have direct access to. [[philosophy of mind|Anti-introspectionist]] positions in science are claimed by its adherents to be primarily due to pre-scientific cultural hangovers from Church rulings against direct spiritual exploration -- stemming historically from the so-called gnostic heresy. They consider [[behaviorism|behaviorist]] reaction to [[Wilhelm Wundt]]s introspectionism in psychology to be merely a legitimation of these cultural attitudes.    \n\nEdmund Husserl taught a different approach to the study of consciousness.  He argued that in order to differentiate in experience between what is given by the world and what is added by our own minds in the constitution of experience, we must cultivate a trained introspection. When we do so (in Husserls terms, when we master the [[Phenomenology (philosophy)|phenomenological reduction]]) we discover there are invariant properties of mind that condition and order our experience.  For instance, we generate a sense of time by retaining recently past experience (retention) and anticipating the near future (protention) and combining these with the actual, on-going now point arising and passing in our sensorium.  Once we come to understand that this is how our mind works, the question then naturally arises, what is real time in the sense of time existing in extramental reality, independent of our experience and our knowledge?  Also, how does the structure of our nervous system mediate this time sense, and how does culture impact upon our interpretations of temporality? \n\nThe group is now examining a variety of issues regarding experience.  Thus far they have utilized this framework to explore the cross-cultural and neuropsychological factors in the experience of emotion, including the emotional aspects of higher states of consciousness, the role of [[Mythology|myth]] and [[Religious cosmology|cosmology]] in [[truth|trueing-up]] the relationship between experience and reality, the importance of altered states of consciousness in bolstering the veridicality of experience, the interpenetration of experience and extramental reality, and a modern re-interpretation of [[Emile Durkheim]]s [[collective effervescence]].\n\n'
p366
tp367
a(I1
S'[[Image:ApolloAndDaphne.JPG|thumb|200px|Berninis Apollo and Daphne in the [[Galleria Borghese]]]]\n[[Image:Tizian 029.jpg|thumb|350px|Titians Sacred and Profane Love]]\n\nThe Borghese Collection is a collection of [[Roman sculpture]]s, [[old master]]s and modern art collected by the Roman [[Borghese]] family, especially Cardinal [[Scipione Borghese]], from the 17th century on.  It includes major collections of [[Michelangelo Merisi|Caravaggio]], [[Raphael]], and [[Titian]], and of [[ancient Roman art]].  The Borghese also bought widely from leading painters and sculptors of his day, and Scipione Borgheses commissions include two portrait busts by [[Gian Lorenzo Bernini]].[http://www.thais.it/scultura/image/sch00345.htm][http://www.artchive.com/artchive/B/bernini/borghese.jpg.html]  Most of the collection remains intact and on display at the [[Galleria Borghese]], although a significant sale of classical sculpture was made under duress to the [[Louvre]] in 1807.\n\n==Scipione Borghese==\nCardinal Scipione Borghese, an important art collector, was the collections instigator and collected the majority of the collection.  His collection was poetically described as early as 1613 by [[Scipione Francucci]]. In 1607, the Pope gave the Cardinal 107 paintings which had been confiscated from the studio of the painter [[Cavalier DArpino]]. In the following year, Raphaels [[Deposition (Raphael)|Deposition]] was removed by force from the Baglioni Chapel in the church of San Francesco in [[Perugia]] and transported to Rome to be given to the Cardinal Scipione through a papal [[motu proprio]].\n\n==Later additions==\nIn 1682, part of [[Olimpia Aldobrandini]]s inheritance entered the Borghese collection; it included works from the collections of Cardinal [[Salviati]] and [[Este|Lucretia dEste]].\n\n==Housing the collection==\n[[Image:Correggio 008.jpg|thumb|Dane by [[Correggio]]]]\nScipione developed a large estate and vineyard on the Pincian hill in Rome into a vast garden and complex of palaces, the [[Villa Borghese]], to house his collection. He also used the [[Villa Mondragone]] for this purpose.  In 1775, in homage to his Borghese ancestors, Prince [[Marcantonio IV Borghese]] and the architect Antonio Asprucci embarked upon renovations to [[Villa Borghese]], which had always been a semi-public museum since the 17th century. Integrating the sculptures of the Borghese collection and existing vast [[Baroque]] ceiling decors, they created a spectacular monument to the Borghese family (Paul 2000).\n\n==At the Villa Borghese==\nThe Villa still houses a major part of the collection, as the [[Galleria Borghese]].  Many of the sculptures there are displayed in the spaces they were intended for, including early works by [[Gian Lorenzo Bernini]].\n\n===Caravaggio paintings===\n*[[Boy with a Basket of Fruit (Caravaggio)|Boy with a Basket of Fruit]]\n*[[Saint Jerome Writing (Borghese) (Caravaggio)|St. Jerome]]\n*[[Sick Bacchus (Caravaggio)|Sick Bacchus]]\n*[[Madonna and Child with St. Anne (Dei Palafrenieri) (Caravaggio)|Madonna of the Palafrenieri]]\n*[[David with the Head of Goliath (Caravaggio)|David with the Head of Goliath]]\n\n===Other notable paintings===\n\n{{commons cat}}\n*[[Sacred and Profane Love]] by [[Titian]] \n*[[Deposition (Raphael)|Deposition]] by [[Raphael]]  \n*[[:Image:Correggio 008.jpg|Dane]] by [[Antonio da Correggio|Correggio]] \n*[[Portrait of a Man (Antonello da Messina)|Portrait of a Man]] by [[Antonello da Messina]] (See also [[:Image:Antonello da Messina 054.jpg|Image]])\n*[[:Image:Domenichino 001.jpg|Diana]] by [[Domenichino]] \n*[[Venus and Cupid (Cranach)|Venus and Cupid]] by [[Lucas Cranach the Elder|Cranach]]\n*[[:Image:DossoDossi.jpg|Circe]] by [[Dosso Dossi]]\n*[[Deposition from the Cross|The Deposition]] by [[Peter Paul Rubens|Rubens]] \n*[[:Image:Raffaello Motta 001.jpg|Tobias and the Angel]] by [[Savoldo]]\n*[[:Image:Lorenzo Lotto 032.jpg|Madonna and Child with Saints]] by [[Lorenzo Lotto]] \n*[[The Last Supper]] by [[Jacopo Bassano]]\n* Various works by [[Federico Barocci]]\n*[[:Image:Leda mit dem Schwan.jpg|Leda and the Swan]] by followers of [[Leonardo da Vinci]]\n\n===Bernini collection===<!-- This section is linked from [[Gian Lorenzo Bernini]] -->\nThe small collection of works by Bernini (whose first patron was Scipione) comprises a large proportion of his lifetime output of secular sculpture; in this collection one can see the sponsored Bernini mature from juvenile, but talented works, such as the [[The Goat Amalthea with the Infant Jupiter and a Faun]] (1615)[http://www.wga.hu/frames-e.html?/html/b/bernini/gianlore/sculptur/1610/2amalthea.html] to his supreme and dynamic [[Apollo and Daphne (Bernini)|Apollo and Daphne]] (162225)[http://gallery.euroweb.hu/html/b/bernini/gianlore/sculptur/1620/apollo_d.html] and [[David (Bernini)|David]] (1623),[http://www.wga.hu/frames-e.html?/html/b/bernini/gianlore/sculptur/1620/david.html] considered seminal works of [[baroque]] sculpture. In addition, the gallery contains three busts, two of [[Pope Paul V]] (161820) and one marvelously conversive and stunningly innovative portrait of his patron, Borghese (1632).[http://www.artchive.com/artchive/B/bernini/borghese.jpg.html] Finally it has some early, less successful, somewhat mannerist, but masterful works such as [[Aeneas, Anchises, and Ascanius]] (161819)[http://www.wga.hu/frames-e.html?/html/b/bernini/gianlore/sculptur/1610/aeneas.html] and the [[Giambologna]]-emulating Plutos [[The Rape of Proserpina (Bernini)|Rape of Prosperpine]] (162122),[http://www.galleriaborghese.it/borghese/en/eproserp.htm] and also a personal allegory of [[Truth Unveiled by Time (Bernini)|Truth Unveiled by Time]] (164652).[http://www.galleriaborghese.it/borghese/en/everita.htm]\n\n==At the Louvre==\nIn 1807, due to financial difficulties and under pressure from his new brother-in-law [[Napoleon Bonaparte]], [[Camillo Filippo Ludovico Borghese]] sold 344 [[antiquities]] (154 statues - including some major examples - , 160 busts, 170 bas-reliefs, 30 columns and various vases), from the collection to the French state at below their market price.  These pieces, which now reside at the [[Louvre Museum]], include:\n*sculptures recently excavated at [[Gabii]]\n*the [[Antinous Mondragone]]\n*the [[Borghese Gladiator]]\n*the [[Borghese Hermaphroditus]]\n*the [[Borghese Vase]]\n\nHe replaced them in the Villa with other pieces from excavations on Borghese property (eg the [[Gladiator Mosaic]], found in 1834) and paintings from his residences stores and cellars, so that already by the 1830s these gaps seem to have been filled and despite the losses the collection was still reckoned as one of the worlds finest.<ref>{{cite book |last=Majanlahti |first=Anthony  |title=The Families Who Made Rome |year=2005 |publisher=Chatto & Windus |location=London |isbn=0701176873 }}, page 180</ref>  Camillo even bought [[Correggio]]s celebrated [[:Image:Correggio 008.jpg|Dane]] in Paris in 1827.\n\n'
p368
tp369
a(I-1
S'{{Sociology}}\nSocial structure is a term used in [[sociology]] and [[anthropology]] to refer to relationships or bonds between groups of individuals (e.g. societies). Whereas structure refers to the macro, [[agency (sociology)|agency]] refers to the micro. (See also: [[Structure and agency]])\n\nIn a general sense, the term can refer to:\n* [[entities]] or groups in definite relation to each other,\n* relatively enduring patterns of behaviour and [[relationship]] within a society, or \n* social [[institution]]s and [[Norm (sociology)|norms]] becoming embedded into social systems in such a way that they shape the behavior of actors within those social systems. \n\nBy the 1930s, the term was in general use in social science<ref>Merton, Robert. 1938. Social Structure and Anomie.  American Sociological Review, Vol. 3, No.5, pp.672-682</ref>, especially as a variable whose sub-components needed to be distinguished in relationship to other sociological variables.  \n\n== Overview ==\nThe notion of social structure as relationships between different entities or groups or as enduring and relatively stable patterns of relationship emphasises the idea that society is grouped into structurally related groups or sets of [[role]]s, with different functions, meanings or purposes. One example of social structure is the idea of [[social stratification]], which refers to the idea that society is separated into different strata (levels), according to social distinctions such as a [[Race (classification of human beings)|race]], [[social class|class]], [[disability]] or [[gender]]. Social treatment of persons within various social structures can be understood as related to their background.\n\nThe notion of structure as embedded institutions or norms that shape the actions of social agents is important, because it explains how structural determination may occur.  Structural determination occurs when the actions of people and organizations are guided (if only partially) by the underlying structures in the social system. This approach has been important in the academic literature with the rise of various forms of [[structuralism]]. It is important in the modern study of organizations, because an organizations structure may determine its flexibility, capacity to change, and many other factors. Therefore, structure is an important issue for [[management]].\n\nSocial structure may be seen to influence important social systems including the [[economic system]], [[legal system]], [[political system]], [[cultural system]], and others. [[Family]], [[religion]], [[law]], [[Economics|economy]] and [[Social class|class]] are all social structures.  The social system is the parent system of those various systems that are embedded in it.\n\n== History ==\nThe early study of social structures has informed the study of institutions, culture and agency, social interaction, and history. [[Alexis de Tocqueville]] was apparently the first to use the term social structure; later, [[Karl Marx]], [[Herbert Spencer]], [[Max Weber]], [[Ferdinand Tnnies]], and [[Emile Durkheim]] all contributed to structural concepts in sociology. Weber investigated and analyzed the institutions of modern society: [[market]], [[bureaucracy]] (private enterprise and public administration), and politics (e.g. democracy).\n\nOne of the earliest and most comprehensive accounts of social structure was provided by Karl Marx, who related political, cultural, and religious life to the [[mode of production]] (an underlying economic structure). Marx argued that the economic [[Base and superstructure (Marxism)|base]] substantially determined the cultural and political [[Base and superstructure (Marxism)|superstructure]] of a society. Subsequent Marxist accounts, such as that by [[Louis Althusser]], proposed a more complex relationship that asserted the relative autonomy of cultural and political institutions, and a general determination by economic factors only in the last instance.<ref name=Calhoun>Dictionary of the Social Science, Social Structure article</ref>\n\nIn 1905, the German sociologist [[Ferdinand Tnnies]] first published his study The Present Problems of Social Structure in the United States,<ref>in: The [[American Journal of Sociology]], vol. 10, 1905, no. 5, p. 569-688</ref> arguing that only the constitution of a multitude into a unity creates a social structure (basing this approach on his concept of [[will (sociology)|social will]]). \n\n[[Emile Durkheim]] (drawing on the analogies between biological and social systems popularized by [[Herbert Spencer]] and others) introduced the idea that diverse social institutions and practices played a role in assuring the functional integration of society  the assimilation of diverse parts into a unified and self-reproducing whole. In this context, Durkheim distinguished two forms of structural relationship: mechanical solidarity and organic solidarity. The former describes structures that unite similar parts through a shared culture; the latter describes differentiated parts united through exchange and material interdependence.<ref name=Calhoun/>\n\n[[Georg Simmel]] developed a wide-ranging approach which provided observations and insights about domination and subordination (as Marx and Weber did but more generally), competition, division of labor, formation of parties, representation, inner solidarity coupled with exclusiveness toward the outside, and many similar features in the state, in a religious community, in an economic association, in an art school, and in family and kinship networks (however diverse the interests that give rise to these associations, the forms in which interests are realized may yet be identical (Crothers, 1996)).\n\nThe notion of social structure was extensively developed in the 20th century, with key contributions from [[structuralist]] perspectives drawing on the theories of [[Claude Lvi-Strauss]], Feminist or Marxist perspectives, from [[structural functionalism|functionalist]] perspectives such as those developed by [[Talcott Parsons]] and his followers, or from a variety of analytic perspectives (see Blau 1975, Lopez and Scott 2000). Some follow Marx in trying to identify the basic dimensions of society that explain the other dimensions, most emphasizing either economic production or political power. Others follow Lvi-Strauss in seeking logical order in cultural structures. Still others, notably [[Peter Blau]], follow Simmel in attempting to base a formal theory of social structure on numerical patterns in relationshipsanalyzing, for example, the ways in which factors like [[Group size measures|group size]] shape intergroup relations.<ref name=Calhoun/>\n\nThe notion of social structure is intimately related to a variety of central topics in social science, including the relation of [[structure and agency]]. The most influential attempts to combine the concept of social structure with agency are [[Anthony Giddens]] [[theory of structuration]] and [[Pierre Bourdieu]]s [[practice theory]]. Giddens emphasizes the duality of structure and agency, in the sense that structures and agency cannot be conceived apart from one another. This permits him to argue that structures are neither independent of actors nor determining of their behavior, but rather sets of rules and competencies on which actors draw, and which, in the aggregate, they reproduce. Giddenss analysis, in this respect, closely parallels [[Jacques Derrida]]s deconstruction of the binaries that underlie classic sociological and anthropological reasoning (notably the universalizing tendencies of Lvi-Strausss structuralism). Bourdieus practice theory also seeks a more supple account of social structure as embedded in, rather than determinative of, individual behavior.<ref name=Calhoun/>\n\nOther recent work by [[Margaret Archer]] (morphogenesis theory), [[Tom R. Burns]] and collaborators ([[actor-system dynamics theory]] and [[social rule system theory]]), and [[Immanuel Wallerstein]] ([[World Systems Theory]]) provided elaborations and applications of the sociological classics in structural sociology.\n\n== Definitions and concepts ==\nAs noted above, social structure has been identified as \n\n:(i) the relationship of definite entities or groups to each other, \n:(ii) enduring patterns of behaviour by participants in a social system in relation to each other, and \n:(iii) institutionalised norms or cognitive frameworks that structure the actions of actors in the social system.\n\nLopez and Scott (2000) distinguish between institutional structure and relational structure, where in the former:\n\n{{cquote|...social structure is seen as comprising those cultural or normative patterns that define the expectations of agents hold about each others behaviour and that organize their enduring relations with each other. (p. 3)}}\n\nwhereas in the latter:\n\n{{cquote|...social structure is seen as comprising the relationships themselves, understood as patterns of causal interconnection and interdependence among agents and their actions, as well as the positions that they occupy. (p. 3)}}\n\nSocial structure can also be divided into [[Microsociology|microstructure]] and [[Macrosociology|macrostructure]]. Microstructure is the pattern of relations between most basic elements of social life, that cannot be further divided and have no social structure of their own (for example, pattern of relations between individuals in a group composed of individuals - where individuals have no social structure, or a structure of organizations as a pattern of relations between [[social position]]s or [[social role]]s, where those positions and roles have no structure by themselves). Macrostructure is thus a kind of second level structure, a pattern of relations between objects that have their own structure (for example, a political social structure between political parties, as political parties have their own social structure). Some types of social structures that modern sociologist differentiate are relation structures (in family or larger family-like clan structures), communication structures (how information is passed in organizations) and [[sociometry|sociometric structure]]s (structures of sympathy, antipathy and indifference in organisations - this was studied by [[Jacob L. Moreno]]).\n\n[[Social rule system theory]] reduces the structures of (3) to particular rule system arrangements, that is, the types of basic structures of (1 and 2). It shares with [[role theory]], [[organizational sociology|organizational]] and [[institutional sociology]], and [[network analysis]] the concern with structural properties and developments and at the same time provides detailed conceptual tools needed too generate interesting, fruitful propositions and models and analyses.\n\nSociologists also distinguish between:\n* normative structure  pattern of relations in given structure (organisation) between [[norm (sociology)|norm]]s and modes of operations of people of varying [[social position]]s\n* ideal structure  pattern of relations between beliefs and views of people of varying social potions\n* interest structure  pattern of relations between goals and desires of people of varying social positions\n* interaction structure  forms of communications of people of varying social positions\n\n== Origins and evolution ==\nSome believe that social structure is naturally developed.  It may be caused by larger system needs, such as the need for [[labour (economics)|labour]], [[management]], [[professional]] and [[military]] classes, or by conflicts between groups, such as competition among [[political party|political parties]] or among [[elite]]s and [[Hoi polloi|masses]]. Others believe that this structuring is not a result of natural processes, but is socially constructed.  It may be created by the power of elites who seek to retain their power, or by [[economic system]]s that place emphasis upon [[competition]] or [[cooperation]].\n\nThe most thorough account of the evolution of social structure is perhaps provided by [[structure and agency]] accounts that allow for a sophisticated analysis of the co-evolution of social structure and human agency, where socialised agents with a degree of autonomy take action in social systems where their action is on the one hand mediated by existing institutional structure and expectations but may, on the other hand, influence or transform that institutional structure.\n\n== Critical Implications ==\nThe notion of social structure may mask systematic biases, as it is comprised of many identifiable subvariables, for example, gender.  Some argue that men and women who have otherwise equal qualifications receive different treatment in the workplace because of their gender, which would be term a social structural bias, but other variables (such as time on the job or hours worked) might be masked.  Modern social structural analysis takes this into account through [[multivariate analysis]] and other techniques, but the analytic problem of how to combine various aspects of social life into a whole remains.<ref>Abercrombie, et al., 2000; Jary & Jary 1991</ref>\n\n\n'
p370
tp371
a(I1
S'{{primarysources|date=March 2007}}\n[[File:100_9640.JPG|thumb|A robot that was made using the VEX system to compete in the 2007 FTC competition]]\nThe VEX Robotics Design System is a [[robot]]ic kit intended to introduce students as well as adults to the world of robotics. The VEX Robotics Design System is centered around the VEX Starter Kit (which retails for about USD $300). This kit comes with the VEX brain (a [[microcontroller]]), a hobby-grade [[remote control]], various [[sensor]]s (2 bumper sensor and 2 limiter switches), three [[electric motor]]s and a [[Servomechanism|servo]], wheels (4 small, 2 medium all purpose, and 2 large high traction tires), gears, and structural parts<ref>http://www.vexrobotics.com/vex-robot-kits.shtml</ref>. Additional sensors ([[ultrasonic]]<ref>http://www.vexrobotics.com/vex-robotics-ultrasonic-range-finder-kit.shtml</ref>, line tracking<ref>http://www.vexrobotics.com/vex-robotics-line-tracker-kit.shtml</ref>, optical shaft encoder<ref>http://www.vexrobotics.com/vex-robotics-optical-shaft-encoder-kit.shtml</ref> , bumper switches<ref>http://www.vexrobotics.com/vex-robotics-bumper-switch-kit.shtml</ref>, limit switches<ref>http://www.vexrobotics.com/vex-robotics-limit-switch-kit.shtml</ref>, and light sensors<ref>http://www.vexrobotics.com/vex-robotics-light-sensor-kit.shtml</ref>), wheels ( small and large [[omni-directional]] wheels<ref>http://www.vexrobotics.com/vex-robotics-large-omni-directional-wheel-kit.shtml</ref>, small, medium, and large regulars), tank treads<ref>http://www.vexrobotics.com/vex-robotics-tank-tread-kit.shtml</ref>, motors<ref>http://www.vexrobotics.com/vex-robotics-motor-kit.shtml</ref>, servos<ref>http://www.vexrobotics.com/vex-robotics-servo-kit.shtml</ref>, gears<ref><http://www.vexrobotics.com/vex-robotics-high-strength-gear-kit.shtml</ref> (regular and advanced), chain and sprocket sets<ref>http://www.vexrobotics.com/vex-robotics-high-strength-sprocket-and-chain-kit.shtml</ref>, extra transmitters and receivers<ref>http://www.vexrobotics.com/vex-robotics-transmitter-receiver-add-on-kit.shtml</ref>, programming kit (easyC<ref>http://www.vexrobotics.com/vex-robotics-easyc-programming-kit.shtml</ref>, robotC<ref>http://www.vexrobotics.com/vex-robotics-robotc-programming-kit.shtml</ref>, MPLab<ref>http://www.vexrobotics.com/vex-robotics-mplab-programming-kit.shtml</ref>), extra metal <ref>http://www.vexrobotics.com/vex-robotics-hardware-and-metal-kit.shtml</ref>, pneumatics<ref>http://www.vexrobotics.com/vex-robotics-pneumatic-parts.shtml</ref>, and rechargeable battery power packs<ref>http://www.vexrobotics.com/vex-power-products.shtml</ref>, can all be purchased separately.\n\nThis award winning platform was developed as part of a partnership between Innovation First, Inc. and IFIrobotics. {{fact|date=April 2007}}\n\nThis product was originally available for purchase in [[RadioShack]] stores, and also on the web.  On [[April 17]] [[2006]] Innovation First announced their acquisition of the VEX Robotics brand name and trademark registrations from RadioShack Corporation.<ref>http://www.vexlabs.com/docs/vex_release_4-17-06.pdf</ref> RadioShack stores are no longer selling Vex kits.\n\n== FIRST Tech Challenge ==\n{{main|FIRST Tech Challenge}}\n\nThe FIRST Tech Challenge, formerly the FIRST Vex Challenge, is a mid-level robotics competition announced by FIRST on [[March 22]], [[2005]]. The FIRST Tech Challenge, according to FIRST, was designed to be a more accessible and affordable option for schools. FIRST has also said that the FTC program was created for those of an intermediate skill level. FIRST Tech Challenge robots are approximately one-third the scale of their FRC counterparts. The FTC competition is meant to provide a transition for students from the [[FIRST LEGO League|FLL]] competition to the [[FIRST Robotics Competition|FRC]] competition.\n\nThe 2005 FIRST season featured a demonstration of the FIRST Vex Challenge using a 1/3 linear scale mock-up of the 2004 FRC Competition, [[FIRST Frenzy: Raising the Bar]]. For their 2005-2006 Pilot Season, FVC teams played the Half-Pipe Hustle game using racquet balls and ramps.\n\nFor the 2006 FVC Season (2007 FIRST Season), the FIRST Vex Challenge teams played the Hangin-A-Round challenge using softballs, rotating platforms, a hanging bar, and a larger Atlas ball which is significantly larger than most Vex robots and harder to manipulate. Competitions were held around the United States, Canada, and Mexico.\n\nThe 2007 season featured the Quad Quandary challenge, which was played using PVC rings and moveable goalposts.\n\nFTC no longer features Vex robots, but instead uses the [[Lego NXT]] microcontroller in conjunction with a new hardware kit named Tetrix.<ref>http://thenxtstep.blogspot.com/2008/04/details-of-ftc-kit.html</ref>\n\n=== Games(FTC/FVC) ===\n* 2005 Demonstration: 1/3 Scale [[FIRST Frenzy: Raising the Bar]]\n* 2006 Pilot Season: [[Half-Pipe Hustle]]\n* 2006 Season: [[Hangin-A-Round]]\n* 2007 Season: [[Quad Quandary]]\n\n== VEX Robotics Competition ==\n\nThe VEX Robotics Competition (a different competition from FTC) is another competition utilizing the Vex set of parts<ref>Site can be found [http://www.vexrobotics.com/ here]</ref>.  Teams build and program a robot to complete a task revealed each year.  The 2008-2009 challenge is Elevation.  <blockquote>Elevation is played on a 12x12 square field. Two alliances - one red and one blue - composed of two teams each, compete in each match which consists of a twenty-second autonomous period followed by two minutes of driver-controlled play. The object of the game is to attain a higher score than your opponent alliance by placing cubes into goals, and by owning goals by having the highest cube in a given goal. Points can also be earned by parking on the platform or by controlling the bonus cube. A bonus is awarded to the alliance that has the most total points at the end of the Autonomous Period.</blockquote><ref>Challenge [http://www.vexrobotics.com/vex-elevation.shtml here]</ref>.\n\nWinners of regional competitions go on to the VEX World Championships, held this year at Dallas, Texas.<ref>http://robotevents.com/program.php?event_id=1&sortid=8#championship</ref>\n\nFor the 2009 season, the game is called Clean Sweep<ref>http://www.vexrobotics.com/vex-clean-sweep.shtml</ref>. The cost is currently $75 for the first team from an organization, and $25 after that.<ref>http://www.vexrobotics.com/vex-competitions.shtml</ref>\n\n== VEXplorer ==\nModel kit maker Revell Monogram and VEX robot supplier Innovation First announced more details of their new consumer robot kit February 13, 2007.\n\nThe [http://www.vexlabs.com/vex-robotics-vexplorer.shtml VEXplorer] robot kit is a direct descendant of the VEX robot kit that is the basis for student robot design competitions. It was designed and marketed to bring robotics creation outside the classroom taking the consumer robotics category to new heights.\n\nVEXplorer includes all the parts, motors and wheels to make a remote controlled rolling robot with a webcam and a claw arm strong enough to pick up a full aluminum can.\n\nVEXplorer is the product of a partnership between the two companies that was announced last year. Revell will handle the marketing while Innovation First will provide the engineering and technical design.\n\nThe VEXplorer kit has 2 add-on kits: a wrist joint to give arms more flexibility, and a tank tread set similar in design to those sold as a standard VEX add-on.\n\nAs of 2009 the Vexplorer has been discontinued; however, accessories are still available while they last.<ref>http://www.vexrobotics.com/vex-robotics-vexplorer.shtml</ref>\n\n'
p372
tp373
a(I-1
S'{{Orphan|date=January 2008}}\n\nThe term cultural baggage refers to the tendency for ones [[culture]] to pervade thinking, speech, and behavior without one being aware of this pervasion. Cultural baggage becomes a factor when a person from one culture encounters a person from another, and unconscious assumptions or behaviors can interfere with interaction.\n\nThe baggage imagery implies that cultural baggage is something that one carries at all times and that it can be burdensome, hindering [[freedom of movement]] (i.e. hinders intercultural dialog). [[Darret B. Rutman]] has used the term to describe early European settlers of [[North America]] (A Place in Time: Middlesex County, Virginia 1650-1750 by Darret B. Rutman, Anita H. Rutman, ISBN 0-393-30318-7).\n\n'
p374
tp375
a(I1
S'[[Image:Alaska tok cutoff.jpg|thumb|right|Driving south on The [[Tok Cut-Off|Alaska Tok Cutoff Highway]].]]\n[[Image:OldalignIL.jpg|thumb|An abandoned early [[U.S. Route 66]] alignment in southern [[Illinois]] in 2006.]]\n[[Image:Gravelly Hill Interchange.svg|thumb|right|One of many Spaghetti Junctions, this one is in [[Birmingham, England]]]]\nA roadgeek is an individual involved in roadgeeking or road enthusiasman interest in [[road]]s as a [[hobby]].  A person with such an interest is also referred to as  a road buff, roadfan or Roads Scholar, the latter being a play on the term [[Rhodes Scholarship|Rhodes Scholar]].<ref>[http://www.houstonfreeways.com/statesman_2004-12-12.htm Road to future or a dead end.], Austin American Statesman, 12 December 2004 (accessed 20 January 2007)</ref>  \n\nRoadgeeking may focus on a single activity related to roads, such as driving the full length of the highway system in a specific area, creating fonts and other graphic elements to share with other enthusiasts, or researching the numbering system used for a national highway system.  Road enthusiasts may also have a comprehensive interest in a single road, a larger highway system, or in roads in general, participating in a wide range of hobby activities.\n\n==Roadgeek behavior==\n[[Image:Highway Gothic sample.svg|thumb|right|[[FHWA Series fonts]]also known as Highway Gothic]]\nBehaviors for roadgeeks may include taking [[road trip]]s for the roads rather than for the destination, sometimes referred to as roadgeeking or Roads Scholaring, or bragging about the extent of their travels, such as the number of [[Interstate Highway]] sections that have wholly traveled.<ref>[http://www.triskele.com/highway-heaven/my-clinched-freeways Mike the Actuarys Musings, My Clinched Freeways], accessed [[November 16]], [[2007]]</ref> Other activities include the photography of [[road sign]]s or of various highway sundries, collecting old [[road map]]s, maintaining [[web site]]s dedicated to highway transport, correcting errors in newspapers and other publications about highway terminology and the history of highways <ref>[http://www.washingtonpost.com/wp-dyn/articles/A40612-2005Feb20.html John Kelly A Long Way to Go for a Refund: Highways, Revisited, Washington Post, Page C11, February 21, 2005], accessed June 27, 2008</ref>, and the design of graphics or fonts to facilitate the work of others.<ref>[http://www.triskele.com/roadgeek-fonts Mike the Actuarys Musings, Roadgeek Fonts], accessed November 16, 2007</ref>\n\n===Roadgeeking online===\nIn 2002, the [[St. Louis Post-Dispatch]] reported that road enthusiasm was an internet phenomenon:\n\n{{cquote|Road enthusiasm is a phenomenon that developed with the Internet. People who for years thought they were the only ones who eagerly awaited the release of the new Rand McNally road atlases each fall suddenly stumbled on to hundreds of people with whom they could trade pictures, share ideas and debate the finer points of interchange design. \n\nIn addition to hundreds of Web sites, there is a newsgroup, misc.transport.road, where the discussion meanders from road-trip routing and construction projects to quirks and inconsistencies in signage.<ref name=Lamb>[http://docs.newsbank.com/g/GooglePM/SL/lib00170,0F63781FF9F53473.html Road Geeks Ramp up Their Hobby on the Information Superhighway,] William Lamb, [[St. Louis Post-Dispatch]], September 22, 2002, p C-1, accessed July 20, 2008</ref>}}\n\nExamples of online road enthusiasm\n*[news://misc.transport.road misc.transport.road] ([[Usenet]]); charter approved November 27, 1995<ref>[http://www.faqs.org/usenet/news.announce.newgroups/misc/misc.transport.misc RFD unmoderated group misc.transport.misc], accessed August 16, 2009; charters were approved for misc.transport.misc, misc.transport.marine, and misc.transport.road; the charter for misc.transport.road is for discussion of all aspects of road/highway transportation and design not included in other groups (such as misc.transport.trucking and misc.transport.urban-transit).</ref>  \n*[http://www.roadfan.com/mtrfaq.html misc.transport.road FAQ]\n*[http://groups.yahoo.com/group/roadgeek/ Roadgeek Yahoo List]; founded April 25, 1999\n*[http://www.sabre-roads.org.uk/ Society for All British and Irish Road Enthusiasts (SABRE)], founded August 13, 1999\n*[http://www.geocities.com/humehwy31/index.html Brads Australian Highways Page]; founded September 19, 1999\n*[http://tech.groups.yahoo.com/group/greatlakesroads/ Great Lakes  Roads Yahoo Forum]; founded February 16, 2002\n*[http://www.boards.ie/vbulletin/forumdisplay.php?f=887 Infrastructure forum on [[boards.ie]]]\n*[http://www.skyscrapercity.com/forumdisplay.php?forumid=813 Highways and Autobahns on SkyscraperCity]\n==Organizations of road enthusiasts==\nThe Society for All British and Irish Road Enthusiasts (SABRE) was started in 1999 and given its current name in 2002. The acronym originally meant Study and Appreciation of the British Roads Experience. SABREs 1300 members meet to discuss road sunjects in online forums, hold formal meetings to elect oficers, and maintain several online data projects.<ref name=SABRE>{{cite web|url=http://www.sabre-roads.org.uk/|title=Society: About Us|work=The Society for All British Road Enthusiasts|accessdate=2009-04-09}}</ref><ref name=Milmo>{{cite news|url=http://www.independent.co.uk/news/uk/home-news/round-the-bend-how-we-became-a-nation-of-roadies-755067.html|title=Round the bend? How we became a nation of roadies|last=Milmo|first=Cahal|date=29 October 2004|work=The Independent|accessdate=2009-04-09}}</ref><ref name=Gupta>{{cite news|url=http://www.telegraph.co.uk/motoring/2732679/Never-mind-the-trainspotters.html|title=Never mind the trainspotters|last=Gupta|first=Lila Das|date=17 Jan 2005|work=The Telegraph|accessdate=2009-04-09}}</ref>\n\n==Sites of interest to roadgeeks==\n[[File:Magic Roundabout Schild db.jpg|right|thumb]]\n===[[United Kingdom]]===\n\n*The [[Magic Roundabout (Swindon)|Magic Roundabout]] in [[Swindon, England]] consists of five mini-roundabouts arranged in a circle.<ref name=Milmo/>\n*[[Gravelly Hill Interchange]], one of many known as [[Spaghetti Junction]], is junction 6 of the M6 motorway where it meets the A38(M) Aston Expressway in [[Birmingham, United Kingdom]].<ref name=Milmo/>\n*The A64(M) portion of [[Leeds Inner Ring Road]] is classified as a pathethic motorway by one SABRE member because it is sadly, only 800 yards long and thats if you go the long way.<ref name=Gupta/>\n{{Clear}}\n===[[United States]]===\n====[[Arkansas]]====\n*[[Arkansas Highway 43]]/[[Oklahoma State Highway 20]] [[concurrency (road)|concurrency]], possibly unique instance of two highways from different states overlapping.<ref>[http://roads.tulok.net/u-a43.html Oklahoma Terminus: Arkansas SH-43], Martin McMahon, [http://roads.tulok.net/index.html Roadklahoma], accessed July 17, 2008</ref>\n\n====[[California]]====\n[[Image:Zzyzx Road.jpg|right|thumb|[[Zzyzx, California|Zzyzx]] Road exit sign on [[Interstate 15]]]]\n[[File:Colorado05.JPG|thumb|right|Westbound I-70 on a viaduct inside Glenwood Canyon paralleling the Colorado River]]\n* The [[Ridge Route]], the first paved highway directly linking the [[Los Angeles Basin]] with the [[San Joaquin Valley]] over the [[Tejon Pass]], a portion of which is in the [[National Register of Historic Places]].  It was documented by uber-Roadgeek, Harrison Irving Scott, in 2002. in Ridge Route: The Road That United California. \n*[[Skyline Boulevard]], the road that spans the highest ridge of [[Santa Cruz Mountains]], making it possible to see the [[Pacific Ocean]] and [[San Francisco Bay]] simultaneously.\n*Decommissioned portions of [[U.S. Route 6 in California#History|U.S. Route 6]], now part of [[California State Route 14#History|State Route 14]], are the subject of significant roadgeek interest.<ref>[http://pqasb.pqarchiver.com/latimes/access/119615812.html?dids=119615812:119615812&FMT=ABS&FMTS=ABS:FT&date=May+14%2C+2002&author=LISA+LEFF&pub=Los+Angeles+Times&desc=BEHIND+THE+WHEEL%3B+Road+Scholars+Driven+to+Go+the+Extra+Mile%3B+A+small+but+dedicated+band+of+buffs+spends+free+time+studying+and%2C+yes%2C+traveling+the+states+highways+and+byways.&pqatl=google Lisa Leff, Los Angeles Times, May 14, 2002, BEHIND THE WHEEL; Road Scholars Driven to Go the Extra Mile; A small but dedicated band of buffs spends free time studying and, yes, traveling the states highways and byways], accessed June 27, 2008</ref>\n*[[Zzyzx Road]], a landmark about halfway between [[Los Angeles]] and [[Las Vegas, Nevada|Las Vegas]], known for its unusual name. It is the last place on Earth in the English alphabetical order.\n*[[Interstate 238]] in the [[San Francisco Bay Area]] which defies numbering logic both by location and the absence of its parent, [[Interstate 38]].\n\n====[[Colorado]]====\n*[[Interstate 70 in Colorado|Interstate 70]]s route through [[Glenwood Canyon]], an engineering marvel\n*[[Eisenhower Tunnel]], the highest point on the [[Interstate Highway System]]\n\n====[[Maryland]]====\n*[[Interstate_70_in_Maryland|I-70s eastern terminus]] at a Park & Ride on [[Security Boulevard]] in Baltimore, one of the more unusual Interstate termini\n\n====[[Missouri]]====\n[[Image:Y-Bridge 1.JPG|thumb|right|The Y-Bridge looking east]]\n*Galena [[Y-Bridge (Galena, Missouri)|Y-Bridge]], an unusual bridge with three land connections\n\n====[[Montana]]====\n*[[Going-to-the-Sun Road]], a scenic road crossing [[Glacier National Park (U.S.)|Glacier National Park]], designated both a [[National Historic Landmark]] and a [[Historic Civil Engineering Landmark]].<ref>[http://www.nps.gov/glac/planyourvisit/goingtothesunroad.htm National Park Service Going-to-the-Sun Road]</ref>\n\n====[[North Carolina]]====\n*[[Interstate 73]], which lies east of [[Interstate 77]]\n*[[Interstate 74]], which lies south of [[Interstate 40]] as well as the already-established I-74s eastern terminus in [[Cincinnati, Ohio]] (but is planned to connect there)\n\n====[[Oklahoma]]====\n*[[Arkansas Highway 43]]/[[Oklahoma State Highway 20]] [[concurrency]], possibly unique instance of two highways from different states overlapping.\n\n====[[Oregon]]====\n[[Image:Abandoned Turnpike.jpg|right|thumb|Abandoned Pennsylvania Turnpike]]\n[[File:NB77SB81.JPG|right|thumb|wrong-way concurrency]]\n*[[Historic Columbia River Highway]], the first paved highway in the Pacific Northwest, an engineering and scenic marvel, designated both a [[National Historic Landmark]] and a [[Historic Civil Engineering Landmark]].<ref>[http://www.columbiariverhighway.com Historic Columbia River Highway]</ref>\n\n====[[Pennsylvania]]====\n*[[Abandoned Pennsylvania Turnpike]], an example of 1930s-era highway standards\n*[[Breezewood, Pennsylvania]], a gap in [[Interstate 70]] that routes traffic down US 30 through town\n*[[Centralia, Pennsylvania]], site of underground coal fires undermining the area highways\n*[[Interstate 99]], which lies west of several lower-numbered interstates, such as [[Interstate 81]] and [[Interstate 95]]\n\n====[[Virginia]]====\n*The [[wrong-way concurrency]] of [[Interstate 81]] and [[Interstate 77]], where one goes north on one route and south on the other at the same time.  Located near [http://maps.google.com/maps?f=q&hl=en&geocode=&q=Wytheville,+va&sll=37.0625,-95.677068&sspn=53.432436,114.257812&ie=UTF8&ll=36.943993,-80.982628&spn=0.106464,0.22316&z=13 Wytheville, VA]\n\n== Notable roadgeeks ==\n*Steve Anderson, creator of [http://www.nycroads.com/ NYCROADS.COM], described himself as a hard-core road fanatic (others, he allowed, might say road geek) from childhood according to The New York Times in 1999<ref>[http://query.nytimes.com/gst/fullpage.html?res=9C00EED91F31F933A25753C1A96F958260 Marcia Biederman, Giving Highways Their Due, October 10, 1999, The New York Times], accessed June 27, 2008</ref>\n*Nick Christensen, also known as Nick Mojave, created the Las Vegas Freeways Page in the early 2000s, and was perfectly comfortable being referred to as a road geek, according to the Las Vegas Review-Journal in 2001.<ref>[http://nl.newsbank.com/nl-search/we/Archives?p_product=LVRB&p_theme=lvrb&p_action=search&p_maxdocs=200&p_topdoc=1&p_text_direct-0=0FD394895CFE7ABD&p_field_direct-0=document_id&p_perpage=10&p_sort=YMD_date:D&s_trackval=GooglePM One mans traffic is anothers obsession], Michael Squires, Las Vegas Review-Journal, [[October 21]], [[2001]], accessed [[July 17]], [[2008]]</ref><ref>[http://www.kvbc.com/Global/story.asp?S=190247 Geekier than moi?], KVBC News 3, accessed July 17, 2008</ref>\n*Andy Field and Alex Nitzman of [http://www.aaroads.com/ AARoads] were noted by the [[St. Louis Post-Dispatch]] and others since 2002 for maintaining a site with an exhaustive guide to the interstate highway system.<ref name=Lamb/><ref>[http://docs.newsbank.com/g/GooglePM/SR/lib00139,10B88BC2510164C0.html Road geeks get their kicks on Route 66, or even on I-90: Studying, documenting, discussing the nations roadways and signage is highway to heaven for these enthusiasts,] [[The Spokesman-Review]], [[August 4]], [[2004]], accessed [[July 20]], [[2008]]</ref>\n*Brad Jackson, founder of the Society for All British Road Enthusiasts (SABRE).<ref name=SABRE/><ref name=Gupta/>\n*Erick Johnson, of [[Palmer, Alaska]], noted by the Seattle Times for his attention to Pacific Northwest roads at his site, [http://nwhighways.amhosting.net/ Northwest Highways].<ref>{{cite news|url=http://seattletimes.nwsource.com/html/localnews/2001994614_roadgeeks02.html|title=Highway geeks keep eyes on road |last=Rodkey|first=Chris|date=August 2, 2004|work=Seattle Times|accessdate=2009-04-09}}</ref>\n*Wesley Johnston, creator of the [http://www.wesleyjohnston.com/roads Northern Ireland Roads Site].<ref>{{cite news|url=http://www.newsletter.co.uk/news/OPINION-Upgraded-M2s-benefits-should.5255859.jp|title=Opinion: Upgraded M2s benefits should outweigh costs|last=Johnston|first=Wesley|date=May 12, 2009|work=Belfast News Letter|accessdate=October 10, 2009}}</ref>\n*Adam Prince, of [http://www.gribblenation.com/ GribbleNation.com] and a self-described road geek whose hobby is learning everything he can about Americas highways and byways, according to the Washington Post<ref>[http://www.washingtonpost.com/ac2/wp-dyn/A56265-2004Feb19?language=printer Washington Post Answer Man, Sunday, February 22, 2004; Page M08, What is the Seminole Trail? What do the green signs that say Seminole Trail along Route 29 in Virginia refer to?], accessed June 27, 2008</ref>\n*David Steinberg, creator of [http://www.ihoz.com/interstates.html The ZZYZX Interstate Highway List], as featured in The Telegraph of Nashua, New Hampshire in 1999.<ref>[http://nl.newsbank.com/nl-search/we/Archives?p_product=NTGB&p_theme=ntgb&p_action=search&p_maxdocs=200&p_topdoc=1&p_text_direct-0=10708D6DB5EE35E8&p_field_direct-0=document_id&p_perpage=10&p_sort=YMD_date:D&s_trackval=GooglePM And you may ask yourself, where does that highway go to?], [[The Telegraph (Nashua)]], New Hampshire, [[December 21]], [[1999]], accessed July 17, 2008</ref>\n*Dan Faigin, creator of [http://www.cahighways.org California Highways], a complete history catalog of all numbered highways in California, has been used as a reference by [[CalTrans]] on a number of occasions.\n\n'
p376
tp377
a(I-1
S'Model Engineer Magazine was first published (in the [[United Kingdom]]) to support the hobby of [[model engineering]] in 1898 by Percival Marshall, who was to remain its editor for over 50 years. It has been published by My Hobby Store.com since 2008.\nThe magazine addressed the emergence of a new hobby  the construction of models (often working) and experimental engineering, largely in metal. It transcended class barriers, appealing to professional engineers, jobbing machinists and anyone interested in making working mechanisms.\n\nThe magazine has had many notable contributors, but foremost among these was [[LBSC]] ([[pen name]] for Lillian Lawrence AKA Curly). From the inter-war period to the 1960s he produced many designs for simple but reliable small model steam locomotives. Most of these were published in Model Engineer, and brought the construction of small passenger hauling locomotives within the reach of the typical home machinist. Other notable contributors include [[Henry Greenly]], [[Edgar T. Westbury]] and one of the most notable editors, [[Martin Evans (Engineer)|Martin Evans]].\n\nModel Engineer has had a long-standing association with the [[Model Engineer Exhibition]], originally held at [[Olympia, London|Olympia]] in London. The exhibition is almost as venerable an institution as the magazine itself, and is notable for the display of some of the finest examples of the hobby.\n\nThe subject matter of the (now twice monthly, earlier weekly) magazine ranges from articles about techniques and tools to profiles of full-size prototypes of modelling subjects. The main content is, however, constructional articles describing projects at various levels of detail. Such articles range from single pages to long running series in alternate issues, some of which can last for many months, if not years. These more detailed series generally appeal to a wider audience than those engaged in the project. It is often as much in the processes described as in the (often loosely) related anecdotes alongside.\n\nOver the years the magazine has waxed and waned, but is currently enjoying the increased popularity of the hobby engendered by the availability of comparatively cheap machine tools from China and Taiwan.\n\n'
p378
tp379
a(I1
S'{{Unreferenced|date=January 2008}}\n\nAquarium lighting describes any type of [[light]] that is used to illuminate an [[aquarium]] tank or in some instances, such as with reef aquariums, support the life contained within. \n\n==Freshwater==\n\nFreshwater aquarium lighting often comes in two forms; one is a screw-in style [[incandescent bulb]] and the other is normal output [[fluorescent lighting]]. Screw-in [[Compact fluorescent lamp|compact fluorescent lighting]] is also used in freshwater aquaria since it provides brighter light output than traditional screw-in style bulbs.\n\nMore demanding freshwater set-ups, such as planted freshwater aquariums, may require stronger light sources. Compact fluorescent bulbs, high output T5 bulbs or [[metal halide lamp]]s are often used over such aquariums to encourage plant growth. While these lights can provide a better spectrum than traditional ones, they often use more electricity and have a high heat output.\n\n==Reef==\nThe [[reef aquarium]] field is where aquarium lighting varies the greatest. Some reef aquarium keepers use VHO (Very High Output) fluorescent tubes, compact fluorescent lighting, and metal halide lighting since they provide much brighter light than average fluorescent bulbs and come in a variety of spectrums. Reef keepers often opt for light of varying spectrum. Since many corals require a deep blue or actinic spectrum of light to thrive many aquarists must supplement traditional white light with light of this color. Also popular with reef keepers is T5 High Output fluorescent bulbs. These bulbs are thinner than traditional T8 bulbs and provide a much brighter, more powerful light.\n\nAnother light source in reef aquariums today is metal halide lighting. These high output lights closely recreate the shimmering effect of bright tropical sun over a patch of coral reef. Metal halide bulbs come in a variety of spectra from 5000k on up to 20,000k and allow for a variety of light hungry corals to survive under them. Many aquarists will use metal halide bulbs in conjunction with either power compact fluorescents or T5 fluorescents since halide lighting does not have the overall balanced effect of other light types. While very useful to reef aquarium keepers, halide lighting also uses a lot of electricity (150-400 watts being common)and produces copious amounts of heat. Most reef keepers mount halide bulbs at least one foot above their tank and some, due to the lights heat output have had to add chillers to keep aquarium water cool. \n\nMany light fixtures come as all-in-one units with light for both daylight hours and nighttime viewing. [[LED lamp]]s of 3/4 to 2 watts can be implemented to come on at night, simulating the glow of the moon over the tank. All in one fixtures require large fans to cool the bulbs and achieve maximum light efficiency. LED lighting is also becoming more common for not only lunar lighting but also to simulate daylight conditions, LEDs have a higher initial cost than other lighting sources but utilize much less energy.  They are also dimmable.  LEDs produce a very narrow color spectrum that is limited to a narrow band of wavelengths. For this reason an array of different colored LEDs is required to be used in combination to simulate spectral coverage that is suitable for coral growth.  Early adopters of pure LED based systems have reported that the limited color spectrum provided by LEDs may not produce optimal coral growth.\n\n\n{{Aquarium}}\n\n'
p380
tp381
a(I-1
S'{{Orphan|date=November 2006}} \nMapcore is a game development community primarily revolving around mod makers who specialize in mapping, texturing and modeling. While originally it was mostly a [[Half-Life (video game)|Half-Life]] community it has evolved into a community for a wide variety of [[Video game|games]]. <!-- Unsourced image removed: [[image:mapcore-logo.jpg|right|thumb|225px|The new Mapcore logo.]] -->\n\n== History ==\n\nMapCore was founded in 2000 by young (then 15 years old) level designer Mark Anarchy Long under collaboration with several other well-known designers and artists from the Half-Life development community, notably Joshua EuroBrew De Jong, Mike MikeZilla Neumann, Fletch (real name unknown), Lestat (real name unknown), David Zaphod Marsh, and Pat Mojo Krefting. \n\nMapCore was an evolutionary progression from the self-titled Anarchy Design (1999), a design-focused website and IRC community officially supported and hosted by the original [[Counter-Strike]] development team. Due to the explosive growth of the community and the widespread popularity of the Half-Life engine as a platform for development of third party modifications, Anarchy Design was revamped to include developers from projects other than Counter-Strike and renamed MapCore in order to suit the new direction of the site. \n\nThe website was re-launched in August 2000 as an affiliate on the (now defunct) [[GameFan]] Network, and partnered up with other sites in the creative community, including 3DPalette, Skindom, [[GFXArtist]], and GameArt. Unfortunately, the timing of this move was extremely poor, with GFN playing a leading role in a fairly high profile [http://slashdot.org/articles/00/10/10/1221234.shtml scandal] just months later - the network refused to honor advertising agreements with its partner sites, withholding paychecks from major players including SomethingAwful, VoodooExtreme, and others. The network imploded rapidly, leaving MapCore without a home. Shortly after, Anarchy passed the reins off to the remaining members of the team, and the community was run by EuroBrew for some time. In 2002, MikeZilla took over and put the site back up with the help of Mojo and Zaphod. \n\nSince 2000, core members of the community have contributed to almost every major Half-Life mod, including [[Counter-Strike]] and [[Day of Defeat]]. Several members of the community have even gone on to professional careers in [[game development]] and contributed to titles such as [[Brothers in Arms]], [[Vampire: The Masquerade - Bloodlines|Vampire: Bloodlines]], [[Hitman: Blood Money]], [[StarCraft 2]], [[World of Warcraft]], [[Diablo 3]]  and [[S.T.A.L.K.E.R.]] Today MapCore is a group of people, both amateurs and professionals, who share the same passion of [[game design]] and development on all [[Platform (computing)|platforms]] and [[game engine|engines]]. Through this web presence and an [[IRC]] channel, MapCore aims to provide a community for developers to socialize, learn, teach, and draw talent from.\n\n== IRC ==\nMapcore first started as an [[IRC]] channel.\nThe current channel is located at #mapcore on the server [[GameSurge|irc.gamesurge.net]]\n\n== Website ==\nMapcore is also composed of a website, revolving mostly around the forums.\n\n=== Thumbnails ===\nThe thumbnail images on the mapcore frontpage were updated frequently. They showed what the MapCore members are capable of and set a standard for the community. When clicked they linked to the forum thread about the subject. The works presented were of a level of quality you will only find in the professional gaming industry. This feature is due to be reintroduced in Summer 2008.\n\n'
p382
tp383
a(I1
S'[[Image:Painted Indian Glassy Fish.jpg|right|thumb|200px|Painted Parambassis ranga specimen. A needle was used to inject the pink dye.]] \nThe term painted fish refers to ornamental [[aquarium]] [[fish]] which have been artificially coloured to appeal to consumers. This artificial colouring, also known as juicing, is achieved by a number of methods, such as [[Injection (medicine)|injecting]] the fish with a [[hypodermic]] [[syringe]] containing bright fluorescent colour [[dye]], dipping the fish into a dye solution, or feeding the fish dyed food.\n\nThis process is usually done to make the fish a brighter colour and more attractive to consumers. The colouring of the fish is not permanent, and usually fades away in six to nine months.\n\n==Methods==\nThere are a number of methods for introducing artificial colour to fish, although specific information on methodology is sometimes scanty.\n\n===Dyes===\nA common method of creating painted fish is through injection via syringe. Generally, fish are injected multiple times.<ref name=pf0398>{{cite web | url = http://www.practicalfishkeeping.co.uk/pfk/pages/show_article.php?article_id=72 | title = Why its cruel to dye | publisher = Practical Fishkeeping | author = Dr Stan MacMahon and Dr Peter Burgess | date = March, 1998 | accessdate = April 20, 2009 }}</ref> Fish may also be dipped in a caustic solution to strip their outer slime coat, then dipped in dye. This method is reported to have a very high mortality rate.<ref name=sharpe>{{cite web | url=http://freshaquarium.about.com/cs/beginnerinfo/a/paintedfish.htm | title=Death by Dyeing | publisher = About.Com | author = Shirlie Sharp | accessdate = May 19, 2006 }}</ref>\n\nMany varieties of colour-enhancing foods for aquarium fishes are available to the consumer. Generally, these foods contain natural dyes such as beta [[carotene]] and are not harmful to fish, although as with other dye methods, the effect is temporary.  One source reports that harmful dyes are sometimes used by wholesalers, however.<ref name=sharpe />\n\n===Lasers===\nFish can also be tattooed using a low-intensity laser with a dye, a process developed for fisheries by scientists but this technique is now applied to ornamental fish.<ref>{{cite web | url = http://www.practicalfishkeeping.co.uk/pfk/pages/item.php?news=850 | title = Company offers custom fish tattoos with laser | publication = Practical Fishkeeping | date = [[2006-02-23]] | accessdate = 2006-05-19}}</ref>\n\n===Genetic modification===\nAquarium fish genetically modified to fluoresce in bright colours under [[white light|white]] or [[ultraviolet light|ultraviolet]] [[light]] are now available commercially in the [[United States]], under the trade name [[GloFish]]. The technology was developed originally to produce a fish capable of detecting environmental [[pollution]].<ref>{{cite web | title = GloFish: First Genetically Modified Pet in U.S. | publisher = The Pew Initiative on Food and Biotechnology | year = 2004 | url = http://pewagbiotech.org/buzz/display.php3?StoryID=118 | accessdate = 2006-12-10 }}</ref> These [[zebrafish]] are available in several fluorescent colours, protected by a United States [[patent]].<ref>{{cite web | title = United States Patent 7,135,613 | date = November 14, 2006  | url = http://patft.uspto.gov/netacgi/nph-Parser?Sect1=PTO2&Sect2=HITOFF&p=1&u=%2Fnetahtml%2FPTO%2Fsearch-bool.html&r=1&f=G&l=50&co1=AND&d=PTXT&s1=7,135,613&OS=7,135,613&RS=7,135,613 | accessdate = 2006-12-10}}</ref>\n\n=== Hormones ===\n\nIts not introducing any kind of artificial color, but provoking the apparition of mating period tonalities by administering hormones. This is argued to be used for minimizing the stressful effects of transport in fish aspect. This might also be used for making females of certain fish species look more colorful, despite this can also render them infertile. <ref>http://www.thekrib.com/Fish/steroids.html thekrib.com</ref>\n\n==Varieties==\n[[Image:Painted Blood Parrot Cichilds2.jpg|thumb|200px|Painted [[blood parrot cichlid]]s]]\nSome species, such as albino [[Corydoras]] and painted glassfish, are injected with dye using a [[hypodermic needle]]. In more recent times (2004-2005), injection dyed albino [[Plecostomus]] and rift lake [[cichlids]] have also become available. Other than the Indian Glassy Fish, most dyed fish are albinos.\n\n===Some commonly painted species===\n*[[Indian glassy fish|Indian Glassy Fish]] (Parambassis ranga). Tradename: Painted glassfish; Disco Fish; Colored Glass Tetra; Lightbulb tetra.\n*[[Black tetra]] (Gymnocorymbus ternetzi). Tradenames: Berry Tetra; Painted Tetra.\n*[[Oscar (fish)|Oscar]] (Astronautus ocellatus). Tradenames: Blueberry Oscar; Strawberry Oscar.\n*[[Corydoras]] species\n*African Rift Lake [[cichlid]]s, such as Pseudotropheus. Tradenames: Ice Blue Albino Cichlid; Zebra Ice Albino Cichlid.\n*[[Plecostomus|Suckermouth catfish]] (Hypostomus plecostomus). Tradenames: Patriotic Suckerfish; Mixed Color Suckerfish.\n*[[Blood parrot cichlid]] (Amphiliphus citrinellus x Heros severus). Tradenames: Jellybean Cichlid; Cotton Candy Cichlid.\n*[[Goldfish]] (Carassius auratus). Tradenames: Jellybeans; Icepops.<ref>{{cite web | url = http://www.deathbydyeing.org/colormedead.htm | title = Shades of Death | accessdate = 2006-05-19}}</ref>\n\n==Health hazards to painted fish==\nA 1998 survey carried out in the South of England  revealed that over 40% of painted [[Indian glassy fish|glassfish]] showed signs of a [[Lymphocystis]] infection, compared to 10% of unpainted glassfish.  The infection may have been caused by transmitting the virus from fish to fish via an infected needle, or by a reduced resistance to the infection due to stress from the injection process.<ref name=pf0398/>  In addition, fishes injected with dye often die without apparent external disease symptoms, presumably due to kidney disease caused by injection.<ref>{{cite web | url = http://www.edas.com.au/EDAS-Editorials.htm#PaintedAngels | title = Whats wrong with a painted angel? | author = Jim Greenwood, B.V.Sc. | publisher = Eastern Districts Aquarium Society | accessdate = 2009-04-20 }}</ref>\n\n==Efforts to stop fish painting==\nSome members of the aquarium trade want to ban this practice. For example, the British publication [[Practical Fishkeeping]] started a campaign in 1996 to ask retailers to stop selling dyed fish, which led to a significant decrease in the number sold in the [[United Kingdom]]. Practical Fishkeeping has launched a similar campaign with a global scope and maintains a register of stores which do not stock dyed fish.<ref>{{cite web | url = http://www.practicalfishkeeping.co.uk/pfk/pages/campaign.php | title = Dyed Fish Campaign | publication = Practical Fishkeeping | accessdate = 2006-05-19 }}</ref>  The [[Royal Society for the Prevention of Cruelty to Animals]] (RSPCA) regards the practice as cruel and unnecessary cosmetic [[mutilation]]. A campaign in Australia and in the UK has limited the sale of these fish. Dyed fish are still available and are generally imported from [[Southeast Asia]].\n\nIn February 2006, the UKs [[Department for Environment, Food and Rural Affairs]] (Defra) confirmed that it will not be making it illegal to sell dyed fish in the UK under the forthcoming Animal Welfare Bill.<ref>{{cite web | url = http://www.practicalfishkeeping.co.uk/pfk/pages/item.php?news=848 | title = Dyed fish to remain legal | publication = Practical Fishkeeping | date = [[2006-02-17]] | accessdate = 2006-05-19 }}</ref>\n\n'
p384
tp385
a(I1
S'[[Image:Lockpicking Tools.jpg|thumb|right|A traditional set of pin/tumbler lock picks. The two tools on the left are torsion wrenches (commonly referred to as tension wrenches).|400px]]\n[[Image:IDET2007 lock picking device.jpg|thumb|right|400px|CYL2, device used by Czech [[StB]] for lock picking and creating duplicates of common pin tumbler locks]]\n\nLock picking is the skill of unlocking a [[lock (device)|lock]] by analyzing and manipulating the components of the lock device, without the original key.  Although lock picking can be associated with [[criminal intent]], it is an essential skill for a [[locksmithing|locksmith]].  Lock picking is the ideal way of opening a lock without the correct key, while not damaging the lock, allowing it to be [[rekey]]ed for later use, which is especially important with antique locks that would be impossible to replace if destructive entry methods were used.\n\nLocking picking is only made possible by unavoidable mechanical machining errors in the fabrication of locks. \n\nThe move towards combination locks for high security items such as safes was intended to remove the weakest part of the lock: its keyhole.\n\nIn normal situations it is almost always easier to gain access by some means other than lock picking; most common locks can be quickly and easily opened using a drill, [[bolt cutters]], padlock shim, a [[Lock bumping|bump key]] or a hydraulic jack.  The hasp, door, or fixture they are attached to can be cut, broken, unscrewed or otherwise removed, windows can be broken etc.  Therefore a lock that offers high resistance to picking does not necessarily make unauthorized access more difficult, but will make [[wikt:surreptitious|surreptitious]] unauthorized access more difficult.  Locks are often used in combination with [[Burglar alarm|alarm]]s to provide [[layered security]].\n\nSome people enjoy picking locks recreationally.  This may also be referred to as [[Locksport]].\n\n== Pin/Tumbler and Wafer Pick sets ==\nThe tools for lock picking Pin/Tumbler type locks and wafer type locks can be improvised from common items, or machined at home with relative ease. This is also the case with warded locks. These type above cover the vast majority of American and European domestic locks, the UK being an exception where five lever mortice locks are a requirement for home insurance.  A different tool set is required for more complex locks such as mortice locks which are not as easily fabricated. \n\nThe process of picking pin/tumbler and wafer locks is concerned with causing the two sets of pins (upper or driver pins and bottom pins) to separate such the cylinder will turn. The point at which the pins properly separate when the lock is unlocked is called the shearline.\n\nLock pick kits can be purchased openly via the Internet.  Many different selections are present.  Nine-piece sets and a 32-piece set equipped with a Pick Gun for example differ in value and price greatly.  However, many lock pickers state that for most simple locks, a basic set of five picks is enough; therefore it is unnecessary to carry around a wide variety of professional lock picks.\n\n===Torsion wrench===\n[[Image:Lockpicks.jpg|thumb|right|A traditional pickset. From left to right: Torsion wrench, twist-flex torsion wrench, offset diamond pick, ball pick, half-diamond pick, short hook, medium hook, saw (or L) rake, snake (or C) rake.|250px]]\nOften called a torque wrench or a torsion wrench. A tension wrench is a [[tool]] used in picking locks.  Typically shaped like a letter L (although the vertical part of the letter is elongated in comparison to the horizontal part), it is used to apply torsion to the inner cylinder of a lock, in order to hold any picked pins in place, while the other pins are shifted.  The tension wrench is then used to turn the inner cylinder and open the lock.\n\nDespite its popular name, the tool provides [[torsion (mechanics)|torsion]], not [[tension (mechanics)|tension]].  A tension wrench would be, by definition, a tool that stretches something.  A torsion wrench would be a tool that twists.\n\nSome tension wrenches (called Feather Touch wrenches, among other names) are coiled into a [[spring (device)|spring]] at the bend in the L, which helps the user apply constant torque. Some users, however, maintain that such wrenches reduce torsion control and the feedback available to the user. \n\nOther torsion tools, espcially those for use with cars resemble a pair of tweezers and allow the user to apply torsion to both the top and the bottom of the lock. These would commonly be used with double sided wafer locks.\n\nAlso, high tech torsion tools exist which sit over the lock face allowing the user to see a display of the amount of torsion applied. This aids with the process of feeling when a pin has set.\n\nThe torsion tool is just as important, if not more so, as other tools in the set, but is often neglected and is rarely represented in fiction.\n\nFor avoidance of doubt, it is not possible to pick a pin/tumbler or wafer lock without a torsion tool, even with the use of a pick gun.\n\n===Half-diamond pick===\nPerhaps the most basic and common pick, this versatile pick is included in all kits and is mainly used for picking individual pins, but can also be used for raking and for wafer and disk locks. Each of the ends of triangular half diamond of this pick can be either steep or shallow in angle, depending on the need for picking without neighboring pins, or raking as appropriate. A normal set would comprise around three half diamond picks and a double half diamond pick.\n\n===Hook pick===\nIt is similar to the half diamond pick, but has a hook shaped tip rather than a half diamond shape.\nThe hook pick is sometimes referred to as a feeler or finger and is not used for raking. This is the most basic lock picking tool and is all that a professional will usually need if the lock is to be picked in the traditional sense rather than opened by raking or using a pickgun. A variety of different sized and shaped hooks will be available in a normal set.\n\n===Rake picks===\nThese picks, such as the common snake rake, are designed to rake pins by rapidly sliding the pick past all the pins, repeatedly, in order to bounce the pins until they reach the shear line. This method requires much less skill than picking pins individually, and generally works well on cheaper locks.\n\nWhen the pins are excited they bounce all around the shear line and with the skillful application of a torsion tool this is the easiest way to pick a lock. This is also how beginners begin. Advance rakes are available which are shaped to mimic various different pin height key positions and are considerably easier to use than traditional rakes. \n\n===Slagel pick===\nA rarely used pick mainly used for opening [[electronic lock]]s.  It is often made with small magnetic regions.  The Slagel pick is named after [[James Slagel]], who is a leading security technician for IBM.  The Slagel pick works by selectively pulling internal parts of the lock to the correct positions.{{Citation needed|date=October 2009}}\n\n===Warded pick===\nA warded pick, also known as a skeleton key, is a device for opening [[warded lock]]s. It is generally made to conform to a generalized key shape relatively simpler than the actual key used to open the lock; this simpler shape allows for internal manipulations. This style of pick can also be used to rip the lock. This is where the pick is placed at the back of the lock and then pulled out in one sharp fast ripping action.\n\nThe keys for warded locks only require the end section which is the one which actually open the locks. The other parts are there to distinguish between different variation of their locks. I.e if you have a chest of drawers which a warded lock you can make a skeleton key for that type of warded lock by filing away all but the end of the key.\n\n== Pick guns ==\n[[Image:PKXGUN-E.jpg|thumb|right|A traditional electric pick gun that runs off of C-cell batteries.]]\n[[Image:PKXGUN-M.jpg|thumb|right|A traditional manual pick gun that is used by pulling the trigger.]]\nOften seen in movies and in the tool box of locksmiths, manual and electronic pick guns are a popular method used today for quick and easy ways of opening doors. The higher-end electric pick guns are usually made of aircraft aluminum and hard steel.  The pick is operated by simply pressing a button that vibrates while the normal tension wrench is being used.  A manual pick gun (or [[Snap gun]]) is used in a similar way but usually has a trigger that creates an upward movement that must be repeated rapidly to open the lock.\n\nThese operate on the same principle as Newtons Cradle. They transfer sudden upwards energy to the bottom pins which communicate this to the top pins causing those pins only simultaneously to jump. A pick gun is used in conjunction with a torsion tool and the only skill required here is learning the timing. \n\n==Anti picking methods==\n\nTo prevent picking of locks numerous methods have been employed throughout history including the firing of spring loaded knives and electrocution as well as locks which will need to be reset with a master key if they have been unsuccessfully picked. \n\nToday anti picking methods include the use of side wards (which obstruct the key way) and security pins. These are pins which are shaped like a spool, mushroom, or barrel with the effect that they feel as though they have set when in fact they have not. Overcoming these pins involves reverse picking (the process of first setting all pins above the shear line and gradually reducing torsion.\n\n== Legal status ==\n===United States===\nIn the [[United States]], laws concerning possession of lock picks vary from state to state.  Generally, possession and use of lock picks is considered equivalent to the possession of a [[Crowbar (tool)|crowbar]] or any other tool that may or may not be used in a burglary.  Illegal possession of lock picks is generally prosecuted as a felony under the category of possession of burglary tools or similar statutes.  In many states, simple possession is completely legal as their statutes require proof of intent.  \n\nIn [[California]], locksmiths must be licensed by the state.<ref>{{\ncite news\n|url=http://www.dca.ca.gov/bsis/industries_regulated/locksmith.shtml\n|publisher=California Department of Consumer Affairs\n|title=Locksmith Companies and Employees\n}}</ref>  However possession by [[laymen]] may be legal there and in most states, as illegal possession must be coupled with felonious or malicious intent.<ref>{{\ncite news\n|url=http://www.leginfo.ca.gov/cgi-bin/displaycode?section=pen&group=00001-01000&file=466-469\n|publisher=California Legislative Information\n|title=California Penal Codes, Sections 466469\n}}</ref> This is also the case in [[Utah]],<ref>http://le.utah.gov/~code/TITLE76/htm/76_06_020500.htm Utah Criminal Code: Title 76 - Chapter 06 - Section 205</ref> [[Massachusetts]], [[Maine]], [[New Hampshire]], [[Washington, DC]],<ref>[http://weblinks.westlaw.com/Find/Default.wl?DB=DC%2DST%2DTOC%3BSTADCTOC&DocName=DCCODES22%2D2501&FindType=W&AP=&fn=_top&rs=WEBL8.10&vr=2.0&spa=DCC-1000&trailtype=26&Cnt=Document District of Columbia Official Code, DC ST  22-2501]</ref> and [[New York]].\n\n===Canada===\nIn [[Canada]], possession of lock picking tools, with the exception of key duplication tools, is legal. However, Canadian Criminal Code prohibit the use or possession of Lock Picking tools with the intention to commit a crime. It is illegal to use lock picking tools to trespass, commit an act of robbery or commit any other criminal offense. In short, lock pick tools fit in the same category as crowbars or hammers, meaning they are legal to possess and use unless they are used to commit a crime or if it is shown there was intention to commit a crime. If you are found using Lock Picks to commit a crime, you may be charged with Possession of tools with the intention of committing a crime which carries a maximal penalty of 10 years in jail.<ref>{{cite web|url=http://www.lockpickersmall.com/faq.html#13|title=Canadian Laws on possession and usage of Lock Picking Tools|accessdate=2008-06-11}}</ref>\n\n=== European Union ===\nMost countries of the [[European Union]] dont regulate the possession of lock picks. In fact some even encourage people to learn this skill since it can be useful in emergency situations.{{Citation needed|date=March 2009}} All responsibility concerning criminal or legal acts using the picks is taken by the user of the lock picks, when the [[owner]] of the lock picks may be involved in the [[jurisdiction]] or [[Service of process|legal process]] as an [[accomplice]] or [[witness]]. \n\n==== Netherlands ====\nIn the [[Netherlands]], owning lock picks is legal, but using them on someone elses locks without permission is not.  There is a lock picking championship, the Dutch Open (organised by [[The Open Organization Of Lockpickers|TOOOL]]), which was reported on in the newspapers.<ref>Lock pickers hebben slot in paar seconden open, the Leeuwarder Courant, [[2002-12-02]]\n*Vito Tieke, Even Vragen Aan, the Algemeen Dagblad, [[2002-12-02]]\n*Duitser kampioen sloten openen, the Sp!ts, probably [[2002-12-02]]\n*Duitser wordt in Sneek kampioen sloten openen, the Friesch Dagblad, probably [[2002-12-02]]\n*Duitser eerste kampioen sloten openen in Sneek, the Dagblad van het Noorden, probably [[2002-12-02]]\n*Sloten openen als nieuwe sport, Dagblad de Limburger, probably [[2002-12-02]]\nNote: the dates of some articles were not available, but considering the fact that newspapers generally report promptly, it can be assumed the given dates are correct.\n\nIt was also documented on television, in the programs Hart van Nederland and on Omproep Friesland.</ref>\n\n==== Poland ====\nIn [[Poland]] according to the delinquency Codeep Act article 129  1:<br />\n1) possessing, producing or obtaining a lockpick by a person whose profession and occupation doesnt require it;<br />\n2) delivering a lockpick to a person whose profession and occupation doesnt require it;<br />\n3) []<br />\nis punishable with arrest, freedom limitation or fine.  3 says that a lockpick is forfeited even if it wasnt a property of the principal.\n\n====United Kingdom====\nIn the [[United Kingdom]], a person who carries a lock pick set (even a home made one) can be charged with the offence of going equipped to commit theft, unless they have a good reason for carrying them.<ref>{{cite web|\nurl=http://www.police-information.co.uk/legislation/legislationindexeng.html#G|\ntitle=Police-information.co.uk legislation index|\naccessdate=2006-08-10}}</ref>  The penalty for this can be upward of 5 years imprisonment.  The arresting officer must have [[reasonable cause]].\n\n===New Zealand===\nIn [[New Zealand]] lock picking tools are not illegal, but possession with the intent to use them for [[burglary]] carries a potential penalty of three years in prison.<ref>{{cite web|url=http://www.legislation.govt.nz/act/public/1961/0043/latest/DLM330247.html?search=qs_act_burglary#DLM330247|title=New Zealand Crimes Act (1961), Section 223, subsection 1 - Being disguised or in possession of instrument for burglary|accessdate=2008-03-26}}</ref>\n\n==Media==\nWhen lockpicking is shown in movies and television shows, the torsion wrench is almost always omitted.  Picking a [[Pin tumbler lock|pin and tumbler]] lock without torsion is impossible unless there  is a major defect in the lock.  \n\nIn some modern dramas (such as [[Fox Broadcasting Company|Fox]]s [[24 (TV series)|24]]) in which realistic depiction of events is favored, the pick-and-wrench technique is fully shown (albeit often executed in a second or two, which doesnt accurately reflect the luck involved with raking an unfamiliar lock).\n\nAlthough there do exist raking tools in which a single element may be used to open a lock (such as automobile tryout keys), these are rarely used in media depictions, and almost as rarely used in real life.  The broad width of these picks allows for the necessary application of torque, just as an external source of torque is not required when using a standard key.\n\n'
p386
tp387
a(I-1
S'{{otheruses}}\n\nSympathy is a social affinity in which one person stands with another person, closely understanding his or her feelings. The word derives from the [[Greek language|Greek]]  (sympatheia)<ref>[http://www.perseus.tufts.edu/cgi-bin/ptext?doc=Perseus%3Atext%3A1999.04.0057%3Aentry%3D%2398480 Sympatheia, Henry George Liddell, Robert Scott, A Greek-English Lexicon, at Perseus]</ref>, from  (syn) together +  ([[pathos]]), in this case suffering (from  - pascho, to be affected by, to suffer). It also can mean being affected by feelings or emotions. Thus the essence of sympathy is that one has a strong concern for the other person. Sympathy exists when the feelings or [[emotions]] of one person are deeply understood and appreciated by another person.\n\nThe [[psychology|psychological]] state of sympathy is closely linked with that of [[compassion]], [[empathy]] and [[empathic concern]]. Although empathy and sympathy are often used interchangeably, a subtle variation in ordinary usage can be detected. To empathize is to respond to anothers perceived emotional state by experiencing feelings of a similar sort.<ref>Chismar, D. (1988). Empathy and sympathy: the important difference. The Journal of Value Inquiry, 22, 257-266.</ref> Sympathy not only includes empathizing (but not always), but also entails having a positive regard or a non- fleeting concern for the other person.<ref>Decety, J., & Batson, C.D. (2007). Social neuroscience approaches to interpersonal sensitivity. Social Neuroscience, 2(3-4), 151-157.</ref>\n\nIn common usage, sympathy is usually making known ones understanding of anothers [[unhappiness]] or [[suffering]], especially when it is [[grief]].\n\nSympathy can also refer to being aware of other ([[Positive affectivity|positive]]) emotions as well. \n\nIn a broader sense, it can refer to the sharing of political or [[ideology|ideological]] sentiments, such as in the phrase a [[communism|communist]] sympathizer.\n\n\n'
p388
tp389
a(I-1
S'{{Expert-subject|sociology|date=November 2008}}\nCultural appropriation is the adoption of some specific elements of one culture by a different cultural group.  It denotes [[acculturation]] or [[Cultural assimilation|assimilation]], but often connotes a negative view towards acculturation from a minority culture by a dominant culture.[http://www.nysun.com/article/25979][http://www.msu.edu/~hypatia/White_People.htm]  It can include the introduction of forms of dress or personal adornment, [[music]] and [[art]], [[religion]], [[language]], or social behavior.  These elements, once removed from their [[indigenous peoples|indigenous]] cultural contexts, may take on meanings that are significantly divergent from, or merely less nuanced than, those they originally held. \n\n==Overview==\nThe term cultural appropriation can have a negative connotation. It generally is applied when the subject culture is a minority culture or somehow subordinate in social, political, economic, or military status to the appropriating culture; or, when there are other issues involved, such as a history of [[ethnic]] or [[Race (classification of human beings)|racial]] conflict between the two groups.  \n\nTo many, the term implies that culture can actually be stolen through cultural diffusion.\n\nCultural and racial theorist, [[George Lipsitz]], outlined this concept of cultural appropriation in his seminal term strategic anti-essentialism. Strategic anti-essentialism is defined as the calculated use of a cultural form, outside of your own, to define yourself or your group. Strategic anti-essentialism can be seen both in minority cultures and majority cultures, and are not confined to only the appropriation of the other. For example, the American band [[Redbone (band)|Redbone]], composed of founding members of Mexican heritage, essentialized their group as belonging to the Native American tradition, and are known for their famous songs in support of the American Indian Movement We Were All Wounded at Wounded Knee and Custer Had It Coming. However, as Lipsitz argues, when the majority culture attempts to strategically anti-essentialize themselves by appropriating a minority culture, they must take great care to recognize the specific socio-historical circumstances and significance of these cultural forms so as not the perpetuate the already existing, majority vs. minority, unequal power relations.\n\nCultural appropriation may be defined differently in different cultures. While academics in a country such as the [[United States]], where racial dynamics had been a cause of cultural segmentation, may see many instances of intercultural communication as cultural appropriation, other countries may identify such communication as a [[melting pot]] effect.  \n\nCultural appropriation has also been seen as a site of resistance to dominant society when members of a marginalized group take and alter aspects of dominant culture to assert their agency and resistance.  This is exemplified in the novel [[Crick Crack, Monkey]] by [[Merle Hodge]] when those who are colonized appropriate the culture of the colonizers. Another historical example were the [[Mod (subculture)|Mods]] in the [[United Kingdom|UK]] in the 1960s, working class youth who appropriated and exaggerated the highly tailored clothing of the upper middle class.  Objections have been raised to such political cultural appropriation, citing [[class warfare]] and [[identity politics]].\n\n==Support==\nJustin Britt-Gibsons article for the Washington Post looked at the appropriation of Jamaican culture by Italians and of other cultures by African-Americans as a sign of progress:\n\n<blockquote>Throngs of [[dreadlocks|dreadlocked]] Italians were smoking joints, drinking beer, grooving to the rhythms of [[Bob Marley]], [[Steel Pulse]] and other [[reggae]] icons. Most striking was how comfortable these Italians seemed in their appropriated shoes, adopting a foreign culture and somehow making it theirs. The scene reinforced my sense of how far weve come since the days when people dressed, talked and celebrated only that which sprang from their own background. For the first time in my life, I was fully aware of the spiritual concept that were all simply one.\n\nThat sense hasnt left me. Everywhere I look, I see young people -- such as my two younger brothers, a Japanese-anime-obsessed 11-year-old and a pastel-Polo-sporting 21-year-old -- adopting styles, hobbies and attitudes from outside the culture in which they were raised. Last month in a Los Angeles barbershop, I was waiting to get my trademark Afro cut when I noticed a brother in his late teens sitting, eyes closed, as the barber clipped his hair into a frohawk, the punk-inspired African American adaptation of the mohawk. Asked why he chose the look, the guy, without looking up, shrugged, Something different. Immediately, I understood. Minutes later, his different cut became my new look.<ref name=RacePost>[http://www.washingtonpost.com/wp-dyn/content/article/2007/03/16/AR2007031602691.html Race Isnt a Factor When My Generation Chooses Friends.]</ref></blockquote>\n\n==Examples==\nA common sort of cultural appropriation is the adoption of the [[iconography]] of another culture. Obvious examples include [[tattoos]] of [[Hindu]] [[Deity|gods]], [[Polynesia]]n [[Tribe|tribal]] iconography, [[Chinese character]]s, or [[Celtic art|Celtic bands]] worn by people who have no interest in, or understanding of, their original cultural significance. When these [[Cultural artifact|artifacts]] are regarded as objects that merely look [[cool]], or when they are [[Mass production|mass produced]] cheaply as [[consumer]] [[kitsch]], people who venerate and wish to preserve their indigenous cultural traditions may be offended. In [[Australia]], [[Australian Aboriginal|Aboriginal]] [[Australian Aboriginal art|artists]] have discussed an [http://www.aic.gov.au/conferences/artcrime/newstead.pdf authenticity brand] to ensure consumers are aware of artworks claiming false Aboriginal significance [http://www.eniar.org/news/art-dot.html]. The movement for such a measure has gained momentum after the 1999 conviction of John OLoughlin for fraud, for the sale of works described as Aboriginal but painted by non-indigenous artists [http://news.bbc.co.uk/2/hi/entertainment/3246474.stm]. \n\nIn history, some of the most hotly debated cases of cultural appropriation occur in places where cultural exchange is the highest, such as along the trade routes in southwestern [[Asia]] and southeastern [[Europe]]. For instance, some scholars of the [[Ottoman empire]] and [[ancient Egypt]] argue that Ottoman and Egyptian architectural traditions have long been falsely claimed and praised as Persian or Arab, [http://archnet.org/library/documents/one-document.tcl?document_id=8983] and [[Greco-Roman]], innovations, respectively{{Fact|date=October 2007}}. \n\nA more subtle example is brass band music ([[trubaci]]). While this kind of music is almost exclusively performed by [[Romani]] people, who may not consider themselves [[Serbs]], many people of Serbian origin will consider this to be their own style. {{Fact|date=June 2009}}\n\nOn the other hand, when the middle-class [[Slovenia]]n band [[Pankrti]] adopted the style of [[London]] [[punk music]] rooted in unemployment and other issues specific to the [[United Kingdom|UK]], it was seen in [[Yugoslavia]] as the spread of British culture and its adaptation to the local setting.\n\n[[African American culture]] historically has been the subject of a good deal of cultural appropriation, especially elements of its [[African American music|music]], dance, [[slang]], dress, and demeanor. (See [[blackface]] and [[Cool (aesthetic)|cool]].) For example, artists such as [[Eminem]], a white American who adopted a traditionally [[African American]] music and style, may be perceived this way.\n\nAnother prominent example of cultural appropriation is the use of real or imaginary elements of [[Indigenous peoples of the Americas|Native American]] culture by [[North America]]n [[summer camp]]s, by organizations such as the [[Boy Scouts of America]], or by [[New age]] spiritual leaders (see [[Plastic shaman]]s). Many summer camps, and many age-segregated groups of campers within summer camps, are named after real Native American tribes ([[Mohawk nation|Mohawk]], [[Seminole]], etc.); [[tipi]]s are common at summer camps (even at an enormous distance from the [[Great Plains]]); and rituals often evoke Native American culture, using phrases like the [[Great Spirit]], for example. The Boy Scout [[honor society]] is called the [[Order of the Arrow]].  \n\nIn some cases, a culture usually viewed as the target of cultural appropriation can become the agent of appropriation. For example, the government of [[Ghana]] has been accused of cultural appropriation in adopting the Caribbean holiday of [[Emancipation Day]] and marketing it to African American tourists as an African festival.<ref>Jennifer Hasty, Rites of Passage, Routes of Redemption: Emancipation Tourism and the Wealth of Culture, Africa Today, Volume 49, Number 3, Fall 2002, pp. 47-76. Indiana University Press. [http://muse.jhu.edu/journals/africa_today/v049/49.3hasty.pdf PDF] available on subscription site muse.jhu.edu.</ref>.\n\nA [[bindi (decoration)|bindi]] dot when worn as a decorative item by a non-[[Hindu]] woman could be considered cultural appropriation,<ref>Salil Tripathi, [http://www.saliltripathi.com/articles/20Sept1999NewStatesman.html Hindus and Kubrick], The New Statesman, [[20 September]] [[1999]]. Accessed online [[23 November]] [[2006]].</ref> along with the use of [[henna]] in [[mehndi]] as a decoration outside traditional ceremonies.\n\nThe [[metrosexual]] fashion is often seen as{{Who|date=July 2007}} a form of cultural appropriation of [[Sexuality and gender identity-based cultures|gay culture]] by [[heterosexuality|straight]] men. This view is parodied in the [[South Park]] episode [[South Park is Gay!]] \n\nControversy has arisen concerning the usage of the [[leprechaun]] mascot by the [[Boston Celtics]] basketball club and the [[Notre Dame Fighting Irish football|University of Notre Dame Fighting Irish]] football team. Some people of [[Ireland|Irish]] ancestry see the usage as an example of cultural appropriation and even racism. Leprechauns appear in many [[Celtic mythology|Celtic mythological]] motifs, and the reduction of this mythological figure to a set of stereotypes and clichs may be perceived as offensive. [http://www.thelowell.org/content/view/1906/29/][http://www.ndsmcobserver.com/news/2006/03/23/Viewpoint/fighting.Irish.Not.A.Racist.Moniker-1713482.shtml] A common term amongst the Irish for someone who appropriates or misrepresents Irish culture is [[Plastic Paddy]].<ref> {{cite journal| last =Arrowsmith| first =Aidan| authorlink =| coauthors =| title =Plastic Paddy: Negotiating Identity in Second-generation Irish-English Writing| journal =Irish Studies Review| volume =8| issue =1| pages =3543| publisher =Routledge| date =April 1, 2000| url =| doi =10.1080/09670880050005093| id =| accessdate =  }}</ref>\n\n'
p390
tp391
a(I1
S'The XBC, or the Xport Botball Controller, is a robot based on [http://www.charmedlabs.com Charmed Labs] [http://www.charmedlabs.com/index.php?option=content&task=view&id=25 Xport] hardware.  It was built specifically for the [[Botball]] competition and uses a [[Game Boy Advance]] for its display and has a processor with a separate rechargeable battery pack for power.  The XBC is programmed using Interactive C, which is a variant of the [[C (programming language)|C programming language]].  The XBC replaced the RCX in 2005 as Botballs official processor.  The RCX can be programmed using Interactive C, Not Quite C, or Legos simple GUI interface.  Both robots can have bases built with [[Lego]] pieces.\n\n== Sensors ==\nThe XBC has ports for LEDs/light sensors, IR reflection/color sensors, SONAR, and touch sensors. A camera can also be connected via a header pin array on the front of the XBC; it can blob-track or serve as a color sensor. The cameras live feed can be displayed on the GBAs screen.\n\n== Servos and Motors ==\nThe XBC has 4 motor ports and 4 servo ports, each labeled 0-3, respectively. Each motor can be independently programmed to go either backwards or forwards and each servo can be independently changed and controlled with precision.\n\n== Programming ==\nThe XBC can be programmed using either Interactive C (IC) or the Xport Development Kit (Xport DK).  IC is a simplified variant of C, which is intended to be as easy as possible to use.  The Xport DK, in contrast, is a full-blown C/C++ cross-compiler.  IC has many feature limitations that are not present in the Xport DK; this is in part a result of the fact that IC was originally written for the Handy Board (which had much fewer features), not the XBC.  Some limitations of IC include a 16KiB compiled program size limit, and the lack of features for graphics and sound.  The Xport DK was originally designed to program the Xport Robot Controller (XRC - the predecessor of the XBC), and supports the XBC as well.  The Xport DK doesnt have the same limitations of IC, but has its own problem - an almost complete lack of documentation.  Because IC is significantly easier to use, has extensive documentation for most features, and is still powerful enough for most uses, the vast majority of XBC users program in IC.\n\n'
p392
tp393
a(I-1
S'{{Orphan|date=February 2009}}\nPonerology is the name given by [[Poland|Polish]] psychiatrist [[Andrzej obaczewski]] to an interdisciplinary study of the causes of periods of [[social injustice]].<ref>obaczewski, Andrzej, Political Ponerology: A Science on the Nature of Evil Adjusted for Political Purposes, (Grande Prairie: Red Pill Press, 2006), p. 22. </ref>  This discipline makes use of data from psychology, psychopathology, sociology, philosophy, and history to account for such phenomena as [[aggressive war]], [[ethnic cleansing]], [[genocide]], and [[police states]].  The original theory and research was conducted by psychologists and psychiatrists working in Poland, Czechoslovakia, and Hungary in the years before the institution of Communism such as [[Kazimierz Dbrowski]] and [[Stefan Blachowski]].<ref>Dbrowski, Kazimierz, The Dynamics of Concepts (London: Gryf Publications, 1973), pp. 37-40.</ref>\n\nobaczewski adopted the term from the branch of [[theology]] dealing with the study of [[evil]], derived from the [[Greek language|Greek]] word poneros.\n\n'
p394
tp395
a(I-1
S'Manifest and latent functions are [[social concept|social scientific concepts]] first clarified for [[sociology]] by [[Robert K. Merton]] [http://www.diligio.com/notes26.htm Diligio, 2000]. Merton appeared interested in sharpening the conceptual tools to be employed in a [[Structural functionalism|functional analysis]].  \n\nManifest [[Functionalism (sociology)|function]]s and [[Dysfunction (sociology)|dysfunctions]] are conscious and deliberate, the latent ones the unconscious and unintended. [http://www.angelfire.com/or/sociologyshop/manlat.html Berger, 1963] While functions are intended (manifest) or recognized(latent), and have a positive effect on [[society]], dysfunctions are unintended (manifest) or unrecognized (latent) and have a negative effect on society.[Brinkerhoff et al. 2004]\n\n== Functions ==\nManifest [[Functionalism (sociology)|function]]s are the consequences that people observe or expect. It is explicitly stated and understood by the participants in the relevant action. The manifest function of a [[rain dance]], used as an example by Merton in his 1967  [[Social Theory and Social Structure]][http://www.faculty.rsu.edu/~felwell/TheoryWeb/Merton.htm Merton, 1957], is to produce [[rain]], and this outcome is intended and desired by people participating in the ritual. This could also be defined as [[emic]] with [[cognized model]]s.[http://www.as.ua.edu/ant/Faculty/murphy/ecologic.htm M.D. Murphy, 2001]\n\nLatent functions are those that are neither recognized nor intended. A latent function of a behavior is not explicitly stated, recognized, or intended by the people involved. Thus, they are idenified observers. Latent functions are associated with [[etic]] and [[operational model]]s. [http://www.as.ua.edu/ant/Faculty/murphy/ecologic.htm M.D. Murphy, 2001] In the example of rain ceremony, the latent function could be to [[reinforce]] the [[group identity]] by providing a periodic occasion on which the scattered members of a [[group (sociology)|group]] assemble to engage in a common [[activity]]. [http://www.faculty.rsu.edu/~felwell/TheoryWeb/Merton.htm Merton, 1957]\n\n[[Peter L. Berger]] describes a series of examples illustrating the differences between manifest and latent functions [http://www.angelfire.com/or/sociologyshop/manlat.html Berger, 1963]: ...the manifest function of anti[[gambling]] [[legislation]] may be to suppress gambling, its latent function to create an illegal empire for the gambling [[syndicate]]s. Or [[Christian mission]]s in parts of [[Africa]] manifestly tried to [[convert]] Africans to [[Christianity]], latently helped to destroy the indigenous [[tribal culture]]s and this provided an important impetus towards rapid [[social transformation]]. Or the control of the [[Communist Party]] over all sectors of [[social life]] in [[Russia]] manifestly was to assure the continued dominance of the revolutionary [[ethos]], latently created a new [[social class|class]] of comfortable [[bureaucrat]]s uncannily [[bourgeois]] in its aspirations and increasingly disinclined toward the self-denial of [[Bolshevik]] dedication ([[nomenklatura]]). Or the manifest function of many [[voluntary association]]s in America is [[sociability]] and [[community service|public service]], the latent function to attach [[social status|status]] indices to those permitted to belong to such associations. \n\nWhile [[Talcott Parsons]] tends to emphasize the manifest functions of [[social behavior]], Merton sees attention to latent functions as increasing the understanding of society: the distinction between manifest and latent forces the [[sociologist]] to go beyond the reasons individuals give for their actions or for the existence of [[Tradition|custom]]s and [[institution]]s; it makes them look for other [[social consequence]]s that allow these practices survival and illuminate the way society works.\n\n== Dysfunctions ==\n[[Dysfunction (sociology)|Dysfunction]]s can also be manifest or latent. While functions are intended (manifest) or recognized (latent), and have a positive effect on society, dysfunctions are unintended (manifest) or unrecognized (latent) and have a negative effect on society.\n\n== Medical science model ==\nBroadly stated and here relying on the systems model first developed in medical science, an interrelated bundle of [[social structure]]s (e.g., [[Zulu culture]]), treated as a [[social system]], involves the parts (structural elements) acting in such a fashion so as to help maintain the [[homeodynamic]] equilibrium of the system of which they are an element. Manifest [[Functionalism (sociology)|functions]] are the obvious and intended consequences a structural feature displays in the maintenance of the steady state of the system of which it is a part. Latent functions are less obvious or [[unintended consequence]]s. Both manifest and latent functions contribute to the social systems unchanging ongoingness or stasis. In this very specific sense both may be interpreted as useful and positive.\n\nIn conducting a functional analysis, dysfunctions are consequences of structural elements that produce changes in their environing social system. The flame of the candle system flickers. The structural cause would be labeled dysfunctional. The candles steady state has been disturbed or changed. The concept affords the only relief to structural-functionalisms inherent conservative bias. Dysfunction signifies the mechanism by which social change is evidenced within a social system.  Whether that change is manifest or latent is a relatively simple empirical question. Whether that change is good or bad would seem to require interpretative criteria not afforded by a social scientific paradigm for functional analysis.\n\n== Quotes ==\n* ... the distinction between manifest and latent functions was devised to preclude ... confusion ... between conscious motivations for social behaviour and its objective consequences - Robert K. Merton, Social Theory and Social Structure, 1957, page 61 [http://www.mdx.ac.uk/www/study/xmer.htm#LatentFunction]\n* ... I have adapted the terms manifest and latent from their use in another context by Freud..., [[ibid]].\n* [[Emile Durkheim]]s... analysis of the social functions of punishment is... focused on its latent functions (consequences for the community) rather than confined to manifest functions (consequences for the criminal), ibid.\n\n'
p396
tp397
a(I1
S'{{Infobox Magazine\n|title = Model Rocketry\n|image_file =Model Rocketry September 1969 Cover.jpg\n|image_size = \n|image_caption = September 1969 issue of Model Rocketry.\n|editor = Gorden Mandell\n|editor_title = Managing Editor\n|staff_writer = \n|frequency = Monthly\n|circulation = 15,000\n|category = Hobby magazines\n|company = Model Rocketry, Inc.\n|publisher = George Flynn\n|firstdate = October 1968\n|finaldate = February 1972\n|finalnumber = Vol. 4 No. 4\n|country = {{USA}} \n|language = English \n|website = \n|issn = \n}}\nModel Rocketry was an American hobbyist magazine published from October 1968 to February 1972. The Publisher and Editor was George Flynn and the Managing Editor was Gorden Mandell. The magazine was owned by the editorial staff and the paid circulation reached 15,000 by 1970.<ref name= Circulation>{{cite journal | last =Flynn | first =George J | title = Statement of Ownership, Management and Circulation. | journal = Model Rocketry | volume = 3 | issue = 04 | pages = p. 37 | publisher = Model Rocketry, Inc | location = Cambridge, MA | date = January 1971 | url = http://www.ninfinger.org/~sven/rockets/ModelRocketry/ModelRocketry.html | accessdate = August 16, 2008}}</ref>\n\nThe launch of [[Sputnik]] in 1957 and the [[space race]] to the moon made [[model rocket]]s a popular hobby. This magazine was started height of the [[Apollo program]]. Each issues had construction plans on how to construct rockets typically powered by black powder rocket motors such as those made by [[Estes Industries]]. There were also technical articles on model rocket design that would include several pages of theory and equations. There was a series of articles starting in October 1969 on writing [[FORTRAN]] programs to calculate flight parameters. The magazine also covered amateur rocketry clubs launch meets and contests.\n\nThe September 1969 issue of Model Rocketry has a typical cover design and contents. The cover photo shows the launch of a model rocket approximately 2 feet (60 cm) tall with a small camera as the payload. The camera will take a photo after the rocket reaches its apogee and starts the decent with a parachute. The magazine has construction plans for an egg lofting rocket. These would be used in contest to see how high an egg could be launched without cracking. The topics on the cover include [[Apollo 11]]. There was a 6 page article by the Managing Editor, Gordon Mandell, about the first manned mission to land on the moon.\n\n==Micro Instrumentation and Telemetry Systems==\n[[Image:MITS Rocket Light Flasher.jpg|thumb|left| Transistorized Tracking Light.]]\nIn July 1969, Publisher George Flynn attended the Southwestern Model Rocket Conference at [[Eastern New Mexico University]]. There he met Air Force Captain [[Forrest Mims]], senior advisor to the Albuquerque Model Rocket Club.<ref name=ENMU>{{cite journal | last =Flynn | first =George J. | title = Southwestern Model Rocket Conference | journal = Model Rocketry | volume = 1 | issue = 11| pages = pp. 1416 | publisher = Model Rocketry, Inc | location = Cambridge, MA | date = September 1969 | url = http://www.ninfinger.org/~sven/rockets/ModelRocketry/ModelRocketry.html | accessdate = August 16, 2008}}</ref> Mims told Flynn about a transistorized lamp flasher for tracking night launched rockets. He also described modulating Light Emitting Diodes to transmit data from the rocket to infrared detectors on the ground. Flynn invited Mims to write an article about his Transistorized Tracking Light for Night Launched Model Rockets and it was published in the September 1969 issue of Model Rocketry.<ref name Tracking Light >{{cite journal | last =Mims | first =Forrest M. | title = Transistorized Tracking Light for Night Launched Model Rockets | journal = Model Rocketry | volume = 1 | issue = 11 | pages = pp. 911 | publisher = Model Rocketry, Inc | location = Cambridge, MA | date = September 1969 | url = http://www.ninfinger.org/~sven/rockets/ModelRocketry/ModelRocketry.html | accessdate = August 16, 2008}}</ref>\n\nMims was stationed at [[Kirtland Air Force Base]] in Albuquerque NM with a fellow officer, [[Ed Roberts (computers) | Ed Roberts]]. They decided to form a company to sell electronic kits for projects like the tracking light. Mims, Roberts and two other coworkers formed [[Micro Instrumentation and Telemetry Systems]] (MITS) in late 1969.<ref name= Ceruzzi >{{cite book | last = Ceruzzi | first = Paul E. | title = A History of Modern Computing | publisher = MIT Press | date = 2003 | location = Cambridge, MA | pages = 227233 | isbn = 0-262-53203-4}}</ref> The press release announcing the formation of MITS was published in the December 1969 issue of Model Rocketry. In January 1975 MITS introduced the [[Altair 8800]] computer and the personal computer revolution was launched.<ref name= Creative Computing> {{cite journal | last = Mims | first = Forrest M. | year = 1984 | month = November | title = The Altair story; early days at MITS | journal = Creative Computing | volume = 10 | issue = 11 | pages = p. 17 | url = http://www.atarimagazines.com/creative/v10n11/17_The_Altair_story_early_d.php| accessdate = August 16, 2008}}</ref> [[Bill Gates]] and [[Paul Allen]] moved to Albuquerque in 1975 to write [[Altair BASIC]] and soon started [[Microsoft]].\n\nSeveral copies of Model Rocketry magazine and the prototype tracking light are on display at the [[New Mexico Museum of Natural History and Science]] in their STARTUP: Albuquerque and the Personal Computer Revolution exhibit. Mr. Mims donated his MITS 816 calculator, Altair 8800 computer, early MITS documents and unsold model rocket telemetry kits to the Smithsonian [[National Museum of American History]].<ref name = Mims>{{cite book | last = Mims | first = Forrest M | authorlink = Forrest Mims | title = Siliconnections: Coming of Age in the Electronic Era | publisher = McGraw-Hill | date =1986 | location = New York, NY | pages = 2732, 167 | isbn = 9780070424111 }}</ref>\n\n'
p398
tp399
a(I1
S'{{otheruses}}  \t \n[[Image:Snowpyramids.jpg|thumb|A sampling of snowballs.]] \n[[File:Giant snowball Oxford.jpg|thumb|A large snowball under construction in Oxford.]]\n[[Image:Venceslao Gennaio Castello Buonconsiglio Trento c1400 detail.jpg|thumb|right|A medieval image from Italy of people using snowballs]]\n[[Image:Ambrogio Lorenzetti 010.jpg|thumb|100px|Ambrogio Lorenzettis Winter]] \n{{wiktionary|snowballs chance in hell}}\n\nA snowball is a [[sphere|spherical]] object made from [[snow]], usually created by scooping snow with the hands, and compacting it into a roughly fist-sized ball. The snowball is often used to engage in games, such as [[snowball fight]]s. Snowball fights are usually light-hearted and involve throwing snowballs at ones friends or family. The pressure exerted by the hands on the snow is a determinant for the final result. Reduced pressure leads to a light and soft snowball. A higher pressure causes the snow to melt, turning into liquid water. Once the pressure is removed, the water turns again into [[ice]], leading to a more compact and hard snowball called an iceball, which eventually can be considered harmful during a snowball fight. The process of melting and refreezing is called [[regelation]].\n\nA snowball may also be a large ball of snow formed by rolling a smaller snowball on a snow-covered surface. The smaller snowball grows by picking up additional snow as it rolls. The terms [[snowball effect]] and snowballing are named after this process. This technique is often used to create [[Snowman|snowmen]]. \n\nThere are some temperature/humidity ranges that prohibit or restrict the formulation of a snowball. With a powdery snow, snowballs are difficult to form. If youre walking on snow and it squeaks, chances are the temperature/humidity level wont form a snowball.\n\n==Current world record==\n\nStudents of [[Michigan Technological University]] rolled the worlds largest snowball on February 10, 2006.<ref name=record>{{Cite web|url=http://www.mtu.edu/worldrecord/|title=World Records|accessdate=December 17 2007|dateformat=mdy|publisher=[[Michigan Technological University]]|year=2006|author=Michigan Tech}}</ref> It was 21 [[Foot (length)|feet]] 3 [[inch]]es in circumference (81 inches or 2.06 [[metre]]s in diameter).<ref name=record/>\n\n==Heraldry==\n\nThe snowball occasionally occurs as a [[charge (heraldry)|charge]] in [[heraldry]].\n\n'
p400
tp401
a.